(function (root, factory) {
    if (typeof define === "function" && define.amd) {
        define(["exports"], factory);
    } else if (typeof exports === 'object' &&
               typeof exports.nodeName !== 'string') {
        factory(exports);
    } else {
        factory(root.libsodium = {});
    }
})(this, (function (exports) {
    "use strict";
    var Module = exports;
var Module;if(!Module)Module=(typeof Module!=="undefined"?Module:null)||{};var moduleOverrides={};for(var key in Module){if(Module.hasOwnProperty(key)){moduleOverrides[key]=Module[key]}}var ENVIRONMENT_IS_WEB=false;var ENVIRONMENT_IS_WORKER=false;var ENVIRONMENT_IS_NODE=false;var ENVIRONMENT_IS_SHELL=false;if(Module["ENVIRONMENT"]){if(Module["ENVIRONMENT"]==="WEB"){ENVIRONMENT_IS_WEB=true}else if(Module["ENVIRONMENT"]==="WORKER"){ENVIRONMENT_IS_WORKER=true}else if(Module["ENVIRONMENT"]==="NODE"){ENVIRONMENT_IS_NODE=true}else if(Module["ENVIRONMENT"]==="SHELL"){ENVIRONMENT_IS_SHELL=true}else{throw new Error("The provided Module['ENVIRONMENT'] value is not valid. It must be one of: WEB|WORKER|NODE|SHELL.")}}else{ENVIRONMENT_IS_WEB=typeof window==="object";ENVIRONMENT_IS_WORKER=typeof importScripts==="function";ENVIRONMENT_IS_NODE=typeof process==="object"&&typeof require==="function"&&!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_WORKER;ENVIRONMENT_IS_SHELL=!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_NODE&&!ENVIRONMENT_IS_WORKER}if(ENVIRONMENT_IS_NODE){if(!Module["print"])Module["print"]=console.log;if(!Module["printErr"])Module["printErr"]=console.warn;var nodeFS;var nodePath;Module["read"]=function read(filename,binary){if(!nodeFS)nodeFS=require("fs");if(!nodePath)nodePath=require("path");filename=nodePath["normalize"](filename);var ret=nodeFS["readFileSync"](filename);return binary?ret:ret.toString()};Module["readBinary"]=function readBinary(filename){var ret=Module["read"](filename,true);if(!ret.buffer){ret=new Uint8Array(ret)}assert(ret.buffer);return ret};Module["load"]=function load(f){globalEval(read(f))};if(!Module["thisProgram"]){if(process["argv"].length>1){Module["thisProgram"]=process["argv"][1].replace(/\\/g,"/")}else{Module["thisProgram"]="unknown-program"}}Module["arguments"]=process["argv"].slice(2);if(typeof module!=="undefined"){module["exports"]=Module}process["on"]("uncaughtException",(function(ex){if(!(ex instanceof ExitStatus)){throw ex}}));Module["inspect"]=(function(){return"[Emscripten Module object]"})}else if(ENVIRONMENT_IS_SHELL){if(!Module["print"])Module["print"]=print;if(typeof printErr!="undefined")Module["printErr"]=printErr;if(typeof read!="undefined"){Module["read"]=read}else{Module["read"]=function read(){throw"no read() available (jsc?)"}}Module["readBinary"]=function readBinary(f){if(typeof readbuffer==="function"){return new Uint8Array(readbuffer(f))}var data=read(f,"binary");assert(typeof data==="object");return data};if(typeof scriptArgs!="undefined"){Module["arguments"]=scriptArgs}else if(typeof arguments!="undefined"){Module["arguments"]=arguments}}else if(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER){Module["read"]=function read(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.send(null);return xhr.responseText};Module["readAsync"]=function readAsync(url,onload,onerror){var xhr=new XMLHttpRequest;xhr.open("GET",url,true);xhr.responseType="arraybuffer";xhr.onload=function xhr_onload(){if(xhr.status==200||xhr.status==0&&xhr.response){onload(xhr.response)}else{onerror()}};xhr.onerror=onerror;xhr.send(null)};if(typeof arguments!="undefined"){Module["arguments"]=arguments}if(typeof console!=="undefined"){if(!Module["print"])Module["print"]=function print(x){console.log(x)};if(!Module["printErr"])Module["printErr"]=function printErr(x){console.warn(x)}}else{var TRY_USE_DUMP=false;if(!Module["print"])Module["print"]=TRY_USE_DUMP&&typeof dump!=="undefined"?(function(x){dump(x)}):(function(x){})}if(ENVIRONMENT_IS_WORKER){Module["load"]=importScripts}if(typeof Module["setWindowTitle"]==="undefined"){Module["setWindowTitle"]=(function(title){document.title=title})}}else{throw"Unknown runtime environment. Where are we?"}function globalEval(x){abort("NO_DYNAMIC_EXECUTION=1 was set, cannot eval")}if(!Module["load"]&&Module["read"]){Module["load"]=function load(f){globalEval(Module["read"](f))}}if(!Module["print"]){Module["print"]=(function(){})}if(!Module["printErr"]){Module["printErr"]=Module["print"]}if(!Module["arguments"]){Module["arguments"]=[]}if(!Module["thisProgram"]){Module["thisProgram"]="./this.program"}Module.print=Module["print"];Module.printErr=Module["printErr"];Module["preRun"]=[];Module["postRun"]=[];for(var key in moduleOverrides){if(moduleOverrides.hasOwnProperty(key)){Module[key]=moduleOverrides[key]}}moduleOverrides=undefined;var Runtime={setTempRet0:(function(value){tempRet0=value}),getTempRet0:(function(){return tempRet0}),stackSave:(function(){return STACKTOP}),stackRestore:(function(stackTop){STACKTOP=stackTop}),getNativeTypeSize:(function(type){switch(type){case"i1":case"i8":return 1;case"i16":return 2;case"i32":return 4;case"i64":return 8;case"float":return 4;case"double":return 8;default:{if(type[type.length-1]==="*"){return Runtime.QUANTUM_SIZE}else if(type[0]==="i"){var bits=parseInt(type.substr(1));assert(bits%8===0);return bits/8}else{return 0}}}}),getNativeFieldSize:(function(type){return Math.max(Runtime.getNativeTypeSize(type),Runtime.QUANTUM_SIZE)}),STACK_ALIGN:16,prepVararg:(function(ptr,type){if(type==="double"||type==="i64"){if(ptr&7){assert((ptr&7)===4);ptr+=4}}else{assert((ptr&3)===0)}return ptr}),getAlignSize:(function(type,size,vararg){if(!vararg&&(type=="i64"||type=="double"))return 8;if(!type)return Math.min(size,8);return Math.min(size||(type?Runtime.getNativeFieldSize(type):0),Runtime.QUANTUM_SIZE)}),dynCall:(function(sig,ptr,args){if(args&&args.length){return Module["dynCall_"+sig].apply(null,[ptr].concat(args))}else{return Module["dynCall_"+sig].call(null,ptr)}}),functionPointers:[null,null,null,null,null,null,null,null],addFunction:(function(func){for(var i=0;i<Runtime.functionPointers.length;i++){if(!Runtime.functionPointers[i]){Runtime.functionPointers[i]=func;return 1*(1+i)}}throw"Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS."}),removeFunction:(function(index){Runtime.functionPointers[(index-1)/1]=null}),warnOnce:(function(text){if(!Runtime.warnOnce.shown)Runtime.warnOnce.shown={};if(!Runtime.warnOnce.shown[text]){Runtime.warnOnce.shown[text]=1;Module.printErr(text)}}),funcWrappers:{},getFuncWrapper:(function(func,sig){assert(sig);if(!Runtime.funcWrappers[sig]){Runtime.funcWrappers[sig]={}}var sigCache=Runtime.funcWrappers[sig];if(!sigCache[func]){if(sig.length===1){sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func)}}else if(sig.length===2){sigCache[func]=function dynCall_wrapper(arg){return Runtime.dynCall(sig,func,[arg])}}else{sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func,Array.prototype.slice.call(arguments))}}}return sigCache[func]}),getCompilerSetting:(function(name){throw"You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work"}),stackAlloc:(function(size){var ret=STACKTOP;STACKTOP=STACKTOP+size|0;STACKTOP=STACKTOP+15&-16;return ret}),staticAlloc:(function(size){var ret=STATICTOP;STATICTOP=STATICTOP+size|0;STATICTOP=STATICTOP+15&-16;return ret}),dynamicAlloc:(function(size){var ret=DYNAMICTOP;DYNAMICTOP=DYNAMICTOP+size|0;DYNAMICTOP=DYNAMICTOP+15&-16;if(DYNAMICTOP>=TOTAL_MEMORY){var success=enlargeMemory();if(!success){DYNAMICTOP=ret;return 0}}return ret}),alignMemory:(function(size,quantum){var ret=size=Math.ceil(size/(quantum?quantum:16))*(quantum?quantum:16);return ret}),makeBigInt:(function(low,high,unsigned){var ret=unsigned?+(low>>>0)+ +(high>>>0)*+4294967296:+(low>>>0)+ +(high|0)*+4294967296;return ret}),GLOBAL_BASE:8,QUANTUM_SIZE:4,__dummy__:0};Module["Runtime"]=Runtime;var ABORT=false;var EXITSTATUS=0;function assert(condition,text){if(!condition){abort("Assertion failed: "+text)}}function getCFunc(ident){var func=Module["_"+ident];if(!func){abort("NO_DYNAMIC_EXECUTION=1 was set, cannot eval")}assert(func,"Cannot call unknown function "+ident+" (perhaps LLVM optimizations or closure removed it?)");return func}var cwrap,ccall;((function(){var JSfuncs={"stackSave":(function(){Runtime.stackSave()}),"stackRestore":(function(){Runtime.stackRestore()}),"arrayToC":(function(arr){var ret=Runtime.stackAlloc(arr.length);writeArrayToMemory(arr,ret);return ret}),"stringToC":(function(str){var ret=0;if(str!==null&&str!==undefined&&str!==0){ret=Runtime.stackAlloc((str.length<<2)+1);writeStringToMemory(str,ret)}return ret})};var toC={"string":JSfuncs["stringToC"],"array":JSfuncs["arrayToC"]};ccall=function ccallFunc(ident,returnType,argTypes,args,opts){var func=getCFunc(ident);var cArgs=[];var stack=0;if(args){for(var i=0;i<args.length;i++){var converter=toC[argTypes[i]];if(converter){if(stack===0)stack=Runtime.stackSave();cArgs[i]=converter(args[i])}else{cArgs[i]=args[i]}}}var ret=func.apply(null,cArgs);if(returnType==="string")ret=Pointer_stringify(ret);if(stack!==0){if(opts&&opts.async){EmterpreterAsync.asyncFinalizers.push((function(){Runtime.stackRestore(stack)}));return}Runtime.stackRestore(stack)}return ret};cwrap=function cwrap(ident,returnType,argTypes){return(function(){return ccall(ident,returnType,argTypes,arguments)})}}))();Module["ccall"]=ccall;Module["cwrap"]=cwrap;function setValue(ptr,value,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":HEAP8[ptr>>0]=value;break;case"i8":HEAP8[ptr>>0]=value;break;case"i16":HEAP16[ptr>>1]=value;break;case"i32":HEAP32[ptr>>2]=value;break;case"i64":tempI64=[value>>>0,(tempDouble=value,+Math_abs(tempDouble)>=+1?tempDouble>+0?(Math_min(+Math_floor(tempDouble/+4294967296),+4294967295)|0)>>>0:~~+Math_ceil((tempDouble- +(~~tempDouble>>>0))/+4294967296)>>>0:0)],HEAP32[ptr>>2]=tempI64[0],HEAP32[ptr+4>>2]=tempI64[1];break;case"float":HEAPF32[ptr>>2]=value;break;case"double":HEAPF64[ptr>>3]=value;break;default:abort("invalid type for setValue: "+type)}}Module["setValue"]=setValue;function getValue(ptr,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":return HEAP8[ptr>>0];case"i8":return HEAP8[ptr>>0];case"i16":return HEAP16[ptr>>1];case"i32":return HEAP32[ptr>>2];case"i64":return HEAP32[ptr>>2];case"float":return HEAPF32[ptr>>2];case"double":return HEAPF64[ptr>>3];default:abort("invalid type for setValue: "+type)}return null}Module["getValue"]=getValue;var ALLOC_NORMAL=0;var ALLOC_STACK=1;var ALLOC_STATIC=2;var ALLOC_DYNAMIC=3;var ALLOC_NONE=4;Module["ALLOC_NORMAL"]=ALLOC_NORMAL;Module["ALLOC_STACK"]=ALLOC_STACK;Module["ALLOC_STATIC"]=ALLOC_STATIC;Module["ALLOC_DYNAMIC"]=ALLOC_DYNAMIC;Module["ALLOC_NONE"]=ALLOC_NONE;function allocate(slab,types,allocator,ptr){var zeroinit,size;if(typeof slab==="number"){zeroinit=true;size=slab}else{zeroinit=false;size=slab.length}var singleType=typeof types==="string"?types:null;var ret;if(allocator==ALLOC_NONE){ret=ptr}else{ret=[typeof _malloc==="function"?_malloc:Runtime.staticAlloc,Runtime.stackAlloc,Runtime.staticAlloc,Runtime.dynamicAlloc][allocator===undefined?ALLOC_STATIC:allocator](Math.max(size,singleType?1:types.length))}if(zeroinit){var ptr=ret,stop;assert((ret&3)==0);stop=ret+(size&~3);for(;ptr<stop;ptr+=4){HEAP32[ptr>>2]=0}stop=ret+size;while(ptr<stop){HEAP8[ptr++>>0]=0}return ret}if(singleType==="i8"){if(slab.subarray||slab.slice){HEAPU8.set(slab,ret)}else{HEAPU8.set(new Uint8Array(slab),ret)}return ret}var i=0,type,typeSize,previousType;while(i<size){var curr=slab[i];if(typeof curr==="function"){curr=Runtime.getFunctionIndex(curr)}type=singleType||types[i];if(type===0){i++;continue}if(type=="i64")type="i32";setValue(ret+i,curr,type);if(previousType!==type){typeSize=Runtime.getNativeTypeSize(type);previousType=type}i+=typeSize}return ret}Module["allocate"]=allocate;function getMemory(size){if(!staticSealed)return Runtime.staticAlloc(size);if(typeof _sbrk!=="undefined"&&!_sbrk.called||!runtimeInitialized)return Runtime.dynamicAlloc(size);return _malloc(size)}Module["getMemory"]=getMemory;function Pointer_stringify(ptr,length){if(length===0||!ptr)return"";var hasUtf=0;var t;var i=0;while(1){t=HEAPU8[ptr+i>>0];hasUtf|=t;if(t==0&&!length)break;i++;if(length&&i==length)break}if(!length)length=i;var ret="";if(hasUtf<128){var MAX_CHUNK=1024;var curr;while(length>0){curr=String.fromCharCode.apply(String,HEAPU8.subarray(ptr,ptr+Math.min(length,MAX_CHUNK)));ret=ret?ret+curr:curr;ptr+=MAX_CHUNK;length-=MAX_CHUNK}return ret}return Module["UTF8ToString"](ptr)}Module["Pointer_stringify"]=Pointer_stringify;function AsciiToString(ptr){var str="";while(1){var ch=HEAP8[ptr++>>0];if(!ch)return str;str+=String.fromCharCode(ch)}}Module["AsciiToString"]=AsciiToString;function stringToAscii(str,outPtr){return writeAsciiToMemory(str,outPtr,false)}Module["stringToAscii"]=stringToAscii;function UTF8ArrayToString(u8Array,idx){var u0,u1,u2,u3,u4,u5;var str="";while(1){u0=u8Array[idx++];if(!u0)return str;if(!(u0&128)){str+=String.fromCharCode(u0);continue}u1=u8Array[idx++]&63;if((u0&224)==192){str+=String.fromCharCode((u0&31)<<6|u1);continue}u2=u8Array[idx++]&63;if((u0&240)==224){u0=(u0&15)<<12|u1<<6|u2}else{u3=u8Array[idx++]&63;if((u0&248)==240){u0=(u0&7)<<18|u1<<12|u2<<6|u3}else{u4=u8Array[idx++]&63;if((u0&252)==248){u0=(u0&3)<<24|u1<<18|u2<<12|u3<<6|u4}else{u5=u8Array[idx++]&63;u0=(u0&1)<<30|u1<<24|u2<<18|u3<<12|u4<<6|u5}}}if(u0<65536){str+=String.fromCharCode(u0)}else{var ch=u0-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}}}Module["UTF8ArrayToString"]=UTF8ArrayToString;function UTF8ToString(ptr){return UTF8ArrayToString(HEAPU8,ptr)}Module["UTF8ToString"]=UTF8ToString;function stringToUTF8Array(str,outU8Array,outIdx,maxBytesToWrite){if(!(maxBytesToWrite>0))return 0;var startIdx=outIdx;var endIdx=outIdx+maxBytesToWrite-1;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){if(outIdx>=endIdx)break;outU8Array[outIdx++]=u}else if(u<=2047){if(outIdx+1>=endIdx)break;outU8Array[outIdx++]=192|u>>6;outU8Array[outIdx++]=128|u&63}else if(u<=65535){if(outIdx+2>=endIdx)break;outU8Array[outIdx++]=224|u>>12;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=2097151){if(outIdx+3>=endIdx)break;outU8Array[outIdx++]=240|u>>18;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=67108863){if(outIdx+4>=endIdx)break;outU8Array[outIdx++]=248|u>>24;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else{if(outIdx+5>=endIdx)break;outU8Array[outIdx++]=252|u>>30;outU8Array[outIdx++]=128|u>>24&63;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}}outU8Array[outIdx]=0;return outIdx-startIdx}Module["stringToUTF8Array"]=stringToUTF8Array;function stringToUTF8(str,outPtr,maxBytesToWrite){return stringToUTF8Array(str,HEAPU8,outPtr,maxBytesToWrite)}Module["stringToUTF8"]=stringToUTF8;function lengthBytesUTF8(str){var len=0;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){++len}else if(u<=2047){len+=2}else if(u<=65535){len+=3}else if(u<=2097151){len+=4}else if(u<=67108863){len+=5}else{len+=6}}return len}Module["lengthBytesUTF8"]=lengthBytesUTF8;function demangle(func){var hasLibcxxabi=!!Module["___cxa_demangle"];if(hasLibcxxabi){try{var buf=_malloc(func.length);writeStringToMemory(func.substr(1),buf);var status=_malloc(4);var ret=Module["___cxa_demangle"](buf,0,0,status);if(getValue(status,"i32")===0&&ret){return Pointer_stringify(ret)}}catch(e){}finally{if(buf)_free(buf);if(status)_free(status);if(ret)_free(ret)}return func}Runtime.warnOnce("warning: build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling");return func}function demangleAll(text){return text.replace(/__Z[\w\d_]+/g,(function(x){var y=demangle(x);return x===y?x:x+" ["+y+"]"}))}function jsStackTrace(){var err=new Error;if(!err.stack){try{throw new Error(0)}catch(e){err=e}if(!err.stack){return"(no stack trace available)"}}return err.stack.toString()}function stackTrace(){var js=jsStackTrace();if(Module["extraStackTrace"])js+="\n"+Module["extraStackTrace"]();return demangleAll(js)}Module["stackTrace"]=stackTrace;var PAGE_SIZE=4096;function alignMemoryPage(x){if(x%4096>0){x+=4096-x%4096}return x}var HEAP;var buffer;var HEAP8,HEAPU8,HEAP16,HEAPU16,HEAP32,HEAPU32,HEAPF32,HEAPF64;function updateGlobalBufferViews(){Module["HEAP8"]=HEAP8=new Int8Array(buffer);Module["HEAP16"]=HEAP16=new Int16Array(buffer);Module["HEAP32"]=HEAP32=new Int32Array(buffer);Module["HEAPU8"]=HEAPU8=new Uint8Array(buffer);Module["HEAPU16"]=HEAPU16=new Uint16Array(buffer);Module["HEAPU32"]=HEAPU32=new Uint32Array(buffer);Module["HEAPF32"]=HEAPF32=new Float32Array(buffer);Module["HEAPF64"]=HEAPF64=new Float64Array(buffer)}var STATIC_BASE=0,STATICTOP=0,staticSealed=false;var STACK_BASE=0,STACKTOP=0,STACK_MAX=0;var DYNAMIC_BASE=0,DYNAMICTOP=0;function abortOnCannotGrowMemory(){abort("Cannot enlarge memory arrays. Either (1) compile with  -s TOTAL_MEMORY=X  with X higher than the current value "+TOTAL_MEMORY+", (2) compile with  -s ALLOW_MEMORY_GROWTH=1  which adjusts the size at runtime but prevents some optimizations, (3) set Module.TOTAL_MEMORY to a higher value before the program runs, or if you want malloc to return NULL (0) instead of this abort, compile with  -s ABORTING_MALLOC=0 ")}function enlargeMemory(){abortOnCannotGrowMemory()}var TOTAL_STACK=Module["TOTAL_STACK"]||5242880;var TOTAL_MEMORY=Module["TOTAL_MEMORY"]||131072;var totalMemory=64*1024;while(totalMemory<TOTAL_MEMORY||totalMemory<2*TOTAL_STACK){if(totalMemory<16*1024*1024){totalMemory*=2}else{totalMemory+=16*1024*1024}}if(totalMemory!==TOTAL_MEMORY){TOTAL_MEMORY=totalMemory}if(Module["buffer"]){buffer=Module["buffer"]}else{buffer=new ArrayBuffer(TOTAL_MEMORY)}updateGlobalBufferViews();HEAP32[0]=255;if(HEAPU8[0]!==255||HEAPU8[3]!==0)throw"Typed arrays 2 must be run on a little-endian system";Module["HEAP"]=HEAP;Module["buffer"]=buffer;Module["HEAP8"]=HEAP8;Module["HEAP16"]=HEAP16;Module["HEAP32"]=HEAP32;Module["HEAPU8"]=HEAPU8;Module["HEAPU16"]=HEAPU16;Module["HEAPU32"]=HEAPU32;Module["HEAPF32"]=HEAPF32;Module["HEAPF64"]=HEAPF64;function callRuntimeCallbacks(callbacks){while(callbacks.length>0){var callback=callbacks.shift();if(typeof callback=="function"){callback();continue}var func=callback.func;if(typeof func==="number"){if(callback.arg===undefined){Runtime.dynCall("v",func)}else{Runtime.dynCall("vi",func,[callback.arg])}}else{func(callback.arg===undefined?null:callback.arg)}}}var __ATPRERUN__=[];var __ATINIT__=[];var __ATMAIN__=[];var __ATEXIT__=[];var __ATPOSTRUN__=[];var runtimeInitialized=false;var runtimeExited=false;function preRun(){if(Module["preRun"]){if(typeof Module["preRun"]=="function")Module["preRun"]=[Module["preRun"]];while(Module["preRun"].length){addOnPreRun(Module["preRun"].shift())}}callRuntimeCallbacks(__ATPRERUN__)}function ensureInitRuntime(){if(runtimeInitialized)return;runtimeInitialized=true;callRuntimeCallbacks(__ATINIT__)}function preMain(){callRuntimeCallbacks(__ATMAIN__)}function exitRuntime(){callRuntimeCallbacks(__ATEXIT__);runtimeExited=true}function postRun(){if(Module["postRun"]){if(typeof Module["postRun"]=="function")Module["postRun"]=[Module["postRun"]];while(Module["postRun"].length){addOnPostRun(Module["postRun"].shift())}}callRuntimeCallbacks(__ATPOSTRUN__)}function addOnPreRun(cb){__ATPRERUN__.unshift(cb)}Module["addOnPreRun"]=addOnPreRun;function addOnInit(cb){__ATINIT__.unshift(cb)}Module["addOnInit"]=addOnInit;function addOnPreMain(cb){__ATMAIN__.unshift(cb)}Module["addOnPreMain"]=addOnPreMain;function addOnExit(cb){__ATEXIT__.unshift(cb)}Module["addOnExit"]=addOnExit;function addOnPostRun(cb){__ATPOSTRUN__.unshift(cb)}Module["addOnPostRun"]=addOnPostRun;function intArrayFromString(stringy,dontAddNull,length){var len=length>0?length:lengthBytesUTF8(stringy)+1;var u8array=new Array(len);var numBytesWritten=stringToUTF8Array(stringy,u8array,0,u8array.length);if(dontAddNull)u8array.length=numBytesWritten;return u8array}Module["intArrayFromString"]=intArrayFromString;function intArrayToString(array){var ret=[];for(var i=0;i<array.length;i++){var chr=array[i];if(chr>255){chr&=255}ret.push(String.fromCharCode(chr))}return ret.join("")}Module["intArrayToString"]=intArrayToString;function writeStringToMemory(string,buffer,dontAddNull){var array=intArrayFromString(string,dontAddNull);var i=0;while(i<array.length){var chr=array[i];HEAP8[buffer+i>>0]=chr;i=i+1}}Module["writeStringToMemory"]=writeStringToMemory;function writeArrayToMemory(array,buffer){for(var i=0;i<array.length;i++){HEAP8[buffer++>>0]=array[i]}}Module["writeArrayToMemory"]=writeArrayToMemory;function writeAsciiToMemory(str,buffer,dontAddNull){for(var i=0;i<str.length;++i){HEAP8[buffer++>>0]=str.charCodeAt(i)}if(!dontAddNull)HEAP8[buffer>>0]=0}Module["writeAsciiToMemory"]=writeAsciiToMemory;if(!Math["imul"]||Math["imul"](4294967295,5)!==-5)Math["imul"]=function imul(a,b){var ah=a>>>16;var al=a&65535;var bh=b>>>16;var bl=b&65535;return al*bl+(ah*bl+al*bh<<16)|0};Math.imul=Math["imul"];if(!Math["clz32"])Math["clz32"]=(function(x){x=x>>>0;for(var i=0;i<32;i++){if(x&1<<31-i)return i}return 32});Math.clz32=Math["clz32"];if(!Math["trunc"])Math["trunc"]=(function(x){return x<0?Math.ceil(x):Math.floor(x)});Math.trunc=Math["trunc"];var Math_abs=Math.abs;var Math_cos=Math.cos;var Math_sin=Math.sin;var Math_tan=Math.tan;var Math_acos=Math.acos;var Math_asin=Math.asin;var Math_atan=Math.atan;var Math_atan2=Math.atan2;var Math_exp=Math.exp;var Math_log=Math.log;var Math_sqrt=Math.sqrt;var Math_ceil=Math.ceil;var Math_floor=Math.floor;var Math_pow=Math.pow;var Math_imul=Math.imul;var Math_fround=Math.fround;var Math_min=Math.min;var Math_clz32=Math.clz32;var Math_trunc=Math.trunc;var runDependencies=0;var runDependencyWatcher=null;var dependenciesFulfilled=null;function addRunDependency(id){runDependencies++;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}}Module["addRunDependency"]=addRunDependency;function removeRunDependency(id){runDependencies--;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}if(runDependencies==0){if(runDependencyWatcher!==null){clearInterval(runDependencyWatcher);runDependencyWatcher=null}if(dependenciesFulfilled){var callback=dependenciesFulfilled;dependenciesFulfilled=null;callback()}}}Module["removeRunDependency"]=removeRunDependency;Module["preloadedImages"]={};Module["preloadedAudios"]={};var ASM_CONSTS=[(function(){{return Module.getRandomValue()}}),(function(){{if(Module.getRandomValue===undefined){try{var window_="object"===typeof window?window:self,crypto_=typeof window_.crypto!=="undefined"?window_.crypto:window_.msCrypto,randomValuesStandard=(function(){var buf=new Uint32Array(1);crypto_.getRandomValues(buf);return buf[0]>>>0});randomValuesStandard();Module.getRandomValue=randomValuesStandard}catch(e){try{var crypto=require("crypto"),randomValueNodeJS=(function(){var buf=crypto.randomBytes(4);return(buf[0]<<24|buf[1]<<16|buf[2]<<8|buf[3])>>>0});randomValueNodeJS();Module.getRandomValue=randomValueNodeJS}catch(e){throw"No secure random number generator found"}}}}})];function _emscripten_asm_const_i(code){return ASM_CONSTS[code]()}function _emscripten_asm_const_v(code){return ASM_CONSTS[code]()}STATIC_BASE=8;STATICTOP=STATIC_BASE+56e3;__ATINIT__.push({func:(function(){__GLOBAL__I_000101()})},{func:(function(){__GLOBAL__sub_I_iostream_cpp()})});allocate([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,38,232,149,143,194,178,39,176,69,195,244,137,242,239,152,240,213,223,172,5,211,198,51,57,177,56,2,136,109,83,252,5,199,23,106,112,61,77,216,79,186,60,11,118,13,16,103,15,42,32,83,250,44,57,204,198,78,199,253,119,146,172,3,122,19,232,149,143,194,178,39,176,69,195,244,137,242,239,152,240,213,223,172,5,211,198,51,57,177,56,2,136,109,83,252,133,180,23,106,112,61,77,216,79,186,60,11,118,13,16,103,15,42,32,83,250,44,57,204,198,78,199,253,119,146,172,3,250,236,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,237,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,238,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,217,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,218,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,219,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,8,201,188,243,103,230,9,106,59,167,202,132,133,174,103,187,43,248,148,254,114,243,110,60,241,54,29,95,58,245,79,165,209,130,230,173,127,82,14,81,31,108,62,43,140,104,5,155,107,189,65,251,171,217,131,31,121,33,126,19,25,205,224,91,92,160,0,0,145,179,0,0,224,1,0,0,0,0,0,0,52,160,0,0,187,179,0,0,92,160,0,0,205,179,0,0,224,1,0,0,0,0,0,0,52,160,0,0,247,179,0,0,52,160,0,0,40,180,0,0,232,160,0,0,89,180,0,0,0,0,0,0,1,0,0,0,208,1,0,0,3,244,255,255,232,160,0,0,136,180,0,0,0,0,0,0,1,0,0,0,232,1,0,0,3,244,255,255,232,160,0,0,183,180,0,0,0,0,0,0,1,0,0,0,208,1,0,0,3,244,255,255,232,160,0,0,230,180,0,0,0,0,0,0,1,0,0,0,232,1,0,0,3,244,255,255,92,160,0,0,21,181,0,0,56,7,0,0,0,0,0,0,92,160,0,0,47,181,0,0,72,7,0,0,0,0,0,0,92,160,0,0,138,181,0,0,248,1,0,0,0,0,0,0,92,160,0,0,200,181,0,0,0,2,0,0,0,0,0,0,92,160,0,0,224,181,0,0,248,1,0,0,0,0,0,0,92,160,0,0,249,181,0,0,0,2,0,0,0,0,0,0,92,160,0,0,18,182,0,0,216,2,0,0,0,0,0,0,92,160,0,0,38,182,0,0,40,7,0,0,0,0,0,0,92,160,0,0,60,182,0,0,216,2,0,0,0,0,0,0,232,160,0,0,80,182,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,24,3,0,0,0,0,0,0,232,160,0,0,148,182,0,0,0,0,0,0,1,0,0,0,48,3,0,0,0,0,0,0,52,160,0,0,170,182,0,0,232,160,0,0,233,182,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,88,3,0,0,0,0,0,0,232,160,0,0,45,183,0,0,0,0,0,0,1,0,0,0,48,3,0,0,0,0,0,0,232,160,0,0,67,183,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,144,3,0,0,0,0,0,0,232,160,0,0,135,183,0,0,0,0,0,0,1,0,0,0,168,3,0,0,0,0,0,0,52,160,0,0,157,183,0,0,232,160,0,0,201,183,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,208,3,0,0,0,0,0,0,232,160,0,0,13,184,0,0,0,0,0,0,1,0,0,0,168,3,0,0,0,0,0,0,232,160,0,0,35,184,0,0,0,0,0,0,3,0,0,0,216,2,0,0,2,0,0,0,16,4,0,0,2,0,0,0,24,4,0,0,0,8,0,0,52,160,0,0,104,184,0,0,52,160,0,0,123,184,0,0,232,160,0,0,221,185,0,0,0,0,0,0,3,0,0,0,216,2,0,0,2,0,0,0,16,4,0,0,2,0,0,0,72,4,0,0,0,8,0,0,52,160,0,0,34,186,0,0,232,160,0,0,68,186,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,112,4,0,0,0,8,0,0,52,160,0,0,137,186,0,0,232,160,0,0,158,186,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,112,4,0,0,0,8,0,0,232,160,0,0,248,186,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,184,4,0,0,2,0,0,0,52,160,0,0,20,187,0,0,232,160,0,0,41,187,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,184,4,0,0,2,0,0,0,232,160,0,0,69,187,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,184,4,0,0,2,0,0,0,232,160,0,0,97,187,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,184,4,0,0,2,0,0,0,232,160,0,0,125,187,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,64,5,0,0,0,0,0,0,52,160,0,0,195,187,0,0,232,160,0,0,251,187,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,104,5,0,0,0,0,0,0,52,160,0,0,65,188,0,0,232,160,0,0,101,188,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,144,5,0,0,0,0,0,0,52,160,0,0,171,188,0,0,232,160,0,0,202,188,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,184,5,0,0,0,0,0,0,52,160,0,0,16,189,0,0,232,160,0,0,41,189,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,224,5,0,0,2,0,0,0,52,160,0,0,62,189,0,0,232,160,0,0,86,189,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,224,5,0,0,2,0,0,0,92,160,0,0,107,189,0,0,24,6,0,0,0,0,0,0,232,160,0,0,141,189,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,56,6,0,0,2,0,0,0,52,160,0,0,176,189,0,0,92,160,0,0,199,189,0,0,24,6,0,0,0,0,0,0,232,160,0,0,234,189,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,56,6,0,0,2,0,0,0,232,160,0,0,12,190,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,56,6,0,0,2,0,0,0,232,160,0,0,46,190,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,56,6,0,0,2,0,0,0,92,160,0,0,81,190,0,0,216,2,0,0,0,0,0,0,232,160,0,0,103,190,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,224,6,0,0,2,0,0,0,52,160,0,0,121,190,0,0,232,160,0,0,142,190,0,0,0,0,0,0,2,0,0,0,216,2,0,0,2,0,0,0,224,6,0,0,2,0,0,0,92,160,0,0,160,190,0,0,216,2,0,0,0,0,0,0,92,160,0,0,192,190,0,0,216,2,0,0,0,0,0,0,52,160,0,0,220,190,0,0,52,160,0,0,2,191,0,0,92,160,0,0,27,191,0,0,184,7,0,0,0,0,0,0,92,160,0,0,50,191,0,0,48,7,0,0,0,0,0,0,52,160,0,0,89,192,0,0,92,160,0,0,55,192,0,0,128,7,0,0,0,0,0,0,92,160,0,0,228,191,0,0,96,7,0,0,0,0,0,0,92,160,0,0,9,192,0,0,144,7,0,0,0,0,0,0,52,160,0,0,42,192,0,0,92,160,0,0,81,193,0,0,88,7,0,0,0,0,0,0,92,160,0,0,109,193,0,0,88,7,0,0,0,0,0,0,92,160,0,0,125,193,0,0,88,7,0,0,0,0,0,0,92,160,0,0,143,193,0,0,168,7,0,0,0,0,0,0,92,160,0,0,160,193,0,0,88,7,0,0,0,0,0,0,92,160,0,0,186,193,0,0,96,7,0,0,0,0,0,0,182,120,89,255,133,114,211,0,189,110,21,255,15,10,106,0,41,192,1,0,152,232,121,255,188,60,160,255,153,113,206,255,0,183,226,254,180,13,72,255,176,160,14,254,211,201,134,255,158,24,143,0,127,105,53,0,96,12,189,0,167,215,251,255,159,76,128,254,106,101,225,255,30,252,4,0,146,12,174,0,89,241,178,254,10,229,166,255,123,221,42,254,30,20,212,0,82,128,3,0,48,209,243,0,119,121,64,255,50,227,156,255,0,110,197,1,103,27,144,0,133,59,140,1,189,241,36,255,248,37,195,1,96,220,55,0,183,76,62,255,195,66,61,0,50,76,164,1,225,164,76,255,76,61,163,255,117,62,31,0,81,145,64,255,118,65,14,0,162,115,214,255,6,138,46,0,124,230,244,255,10,138,143,0,52,26,194,0,184,244,76,0,129,143,41,1,190,244,19,255,123,170,122,255,98,129,68,0,121,213,147,0,86,101,30,255,161,103,155,0,140,89,67,255,239,229,190,1,67,11,181,0,198,240,137,254,238,69,188,255,67,151,238,0,19,42,108,255,229,85,113,1,50,68,135,255,17,106,9,0,50,103,1,255,80,1,168,1,35,152,30,255,16,168,185,1,56,89,232,255,101,210,252,0,41,250,71,0,204,170,79,255,14,46,239,255,80,77,239,0,189,214,75,255,17,141,249,0,38,80,76,255,190,85,117,0,86,228,170,0,156,216,208,1,195,207,164,255,150,66,76,255,175,225,16,255,141,80,98,1,76,219,242,0,198,162,114,0,46,218,152,0,155,43,241,254,155,160,104,255,51,187,165,0,2,17,175,0,66,84,160,1,247,58,30,0,35,65,53,254,69,236,191,0,45,134,245,1,163,123,221,0,32,110,20,255,52,23,165,0,186,214,71,0,233,176,96,0,242,239,54,1,57,89,138,0,83,0,84,255,136,160,100,0,92,142,120,254,104,124,190,0,181,177,62,255,250,41,85,0,152,130,42,1,96,252,246,0,151,151,63,254,239,133,62,0,32,56,156,0,45,167,189,255,142,133,179,1,131,86,211,0,187,179,150,254,250,170,14,255,210,163,78,0,37,52,151,0,99,77,26,0,238,156,213,255,213,192,209,1,73,46,84,0,20,65,41,1,54,206,79,0,201,131,146,254,170,111,24,255,177,33,50,254,171,38,203,255,78,247,116,0,209,221,153,0,133,128,178,1,58,44,25,0,201,39,59,1,189,19,252,0,49,229,210,1,117,187,117,0,181,179,184,1,0,114,219,0,48,94,147,0,245,41,56,0,125,13,204,254,244,173,119,0,44,221,32,254,84,234,20,0,249,160,198,1,236,126,234,255,47,99,168,254,170,226,153,255,102,179,216,0,226,141,122,255,122,66,153,254,182,245,134,0,227,228,25,1,214,57,235,255,216,173,56,255,181,231,210,0,119,128,157,255,129,95,136,255,110,126,51,0,2,169,183,255,7,130,98,254,69,176,94,255,116,4,227,1,217,242,145,255,202,173,31,1,105,1,39,255,46,175,69,0,228,47,58,255,215,224,69,254,207,56,69,255,16,254,139,255,23,207,212,255,202,20,126,255,95,213,96,255,9,176,33,0,200,5,207,255,241,42,128,254,35,33,192,255,248,229,196,1,129,17,120,0,251,103,151,255,7,52,112,255,140,56,66,255,40,226,245,255,217,70,37,254,172,214,9,255,72,67,134,1,146,192,214,255,44,38,112,0,68,184,75,255,206,90,251,0,149,235,141,0,181,170,58,0,116,244,239,0,92,157,2,0,102,173,98,0,233,137,96,1,127,49,203,0,5,155,148,0,23,148,9,255,211,122,12,0,34,134,26,255,219,204,136,0,134,8,41,255,224,83,43,254,85,25,247,0,109,127,0,254,169,136,48,0,238,119,219,255,231,173,213,0,206,18,254,254,8,186,7,255,126,9,7,1,111,42,72,0,111,52,236,254,96,63,141,0,147,191,127,254,205,78,192,255,14,106,237,1,187,219,76,0,175,243,187,254,105,89,173,0,85,25,89,1,162,243,148,0,2,118,209,254,33,158,9,0,139,163,46,255,93,70,40,0,108,42,142,254,111,252,142,255,155,223,144,0,51,229,167,255,73,252,155,255,94,116,12,255,152,160,218,255,156,238,37,255,179,234,207,255,197,0,179,255,154,164,141,0,225,196,104,0,10,35,25,254,209,212,242,255,97,253,222,254,184,101,229,0,222,18,127,1,164,136,135,255,30,207,140,254,146,97,243,0,129,192,26,254,201,84,33,255,111,10,78,255,147,81,178,255,4,4,24,0,161,238,215,255,6,141,33,0,53,215,14,255,41,181,208,255,231,139,157,0,179,203,221,255,255,185,113,0,189,226,172,255,113,66,214,255,202,62,45,255,102,64,8,255,78,174,16,254,133,117,68,255,133,59,140,1,189,241,36,255,248,37,195,1,96,220,55,0,183,76,62,255,195,66,61,0,50,76,164,1,225,164,76,255,76,61,163,255,117,62,31,0,81,145,64,255,118,65,14,0,162,115,214,255,6,138,46,0,124,230,244,255,10,138,143,0,52,26,194,0,184,244,76,0,129,143,41,1,190,244,19,255,123,170,122,255,98,129,68,0,121,213,147,0,86,101,30,255,161,103,155,0,140,89,67,255,239,229,190,1,67,11,181,0,198,240,137,254,238,69,188,255,234,113,60,255,37,255,57,255,69,178,182,254,128,208,179,0,118,26,125,254,3,7,214,255,241,50,77,255,85,203,197,255,211,135,250,255,25,48,100,255,187,213,180,254,17,88,105,0,83,209,158,1,5,115,98,0,4,174,60,254,171,55,110,255,217,181,17,255,20,188,170,0,146,156,102,254,87,214,174,255,114,122,155,1,233,44,170,0,127,8,239,1,214,236,234,0,175,5,219,0,49,106,61,255,6,66,208,255,2,106,110,255,81,234,19,255,215,107,192,255,67,151,238,0,19,42,108,255,229,85,113,1,50,68,135,255,17,106,9,0,50,103,1,255,80,1,168,1,35,152,30,255,16,168,185,1,56,89,232,255,101,210,252,0,41,250,71,0,204,170,79,255,14,46,239,255,80,77,239,0,189,214,75,255,17,141,249,0,38,80,76,255,190,85,117,0,86,228,170,0,156,216,208,1,195,207,164,255,150,66,76,255,175,225,16,255,141,80,98,1,76,219,242,0,198,162,114,0,46,218,152,0,155,43,241,254,155,160,104,255,178,9,252,254,100,110,212,0,14,5,167,0,233,239,163,255,28,151,157,1,101,146,10,255,254,158,70,254,71,249,228,0,88,30,50,0,68,58,160,255,191,24,104,1,129,66,129,255,192,50,85,255,8,179,138,255,38,250,201,0,115,80,160,0,131,230,113,0,125,88,147,0,90,68,199,0,253,76,158,0,28,255,118,0,113,250,254,0,66,75,46,0,230,218,43,0,229,120,186,1,148,68,43,0,136,124,238,1,187,107,197,255,84,53,246,255,51,116,254,255,51,187,165,0,2,17,175,0,66,84,160,1,247,58,30,0,35,65,53,254,69,236,191,0,45,134,245,1,163,123,221,0,32,110,20,255,52,23,165,0,186,214,71,0,233,176,96,0,242,239,54,1,57,89,138,0,83,0,84,255,136,160,100,0,92,142,120,254,104,124,190,0,181,177,62,255,250,41,85,0,152,130,42,1,96,252,246,0,151,151,63,254,239,133,62,0,32,56,156,0,45,167,189,255,142,133,179,1,131,86,211,0,187,179,150,254,250,170,14,255,68,113,21,255,222,186,59,255,66,7,241,1,69,6,72,0,86,156,108,254,55,167,89,0,109,52,219,254,13,176,23,255,196,44,106,255,239,149,71,255,164,140,125,255,159,173,1,0,51,41,231,0,145,62,33,0,138,111,93,1,185,83,69,0,144,115,46,0,97,151,16,255,24,228,26,0,49,217,226,0,113,75,234,254,193,153,12,255,182,48,96,255,14,13,26,0,128,195,249,254,69,193,59,0,132,37,81,254,125,106,60,0,214,240,169,1,164,227,66,0,210,163,78,0,37,52,151,0,99,77,26,0,238,156,213,255,213,192,209,1,73,46,84,0,20,65,41,1,54,206,79,0,201,131,146,254,170,111,24,255,177,33,50,254,171,38,203,255,78,247,116,0,209,221,153,0,133,128,178,1,58,44,25,0,201,39,59,1,189,19,252,0,49,229,210,1,117,187,117,0,181,179,184,1,0,114,219,0,48,94,147,0,245,41,56,0,125,13,204,254,244,173,119,0,44,221,32,254,84,234,20,0,249,160,198,1,236,126,234,255,143,62,221,0,129,89,214,255,55,139,5,254,68,20,191,255,14,204,178,1,35,195,217,0,47,51,206,1,38,246,165,0,206,27,6,254,158,87,36,0,217,52,146,255,125,123,215,255,85,60,31,255,171,13,7,0,218,245,88,254,252,35,60,0,55,214,160,255,133,101,56,0,224,32,19,254,147,64,234,0,26,145,162,1,114,118,125,0,248,252,250,0,101,94,196,255,198,141,226,254,51,42,182,0,135,12,9,254,109,172,210,255,197,236,194,1,241,65,154,0,48,156,47,255,153,67,55,255,218,165,34,254,74,180,179,0,218,66,71,1,88,122,99,0,212,181,219,255,92,42,231,255,239,0,154,0,245,77,183,255,94,81,170,1,18,213,216,0,171,93,71,0,52,94,248,0,18,151,161,254,197,209,66,255,174,244,15,254,162,48,183,0,49,61,240,254,182,93,195,0,199,228,6,1,200,5,17,255,137,45,237,255,108,148,4,0,90,79,237,255,39,63,77,255,53,82,207,1,142,22,118,255,101,232,18,1,92,26,67,0,5,200,88,255,33,168,138,255,149,225,72,0,2,209,27,255,44,245,168,1,220,237,17,255,30,211,105,254,141,238,221,0,128,80,245,254,111,254,14,0,222,95,190,1,223,9,241,0,146,76,212,255,108,205,104,255,63,117,153,0,144,69,48,0,35,228,111,0,192,33,193,255,112,214,190,254,115,152,151,0,23,102,88,0,51,74,248,0,226,199,143,254,204,162,101,255,208,97,189,1,245,104,18,0,230,246,30,255,23,148,69,0,110,88,52,254,226,181,89,255,208,47,90,254,114,161,80,255,33,116,248,0,179,152,87,255,69,144,177,1,88,238,26,255,58,32,113,1,1,77,69,0,59,121,52,255,152,238,83,0,52,8,193,0,231,39,233,255,199,34,138,0,222,68,173,0,91,57,242,254,220,210,127,255,192,7,246,254,151,35,187,0,195,236,165,0,111,93,206,0,212,247,133,1,154,133,209,255,155,231,10,0,64,78,38,0,122,249,100,1,30,19,97,255,62,91,249,1,248,133,77,0,197,63,168,254,116,10,82,0,184,236,113,254,212,203,194,255,61,100,252,254,36,5,202,255,119,91,153,255,129,79,29,0,103,103,171,254,237,215,111,255,216,53,69,0,239,240,23,0,194,149,221,255,38,225,222,0,232,255,180,254,118,82,133,255,57,209,177,1,139,232,133,0,158,176,46,254,194,115,46,0,88,247,229,1,28,103,191,0,221,222,175,254,149,235,44,0,151,228,25,254,218,105,103,0,142,85,210,0,149,129,190,255,213,65,94,254,117,134,224,255,82,198,117,0,157,221,220,0,163,101,36,0,197,114,37,0,104,172,166,254,11,182,0,0,81,72,188,255,97,188,16,255,69,6,10,0,199,147,145,255,8,9,115,1,65,214,175,255,217,173,209,0,80,127,166,0,247,229,4,254,167,183,124,255,90,28,204,254,175,59,240,255,11,41,248,1,108,40,51,255,144,177,195,254,150,250,126,0,138,91,65,1,120,60,222,255,245,193,239,0,29,214,189,255,128,2,25,0,80,154,162,0,77,220,107,1,234,205,74,255,54,166,103,255,116,72,9,0,228,94,47,255,30,200,25,255,35,214,89,255,61,176,140,255,83,226,163,255,75,130,172,0,128,38,17,0,95,137,152,255,215,124,159,1,79,93,0,0,148,82,157,254,195,130,251,255,40,202,76,255,251,126,224,0,157,99,62,254,207,7,225,255,96,68,195,0,140,186,157,255,131,19,231,255,42,128,254,0,52,219,61,254,102,203,72,0,141,7,11,255,186,164,213,0,31,122,119,0,133,242,145,0,208,252,232,255,91,213,182,255,143,4,250,254,249,215,74,0,165,30,111,1,171,9,223,0,229,123,34,1,92,130,26,255,77,155,45,1,195,139,28,255,59,224,78,0,136,17,247,0,108,121,32,0,79,250,189,255,96,227,252,254,38,241,62,0,62,174,125,255,155,111,93,255,10,230,206,1,97,197,40,255,0,49,57,254,65,250,13,0,18,251,150,255,220,109,210,255,5,174,166,254,44,129,189,0,235,35,147,255,37,247,141,255,72,141,4,255,103,107,255,0,247,90,4,0,53,44,42,0,2,30,240,0,4,59,63,0,88,78,36,0,113,167,180,0,190,71,193,255,199,158,164,255,58,8,172,0,77,33,12,0,65,63,3,0,153,77,33,255,172,254,102,1,228,221,4,255,87,30,254,1,146,41,86,255,138,204,239,254,108,141,17,255,187,242,135,0,210,208,127,0,68,45,14,254,73,96,62,0,81,60,24,255,170,6,36,255,3,249,26,0,35,213,109,0,22,129,54,255,21,35,225,255,234,61,56,255,58,217,6,0,143,124,88,0,236,126,66,0,209,38,183,255,34,238,6,255,174,145,102,0,95,22,211,0,196,15,153,254,46,84,232,255,117,34,146,1,231,250,74,255,27,134,100,1,92,187,195,255,170,198,112,0,120,28,42,0,209,70,67,0,29,81,31,0,29,168,100,1,169,173,160,0,107,35,117,0,62,96,59,255,81,12,69,1,135,239,190,255,220,252,18,0,163,220,58,255,137,137,188,255,83,102,109,0,96,6,76,0,234,222,210,255,185,174,205,1,60,158,213,255,13,241,214,0,172,129,140,0,93,104,242,0,192,156,251,0,43,117,30,0,225,81,158,0,127,232,218,0,226,28,203,0,233,27,151,255,117,43,5,255,242,14,47,255,33,20,6,0,137,251,44,254,27,31,245,255,183,214,125,254,40,121,149,0,186,158,213,255,89,8,227,0,69,88,0,254,203,135,225,0,201,174,203,0,147,71,184,0,18,121,41,254,94,5,78,0,224,214,240,254,36,5,180,0,251,135,231,1,163,138,212,0,210,249,116,254,88,129,187,0,19,8,49,254,62,14,144,255,159,76,211,0,214,51,82,0,109,117,228,254,103,223,203,255,75,252,15,1,154,71,220,255,23,13,91,1,141,168,96,255,181,182,133,0,250,51,55,0,234,234,212,254,175,63,158,0,39,240,52,1,158,189,36,255,213,40,85,1,32,180,247,255,19,102,26,1,84,24,97,255,69,21,222,0,148,139,122,255,220,213,235,1,232,203,255,0,121,57,147,0,227,7,154,0,53,22,147,1,72,1,225,0,82,134,48,254,83,60,157,255,145,72,169,0,34,103,239,0,198,233,47,0,116,19,4,255,184,106,9,255,183,129,83,0,36,176,230,1,34,103,72,0,219,162,134,0,245,42,158,0,32,149,96,254,165,44,144,0,202,239,72,254,215,150,5,0,42,66,36,1,132,215,175,0,86,174,86,255,26,197,156,255,49,232,135,254,103,182,82,0,253,128,176,1,153,178,122,0,245,250,10,0,236,24,178,0,137,106,132,0,40,29,41,0,50,30,152,255,124,105,38,0,230,191,75,0,143,43,170,0,44,131,20,255,44,13,23,255,237,255,155,1,159,109,100,255,112,181,24,255,104,220,108,0,55,211,131,0,99,12,213,255,152,151,145,255,238,5,159,0,97,155,8,0,33,108,81,0,1,3,103,0,62,109,34,255,250,155,180,0,32,71,195,255,38,70,145,1,159,95,245,0,69,229,101,1,136,28,240,0,79,224,25,0,78,110,121,255,248,168,124,0,187,128,247,0,2,147,235,254,79,11,132,0,70,58,12,1,181,8,163,255,79,137,133,255,37,170,11,255,141,243,85,255,176,231,215,255,204,150,164,255,239,215,39,255,46,87,156,254,8,163,88,255,172,34,232,0,66,44,102,255,27,54,41,254,236,99,87,255,41,123,169,1,52,114,43,0,117,134,40,0,155,134,26,0,231,207,91,254,35,132,38,255,19,102,125,254,36,227,133,255,118,3,113,255,29,13,124,0,152,96,74,1,88,146,206,255,167,191,220,254,162,18,88,255,182,100,23,0,31,117,52,0,81,46,106,1,12,2,7,0,69,80,201,1,209,246,172,0,12,48,141,1,224,211,88,0,116,226,159,0,122,98,130,0,65,236,234,1,225,226,9,255,207,226,123,1,89,214,59,0,112,135,88,1,90,244,203,255,49,11,38,1,129,108,186,0,89,112,15,1,101,46,204,255,127,204,45,254,79,255,221,255,51,73,18,255,127,42,101,255,241,21,202,0,160,227,7,0,105,50,236,0,79,52,197,255,104,202,208,1,180,15,16,0,101,197,78,255,98,77,203,0,41,185,241,1,35,193,124,0,35,155,23,255,207,53,192,0,11,125,163,1,249,158,185,255,4,131,48,0,21,93,111,255,61,121,231,1,69,200,36,255,185,48,185,255,111,238,21,255,39,50,25,255,99,215,163,255,87,212,30,255,164,147,5,255,128,6,35,1,108,223,110,255,194,76,178,0,74,101,180,0,243,47,48,0,174,25,43,255,82,173,253,1,54,114,192,255,40,55,91,0,215,108,176,255,11,56,7,0,224,233,76,0,209,98,202,254,242,25,125,0,44,193,93,254,203,8,177,0,135,176,19,0,112,71,213,255,206,59,176,1,4,67,26,0,14,143,213,254,42,55,208,255,60,67,120,0,193,21,163,0,99,164,115,0,10,20,118,0,156,212,222,254,160,7,217,255,114,245,76,1,117,59,123,0,176,194,86,254,213,15,176,0,78,206,207,254,213,129,59,0,233,251,22,1,96,55,152,255,236,255,15,255,197,89,84,255,93,149,133,0,174,160,113,0,234,99,169,255,152,116,88,0,144,164,83,255,95,29,198,255,34,47,15,255,99,120,134,255,5,236,193,0,249,247,126,255,147,187,30,0,50,230,117,255,108,217,219,255,163,81,166,255,72,25,169,254,155,121,79,255,28,155,89,254,7,126,17,0,147,65,33,1,47,234,253,0,26,51,18,0,105,83,199,255,163,196,230,0,113,248,164,0,226,254,218,0,189,209,203,255,164,247,222,254,255,35,165,0,4,188,243,1,127,179,71,0,37,237,254,255,100,186,240,0,5,57,71,254,103,72,73,255,244,18,81,254,229,210,132,255,238,6,180,255,11,229,174,255,227,221,192,1,17,49,28,0,163,215,196,254,9,118,4,255,51,240,71,0,113,129,109,255,76,240,231,0,188,177,127,0,125,71,44,1,26,175,243,0,94,169,25,254,27,230,29,0,15,139,119,1,168,170,186,255,172,197,76,255,252,75,188,0,137,124,196,0,72,22,96,255,45,151,249,1,220,145,100,0,64,192,159,255,120,239,226,0,129,178,146,0,0,192,125,0,235,138,234,0,183,157,146,0,83,199,192,255,184,172,72,255,73,225,128,0,77,6,250,255,186,65,67,0,104,246,207,0,188,32,138,255,218,24,242,0,67,138,81,254,237,129,121,255,20,207,150,1,41,199,16,255,6,20,128,0,159,118,5,0,181,16,143,255,220,38,15,0,23,64,147,254,73,26,13,0,87,228,57,1,204,124,128,0,43,24,223,0,219,99,199,0,22,75,20,255,19,27,126,0,157,62,215,0,110,29,230,0,179,167,255,1,54,252,190,0,221,204,182,254,179,158,65,255,81,157,3,0,194,218,159,0,170,223,0,0,224,11,32,255,38,197,98,0,168,164,37,0,23,88,7,1,164,186,110,0,96,36,134,0,234,242,229,0,250,121,19,0,242,254,112,255,3,47,94,1,9,239,6,255,81,134,153,254,214,253,168,255,67,124,224,0,245,95,74,0,28,30,44,254,1,109,220,255,178,89,89,0,252,36,76,0,24,198,46,255,76,77,111,0,134,234,136,255,39,94,29,0,185,72,234,255,70,68,135,255,231,102,7,254,77,231,140,0,167,47,58,1,148,97,118,255,16,27,225,1,166,206,143,255,110,178,214,255,180,131,162,0,143,141,225,1,13,218,78,255,114,153,33,1,98,104,204,0,175,114,117,1,167,206,75,0,202,196,83,1,58,64,67,0,138,47,111,1,196,247,128,255,137,224,224,254,158,112,207,0,154,100,255,1,134,37,107,0,198,128,79,255,127,209,155,255,163,254,185,254,60,14,243,0,31,219,112,254,29,217,65,0,200,13,116,254,123,60,196,255,224,59,184,254,242,89,196,0,123,16,75,254,149,16,206,0,69,254,48,1,231,116,223,255,209,160,65,1,200,80,98,0,37,194,184,254,148,63,34,0,139,240,65,255,217,144,132,255,56,38,45,254,199,120,210,0,108,177,166,255,160,222,4,0,220,126,119,254,165,107,160,255,82,220,248,1,241,175,136,0,144,141,23,255,169,138,84,0,160,137,78,255,226,118,80,255,52,27,132,255,63,96,139,255,152,250,39,0,188,155,15,0,232,51,150,254,40,15,232,255,240,229,9,255,137,175,27,255,75,73,97,1,218,212,11,0,135,5,162,1,107,185,213,0,2,249,107,255,40,242,70,0,219,200,25,0,25,157,13,0,67,82,80,255,196,249,23,255,145,20,149,0,50,72,146,0,94,76,148,1,24,251,65,0,31,192,23,0,184,212,201,255,123,233,162,1,247,173,72,0,162,87,219,254,126,134,89,0,159,11,12,254,166,105,29,0,73,27,228,1,113,120,183,255,66,163,109,1,212,143,11,255,159,231,168,1,255,128,90,0,57,14,58,254,89,52,10,255,253,8,163,1,0,145,210,255,10,129,85,1,46,181,27,0,103,136,160,254,126,188,209,255,34,35,111,0,215,219,24,255,212,11,214,254,101,5,118,0,232,197,133,255,223,167,109,255,237,80,86,255,70,139,94,0,158,193,191,1,155,15,51,255,15,190,115,0,78,135,207,255,249,10,27,1,181,125,233,0,95,172,13,254,170,213,161,255,39,236,138,255,95,93,87,255,190,128,95,0,125,15,206,0,166,150,159,0,227,15,158,255,206,158,120,255,42,141,128,0,101,178,120,1,156,109,131,0,218,14,44,254,247,168,206,255,212,112,28,0,112,17,228,255,90,16,37,1,197,222,108,0,254,207,83,255,9,90,243,255,243,244,172,0,26,88,115,255,205,116,122,0,191,230,193,0,180,100,11,1,217,37,96,255,154,78,156,0,235,234,31,255,206,178,178,255,149,192,251,0,182,250,135,0,246,22,105,0,124,193,109,255,2,210,149,255,169,17,170,0,0,96,110,255,117,9,8,1,50,123,40,255,193,189,99,0,34,227,160,0,48,80,70,254,211,51,236,0,45,122,245,254,44,174,8,0,173,37,233,255,158,65,171,0,122,69,215,255,90,80,2,255,131,106,96,254,227,114,135,0,205,49,119,254,176,62,64,255,82,51,17,255,241,20,243,255,130,13,8,254,128,217,243,255,162,27,1,254,90,118,241,0,246,198,246,255,55,16,118,255,200,159,157,0,163,17,1,0,140,107,121,0,85,161,118,255,38,0,149,0,156,47,238,0,9,166,166,1,75,98,181,255,50,74,25,0,66,15,47,0,139,225,159,0,76,3,142,255,14,238,184,0,11,207,53,255,183,192,186,1,171,32,174,255,191,76,221,1,247,170,219,0,25,172,50,254,217,9,233,0,203,126,68,255,183,92,48,0,127,167,183,1,65,49,254,0,16,63,127,1,254,21,170,255,59,224,127,254,22,48,63,255,27,78,130,254,40,195,29,0,250,132,112,254,35,203,144,0,104,169,168,0,207,253,30,255,104,40,38,254,94,228,88,0,206,16,128,255,212,55,122,255,223,22,234,0,223,197,127,0,253,181,181,1,145,102,118,0,236,153,36,255,212,217,72,255,20,38,24,254,138,62,62,0,152,140,4,0,230,220,99,255,1,21,212,255,148,201,231,0,244,123,9,254,0,171,210,0,51,58,37,255,1,255,14,255,244,183,145,254,0,242,166,0,22,74,132,0,121,216,41,0,95,195,114,254,133,24,151,255,156,226,231,255,247,5,77,255,246,148,115,254,225,92,81,255,222,80,246,254,170,123,89,255,74,199,141,0,29,20,8,255,138,136,70,255,93,75,92,0,221,147,49,254,52,126,226,0,229,124,23,0,46,9,181,0,205,64,52,1,131,254,28,0,151,158,212,0,131,64,78,0,206,25,171,0,0,230,139,0,191,253,110,254,103,247,167,0,64,40,40,1,42,165,241,255,59,75,228,254,124,243,189,255,196,92,178,255,130,140,86,255,141,89,56,1,147,198,5,255,203,248,158,254,144,162,141,0,11,172,226,0,130,42,21,255,1,167,143,255,144,36,36,255,48,88,164,254,168,170,220,0,98,71,214,0,91,208,79,0,159,76,201,1,166,42,214,255,69,255,0,255,6,128,125,255,190,1,140,0,146,83,218,255,215,238,72,1,122,127,53,0,189,116,165,255,84,8,66,255,214,3,208,255,213,110,133,0,195,168,44,1,158,231,69,0,162,64,200,254,91,58,104,0,182,58,187,254,249,228,136,0,203,134,76,254,99,221,233,0,75,254,214,254,80,69,154,0,64,152,248,254,236,136,202,255,157,105,153,254,149,175,20,0,22,35,19,255,124,121,233,0,186,250,198,254,132,229,139,0,137,80,174,255,165,125,68,0,144,202,148,254,235,239,248,0,135,184,118,0,101,94,17,255,122,72,70,254,69,130,146,0,127,222,248,1,69,127,118,255,30,82,215,254,188,74,19,255,229,167,194,254,117,25,66,255,65,234,56,254,213,22,156,0,151,59,93,254,45,28,27,255,186,126,164,255,32,6,239,0,127,114,99,1,219,52,2,255,99,96,166,254,62,190,126,255,108,222,168,1,75,226,174,0,230,226,199,0,60,117,218,255,252,248,20,1,214,188,204,0,31,194,134,254,123,69,192,255,169,173,36,254,55,98,91,0,223,42,102,254,137,1,102,0,157,90,25,0,239,122,64,255,252,6,233,0,7,54,20,255,82,116,174,0,135,37,54,255,15,186,125,0,227,112,175,255,100,180,225,255,42,237,244,255,244,173,226,254,248,18,33,0,171,99,150,255,74,235,50,255,117,82,32,254,106,168,237,0,207,109,208,1,228,9,186,0,135,60,169,254,179,92,143,0,244,170,104,255,235,45,124,255,70,99,186,0,117,137,183,0,224,31,215,0,40,9,100,0,26,16,95,1,68,217,87,0,8,151,20,255,26,100,58,255,176,165,203,1,52,118,70,0,7,32,254,254,244,254,245,255,167,144,194,255,125,113,23,255,176,121,181,0,136,84,209,0,138,6,30,255,89,48,28,0,33,155,14,255,25,240,154,0,141,205,109,1,70,115,62,255,20,40,107,254,138,154,199,255,94,223,226,255,157,171,38,0,163,177,25,254,45,118,3,255,14,222,23,1,209,190,81,255,118,123,232,1,13,213,101,255,123,55,123,254,27,246,165,0,50,99,76,255,140,214,32,255,97,65,67,255,24,12,28,0,174,86,78,1,64,247,96,0,160,135,67,0,66,55,243,255,147,204,96,255,26,6,33,255,98,51,83,1,153,213,208,255,2,184,54,255,25,218,11,0,49,67,246,254,18,149,72,255,13,25,72,0,42,79,214,0,42,4,38,1,27,139,144,255,149,187,23,0,18,164,132,0,245,84,184,254,120,198,104,255,126,218,96,0,56,117,234,255,13,29,214,254,68,47,10,255,167,154,132,254,152,38,198,0,66,178,89,255,200,46,171,255,13,99,83,255,210,187,253,255,170,45,42,1,138,209,124,0,214,162,141,0,12,230,156,0,102,36,112,254,3,147,67,0,52,215,123,255,233,171,54,255,98,137,62,0,247,218,39,255,231,218,236,0,247,191,127,0,195,146,84,0,165,176,92,255,19,212,94,255,17,74,227,0,88,40,153,1,198,147,1,255,206,67,245,254,240,3,218,255,61,141,213,255,97,183,106,0,195,232,235,254,95,86,154,0,209,48,205,254,118,209,241,255,240,120,223,1,213,29,159,0,163,127,147,255,13,218,93,0,85,24,68,254,70,20,80,255,189,5,140,1,82,97,254,255,99,99,191,255,132,84,133,255,107,218,116,255,112,122,46,0,105,17,32,0,194,160,63,255,68,222,39,1,216,253,92,0,177,105,205,255,149,201,195,0,42,225,11,255,40,162,115,0,9,7,81,0,165,218,219,0,180,22,0,254,29,146,252,255,146,207,225,1,180,135,96,0,31,163,112,0,177,11,219,255,133,12,193,254,43,78,50,0,65,113,121,1,59,217,6,255,110,94,24,1,112,172,111,0,7,15,96,0,36,85,123,0,71,150,21,255,208,73,188,0,192,11,167,1,213,245,34,0,9,230,92,0,162,142,39,255,215,90,27,0,98,97,89,0,94,79,211,0,90,157,240,0,95,220,126,1,102,176,226,0,36,30,224,254,35,31,127,0,231,232,115,1,85,83,130,0,210,73,245,255,47,143,114,255,68,65,197,0,59,72,62,255,183,133,173,254,93,121,118,255,59,177,81,255,234,69,173,255,205,128,177,0,220,244,51,0,26,244,209,1,73,222,77,255,163,8,96,254,150,149,211,0,158,254,203,1,54,127,139,0,161,224,59,0,4,109,22,255,222,42,45,255,208,146,102,255,236,142,187,0,50,205,245,255,10,74,89,254,48,79,142,0,222,76,130,255,30,166,63,0,236,12,13,255,49,184,244,0,187,113,102,0,218,101,253,0,153,57,182,254,32,150,42,0,25,198,146,1,237,241,56,0,140,68,5,0,91,164,172,255,78,145,186,254,67,52,205,0,219,207,129,1,109,115,17,0,54,143,58,1,21,248,120,255,179,255,30,0,193,236,66,255,1,255,7,255,253,192,48,255,19,69,217,1,3,214,0,255,64,101,146,1,223,125,35,255,235,73,179,255,249,167,226,0,225,175,10,1,97,162,58,0,106,112,171,1,84,172,5,255,133,140,178,255,134,245,142,0,97,90,125,255,186,203,185,255,223,77,23,255,192,92,106,0,15,198,115,255,217,152,248,0,171,178,120,255,228,134,53,0,176,54,193,1,250,251,53,0,213,10,100,1,34,199,106,0,151,31,244,254,172,224,87,255,14,237,23,255,253,85,26,255,127,39,116,255,172,104,100,0,251,14,70,255,212,208,138,255,253,211,250,0,176,49,165,0,15,76,123,255,37,218,160,255,92,135,16,1,10,126,114,255,70,5,224,255,247,249,141,0,68,20,60,1,241,210,189,255,195,217,187,1,151,3,113,0,151,92,174,0,231,62,178,255,219,183,225,0,23,23,33,255,205,181,80,0,57,184,248,255,67,180,1,255,90,123,93,255,39,0,162,255,96,248,52,255,84,66,140,0,34,127,228,255,194,138,7,1,166,110,188,0,21,17,155,1,154,190,198,255,214,80,59,255,18,7,143,0,72,29,226,1,199,217,249,0,232,161,71,1,149,190,201,0,217,175,95,254,113,147,67,255,138,143,199,255,127,204,1,0,29,182,83,1,206,230,155,255,186,204,60,0,10,125,85,255,232,96,25,255,255,89,247,255,213,254,175,1,232,193,81,0,28,43,156,254,12,69,8,0,147,24,248,0,18,198,49,0,134,60,35,0,118,246,18,255,49,88,254,254,228,21,186,255,182,65,112,1,219,22,1,255,22,126,52,255,189,53,49,255,112,25,143,0,38,127,55,255,226,101,163,254,208,133,61,255,137,69,174,1,190,118,145,255,60,98,219,255,217,13,245,255,250,136,10,0,84,254,226,0,201,31,125,1,240,51,251,255,31,131,130,255,2,138,50,255,215,215,177,1,223,12,238,255,252,149,56,255,124,91,68,255,72,126,170,254,119,255,100,0,130,135,232,255,14,79,178,0,250,131,197,0,138,198,208,0,121,216,139,254,119,18,36,255,29,193,122,0,16,42,45,255,213,240,235,1,230,190,169,255,198,35,228,254,110,173,72,0,214,221,241,255,56,148,135,0,192,117,78,254,141,93,207,255,143,65,149,0,21,18,98,255,95,44,244,1,106,191,77,0,254,85,8,254,214,110,176,255,73,173,19,254,160,196,199,255,237,90,144,0,193,172,113,255,200,155,136,254,228,90,221,0,137,49,74,1,164,221,215,255,209,189,5,255,105,236,55,255,42,31,129,1,193,255,236,0,46,217,60,0,138,88,187,255,226,82,236,255,81,69,151,255,142,190,16,1,13,134,8,0,127,122,48,255,81,64,156,0,171,243,139,0,237,35,246,0,122,143,193,254,212,122,146,0,95,41,255,1,87,132,77,0,4,212,31,0,17,31,78,0,39,45,173,254,24,142,217,255,95,9,6,255,227,83,6,0,98,59,130,254,62,30,33,0,8,115,211,1,162,97,128,255,7,184,23,254,116,28,168,255,248,138,151,255,98,244,240,0,186,118,130,0,114,248,235,255,105,173,200,1,160,124,71,255,94,36,164,1,175,65,146,255,238,241,170,254,202,198,197,0,228,71,138,254,45,246,109,255,194,52,158,0,133,187,176,0,83,252,154,254,89,189,221,255,170,73,252,0,148,58,125,0,36,68,51,254,42,69,177,255,168,76,86,255,38,100,204,255,38,53,35,0,175,19,97,0,225,238,253,255,81,81,135,0,210,27,255,254,235,73,107,0,8,207,115,0,82,127,136,0,84,99,21,254,207,19,136,0,100,164,101,0,80,208,77,255,132,207,237,255,15,3,15,255,33,166,110,0,156,95,85,255,37,185,111,1,150,106,35,255,166,151,76,0,114,87,135,255,159,194,64,0,12,122,31,255,232,7,101,254,173,119,98,0,154,71,220,254,191,57,53,255,168,232,160,255,224,32,99,255,218,156,165,0,151,153,163,0,217,13,148,1,197,113,89,0,149,28,161,254,207,23,30,0,105,132,227,255,54,230,94,255,133,173,204,255,92,183,157,255,88,144,252,254,102,33,90,0,159,97,3,0,181,218,155,255,240,114,119,0,106,214,53,255,165,190,115,1,152,91,225,255,88,106,44,255,208,61,113,0,151,52,124,0,191,27,156,255,110,54,236,1,14,30,166,255,39,127,207,1,229,199,28,0,188,228,188,254,100,157,235,0,246,218,183,1,107,22,193,255,206,160,95,0,76,239,147,0,207,161,117,0,51,166,2,255,52,117,10,254,73,56,227,255,152,193,225,0,132,94,136,255,101,191,209,0,32,107,229,255,198,43,180,1,100,210,118,0,114,67,153,255,23,88,26,255,89,154,92,1,220,120,140,255,144,114,207,255,252,115,250,255,34,206,72,0,138,133,127,255,8,178,124,1,87,75,97,0,15,229,92,254,240,67,131,255,118,123,227,254,146,120,104,255,145,213,255,1,129,187,70,255,219,119,54,0,1,19,173,0,45,150,148,1,248,83,72,0,203,233,169,1,142,107,56,0,247,249,38,1,45,242,80,255,30,233,103,0,96,82,70,0,23,201,111,0,81,39,30,255,161,183,78,255,194,234,33,255,68,227,140,254,216,206,116,0,70,27,235,255,104,144,79,0,164,230,93,254,214,135,156,0,154,187,242,254,188,20,131,255,36,109,174,0,159,112,241,0,5,110,149,1,36,165,218,0,166,29,19,1,178,46,73,0,93,43,32,254,248,189,237,0,102,155,141,0,201,93,195,255,241,139,253,255,15,111,98,255,108,65,163,254,155,79,190,255,73,174,193,254,246,40,48,255,107,88,11,254,202,97,85,255,253,204,18,255,113,242,66,0,110,160,194,254,208,18,186,0,81,21,60,0,188,104,167,255,124,166,97,254,210,133,142,0,56,242,137,254,41,111,130,0,111,151,58,1,111,213,141,255,183,172,241,255,38,6,196,255,185,7,123,255,46,11,246,0,245,105,119,1,15,2,161,255,8,206,45,255,18,202,74,255,83,124,115,1,212,141,157,0,83,8,209,254,139,15,232,255,172,54,173,254,50,247,132,0,214,189,213,0,144,184,105,0,223,254,248,0,255,147,240,255,23,188,72,0,7,51,54,0,188,25,180,254,220,180,0,255,83,160,20,0,163,189,243,255,58,209,194,255,87,73,60,0,106,24,49,0,245,249,220,0,22,173,167,0,118,11,195,255,19,126,237,0,110,159,37,255,59,82,47,0,180,187,86,0,188,148,208,1,100,37,133,255,7,112,193,0,129,188,156,255,84,106,129,255,133,225,202,0,14,236,111,255,40,20,101],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE);allocate([172,172,49,254,51,54,74,255,251,185,184,255,93,155,224,255,180,249,224,1,230,178,146,0,72,57,54,254,178,62,184,0,119,205,72,0,185,239,253,255,61,15,218,0,196,67,56,255,234,32,171,1,46,219,228,0,208,108,234,255,20,63,232,255,165,53,199,1,133,228,5,255,52,205,107,0,74,238,140,255,150,156,219,254,239,172,178,255,251,189,223,254,32,142,211,255,218,15,138,1,241,196,80,0,28,36,98,254,22,234,199,0,61,237,220,255,246,57,37,0,142,17,142,255,157,62,26,0,43,238,95,254,3,217,6,255,213,25,240,1,39,220,174,255,154,205,48,254,19,13,192,255,244,34,54,254,140,16,155,0,240,181,5,254,155,193,60,0,166,128,4,255,36,145,56,255,150,240,219,0,120,51,145,0,82,153,42,1,140,236,146,0,107,92,248,1,189,10,3,0,63,136,242,0,211,39,24,0,19,202,161,1,173,27,186,255,210,204,239,254,41,209,162,255,182,254,159,255,172,116,52,0,195,103,222,254,205,69,59,0,53,22,41,1,218,48,194,0,80,210,242,0,210,188,207,0,187,161,161,254,216,17,1,0,136,225,113,0,250,184,63,0,223,30,98,254,77,168,162,0,59,53,175,0,19,201,10,255,139,224,194,0,147,193,154,255,212,189,12,254,1,200,174,255,50,133,113,1,94,179,90,0,173,182,135,0,94,177,113,0,43,89,215,255,136,252,106,255,123,134,83,254,5,245,66,255,82,49,39,1,220,2,224,0,97,129,177,0,77,59,89,0,61,29,155,1,203,171,220,255,92,78,139,0,145,33,181,255,169,24,141,1,55,150,179,0,139,60,80,255,218,39,97,0,2,147,107,255,60,248,72,0,173,230,47,1,6,83,182,255,16,105,162,254,137,212,81,255,180,184,134,1,39,222,164,255,221,105,251,1,239,112,125,0,63,7,97,0,63,104,227,255,148,58,12,0,90,60,224,255,84,212,252,0,79,215,168,0,248,221,199,1,115,121,1,0,36,172,120,0,32,162,187,255,57,107,49,255,147,42,21,0,106,198,43,1,57,74,87,0,126,203,81,255,129,135,195,0,140,31,177,0,221,139,194,0,3,222,215,0,131,68,231,0,177,86,178,254,124,151,180,0,184,124,38,1,70,163,17,0,249,251,181,1,42,55,227,0,226,161,44,0,23,236,110,0,51,149,142,1,93,5,236,0,218,183,106,254,67,24,77,0,40,245,209,255,222,121,153,0,165,57,30,0,83,125,60,0,70,38,82,1,229,6,188,0,109,222,157,255,55,118,63,255,205,151,186,0,227,33,149,255,254,176,246,1,227,177,227,0,34,106,163,254,176,43,79,0,106,95,78,1,185,241,122,255,185,14,61,0,36,1,202,0,13,178,162,255,247,11,132,0,161,230,92,1,65,1,185,255,212,50,165,1,141,146,64,255,158,242,218,0,21,164,125,0,213,139,122,1,67,71,87,0,203,158,178,1,151,92,43,0,152,111,5,255,39,3,239,255,217,255,250,255,176,63,71,255,74,245,77,1,250,174,18,255,34,49,227,255,246,46,251,255,154,35,48,1,125,157,61,255,106,36,78,255,97,236,153,0,136,187,120,255,113,134,171,255,19,213,217,254,216,94,209,255,252,5,61,0,94,3,202,0,3,26,183,255,64,191,43,255,30,23,21,0,129,141,77,255,102,120,7,1,194,76,140,0,188,175,52,255,17,81,148,0,232,86,55,1,225,48,172,0,134,42,42,255,238,50,47,0,169,18,254,0,20,147,87,255,14,195,239,255,69,247,23,0,238,229,128,255,177,49,112,0,168,98,251,255,121,71,248,0,243,8,145,254,246,227,153,255,219,169,177,254,251,139,165,255,12,163,185,255,164,40,171,255,153,159,27,254,243,109,91,255,222,24,112,1,18,214,231,0,107,157,181,254,195,147,0,255,194,99,104,255,89,140,190,255,177,66,126,254,106,185,66,0,49,218,31,0,252,174,158,0,188,79,230,1,238,41,224,0,212,234,8,1,136,11,181,0,166,117,83,255,68,195,94,0,46,132,201,0,240,152,88,0,164,57,69,254,160,224,42,255,59,215,67,255,119,195,141,255,36,180,121,254,207,47,8,255,174,210,223,0,101,197,68,255,255,82,141,1,250,137,233,0,97,86,133,1,16,80,69,0,132,131,159,0,116,93,100,0,45,141,139,0,152,172,157,255,90,43,91,0,71,153,46,0,39,16,112,255,217,136,97,255,220,198,25,254,177,53,49,0,222,88,134,255,128,15,60,0,207,192,169,255,192,116,209,255,106,78,211,1,200,213,183,255,7,12,122,254,222,203,60,255,33,110,199,254,251,106,117,0,228,225,4,1,120,58,7,255,221,193,84,254,112,133,27,0,189,200,201,255,139,135,150,0,234,55,176,255,61,50,65,0,152,108,169,255,220,85,1,255,112,135,227,0,162,26,186,0,207,96,185,254,244,136,107,0,93,153,50,1,198,97,151,0,110,11,86,255,143,117,174,255,115,212,200,0,5,202,183,0,237,164,10,254,185,239,62,0,236,120,18,254,98,123,99,255,168,201,194,254,46,234,214,0,191,133,49,255,99,169,119,0,190,187,35,1,115,21,45,255,249,131,72,0,112,6,123,255,214,49,181,254,166,233,34,0,92,197,102,254,253,228,205,255,3,59,201,1,42,98,46,0,219,37,35,255,169,195,38,0,94,124,193,1,156,43,223,0,95,72,133,254,120,206,191,0,122,197,239,255,177,187,79,255,254,46,2,1,250,167,190,0,84,129,19,0,203,113,166,255,249,31,189,254,72,157,202,255,208,71,73,255,207,24,72,0,10,16,18,1,210,81,76,255,88,208,192,255,126,243,107,255,238,141,120,255,199,121,234,255,137,12,59,255,36,220,123,255,148,179,60,254,240,12,29,0,66,0,97,1,36,30,38,255,115,1,93,255,96,103,231,255,197,158,59,1,192,164,240,0,202,202,57,255,24,174,48,0,89,77,155,1,42,76,215,0,244,151,233,0,23,48,81,0,239,127,52,254,227,130,37,255,248,116,93,1,124,132,118,0,173,254,192,1,6,235,83,255,110,175,231,1,251,28,182,0,129,249,93,254,84,184,128,0,76,181,62,0,175,128,186,0,100,53,136,254,109,29,226,0,221,233,58,1,20,99,74,0,0,22,160,0,134,13,21,0,9,52,55,255,17,89,140,0,175,34,59,0,84,165,119,255,224,226,234,255,7,72,166,255,123,115,255,1,18,214,246,0,250,7,71,1,217,220,185,0,212,35,76,255,38,125,175,0,189,97,210,0,114,238,44,255,41,188,169,254,45,186,154,0,81,92,22,0,132,160,193,0,121,208,98,255,13,81,44,255,203,156,82,0,71,58,21,255,208,114,191,254,50,38,147,0,154,216,195,0,101,25,18,0,60,250,215,255,233,132,235,255,103,175,142,1,16,14,92,0,141,31,110,254,238,241,45,255,153,217,239,1,97,168,47,255,249,85,16,1,28,175,62,255,57,254,54,0,222,231,126,0,166,45,117,254,18,189,96,255,228,76,50,0,200,244,94,0,198,152,120,1,68,34,69,255,12,65,160,254,101,19,90,0,167,197,120,255,68,54,185,255,41,218,188,0,113,168,48,0,88,105,189,1,26,82,32,255,185,93,164,1,228,240,237,255,66,182,53,0,171,197,92,255,107,9,233,1,199,120,144,255,78,49,10,255,109,170,105,255,90,4,31,255,28,244,113,255,74,58,11,0,62,220,246,255,121,154,200,254,144,210,178,255,126,57,129,1,43,250,14,255,101,111,28,1,47,86,241,255,61,70,150,255,53,73,5,255,30,26,158,0,209,26,86,0,138,237,74,0,164,95,188,0,142,60,29,254,162,116,248,255,187,175,160,0,151,18,16,0,209,111,65,254,203,134,39,255,88,108,49,255,131,26,71,255,221,27,215,254,104,105,93,255,31,236,31,254,135,0,211,255,143,127,110,1,212,73,229,0,233,67,167,254,195,1,208,255,132,17,221,255,51,217,90,0,67,235,50,255,223,210,143,0,179,53,130,1,233,106,198,0,217,173,220,255,112,229,24,255,175,154,93,254,71,203,246,255,48,66,133,255,3,136,230,255,23,221,113,254,235,111,213,0,170,120,95,254,251,221,2,0,45,130,158,254,105,94,217,255,242,52,180,254,213,68,45,255,104,38,28,0,244,158,76,0,161,200,96,255,207,53,13,255,187,67,148,0,170,54,248,0,119,162,178,255,83,20,11,0,42,42,192,1,146,159,163,255,183,232,111,0,77,229,21,255,71,53,143,0,27,76,34,0,246,136,47,255,219,39,182,255,92,224,201,1,19,142,14,255,69,182,241,255,163,118,245,0,9,109,106,1,170,181,247,255,78,47,238,255,84,210,176,255,213,107,139,0,39,38,11,0,72,21,150,0,72,130,69,0,205,77,155,254,142,133,21,0,71,111,172,254,226,42,59,255,179,0,215,1,33,128,241,0,234,252,13,1,184,79,8,0,110,30,73,255,246,141,189,0,170,207,218,1,74,154,69,255,138,246,49,255,155,32,100,0,125,74,105,255,90,85,61,255,35,229,177,255,62,125,193,255,153,86,188,1,73,120,212,0,209,123,246,254,135,209,38,255,151,58,44,1,92,69,214,255,14,12,88,255,252,153,166,255,253,207,112,255,60,78,83,255,227,124,110,0,180,96,252,255,53,117,33,254,164,220,82,255,41,1,27,255,38,164,166,255,164,99,169,254,61,144,70,255,192,166,18,0,107,250,66,0,197,65,50,0,1,179,18,255,255,104,1,255,43,153,35,255,80,111,168,0,110,175,168,0,41,105,45,255,219,14,205,255,164,233,140,254,43,1,118,0,233,67,195,0,178,82,159,255,138,87,122,255,212,238,90,255,144,35,124,254,25,140,164,0,251,215,44,254,133,70,107,255,101,227,80,254,92,169,55,0,215,42,49,0,114,180,85,255,33,232,27,1,172,213,25,0,62,176,123,254,32,133,24,255,225,191,62,0,93,70,153,0,181,42,104,1,22,191,224,255,200,200,140,255,249,234,37,0,149,57,141,0,195,56,208,255,254,130,70,255,32,173,240,255,29,220,199,0,110,100,115,255,132,229,249,0,228,233,223,255,37,216,209,254,178,177,209,255,183,45,165,254,224,97,114,0,137,97,168,255,225,222,172,0,165,13,49,1,210,235,204,255,252,4,28,254,70,160,151,0,232,190,52,254,83,248,93,255,62,215,77,1,175,175,179,255,160,50,66,0,121,48,208,0,63,169,209,255,0,210,200,0,224,187,44,1,73,162,82,0,9,176,143,255,19,76,193,255,29,59,167,1,24,43,154,0,28,190,190,0,141,188,129,0,232,235,203,255,234,0,109,255,54,65,159,0,60,88,232,255,121,253,150,254,252,233,131,255,198,110,41,1,83,77,71,255,200,22,59,254,106,253,242,255,21,12,207,255,237,66,189,0,90,198,202,1,225,172,127,0,53,22,202,0,56,230,132,0,1,86,183,0,109,190,42,0,243,68,174,1,109,228,154,0,200,177,122,1,35,160,183,255,177,48,85,255,90,218,169,255,248,152,78,0,202,254,110,0,6,52,43,0,142,98,65,255,63,145,22,0,70,106,93,0,232,138,107,1,110,179,61,255,211,129,218,1,242,209,92,0,35,90,217,1,182,143,106,255,116,101,217,255,114,250,221,255,173,204,6,0,60,150,163,0,73,172,44,255,239,110,80,255,237,76,153,254,161,140,249,0,149,232,229,0,133,31,40,255,174,164,119,0,113,51,214,0,129,228,2,254,64,34,243,0,107,227,244,255,174,106,200,255,84,153,70,1,50,35,16,0,250,74,216,254,236,189,66,255,153,249,13,0,230,178,4,255,221,41,238,0,118,227,121,255,94,87,140,254,254,119,92,0,73,239,246,254,117,87,128,0,19,211,145,255,177,46,252,0,229,91,246,1,69,128,247,255,202,77,54,1,8,11,9,255,153,96,166,0,217,214,173,255,134,192,2,1,0,207,0,0,189,174,107,1,140,134,100,0,158,193,243,1,182,102,171,0,235,154,51,0,142,5,123,255,60,168,89,1,217,14,92,255,19,214,5,1,211,167,254,0,44,6,202,254,120,18,236,255,15,113,184,255,184,223,139,0,40,177,119,254,182,123,90,255,176,165,176,0,247,77,194,0,27,234,120,0,231,0,214,255,59,39,30,0,125,99,145,255,150,68,68,1,141,222,248,0,153,123,210,255,110,127,152,255,229,33,214,1,135,221,197,0,137,97,2,0,12,143,204,255,81,41,188,0,115,79,130,255,94,3,132,0,152,175,187,255,124,141,10,255,126,192,179,255,11,103,198,0,149,6,45,0,219,85,187,1,230,18,178,255,72,182,152,0,3,198,184,255,128,112,224,1,97,161,230,0,254,99,38,255,58,159,197,0,151,66,219,0,59,69,143,255,185,112,249,0,119,136,47,255,123,130,132,0,168,71,95,255,113,176,40,1,232,185,173,0,207,93,117,1,68,157,108,255,102,5,147,254,49,97,33,0,89,65,111,254,247,30,163,255,124,217,221,1,102,250,216,0,198,174,75,254,57,55,18,0,227,5,236,1,229,213,173,0,201,109,218,1,49,233,239,0,30,55,158,1,25,178,106,0,155,111,188,1,94,126,140,0,215,31,238,1,77,240,16,0,213,242,25,1,38,71,168,0,205,186,93,254,49,211,140,255,219,0,180,255,134,118,165,0,160,147,134,255,110,186,35,255,198,243,42,0,243,146,119,0,134,235,163,1,4,241,135,255,193,46,193,254,103,180,79,255,225,4,184,254,242,118,130,0,146,135,176,1,234,111,30,0,69,66,213,254,41,96,123,0,121,94,42,255,178,191,195,255,46,130,42,0,117,84,8,255,233,49,214,254,238,122,109,0,6,71,89,1,236,211,123,0,244,13,48,254,119,148,14,0,114,28,86,255,75,237,25,255,145,229,16,254,129,100,53,255,134,150,120,254,168,157,50,0,23,72,104,255,224,49,14,0,255,123,22,255,151,185,151,255,170,80,184,1,134,182,20,0,41,100,101,1,153,33,16,0,76,154,111,1,86,206,234,255,192,160,164,254,165,123,93,255,1,216,164,254,67,17,175,255,169,11,59,255,158,41,61,255,73,188,14,255,195,6,137,255,22,147,29,255,20,103,3,255,246,130,227,255,122,40,128,0,226,47,24,254,35,36,32,0,152,186,183,255,69,202,20,0,195,133,195,0,222,51,247,0,169,171,94,1,183,0,160,255,64,205,18,1,156,83,15,255,197,58,249,254,251,89,110,255,50,10,88,254,51,43,216,0,98,242,198,1,245,151,113,0,171,236,194,1,197,31,199,255,229,81,38,1,41,59,20,0,253,104,230,0,152,93,14,255,246,242,146,254,214,169,240,255,240,102,108,254,160,167,236,0,154,218,188,0,150,233,202,255,27,19,250,1,2,71,133,255,175,12,63,1,145,183,198,0,104,120,115,255,130,251,247,0,17,212,167,255,62,123,132,255,247,100,189,0,155,223,152,0,143,197,33,0,155,59,44,255,150,93,240,1,127,3,87,255,95,71,207,1,167,85,1,255,188,152,116,255,10,23,23,0,137,195,93,1,54,98,97,0,240,0,168,255,148,188,127,0,134,107,151,0,76,253,171,0,90,132,192,0,146,22,54,0,224,66,54,254,230,186,229,255,39,182,196,0,148,251,130,255,65,131,108,254,128,1,160,0,169,49,167,254,199,254,148,255,251,6,131,0,187,254,129,255,85,82,62,0,178,23,58,255,254,132,5,0,164,213,39,0,134,252,146,254,37,53,81,255,155,134,82,0,205,167,238,255,94,45,180,255,132,40,161,0,254,111,112,1,54,75,217,0,179,230,221,1,235,94,191,255,23,243,48,1,202,145,203,255,39,118,42,255,117,141,253,0,254,0,222,0,43,251,50,0,54,169,234,1,80,68,208,0,148,203,243,254,145,7,135,0,6,254,0,0,252,185,127,0,98,8,129,255,38,35,72,255,211,36,220,1,40,26,89,0,168,64,197,254,3,222,239,255,2,83,215,254,180,159,105,0,58,115,194,0,186,116,106,255,229,247,219,255,129,118,193,0,202,174,183,1,166,161,72,0,201,107,147,254,237,136,74,0,233,230,106,1,105,111,168,0,64,224,30,1,1,229,3,0,102,151,175,255,194,238,228,255,254,250,212,0,187,237,121,0,67,251,96,1,197,30,11,0,183,95,204,0,205,89,138,0,64,221,37,1,255,223,30,255,178,48,211,255,241,200,90,255,167,209,96,255,57,130,221,0,46,114,200,255,61,184,66,0,55,182,24,254,110,182,33,0,171,190,232,255,114,94,31,0,18,221,8,0,47,231,254,0,255,112,83,0,118,15,215,255,173,25,40,254,192,193,31,255,238,21,146,255,171,193,118,255,101,234,53,254,131,212,112,0,89,192,107,1,8,208,27,0,181,217,15,255,231,149,232,0,140,236,126,0,144,9,199,255,12,79,181,254,147,182,202,255,19,109,182,255,49,212,225,0,74,163,203,0,175,233,148,0,26,112,51,0,193,193,9,255,15,135,249,0,150,227,130,0,204,0,219,1,24,242,205,0,238,208,117,255,22,244,112,0,26,229,34,0,37,80,188,255,38,45,206,254,240,90,225,255,29,3,47,255,42,224,76,0,186,243,167,0,32,132,15,255,5,51,125,0,139,135,24,0,6,241,219,0,172,229,133,255,246,214,50,0,231,11,207,255,191,126,83,1,180,163,170,255,245,56,24,1,178,164,211,255,3,16,202,1,98,57,118,255,141,131,89,254,33,51,24,0,243,149,91,255,253,52,14,0,35,169,67,254,49,30,88,255,179,27,36,255,165,140,183,0,58,189,151,0,88,31,0,0,75,169,66,0,66,101,199,255,24,216,199,1,121,196,26,255,14,79,203,254,240,226,81,255,94,28,10,255,83,193,240,255,204,193,131,255,94,15,86,0,218,40,157,0,51,193,209,0,0,242,177,0,102,185,247,0,158,109,116,0,38,135,91,0,223,175,149,0,220,66,1,255,86,60,232,0,25,96,37,255,225,122,162,1,215,187,168,255,158,157,46,0,56,171,162,0,232,240,101,1,122,22,9,0,51,9,21,255,53,25,238,255,217,30,232,254,125,169,148,0,13,232,102,0,148,9,37,0,165,97,141,1,228,131,41,0,222,15,243,255,254,18,17,0,6,60,237,1,106,3,113,0,59,132,189,0,92,112,30,0,105,208,213,0,48,84,179,255,187,121,231,254,27,216,109,255,162,221,107,254,73,239,195,255,250,31,57,255,149,135,89,255,185,23,115,1,3,163,157,255,18,112,250,0,25,57,187,255,161,96,164,0,47,16,243,0,12,141,251,254,67,234,184,255,41,18,161,0,175,6,96,255,160,172,52,254,24,176,183,255,198,193,85,1,124,121,137,255,151,50,114,255,220,203,60,255,207,239,5,1,0,38,107,255,55,238,94,254,70,152,94,0,213,220,77,1,120,17,69,255,85,164,190,255,203,234,81,0,38,49,37,254,61,144,124,0,137,78,49,254,168,247,48,0,95,164,252,0,105,169,135,0,253,228,134,0,64,166,75,0,81,73,20,255,207,210,10,0,234,106,150,255,94,34,90,255,254,159,57,254,220,133,99,0,139,147,180,254,24,23,185,0,41,57,30,255,189,97,76,0,65,187,223,255,224,172,37,255,34,62,95,1,231,144,240,0,77,106,126,254,64,152,91,0,29,98,155,0,226,251,53,255,234,211,5,255,144,203,222,255,164,176,221,254,5,231,24,0,179,122,205,0,36,1,134,255,125,70,151,254,97,228,252,0,172,129,23,254,48,90,209,255,150,224,82,1,84,134,30,0,241,196,46,0,103,113,234,255,46,101,121,254,40,124,250,255,135,45,242,254,9,249,168,255,140,108,131,255,143,163,171,0,50,173,199,255,88,222,142,255,200,95,158,0,142,192,163,255,7,117,135,0,111,124,22,0,236,12,65,254,68,38,65,255,227,174,254,0,244,245,38,0,240,50,208,255,161,63,250,0,60,209,239,0,122,35,19,0,14,33,230,254,2,159,113,0,106,20,127,255,228,205,96,0,137,210,174,254,180,212,144,255,89,98,154,1,34,88,139,0,167,162,112,1,65,110,197,0,241,37,169,0,66,56,131,255,10,201,83,254,133,253,187,255,177,112,45,254,196,251,0,0,196,250,151,255,238,232,214,255,150,209,205,0,28,240,118,0,71,76,83,1,236,99,91,0,42,250,131,1,96,18,64,255,118,222,35,0,113,214,203,255,122,119,184,255,66,19,36,0,204,64,249,0,146,89,139,0,134,62,135,1,104,233,101,0,188,84,26,0,49,249,129,0,208,214,75,255,207,130,77,255,115,175,235,0,171,2,137,255,175,145,186,1,55,245,135,255,154,86,181,1,100,58,246,255,109,199,60,255,82,204,134,255,215,49,230,1,140,229,192,255,222,193,251,255,81,136,15,255,179,149,162,255,23,39,29,255,7,95,75,254,191,81,222,0,241,81,90,255,107,49,201,255,244,211,157,0,222,140,149,255,65,219,56,254,189,246,90,255,178,59,157,1,48,219,52,0,98,34,215,0,28,17,187,255,175,169,24,0,92,79,161,255,236,200,194,1,147,143,234,0,229,225,7,1,197,168,14,0,235,51,53,1,253,120,174,0,197,6,168,255,202,117,171,0,163,21,206,0,114,85,90,255,15,41,10,255,194,19,99,0,65,55,216,254,162,146,116,0,50,206,212,255,64,146,29,255,158,158,131,1,100,165,130,255,172,23,129,255,125,53,9,255,15,193,18,1,26,49,11,255,181,174,201,1,135,201,14,255,100,19,149,0,219,98,79,0,42,99,143,254,96,0,48,255,197,249,83,254,104,149,79,255,235,110,136,254,82,128,44,255,65,41,36,254,88,211,10,0,187,121,187,0,98,134,199,0,171,188,179,254,210,11,238,255,66,123,130,254,52,234,61,0,48,113,23,254,6,86,120,255,119,178,245,0,87,129,201,0,242,141,209,0,202,114,85,0,148,22,161,0,103,195,48,0,25,49,171,255,138,67,130,0,182,73,122,254,148,24,130,0,211,229,154,0,32,155,158,0,84,105,61,0,177,194,9,255,166,89,86,1,54,83,187,0,249,40,117,255,109,3,215,255,53,146,44,1,63,47,179,0,194,216,3,254,14,84,136,0,136,177,13,255,72,243,186,255,117,17,125,255,211,58,211,255,93,79,223,0,90,88,245,255,139,209,111,255,70,222,47,0,10,246,79,255,198,217,178,0,227,225,11,1,78,126,179,255,62,43,126,0,103,148,35,0,129,8,165,254,245,240,148,0,61,51,142,0,81,208,134,0,15,137,115,255,211,119,236,255,159,245,248,255,2,134,136,255,230,139,58,1,160,164,254,0,114,85,141,255,49,166,182,255,144,70,84,1,85,182,7,0,46,53,93,0,9,166,161,255,55,162,178,255,45,184,188,0,146,28,44,254,169,90,49,0,120,178,241,1,14,123,127,255,7,241,199,1,189,66,50,255,198,143,101,254,189,243,135,255,141,24,24,254,75,97,87,0,118,251,154,1,237,54,156,0,171,146,207,255,131,196,246,255,136,64,113,1,151,232,57,0,240,218,115,0,49,61,27,255,64,129,73,1,252,169,27,255,40,132,10,1,90,201,193,255,252,121,240,1,186,206,41,0,43,198,97,0,145,100,183,0,204,216,80,254,172,150,65,0,249,229,196,254,104,123,73,255,77,104,96,254,130,180,8,0,104,123,57,0,220,202,229,255,102,249,211,0,86,14,232,255,182,78,209,0,239,225,164,0,106,13,32,255,120,73,17,255,134,67,233,0,83,254,181,0,183,236,112,1,48,64,131,255,241,216,243,255,65,193,226,0,206,241,100,254,100,134,166,255,237,202,197,0,55,13,81,0,32,124,102,255,40,228,177,0,118,181,31,1,231,160,134,255,119,187,202,0,0,142,60,255,128,38,189,255,166,201,150,0,207,120,26,1,54,184,172,0,12,242,204,254,133,66,230,0,34,38,31,1,184,112,80,0,32,51,165,254,191,243,55,0,58,73,146,254,155,167,205,255,100,104,152,255,197,254,207,255,173,19,247,0,238,10,202,0,239,151,242,0,94,59,39,255,240,29,102,255,10,92,154,255,229,84,219,255,161,129,80,0,208,90,204,1,240,219,174,255,158,102,145,1,53,178,76,255,52,108,168,1,83,222,107,0,211,36,109,0,118,58,56,0,8,29,22,0,237,160,199,0,170,209,157,0,137,71,47,0,143,86,32,0,198,242,2,0,212,48,136,1,92,172,186,0,230,151,105,1,96,191,229,0,138,80,191,254,240,216,130,255,98,43,6,254,168,196,49,0,253,18,91,1,144,73,121,0,61,146,39,1,63,104,24,255,184,165,112,254,126,235,98,0,80,213,98,255,123,60,87,255,82,140,245,1,223,120,173,255,15,198,134,1,206,60,239,0,231,234,92,255,33,238,19,255,165,113,142,1,176,119,38,0,160,43,166,254,239,91,105,0,107,61,194,1,25,4,68,0,15,139,51,0,164,132,106,255,34,116,46,254,168,95,197,0,137,212,23,0,72,156,58,0,137,112,69,254,150,105,154,255,236,201,157,0,23,212,154,255,136,82,227,254,226,59,221,255,95,149,192,0,81,118,52,255,33,43,215,1,14,147,75,255,89,156,121,254,14,18,79,0,147,208,139,1,151,218,62,255,156,88,8,1,210,184,98,255,20,175,123,255,102,83,229,0,220,65,116,1,150,250,4,255,92,142,220,255,34,247,66,255,204,225,179,254,151,81,151,0,71,40,236,255,138,63,62,0,6,79,240,255,183,185,181,0,118,50,27,0,63,227,192,0,123,99,58,1,50,224,155,255,17,225,223,254,220,224,77,255,14,44,123,1,141,128,175,0,248,212,200,0,150,59,183,255,147,97,29,0,150,204,181,0,253,37,71,0,145,85,119,0,154,200,186,0,2,128,249,255,83,24,124,0,14,87,143,0,168,51,245,1,124,151,231,255,208,240,197,1,124,190,185,0,48,58,246,0,20,233,232,0,125,18,98,255,13,254,31,255,245,177,130,255,108,142,35,0,171,125,242,254,140,12,34,255,165,161,162,0,206,205,101,0,247,25,34,1,100,145,57,0,39,70,57,0,118,204,203,255,242,0,162,0,165,244,30,0,198,116,226,0,128,111,153,255,140,54,182,1,60,122,15,255,155,58,57,1,54,50,198,0,171,211,29,255,107,138,167,255,173,107,199,255,109,161,193,0,89,72,242,255,206,115,89,255,250,254,142,254,177,202,94,255,81,89,50,0,7,105,66,255,25,254,255,254,203,64,23,255,79,222,108,255,39,249,75,0,241,124,50,0,239,152,133,0,221,241,105,0,147,151,98,0,213,161,121,254,242,49,137,0,233,37,249,254,42,183,27,0,184,119,230,255,217,32,163,255,208,251,228,1,137,62,131,255,79,64,9,254,94,48,113,0,17,138,50,254,193,255,22,0,247,18,197,1,67,55,104,0,16,205,95,255,48,37,66,0,55,156,63,1,64,82,74,255,200,53,71,254,239,67,125,0,26,224,222,0,223,137,93,255,30,224,202,255,9,220,132,0,198,38,235,1,102,141,86,0,60,43,81,1,136,28,26,0,233,36,8,254,207,242,148,0,164,162,63,0,51,46,224,255,114,48,79,255,9,175,226,0,222,3,193,255,47,160,232,255,255,93,105,254,14,42,230,0,26,138,82,1,208,43,244,0,27,39,38,255,98,208,127,255,64,149,182,255,5,250,209,0,187,60,28,254,49,25,218,255,169,116,205,255,119,18,120,0,156,116,147,255,132,53,109,255,13,10,202,0,110,83,167,0,157,219,137,255,6,3,130,255,50,167,30,255,60,159,47,255,129,128,157,254,94,3,189,0,3,166,68,0,83,223,215,0,150,90,194,1,15,168,65,0,227,83,51,255,205,171,66,255,54,187,60,1,152,102,45,255,119,154,225,0,240,247,136,0,100,197,178,255,139,71,223,255,204,82,16,1,41,206,42,255,156,192,221,255,216,123,244,255,218,218,185,255,187,186,239,255,252,172,160,255,195,52,22,0,144,174,181,254,187,100,115,255,211,78,176,255,27,7,193,0,147,213,104,255,90,201,10,255,80,123,66,1,22,33,186,0,1,7,99,254,30,206,10,0,229,234,5,0,53,30,210,0,138,8,220,254,71,55,167,0,72,225,86,1,118,190,188,0,254,193,101,1,171,249,172,255,94,158,183,254,93,2,108,255,176,93,76,255,73,99,79,255,74,64,129,254,246,46,65,0,99,241,127,254,246,151,102,255,44,53,208,254,59,102,234,0,154,175,164,255,88,242,32,0,111,38,1,0,255,182,190,255,115,176,15,254,169,60,129,0,122,237,241,0,90,76,63,0,62,74,120,255,122,195,110,0,119,4,178,0,222,242,210,0,130,33,46,254,156,40,41,0,167,146,112,1,49,163,111,255,121,176,235,0,76,207,14,255,3,25,198,1,41,235,213,0,85,36,214,1,49,92,109,255,200,24,30,254,168,236,195,0,145,39,124,1,236,195,149,0,90,36,184,255,67,85,170,255,38,35,26,254,131,124,68,255,239,155,35,255,54,201,164,0,196,22,117,255,49,15,205,0,24,224,29,1,126,113,144,0,117,21,182,0,203,159,141,0,223,135,77,0,176,230,176,255,190,229,215,255,99,37,181,255,51,21,138,255,25,189,89,255,49,48,165,254,152,45,247,0,170,108,222,0,80,202,5,0,27,69,103,254,204,22,129,255,180,252,62,254,210,1,91,255,146,110,254,255,219,162,28,0,223,252,213,1,59,8,33,0,206,16,244,0,129,211,48,0,107,160,208,0,112,59,209,0,109,77,216,254,34,21,185,255,246,99,56,255,179,139,19,255,185,29,50,255,84,89,19,0,74,250,98,255,225,42,200,255,192,217,205,255,210,16,167,0,99,132,95,1,43,230,57,0,254,11,203,255,99,188,63,255,119,193,251,254,80,105,54,0,232,181,189,1,183,69,112,255,208,171,165,255,47,109,180,255,123,83,165,0,146,162,52,255,154,11,4,255,151,227,90,255,146,137,97,254,61,233,41,255,94,42,55,255,108,164,236,0,152,68,254,0,10,140,131,255,10,106,79,254,243,158,137,0,67,178,66,254,177,123,198,255,15,62,34,0,197,88,42,255,149,95,177,255,152,0,198,255,149,254,113,255,225,90,163,255,125,217,247,0,18,17,224,0,128,66,120,254,192,25,9,255,50,221,205,0,49,212,70,0,233,255,164,0,2,209,9,0,221,52,219,254,172,224,244,255,94,56,206,1,242,179,2,255,31,91,164,1,230,46,138,255,189,230,220,0,57,47,61,255,111,11,157,0,177,91,152,0,28,230,98,0,97,87,126,0,198,89,145,255,167,79,107,0,249,77,160,1,29,233,230,255,150,21,86,254,60,11,193,0,151,37,36,254,185,150,243,255,228,212,83,1,172,151,180,0,201,169,155,0,244,60,234,0,142,235,4,1,67,218,60,0,192,113,75,1,116,243,207,255,65,172,155,0,81,30,156,255,80,72,33,254,18,231,109,255,142,107,21,254,125,26,132,255,176,16,59,255,150,201,58,0,206,169,201,0,208,121,226,0,40,172,14,255,150,61,94,255,56,57,156,255,141,60,145,255,45,108,149,255,238,145,155,255,209,85,31,254,192,12,210,0,99,98,93,254,152,16,151,0,225,185,220,0,141,235,44,255,160,172,21,254,71,26,31,255,13,64,93,254,28,56,198,0,177,62,248,1,182,8,241,0,166,101,148,255,78,81,133,255,129,222,215,1,188,169,129,255,232,7,97,0,49,112,60,255,217,229,251,0,119,108,138,0,39,19,123,254,131,49,235,0,132,84,145,0,130,230,148,255,25,74,187,0,5,245,54,255,185,219,241,1,18,194,228,255,241,202,102,0,105,113,202,0,155,235,79,0,21,9,178,255,156,1,239,0,200,148,61,0,115,247,210,255,49,221,135,0,58,189,8,1,35,46,9,0,81,65,5,255,52,158,185,255,125,116,46,255,74,140,13,255,210,92,172,254,147,23,71,0,217,224,253,254,115,108,180,255,145,58,48,254,219,177,24,255,156,255,60,1,154,147,242,0,253,134,87,0,53,75,229,0,48,195,222,255,31,175,50,255,156,210,120,255,208,35,222,255,18,248,179,1,2,10,101,255,157,194,248,255,158,204,101,255,104,254,197,255,79,62,4,0,178,172,101,1,96,146,251,255,65,10,156,0,2,137,165,255,116,4,231,0,242,215,1,0,19,35,29,255,43,161,79,0,59,149,246,1,251,66,176,0,200,33,3,255,80,110,142,255,195,161,17,1,228,56,66,255,123,47,145,254,132,4,164,0,67,174,172,0,25,253,114,0,87,97,87,1,250,220,84,0,96,91,200,255,37,125,59,0,19,65,118,0,161,52,241,255,237,172,6,255,176,191,255,255,1,65,130,254,223,190,230,0,101,253,231,255,146,35,109,0,250,29,77,1,49,0,19,0,123,90,155,1,22,86,32,255,218,213,65,0,111,93,127,0,60,93,169,255,8,127,182,0,17,186,14,254,253,137,246,255,213,25,48,254,76,238,0,255,248,92,70,255,99,224,139,0,184,9,255,1,7,164,208,0,205,131,198,1,87,214,199,0,130,214,95,0,221,149,222,0,23,38,171,254,197,110,213,0,43,115,140,254,215,177,118,0,96,52,66,1,117,158,237,0,14,64,182,255,46,63,174,255,158,95,190,255,225,205,177,255,43,5,142,255,172,99,212,255,244,187,147,0,29,51,153,255,228,116,24,254,30,101,207,0,19,246,150,255,134,231,5,0,125,134,226,1,77,65,98,0,236,130,33,255,5,110,62,0,69,108,127,255,7,113,22,0,145,20,83,254,194,161,231,255,131,181,60,0,217,209,177,255,229,148,212,254,3,131,184,0,117,177,187,1,28,14,31,255,176,102,80,0,50,84,151,255,125,31,54,255,21,157,133,255,19,179,139,1,224,232,26,0,34,117,170,255,167,252,171,255,73,141,206,254,129,250,35,0,72,79,236,1,220,229,20,255,41,202,173,255,99,76,238,255,198,22,224,255,108,198,195,255,36,141,96,1,236,158,59,255,106,100,87,0,110,226,2,0,227,234,222,0,154,93,119,255,74,112,164,255,67,91,2,255,21,145,33,255,102,214,137,255,175,230,103,254,163,246,166,0,93,247,116,254,167,224,28,255,220,2,57,1,171,206,84,0,123,228,17,255,27,120,119,0,119,11,147,1,180,47,225,255,104,200,185,254,165,2,114,0,77,78,212,0,45,154,177,255,24,196,121,254,82,157,182,0,90,16,190,1,12,147,197,0,95,239,152,255,11,235,71,0,86,146,119,255,172,134,214,0,60,131,196,0,161,225,129,0,31,130,120,254,95,200,51,0,105,231,210,255,58,9,148,255,43,168,221,255,124,237,142,0,198,211,50,254,46,245,103,0,164,248,84,0,152,70,208,255,180,117,177,0,70,79,185,0,243,74,32,0,149,156,207,0,197,196,161,1,245,53,239,0,15,93,246,254,139,240,49,255,196,88,36,255,162,38,123,0,128,200,157,1,174,76,103,255,173,169,34,254,216,1,171,255,114,51,17,0,136,228,194,0,110,150,56,254,106,246,159,0,19,184,79,255,150,77,240,255,155,80,162,0,0,53,169,255,29,151,86,0,68,94,16,0,92,7,110,254,98,117,149,255,249,77,230,255,253,10,140,0,214,124,92,254,35,118,235,0,89,48,57,1,22,53,166,0,184,144,61,255,179,255,194,0,214,248,61,254,59,110,246,0,121,21,81,254,166,3,228,0,106,64,26,255,69,232,134,255,242,220,53,254,46,220,85,0,113,149,247,255,97,179,103,255,190,127,11,0,135,209,182,0,95,52,129,1,170,144,206,255,122,200,204,255,168,100,146,0,60,144,149,254,70,60,40,0,122,52,177,255,246,211,101,255,174,237,8,0,7,51,120,0,19,31,173,0,126,239,156,255,143,189,203,0,196,128,88,255,233,133,226,255,30,125,173,255,201,108,50,0,123,100,59,255,254,163,3,1,221,148,181,255,214,136,57,254,222,180,137,255,207,88,54,255,28,33,251,255,67,214,52,1,210,208,100,0,81,170,94,0,145,40,53,0,224,111,231,254,35,28,244,255,226,199,195,254,238,17,230,0,217,217,164,254,169,157,221,0,218,46,162,1,199,207,163,255,108,115,162,1,14,96,187,255,118,60,76,0,184,159,152,0,209,231,71,254,42,164,186,255,186,153,51,254,221,171,182,255,162,142,173,0,235,47,193,0,7,139,16,1,95,164,64,255,16,221,166,0,219,197,16,0,132,29,44,255,100,69,117,255,60,235,88,254,40,81,173,0,71,190,61,255,187,88,157,0,231,11,23,0,237,117,164,0,225,168,223,255,154,114,116,255,163,152,242,1,24,32,170,0,125,98,113,254,168,19,76,0,17,157,220,254,155,52,5,0,19,111,161,255,71,90,252,255,173,110,240,0,10,198,121,255,253,255,240,255,66,123,210,0,221,194,215,254,121,163,17,255,225,7,99,0,190,49,182,0,115,9,133,1,232,26,138,255,213,68,132,0,44,119,122,255,179,98,51,0,149,90,106,0,71,50,230,255,10,153,118,255,177,70,25,0,165,87,205,0,55,138,234,0,238,30,97,0,113,155,207,0,98,153,127,0,34,107,219,254,117,114,172,255,76,180,255,254,242,57,179,255,221,34,172,254,56,162,49,255,83,3,255,255,113,221,189,255,188,25,228,254,16,88,89,255,71,28,198,254,22,17,149,255,243,121,254,255,107,202,99,255,9,206,14,1,220,47,153,0,107,137,39,1,97,49,194,255,149,51,197,254,186,58,11,255,107,43,232,1,200,6,14,255,181,133,65,254,221,228,171,255,123,62,231,1,227,234,179,255,34,189,212,254,244,187,249,0,190,13,80,1,130,89,1,0,223,133,173,0,9,222,198,255,66,127,74,0,167,216,93,255,155,168,198,1,66,145,0,0,68,102,46,1,172,90,154,0,216,128,75,255,160,40,51,0,158,17,27,1,124,240,49,0,236,202,176,255,151,124,192,255,38,193,190,0,95,182,61,0,163,147,124,255,255,165,51,255,28,40,17,254,215,96,78,0,86,145,218,254,31,36,202,255,86,9,5,0,111,41,200,255,237,108,97,0,57,62,44,0,117,184,15,1,45,241,116,0,152,1,220,255,157,165,188,0,250,15,131,1,60,44,125,255,65,220,251,255,75,50,184,0,53,90,128,255,231,80,194,255,136,129,127,1,21,18,187,255,45,58,161,255,71,147,34,0,174,249,11,254,35,141,29,0,239,68,177,255,115,110,58,0,238,190,177,1,87,245,166,255,190,49,247,255,146,83,184,255,173,14,39,255,146,215,104,0,142,223,120,0,149,200,155,255,212,207,145,1,16,181,217,0,173,32,87,255,255,35,181,0,119,223,161,1,200,223,94,255,70,6,186,255,192,67,85,255,50,169,152,0,144,26,123,255,56,243,179,254,20,68,136,0,39,140,188,254,253,208,5,255,200,115,135,1,43,172,229,255,156,104,187,0,151,251,167,0,52,135,23,0,151,153,72,0,147,197,107,254,148,158,5,255,238,143,206,0,126,153,137,255,88,152,197,254,7,68,167,0,252,159,165,255,239,78,54,255,24,63,55,255,38,222,94,0,237,183,12,255,206,204,210,0,19,39,246,254,30,74,231,0,135,108,29,1,179,115,0,0,117,118,116,1,132,6,252,255,145,129,161,1,105,67,141,0,82,37,226,255,238,226,228,255,204,214,129,254,162,123,100,255,185,121,234,0,45,108,231,0,66,8,56,255,132,136,128,0,172,224,66,254,175,157,188,0,230,223,226,254,242,219,69,0,184,14,119,1,82,162,56,0,114,123,20,0,162,103,85,255,49,239,99,254,156,135,215,0,111,255,167,254,39,196,214,0,144,38,79,1,249,168,125,0,155,97,156,255,23,52,219,255,150,22,144,0,44,149,165,255,40,127,183,0,196,77,233,255,118,129,210,255,170,135,230,255,214,119,198,0,233,240,35,0,253,52,7,255,117,102,48,255,21,204,154,255,179,136,177,255,23,2,3,1,149,130,89,255,252,17,159,1,70,60,26,0,144,107,17,0,180,190,60,255,56,182,59,255,110,71,54,255,198,18,129,255,149,224,87,255,223,21,152,255,138,22,182,255,250,156,205,0,236,45,208,255,79,148,242,1,101,70,209,0,103,78,174,0,101,144,172,255,152,136,237,1,191,194,136,0,113,80,125,1,152,4,141,0,155,150,53,255,196,116,245,0,239,114,73,254,19,82,17,255,124,125,234,255,40,52,191,0,42,210,158,255,155,132,165,0,178,5,42,1,64,92,40,255,36,85,77,255,178,228,118,0,137,66,96,254,115,226,66,0,110,240,69,254,151,111,80,0,167,174,236,255,227,108,107,255,188,242,65,255,183,81,255,0,57,206,181,255,47,34,181,255,213,240,158,1,71,75,95,0,156,40,24,255,102,210,81,0,171,199,228,255,154,34,41,0,227,175,75,0,21,239,195,0,138,229,95,1,76,192,49,0,117,123,87,1,227,225,130,0,125,62,63,255,2,198,171,0,254,36,13,254,145,186,206,0,148,255,244,255,35,0,166,0,30,150,219,1,92,228,212,0,92,198,60,254,62,133,200,255,201,41,59,0,125,238,109,255,180,163,238,1,140,122,82,0,9,22,88,255,197,157,47,255,153,94,57,0,88,30,182,0,84,161,85,0,178,146,124,0,166,166,7,255,21,208,223,0,156,182,242,0,155,121,185,0,83,156,174,254,154,16,118,255,186,83,232,1,223,58,121,255,29,23,88,0,35,125,127,255,170,5,149,254,164,12,130,255,155,196,29,0,161,96,136,0,7,35,29,1,162,37,251,0,3,46,242,255,0,217,188,0,57,174,226,1,206,233,2,0,57,187,136,254,123,189,9,255,201,117,127,255,186,36,204,0,231,25,216,0,80,78,105,0,19,134,129,255,148,203,68,0,141,81,125,254,248,165,200,255,214,144,135,0,151,55,166,255,38,235,91,0,21,46,154,0,223,254,150,255,35,153,180,255,125,176,29,1,43,98,30,255,216,122,230,255,233,160,12,0,57,185,12,254,240,113,7,255,5,9,16,254,26,91,108,0,109,198,203,0,8,147,40,0,129,134,228,255,124,186,40,255,114,98,132,254,166,132,23,0,99,69,44,0,9,242,238,255,184,53,59,0,132,129,102,255,52,32,243,254,147,223,200,255,123,83,179,254,135,144,201,255,141,37,56,1,151,60,227,255,90,73,156,1,203,172,187,0,80,151,47,255,94,137,231,255,36,191,59,255,225,209,181,255,74,215,213,254,6,118,179,255,153,54,193,1,50,0,231,0,104,157,72,1,140,227,154,255,182,226,16,254,96,225,92,255,115,20,170,254,6,250,78,0,248,75,173,255,53,89,6,255,0,180,118,0,72,173,1,0,64,8,206,1,174,133,223,0,185,62,133,255,214,11,98,0,197,31,208,0,171,167,244,255,22,231,181,1,150,218,185,0,247,169,97,1,165,139,247,255,47,120,149,1,103,248,51,0,60,69,28,254,25,179,196,0,124,7,218,254,58,107,81,0,184,233,156,255,252,74,36,0,118,188,67,0,141,95,53,255,222,94,165,254,46,61,53,0,206,59,115,255,47,236,250,255,74,5,32,1,129,154,238,255,106,32,226,0,121,187,61,255,3,166,241,254,67,170,172,255,29,216,178,255,23,201,252,0,253,110,243,0,200,125,57,0,109,192,96,255,52,115,238,0,38,121,243,255,201,56,33,0,194,118,130,0,75,96,25,255,170,30,230,254,39,63,253,0,36,45,250,255,251,1,239,0,160,212,92,1,45,209,237,0,243,33,87,254,237,84,201,255,212,18,157,254,212,99,127,255,217,98,16,254,139,172,239,0,168,201,130,255,143,193,169,255,238,151,193,1,215,104,41,0,239,61,165,254,2,3,242,0,22,203,177,254,177,204,22,0,149,129,213,254,31,11,41,255,0,159,121,254,160,25,114,255,162,80,200,0,157,151,11,0,154,134,78,1,216,54,252,0,48,103,133,0,105,220,197,0,253,168,77,254,53,179,23,0,24,121,240,1,255,46,96,255,107,60,135,254,98,205,249,255,63,249,119,255,120,59,211,255,114,180,55,254,91,85,237,0,149,212,77,1,56,73,49,0,86,198,150,0,93,209,160,0,69,205,182,255,244,90,43,0,20,36,176,0,122,116,221,0,51,167,39,1,231,1,63,255,13,197,134,0,3,209,34,255,135,59,202,0,167,100,78,0,47,223,76,0,185,60,62,0,178,166,123,1,132,12,161,255,61,174,43,0,195,69,144,0,127,47,191,1,34,44,78,0,57,234,52,1,255,22,40,255,246,94,146,0,83,228,128,0,60,78,224,255,0,96,210,255,153,175,236,0,159,21,73,0,180,115,196,254,131,225,106,0,255,167,134,0,159,8,112,255,120,68,194,255,176,196,198,255,118,48,168,255,93,169,1,0,112,200,102,1,74,24,254,0,19,141,4,254,142,62,63,0,131,179,187,255,77,156,155,255,119,86,164,0,170,208,146,255,208,133,154,255,148,155,58,255,162,120,232,254,252,213,155,0,241,13,42,0,94,50,131,0,179,170,112,0,140,83,151,255,55,119,84,1,140,35,239,255,153,45,67,1,236,175,39,0,54,151,103,255,158,42,65,255,196,239,135,254,86,53,203],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+10240);allocate([149,97,47,254,216,35,17,255,70,3,70,1,103,36,90,255,40,26,173,0,184,48,13,0,163,219,217,255,81,6,1,255,221,170,108,254,233,208,93,0,100,201,249,254,86,36,35,255,209,154,30,1,227,201,251,255,2,189,167,254,100,57,3,0,13,128,41,0,197,100,75,0,150,204,235,255,145,174,59,0,120,248,149,255,85,55,225,0,114,210,53,254,199,204,119,0,14,247,74,1,63,251,129,0,67,104,151,1,135,130,80,0,79,89,55,255,117,230,157,255,25,96,143,0,213,145,5,0,69,241,120,1,149,243,95,255,114,42,20,0,131,72,2,0,154,53,20,255,73,62,109,0,196,102,152,0,41,12,204,255,122,38,11,1,250,10,145,0,207,125,148,0,246,244,222,255,41,32,85,1,112,213,126,0,162,249,86,1,71,198,127,255,81,9,21,1,98,39,4,255,204,71,45,1,75,111,137,0,234,59,231,0,32,48,95,255,204,31,114,1,29,196,181,255,51,241,167,254,93,109,142,0,104,144,45,0,235,12,181,255,52,112,164,0,76,254,202,255,174,14,162,0,61,235,147,255,43,64,185,254,233,125,217,0,243,88,167,254,74,49,8,0,156,204,66,0,124,214,123,0,38,221,118,1,146,112,236,0,114,98,177,0,151,89,199,0,87,197,112,0,185,149,161,0,44,96,165,0,248,179,20,255,188,219,216,254,40,62,13,0,243,142,141,0,229,227,206,255,172,202,35,255,117,176,225,255,82,110,38,1,42,245,14,255,20,83,97,0,49,171,10,0,242,119,120,0,25,232,61,0,212,240,147,255,4,115,56,255,145,17,239,254,202,17,251,255,249,18,245,255,99,117,239,0,184,4,179,255,246,237,51,255,37,239,137,255,166,112,166,255,81,188,33,255,185,250,142,255,54,187,173,0,208,112,201,0,246,43,228,1,104,184,88,255,212,52,196,255,51,117,108,255,254,117,155,0,46,91,15,255,87,14,144,255,87,227,204,0,83,26,83,1,159,76,227,0,159,27,213,1,24,151,108,0,117,144,179,254,137,209,82,0,38,159,10,0,115,133,201,0,223,182,156,1,110,196,93,255,57,60,233,0,5,167,105,255,154,197,164,0,96,34,186,255,147,133,37,1,220,99,190,0,1,167,84,255,20,145,171,0,194,197,251,254,95,78,133,255,252,248,243,255,225,93,131,255,187,134,196,255,216,153,170,0,20,118,158,254,140,1,118,0,86,158,15,1,45,211,41,255,147,1,100,254,113,116,76,255,211,127,108,1,103,15,48,0,193,16,102,1,69,51,95,255,107,128,157,0,137,171,233,0,90,124,144,1,106,161,182,0,175,76,236,1,200,141,172,255,163,58,104,0,233,180,52,255,240,253,14,255,162,113,254,255,38,239,138,254,52,46,166,0,241,101,33,254,131,186,156,0,111,208,62,255,124,94,160,255,31,172,254,0,112,174,56,255,188,99,27,255,67,138,251,0,125,58,128,1,156,152,174,255,178,12,247,255,252,84,158,0,82,197,14,254,172,200,83,255,37,39,46,1,106,207,167,0,24,189,34,0,131,178,144,0,206,213,4,0,161,226,210,0,72,51,105,255,97,45,187,255,78,184,223,255,176,29,251,0,79,160,86,255,116,37,178,0,82,77,213,1,82,84,141,255,226,101,212,1,175,88,199,255,245,94,247,1,172,118,109,255,166,185,190,0,131,181,120,0,87,254,93,255,134,240,73,255,32,245,143,255,139,162,103,255,179,98,18,254,217,204,112,0,147,223,120,255,53,10,243,0,166,140,150,0,125,80,200,255,14,109,219,255,91,218,1,255,252,252,47,254,109,156,116,255,115,49,127,1,204,87,211,255,148,202,217,255,26,85,249,255,14,245,134,1,76,89,169,255,242,45,230,0,59,98,172,255,114,73,132,254,78,155,49,255,158,126,84,0,49,175,43,255,16,182,84,255,157,103,35,0,104,193,109,255,67,221,154,0,201,172,1,254,8,162,88,0,165,1,29,255,125,155,229,255,30,154,220,1,103,239,92,0,220,1,109,255,202,198,1,0,94,2,142,1,36,54,44,0,235,226,158,255,170,251,214,255,185,77,9,0,97,74,242,0,219,163,149,255,240,35,118,255,223,114,88,254,192,199,3,0,106,37,24,255,201,161,118,255,97,89,99,1,224,58,103,255,101,199,147,254,222,60,99,0,234,25,59,1,52,135,27,0,102,3,91,254,168,216,235,0,229,232,136,0,104,60,129,0,46,168,238,0,39,191,67,0,75,163,47,0,143,97,98,255,56,216,168,1,168,233,252,255,35,111,22,255,92,84,43,0,26,200,87,1,91,253,152,0,202,56,70,0,142,8,77,0,80,10,175,1,252,199,76,0,22,110,82,255,129,1,194,0,11,128,61,1,87,14,145,255,253,222,190,1,15,72,174,0,85,163,86,254,58,99,44,255,45,24,188,254,26,205,15,0,19,229,210,254,248,67,195,0,99,71,184,0,154,199,37,255,151,243,121,255,38,51,75,255,201,85,130,254,44,65,250,0,57,147,243,254,146,43,59,255,89,28,53,0,33,84,24,255,179,51,18,254,189,70,83,0,11,156,179,1,98,134,119,0,158,111,111,0,119,154,73,255,200,63,140,254,45,13,13,255,154,192,2,254,81,72,42,0,46,160,185,254,44,112,6,0,146,215,149,1,26,176,104,0,68,28,87,1,236,50,153,255,179,128,250,254,206,193,191,255,166,92,137,254,53,40,239,0,210,1,204,254,168,173,35,0,141,243,45,1,36,50,109,255,15,242,194,255,227,159,122,255,176,175,202,254,70,57,72,0,40,223,56,0,208,162,58,255,183,98,93,0,15,111,12,0,30,8,76,255,132,127,246,255,45,242,103,0,69,181,15,255,10,209,30,0,3,179,121,0,241,232,218,1,123,199,88,255,2,210,202,1,188,130,81,255,94,101,208,1,103,36,45,0,76,193,24,1,95,26,241,255,165,162,187,0,36,114,140,0,202,66,5,255,37,56,147,0,152,11,243,1,127,85,232,255,250,135,212,1,185,177,113,0,90,220,75,255,69,248,146,0,50,111,50,0,92,22,80,0,244,36,115,254,163,100,82,255,25,193,6,1,127,61,36,0,253,67,30,254,65,236,170,255,161,17,215,254,63,175,140,0,55,127,4,0,79,112,233,0,109,160,40,0,143,83,7,255,65,26,238,255,217,169,140,255,78,94,189,255,0,147,190,255,147,71,186,254,106,77,127,255,233,157,233,1,135,87,237,255,208,13,236,1,155,109,36,255,180,100,218,0,180,163,18,0,190,110,9,1,17,63,123,255,179,136,180,255,165,123,123,255,144,188,81,254,71,240,108,255,25,112,11,255,227,218,51,255,167,50,234,255,114,79,108,255,31,19,115,255,183,240,99,0,227,87,143,255,72,217,248,255,102,169,95,1,129,149,149,0,238,133,12,1,227,204,35,0,208,115,26,1,102,8,234,0,112,88,143,1,144,249,14,0,240,158,172,254,100,112,119,0,194,141,153,254,40,56,83,255,121,176,46,0,42,53,76,255,158,191,154,0,91,209,92,0,173,13,16,1,5,72,226,255,204,254,149,0,80,184,207,0,100,9,122,254,118,101,171,255,252,203,0,254,160,207,54,0,56,72,249,1,56,140,13,255,10,64,107,254,91,101,52,255,225,181,248,1,139,255,132,0,230,145,17,0,233,56,23,0,119,1,241,255,213,169,151,255,99,99,9,254,185,15,191,255,173,103,109,1,174,13,251,255,178,88,7,254,27,59,68,255,10,33,2,255,248,97,59,0,26,30,146,1,176,147,10,0,95,121,207,1,188,88,24,0,185,94,254,254,115,55,201,0,24,50,70,0,120,53,6,0,142,66,146,0,228,226,249,255,104,192,222,1,173,68,219,0,162,184,36,255,143,102,137,255,157,11,23,0,125,45,98,0,235,93,225,254,56,112,160,255,70,116,243,1,153,249,55,255,129,39,17,1,241,80,244,0,87,69,21,1,94,228,73,255,78,66,65,255,194,227,231,0,61,146,87,255,173,155,23,255,112,116,219,254,216,38,11,255,131,186,133,0,94,212,187,0,100,47,91,0,204,254,175,255,222,18,215,254,173,68,108,255,227,228,79,255,38,221,213,0,163,227,150,254,31,190,18,0,160,179,11,1,10,90,94,255,220,174,88,0,163,211,229,255,199,136,52,0,130,95,221,255,140,188,231,254,139,113,128,255,117,171,236,254,49,220,20,255,59,20,171,255,228,109,188,0,20,225,32,254,195,16,174,0,227,254,136,1,135,39,105,0,150,77,206,255,210,238,226,0,55,212,132,254,239,57,124,0,170,194,93,255,249,16,247,255,24,151,62,255,10,151,10,0,79,139,178,255,120,242,202,0,26,219,213,0,62,125,35,255,144,2,108,255,230,33,83,255,81,45,216,1,224,62,17,0,214,217,125,0,98,153,153,255,179,176,106,254,131,93,138,255,109,62,36,255,178,121,32,255,120,252,70,0,220,248,37,0,204,88,103,1,128,220,251,255,236,227,7,1,106,49,198,255,60,56,107,0,99,114,238,0,220,204,94,1,73,187,1,0,89,154,34,0,78,217,165,255,14,195,249,255,9,230,253,255,205,135,245,0,26,252,7,255,84,205,27,1,134,2,112,0,37,158,32,0,231,91,237,255,191,170,204,255,152,7,222,0,109,192,49,0,193,166,146,255,232,19,181,255,105,142,52,255,103,16,27,1,253,200,165,0,195,217,4,255,52,189,144,255,123,155,160,254,87,130,54,255,78,120,61,255,14,56,41,0,25,41,125,255,87,168,245,0,214,165,70,0,212,169,6,255,219,211,194,254,72,93,164,255,197,33,103,255,43,142,141,0,131,225,172,0,244,105,28,0,68,68,225,0,136,84,13,255,130,57,40,254,139,77,56,0,84,150,53,0,54,95,157,0,144,13,177,254,95,115,186,0,117,23,118,255,244,166,241,255,11,186,135,0,178,106,203,255,97,218,93,0,43,253,45,0,164,152,4,0,139,118,239,0,96,1,24,254,235,153,211,255,168,110,20,255,50,239,176,0,114,41,232,0,193,250,53,0,254,160,111,254,136,122,41,255,97,108,67,0,215,152,23,255,140,209,212,0,42,189,163,0,202,42,50,255,106,106,189,255,190,68,217,255,233,58,117,0,229,220,243,1,197,3,4,0,37,120,54,254,4,156,134,255,36,61,171,254,165,136,100,255,212,232,14,0,90,174,10,0,216,198,65,255,12,3,64,0,116,113,115,255,248,103,8,0,231,125,18,255,160,28,197,0,30,184,35,1,223,73,249,255,123,20,46,254,135,56,37,255,173,13,229,1,119,161,34,255,245,61,73,0,205,125,112,0,137,104,134,0,217,246,30,255,237,142,143,0,65,159,102,255,108,164,190,0,219,117,173,255,34,37,120,254,200,69,80,0,31,124,218,254,74,27,160,255,186,154,199,255,71,199,252,0,104,81,159,1,17,200,39,0,211,61,192,1,26,238,91,0,148,217,12,0,59,91,213,255,11,81,183,255,129,230,122,255,114,203,145,1,119,180,66,255,72,138,180,0,224,149,106,0,119,82,104,255,208,140,43,0,98,9,182,255,205,101,134,255,18,101,38,0,95,197,166,255,203,241,147,0,62,208,145,255,133,246,251,0,2,169,14,0,13,247,184,0,142,7,254,0,36,200,23,255,88,205,223,0,91,129,52,255,21,186,30,0,143,228,210,1,247,234,248,255,230,69,31,254,176,186,135,255,238,205,52,1,139,79,43,0,17,176,217,254,32,243,67,0,242,111,233,0,44,35,9,255,227,114,81,1,4,71,12,255,38,105,191,0,7,117,50,255,81,79,16,0,63,68,65,255,157,36,110,255,77,241,3,255,226,45,251,1,142,25,206,0,120,123,209,1,28,254,238,255,5,128,126,255,91,222,215,255,162,15,191,0,86,240,73,0,135,185,81,254,44,241,163,0,212,219,210,255,112,162,155,0,207,101,118,0,168,72,56,255,196,5,52,0,72,172,242,255,126,22,157,255,146,96,59,255,162,121,152,254,140,16,95,0,195,254,200,254,82,150,162,0,119,43,145,254,204,172,78,255,166,224,159,0,104,19,237,255,245,126,208,255,226,59,213,0,117,217,197,0,152,72,237,0,220,31,23,254,14,90,231,255,188,212,64,1,60,101,246,255,85,24,86,0,1,177,109,0,146,83,32,1,75,182,192,0,119,241,224,0,185,237,27,255,184,101,82,1,235,37,77,255,253,134,19,0,232,246,122,0,60,106,179,0,195,11,12,0,109,66,235,1,125,113,59,0,61,40,164,0,175,104,240,0,2,47,187,255,50,12,141,0,194,139,181,255,135,250,104,0,97,92,222,255,217,149,201,255,203,241,118,255,79,151,67,0,122,142,218,255,149,245,239,0,138,42,200,254,80,37,97,255,124,112,167,255,36,138,87,255,130,29,147,255,241,87,78,255,204,97,19,1,177,209,22,255,247,227,127,254,99,119,83,255,212,25,198,1,16,179,179,0,145,77,172,254,89,153,14,255,218,189,167,0,107,233,59,255,35,33,243,254,44,112,112,255,161,127,79,1,204,175,10,0,40,21,138,254,104,116,228,0,199,95,137,255,133,190,168,255,146,165,234,1,183,99,39,0,183,220,54,254,255,222,133,0,162,219,121,254,63,239,6,0,225,102,54,255,251,18,246,0,4,34,129,1,135,36,131,0,206,50,59,1,15,97,183,0,171,216,135,255,101,152,43,255,150,251,91,0,38,145,95,0,34,204,38,254,178,140,83,255,25,129,243,255,76,144,37,0,106,36,26,254,118,144,172,255,68,186,229,255,107,161,213,255,46,163,68,255,149,170,253,0,187,17,15,0,218,160,165,255,171,35,246,1,96,13,19,0,165,203,117,0,214,107,192,255,244,123,177,1,100,3,104,0,178,242,97,255,251,76,130,255,211,77,42,1,250,79,70,255,63,244,80,1,105,101,246,0,61,136,58,1,238,91,213,0,14,59,98,255,167,84,77,0,17,132,46,254,57,175,197,255,185,62,184,0,76,64,207,0,172,175,208,254,175,74,37,0,138,27,211,254,148,125,194,0,10,89,81,0,168,203,101,255,43,213,209,1,235,245,54,0,30,35,226,255,9,126,70,0,226,125,94,254,156,117,20,255,57,248,112,1,230,48,64,255,164,92,166,1,224,214,230,255,36,120,143,0,55,8,43,255,251,1,245,1,106,98,165,0,74,107,106,254,53,4,54,255,90,178,150,1,3,120,123,255,244,5,89,1,114,250,61,255,254,153,82,1,77,15,17,0,57,238,90,1,95,223,230,0,236,52,47,254,103,148,164,255,121,207,36,1,18,16,185,255,75,20,74,0,187,11,101,0,46,48,129,255,22,239,210,255,77,236,129,255,111,77,204,255,61,72,97,255,199,217,251,255,42,215,204,0,133,145,201,255,57,230,146,1,235,100,198,0,146,73,35,254,108,198,20,255,182,79,210,255,82,103,136,0,246,108,176,0,34,17,60,255,19,74,114,254,168,170,78,255,157,239,20,255,149,41,168,0,58,121,28,0,79,179,134,255,231,121,135,255,174,209,98,255,243,122,190,0,171,166,205,0,212,116,48,0,29,108,66,255,162,222,182,1,14,119,21,0,213,39,249,255,254,223,228,255,183,165,198,0,133,190,48,0,124,208,109,255,119,175,85,255,9,209,121,1,48,171,189,255,195,71,134,1,136,219,51,255,182,91,141,254,49,159,72,0,35,118,245,255,112,186,227,255,59,137,31,0,137,44,163,0,114,103,60,254,8,213,150,0,162,10,113,255,194,104,72,0,220,131,116,255,178,79,92,0,203,250,213,254,93,193,189,255,130,255,34,254,212,188,151,0,136,17,20,255,20,101,83,255,212,206,166,0,229,238,73,255,151,74,3,255,168,87,215,0,155,188,133,255,166,129,73,0,240,79,133,255,178,211,81,255,203,72,163,254,193,168,165,0,14,164,199,254,30,255,204,0,65,72,91,1,166,74,102,255,200,42,0,255,194,113,227,255,66,23,208,0,229,216,100,255,24,239,26,0,10,233,62,255,123,10,178,1,26,36,174,255,119,219,199,1,45,163,190,0,16,168,42,0,166,57,198,255,28,26,26,0,126,165,231,0,251,108,100,255,61,229,121,255,58,118,138,0,76,207,17,0,13,34,112,254,89,16,168,0,37,208,105,255,35,201,215,255,40,106,101,254,6,239,114,0,40,103,226,254,246,127,110,255,63,167,58,0,132,240,142,0,5,158,88,255,129,73,158,255,94,89,146,0,230,54,146,0,8,45,173,0,79,169,1,0,115,186,247,0,84,64,131,0,67,224,253,255,207,189,64,0,154,28,81,1,45,184,54,255,87,212,224,255,0,96,73,255,129,33,235,1,52,66,80,255,251,174,155,255,4,179,37,0,234,164,93,254,93,175,253,0,198,69,87,255,224,106,46,0,99,29,210,0,62,188,114,255,44,234,8,0,169,175,247,255,23,109,137,255,229,182,39,0,192,165,94,254,245,101,217,0,191,88,96,0,196,94,99,255,106,238,11,254,53,126,243,0,94,1,101,255,46,147,2,0,201,124,124,255,141,12,218,0,13,166,157,1,48,251,237,255,155,250,124,255,106,148,146,255,182,13,202,0,28,61,167,0,217,152,8,254,220,130,45,255,200,230,255,1,55,65,87,255,93,191,97,254,114,251,14,0,32,105,92,1,26,207,141,0,24,207,13,254,21,50,48,255,186,148,116,255,211,43,225,0,37,34,162,254,164,210,42,255,68,23,96,255,182,214,8,255,245,117,137,255,66,195,50,0,75,12,83,254,80,140,164,0,9,165,36,1,228,110,227,0,241,17,90,1,25,52,212,0,6,223,12,255,139,243,57,0,12,113,75,1,246,183,191,255,213,191,69,255,230,15,142,0,1,195,196,255,138,171,47,255,64,63,106,1,16,169,214,255,207,174,56,1,88,73,133,255,182,133,140,0,177,14,25,255,147,184,53,255,10,227,161,255,120,216,244,255,73,77,233,0,157,238,139,1,59,65,233,0,70,251,216,1,41,184,153,255,32,203,112,0,146,147,253,0,87,101,109,1,44,82,133,255,244,150,53,255,94,152,232,255,59,93,39,255,88,147,220,255,78,81,13,1,32,47,252,255,160,19,114,255,93,107,39,255,118,16,211,1,185,119,209,255,227,219,127,254,88,105,236,255,162,110,23,255,36,166,110,255,91,236,221,255,66,234,116,0,111,19,244,254,10,233,26,0,32,183,6,254,2,191,242,0,218,156,53,254,41,60,70,255,168,236,111,0,121,185,126,255,238,142,207,255,55,126,52,0,220,129,208,254,80,204,164,255,67,23,144,254,218,40,108,255,127,202,164,0,203,33,3,255,2,158,0,0,37,96,188,255,192,49,74,0,109,4,0,0,111,167,10,254,91,218,135,255,203,66,173,255,150,194,226,0,201,253,6,255,174,102,121,0,205,191,110,0,53,194,4,0,81,40,45,254,35,102,143,255,12,108,198,255,16,27,232,255,252,71,186,1,176,110,114,0,142,3,117,1,113,77,142,0,19,156,197,1,92,47,252,0,53,232,22,1,54,18,235,0,46,35,189,255,236,212,129,0,2,96,208,254,200,238,199,255,59,175,164,255,146,43,231,0,194,217,52,255,3,223,12,0,138,54,178,254,85,235,207,0,232,207,34,0,49,52,50,255,166,113,89,255,10,45,216,255,62,173,28,0,111,165,246,0,118,115,91,255,128,84,60,0,167,144,203,0,87,13,243,0,22,30,228,1,177,113,146,255,129,170,230,254,252,153,129,255,145,225,43,0,70,231,5,255,122,105,126,254,86,246,148,255,110,37,154,254,209,3,91,0,68,145,62,0,228,16,165,255,55,221,249,254,178,210,91,0,83,146,226,254,69,146,186,0,93,210,104,254,16,25,173,0,231,186,38,0,189,122,140,255,251,13,112,255,105,110,93,0,251,72,170,0,192,23,223,255,24,3,202,1,225,93,228,0,153,147,199,254,109,170,22,0,248,101,246,255,178,124,12,255,178,254,102,254,55,4,65,0,125,214,180,0,183,96,147,0,45,117,23,254,132,191,249,0,143,176,203,254,136,183,54,255,146,234,177,0,146,101,86,255,44,123,143,1,33,209,152,0,192,90,41,254,83,15,125,255,213,172,82,0,215,169,144,0,16,13,34,0,32,209,100,255,84,18,249,1,197,17,236,255,217,186,230,0,49,160,176,255,111,118,97,255,237,104,235,0,79,59,92,254,69,249,11,255,35,172,74,1,19,118,68,0,222,124,165,255,180,66,35,255,86,174,246,0,43,74,111,255,126,144,86,255,228,234,91,0,242,213,24,254,69,44,235,255,220,180,35,0,8,248,7,255,102,47,92,255,240,205,102,255,113,230,171,1,31,185,201,255,194,246,70,255,122,17,187,0,134,70,199,255,149,3,150,255,117,63,103,0,65,104,123,255,212,54,19,1,6,141,88,0,83,134,243,255,136,53,103,0,169,27,180,0,177,49,24,0,111,54,167,0,195,61,215,255,31,1,108,1,60,42,70,0,185,3,162,255,194,149,40,255,246,127,38,254,190,119,38,255,61,119,8,1,96,161,219,255,42,203,221,1,177,242,164,255,245,159,10,0,116,196,0,0,5,93,205,254,128,127,179,0,125,237,246,255,149,162,217,255,87,37,20,254,140,238,192,0,9,9,193,0,97,1,226,0,29,38,10,0,0,136,63,255,229,72,210,254,38,134,92,255,78,218,208,1,104,36,84,255,12,5,193,255,242,175,61,255,191,169,46,1,179,147,147,255,113,190,139,254,125,172,31,0,3,75,252,254,215,36,15,0,193,27,24,1,255,69,149,255,110,129,118,0,203,93,249,0,138,137,64,254,38,70,6,0,153,116,222,0,161,74,123,0,193,99,79,255,118,59,94,255,61,12,43,1,146,177,157,0,46,147,191,0,16,255,38,0,11,51,31,1,60,58,98,255,111,194,77,1,154,91,244,0,140,40,144,1,173,10,251,0,203,209,50,254,108,130,78,0,228,180,90,0,174,7,250,0,31,174,60,0,41,171,30,0,116,99,82,255,118,193,139,255,187,173,198,254,218,111,56,0,185,123,216,0,249,158,52,0,52,180,93,255,201,9,91,255,56,45,166,254,132,155,203,255,58,232,110,0,52,211,89,255,253,0,162,1,9,87,183,0,145,136,44,1,94,122,245,0,85,188,171,1,147,92,198,0,0,8,104,0,30,95,174,0,221,230,52,1,247,247,235,255,137,174,53,255,35,21,204,255,71,227,214,1,232,82,194,0,11,48,227,255,170,73,184,255,198,251,252,254,44,112,34,0,131,101,131,255,72,168,187,0,132,135,125,255,138,104,97,255,238,184,168,255,243,104,84,255,135,216,226,255,139,144,237,0,188,137,150,1,80,56,140,255,86,169,167,255,194,78,25,255,220,17,180,255,17,13,193,0,117,137,212,255,141,224,151,0,49,244,175,0,193,99,175,255,19,99,154,1,255,65,62,255,156,210,55,255,242,244,3,255,250,14,149,0,158,88,217,255,157,207,134,254,251,232,28,0,46,156,251,255,171,56,184,255,239,51,234,0,142,138,131,255,25,254,243,1,10,201,194,0,63,97,75,0,210,239,162,0,192,200,31,1,117,214,243,0,24,71,222,254,54,40,232,255,76,183,111,254,144,14,87,255,214,79,136,255,216,196,212,0,132,27,140,254,131,5,253,0,124,108,19,255,28,215,75,0,76,222,55,254,233,182,63,0,68,171,191,254,52,111,222,255,10,105,77,255,80,170,235,0,143,24,88,255,45,231,121,0,148,129,224,1,61,246,84,0,253,46,219,255,239,76,33,0,49,148,18,254,230,37,69,0,67,134,22,254,142,155,94,0,31,157,211,254,213,42,30,255,4,228,247,254,252,176,13,255,39,0,31,254,241,244,255,255,170,45,10,254,253,222,249,0,222,114,132,0,255,47,6,255,180,163,179,1,84,94,151,255,89,209,82,254,229,52,169,255,213,236,0,1,214,56,228,255,135,119,151,255,112,201,193,0,83,160,53,254,6,151,66,0,18,162,17,0,233,97,91,0,131,5,78,1,181,120,53,255,117,95,63,255,237,117,185,0,191,126,136,255,144,119,233,0,183,57,97,1,47,201,187,255,167,165,119,1,45,100,126,0,21,98,6,254,145,150,95,255,120,54,152,0,209,98,104,0,143,111,30,254,184,148,249,0,235,216,46,0,248,202,148,255,57,95,22,0,242,225,163,0,233,247,232,255,71,171,19,255,103,244,49,255,84,103,93,255,68,121,244,1,82,224,13,0,41,79,43,255,249,206,167,255,215,52,21,254,192,32,22,255,247,111,60,0,101,74,38,255,22,91,84,254,29,28,13,255,198,231,215,254,244,154,200,0,223,137,237,0,211,132,14,0,95,64,206,255,17,62,247,255,233,131,121,1,93,23,77,0,205,204,52,254,81,189,136,0,180,219,138,1,143,18,94,0,204,43,140,254,188,175,219,0,111,98,143,255,151,63,162,255,211,50,71,254,19,146,53,0,146,45,83,254,178,82,238,255,16,133,84,255,226,198,93,255,201,97,20,255,120,118,35,255,114,50,231,255,162,229,156,255,211,26,12,0,114,39,115,255,206,212,134,0,197,217,160,255,116,129,94,254,199,215,219,255,75,223,249,1,253,116,181,255,232,215,104,255,228,130,246,255,185,117,86,0,14,5,8,0,239,29,61,1,237,87,133,255,125,146,137,254,204,168,223,0,46,168,245,0,154,105,22,0,220,212,161,255,107,69,24,255,137,218,181,255,241,84,198,255,130,122,211,255,141,8,153,255,190,177,118,0,96,89,178,0,255,16,48,254,122,96,105,255,117,54,232,255,34,126,105,255,204,67,166,0,232,52,138,255,211,147,12,0,25,54,7,0,44,15,215,254,51,236,45,0,190,68,129,1,106,147,225,0,28,93,45,254,236,141,15,255,17,61,161,0,220,115,192,0,236,145,24,254,111,168,169,0,224,58,63,255,127,164,188,0,82,234,75,1,224,158,134,0,209,68,110,1,217,166,217,0,70,225,166,1,187,193,143,255,16,7,88,255,10,205,140,0,117,192,156,1,17,56,38,0,27,124,108,1,171,215,55,255,95,253,212,0,155,135,168,255,246,178,153,254,154,68,74,0,232,61,96,254,105,132,59,0,33,76,199,1,189,176,130,255,9,104,25,254,75,198,102,255,233,1,112,0,108,220,20,255,114,230,70,0,140,194,133,255,57,158,164,254,146,6,80,255,169,196,97,1,85,183,130,0,70,158,222,1,59,237,234,255,96,25,26,255,232,175,97,255,11,121,248,254,88,35,194,0,219,180,252,254,74,8,227,0,195,227,73,1,184,110,161,255,49,233,164,1,128,53,47,0,82,14,121,255,193,190,58,0,48,174,117,255,132,23,32,0,40,10,134,1,22,51,25,255,240,11,176,255,110,57,146,0,117,143,239,1,157,101,118,255,54,84,76,0,205,184,18,255,47,4,72,255,78,112,85,255,193,50,66,1,93,16,52,255,8,105,134,0,12,109,72,255,58,156,251,0,144,35,204,0,44,160,117,254,50,107,194,0,1,68,165,255,111,110,162,0,158,83,40,254,76,214,234,0,58,216,205,255,171,96,147,255,40,227,114,1,176,227,241,0,70,249,183,1,136,84,139,255,60,122,247,254,143,9,117,255,177,174,137,254,73,247,143,0,236,185,126,255,62,25,247,255,45,64,56,255,161,244,6,0,34,57,56,1,105,202,83,0,128,147,208,0,6,103,10,255,74,138,65,255,97,80,100,255,214,174,33,255,50,134,74,255,110,151,130,254,111,84,172,0,84,199,75,254,248,59,112,255,8,216,178,1,9,183,95,0,238,27,8,254,170,205,220,0,195,229,135,0,98,76,237,255,226,91,26,1,82,219,39,255,225,190,199,1,217,200,121,255,81,179,8,255,140,65,206,0,178,207,87,254,250,252,46,255,104,89,110,1,253,189,158,255,144,214,158,255,160,245,54,255,53,183,92,1,21,200,194,255,146,33,113,1,209,1,255,0,235,106,43,255,167,52,232,0,157,229,221,0,51,30,25,0,250,221,27,1,65,147,87,255,79,123,196,0,65,196,223,255,76,44,17,1,85,241,68,0,202,183,249,255,65,212,212,255,9,33,154,1,71,59,80,0,175,194,59,255,141,72,9,0,100,160,244,0,230,208,56,0,59,25,75,254,80,194,194,0,18,3,200,254,160,159,115,0,132,143,247,1,111,93,57,255,58,237,11,1,134,222,135,255,122,163,108,1,123,43,190,255,251,189,206,254,80,182,72,255,208,246,224,1,17,60,9,0,161,207,38,0,141,109,91,0,216,15,211,255,136,78,110,0,98,163,104,255,21,80,121,255,173,178,183,1,127,143,4,0,104,60,82,254,214,16,13,255,96,238,33,1,158,148,230,255,127,129,62,255,51,255,210,255,62,141,236,254,157,55,224,255,114,39,244,0,192,188,250,255,228,76,53,0,98,84,81,255,173,203,61,254,147,50,55,255,204,235,191,0,52,197,244,0,88,43,211,254,27,191,119,0,188,231,154,0,66,81,161,0,92,193,160,1,250,227,120,0,123,55,226,0,184,17,72,0,133,168,10,254,22,135,156,255,41,25,103,255,48,202,58,0,186,149,81,255,188,134,239,0,235,181,189,254,217,139,188,255,74,48,82,0,46,218,229,0,189,253,251,0,50,229,12,255,211,141,191,1,128,244,25,255,169,231,122,254,86,47,189,255,132,183,23,255,37,178,150,255,51,137,253,0,200,78,31,0,22,105,50,0,130,60,0,0,132,163,91,254,23,231,187,0,192,79,239,0,157,102,164,255,192,82,20,1,24,181,103,255,240,9,234,0,1,123,164,255,133,233,0,255,202,242,242,0,60,186,245,0,241,16,199,255,224,116,158,254,191,125,91,255,224,86,207,0,121,37,231,255,227,9,198,255,15,153,239,255,121,232,217,254,75,112,82,0,95,12,57,254,51,214,105,255,148,220,97,1,199,98,36,0,156,209,12,254,10,212,52,0,217,180,55,254,212,170,232,255,216,20,84,255,157,250,135,0,157,99,127,254,1,206,41,0,149,36,70,1,54,196,201,255,87,116,0,254,235,171,150,0,27,163,234,0,202,135,180,0,208,95,0,254,123,156,93,0,183,62,75,0,137,235,182,0,204,225,255,255,214,139,210,255,2,115,8,255,29,12,111,0,52,156,1,0,253,21,251,255,37,165,31,254,12,130,211,0,106,18,53,254,42,99,154,0,14,217,61,254,216,11,92,255,200,197,112,254,147,38,199,0,36,252,120,254,107,169,77,0,1,123,159,255,207,75,102,0,163,175,196,0,44,1,240,0,120,186,176,254,13,98,76,255,237,124,241,255,232,146,188,255,200,96,224,0,204,31,41,0,208,200,13,0,21,225,96,255,175,156,196,0,247,208,126,0,62,184,244,254,2,171,81,0,85,115,158,0,54,64,45,255,19,138,114,0,135,71,205,0,227,47,147,1,218,231,66,0,253,209,28,0,244,15,173,255,6,15,118,254,16,150,208,255,185,22,50,255,86,112,207,255,75,113,215,1,63,146,43,255,4,225,19,254,227,23,62,255,14,255,214,254,45,8,205,255,87,197,151,254,210,82,215,255,245,248,247,255,128,248,70,0,225,247,87,0,90,120,70,0,213,245,92,0,13,133,226,0,47,181,5,1,92,163,105,255,6,30,133,254,232,178,61,255,230,149,24,255,18,49,158,0,228,100,61,254,116,243,251,255,77,75,92,1,81,219,147,255,76,163,254,254,141,213,246,0,232,37,152,254,97,44,100,0,201,37,50,1,212,244,57,0,174,171,183,255,249,74,112,0,166,156,30,0,222,221,97,255,243,93,73,254,251,101,100,255,216,217,93,255,254,138,187,255,142,190,52,255,59,203,177,255,200,94,52,0,115,114,158,255,165,152,104,1,126,99,226,255,118,157,244,1,107,200,16,0,193,90,229,0,121,6,88,0,156,32,93,254,125,241,211,255,14,237,157,255,165,154,21,255,184,224,22,255,250,24,152,255,113,77,31,0,247,171,23,255,237,177,204,255,52,137,145,255,194,182,114,0,224,234,149,0,10,111,103,1,201,129,4,0,238,142,78,0,52,6,40,255,110,213,165,254,60,207,253,0,62,215,69,0,96,97,0,255,49,45,202,0,120,121,22,255,235,139,48,1,198,45,34,255,182,50,27,1,131,210,91,255,46,54,128,0,175,123,105,255,198,141,78,254,67,244,239,255,245,54,103,254,78,38,242,255,2,92,249,254,251,174,87,255,139,63,144,0,24,108,27,255,34,102,18,1,34,22,152,0,66,229,118,254,50,143,99,0,144,169,149,1,118,30,152,0,178,8,121,1,8,159,18,0,90,101,230,255,129,29,119,0,68,36,11,1,232,183,55,0,23,255,96,255,161,41,193,255,63,139,222,0,15,179,243,0,255,100,15,255,82,53,135,0,137,57,149,1,99,240,170,255,22,230,228,254,49,180,82,255,61,82,43,0,110,245,217,0,199,125,61,0,46,253,52,0,141,197,219,0,211,159,193,0,55,121,105,254,183,20,129,0,169,119,170,255,203,178,139,255,135,40,182,255,172,13,202,255,65,178,148,0,8,207,43,0,122,53,127,1,74,161,48,0,227,214,128,254,86,11,243,255,100,86,7,1,245,68,134,255,61,43,21,1,152,84,94,255,190,60,250,254,239,118,232,255,214,136,37,1,113,76,107,255,93,104,100,1,144,206,23,255,110,150,154,1,228,103,185,0,218,49,50,254,135,77,139,255,185,1,78,0,0,161,148,255,97,29,233,255,207,148,149,255,160,168,0,0,91,128,171,255,6,28,19,254,11,111,247,0,39,187,150,255,138,232,149,0,117,62,68,255,63,216,188,255,235,234,32,254,29,57,160,255,25,12,241,1,169,60,191,0,32,131,141,255,237,159,123,255,94,197,94,254,116,254,3,255,92,179,97,254,121,97,92,255,170,112,14,0,21,149,248,0,248,227,3,0,80,96,109,0,75,192,74,1,12,90,226,255,161,106,68,1,208,114,127,255,114,42,255,254,74,26,74,255,247,179,150,254,121,140,60,0,147,70,200,255,214,40,161,255,161,188,201,255,141,65,135,255,242,115,252,0,62,47,202,0,180,149,255,254,130,55,237,0,165,17,186,255,10,169,194,0,156,109,218,255,112,140,123,255,104,128,223,254,177,142,108,255,121,37,219,255,128,77,18,255,111,108,23,1,91,192,75,0,174,245,22,255,4,236,62,255,43,64,153,1,227,173,254,0,237,122,132,1,127,89,186,255,142,82,128,254,252,84,174,0,90,179,177,1,243,214,87,255,103,60,162,255,208,130,14,255,11,130,139,0,206,129,219,255,94,217,157,255,239,230,230,255,116,115,159,254,164,107,95,0,51,218,2,1,216,125,198,255,140,202,128,254,11,95,68,255,55,9,93,254,174,153,6,255,204,172,96,0,69,160,110,0,213,38,49,254,27,80,213,0,118,125,114,0,70,70,67,255,15,142,73,255,131,122,185,255,243,20,50,254,130,237,40,0,210,159,140,1,197,151,65,255,84,153,66,0,195,126,90,0,16,238,236,1,118,187,102,255,3,24,133,255,187,69,230,0,56,197,92,1,213,69,94,255,80,138,229,1,206,7,230,0,222,111,230,1,91,233,119,255,9,89,7,1,2,98,1,0,148,74,133,255,51,246,180,255,228,177,112,1,58,189,108,255,194,203,237,254,21,209,195,0,147,10,35,1,86,157,226,0,31,163,139,254,56,7,75,255,62,90,116,0,181,60,169,0,138,162,212,254,81,167,31,0,205,90,112,255,33,112,227,0,83,151,117,1,177,224,73,255,174,144,217,255,230,204,79,255,22,77,232,255,114,78,234,0,224,57,126,254,9,49,141,0,242,147,165,1,104,182,140,255,167,132,12,1,123,68,127,0,225,87,39,1,251,108,8,0,198,193,143,1,121,135,207,255,172,22,70,0,50,68,116,255,101,175,40,255,248,105,233,0,166,203,7,0,110,197,218,0,215,254,26,254,168,226,253,0,31,143,96,0,11,103,41,0,183,129,203,254,100,247,74,255,213,126,132,0,210,147,44,0,199,234,27,1,148,47,181,0,155,91,158,1,54,105,175,255,2,78,145,254,102,154,95,0,128,207,127,254,52,124,236,255,130,84,71,0,221,243,211,0,152,170,207,0,222,106,199,0,183,84,94,254,92,200,56,255,138,182,115,1,142,96,146,0,133,136,228,0,97,18,150,0,55,251,66,0,140,102,4,0,202,103,151,0,30,19,248,255,51,184,207,0,202,198,89,0,55,197,225,254,169,95,249,255,66,65,68,255,188,234,126,0,166,223,100,1,112,239,244,0,144,23,194,0,58,39,182,0,244,44,24,254,175,68,179,255,152,118,154,1,176,162,130,0,217,114,204,254,173,126,78,255,33,222,30,255,36,2,91,255,2,143,243,0,9,235,215,0,3,171,151,1,24,215,245,255,168,47,164,254,241,146,207,0,69,129,180,0,68,243,113,0,144,53,72,254,251,45,14,0,23,110,168,0,68,68,79,255,110,70,95,254,174,91,144,255,33,206,95,255,137,41,7,255,19,187,153,254,35,255,112,255,9,145,185,254,50,157,37,0,11,112,49,1,102,8,190,255,234,243,169,1,60,85,23,0,74,39,189,0,116,49,239,0,173,213,210,0,46,161,108,255,159,150,37,0,196,120,185,255,34,98,6,255,153,195,62,255,97,230,71,255,102,61,76,0,26,212,236,255,164,97,16,0,198,59,146,0,163,23,196,0,56,24,61,0,181,98,193,0,251,147,229,255,98,189,24,255,46,54,206,255,234,82,246,0,183,103,38,1,109,62,204,0,10,240,224,0,146,22,117,255,142,154,120,0,69,212,35,0,208,99,118,1,121,255,3,255,72,6,194,0,117,17,197,255,125,15,23,0,154,79,153,0,214,94,197,255,185,55,147,255,62,254,78,254,127,82,153,0,110,102,63,255,108,82,161,255,105,187,212,1,80,138,39,0,60,255,93,255,72,12,186,0,210,251,31,1,190,167,144,255,228,44,19,254,128,67,232,0,214,249,107,254,136,145,86,255,132,46,176,0,189,187,227,255,208,22,140,0,217,211,116,0,50,81,186,254,139,250,31,0,30,64,198,1,135,155,100,0,160,206,23,254,187,162,211,255,16,188,63,0,254,208,49,0,85,84,191,0,241,192,242,255,153,126,145,1,234,162,162,255,230,97,216,1,64,135,126,0,190,148,223,1,52,0,43,255,28,39,189,1,64,136,238,0,175,196,185,0,98,226,213,255,127,159,244,1,226,175,60,0,160,233,142,1,180,243,207,255,69,152,89,1,31,101,21,0,144,25,164,254,139,191,209,0,91,25,121,0,32,147,5,0,39,186,123,255,63,115,230,255,93,167,198,255,143,213,220,255,179,156,19,255,25,66,122,0,214,160,217,255,2,45,62,255,106,79,146,254,51,137,99,255,87,100,231,255,175,145,232,255,101,184,1,255,174,9,125,0,82,37,161,1,36,114,141,255,48,222,142,255,245,186,154,0,5,174,221,254,63,114,155,255,135,55,160,1,80,31,135,0,126,250,179,1,236,218,45,0,20,28,145,1,16,147,73,0,249,189,132,1,17,189,192,255,223,142,198,255,72,20,15,255,250,53,237,254,15,11,18,0,27,211,113,254,213,107,56,255,174,147,146,255,96,126,48,0,23,193,109,1,37,162,94,0,199,157,249,254,24,128,187,255,205,49,178,254,93,164,42,255,43,119,235,1,88,183,237,255,218,210,1,255,107,254,42,0,230,10,99,255,162,0,226,0,219,237,91,0,129,178,203,0,208,50,95,254,206,208,95,255,247,191,89,254,110,234,79,255,165,61,243,0,20,122,112,255,246,246,185,254,103,4,123,0,233,99,230,1,219,91,252,255,199,222,22,255,179,245,233,255,211,241,234,0,111,250,192,255,85,84,136,0,101,58,50,255,131,173,156,254,119,45,51,255,118,233,16,254,242,90,214,0,94,159,219,1,3,3,234,255,98,76,92,254,80,54,230,0,5,228,231,254,53,24,223,255,113,56,118,1,20,132,1,255,171,210,236,0,56,241,158,255,186,115,19,255,8,229,174,0,48,44,0,1,114,114,166,255,6,73,226,255,205,89,244,0,137,227,75,1,248,173,56,0,74,120,246,254,119,3,11,255,81,120,198,255,136,122,98,255,146,241,221,1,109,194,78,255,223,241,70,1,214,200,169,255,97,190,47,255,47,103,174,255,99,92,72,254,118,233,180,255,193,35,233,254,26,229,32,255,222,252,198,0,204,43,71,255,199,84,172,0,134,102,190,0,111,238,97,254,230,40,230,0,227,205,64,254,200,12,225,0,166,25,222,0,113,69,51,255,143,159,24,0,167,184,74,0,29,224,116,254,158,208,233,0,193,116,126,255,212,11,133,255,22,58,140,1,204,36,51,255,232,30,43,0,235,70,181,255,64,56,146,254,169,18,84,255,226,1,13,255,200,50,176,255,52,213,245,254,168,209,97,0,191,71,55,0,34,78,156,0,232,144,58,1,185,74,189,0,186,142,149,254,64,69,127,255,161,203,147,255,176,151,191,0,136,231,203,254,163,182,137,0,161,126,251,254,233,32,66,0,68,207,66,0,30,28,37,0,93,114,96,1,254,92,247,255,44,171,69,0,202,119,11,255,188,118,50,1,255,83,136,255,71,82,26,0,70,227,2,0,32,235,121,1,181,41,154,0,71,134,229,254,202,255,36,0,41,152,5,0,154,63,73,255,34,182,124,0,121,221,150,255,26,204,213,1,41,172,87,0,90,157,146,255,109,130,20,0,71,107,200,255,243,102,189,0,1,195,145,254,46,88,117,0,8,206,227,0,191,110,253,255,109,128,20,254,134,85,51,255,137,177,112,1,216,34,22,255,131,16,208,255,121,149,170,0,114,19,23,1,166,80,31,255,113,240,122,0,232,179,250,0,68,110,180,254,210,170,119,0,223,108,164,255,207,79,233,255,27,229,226,254,209,98,81,255,79,68,7,0,131,185,100,0,170,29,162,255,17,162,107,255,57,21,11,1,100,200,181,255,127,65,166,1,165,134,204,0,104,167,168,0,1,164,79,0,146,135,59,1,70,50,128,255,102,119,13,254,227,6,135,0,162,142,179,255,160,100,222,0,27,224,219,1,158,93,195,255,234,141,137,0,16,24,125,255,238,206,47,255,97,17,98,255,116,110,12,255,96,115,77,0,91,227,232,255,248,254,79,255,92,229,6,254,88,198,139,0,206,75,129,0,250,77,206,255,141,244,123,1,138,69,220,0,32,151,6,1,131,167,22,255,237,68,167,254,199,189,150,0,163,171,138,255,51,188,6,255,95,29,137,254,148,226,179,0,181,107,208,255,134,31,82,255,151,101,45,255,129,202,225,0,224,72,147,0,48,138,151,255,195,64,206,254,237,218,158,0,106,29,137,254,253,189,233,255,103,15,17,255,194,97,255,0,178,45,169,254,198,225,155,0,39,48,117,255,135,106,115,0,97,38,181,0,150,47,65,255,83,130,229,254,246,38,129,0,92,239,154,254,91,99,127,0,161,111,33,255,238,217,242,255,131,185,195,255,213,191,158,255,41,150,218,0,132,169,131,0,89,84,252,1,171,70,128,255,163,248,203,254,1,50,180,255,124,76,85,1,251,111,80,0,99,66,239,255,154,237,182,255,221,126,133,254,74,204,99,255,65,147,119,255,99,56,167,255,79,248,149,255,116,155,228,255,237,43,14,254,69,137,11,255,22,250,241,1,91,122,143,255,205,249,243,0,212,26,60,255,48,182,176,1,48,23,191,255,203,121,152,254,45,74,213,255,62,90,18,254,245,163,230,255,185,106,116,255,83,35,159,0,12,33,2,255,80,34,62,0,16,87,174,255,173,101,85,0,202,36,81,254,160,69,204,255,64,225,187,0,58,206,94,0,86,144,47,0,229,86,245,0,63,145,190,1,37,5,39,0,109,251,26,0,137,147,234,0,162,121,145,255,144,116,206,255,197,232,185,255,183,190,140,255,73,12,254,255,139,20,242,255,170,90,239,255,97,66,187,255,245,181,135,254,222,136,52,0,245,5,51,254,203,47,78,0,152,101,216,0,73,23,125,0,254,96,33,1,235,210,73,255,43,209,88,1,7,129,109,0,122,104,228,254,170,242,203,0,242,204,135,255,202,28,233,255,65,6,127,0,159,144,71,0,100,140,95,0,78,150,13,0,251,107,118,1,182,58,125,255,1,38,108,255,141,189,209,255,8,155,125,1,113,163,91,255,121,79,190,255,134,239,108,255,76,47,248,0,163,228,239,0,17,111,10,0,88,149,75,255,215,235,239,0,167,159,24,255,47,151,108,255,107,209,188,0,233,231,99,254,28,202,148,255,174,35,138,255,110,24,68,255,2,69,181,0,107,102,82,0,102,237,7,0,92,36,237,255,221,162,83,1,55,202,6,255,135,234,135,255,24,250,222,0,65,94,168,254,245,248,210,255,167,108,201,254,255,161,111,0,205,8,254,0,136,13,116,0,100,176,132,255,43,215,126,255,177,133,130,255,158,79,148,0,67,224,37,1,12,206,21,255,62,34,110,1,237,104,175,255,80,132,111,255,142,174,72,0,84,229,180,254,105,179,140,0,64,248,15,255,233,138,16,0,245,67,123,254,218,121,212,255,63,95,218,1,213,133,137,255,143,182,82,255,48,28,11,0,244,114,141,1,209,175,76,255],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+20480);allocate([157,181,150,255,186,229,3,255,164,157,111,1,231,189,139,0,119,202,190,255,218,106,64,255,68,235,63,254,96,26,172,255,187,47,11,1,215,18,251,255,81,84,89,0,68,58,128,0,94,113,5,1,92,129,208,255,97,15,83,254,9,28,188,0,239,9,164,0,60,205,152,0,192,163,98,255,184,18,60,0,217,182,139,0,109,59,120,255,4,192,251,0,169,210,240,255,37,172,92,254,148,211,245,255,179,65,52,0,253,13,115,0,185,174,206,1,114,188,149,255,237,90,173,0,43,199,192,255,88,108,113,0,52,35,76,0,66,25,148,255,221,4,7,255,151,241,114,255,190,209,232,0,98,50,199,0,151,150,213,255,18,74,36,1,53,40,7,0,19,135,65,255,26,172,69,0,174,237,85,0,99,95,41,0,3,56,16,0,39,160,177,255,200,106,218,254,185,68,84,255,91,186,61,254,67,143,141,255,13,244,166,255,99,114,198,0,199,110,163,255,193,18,186,0,124,239,246,1,110,68,22,0,2,235,46,1,212,60,107,0,105,42,105,1,14,230,152,0,7,5,131,0,141,104,154,255,213,3,6,0,131,228,162,255,179,100,28,1,231,123,85,255,206,14,223,1,253,96,230,0,38,152,149,1,98,137,122,0,214,205,3,255,226,152,179,255,6,133,137,0,158,69,140,255,113,162,154,255,180,243,172,255,27,189,115,255,143,46,220,255,213,134,225,255,126,29,69,0,188,43,137,1,242,70,9,0,90,204,255,255,231,170,147,0,23,56,19,254,56,125,157,255,48,179,218,255,79,182,253,255,38,212,191,1,41,235,124,0,96,151,28,0,135,148,190,0,205,249,39,254,52,96,136,255,212,44,136,255,67,209,131,255,252,130,23,255,219,128,20,255,198,129,118,0,108,101,11,0,178,5,146,1,62,7,100,255,181,236,94,254,28,26,164,0,76,22,112,255,120,102,79,0,202,192,229,1,200,176,215,0,41,64,244,255,206,184,78,0,167,45,63,1,160,35,0,255,59,12,142,255,204,9,144,255,219,94,229,1,122,27,112,0,189,105,109,255,64,208,74,255,251,127,55,1,2,226,198,0,44,76,209,0,151,152,77,255,210,23,46,1,201,171,69,255,44,211,231,0,190,37,224,255,245,196,62,255,169,181,222,255,34,211,17,0,119,241,197,255,229,35,152,1,21,69,40,255,178,226,161,0,148,179,193,0,219,194,254,1,40,206,51,255,231,92,250,1,67,153,170,0,21,148,241,0,170,69,82,255,121,18,231,255,92,114,3,0,184,62,230,0,225,201,87,255,146,96,162,255,181,242,220,0,173,187,221,1,226,62,170,255,56,126,217,1,117,13,227,255,179,44,239,0,157,141,155,255,144,221,83,0,235,209,208,0,42,17,165,1,251,81,133,0,124,245,201,254,97,211,24,255,83,214,166,0,154,36,9,255,248,47,127,0,90,219,140,255,161,217,38,254,212,147,63,255,66,84,148,1,207,3,1,0,230,134,89,1,127,78,122,255,224,155,1,255,82,136,74,0,178,156,208,255,186,25,49,255,222,3,210,1,229,150,190,255,85,162,52,255,41,84,141,255,73,123,84,254,93,17,150,0,119,19,28,1,32,22,215,255,28,23,204,255,142,241,52,255,228,52,125,0,29,76,207,0,215,167,250,254,175,164,230,0,55,207,105,1,109,187,245,255,161,44,220,1,41,101,128,255,167,16,94,0,93,214,107,255,118,72,0,254,80,61,234,255,121,175,125,0,139,169,251,0,97,39,147,254,250,196,49,255,165,179,110,254,223,70,187,255,22,142,125,1,154,179,138,255,118,176,42,1,10,174,153,0,156,92,102,0,168,13,161,255,143,16,32,0,250,197,180,255,203,163,44,1,87,32,36,0,161,153,20,255,123,252,15,0,25,227,80,0,60,88,142,0,17,22,201,1,154,205,77,255,39,63,47,0,8,122,141,0,128,23,182,254,204,39,19,255,4,112,29,255,23,36,140,255,210,234,116,254,53,50,63,255,121,171,104,255,160,219,94,0,87,82,14,254,231,42,5,0,165,139,127,254,86,78,38,0,130,60,66,254,203,30,45,255,46,196,122,1,249,53,162,255,136,143,103,254,215,210,114,0,231,7,160,254,169,152,42,255,111,45,246,0,142,131,135,255,131,71,204,255,36,226,11,0,0,28,242,255,225,138,213,255,247,46,216,254,245,3,183,0,108,252,74,1,206,26,48,255,205,54,246,255,211,198,36,255,121,35,50,0,52,216,202,255,38,139,129,254,242,73,148,0,67,231,141,255,42,47,204,0,78,116,25,1,4,225,191,255,6,147,228,0,58,88,177,0,122,165,229,255,252,83,201,255,224,167,96,1,177,184,158,255,242,105,179,1,248,198,240,0,133,66,203,1,254,36,47,0,45,24,115,255,119,62,254,0,196,225,186,254,123,141,172,0,26,85,41,255,226,111,183,0,213,231,151,0,4,59,7,255,238,138,148,0,66,147,33,255,31,246,141,255,209,141,116,255,104,112,31,0,88,161,172,0,83,215,230,254,47,111,151,0,45,38,52,1,132,45,204,0,138,128,109,254,233,117,134,255,243,190,173,254,241,236,240,0,82,127,236,254,40,223,161,255,110,182,225,255,123,174,239,0,135,242,145,1,51,209,154,0,150,3,115,254,217,164,252,255,55,156,69,1,84,94,255,255,232,73,45,1,20,19,212,255,96,197,59,254,96,251,33,0,38,199,73,1,64,172,247,255,117,116,56,255,228,17,18,0,62,138,103,1,246,229,164,255,244,118,201,254,86,32,159,255,109,34,137,1,85,211,186,0,10,193,193,254,122,194,177,0,122,238,102,255,162,218,171,0,108,217,161,1,158,170,34,0,176,47,155,1,181,228,11,255,8,156,0,0,16,75,93,0,206,98,255,1,58,154,35,0,12,243,184,254,67,117,66,255,230,229,123,0,201,42,110,0,134,228,178,254,186,108,118,255,58,19,154,255,82,169,62,255,114,143,115,1,239,196,50,255,173,48,193,255,147,2,84,255,150,134,147,254,95,232,73,0,109,227,52,254,191,137,10,0,40,204,30,254,76,52,97,255,164,235,126,0,254,124,188,0,74,182,21,1,121,29,35,255,241,30,7,254,85,218,214,255,7,84,150,254,81,27,117,255,160,159,152,254,66,24,221,255,227,10,60,1,141,135,102,0,208,189,150,1,117,179,92,0,132,22,136,255,120,199,28,0,21,129,79,254,182,9,65,0,218,163,169,0,246,147,198,255,107,38,144,1,78,175,205,255,214,5,250,254,47,88,29,255,164,47,204,255,43,55,6,255,131,134,207,254,116,100,214,0,96,140,75,1,106,220,144,0,195,32,28,1,172,81,5,255,199,179,52,255,37,84,203,0,170,112,174,0,11,4,91,0,69,244,27,1,117,131,92,0,33,152,175,255,140,153,107,255,251,135,43,254,87,138,4,255,198,234,147,254,121,152,84,255,205,101,155,1,157,9,25,0,72,106,17,254,108,153,0,255,189,229,186,0,193,8,176,255,174,149,209,0,238,130,29,0,233,214,126,1,61,226,102,0,57,163,4,1,198,111,51,255,45,79,78,1,115,210,10,255,218,9,25,255,158,139,198,255,211,82,187,254,80,133,83,0,157,129,230,1,243,133,134,255,40,136,16,0,77,107,79,255,183,85,92,1,177,204,202,0,163,71,147,255,152,69,190,0,172,51,188,1,250,210,172,255,211,242,113,1,89,89,26,255,64,66,111,254,116,152,42,0,161,39,27,255,54,80,254,0,106,209,115,1,103,124,97,0,221,230,98,255,31,231,6,0,178,192,120,254,15,217,203,255,124,158,79,0,112,145,247,0,92,250,48,1,163,181,193,255,37,47,142,254,144,189,165,255,46,146,240,0,6,75,128,0,41,157,200,254,87,121,213,0,1,113,236,0,5,45,250,0,144,12,82,0,31,108,231,0,225,239,119,255,167,7,189,255,187,228,132,255,110,189,34,0,94,44,204,1,162,52,197,0,78,188,241,254,57,20,141,0,244,146,47,1,206,100,51,0,125,107,148,254,27,195,77,0,152,253,90,1,7,143,144,255,51,37,31,0,34,119,38,255,7,197,118,0,153,188,211,0,151,20,116,254,245,65,52,255,180,253,110,1,47,177,209,0,161,99,17,255,118,222,202,0,125,179,252,1,123,54,126,255,145,57,191,0,55,186,121,0,10,243,138,0,205,211,229,255,125,156,241,254,148,156,185,255,227,19,188,255,124,41,32,255,31,34,206,254,17,57,83,0,204,22,37,255,42,96,98,0,119,102,184,1,3,190,28,0,110,82,218,255,200,204,192,255,201,145,118,0,117,204,146,0,132,32,98,1,192,194,121,0,106,161,248,1,237,88,124,0,23,212,26,0,205,171,90,255,248,48,216,1,141,37,230,255,124,203,0,254,158,168,30,255,214,248,21,0,112,187,7,255,75,133,239,255,74,227,243,255,250,147,70,0,214,120,162,0,167,9,179,255,22,158,18,0,218,77,209,1,97,109,81,255,244,33,179,255,57,52,57,255,65,172,210,255,249,71,209,255,142,169,238,0,158,189,153,255,174,254,103,254,98,33,14,0,141,76,230,255,113,139,52,255,15,58,212,0,168,215,201,255,248,204,215,1,223,68,160,255,57,154,183,254,47,231,121,0,106,166,137,0,81,136,138,0,165,43,51,0,231,139,61,0,57,95,59,254,118,98,25,255,151,63,236,1,94,190,250,255,169,185,114,1,5,250,58,255,75,105,97,1,215,223,134,0,113,99,163,1,128,62,112,0,99,106,147,0,163,195,10,0,33,205,182,0,214,14,174,255,129,38,231,255,53,182,223,0,98,42,159,255,247,13,40,0,188,210,177,1,6,21,0,255,255,61,148,254,137,45,129,255,89,26,116,254,126,38,114,0,251,50,242,254,121,134,128,255,204,249,167,254,165,235,215,0,202,177,243,0,133,141,62,0,240,130,190,1,110,175,255,0,0,20,146,1,37,210,121,255,7,39,130,0,142,250,84,255,141,200,207,0,9,95,104,255,11,244,174,0,134,232,126,0,167,1,123,254,16,193,149,255,232,233,239,1,213,70,112,255,252,116,160,254,242,222,220,255,205,85,227,0,7,185,58,0,118,247,63,1,116,77,177,255,62,245,200,254,63,18,37,255,107,53,232,254,50,221,211,0,162,219,7,254,2,94,43,0,182,62,182,254,160,78,200,255,135,140,170,0,235,184,228,0,175,53,138,254,80,58,77,255,152,201,2,1,63,196,34,0,5,30,184,0,171,176,154,0,121,59,206,0,38,99,39,0,172,80,77,254,0,134,151,0,186,33,241,254,94,253,223,255,44,114,252,0,108,126,57,255,201,40,13,255,39,229,27,255,39,239,23,1,151,121,51,255,153,150,248,0,10,234,174,255,118,246,4,254,200,245,38,0,69,161,242,1,16,178,150,0,113,56,130,0,171,31,105,0,26,88,108,255,49,42,106,0,251,169,66,0,69,93,149,0,20,57,254,0,164,25,111,0,90,188,90,255,204,4,197,0,40,213,50,1,212,96,132,255,88,138,180,254,228,146,124,255,184,246,247,0,65,117,86,255,253,102,210,254,254,121,36,0,137,115,3,255,60,24,216,0,134,18,29,0,59,226,97,0,176,142,71,0,7,209,161,0,189,84,51,254,155,250,72,0,213,84,235,255,45,222,224,0,238,148,143,255,170,42,53,255,78,167,117,0,186,0,40,255,125,177,103,255,69,225,66,0,227,7,88,1,75,172,6,0,169,45,227,1,16,36,70,255,50,2,9,255,139,193,22,0,143,183,231,254,218,69,50,0,236,56,161,1,213,131,42,0,138,145,44,254,136,229,40,255,49,63,35,255,61,145,245,255,101,192,2,254,232,167,113,0,152,104,38,1,121,185,218,0,121,139,211,254,119,240,35,0,65,189,217,254,187,179,162,255,160,187,230,0,62,248,14,255,60,78,97,0,255,247,163,255,225,59,91,255,107,71,58,255,241,47,33,1,50,117,236,0,219,177,63,254,244,90,179,0,35,194,215,255,189,67,50,255,23,135,129,0,104,189,37,255,185,57,194,0,35,62,231,255,220,248,108,0,12,231,178,0,143,80,91,1,131,93,101,255,144,39,2,1,255,250,178,0,5,17,236,254,139,32,46,0,204,188,38,254,245,115,52,255,191,113,73,254,191,108,69,255,22,69,245,1,23,203,178,0,170,99,170,0,65,248,111,0,37,108,153,255,64,37,69,0,0,88,62,254,89,148,144,255,191,68,224,1,241,39,53,0,41,203,237,255,145,126,194,255,221,42,253,255,25,99,151,0,97,253,223,1,74,115,49,255,6,175,72,255,59,176,203,0,124,183,249,1,228,228,99,0,129,12,207,254,168,192,195,255,204,176,16,254,152,234,171,0,77,37,85,255,33,120,135,255,142,194,227,1,31,214,58,0,213,187,125,255,232,46,60,255,190,116,42,254,151,178,19,255,51,62,237,254,204,236,193,0,194,232,60,0,172,34,157,255,189,16,184,254,103,3,95,255,141,233,36,254,41,25,11,255,21,195,166,0,118,245,45,0,67,213,149,255,159,12,18,255,187,164,227,1,160,25,5,0,12,78,195,1,43,197,225,0,48,142,41,254,196,155,60,255,223,199,18,1,145,136,156,0,252,117,169,254,145,226,238,0,239,23,107,0,109,181,188,255,230,112,49,254,73,170,237,255,231,183,227,255,80,220,20,0,194,107,127,1,127,205,101,0,46,52,197,1,210,171,36,255,88,3,90,255,56,151,141,0,96,187,255,255,42,78,200,0,254,70,70,1,244,125,168,0,204,68,138,1,124,215,70,0,102,66,200,254,17,52,228,0,117,220,143,254,203,248,123,0,56,18,174,255,186,151,164,255,51,232,208,1,160,228,43,255,249,29,25,1,68,190,63,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,5,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,19,0,0,0,172,210,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,19,0,0,0,180,210,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,0,0,0,19,0,0,0,188,214,0,0,0,4,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,220,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,127],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+30720);allocate([1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,90,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,90,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5,0,0,0,0,224,1,0,0,18,0,0,0,19,0,0,0,0,0,0,0,248,1,0,0,20,0,0,0,21,0,0,0,18,0,0,0,23,0,0,0,18,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,24,0,0,0,21,0,0,0,22,0,0,0,18,0,0,0,25,0,0,0,19,0,0,0,0,0,0,0,0,2,0,0,22,0,0,0,23,0,0,0,19,0,0,0,26,0,0,0,19,0,0,0,19,0,0,0,23,0,0,0,24,0,0,0,27,0,0,0,25,0,0,0,26,0,0,0,20,0,0,0,28,0,0,0,21,0,0,0,8,0,0,0,0,0,0,0,8,2,0,0,24,0,0,0,25,0,0,0,248,255,255,255,248,255,255,255,8,2,0,0,26,0,0,0,27,0,0,0,8,0,0,0,0,0,0,0,32,2,0,0,28,0,0,0,29,0,0,0,248,255,255,255,248,255,255,255,32,2,0,0,30,0,0,0,31,0,0,0,4,0,0,0,0,0,0,0,56,2,0,0,32,0,0,0,33,0,0,0,252,255,255,255,252,255,255,255,56,2,0,0,34,0,0,0,35,0,0,0,4,0,0,0,0,0,0,0,80,2,0,0,36,0,0,0,37,0,0,0,252,255,255,255,252,255,255,255,80,2,0,0,38,0,0,0,39,0,0,0,0,0,0,0,104,2,0,0,40,0,0,0,41,0,0,0,27,0,0,0,0,0,0,0,120,2,0,0,42,0,0,0,43,0,0,0,28,0,0,0,18,0,0,0,29,0,0,0,30,0,0,0,19,0,0,0,0,0,0,0,136,2,0,0,20,0,0,0,44,0,0,0,20,0,0,0,23,0,0,0,18,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,24,0,0,0,29,0,0,0,30,0,0,0,22,0,0,0,25,0,0,0,19,0,0,0,0,0,0,0,152,2,0,0,22,0,0,0,45,0,0,0,21,0,0,0,26,0,0,0,19,0,0,0,19,0,0,0,23,0,0,0,24,0,0,0,27,0,0,0,31,0,0,0,32,0,0,0,23,0,0,0,28,0,0,0,21,0,0,0,0,0,0,0,168,2,0,0,20,0,0,0,46,0,0,0,22,0,0,0,23,0,0,0,18,0,0,0,18,0,0,0,33,0,0,0,20,0,0,0,24,0,0,0,21,0,0,0,22,0,0,0,18,0,0,0,31,0,0,0,24,0,0,0,0,0,0,0,184,2,0,0,22,0,0,0,47,0,0,0,23,0,0,0,26,0,0,0,19,0,0,0,19,0,0,0,34,0,0,0,24,0,0,0,27,0,0,0,25,0,0,0,26,0,0,0,20,0,0,0,32,0,0,0,25,0,0,0,0,0,0,0,200,2,0,0,48,0,0,0,49,0,0,0,50,0,0,0,18,0,0,0,20,0,0,0,33,0,0,0,0,0,0,0,232,2,0,0,51,0,0,0,52,0,0,0,50,0,0,0,19,0,0,0,21,0,0,0,34,0,0,0,0,0,0,0,248,2,0,0,53,0,0,0,54,0,0,0,50,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,56,3,0,0,55,0,0,0,56,0,0,0,50,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,0,0,0,0,112,3,0,0,57,0,0,0,58,0,0,0,50,0,0,0,20,0,0,0,21,0,0,0,40,0,0,0,22,0,0,0,41,0,0,0,18,0,0,0,19,0,0,0,23,0,0,0,0,0,0,0,176,3,0,0,59,0,0,0,60,0,0,0,50,0,0,0,24,0,0,0,25,0,0,0,42,0,0,0,26,0,0,0,43,0,0,0,20,0,0,0,21,0,0,0,27,0,0,0,0,0,0,0,232,3,0,0,61,0,0,0,62,0,0,0,50,0,0,0,35,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,18,0,0,0,248,255,255,255,232,3,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,0,0,0,0,32,4,0,0,63,0,0,0,64,0,0,0,50,0,0,0,43,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,19,0,0,0,248,255,255,255,32,4,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,80,4,0,0,65,0,0,0,66,0,0,0,50,0,0,0,18,0,0,0,0,0,0,0,120,4,0,0,67,0,0,0,68,0,0,0,50,0,0,0,19,0,0,0,0,0,0,0,152,4,0,0,69,0,0,0,70,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,53,0,0,0,28,0,0,0,29,0,0,0,0,0,0,0,192,4,0,0,71,0,0,0,72,0,0,0,50,0,0,0,54,0,0,0,55,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,56,0,0,0,34,0,0,0,35,0,0,0,0,0,0,0,224,4,0,0,73,0,0,0,74,0,0,0,50,0,0,0,57,0,0,0,58,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,59,0,0,0,40,0,0,0,41,0,0,0,0,0,0,0,0,5,0,0,75,0,0,0,76,0,0,0,50,0,0,0,60,0,0,0,61,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,62,0,0,0,46,0,0,0,47,0,0,0,0,0,0,0,32,5,0,0,77,0,0,0,78,0,0,0,50,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,72,5,0,0,79,0,0,0,80,0,0,0,50,0,0,0,22,0,0,0,23,0,0,0,0,0,0,0,112,5,0,0,81,0,0,0,82,0,0,0,50,0,0,0,18,0,0,0,54,0,0,0,0,0,0,0,152,5,0,0,83,0,0,0,84,0,0,0,50,0,0,0,19,0,0,0,55,0,0,0,0,0,0,0,192,5,0,0,85,0,0,0,86,0,0,0,50,0,0,0,35,0,0,0,20,0,0,0,48,0,0,0,0,0,0,0,232,5,0,0,87,0,0,0,88,0,0,0,50,0,0,0,36,0,0,0,21,0,0,0,49,0,0,0,0,0,0,0,8,6,0,0,89,0,0,0,90,0,0,0,50,0,0,0,20,0,0,0,21,0,0,0,28,0,0,0,63,0,0,0,64,0,0,0,29,0,0,0,65,0,0,0,0,0,0,0,64,6,0,0,89,0,0,0,91,0,0,0,50,0,0,0,20,0,0,0,21,0,0,0,28,0,0,0,63,0,0,0,64,0,0,0,29,0,0,0,65,0,0,0,0,0,0,0,112,6,0,0,92,0,0,0,93,0,0,0,50,0,0,0,22,0,0,0,23,0,0,0,30,0,0,0,66,0,0,0,67,0,0,0,31,0,0,0,68,0,0,0,0,0,0,0,176,6,0,0,94,0,0,0,95,0,0,0,50,0,0,0,0,0,0,0,192,6,0,0,96,0,0,0,97,0,0,0,50,0,0,0,26,0,0,0,37,0,0,0,27,0,0,0,38,0,0,0,28,0,0,0,18,0,0,0,39,0,0,0,32,0,0,0,0,0,0,0,8,7,0,0,98,0,0,0,99,0,0,0,50,0,0,0,69,0,0,0,70,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,0,0,0,0,24,7,0,0,100,0,0,0,101,0,0,0,50,0,0,0,71,0,0,0,72,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,216,2,0,0,89,0,0,0,102,0,0,0,50,0,0,0,0,0,0,0,232,6,0,0,89,0,0,0,103,0,0,0,50,0,0,0,40,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,29,0,0,0,41,0,0,0,30,0,0,0,42,0,0,0,31,0,0,0,22,0,0,0,43,0,0,0,33,0,0,0,0,0,0,0,80,6,0,0,89,0,0,0,104,0,0,0,50,0,0,0,24,0,0,0,25,0,0,0,34,0,0,0,73,0,0,0,74,0,0,0,35,0,0,0,75,0,0,0,0,0,0,0,144,6,0,0,89,0,0,0,105,0,0,0,50,0,0,0,26,0,0,0,27,0,0,0,36,0,0,0,76,0,0,0,77,0,0,0,37,0,0,0,78,0,0,0,0,0,0,0,24,6,0,0,89,0,0,0,106,0,0,0,50,0,0,0,20,0,0,0,21,0,0,0,28,0,0,0,63,0,0,0,64,0,0,0,29,0,0,0,65,0,0,0,0,0,0,0,56,7,0,0,107,0,0,0,108,0,0,0,27,0,0,0,18,0,0,0,0,0,0,0,96,7,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,44,0,0,0,22,0,0,0,18,0,0,0,22,0,0,0,0,0,0,0,112,7,0,0,109,0,0,0,113,0,0,0,111,0,0,0,112,0,0,0,44,0,0,0,23,0,0,0,19,0,0,0,23,0,0,0,0,0,0,0,152,7,0,0,114,0,0,0,115,0,0,0,79,0,0,0,0,0,0,0,168,7,0,0,116,0,0,0,117,0,0,0,80,0,0,0,0,0,0,0,184,7,0,0,118,0,0,0,119,0,0,0,27,0,0,0,0,0,0,0,200,7,0,0,116,0,0,0,120,0,0,0,80,0,0,0,0,0,0,0,216,7,0,0,121,0,0,0,122,0,0,0,81,0,0,0,0,0,0,0,232,7,0,0,109,0,0,0,123,0,0,0,111,0,0,0,112,0,0,0,44,0,0,0,24,0,0,0,20,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,3,32,2,32,2,32,2,32,2,32,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,1,96,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,4,192,4,192,4,192,4,192,4,192,4,192,4,192,8,213,8,213,8,213,8,213,8,213,8,213,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,4,192,4,192,4,192,4,192,4,192,4,192,8,214,8,214,8,214,8,214,8,214,8,214,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,4,192,4,192,4,192,4,192,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,108,97,107,101,50,98,0,83,45,62,98,117,102,108,101,110,32,60,61,32,66,76,65,75,69,50,66,95,66,76,79,67,75,66,89,84,69,83,0,99,114,121,112,116,111,95,103,101,110,101,114,105,99,104,97,115,104,47,98,108,97,107,101,50,47,114,101,102,47,98,108,97,107,101,50,98,45,114,101,102,46,99,0,99,114,121,112,116,111,95,103,101,110,101,114,105,99,104,97,115,104,95,98,108,97,107,101,50,98,95,95,102,105,110,97,108,0,111,117,116,108,101,110,32,60,61,32,85,73,78,84,56,95,77,65,88,0,99,114,121,112,116,111,95,103,101,110,101,114,105,99,104,97,115,104,47,98,108,97,107,101,50,47,114,101,102,47,103,101,110,101,114,105,99,104,97,115,104,95,98,108,97,107,101,50,98,46,99,0,99,114,121,112,116,111,95,103,101,110,101,114,105,99,104,97,115,104,95,98,108,97,107,101,50,98,0,107,101,121,108,101,110,32,60,61,32,85,73,78,84,56,95,77,65,88,0,99,114,121,112,116,111,95,103,101,110,101,114,105,99,104,97,115,104,95,98,108,97,107,101,50,98,95,105,110,105,116,0,99,114,121,112,116,111,95,103,101,110,101,114,105,99,104,97,115,104,95,98,108,97,107,101,50,98,95,102,105,110,97,108,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,237,211,245,92,26,99,18,88,214,156,247,162,222,249,222,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,123,32,114,101,116,117,114,110,32,77,111,100,117,108,101,46,103,101,116,82,97,110,100,111,109,86,97,108,117,101,40,41,59,32,125,0,123,32,105,102,32,40,77,111,100,117,108,101,46,103,101,116,82,97,110,100,111,109,86,97,108,117,101,32,61,61,61,32,117,110,100,101,102,105,110,101,100,41,32,123,32,116,114,121,32,123,32,118,97,114,32,119,105,110,100,111,119,95,32,61,32,34,111,98,106,101,99,116,34,32,61,61,61,32,116,121,112,101,111,102,32,119,105,110,100,111,119,32,63,32,119,105,110,100,111,119,32,58,32,115,101,108,102,44,32,99,114,121,112,116,111,95,32,61,32,116,121,112,101,111,102,32,119,105,110,100,111,119,95,46,99,114,121,112,116,111,32,33,61,61,32,34,117,110,100,101,102,105,110,101,100,34,32,63,32,119,105,110,100,111,119,95,46,99,114,121,112,116,111,32,58,32,119,105,110,100,111,119,95,46,109,115,67,114,121,112,116,111,44,32,114,97,110,100,111,109,86,97,108,117,101,115,83,116,97,110,100,97,114,100,32,61,32,102,117,110,99,116,105,111,110,40,41,32,123,32,118,97,114,32,98,117,102,32,61,32,110,101,119,32,85,105,110,116,51,50,65,114,114,97,121,40,49,41,59,32,99,114,121,112,116,111,95,46,103,101,116,82,97,110,100,111,109,86,97,108,117,101,115,40,98,117,102,41,59,32,114,101,116,117,114,110,32,98,117,102,91,48,93,32,62,62,62,32,48,59,32,125,59,32,114,97,110,100,111,109,86,97,108,117,101,115,83,116,97,110,100,97,114,100,40,41,59,32,77,111,100,117,108,101,46,103,101,116,82,97,110,100,111,109,86,97,108,117,101,32,61,32,114,97,110,100,111,109,86,97,108,117,101,115,83,116,97,110,100,97,114,100,59,32,125,32,99,97,116,99,104,32,40,101,41,32,123,32,116,114,121,32,123,32,118,97,114,32,99,114,121,112,116,111,32,61,32,114,101,113,117,105,114,101,40,39,99,114,121,112,116,111,39,41,44,32,114,97,110,100,111,109,86,97,108,117,101,78,111,100,101,74,83,32,61,32,102,117,110,99,116,105,111,110,40,41,32,123,32,118,97,114,32,98,117,102,32,61,32,99,114,121,112,116,111,46,114,97,110,100,111,109,66,121,116,101,115,40,52,41,59,32,114,101,116,117,114,110,32,40,98,117,102,91,48,93,32,60,60,32,50,52,32,124,32,98,117,102,91,49,93,32,60,60,32,49,54,32,124,32,98,117,102,91,50,93,32,60,60,32,56,32,124,32,98,117,102,91,51,93,41,32,62,62,62,32,48,59,32,125,59,32,114,97,110,100,111,109,86,97,108,117,101,78,111,100,101,74,83,40,41,59,32,77,111,100,117,108,101,46,103,101,116,82,97,110,100,111,109,86,97,108,117,101,32,61,32,114,97,110,100,111,109,86,97,108,117,101,78,111,100,101,74,83,59,32,125,32,99,97,116,99,104,32,40,101,41,32,123,32,116,104,114,111,119,32,39,78,111,32,115,101,99,117,114,101,32,114,97,110,100,111,109,32,110,117,109,98,101,114,32,103,101,110,101,114,97,116,111,114,32,102,111,117,110,100,39,59,32,125,32,125,32,125,32,125,0,98,117,102,95,108,101,110,32,60,61,32,83,73,90,69,95,77,65,88,0,114,97,110,100,111,109,98,121,116,101,115,47,114,97,110,100,111,109,98,121,116,101,115,46,99,0,114,97,110,100,111,109,98,121,116,101,115,0,49,46,48,46,49,49,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,3,4,5,6,7,8,9,255,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,4,7,3,6,5,0,17,0,10,0,17,17,17,0,0,0,0,5,0,0,0,0,0,0,9,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,15,10,17,17,17,3,10,7,0,1,19,9,11,11,0,0,9,6,11,0,0,11,0,6,17,0,0,0,17,17,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,10,10,17,17,17,0,10,0,0,2,0,9,11,0,0,0,9,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,4,13,0,0,0,0,9,14,0,0,0,0,0,14,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,15,0,0,0,0,9,16,0,0,0,0,0,16,0,0,16,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,10,0,0,0,0,9,11,0,0,0,0,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,45,43,32,32,32,48,88,48,120,0,84,33,34,25,13,1,2,3,17,75,28,12,16,4,11,29,18,30,39,104,110,111,112,113,98,32,5,6,15,19,20,21,26,8,22,7,40,36,23,24,9,10,14,27,31,37,35,131,130,125,38,42,43,60,61,62,63,67,71,74,77,88,89,90,91,92,93,94,95,96,97,99,100,101,102,103,105,106,107,108,114,115,116,121,122,123,124,0,73,108,108,101,103,97,108,32,98,121,116,101,32,115,101,113,117,101,110,99,101,0,68,111,109,97,105,110,32,101,114,114,111,114,0,82,101,115,117,108,116,32,110,111,116,32,114,101,112,114,101,115,101,110,116,97,98,108,101,0,78,111,116,32,97,32,116,116,121,0,80,101,114,109,105,115,115,105,111,110,32,100,101,110,105,101,100,0,79,112,101,114,97,116,105,111,110,32,110,111,116,32,112,101,114,109,105,116,116,101,100,0,78,111,32,115,117,99,104,32,102,105,108,101,32,111,114,32,100,105,114,101,99,116,111,114,121,0,78,111,32,115,117,99,104,32,112,114,111,99,101,115,115,0,70,105,108,101,32,101,120,105,115,116,115,0,86,97,108,117,101,32,116,111,111,32,108,97,114,103,101,32,102,111,114,32,100,97,116,97,32,116,121,112,101,0,78,111,32,115,112,97,99,101,32,108,101,102,116,32,111,110,32,100,101,118,105,99,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,115,111,117,114,99,101,32,98,117,115,121,0,73,110,116,101,114,114,117,112,116,101,100,32,115,121,115,116,101,109,32,99,97,108,108,0,82,101,115,111,117,114,99,101,32,116,101,109,112,111,114,97,114,105,108,121,32,117,110,97,118,97,105,108,97,98,108,101,0,73,110,118,97,108,105,100,32,115,101,101,107,0,67,114,111,115,115,45,100,101,118,105,99,101,32,108,105,110,107,0,82,101,97,100,45,111,110,108,121,32,102,105,108,101,32,115,121,115,116,101,109,0,68,105,114,101,99,116,111,114,121,32,110,111,116,32,101,109,112,116,121,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,112,101,101,114,0,79,112,101,114,97,116,105,111,110,32,116,105,109,101,100,32,111,117,116,0,67,111,110,110,101,99,116,105,111,110,32,114,101,102,117,115,101,100,0,72,111,115,116,32,105,115,32,100,111,119,110,0,72,111,115,116,32,105,115,32,117,110,114,101,97,99,104,97,98,108,101,0,65,100,100,114,101,115,115,32,105,110,32,117,115,101,0,66,114,111,107,101,110,32,112,105,112,101,0,73,47,79,32,101,114,114,111,114,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,32,111,114,32,97,100,100,114,101,115,115,0,66,108,111,99,107,32,100,101,118,105,99,101,32,114,101,113,117,105,114,101,100,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,0,78,111,116,32,97,32,100,105,114,101,99,116,111,114,121,0,73,115,32,97,32,100,105,114,101,99,116,111,114,121,0,84,101,120,116,32,102,105,108,101,32,98,117,115,121,0,69,120,101,99,32,102,111,114,109,97,116,32,101,114,114,111,114,0,73,110,118,97,108,105,100,32,97,114,103,117,109,101,110,116,0,65,114,103,117,109,101,110,116,32,108,105,115,116,32,116,111,111,32,108,111,110,103,0,83,121,109,98,111,108,105,99,32,108,105,110,107,32,108,111,111,112,0,70,105,108,101,110,97,109,101,32,116,111,111,32,108,111,110,103,0,84,111,111,32,109,97,110,121,32,111,112,101,110,32,102,105,108,101,115,32,105,110,32,115,121,115,116,101,109,0,78,111,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,115,32,97,118,97,105,108,97,98,108,101,0,66,97,100,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,0,78,111,32,99,104,105,108,100,32,112,114,111,99,101,115,115,0,66,97,100,32,97,100,100,114,101,115,115,0,70,105,108,101,32,116,111,111,32,108,97,114,103,101,0,84,111,111,32,109,97,110,121,32,108,105,110,107,115,0,78,111,32,108,111,99,107,115,32,97,118,97,105,108,97,98,108,101,0,82,101,115,111,117,114,99,101,32,100,101,97,100,108,111,99,107,32,119,111,117,108,100,32,111,99,99,117,114,0,83,116,97,116,101,32,110,111,116,32,114,101,99,111,118,101,114,97,98,108,101,0,80,114,101,118,105,111,117,115,32,111,119,110,101,114,32,100,105,101,100,0,79,112,101,114,97,116,105,111,110,32,99,97,110,99,101,108,101,100,0,70,117,110,99,116,105,111,110,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,78,111,32,109,101,115,115,97,103,101,32,111,102,32,100,101,115,105,114,101,100,32,116,121,112,101,0,73,100,101,110,116,105,102,105,101,114,32,114,101,109,111,118,101,100,0,68,101,118,105,99,101,32,110,111,116,32,97,32,115,116,114,101,97,109,0,78,111,32,100,97,116,97,32,97,118,97,105,108,97,98,108,101,0,68,101,118,105,99,101,32,116,105,109,101,111,117,116,0,79,117,116,32,111,102,32,115,116,114,101,97,109,115,32,114,101,115,111,117,114,99,101,115,0,76,105,110,107,32,104,97,115,32,98,101,101,110,32,115,101,118,101,114,101,100,0,80,114,111,116,111,99,111,108,32,101,114,114,111,114,0,66,97,100,32,109,101,115,115,97,103,101,0,70,105,108,101,32,100,101,115,99,114,105,112,116,111,114,32,105,110,32,98,97,100,32,115,116,97,116,101,0,78,111,116,32,97,32,115,111,99,107,101,116,0,68,101,115,116,105,110,97,116,105,111,110,32,97,100,100,114,101,115,115,32,114,101,113,117,105,114,101,100,0,77,101,115,115,97,103,101,32,116,111,111,32,108,97,114,103,101,0,80,114,111,116,111,99,111,108,32,119,114,111,110,103,32,116,121,112,101,32,102,111,114,32,115,111,99,107,101,116,0,80,114,111,116,111,99,111,108,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,80,114,111,116,111,99,111,108,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,83,111,99,107,101,116,32,116,121,112,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,111,116,32,115,117,112,112,111,114,116,101,100,0,80,114,111,116,111,99,111,108,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,65,100,100,114,101,115,115,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,112,114,111,116,111,99,111,108,0,65,100,100,114,101,115,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,78,101,116,119,111,114,107,32,105,115,32,100,111,119,110,0,78,101,116,119,111,114,107,32,117,110,114,101,97,99,104,97,98,108,101,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,110,101,116,119,111,114,107,0,67,111,110,110,101,99,116,105,111,110,32,97,98,111,114,116,101,100,0,78,111,32,98,117,102,102,101,114,32,115,112,97,99,101,32,97,118,97,105,108,97,98,108,101,0,83,111,99,107,101,116,32,105,115,32,99,111,110,110,101,99,116,101,100,0,83,111,99,107,101,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,67,97,110,110,111,116,32,115,101,110,100,32,97,102,116,101,114,32,115,111,99,107,101,116,32,115,104,117,116,100,111,119,110,0,79,112,101,114,97,116,105,111,110,32,97,108,114,101,97,100,121,32,105,110,32,112,114,111,103,114,101,115,115,0,79,112,101,114,97,116,105,111,110,32,105,110,32,112,114,111,103,114,101,115,115,0,83,116,97,108,101,32,102,105,108,101,32,104,97,110,100,108,101,0,82,101,109,111,116,101,32,73,47,79,32,101,114,114,111,114,0,81,117,111,116,97,32,101,120,99,101,101,100,101,100,0,78,111,32,109,101,100,105,117,109,32,102,111,117,110,100,0,87,114,111,110,103,32,109,101,100,105,117,109,32,116,121,112,101,0,78,111,32,101,114,114,111,114,32,105,110,102,111,114,109,97,116,105,111,110,0,0,40,110,117,108,108,41,0,45,48,88,43,48,88,32,48,88,45,48,120,43,48,120,32,48,120,0,105,110,102,0,73,78,70,0,78,65,78,0,105,110,102,105,110,105,116,121,0,110,97,110,0,80,79,83,73,88,0,46,0,78,83,116,51,95,95,50,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,56,105,111,115,95,98,97,115,101,69,0,78,83,116,51,95,95,50,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,78,83,116,51,95,95,50,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,105,111,115,116,114,101,97,109,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,50,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,78,83,116,51,95,95,50,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,78,83,116,51,95,95,50,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,78,83,116,51,95,95,50,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,78,83,116,51,95,95,50,55,99,111,108,108,97,116,101,73,99,69,69,0,78,83,116,51,95,95,50,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,78,83,116,51,95,95,50,55,99,111,108,108,97,116,101,73,119,69,69,0,78,83,116,51,95,95,50,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,78,83,116,51,95,95,50,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,48],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+36540);allocate([49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,67,0,37,112,0,78,83,116,51,95,95,50,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,78,83,116,51,95,95,50,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,78,83,116,51,95,95,50,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,37,0,0,0,0,0,108,0,108,108,0,76,0,37,112,0,0,0,0,78,83,116,51,95,95,50,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,116,105,109,101,95,98,97,115,101,69,0,78,83,116,51,95,95,50,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,37,72,58,37,77,37,72,58,37,77,58,37,83,83,117,110,100,97,121,0,77,111,110,100,97,121,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,84,104,117,114,115,100,97,121,0,70,114,105,100,97,121,0,83,97,116,117,114,100,97,121,0,83,117,110,0,77,111,110,0,84,117,101,0,87,101,100,0,84,104,117,0,70,114,105,0,83,97,116,0,74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,77,97,114,99,104,0,65,112,114,105,108,0,77,97,121,0,74,117,110,101,0,74,117,108,121,0,65,117,103,117,115,116,0,83,101,112,116,101,109,98,101,114,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,68,101,99,101,109,98,101,114,0,74,97,110,0,70,101,98,0,77,97,114,0,65,112,114,0,74,117,110,0,74,117,108,0,65,117,103,0,83,101,112,0,79,99,116,0,78,111,118,0,68,101,99,0,65,77,0,80,77,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,37,73,58,37,77,58,37,83,32,37,112,0,37,109,47,37,100,47,37,121,0,37,72,58,37,77,58,37,83,0,78,83,116,51,95,95,50,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,48,95,95,116,105,109,101,95,112,117,116,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,48,49,50,51,52,53,54,55,56,57,0,37,76,102,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,48,49,50,51,52,53,54,55,56,57,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,37,46,48,76,102,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,78,83,116,51,95,95,50,56,109,101,115,115,97,103,101,115,73,99,69,69,0,78,83,116,51,95,95,50,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,78,83,116,51,95,95,50,56,109,101,115,115,97,103,101,115,73,119,69,69,0,78,83,116,51,95,95,50,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,78,83,116,51,95,95,50,53,99,116,121,112,101,73,99,69,69,0,78,83,116,51,95,95,50,49,48,99,116,121,112,101,95,98,97,115,101,69,0,78,83,116,51,95,95,50,53,99,116,121,112,101,73,119,69,69,0,78,83,116,51,95,95,50,56,110,117,109,112,117,110,99,116,73,99,69,69,0,116,114,117,101,0,102,97,108,115,101,0,78,83,116,51,95,95,50,56,110,117,109,112,117,110,99,116,73,119,69,69,0,118,101,99,116,111,114,0,78,83,116,51,95,95,50,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,98,97,115,105,99,95,115,116,114,105,110,103,0,78,83,116,51,95,95,50,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,78,83,116,51,95,95,50,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,78,83,116,51,95,95,50,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,58,32,0,99,97,110,110,111,116,32,122,101,114,111,32,111,117,116,32,116,104,114,101,97,100,32,118,97,108,117,101,32,102,111,114,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,40,41,0,99,97,110,110,111,116,32,99,114,101,97,116,101,32,112,116,104,114,101,97,100,32,107,101,121,32,102,111,114,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,40,41,0,112,116,104,114,101,97,100,95,111,110,99,101,32,102,97,105,108,117,114,101,32,105,110,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,95,102,97,115,116,40,41,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,83,116,57,116,121,112,101,95,105,110,102,111,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,83,116,57,101,120,99,101,112,116,105,111,110,0,117,110,99,97,117,103,104,116,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,101,120,99,101,112,116,105,111,110,32,111,102,32,116,121,112,101,32,37,115,58,32,37,115,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,101,120,99,101,112,116,105,111,110,32,111,102,32,116,121,112,101,32,37,115,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,102,111,114,101,105,103,110,32,101,120,99,101,112,116,105,111,110,0,116,101,114,109,105,110,97,116,105,110,103,0,116,101,114,109,105,110,97,116,101,95,104,97,110,100,108,101,114,32,117,110,101,120,112,101,99,116,101,100,108,121,32,114,101,116,117,114,110,101,100,0,116,101,114,109,105,110,97,116,101,95,104,97,110,100,108,101,114,32,117,110,101,120,112,101,99,116,101,100,108,121,32,116,104,114,101,119,32,97,110,32,101,120,99,101,112,116,105,111,110,0,83,116,57,98,97,100,95,97,108,108,111,99,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,83,116,56,98,97,100,95,99,97,115,116,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+46780);var tempDoublePtr=STATICTOP;STATICTOP+=16;function _atexit(func,arg){__ATEXIT__.unshift({func:func,arg:arg})}function ___cxa_atexit(){return _atexit.apply(null,arguments)}Module["_i64Subtract"]=_i64Subtract;function ___setErrNo(value){if(Module["___errno_location"])HEAP32[Module["___errno_location"]()>>2]=value;return value}var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};function _sysconf(name){switch(name){case 30:return PAGE_SIZE;case 85:return totalMemory/PAGE_SIZE;case 132:case 133:case 12:case 137:case 138:case 15:case 235:case 16:case 17:case 18:case 19:case 20:case 149:case 13:case 10:case 236:case 153:case 9:case 21:case 22:case 159:case 154:case 14:case 77:case 78:case 139:case 80:case 81:case 82:case 68:case 67:case 164:case 11:case 29:case 47:case 48:case 95:case 52:case 51:case 46:return 200809;case 79:return 0;case 27:case 246:case 127:case 128:case 23:case 24:case 160:case 161:case 181:case 182:case 242:case 183:case 184:case 243:case 244:case 245:case 165:case 178:case 179:case 49:case 50:case 168:case 169:case 175:case 170:case 171:case 172:case 97:case 76:case 32:case 173:case 35:return-1;case 176:case 177:case 7:case 155:case 8:case 157:case 125:case 126:case 92:case 93:case 129:case 130:case 131:case 94:case 91:return 1;case 74:case 60:case 69:case 70:case 4:return 1024;case 31:case 42:case 72:return 32;case 87:case 26:case 33:return 2147483647;case 34:case 1:return 47839;case 38:case 36:return 99;case 43:case 37:return 2048;case 0:return 2097152;case 3:return 65536;case 28:return 32768;case 44:return 32767;case 75:return 16384;case 39:return 1e3;case 89:return 700;case 71:return 256;case 40:return 255;case 2:return 100;case 180:return 64;case 25:return 20;case 5:return 16;case 6:return 6;case 73:return 4;case 84:{if(typeof navigator==="object")return navigator["hardwareConcurrency"]||1;return 1}}___setErrNo(ERRNO_CODES.EINVAL);return-1}function __ZSt18uncaught_exceptionv(){return!!__ZSt18uncaught_exceptionv.uncaught_exception}var EXCEPTIONS={last:0,caught:[],infos:{},deAdjust:(function(adjusted){if(!adjusted||EXCEPTIONS.infos[adjusted])return adjusted;for(var ptr in EXCEPTIONS.infos){var info=EXCEPTIONS.infos[ptr];if(info.adjusted===adjusted){return ptr}}return adjusted}),addRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];info.refcount++}),decRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];assert(info.refcount>0);info.refcount--;if(info.refcount===0){if(info.destructor){Runtime.dynCall("vi",info.destructor,[ptr])}delete EXCEPTIONS.infos[ptr];___cxa_free_exception(ptr)}}),clearRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];info.refcount=0})};function ___resumeException(ptr){if(!EXCEPTIONS.last){EXCEPTIONS.last=ptr}EXCEPTIONS.clearRef(EXCEPTIONS.deAdjust(ptr));throw ptr}function ___cxa_find_matching_catch(){var thrown=EXCEPTIONS.last;if(!thrown){return(asm["setTempRet0"](0),0)|0}var info=EXCEPTIONS.infos[thrown];var throwntype=info.type;if(!throwntype){return(asm["setTempRet0"](0),thrown)|0}var typeArray=Array.prototype.slice.call(arguments);var pointer=Module["___cxa_is_pointer_type"](throwntype);if(!___cxa_find_matching_catch.buffer)___cxa_find_matching_catch.buffer=_malloc(4);HEAP32[___cxa_find_matching_catch.buffer>>2]=thrown;thrown=___cxa_find_matching_catch.buffer;for(var i=0;i<typeArray.length;i++){if(typeArray[i]&&Module["___cxa_can_catch"](typeArray[i],throwntype,thrown)){thrown=HEAP32[thrown>>2];info.adjusted=thrown;return(asm["setTempRet0"](typeArray[i]),thrown)|0}}thrown=HEAP32[thrown>>2];return(asm["setTempRet0"](throwntype),thrown)|0}function ___cxa_throw(ptr,type,destructor){EXCEPTIONS.infos[ptr]={ptr:ptr,adjusted:ptr,type:type,destructor:destructor,refcount:0};EXCEPTIONS.last=ptr;if(!("uncaught_exception"in __ZSt18uncaught_exceptionv)){__ZSt18uncaught_exceptionv.uncaught_exception=1}else{__ZSt18uncaught_exceptionv.uncaught_exception++}throw ptr}Module["_memset"]=_memset;Module["_pthread_mutex_lock"]=_pthread_mutex_lock;function __isLeapYear(year){return year%4===0&&(year%100!==0||year%400===0)}function __arraySum(array,index){var sum=0;for(var i=0;i<=index;sum+=array[i++]);return sum}var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date,days){var newDate=new Date(date.getTime());while(days>0){var leap=__isLeapYear(newDate.getFullYear());var currentMonth=newDate.getMonth();var daysInCurrentMonth=(leap?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR)[currentMonth];if(days>daysInCurrentMonth-newDate.getDate()){days-=daysInCurrentMonth-newDate.getDate()+1;newDate.setDate(1);if(currentMonth<11){newDate.setMonth(currentMonth+1)}else{newDate.setMonth(0);newDate.setFullYear(newDate.getFullYear()+1)}}else{newDate.setDate(newDate.getDate()+days);return newDate}}return newDate}function _strftime(s,maxsize,format,tm){var tm_zone=HEAP32[tm+40>>2];var date={tm_sec:HEAP32[tm>>2],tm_min:HEAP32[tm+4>>2],tm_hour:HEAP32[tm+8>>2],tm_mday:HEAP32[tm+12>>2],tm_mon:HEAP32[tm+16>>2],tm_year:HEAP32[tm+20>>2],tm_wday:HEAP32[tm+24>>2],tm_yday:HEAP32[tm+28>>2],tm_isdst:HEAP32[tm+32>>2],tm_gmtoff:HEAP32[tm+36>>2],tm_zone:tm_zone?Pointer_stringify(tm_zone):""};var pattern=Pointer_stringify(format);var EXPANSION_RULES_1={"%c":"%a %b %d %H:%M:%S %Y","%D":"%m/%d/%y","%F":"%Y-%m-%d","%h":"%b","%r":"%I:%M:%S %p","%R":"%H:%M","%T":"%H:%M:%S","%x":"%m/%d/%y","%X":"%H:%M:%S"};for(var rule in EXPANSION_RULES_1){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_1[rule])}var WEEKDAYS=["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];var MONTHS=["January","February","March","April","May","June","July","August","September","October","November","December"];function leadingSomething(value,digits,character){var str=typeof value==="number"?value.toString():value||"";while(str.length<digits){str=character[0]+str}return str}function leadingNulls(value,digits){return leadingSomething(value,digits,"0")}function compareByDay(date1,date2){function sgn(value){return value<0?-1:value>0?1:0}var compare;if((compare=sgn(date1.getFullYear()-date2.getFullYear()))===0){if((compare=sgn(date1.getMonth()-date2.getMonth()))===0){compare=sgn(date1.getDate()-date2.getDate())}}return compare}function getFirstWeekStartDate(janFourth){switch(janFourth.getDay()){case 0:return new Date(janFourth.getFullYear()-1,11,29);case 1:return janFourth;case 2:return new Date(janFourth.getFullYear(),0,3);case 3:return new Date(janFourth.getFullYear(),0,2);case 4:return new Date(janFourth.getFullYear(),0,1);case 5:return new Date(janFourth.getFullYear()-1,11,31);case 6:return new Date(janFourth.getFullYear()-1,11,30)}}function getWeekBasedYear(date){var thisDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);var janFourthThisYear=new Date(thisDate.getFullYear(),0,4);var janFourthNextYear=new Date(thisDate.getFullYear()+1,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);if(compareByDay(firstWeekStartThisYear,thisDate)<=0){if(compareByDay(firstWeekStartNextYear,thisDate)<=0){return thisDate.getFullYear()+1}else{return thisDate.getFullYear()}}else{return thisDate.getFullYear()-1}}var EXPANSION_RULES_2={"%a":(function(date){return WEEKDAYS[date.tm_wday].substring(0,3)}),"%A":(function(date){return WEEKDAYS[date.tm_wday]}),"%b":(function(date){return MONTHS[date.tm_mon].substring(0,3)}),"%B":(function(date){return MONTHS[date.tm_mon]}),"%C":(function(date){var year=date.tm_year+1900;return leadingNulls(year/100|0,2)}),"%d":(function(date){return leadingNulls(date.tm_mday,2)}),"%e":(function(date){return leadingSomething(date.tm_mday,2," ")}),"%g":(function(date){return getWeekBasedYear(date).toString().substring(2)}),"%G":(function(date){return getWeekBasedYear(date)}),"%H":(function(date){return leadingNulls(date.tm_hour,2)}),"%I":(function(date){var twelveHour=date.tm_hour;if(twelveHour==0)twelveHour=12;else if(twelveHour>12)twelveHour-=12;return leadingNulls(twelveHour,2)}),"%j":(function(date){return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900)?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,date.tm_mon-1),3)}),"%m":(function(date){return leadingNulls(date.tm_mon+1,2)}),"%M":(function(date){return leadingNulls(date.tm_min,2)}),"%n":(function(){return"\n"}),"%p":(function(date){if(date.tm_hour>=0&&date.tm_hour<12){return"AM"}else{return"PM"}}),"%S":(function(date){return leadingNulls(date.tm_sec,2)}),"%t":(function(){return"\t"}),"%u":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()||7}),"%U":(function(date){var janFirst=new Date(date.tm_year+1900,0,1);var firstSunday=janFirst.getDay()===0?janFirst:__addDays(janFirst,7-janFirst.getDay());var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstSunday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstSundayUntilEndJanuary=31-firstSunday.getDate();var days=firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstSunday,janFirst)===0?"01":"00"}),"%V":(function(date){var janFourthThisYear=new Date(date.tm_year+1900,0,4);var janFourthNextYear=new Date(date.tm_year+1901,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);var endDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);if(compareByDay(endDate,firstWeekStartThisYear)<0){return"53"}if(compareByDay(firstWeekStartNextYear,endDate)<=0){return"01"}var daysDifference;if(firstWeekStartThisYear.getFullYear()<date.tm_year+1900){daysDifference=date.tm_yday+32-firstWeekStartThisYear.getDate()}else{daysDifference=date.tm_yday+1-firstWeekStartThisYear.getDate()}return leadingNulls(Math.ceil(daysDifference/7),2)}),"%w":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()}),"%W":(function(date){var janFirst=new Date(date.tm_year,0,1);var firstMonday=janFirst.getDay()===1?janFirst:__addDays(janFirst,janFirst.getDay()===0?1:7-janFirst.getDay()+1);var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstMonday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstMondayUntilEndJanuary=31-firstMonday.getDate();var days=firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstMonday,janFirst)===0?"01":"00"}),"%y":(function(date){return(date.tm_year+1900).toString().substring(2)}),"%Y":(function(date){return date.tm_year+1900}),"%z":(function(date){var off=date.tm_gmtoff;var ahead=off>=0;off=Math.abs(off)/60;off=off/60*100+off%60;return(ahead?"+":"-")+String("0000"+off).slice(-4)}),"%Z":(function(date){return date.tm_zone}),"%%":(function(){return"%"})};for(var rule in EXPANSION_RULES_2){if(pattern.indexOf(rule)>=0){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_2[rule](date))}}var bytes=intArrayFromString(pattern,false);if(bytes.length>maxsize){return 0}writeArrayToMemory(bytes,s);return bytes.length-1}function _strftime_l(s,maxsize,format,tm){return _strftime(s,maxsize,format,tm)}function _abort(){Module["abort"]()}function _free(){}Module["_free"]=_free;function ___cxa_free_exception(ptr){try{return _free(ptr)}catch(e){}}function ___cxa_end_catch(){if(___cxa_end_catch.rethrown){___cxa_end_catch.rethrown=false;return}asm["setThrew"](0);var ptr=EXCEPTIONS.caught.pop();if(ptr){EXCEPTIONS.decRef(EXCEPTIONS.deAdjust(ptr));EXCEPTIONS.last=0}}function _pthread_once(ptr,func){if(!_pthread_once.seen)_pthread_once.seen={};if(ptr in _pthread_once.seen)return;Runtime.dynCall("v",func);_pthread_once.seen[ptr]=1}function ___lock(){}function ___unlock(){}var PTHREAD_SPECIFIC={};function _pthread_getspecific(key){return PTHREAD_SPECIFIC[key]||0}var _llvm_fabs_f64=Math_abs;function ___assert_fail(condition,filename,line,func){ABORT=true;throw"Assertion failed: "+Pointer_stringify(condition)+", at: "+[filename?Pointer_stringify(filename):"unknown filename",line,func?Pointer_stringify(func):"unknown function"]+" at "+stackTrace()}var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key,destructor){if(key==0){return ERRNO_CODES.EINVAL}HEAP32[key>>2]=PTHREAD_SPECIFIC_NEXT_KEY;PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY]=0;PTHREAD_SPECIFIC_NEXT_KEY++;return 0}function _pthread_setspecific(key,value){if(!(key in PTHREAD_SPECIFIC)){return ERRNO_CODES.EINVAL}PTHREAD_SPECIFIC[key]=value;return 0}function _malloc(bytes){var ptr=Runtime.dynamicAlloc(bytes+8);return ptr+8&4294967288}Module["_malloc"]=_malloc;function ___cxa_allocate_exception(size){return _malloc(size)}var SYSCALLS={varargs:0,get:(function(varargs){SYSCALLS.varargs+=4;var ret=HEAP32[SYSCALLS.varargs-4>>2];return ret}),getStr:(function(){var ret=Pointer_stringify(SYSCALLS.get());return ret}),get64:(function(){var low=SYSCALLS.get(),high=SYSCALLS.get();if(low>=0)assert(high===0);else assert(high===-1);return low}),getZero:(function(){assert(SYSCALLS.get()===0)})};function ___syscall54(which,varargs){SYSCALLS.varargs=varargs;try{return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}Module["_bitshift64Ashr"]=_bitshift64Ashr;Module["_bitshift64Lshr"]=_bitshift64Lshr;function _pthread_cleanup_push(routine,arg){__ATEXIT__.push((function(){Runtime.dynCall("vi",routine,[arg])}));_pthread_cleanup_push.level=__ATEXIT__.length}Module["_pthread_cond_broadcast"]=_pthread_cond_broadcast;function _pthread_cleanup_pop(){assert(_pthread_cleanup_push.level==__ATEXIT__.length,"cannot pop if something else added meanwhile!");__ATEXIT__.pop();_pthread_cleanup_push.level=__ATEXIT__.length}Module["_i64Add"]=_i64Add;function ___cxa_find_matching_catch_2(){return ___cxa_find_matching_catch.apply(null,arguments)}function ___cxa_find_matching_catch_3(){return ___cxa_find_matching_catch.apply(null,arguments)}Module["_pthread_mutex_unlock"]=_pthread_mutex_unlock;Module["_bitshift64Shl"]=_bitshift64Shl;function _emscripten_memcpy_big(dest,src,num){HEAPU8.set(HEAPU8.subarray(src,src+num),dest);return dest}Module["_memcpy"]=_memcpy;function ___syscall6(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD();FS.close(stream);return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}var cttz_i8=allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0],"i8",ALLOC_STATIC);Module["_llvm_cttz_i32"]=_llvm_cttz_i32;Module["___udivmoddi4"]=___udivmoddi4;Module["___udivdi3"]=___udivdi3;Module["___muldsi3"]=___muldsi3;Module["___muldi3"]=___muldi3;function _sbrk(bytes){var self=_sbrk;if(!self.called){DYNAMICTOP=alignMemoryPage(DYNAMICTOP);self.called=true;assert(Runtime.dynamicAlloc);self.alloc=Runtime.dynamicAlloc;Runtime.dynamicAlloc=(function(){abort("cannot dynamically allocate, sbrk now has control")})}var ret=DYNAMICTOP;if(bytes!=0){var success=self.alloc(bytes);if(!success)return-1>>>0}return ret}Module["_memmove"]=_memmove;function ___cxa_begin_catch(ptr){__ZSt18uncaught_exceptionv.uncaught_exception--;EXCEPTIONS.caught.push(ptr);EXCEPTIONS.addRef(EXCEPTIONS.deAdjust(ptr));return ptr}function ___gxx_personality_v0(){}Module["___uremdi3"]=___uremdi3;function _pthread_cond_wait(){return 0}function ___cxa_rethrow(){___cxa_end_catch.rethrown=true;var ptr=EXCEPTIONS.caught.pop();EXCEPTIONS.last=ptr;throw ptr}Module["_pthread_self"]=_pthread_self;function ___syscall140(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),offset_high=SYSCALLS.get(),offset_low=SYSCALLS.get(),result=SYSCALLS.get(),whence=SYSCALLS.get();var offset=offset_low;assert(offset_high===0);FS.llseek(stream,offset,whence);HEAP32[result>>2]=stream.position;if(stream.getdents&&offset===0&&whence===0)stream.getdents=null;return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall146(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.get(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();var ret=0;if(!___syscall146.buffer){___syscall146.buffers=[null,[],[]];___syscall146.printChar=(function(stream,curr){var buffer=___syscall146.buffers[stream];assert(buffer);if(curr===0||curr===10){(stream===1?Module["print"]:Module["printErr"])(UTF8ArrayToString(buffer,0));buffer.length=0}else{buffer.push(curr)}})}for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];for(var j=0;j<len;j++){___syscall146.printChar(stream,HEAPU8[ptr+j])}ret+=len}return ret}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall145(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();return SYSCALLS.doReadv(stream,iov,iovcnt)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}var ___dso_handle=STATICTOP;STATICTOP+=16;__ATEXIT__.push((function(){var fflush=Module["_fflush"];if(fflush)fflush(0);var printChar=___syscall146.printChar;if(!printChar)return;var buffers=___syscall146.buffers;if(buffers[1].length)printChar(1,10);if(buffers[2].length)printChar(2,10)}));STACK_BASE=STACKTOP=Runtime.alignMemory(STATICTOP);staticSealed=true;STACK_MAX=STACK_BASE+TOTAL_STACK;DYNAMIC_BASE=DYNAMICTOP=Runtime.alignMemory(STACK_MAX);function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7){return Runtime.functionPointers[index](a1,a2,a3,a4,a5,a6,a7)}function invoke_viiiii(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_viiiii(index,a1,a2,a3,a4,a5){Runtime.functionPointers[index](a1,a2,a3,a4,a5)}function invoke_iiiiiid(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiiid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiiiiid(index,a1,a2,a3,a4,a5,a6){return Runtime.functionPointers[index](a1,a2,a3,a4,a5,a6)}function invoke_vi(index,a1){try{Module["dynCall_vi"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_vi(index,a1){Runtime.functionPointers[index](a1)}function invoke_vii(index,a1,a2){try{Module["dynCall_vii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_vii(index,a1,a2){Runtime.functionPointers[index](a1,a2)}function invoke_iiiiiii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiiiiii(index,a1,a2,a3,a4,a5,a6){return Runtime.functionPointers[index](a1,a2,a3,a4,a5,a6)}function invoke_ii(index,a1){try{return Module["dynCall_ii"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_ii(index,a1){return Runtime.functionPointers[index](a1)}function invoke_iiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{return Module["dynCall_iiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){return Runtime.functionPointers[index](a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}function invoke_iiii(index,a1,a2,a3){try{return Module["dynCall_iiii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiii(index,a1,a2,a3){return Runtime.functionPointers[index](a1,a2,a3)}function invoke_viiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15){try{Module["dynCall_viiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_viiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15){Runtime.functionPointers[index](a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15)}function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_viiiiii(index,a1,a2,a3,a4,a5,a6){Runtime.functionPointers[index](a1,a2,a3,a4,a5,a6)}function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7){Runtime.functionPointers[index](a1,a2,a3,a4,a5,a6,a7)}function invoke_viiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_viiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){Runtime.functionPointers[index](a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}function invoke_iii(index,a1,a2){try{return Module["dynCall_iii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iii(index,a1,a2){return Runtime.functionPointers[index](a1,a2)}function invoke_iiiiii(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiiiii(index,a1,a2,a3,a4,a5){return Runtime.functionPointers[index](a1,a2,a3,a4,a5)}function invoke_i(index){try{return Module["dynCall_i"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_i(index){return Runtime.functionPointers[index]()}function invoke_iiiii(index,a1,a2,a3,a4){try{return Module["dynCall_iiiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiiii(index,a1,a2,a3,a4){return Runtime.functionPointers[index](a1,a2,a3,a4)}function invoke_viii(index,a1,a2,a3){try{Module["dynCall_viii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_viii(index,a1,a2,a3){Runtime.functionPointers[index](a1,a2,a3)}function invoke_v(index){try{Module["dynCall_v"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_v(index){Runtime.functionPointers[index]()}function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){return Runtime.functionPointers[index](a1,a2,a3,a4,a5,a6,a7,a8)}function invoke_iiiiid(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiiiid(index,a1,a2,a3,a4,a5){return Runtime.functionPointers[index](a1,a2,a3,a4,a5)}function invoke_viiii(index,a1,a2,a3,a4){try{Module["dynCall_viiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_viiii(index,a1,a2,a3,a4){Runtime.functionPointers[index](a1,a2,a3,a4)}Module.asmGlobalArg={"Math":Math,"Int8Array":Int8Array,"Int16Array":Int16Array,"Int32Array":Int32Array,"Uint8Array":Uint8Array,"Uint16Array":Uint16Array,"Uint32Array":Uint32Array,"Float32Array":Float32Array,"Float64Array":Float64Array,"NaN":NaN,"Infinity":Infinity};Module.asmLibraryArg={"abort":abort,"assert":assert,"invoke_iiiiiiii":invoke_iiiiiiii,"jsCall_iiiiiiii":jsCall_iiiiiiii,"invoke_viiiii":invoke_viiiii,"jsCall_viiiii":jsCall_viiiii,"invoke_iiiiiid":invoke_iiiiiid,"jsCall_iiiiiid":jsCall_iiiiiid,"invoke_vi":invoke_vi,"jsCall_vi":jsCall_vi,"invoke_vii":invoke_vii,"jsCall_vii":jsCall_vii,"invoke_iiiiiii":invoke_iiiiiii,"jsCall_iiiiiii":jsCall_iiiiiii,"invoke_ii":invoke_ii,"jsCall_ii":jsCall_ii,"invoke_iiiiiiiiiiii":invoke_iiiiiiiiiiii,"jsCall_iiiiiiiiiiii":jsCall_iiiiiiiiiiii,"invoke_iiii":invoke_iiii,"jsCall_iiii":jsCall_iiii,"invoke_viiiiiiiiiiiiiii":invoke_viiiiiiiiiiiiiii,"jsCall_viiiiiiiiiiiiiii":jsCall_viiiiiiiiiiiiiii,"invoke_viiiiii":invoke_viiiiii,"jsCall_viiiiii":jsCall_viiiiii,"invoke_viiiiiii":invoke_viiiiiii,"jsCall_viiiiiii":jsCall_viiiiiii,"invoke_viiiiiiiiii":invoke_viiiiiiiiii,"jsCall_viiiiiiiiii":jsCall_viiiiiiiiii,"invoke_iii":invoke_iii,"jsCall_iii":jsCall_iii,"invoke_iiiiii":invoke_iiiiii,"jsCall_iiiiii":jsCall_iiiiii,"invoke_i":invoke_i,"jsCall_i":jsCall_i,"invoke_iiiii":invoke_iiiii,"jsCall_iiiii":jsCall_iiiii,"invoke_viii":invoke_viii,"jsCall_viii":jsCall_viii,"invoke_v":invoke_v,"jsCall_v":jsCall_v,"invoke_iiiiiiiii":invoke_iiiiiiiii,"jsCall_iiiiiiiii":jsCall_iiiiiiiii,"invoke_iiiiid":invoke_iiiiid,"jsCall_iiiiid":jsCall_iiiiid,"invoke_viiii":invoke_viiii,"jsCall_viiii":jsCall_viiii,"_pthread_cleanup_pop":_pthread_cleanup_pop,"_strftime":_strftime,"_pthread_cond_wait":_pthread_cond_wait,"___lock":___lock,"___resumeException":___resumeException,"_pthread_key_create":_pthread_key_create,"_abort":_abort,"_llvm_fabs_f64":_llvm_fabs_f64,"___gxx_personality_v0":___gxx_personality_v0,"___assert_fail":___assert_fail,"___cxa_free_exception":___cxa_free_exception,"___cxa_find_matching_catch_2":___cxa_find_matching_catch_2,"___cxa_find_matching_catch_3":___cxa_find_matching_catch_3,"_emscripten_asm_const_i":_emscripten_asm_const_i,"__addDays":__addDays,"_strftime_l":_strftime_l,"___setErrNo":___setErrNo,"_sbrk":_sbrk,"___cxa_allocate_exception":___cxa_allocate_exception,"_emscripten_memcpy_big":_emscripten_memcpy_big,"___cxa_end_catch":___cxa_end_catch,"_emscripten_asm_const_v":_emscripten_asm_const_v,"__ZSt18uncaught_exceptionv":__ZSt18uncaught_exceptionv,"_sysconf":_sysconf,"___cxa_begin_catch":___cxa_begin_catch,"_pthread_getspecific":_pthread_getspecific,"__arraySum":__arraySum,"_pthread_once":_pthread_once,"___syscall54":___syscall54,"___unlock":___unlock,"__isLeapYear":__isLeapYear,"_pthread_setspecific":_pthread_setspecific,"___cxa_atexit":___cxa_atexit,"___cxa_throw":___cxa_throw,"___cxa_rethrow":___cxa_rethrow,"___syscall6":___syscall6,"_pthread_cleanup_push":_pthread_cleanup_push,"_atexit":_atexit,"___syscall140":___syscall140,"___cxa_find_matching_catch":___cxa_find_matching_catch,"___syscall145":___syscall145,"___syscall146":___syscall146,"STACKTOP":STACKTOP,"STACK_MAX":STACK_MAX,"tempDoublePtr":tempDoublePtr,"ABORT":ABORT,"cttz_i8":cttz_i8,"___dso_handle":___dso_handle};// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer) {
"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.___dso_handle|0;var o=0;var p=0;var q=0;var r=0;var s=global.NaN,t=global.Infinity;var u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;var D=0;var E=global.Math.floor;var F=global.Math.abs;var G=global.Math.sqrt;var H=global.Math.pow;var I=global.Math.cos;var J=global.Math.sin;var K=global.Math.tan;var L=global.Math.acos;var M=global.Math.asin;var N=global.Math.atan;var O=global.Math.atan2;var P=global.Math.exp;var Q=global.Math.log;var R=global.Math.ceil;var S=global.Math.imul;var T=global.Math.min;var U=global.Math.clz32;var V=env.abort;var W=env.assert;var X=env.invoke_iiiiiiii;var Y=env.jsCall_iiiiiiii;var Z=env.invoke_viiiii;var _=env.jsCall_viiiii;var $=env.invoke_iiiiiid;var aa=env.jsCall_iiiiiid;var ba=env.invoke_vi;var ca=env.jsCall_vi;var da=env.invoke_vii;var ea=env.jsCall_vii;var fa=env.invoke_iiiiiii;var ga=env.jsCall_iiiiiii;var ha=env.invoke_ii;var ia=env.jsCall_ii;var ja=env.invoke_iiiiiiiiiiii;var ka=env.jsCall_iiiiiiiiiiii;var la=env.invoke_iiii;var ma=env.jsCall_iiii;var na=env.invoke_viiiiiiiiiiiiiii;var oa=env.jsCall_viiiiiiiiiiiiiii;var pa=env.invoke_viiiiii;var qa=env.jsCall_viiiiii;var ra=env.invoke_viiiiiii;var sa=env.jsCall_viiiiiii;var ta=env.invoke_viiiiiiiiii;var ua=env.jsCall_viiiiiiiiii;var va=env.invoke_iii;var wa=env.jsCall_iii;var xa=env.invoke_iiiiii;var ya=env.jsCall_iiiiii;var za=env.invoke_i;var Aa=env.jsCall_i;var Ba=env.invoke_iiiii;var Ca=env.jsCall_iiiii;var Da=env.invoke_viii;var Ea=env.jsCall_viii;var Fa=env.invoke_v;var Ga=env.jsCall_v;var Ha=env.invoke_iiiiiiiii;var Ia=env.jsCall_iiiiiiiii;var Ja=env.invoke_iiiiid;var Ka=env.jsCall_iiiiid;var La=env.invoke_viiii;var Ma=env.jsCall_viiii;var Na=env._pthread_cleanup_pop;var Oa=env._strftime;var Pa=env._pthread_cond_wait;var Qa=env.___lock;var Ra=env.___resumeException;var Sa=env._pthread_key_create;var Ta=env._abort;var Ua=env._llvm_fabs_f64;var Va=env.___gxx_personality_v0;var Wa=env.___assert_fail;var Xa=env.___cxa_free_exception;var Ya=env.___cxa_find_matching_catch_2;var Za=env.___cxa_find_matching_catch_3;var _a=env._emscripten_asm_const_i;var $a=env.__addDays;var ab=env._strftime_l;var bb=env.___setErrNo;var cb=env._sbrk;var db=env.___cxa_allocate_exception;var eb=env._emscripten_memcpy_big;var fb=env.___cxa_end_catch;var gb=env._emscripten_asm_const_v;var hb=env.__ZSt18uncaught_exceptionv;var ib=env._sysconf;var jb=env.___cxa_begin_catch;var kb=env._pthread_getspecific;var lb=env.__arraySum;var mb=env._pthread_once;var nb=env.___syscall54;var ob=env.___unlock;var pb=env.__isLeapYear;var qb=env._pthread_setspecific;var rb=env.___cxa_atexit;var sb=env.___cxa_throw;var tb=env.___cxa_rethrow;var ub=env.___syscall6;var vb=env._pthread_cleanup_push;var wb=env._atexit;var xb=env.___syscall140;var yb=env.___cxa_find_matching_catch;var zb=env.___syscall145;var Ab=env.___syscall146;var Bb=0;
// EMSCRIPTEN_START_FUNCS
function ec(e,f,g,j,l){e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0.0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;P=i;O=i=i+63&-64;i=i+624|0;K=O+536+40|0;M=O+588|0;N=O+576+12|0;L=O+588+9|0;m=0;n=0;r=0;w=f;a:while(1){do if((m|0)>-1)if((n|0)>(2147483647-m|0)){c[(gp()|0)>>2]=75;m=-1;break}else{m=n+m|0;break}while(0);f=a[w>>0]|0;if(!(f<<24>>24)){J=244;break}else n=w;b:while(1){switch(f<<24>>24){case 37:{f=n;J=9;break b}case 0:{f=n;break b}default:{}}I=n+1|0;f=a[I>>0]|0;n=I}c:do if((J|0)==9)while(1){J=0;if((a[f+1>>0]|0)!=37)break c;n=n+1|0;f=f+2|0;if((a[f>>0]|0)==37)J=9;else break}while(0);v=n-w|0;if(e|0?(c[e>>2]&32|0)==0:0)xf(w,v,e)|0;if((n|0)!=(w|0)){n=v;w=f;continue}o=f+1|0;n=a[o>>0]|0;if(((n<<24>>24)+-48|0)>>>0<10){I=(a[f+2>>0]|0)==36;o=I?f+3|0:o;q=a[o>>0]|0;u=I?(n<<24>>24)+-48|0:-1;r=I?1:r}else{q=n;u=-1}f=q<<24>>24;d:do if((f&-32|0)==32){n=q;q=0;do{if(!(1<<f+-32&75913))break d;q=1<<(n<<24>>24)+-32|q;o=o+1|0;n=a[o>>0]|0;f=n<<24>>24}while((f&-32|0)==32)}else{n=q;q=0}while(0);do if(n<<24>>24==42){n=o+1|0;f=(a[n>>0]|0)+-48|0;if(f>>>0<10?(a[o+2>>0]|0)==36:0){c[l+(f<<2)>>2]=10;f=1;o=o+3|0;n=c[j+((a[n>>0]|0)+-48<<3)>>2]|0}else{if(r|0){m=-1;break a}if(!e){t=q;I=0;o=n;H=0;break}f=(c[g>>2]|0)+(4-1)&~(4-1);I=c[f>>2]|0;c[g>>2]=f+4;f=0;o=n;n=I}if((n|0)<0){t=q|8192;I=f;H=0-n|0}else{t=q;I=f;H=n}}else{f=(n<<24>>24)+-48|0;if(f>>>0<10){n=0;do{n=(n*10|0)+f|0;o=o+1|0;f=(a[o>>0]|0)+-48|0}while(f>>>0<10);if((n|0)<0){m=-1;break a}else{t=q;I=r;H=n}}else{t=q;I=r;H=0}}while(0);e:do if((a[o>>0]|0)==46){f=o+1|0;q=a[f>>0]|0;if(q<<24>>24!=42){if(((q<<24>>24)+-48|0)>>>0<10){n=0;o=(q<<24>>24)+-48|0}else{r=0;break}while(1){n=(n*10|0)+o|0;f=f+1|0;o=(a[f>>0]|0)+-48|0;if(o>>>0>=10){r=n;break e}}}f=o+2|0;n=(a[f>>0]|0)+-48|0;if(n>>>0<10?(a[o+3>>0]|0)==36:0){c[l+(n<<2)>>2]=10;r=c[j+((a[f>>0]|0)+-48<<3)>>2]|0;f=o+4|0;break}if(I|0){m=-1;break a}if(e|0){G=(c[g>>2]|0)+(4-1)&~(4-1);r=c[G>>2]|0;c[g>>2]=G+4}else r=0}else{r=-1;f=o}while(0);q=0;while(1){n=(a[f>>0]|0)+-65|0;if(n>>>0>57){m=-1;break a}G=f+1|0;n=a[43528+(q*58|0)+n>>0]|0;if(((n&255)+-1|0)>>>0<8){f=G;q=n&255}else break}if(!(n<<24>>24)){m=-1;break}o=(u|0)>-1;do if(n<<24>>24==19)if(o){m=-1;break a}else J=52;else{if(o){c[l+(u<<2)>>2]=n&255;F=j+(u<<3)|0;J=c[F+4>>2]|0;c[O>>2]=c[F>>2];c[O+4>>2]=J;J=52;break}if(!e){m=0;break a}Sd(O,n&255,g)}while(0);if((J|0)==52?(J=0,(e|0)==0):0){n=v;r=I;w=G;continue}E=a[f>>0]|0;E=(q|0)!=0&(E&15|0)==3?E&-33:E;o=t&-65537;F=(t&8192|0)==0?t:o;f:do switch(E|0){case 110:switch(q|0){case 0:{c[c[O>>2]>>2]=m;n=v;r=I;w=G;continue a}case 1:{c[c[O>>2]>>2]=m;n=v;r=I;w=G;continue a}case 2:{n=c[O>>2]|0;c[n>>2]=m;c[n+4>>2]=((m|0)<0)<<31>>31;n=v;r=I;w=G;continue a}case 3:{b[c[O>>2]>>1]=m;n=v;r=I;w=G;continue a}case 4:{a[c[O>>2]>>0]=m;n=v;r=I;w=G;continue a}case 6:{c[c[O>>2]>>2]=m;n=v;r=I;w=G;continue a}case 7:{n=c[O>>2]|0;c[n>>2]=m;c[n+4>>2]=((m|0)<0)<<31>>31;n=v;r=I;w=G;continue a}default:{n=v;r=I;w=G;continue a}}case 112:{t=F|8;r=r>>>0>8?r:8;u=120;J=64;break}case 88:case 120:{t=F;u=E;J=64;break}case 111:{n=c[O>>2]|0;o=c[O+4>>2]|0;if((n|0)==0&(o|0)==0)f=K;else{f=K;do{f=f+-1|0;a[f>>0]=n&7|48;n=Mm(n|0,o|0,3)|0;o=D}while(!((n|0)==0&(o|0)==0))}if(!(F&8)){n=F;t=0;q=44008;J=77}else{t=K-f|0;n=F;r=(r|0)>(t|0)?r:t+1|0;t=0;q=44008;J=77}break}case 105:case 100:{f=c[O>>2]|0;n=c[O+4>>2]|0;if((n|0)<0){f=Sm(0,0,f|0,n|0)|0;n=D;c[O>>2]=f;c[O+4>>2]=n;o=1;q=44008;J=76;break f}if(!(F&2048)){o=F&1;q=(F&1|0)==0?44008:44010;J=76}else{o=1;q=44009;J=76}break}case 117:{f=c[O>>2]|0;n=c[O+4>>2]|0;o=0;q=44008;J=76;break}case 99:{a[O+536+39>>0]=c[O>>2];f=O+536+39|0;u=1;w=0;v=44008;n=K;break}case 109:{n=sh(c[(gp()|0)>>2]|0)|0;J=82;break}case 115:{n=c[O>>2]|0;n=n|0?n:45910;J=82;break}case 67:{c[O+8>>2]=c[O>>2];c[O+8+4>>2]=0;c[O>>2]=O+8;f=O+8|0;r=-1;J=86;break}case 83:{f=c[O>>2]|0;if(!r){dg(e,32,H,0,F);f=0;J=97}else J=86;break}case 65:case 71:case 70:case 69:case 97:case 103:case 102:case 101:{p=+h[O>>3];c[O+16>>2]=0;h[k>>3]=p;if((c[k+4>>2]|0)>=0)if(!(F&2048)){B=F&1;C=(F&1|0)==0?45918:45923}else{B=1;C=45920}else{p=-p;B=1;C=45917}h[k>>3]=p;A=c[k+4>>2]&2146435072;do if(A>>>0<2146435072|(A|0)==2146435072&0<0){p=+ss(p,O+16|0)*2.0;if(p!=0.0)c[O+16>>2]=(c[O+16>>2]|0)+-1;if((E|32|0)==97){u=(E&32|0)==0?C:C+9|0;t=B|2;f=12-r|0;do if(!(r>>>0>11|(f|0)==0)){s=8.0;do{f=f+-1|0;s=s*16.0}while((f|0)!=0);if((a[u>>0]|0)==45){p=-(s+(-p-s));break}else{p=p+s-s;break}}while(0);n=c[O+16>>2]|0;f=(n|0)<0?0-n|0:n;f=ih(f,((f|0)<0)<<31>>31,O+576+12|0)|0;if((f|0)==(O+576+12|0)){a[O+576+11>>0]=48;f=O+576+11|0}a[f+-1>>0]=(n>>31&2)+43;q=f+-2|0;a[q>>0]=E+15;o=(r|0)<1;f=O+588|0;while(1){C=~~p;n=f+1|0;a[f>>0]=d[43992+C>>0]|E&32;p=(p-+(C|0))*16.0;do if((n-M|0)==1){if((F&8|0)==0&(o&p==0.0))break;a[n>>0]=46;n=f+2|0}while(0);if(!(p!=0.0))break;else f=n}f=(r|0)!=0&(-2-M+n|0)<(r|0)?N+2+r-q|0:N-M-q+n|0;dg(e,32,H,f+t|0,F);if(!(c[e>>2]&32))xf(u,t,e)|0;dg(e,48,H,f+t|0,F^65536);if(!(c[e>>2]&32))xf(O+588|0,n-M|0,e)|0;dg(e,48,f-(n-M+(N-q))|0,0,0);if(!(c[e>>2]&32))xf(q,N-q|0,e)|0;dg(e,32,H,f+t|0,F^8192);f=(f+t|0)<(H|0)?H:f+t|0;break}f=(r|0)<0?6:r;if(p!=0.0){n=(c[O+16>>2]|0)+-28|0;c[O+16>>2]=n;p=p*268435456.0}else n=c[O+16>>2]|0;A=(n|0)<0?O+24|0:O+24+288|0;q=A;do{z=~~p>>>0;c[q>>2]=z;q=q+4|0;p=(p-+(z>>>0))*1.0e9}while(p!=0.0);n=c[O+16>>2]|0;if((n|0)>0){o=A;do{t=(n|0)>29?29:n;n=q+-4|0;do if(n>>>0>=o>>>0){r=0;do{y=Km(c[n>>2]|0,0,t|0)|0;y=go(y|0,D|0,r|0,0)|0;z=D;x=nl(y|0,z|0,1e9,0)|0;c[n>>2]=x;r=tq(y|0,z|0,1e9,0)|0;n=n+-4|0}while(n>>>0>=o>>>0);if(!r)break;o=o+-4|0;c[o>>2]=r}while(0);while(1){if(q>>>0<=o>>>0)break;n=q+-4|0;if(!(c[n>>2]|0))q=n;else break}n=(c[O+16>>2]|0)-t|0;c[O+16>>2]=n}while((n|0)>0)}else o=A;if((n|0)<0){do{t=0-n|0;t=(t|0)>9?9:t;do if(o>>>0<q>>>0){r=0;n=o;do{z=c[n>>2]|0;c[n>>2]=(z>>>t)+r;r=S(z&(1<<t)+-1,1e9>>>t)|0;n=n+4|0}while(n>>>0<q>>>0);n=(c[o>>2]|0)==0?o+4|0:o;if(!r){o=n;n=q;break}c[q>>2]=r;o=n;n=q+4|0}else{o=(c[o>>2]|0)==0?o+4|0:o;n=q}while(0);q=(E|32|0)==102?A:o;q=(n-q>>2|0)>(((f+25|0)/9|0)+1|0)?q+(((f+25|0)/9|0)+1<<2)|0:n;n=(c[O+16>>2]|0)+t|0;c[O+16>>2]=n}while((n|0)<0);n=o}else n=o;do if(n>>>0<q>>>0){o=(A-n>>2)*9|0;t=c[n>>2]|0;if(t>>>0<10)break;else r=10;do{r=r*10|0;o=o+1|0}while(t>>>0>=r>>>0)}else o=0;while(0);r=f-((E|32|0)!=102?o:0)+(((f|0)!=0&(E|32|0)==103)<<31>>31)|0;if((r|0)<(((q-A>>2)*9|0)+-9|0)){x=A+4+(((r+9216|0)/9|0)+-1024<<2)|0;if((((r+9216|0)%9|0)+1|0)<9){t=10;u=((r+9216|0)%9|0)+1|0;while(1){r=t*10|0;u=u+1|0;if((u|0)==9)break;else t=r}}else r=10;v=c[x>>2]|0;w=(v>>>0)%(r>>>0)|0;t=(x+4|0)==(q|0);do if(t&(w|0)==0)r=x;else{s=(((v>>>0)/(r>>>0)|0)&1|0)==0?9007199254740992.0:9007199254740994.0;u=(r|0)/2|0;if(w>>>0<u>>>0)p=.5;else p=t&(w|0)==(u|0)?1.0:1.5;do if(B){if((a[C>>0]|0)!=45)break;s=-s;p=-p}while(0);c[x>>2]=v-w;if(!(s+p!=s)){r=x;break}z=v-w+r|0;c[x>>2]=z;if(z>>>0>999999999){o=x;while(1){r=o+-4|0;c[o>>2]=0;if(r>>>0<n>>>0){n=n+-4|0;c[n>>2]=0}z=(c[r>>2]|0)+1|0;c[r>>2]=z;if(z>>>0>999999999)o=r;else break}}else r=x;o=(A-n>>2)*9|0;u=c[n>>2]|0;if(u>>>0<10)break;else t=10;do{t=t*10|0;o=o+1|0}while(u>>>0>=t>>>0)}while(0);y=r+4|0;z=n;n=q>>>0>y>>>0?y:q}else{z=n;n=q}u=0-o|0;y=n;while(1){if(y>>>0<=z>>>0){w=0;break}n=y+-4|0;if(!(c[n>>2]|0))y=n;else{w=1;break}}do if((E|32|0)==103){if((((f|0)!=0^1)+f|0)>(o|0)&(o|0)>-5){t=E+-1|0;f=((f|0)!=0^1)+f+-1-o|0}else{t=E+-2|0;f=((f|0)!=0^1)+f+-1|0}if(F&8|0){r=F&8;break}do if(w){n=c[y+-4>>2]|0;if(!n){q=9;break}if(!((n>>>0)%10|0)){r=10;q=0}else{q=0;break}do{r=r*10|0;q=q+1|0}while(!((n>>>0)%(r>>>0)|0|0))}else q=9;while(0);n=((y-A>>2)*9|0)+-9|0;if((t|32|0)==102){r=n-q|0;r=(r|0)<0?0:r;f=(f|0)<(r|0)?f:r;r=0;break}else{r=n+o-q|0;r=(r|0)<0?0:r;f=(f|0)<(r|0)?f:r;r=0;break}}else{t=E;r=F&8}while(0);v=f|r;q=(t|32|0)==102;if(q){n=(o|0)>0?o:0;u=0}else{n=(o|0)<0?u:o;n=ih(n,((n|0)<0)<<31>>31,O+576+12|0)|0;if((N-n|0)<2)do{n=n+-1|0;a[n>>0]=48}while((N-n|0)<2);a[n+-1>>0]=(o>>31&2)+43;u=n+-2|0;a[u>>0]=t;n=N-u|0}x=B+1+f+((v|0)!=0&1)+n|0;dg(e,32,H,x,F);if(!(c[e>>2]&32))xf(C,B,e)|0;dg(e,48,H,x,F^65536);do if(q){q=z>>>0>A>>>0?A:z;o=q;do{n=ih(c[o>>2]|0,0,L)|0;do if((o|0)==(q|0)){if((n|0)!=(L|0))break;a[O+588+8>>0]=48;n=O+588+8|0}else{if(n>>>0<=(O+588|0)>>>0)break;ei(O+588|0,48,n-M|0)|0;do n=n+-1|0;while(n>>>0>(O+588|0)>>>0)}while(0);if(!(c[e>>2]&32))xf(n,L-n|0,e)|0;o=o+4|0}while(o>>>0<=A>>>0);do if(v|0){if(c[e>>2]&32|0)break;xf(45967,1,e)|0}while(0);if((f|0)>0&o>>>0<y>>>0)while(1){n=ih(c[o>>2]|0,0,L)|0;if(n>>>0>(O+588|0)>>>0){ei(O+588|0,48,n-M|0)|0;do n=n+-1|0;while(n>>>0>(O+588|0)>>>0)}if(!(c[e>>2]&32))xf(n,(f|0)>9?9:f,e)|0;o=o+4|0;n=f+-9|0;if(!((f|0)>9&o>>>0<y>>>0)){f=n;break}else f=n}dg(e,48,f+9|0,9,0)}else{t=w?y:z+4|0;if((f|0)>-1){r=(r|0)==0;q=z;do{n=ih(c[q>>2]|0,0,L)|0;if((n|0)==(L|0)){a[O+588+8>>0]=48;n=O+588+8|0}do if((q|0)==(z|0)){o=n+1|0;if(!(c[e>>2]&32))xf(n,1,e)|0;if(r&(f|0)<1){n=o;break}if(c[e>>2]&32|0){n=o;break}xf(45967,1,e)|0;n=o}else{if(n>>>0<=(O+588|0)>>>0)break;ei(O+588|0,48,n+(0-M)|0)|0;do n=n+-1|0;while(n>>>0>(O+588|0)>>>0)}while(0);o=L-n|0;if(!(c[e>>2]&32))xf(n,(f|0)>(o|0)?o:f,e)|0;f=f-o|0;q=q+4|0}while(q>>>0<t>>>0&(f|0)>-1)}dg(e,48,f+18|0,18,0);if(c[e>>2]&32|0)break;xf(u,N-u|0,e)|0}while(0);dg(e,32,H,x,F^8192);f=(x|0)<(H|0)?H:x}else{q=p!=p|0.0!=0.0;n=q?0:B;dg(e,32,H,n+3|0,o);f=c[e>>2]|0;if(!(f&32)){xf(C,n,e)|0;f=c[e>>2]|0}if(!(f&32))xf(q?(E&32|0?45957:45944):E&32|0?45936:45940,3,e)|0;dg(e,32,H,n+3|0,F^8192);f=(n+3|0)<(H|0)?H:n+3|0}while(0);n=f;r=I;w=G;continue a}default:{f=w;o=F;u=r;w=0;v=44008;n=K}}while(0);g:do if((J|0)==64){n=c[O>>2]|0;o=c[O+4>>2]|0;q=u&32;if(!((n|0)==0&(o|0)==0)){f=K;do{f=f+-1|0;a[f>>0]=d[43992+(n&15)>>0]|q;n=Mm(n|0,o|0,4)|0;o=D}while(!((n|0)==0&(o|0)==0));if((t&8|0)==0|(c[O>>2]|0)==0&(c[O+4>>2]|0)==0){n=t;t=0;q=44008;J=77}else{n=t;t=2;q=44008+(u>>4)|0;J=77}}else{f=K;n=t;t=0;q=44008;J=77}}else if((J|0)==76){f=ih(f,n,K)|0;n=F;t=o;J=77}else if((J|0)==82){J=0;F=cf(n,0,r)|0;f=n;u=(F|0)==0?r:F-n|0;w=0;v=44008;n=(F|0)==0?n+r|0:F}else if((J|0)==86){J=0;o=0;n=0;t=f;while(1){q=c[t>>2]|0;if(!q)break;n=bq(O+528|0,q)|0;if((n|0)<0|n>>>0>(r-o|0)>>>0)break;o=n+o|0;if(r>>>0>o>>>0)t=t+4|0;else break}if((n|0)<0){m=-1;break a}dg(e,32,H,o,F);if(!o){f=0;J=97}else{q=0;while(1){n=c[f>>2]|0;if(!n){f=o;J=97;break g}n=bq(O+528|0,n)|0;q=n+q|0;if((q|0)>(o|0)){f=o;J=97;break g}if(!(c[e>>2]&32))xf(O+528|0,n,e)|0;if(q>>>0>=o>>>0){f=o;J=97;break}else f=f+4|0}}}while(0);if((J|0)==97){J=0;dg(e,32,H,f,F^8192);n=(H|0)>(f|0)?H:f;r=I;w=G;continue}if((J|0)==77){J=0;o=(r|0)>-1?n&-65537:n;n=(c[O>>2]|0)!=0|(c[O+4>>2]|0)!=0;if((r|0)!=0|n){u=(n&1^1)+(K-f)|0;u=(r|0)>(u|0)?r:u;w=t;v=q;n=K}else{f=K;u=0;w=t;v=q;n=K}}t=n-f|0;q=(u|0)<(t|0)?t:u;r=w+q|0;n=(H|0)<(r|0)?r:H;dg(e,32,n,r,o);if(!(c[e>>2]&32))xf(v,w,e)|0;dg(e,48,n,r,o^65536);dg(e,48,q,t,0);if(!(c[e>>2]&32))xf(f,t,e)|0;dg(e,32,n,r,o^8192);r=I;w=G}h:do if((J|0)==244)if(!e)if(!r)m=0;else{m=1;while(1){f=c[l+(m<<2)>>2]|0;if(!f){f=0;break}Sd(j+(m<<3)|0,f,g);m=m+1|0;if((m|0)>=10){m=1;break h}}while(1){m=m+1|0;if(f|0){m=-1;break h}if((m|0)>=10){m=1;break h}f=c[l+(m<<2)>>2]|0}}while(0);i=P;return m|0}function fc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0;o=c[b>>2]|0;n=c[b+4>>2]|0;k=c[b+8>>2]|0;fa=c[b+12>>2]|0;N=c[b+16>>2]|0;M=c[b+20>>2]|0;g=c[b+24>>2]|0;ea=c[b+28>>2]|0;L=c[b+32>>2]|0;q=c[b+36>>2]|0;I=c[d>>2]|0;Oc=c[d+4>>2]|0;cc=c[d+8>>2]|0;sb=c[d+12>>2]|0;Ia=c[d+16>>2]|0;jc=c[d+20>>2]|0;Db=c[d+24>>2]|0;Ta=c[d+28>>2]|0;ga=c[d+32>>2]|0;Pc=c[d+36>>2]|0;Mc=Pl(I|0,((I|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;Lc=D;wc=Pl(Oc|0,((Oc|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;vc=D;ub=Pl(cc|0,((cc|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;tb=D;Ka=Pl(sb|0,((sb|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;Ja=D;mc=Pl(Ia|0,((Ia|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;lc=D;Gb=Pl(jc|0,((jc|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;Fb=D;Wa=Pl(Db|0,((Db|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;Va=D;ja=Pl(Ta|0,((Ta|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;ia=D;P=Pl(ga|0,((ga|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;O=D;o=Pl(Pc|0,((Pc|0)<0)<<31>>31|0,o|0,((o|0)<0)<<31>>31|0)|0;l=D;dc=Pl(I|0,((I|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;ec=D;yb=Pl(Oc|0,((Oc|0)<0)<<31>>31|0,n<<1|0,((n<<1|0)<0)<<31>>31|0)|0;xb=D;Ma=Pl(cc|0,((cc|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;La=D;oc=Pl(sb|0,((sb|0)<0)<<31>>31|0,n<<1|0,((n<<1|0)<0)<<31>>31|0)|0;nc=D;Ib=Pl(Ia|0,((Ia|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;Hb=D;Ya=Pl(jc|0,((jc|0)<0)<<31>>31|0,n<<1|0,((n<<1|0)<0)<<31>>31|0)|0;Xa=D;la=Pl(Db|0,((Db|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;ka=D;R=Pl(Ta|0,((Ta|0)<0)<<31>>31|0,n<<1|0,((n<<1|0)<0)<<31>>31|0)|0;Q=D;t=Pl(ga|0,((ga|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;s=D;d=((Pc*19|0)<0)<<31>>31;n=Pl(Pc*19|0,d|0,n<<1|0,((n<<1|0)<0)<<31>>31|0)|0;p=D;wb=Pl(I|0,((I|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;vb=D;Qa=Pl(Oc|0,((Oc|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;Pa=D;qc=Pl(cc|0,((cc|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;pc=D;Kb=Pl(sb|0,((sb|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;Jb=D;_a=Pl(Ia|0,((Ia|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;Za=D;na=Pl(jc|0,((jc|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;ma=D;T=Pl(Db|0,((Db|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;S=D;v=Pl(Ta|0,((Ta|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;u=D;ha=((ga*19|0)<0)<<31>>31;yc=Pl(ga*19|0,ha|0,k|0,((k|0)<0)<<31>>31|0)|0;xc=D;k=Pl(Pc*19|0,d|0,k|0,((k|0)<0)<<31>>31|0)|0;j=D;Oa=Pl(I|0,((I|0)<0)<<31>>31|0,fa|0,((fa|0)<0)<<31>>31|0)|0;Na=D;uc=Pl(Oc|0,((Oc|0)<0)<<31>>31|0,fa<<1|0,((fa<<1|0)<0)<<31>>31|0)|0;tc=D;Mb=Pl(cc|0,((cc|0)<0)<<31>>31|0,fa|0,((fa|0)<0)<<31>>31|0)|0;Lb=D;ab=Pl(sb|0,((sb|0)<0)<<31>>31|0,fa<<1|0,((fa<<1|0)<0)<<31>>31|0)|0;$a=D;pa=Pl(Ia|0,((Ia|0)<0)<<31>>31|0,fa|0,((fa|0)<0)<<31>>31|0)|0;oa=D;V=Pl(jc|0,((jc|0)<0)<<31>>31|0,fa<<1|0,((fa<<1|0)<0)<<31>>31|0)|0;U=D;x=Pl(Db|0,((Db|0)<0)<<31>>31|0,fa|0,((fa|0)<0)<<31>>31|0)|0;w=D;Ua=((Ta*19|0)<0)<<31>>31;Ac=Pl(Ta*19|0,Ua|0,fa<<1|0,((fa<<1|0)<0)<<31>>31|0)|0;zc=D;Sb=Pl(ga*19|0,ha|0,fa|0,((fa|0)<0)<<31>>31|0)|0;Rb=D;fa=Pl(Pc*19|0,d|0,fa<<1|0,((fa<<1|0)<0)<<31>>31|0)|0;f=D;sc=Pl(I|0,((I|0)<0)<<31>>31|0,N|0,((N|0)<0)<<31>>31|0)|0;rc=D;Qb=Pl(Oc|0,((Oc|0)<0)<<31>>31|0,N|0,((N|0)<0)<<31>>31|0)|0;Pb=D;cb=Pl(cc|0,((cc|0)<0)<<31>>31|0,N|0,((N|0)<0)<<31>>31|0)|0;bb=D;ra=Pl(sb|0,((sb|0)<0)<<31>>31|0,N|0,((N|0)<0)<<31>>31|0)|0;qa=D;X=Pl(Ia|0,((Ia|0)<0)<<31>>31|0,N|0,((N|0)<0)<<31>>31|0)|0;W=D;z=Pl(jc|0,((jc|0)<0)<<31>>31|0,N|0,((N|0)<0)<<31>>31|0)|0;y=D;Eb=((Db*19|0)<0)<<31>>31;Cc=Pl(Db*19|0,Eb|0,N|0,((N|0)<0)<<31>>31|0)|0;Bc=D;Ub=Pl(Ta*19|0,Ua|0,N|0,((N|0)<0)<<31>>31|0)|0;Tb=D;ib=Pl(ga*19|0,ha|0,N|0,((N|0)<0)<<31>>31|0)|0;hb=D;N=Pl(Pc*19|0,d|0,N|0,((N|0)<0)<<31>>31|0)|0;e=D;Ob=Pl(I|0,((I|0)<0)<<31>>31|0,M|0,((M|0)<0)<<31>>31|0)|0;Nb=D;gb=Pl(Oc|0,((Oc|0)<0)<<31>>31|0,M<<1|0,((M<<1|0)<0)<<31>>31|0)|0;fb=D;ta=Pl(cc|0,((cc|0)<0)<<31>>31|0,M|0,((M|0)<0)<<31>>31|0)|0;sa=D;Z=Pl(sb|0,((sb|0)<0)<<31>>31|0,M<<1|0,((M<<1|0)<0)<<31>>31|0)|0;Y=D;B=Pl(Ia|0,((Ia|0)<0)<<31>>31|0,M|0,((M|0)<0)<<31>>31|0)|0;A=D;kc=((jc*19|0)<0)<<31>>31;Ec=Pl(jc*19|0,kc|0,M<<1|0,((M<<1|0)<0)<<31>>31|0)|0;Dc=D;Wb=Pl(Db*19|0,Eb|0,M|0,((M|0)<0)<<31>>31|0)|0;Vb=D;kb=Pl(Ta*19|0,Ua|0,M<<1|0,((M<<1|0)<0)<<31>>31|0)|0;jb=D;Aa=Pl(ga*19|0,ha|0,M|0,((M|0)<0)<<31>>31|0)|0;za=D;b=Pl(Pc*19|0,d|0,M<<1|0,((M<<1|0)<0)<<31>>31|0)|0;M=D;eb=Pl(I|0,((I|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;db=D;xa=Pl(Oc|0,((Oc|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;wa=D;$=Pl(cc|0,((cc|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;_=D;E=Pl(sb|0,((sb|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;C=D;Gc=Pl(Ia*19|0,((Ia*19|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;Fc=D;Yb=Pl(jc*19|0,kc|0,g|0,((g|0)<0)<<31>>31|0)|0;Xb=D;mb=Pl(Db*19|0,Eb|0,g|0,((g|0)<0)<<31>>31|0)|0;lb=D;Ca=Pl(Ta*19|0,Ua|0,g|0,((g|0)<0)<<31>>31|0)|0;Ba=D;m=Pl(ga*19|0,ha|0,g|0,((g|0)<0)<<31>>31|0)|0;r=D;g=Pl(Pc*19|0,d|0,g|0,((g|0)<0)<<31>>31|0)|0;ya=D;va=Pl(I|0,((I|0)<0)<<31>>31|0,ea|0,((ea|0)<0)<<31>>31|0)|0;ua=D;da=Pl(Oc|0,((Oc|0)<0)<<31>>31|0,ea<<1|0,((ea<<1|0)<0)<<31>>31|0)|0;ca=D;G=Pl(cc|0,((cc|0)<0)<<31>>31|0,ea|0,((ea|0)<0)<<31>>31|0)|0;F=D;Ic=Pl(sb*19|0,((sb*19|0)<0)<<31>>31|0,ea<<1|0,((ea<<1|0)<0)<<31>>31|0)|0;Hc=D;_b=Pl(Ia*19|0,((Ia*19|0)<0)<<31>>31|0,ea|0,((ea|0)<0)<<31>>31|0)|0;Zb=D;ob=Pl(jc*19|0,kc|0,ea<<1|0,((ea<<1|0)<0)<<31>>31|0)|0;nb=D;Ea=Pl(Db*19|0,Eb|0,ea|0,((ea|0)<0)<<31>>31|0)|0;Da=D;gc=Pl(Ta*19|0,Ua|0,ea<<1|0,((ea<<1|0)<0)<<31>>31|0)|0;fc=D;Ab=Pl(ga*19|0,ha|0,ea|0,((ea|0)<0)<<31>>31|0)|0;zb=D;ea=Pl(Pc*19|0,d|0,ea<<1|0,((ea<<1|0)<0)<<31>>31|0)|0;i=D;ba=Pl(I|0,((I|0)<0)<<31>>31|0,L|0,((L|0)<0)<<31>>31|0)|0;aa=D;K=Pl(Oc|0,((Oc|0)<0)<<31>>31|0,L|0,((L|0)<0)<<31>>31|0)|0;J=D;Kc=Pl(cc*19|0,((cc*19|0)<0)<<31>>31|0,L|0,((L|0)<0)<<31>>31|0)|0;Jc=D;ac=Pl(sb*19|0,((sb*19|0)<0)<<31>>31|0,L|0,((L|0)<0)<<31>>31|0)|0;$b=D;qb=Pl(Ia*19|0,((Ia*19|0)<0)<<31>>31|0,L|0,((L|0)<0)<<31>>31|0)|0;pb=D;Ga=Pl(jc*19|0,kc|0,L|0,((L|0)<0)<<31>>31|0)|0;Fa=D;ic=Pl(Db*19|0,Eb|0,L|0,((L|0)<0)<<31>>31|0)|0;hc=D;Cb=Pl(Ta*19|0,Ua|0,L|0,((L|0)<0)<<31>>31|0)|0;Bb=D;Sa=Pl(ga*19|0,ha|0,L|0,((L|0)<0)<<31>>31|0)|0;Ra=D;L=Pl(Pc*19|0,d|0,L|0,((L|0)<0)<<31>>31|0)|0;h=D;I=Pl(I|0,((I|0)<0)<<31>>31|0,q|0,((q|0)<0)<<31>>31|0)|0;H=D;Oc=Pl(Oc*19|0,((Oc*19|0)<0)<<31>>31|0,q<<1|0,((q<<1|0)<0)<<31>>31|0)|0;Nc=D;cc=Pl(cc*19|0,((cc*19|0)<0)<<31>>31|0,q|0,((q|0)<0)<<31>>31|0)|0;bc=D;sb=Pl(sb*19|0,((sb*19|0)<0)<<31>>31|0,q<<1|0,((q<<1|0)<0)<<31>>31|0)|0;rb=D;Ia=Pl(Ia*19|0,((Ia*19|0)<0)<<31>>31|0,q|0,((q|0)<0)<<31>>31|0)|0;Ha=D;kc=Pl(jc*19|0,kc|0,q<<1|0,((q<<1|0)<0)<<31>>31|0)|0;jc=D;Eb=Pl(Db*19|0,Eb|0,q|0,((q|0)<0)<<31>>31|0)|0;Db=D;Ua=Pl(Ta*19|0,Ua|0,q<<1|0,((q<<1|0)<0)<<31>>31|0)|0;Ta=D;ha=Pl(ga*19|0,ha|0,q|0,((q|0)<0)<<31>>31|0)|0;ga=D;q=Pl(Pc*19|0,d|0,q<<1|0,((q<<1|0)<0)<<31>>31|0)|0;d=D;Lc=go(Oc|0,Nc|0,Mc|0,Lc|0)|0;Jc=go(Lc|0,D|0,Kc|0,Jc|0)|0;Hc=go(Jc|0,D|0,Ic|0,Hc|0)|0;Fc=go(Hc|0,D|0,Gc|0,Fc|0)|0;Dc=go(Fc|0,D|0,Ec|0,Dc|0)|0;Bc=go(Dc|0,D|0,Cc|0,Bc|0)|0;zc=go(Bc|0,D|0,Ac|0,zc|0)|0;xc=go(zc|0,D|0,yc|0,xc|0)|0;p=go(xc|0,D|0,n|0,p|0)|0;n=D;ec=go(wc|0,vc|0,dc|0,ec|0)|0;dc=D;rc=go(uc|0,tc|0,sc|0,rc|0)|0;pc=go(rc|0,D|0,qc|0,pc|0)|0;nc=go(pc|0,D|0,oc|0,nc|0)|0;lc=go(nc|0,D|0,mc|0,lc|0)|0;jc=go(lc|0,D|0,kc|0,jc|0)|0;hc=go(jc|0,D|0,ic|0,hc|0)|0;fc=go(hc|0,D|0,gc|0,fc|0)|0;r=go(fc|0,D|0,m|0,r|0)|0;M=go(r|0,D|0,b|0,M|0)|0;b=D;r=go(p|0,n|0,33554432,0)|0;r=_l(r|0,D|0,26)|0;m=D;bc=go(ec|0,dc|0,cc|0,bc|0)|0;$b=go(bc|0,D|0,ac|0,$b|0)|0;Zb=go($b|0,D|0,_b|0,Zb|0)|0;Xb=go(Zb|0,D|0,Yb|0,Xb|0)|0;Vb=go(Xb|0,D|0,Wb|0,Vb|0)|0;Tb=go(Vb|0,D|0,Ub|0,Tb|0)|0;Rb=go(Tb|0,D|0,Sb|0,Rb|0)|0;j=go(Rb|0,D|0,k|0,j|0)|0;j=go(j|0,D|0,r|0,m|0)|0;k=D;m=Km(r|0,m|0,26)|0;m=Sm(p|0,n|0,m|0,D|0)|0;n=D;p=go(M|0,b|0,33554432,0)|0;p=_l(p|0,D|0,26)|0;r=D;Nb=go(Qb|0,Pb|0,Ob|0,Nb|0)|0;Lb=go(Nb|0,D|0,Mb|0,Lb|0)|0;Jb=go(Lb|0,D|0,Kb|0,Jb|0)|0;Hb=go(Jb|0,D|0,Ib|0,Hb|0)|0;Fb=go(Hb|0,D|0,Gb|0,Fb|0)|0;Db=go(Fb|0,D|0,Eb|0,Db|0)|0;Bb=go(Db|0,D|0,Cb|0,Bb|0)|0;zb=go(Bb|0,D|0,Ab|0,zb|0)|0;ya=go(zb|0,D|0,g|0,ya|0)|0;ya=go(ya|0,D|0,p|0,r|0)|0;g=D;r=Km(p|0,r|0,26)|0;r=Sm(M|0,b|0,r|0,D|0)|0;b=D;M=go(j|0,k|0,16777216,0)|0;M=_l(M|0,D|0,25)|0;p=D;vb=go(yb|0,xb|0,wb|0,vb|0)|0;tb=go(vb|0,D|0,ub|0,tb|0)|0;rb=go(tb|0,D|0,sb|0,rb|0)|0;pb=go(rb|0,D|0,qb|0,pb|0)|0;nb=go(pb|0,D|0,ob|0,nb|0)|0;lb=go(nb|0,D|0,mb|0,lb|0)|0;jb=go(lb|0,D|0,kb|0,jb|0)|0;hb=go(jb|0,D|0,ib|0,hb|0)|0;f=go(hb|0,D|0,fa|0,f|0)|0;f=go(f|0,D|0,M|0,p|0)|0;fa=D;p=Km(M|0,p|0,25)|0;p=Sm(j|0,k|0,p|0,D|0)|0;k=D;j=go(ya|0,g|0,16777216,0)|0;j=_l(j|0,D|0,25)|0;M=D;db=go(gb|0,fb|0,eb|0,db|0)|0;bb=go(db|0,D|0,cb|0,bb|0)|0;$a=go(bb|0,D|0,ab|0,$a|0)|0;Za=go($a|0,D|0,_a|0,Za|0)|0;Xa=go(Za|0,D|0,Ya|0,Xa|0)|0;Va=go(Xa|0,D|0,Wa|0,Va|0)|0;Ta=go(Va|0,D|0,Ua|0,Ta|0)|0;Ra=go(Ta|0,D|0,Sa|0,Ra|0)|0;i=go(Ra|0,D|0,ea|0,i|0)|0;i=go(i|0,D|0,j|0,M|0)|0;ea=D;M=Km(j|0,M|0,25)|0;M=Sm(ya|0,g|0,M|0,D|0)|0;g=D;ya=go(f|0,fa|0,33554432,0)|0;ya=_l(ya|0,D|0,26)|0;j=D;Na=go(Qa|0,Pa|0,Oa|0,Na|0)|0;La=go(Na|0,D|0,Ma|0,La|0)|0;Ja=go(La|0,D|0,Ka|0,Ja|0)|0;Ha=go(Ja|0,D|0,Ia|0,Ha|0)|0;Fa=go(Ha|0,D|0,Ga|0,Fa|0)|0;Da=go(Fa|0,D|0,Ea|0,Da|0)|0;Ba=go(Da|0,D|0,Ca|0,Ba|0)|0;za=go(Ba|0,D|0,Aa|0,za|0)|0;e=go(za|0,D|0,N|0,e|0)|0;e=go(e|0,D|0,ya|0,j|0)|0;N=D;j=Km(ya|0,j|0,26)|0;j=Sm(f|0,fa|0,j|0,D|0)|0;fa=go(i|0,ea|0,33554432,0)|0;fa=_l(fa|0,D|0,26)|0;f=D;ua=go(xa|0,wa|0,va|0,ua|0)|0;sa=go(ua|0,D|0,ta|0,sa|0)|0;qa=go(sa|0,D|0,ra|0,qa|0)|0;oa=go(qa|0,D|0,pa|0,oa|0)|0;ma=go(oa|0,D|0,na|0,ma|0)|0;ka=go(ma|0,D|0,la|0,ka|0)|0;ia=go(ka|0,D|0,ja|0,ia|0)|0;ga=go(ia|0,D|0,ha|0,ga|0)|0;h=go(ga|0,D|0,L|0,h|0)|0;h=go(h|0,D|0,fa|0,f|0)|0;L=D;f=Km(fa|0,f|0,26)|0;f=Sm(i|0,ea|0,f|0,D|0)|0;ea=go(e|0,N|0,16777216,0)|0;ea=_l(ea|0,D|0,25)|0;i=D;b=go(ea|0,i|0,r|0,b|0)|0;r=D;i=Km(ea|0,i|0,25)|0;i=Sm(e|0,N|0,i|0,D|0)|0;N=go(h|0,L|0,16777216,0)|0;N=_l(N|0,D|0,25)|0;e=D;aa=go(da|0,ca|0,ba|0,aa|0)|0;_=go(aa|0,D|0,$|0,_|0)|0;Y=go(_|0,D|0,Z|0,Y|0)|0;W=go(Y|0,D|0,X|0,W|0)|0;U=go(W|0,D|0,V|0,U|0)|0;S=go(U|0,D|0,T|0,S|0)|0;Q=go(S|0,D|0,R|0,Q|0)|0;O=go(Q|0,D|0,P|0,O|0)|0;d=go(O|0,D|0,q|0,d|0)|0;d=go(d|0,D|0,N|0,e|0)|0;q=D;e=Km(N|0,e|0,25)|0;e=Sm(h|0,L|0,e|0,D|0)|0;L=go(b|0,r|0,33554432,0)|0;L=_l(L|0,D|0,26)|0;h=D;g=go(M|0,g|0,L|0,h|0)|0;h=Km(L|0,h|0,26)|0;h=Sm(b|0,r|0,h|0,D|0)|0;r=go(d|0,q|0,33554432,0)|0;r=_l(r|0,D|0,26)|0;b=D;H=go(K|0,J|0,I|0,H|0)|0;F=go(H|0,D|0,G|0,F|0)|0;C=go(F|0,D|0,E|0,C|0)|0;A=go(C|0,D|0,B|0,A|0)|0;y=go(A|0,D|0,z|0,y|0)|0;w=go(y|0,D|0,x|0,w|0)|0;u=go(w|0,D|0,v|0,u|0)|0;s=go(u|0,D|0,t|0,s|0)|0;l=go(s|0,D|0,o|0,l|0)|0;l=go(l|0,D|0,r|0,b|0)|0;o=D;b=Km(r|0,b|0,26)|0;b=Sm(d|0,q|0,b|0,D|0)|0;q=go(l|0,o|0,16777216,0)|0;q=_l(q|0,D|0,25)|0;d=D;r=Pl(q|0,d|0,19,0)|0;n=go(r|0,D|0,m|0,n|0)|0;m=D;d=Km(q|0,d|0,25)|0;d=Sm(l|0,o|0,d|0,D|0)|0;o=go(n|0,m|0,33554432,0)|0;o=_l(o|0,D|0,26)|0;l=D;k=go(p|0,k|0,o|0,l|0)|0;l=Km(o|0,l|0,26)|0;l=Sm(n|0,m|0,l|0,D|0)|0;c[a>>2]=l;c[a+4>>2]=k;c[a+8>>2]=j;c[a+12>>2]=i;c[a+16>>2]=h;c[a+20>>2]=g;c[a+24>>2]=f;c[a+28>>2]=e;c[a+32>>2]=b;c[a+36>>2]=d;return}function gc(e,f,j){e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=i;z=i=i+63&-64;i=i+304|0;k=a[f>>0]|0;a:do if(k<<24>>24){y=z+33+10|0;m=k;k=0;q=f;s=0;l=0;f=0;b:while(1){c:do if(!(Vr(m&255)|0)){m=m<<24>>24==37;d:do if(m){p=q+1|0;n=a[p>>0]|0;e:do switch(n<<24>>24){case 37:break d;case 42:{m=0;p=q+2|0;break}default:{if(((n&255)+-48|0)>>>0<10?(a[q+2>>0]|0)==36:0){c[z+16>>2]=c[j>>2];n=(n&255)+-48|0;while(1){x=(c[z+16>>2]|0)+(4-1)&~(4-1);m=c[x>>2]|0;c[z+16>>2]=x+4;if(n>>>0>1)n=n+-1|0;else break}p=q+3|0;break e}x=(c[j>>2]|0)+(4-1)&~(4-1);m=c[x>>2]|0;c[j>>2]=x+4}}while(0);n=a[p>>0]|0;if(((n&255)+-48|0)>>>0<10){r=n&255;n=0;while(1){q=(n*10|0)+-48+r|0;p=p+1|0;n=a[p>>0]|0;r=n&255;if((r+-48|0)>>>0>=10){r=q;break}else n=q}}else r=0;if(n<<24>>24==109){p=p+1|0;n=a[p>>0]|0;x=(m|0)!=0&1;l=0;f=0}else x=0;q=p+1|0;switch(n&255|0){case 104:{w=(a[q>>0]|0)==104;n=w?p+2|0:q;p=w?-2:-1;break}case 108:{w=(a[q>>0]|0)==108;n=w?p+2|0:q;p=w?3:1;break}case 106:{n=q;p=3;break}case 116:case 122:{n=q;p=1;break}case 76:{n=q;p=2;break}case 110:case 112:case 67:case 83:case 91:case 99:case 115:case 88:case 71:case 70:case 69:case 65:case 103:case 102:case 101:case 97:case 120:case 117:case 111:case 105:case 100:{n=p;p=0;break}default:{A=152;break b}}v=d[n>>0]|0;u=(v&47|0)==3?v|32:v;v=(v&47|0)==3?1:p;switch(u|0){case 99:{w=s;t=(r|0)<1?1:r;break}case 91:{w=s;t=r;break}case 110:{if(!m){p=s;break c}switch(v|0){case -2:{a[m>>0]=s;p=s;break c}case -1:{b[m>>1]=s;p=s;break c}case 0:{c[m>>2]=s;p=s;break c}case 1:{c[m>>2]=s;p=s;break c}case 3:{p=m;c[p>>2]=s;c[p+4>>2]=((s|0)<0)<<31>>31;p=s;break c}default:{p=s;break c}}}default:{Ek(e,0);do{p=c[e+4>>2]|0;if(p>>>0<(c[e+100>>2]|0)>>>0){c[e+4>>2]=p+1;p=d[p>>0]|0}else p=Qf(e)|0}while((Vr(p)|0)!=0);if(!(c[e+100>>2]|0))p=c[e+4>>2]|0;else{p=(c[e+4>>2]|0)+-1|0;c[e+4>>2]=p}w=(c[e+108>>2]|0)+s+p-(c[e+8>>2]|0)|0;t=r}}Ek(e,t);p=c[e+4>>2]|0;q=c[e+100>>2]|0;if(p>>>0<q>>>0)c[e+4>>2]=p+1;else{if((Qf(e)|0)<0){A=152;break b}q=c[e+100>>2]|0}if(q|0)c[e+4>>2]=(c[e+4>>2]|0)+-1;f:do switch(u|0){case 91:case 99:case 115:{g:do if((u|16|0)==115){ei(z+33|0,-1,257)|0;a[z+33>>0]=0;if((u|0)==115){a[z+33+33>>0]=0;a[y>>0]=0;a[y+1>>0]=0;a[y+2>>0]=0;a[y+3>>0]=0;a[y+4>>0]=0}}else{s=n+1|0;p=(a[s>>0]|0)==94;n=p?n+2|0:s;ei(z+33|0,p&1|0,257)|0;a[z+33>>0]=0;switch(a[n>>0]|0){case 45:{a[z+33+46>>0]=p&1^1;s=(p&1^1)&255;n=n+1|0;break}case 93:{a[z+33+94>>0]=p&1^1;s=(p&1^1)&255;n=n+1|0;break}default:s=(p&1^1)&255}while(1){p=a[n>>0]|0;h:do switch(p<<24>>24){case 0:{A=152;break b}case 93:break g;case 45:{r=n+1|0;p=a[r>>0]|0;switch(p<<24>>24){case 93:case 0:{p=45;break h}default:{}}n=a[n+-1>>0]|0;if((n&255)<(p&255)){n=n&255;do{n=n+1|0;a[z+33+n>>0]=s;p=a[r>>0]|0}while((n|0)<(p&255|0));n=r}else n=r;break}default:{}}while(0);a[z+33+((p&255)+1)>>0]=s;n=n+1|0}}while(0);r=(u|0)==99?t+1|0:31;s=(x|0)!=0;i:do if((v|0)==1){if(s){f=bc(r<<2)|0;if(!f){l=0;A=152;break b}}else f=m;c[z+8>>2]=0;c[z+8+4>>2]=0;l=0;j:while(1){q=(f|0)==0;do{k:while(1){p=c[e+4>>2]|0;if(p>>>0<(c[e+100>>2]|0)>>>0){c[e+4>>2]=p+1;p=d[p>>0]|0}else p=Qf(e)|0;if(!(a[z+33+(p+1)>>0]|0))break j;a[z+32>>0]=p;switch(Be(z,z+32|0,1,z+8|0)|0){case -1:{l=0;A=152;break b}case -2:break;default:break k}}if(!q){c[f+(l<<2)>>2]=c[z>>2];l=l+1|0}}while(!(s&(l|0)==(r|0)));l=r<<1|1;p=kh(f,l<<2)|0;if(!p){l=0;A=152;break b}else{q=r;r=l;f=p;l=q}}if(!(vq(z+8|0)|0)){l=0;A=152;break b}else{q=l;l=0}}else{if(s){l=bc(r)|0;if(!l){l=0;f=0;A=152;break b}else p=0;while(1){do{f=c[e+4>>2]|0;if(f>>>0<(c[e+100>>2]|0)>>>0){c[e+4>>2]=f+1;f=d[f>>0]|0}else f=Qf(e)|0;if(!(a[z+33+(f+1)>>0]|0)){q=p;f=0;break i}a[l+p>>0]=f;p=p+1|0}while((p|0)!=(r|0));f=r<<1|1;p=kh(l,f)|0;if(!p){f=0;A=152;break b}else{q=r;r=f;l=p;p=q}}}if(!m){l=q;while(1){f=c[e+4>>2]|0;if(f>>>0<l>>>0){c[e+4>>2]=f+1;f=d[f>>0]|0}else f=Qf(e)|0;if(!(a[z+33+(f+1)>>0]|0)){q=0;l=0;f=0;break i}l=c[e+100>>2]|0}}else{l=0;while(1){f=c[e+4>>2]|0;if(f>>>0<q>>>0){c[e+4>>2]=f+1;f=d[f>>0]|0}else f=Qf(e)|0;if(!(a[z+33+(f+1)>>0]|0)){q=l;l=m;f=0;break i}a[m+l>>0]=f;q=c[e+100>>2]|0;l=l+1|0}}}while(0);if(!(c[e+100>>2]|0))p=c[e+4>>2]|0;else{p=(c[e+4>>2]|0)+-1|0;c[e+4>>2]=p}p=p-(c[e+8>>2]|0)+(c[e+108>>2]|0)|0;if(!p){m=x;break b}if(!((p|0)==(t|0)|(u|0)==99^1)){m=x;break b}do if(s)if((v|0)==1){c[m>>2]=f;break}else{c[m>>2]=l;break}while(0);if((u|0)!=99){if(f|0)c[f+(q<<2)>>2]=0;if(!l){l=0;break f}a[l+q>>0]=0}break}case 120:case 88:case 112:{p=16;A=134;break}case 111:{p=8;A=134;break}case 117:case 100:{p=10;A=134;break}case 105:{p=0;A=134;break}case 71:case 103:case 70:case 102:case 69:case 101:case 65:case 97:{o=+dc(e,v,0);if((c[e+108>>2]|0)==((c[e+8>>2]|0)-(c[e+4>>2]|0)|0)){m=x;break b}if(m)switch(v|0){case 0:{g[m>>2]=o;break f}case 1:{h[m>>3]=o;break f}case 2:{h[m>>3]=o;break f}default:break f}break}default:{}}while(0);l:do if((A|0)==134){A=0;p=pc(e,p,0,-1,-1)|0;if((c[e+108>>2]|0)==((c[e+8>>2]|0)-(c[e+4>>2]|0)|0)){m=x;break b}if((m|0)!=0&(u|0)==112){c[m>>2]=p;break}if(m)switch(v|0){case -2:{a[m>>0]=p;break l}case -1:{b[m>>1]=p;break l}case 0:{c[m>>2]=p;break l}case 1:{c[m>>2]=p;break l}case 3:{x=m;c[x>>2]=p;c[x+4>>2]=D;break l}default:break l}}while(0);k=((m|0)!=0&1)+k|0;p=(c[e+108>>2]|0)+w+(c[e+4>>2]|0)-(c[e+8>>2]|0)|0;break c}while(0);n=q+(m&1)|0;Ek(e,0);m=c[e+4>>2]|0;if(m>>>0<(c[e+100>>2]|0)>>>0){c[e+4>>2]=m+1;m=d[m>>0]|0}else m=Qf(e)|0;if((m|0)!=(d[n>>0]|0)){A=20;break b}p=s+1|0}else{n=q;while(1){m=n+1|0;if(!(Vr(d[m>>0]|0)|0))break;else n=m}Ek(e,0);do{m=c[e+4>>2]|0;if(m>>>0<(c[e+100>>2]|0)>>>0){c[e+4>>2]=m+1;m=d[m>>0]|0}else m=Qf(e)|0}while((Vr(m)|0)!=0);if(!(c[e+100>>2]|0))m=c[e+4>>2]|0;else{m=(c[e+4>>2]|0)+-1|0;c[e+4>>2]=m}p=(c[e+108>>2]|0)+s+m-(c[e+8>>2]|0)|0}while(0);q=n+1|0;m=a[q>>0]|0;if(!(m<<24>>24))break a;else s=p}if((A|0)==20){if(c[e+100>>2]|0)c[e+4>>2]=(c[e+4>>2]|0)+-1;if((k|0)!=0|(m|0)>-1)break;else{k=0;A=153}}else if((A|0)==152)if(!k){k=x;A=153}else m=x;if((A|0)==153){m=k;k=-1}if(m){kc(l);kc(f)}}else k=0;while(0);i=B;return k|0}function hc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0;l=c[b>>2]|0;n=c[b+4>>2]|0;k=c[b+8>>2]|0;f=c[b+12>>2]|0;u=c[b+16>>2]|0;t=c[b+20>>2]|0;g=c[b+24>>2]|0;v=c[b+28>>2]|0;s=c[b+32>>2]|0;q=c[b+36>>2]|0;cb=Pl(l|0,((l|0)<0)<<31>>31|0,l|0,((l|0)<0)<<31>>31|0)|0;bb=D;o=((l<<1|0)<0)<<31>>31;Ua=Pl(l<<1|0,o|0,n|0,((n|0)<0)<<31>>31|0)|0;Ta=D;Oa=Pl(k|0,((k|0)<0)<<31>>31|0,l<<1|0,o|0)|0;Na=D;Ea=Pl(f|0,((f|0)<0)<<31>>31|0,l<<1|0,o|0)|0;Da=D;sa=Pl(u|0,((u|0)<0)<<31>>31|0,l<<1|0,o|0)|0;ra=D;ia=Pl(t|0,((t|0)<0)<<31>>31|0,l<<1|0,o|0)|0;ha=D;_=Pl(g|0,((g|0)<0)<<31>>31|0,l<<1|0,o|0)|0;Z=D;Q=Pl(v|0,((v|0)<0)<<31>>31|0,l<<1|0,o|0)|0;P=D;G=Pl(s|0,((s|0)<0)<<31>>31|0,l<<1|0,o|0)|0;F=D;o=Pl(q|0,((q|0)<0)<<31>>31|0,l<<1|0,o|0)|0;l=D;p=((n<<1|0)<0)<<31>>31;Ma=Pl(n<<1|0,p|0,n|0,((n|0)<0)<<31>>31|0)|0;La=D;Ca=Pl(n<<1|0,p|0,k|0,((k|0)<0)<<31>>31|0)|0;Ba=D;w=((f<<1|0)<0)<<31>>31;wa=Pl(f<<1|0,w|0,n<<1|0,p|0)|0;va=D;ma=Pl(u|0,((u|0)<0)<<31>>31|0,n<<1|0,p|0)|0;la=D;aa=Pl(t<<1|0,((t<<1|0)<0)<<31>>31|0,n<<1|0,p|0)|0;$=D;S=Pl(g|0,((g|0)<0)<<31>>31|0,n<<1|0,p|0)|0;R=D;I=Pl(v<<1|0,((v<<1|0)<0)<<31>>31|0,n<<1|0,p|0)|0;H=D;m=Pl(s|0,((s|0)<0)<<31>>31|0,n<<1|0,p|0)|0;r=D;b=((q*38|0)<0)<<31>>31;p=Pl(q*38|0,b|0,n<<1|0,p|0)|0;n=D;ua=Pl(k|0,((k|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;ta=D;ka=Pl(k<<1|0,((k<<1|0)<0)<<31>>31|0,f|0,((f|0)<0)<<31>>31|0)|0;ja=D;ca=Pl(u|0,((u|0)<0)<<31>>31|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;ba=D;W=Pl(t|0,((t|0)<0)<<31>>31|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;V=D;O=Pl(g|0,((g|0)<0)<<31>>31|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;N=D;z=Pl(v|0,((v|0)<0)<<31>>31|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;y=D;Y=((s*19|0)<0)<<31>>31;Ya=Pl(s*19|0,Y|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;Xa=D;k=Pl(q*38|0,b|0,k|0,((k|0)<0)<<31>>31|0)|0;j=D;ea=Pl(f<<1|0,w|0,f|0,((f|0)<0)<<31>>31|0)|0;da=D;U=Pl(f<<1|0,w|0,u|0,((u|0)<0)<<31>>31|0)|0;T=D;K=Pl(t<<1|0,((t<<1|0)<0)<<31>>31|0,f<<1|0,w|0)|0;J=D;E=Pl(g|0,((g|0)<0)<<31>>31|0,f<<1|0,w|0)|0;C=D;qa=((v*38|0)<0)<<31>>31;_a=Pl(v*38|0,qa|0,f<<1|0,w|0)|0;Za=D;Qa=Pl(s*19|0,Y|0,f<<1|0,w|0)|0;Pa=D;w=Pl(q*38|0,b|0,f<<1|0,w|0)|0;f=D;M=Pl(u|0,((u|0)<0)<<31>>31|0,u|0,((u|0)<0)<<31>>31|0)|0;L=D;B=Pl(u<<1|0,((u<<1|0)<0)<<31>>31|0,t|0,((t|0)<0)<<31>>31|0)|0;A=D;ab=Pl(g*19|0,((g*19|0)<0)<<31>>31|0,u<<1|0,((u<<1|0)<0)<<31>>31|0)|0;$a=D;Sa=Pl(v*38|0,qa|0,u|0,((u|0)<0)<<31>>31|0)|0;Ra=D;Ga=Pl(s*19|0,Y|0,u<<1|0,((u<<1|0)<0)<<31>>31|0)|0;Fa=D;u=Pl(q*38|0,b|0,u|0,((u|0)<0)<<31>>31|0)|0;e=D;eb=Pl(t*38|0,((t*38|0)<0)<<31>>31|0,t|0,((t|0)<0)<<31>>31|0)|0;db=D;Wa=Pl(g*19|0,((g*19|0)<0)<<31>>31|0,t<<1|0,((t<<1|0)<0)<<31>>31|0)|0;Va=D;Ia=Pl(v*38|0,qa|0,t<<1|0,((t<<1|0)<0)<<31>>31|0)|0;Ha=D;ya=Pl(s*19|0,Y|0,t<<1|0,((t<<1|0)<0)<<31>>31|0)|0;xa=D;t=Pl(q*38|0,b|0,t<<1|0,((t<<1|0)<0)<<31>>31|0)|0;d=D;Ka=Pl(g*19|0,((g*19|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;Ja=D;Aa=Pl(v*38|0,qa|0,g|0,((g|0)<0)<<31>>31|0)|0;za=D;oa=Pl(s*19|0,Y|0,g<<1|0,((g<<1|0)<0)<<31>>31|0)|0;na=D;g=Pl(q*38|0,b|0,g|0,((g|0)<0)<<31>>31|0)|0;x=D;qa=Pl(v*38|0,qa|0,v|0,((v|0)<0)<<31>>31|0)|0;pa=D;ga=Pl(s*19|0,Y|0,v<<1|0,((v<<1|0)<0)<<31>>31|0)|0;fa=D;v=Pl(q*38|0,b|0,v<<1|0,((v<<1|0)<0)<<31>>31|0)|0;i=D;Y=Pl(s*19|0,Y|0,s|0,((s|0)<0)<<31>>31|0)|0;X=D;s=Pl(q*38|0,b|0,s|0,((s|0)<0)<<31>>31|0)|0;h=D;q=Pl(q*38|0,b|0,q|0,((q|0)<0)<<31>>31|0)|0;b=D;bb=go(eb|0,db|0,cb|0,bb|0)|0;$a=go(bb|0,D|0,ab|0,$a|0)|0;Za=go($a|0,D|0,_a|0,Za|0)|0;Xa=go(Za|0,D|0,Ya|0,Xa|0)|0;n=go(Xa|0,D|0,p|0,n|0)|0;p=D;Ta=go(Wa|0,Va|0,Ua|0,Ta|0)|0;Ra=go(Ta|0,D|0,Sa|0,Ra|0)|0;Pa=go(Ra|0,D|0,Qa|0,Pa|0)|0;j=go(Pa|0,D|0,k|0,j|0)|0;k=D;La=go(Oa|0,Na|0,Ma|0,La|0)|0;Ja=go(La|0,D|0,Ka|0,Ja|0)|0;Ha=go(Ja|0,D|0,Ia|0,Ha|0)|0;Fa=go(Ha|0,D|0,Ga|0,Fa|0)|0;f=go(Fa|0,D|0,w|0,f|0)|0;w=D;Ba=go(Ea|0,Da|0,Ca|0,Ba|0)|0;za=go(Ba|0,D|0,Aa|0,za|0)|0;xa=go(za|0,D|0,ya|0,xa|0)|0;e=go(xa|0,D|0,u|0,e|0)|0;u=D;ta=go(wa|0,va|0,ua|0,ta|0)|0;ra=go(ta|0,D|0,sa|0,ra|0)|0;pa=go(ra|0,D|0,qa|0,pa|0)|0;na=go(pa|0,D|0,oa|0,na|0)|0;d=go(na|0,D|0,t|0,d|0)|0;t=D;ja=go(ma|0,la|0,ka|0,ja|0)|0;ha=go(ja|0,D|0,ia|0,ha|0)|0;fa=go(ha|0,D|0,ga|0,fa|0)|0;x=go(fa|0,D|0,g|0,x|0)|0;g=D;ba=go(ea|0,da|0,ca|0,ba|0)|0;$=go(ba|0,D|0,aa|0,$|0)|0;Z=go($|0,D|0,_|0,Z|0)|0;X=go(Z|0,D|0,Y|0,X|0)|0;i=go(X|0,D|0,v|0,i|0)|0;v=D;T=go(W|0,V|0,U|0,T|0)|0;R=go(T|0,D|0,S|0,R|0)|0;P=go(R|0,D|0,Q|0,P|0)|0;h=go(P|0,D|0,s|0,h|0)|0;s=D;L=go(O|0,N|0,M|0,L|0)|0;J=go(L|0,D|0,K|0,J|0)|0;H=go(J|0,D|0,I|0,H|0)|0;F=go(H|0,D|0,G|0,F|0)|0;b=go(F|0,D|0,q|0,b|0)|0;q=D;A=go(E|0,C|0,B|0,A|0)|0;y=go(A|0,D|0,z|0,y|0)|0;r=go(y|0,D|0,m|0,r|0)|0;l=go(r|0,D|0,o|0,l|0)|0;o=D;p=Km(n|0,p|0,1)|0;n=D;k=Km(j|0,k|0,1)|0;j=D;w=Km(f|0,w|0,1)|0;f=D;u=Km(e|0,u|0,1)|0;e=D;t=Km(d|0,t|0,1)|0;d=D;g=Km(x|0,g|0,1)|0;x=D;v=Km(i|0,v|0,1)|0;i=D;s=Km(h|0,s|0,1)|0;h=D;q=Km(b|0,q|0,1)|0;b=D;o=Km(l|0,o|0,1)|0;l=D;r=go(p|0,n|0,33554432,0)|0;r=_l(r|0,D|0,26)|0;m=D;j=go(r|0,m|0,k|0,j|0)|0;k=D;m=Km(r|0,m|0,26)|0;m=Sm(p|0,n|0,m|0,D|0)|0;n=D;p=go(t|0,d|0,33554432,0)|0;p=_l(p|0,D|0,26)|0;r=D;x=go(p|0,r|0,g|0,x|0)|0;g=D;r=Km(p|0,r|0,26)|0;r=Sm(t|0,d|0,r|0,D|0)|0;d=D;t=go(j|0,k|0,16777216,0)|0;t=_l(t|0,D|0,25)|0;p=D;f=go(t|0,p|0,w|0,f|0)|0;w=D;p=Km(t|0,p|0,25)|0;p=Sm(j|0,k|0,p|0,D|0)|0;k=D;j=go(x|0,g|0,16777216,0)|0;j=_l(j|0,D|0,25)|0;t=D;i=go(j|0,t|0,v|0,i|0)|0;v=D;t=Km(j|0,t|0,25)|0;t=Sm(x|0,g|0,t|0,D|0)|0;g=D;x=go(f|0,w|0,33554432,0)|0;x=_l(x|0,D|0,26)|0;j=D;e=go(x|0,j|0,u|0,e|0)|0;u=D;j=Km(x|0,j|0,26)|0;j=Sm(f|0,w|0,j|0,D|0)|0;w=go(i|0,v|0,33554432,0)|0;w=_l(w|0,D|0,26)|0;f=D;h=go(w|0,f|0,s|0,h|0)|0;s=D;f=Km(w|0,f|0,26)|0;f=Sm(i|0,v|0,f|0,D|0)|0;v=go(e|0,u|0,16777216,0)|0;v=_l(v|0,D|0,25)|0;i=D;d=go(v|0,i|0,r|0,d|0)|0;r=D;i=Km(v|0,i|0,25)|0;i=Sm(e|0,u|0,i|0,D|0)|0;u=go(h|0,s|0,16777216,0)|0;u=_l(u|0,D|0,25)|0;e=D;b=go(u|0,e|0,q|0,b|0)|0;q=D;e=Km(u|0,e|0,25)|0;e=Sm(h|0,s|0,e|0,D|0)|0;s=go(d|0,r|0,33554432,0)|0;s=_l(s|0,D|0,26)|0;h=D;g=go(t|0,g|0,s|0,h|0)|0;h=Km(s|0,h|0,26)|0;h=Sm(d|0,r|0,h|0,D|0)|0;r=go(b|0,q|0,33554432,0)|0;r=_l(r|0,D|0,26)|0;d=D;l=go(r|0,d|0,o|0,l|0)|0;o=D;d=Km(r|0,d|0,26)|0;d=Sm(b|0,q|0,d|0,D|0)|0;q=go(l|0,o|0,16777216,0)|0;q=_l(q|0,D|0,25)|0;b=D;r=Pl(q|0,b|0,19,0)|0;n=go(r|0,D|0,m|0,n|0)|0;m=D;b=Km(q|0,b|0,25)|0;b=Sm(l|0,o|0,b|0,D|0)|0;o=go(n|0,m|0,33554432,0)|0;o=_l(o|0,D|0,26)|0;l=D;k=go(p|0,k|0,o|0,l|0)|0;l=Km(o|0,l|0,26)|0;l=Sm(n|0,m|0,l|0,D|0)|0;c[a>>2]=l;c[a+4>>2]=k;c[a+8>>2]=j;c[a+12>>2]=i;c[a+16>>2]=h;c[a+20>>2]=g;c[a+24>>2]=f;c[a+28>>2]=e;c[a+32>>2]=d;c[a+36>>2]=b;return}function ic(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0;l=c[b>>2]|0;p=c[b+4>>2]|0;k=c[b+8>>2]|0;f=c[b+12>>2]|0;C=c[b+16>>2]|0;d=c[b+20>>2]|0;g=c[b+24>>2]|0;O=c[b+28>>2]|0;A=c[b+32>>2]|0;q=c[b+36>>2]|0;cb=Pl(l|0,((l|0)<0)<<31>>31|0,l|0,((l|0)<0)<<31>>31|0)|0;bb=D;o=((l<<1|0)<0)<<31>>31;Ia=Pl(l<<1|0,o|0,p|0,((p|0)<0)<<31>>31|0)|0;Ha=D;Wa=Pl(k|0,((k|0)<0)<<31>>31|0,l<<1|0,o|0)|0;Va=D;Ua=Pl(f|0,((f|0)<0)<<31>>31|0,l<<1|0,o|0)|0;Ta=D;Oa=Pl(C|0,((C|0)<0)<<31>>31|0,l<<1|0,o|0)|0;Na=D;ya=Pl(d|0,((d|0)<0)<<31>>31|0,l<<1|0,o|0)|0;xa=D;ga=Pl(g|0,((g|0)<0)<<31>>31|0,l<<1|0,o|0)|0;fa=D;R=Pl(O|0,((O|0)<0)<<31>>31|0,l<<1|0,o|0)|0;Q=D;F=Pl(A|0,((A|0)<0)<<31>>31|0,l<<1|0,o|0)|0;E=D;o=Pl(q|0,((q|0)<0)<<31>>31|0,l<<1|0,o|0)|0;l=D;n=((p<<1|0)<0)<<31>>31;ta=Pl(p<<1|0,n|0,p|0,((p|0)<0)<<31>>31|0)|0;ua=D;ba=Pl(p<<1|0,n|0,k|0,((k|0)<0)<<31>>31|0)|0;ca=D;P=((f<<1|0)<0)<<31>>31;Sa=Pl(f<<1|0,P|0,p<<1|0,n|0)|0;Ra=D;Ca=Pl(C|0,((C|0)<0)<<31>>31|0,p<<1|0,n|0)|0;Ba=D;ia=Pl(d<<1|0,((d<<1|0)<0)<<31>>31|0,p<<1|0,n|0)|0;ha=D;T=Pl(g|0,((g|0)<0)<<31>>31|0,p<<1|0,n|0)|0;S=D;H=Pl(O<<1|0,((O<<1|0)<0)<<31>>31|0,p<<1|0,n|0)|0;G=D;t=Pl(A|0,((A|0)<0)<<31>>31|0,p<<1|0,n|0)|0;s=D;b=((q*38|0)<0)<<31>>31;n=Pl(q*38|0,b|0,p<<1|0,n|0)|0;p=D;Qa=Pl(k|0,((k|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;Pa=D;Aa=Pl(k<<1|0,((k<<1|0)<0)<<31>>31|0,f|0,((f|0)<0)<<31>>31|0)|0;za=D;ka=Pl(C|0,((C|0)<0)<<31>>31|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;ja=D;X=Pl(d|0,((d|0)<0)<<31>>31|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;W=D;N=Pl(g|0,((g|0)<0)<<31>>31|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;M=D;v=Pl(O|0,((O|0)<0)<<31>>31|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;u=D;ea=((A*19|0)<0)<<31>>31;Ya=Pl(A*19|0,ea|0,k<<1|0,((k<<1|0)<0)<<31>>31|0)|0;Xa=D;k=Pl(q*38|0,b|0,k|0,((k|0)<0)<<31>>31|0)|0;j=D;ma=Pl(f<<1|0,P|0,f|0,((f|0)<0)<<31>>31|0)|0;la=D;V=Pl(f<<1|0,P|0,C|0,((C|0)<0)<<31>>31|0)|0;U=D;J=Pl(d<<1|0,((d<<1|0)<0)<<31>>31|0,f<<1|0,P|0)|0;I=D;z=Pl(g|0,((g|0)<0)<<31>>31|0,f<<1|0,P|0)|0;y=D;Ma=((O*38|0)<0)<<31>>31;_a=Pl(O*38|0,Ma|0,f<<1|0,P|0)|0;Za=D;Ea=Pl(A*19|0,ea|0,f<<1|0,P|0)|0;Da=D;P=Pl(q*38|0,b|0,f<<1|0,P|0)|0;f=D;L=Pl(C|0,((C|0)<0)<<31>>31|0,C|0,((C|0)<0)<<31>>31|0)|0;K=D;x=Pl(C<<1|0,((C<<1|0)<0)<<31>>31|0,d|0,((d|0)<0)<<31>>31|0)|0;w=D;ab=Pl(g*19|0,((g*19|0)<0)<<31>>31|0,C<<1|0,((C<<1|0)<0)<<31>>31|0)|0;$a=D;Ga=Pl(O*38|0,Ma|0,C|0,((C|0)<0)<<31>>31|0)|0;Fa=D;oa=Pl(A*19|0,ea|0,C<<1|0,((C<<1|0)<0)<<31>>31|0)|0;na=D;C=Pl(q*38|0,b|0,C|0,((C|0)<0)<<31>>31|0)|0;e=D;eb=Pl(d*38|0,((d*38|0)<0)<<31>>31|0,d|0,((d|0)<0)<<31>>31|0)|0;db=D;Ka=Pl(g*19|0,((g*19|0)<0)<<31>>31|0,d<<1|0,((d<<1|0)<0)<<31>>31|0)|0;Ja=D;qa=Pl(O*38|0,Ma|0,d<<1|0,((d<<1|0)<0)<<31>>31|0)|0;pa=D;_=Pl(A*19|0,ea|0,d<<1|0,((d<<1|0)<0)<<31>>31|0)|0;Z=D;d=Pl(q*38|0,b|0,d<<1|0,((d<<1|0)<0)<<31>>31|0)|0;B=D;sa=Pl(g*19|0,((g*19|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;ra=D;aa=Pl(O*38|0,Ma|0,g|0,((g|0)<0)<<31>>31|0)|0;$=D;m=Pl(A*19|0,ea|0,g<<1|0,((g<<1|0)<0)<<31>>31|0)|0;r=D;g=Pl(q*38|0,b|0,g|0,((g|0)<0)<<31>>31|0)|0;Y=D;Ma=Pl(O*38|0,Ma|0,O|0,((O|0)<0)<<31>>31|0)|0;La=D;wa=Pl(A*19|0,ea|0,O<<1|0,((O<<1|0)<0)<<31>>31|0)|0;va=D;O=Pl(q*38|0,b|0,O<<1|0,((O<<1|0)<0)<<31>>31|0)|0;i=D;ea=Pl(A*19|0,ea|0,A|0,((A|0)<0)<<31>>31|0)|0;da=D;A=Pl(q*38|0,b|0,A|0,((A|0)<0)<<31>>31|0)|0;h=D;q=Pl(q*38|0,b|0,q|0,((q|0)<0)<<31>>31|0)|0;b=D;bb=go(eb|0,db|0,cb|0,bb|0)|0;$a=go(bb|0,D|0,ab|0,$a|0)|0;Za=go($a|0,D|0,_a|0,Za|0)|0;Xa=go(Za|0,D|0,Ya|0,Xa|0)|0;p=go(Xa|0,D|0,n|0,p|0)|0;n=D;ua=go(Wa|0,Va|0,ta|0,ua|0)|0;ta=D;ca=go(Ua|0,Ta|0,ba|0,ca|0)|0;ba=D;Pa=go(Sa|0,Ra|0,Qa|0,Pa|0)|0;Na=go(Pa|0,D|0,Oa|0,Na|0)|0;La=go(Na|0,D|0,Ma|0,La|0)|0;r=go(La|0,D|0,m|0,r|0)|0;B=go(r|0,D|0,d|0,B|0)|0;d=D;r=go(p|0,n|0,33554432,0)|0;r=_l(r|0,D|0,26)|0;m=D;Ha=go(Ka|0,Ja|0,Ia|0,Ha|0)|0;Fa=go(Ha|0,D|0,Ga|0,Fa|0)|0;Da=go(Fa|0,D|0,Ea|0,Da|0)|0;j=go(Da|0,D|0,k|0,j|0)|0;j=go(j|0,D|0,r|0,m|0)|0;k=D;m=Km(r|0,m|0,26)|0;m=Sm(p|0,n|0,m|0,D|0)|0;n=D;p=go(B|0,d|0,33554432,0)|0;p=_l(p|0,D|0,26)|0;r=D;za=go(Ca|0,Ba|0,Aa|0,za|0)|0;xa=go(za|0,D|0,ya|0,xa|0)|0;va=go(xa|0,D|0,wa|0,va|0)|0;Y=go(va|0,D|0,g|0,Y|0)|0;Y=go(Y|0,D|0,p|0,r|0)|0;g=D;r=Km(p|0,r|0,26)|0;r=Sm(B|0,d|0,r|0,D|0)|0;d=D;B=go(j|0,k|0,16777216,0)|0;B=_l(B|0,D|0,25)|0;p=D;ra=go(ua|0,ta|0,sa|0,ra|0)|0;pa=go(ra|0,D|0,qa|0,pa|0)|0;na=go(pa|0,D|0,oa|0,na|0)|0;f=go(na|0,D|0,P|0,f|0)|0;f=go(f|0,D|0,B|0,p|0)|0;P=D;p=Km(B|0,p|0,25)|0;p=Sm(j|0,k|0,p|0,D|0)|0;k=D;j=go(Y|0,g|0,16777216,0)|0;j=_l(j|0,D|0,25)|0;B=D;ja=go(ma|0,la|0,ka|0,ja|0)|0;ha=go(ja|0,D|0,ia|0,ha|0)|0;fa=go(ha|0,D|0,ga|0,fa|0)|0;da=go(fa|0,D|0,ea|0,da|0)|0;i=go(da|0,D|0,O|0,i|0)|0;i=go(i|0,D|0,j|0,B|0)|0;O=D;B=Km(j|0,B|0,25)|0;B=Sm(Y|0,g|0,B|0,D|0)|0;g=D;Y=go(f|0,P|0,33554432,0)|0;Y=_l(Y|0,D|0,26)|0;j=D;$=go(ca|0,ba|0,aa|0,$|0)|0;Z=go($|0,D|0,_|0,Z|0)|0;e=go(Z|0,D|0,C|0,e|0)|0;e=go(e|0,D|0,Y|0,j|0)|0;C=D;j=Km(Y|0,j|0,26)|0;j=Sm(f|0,P|0,j|0,D|0)|0;P=go(i|0,O|0,33554432,0)|0;P=_l(P|0,D|0,26)|0;f=D;U=go(X|0,W|0,V|0,U|0)|0;S=go(U|0,D|0,T|0,S|0)|0;Q=go(S|0,D|0,R|0,Q|0)|0;h=go(Q|0,D|0,A|0,h|0)|0;h=go(h|0,D|0,P|0,f|0)|0;A=D;f=Km(P|0,f|0,26)|0;f=Sm(i|0,O|0,f|0,D|0)|0;O=go(e|0,C|0,16777216,0)|0;O=_l(O|0,D|0,25)|0;i=D;d=go(O|0,i|0,r|0,d|0)|0;r=D;i=Km(O|0,i|0,25)|0;i=Sm(e|0,C|0,i|0,D|0)|0;C=go(h|0,A|0,16777216,0)|0;C=_l(C|0,D|0,25)|0;e=D;K=go(N|0,M|0,L|0,K|0)|0;I=go(K|0,D|0,J|0,I|0)|0;G=go(I|0,D|0,H|0,G|0)|0;E=go(G|0,D|0,F|0,E|0)|0;b=go(E|0,D|0,q|0,b|0)|0;b=go(b|0,D|0,C|0,e|0)|0;q=D;e=Km(C|0,e|0,25)|0;e=Sm(h|0,A|0,e|0,D|0)|0;A=go(d|0,r|0,33554432,0)|0;A=_l(A|0,D|0,26)|0;h=D;g=go(B|0,g|0,A|0,h|0)|0;h=Km(A|0,h|0,26)|0;h=Sm(d|0,r|0,h|0,D|0)|0;r=go(b|0,q|0,33554432,0)|0;r=_l(r|0,D|0,26)|0;d=D;w=go(z|0,y|0,x|0,w|0)|0;u=go(w|0,D|0,v|0,u|0)|0;s=go(u|0,D|0,t|0,s|0)|0;l=go(s|0,D|0,o|0,l|0)|0;l=go(l|0,D|0,r|0,d|0)|0;o=D;d=Km(r|0,d|0,26)|0;d=Sm(b|0,q|0,d|0,D|0)|0;q=go(l|0,o|0,16777216,0)|0;q=_l(q|0,D|0,25)|0;b=D;r=Pl(q|0,b|0,19,0)|0;n=go(r|0,D|0,m|0,n|0)|0;m=D;b=Km(q|0,b|0,25)|0;b=Sm(l|0,o|0,b|0,D|0)|0;o=go(n|0,m|0,33554432,0)|0;o=_l(o|0,D|0,26)|0;l=D;k=go(p|0,k|0,o|0,l|0)|0;l=Km(o|0,l|0,26)|0;l=Sm(n|0,m|0,l|0,D|0)|0;c[a>>2]=l;c[a+4>>2]=k;c[a+8>>2]=j;c[a+12>>2]=i;c[a+16>>2]=h;c[a+20>>2]=g;c[a+24>>2]=f;c[a+28>>2]=e;c[a+32>>2]=d;c[a+36>>2]=b;return}function jc(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;m=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;p=d[g+4>>0]|d[g+4+1>>0]<<8|d[g+4+2>>0]<<16|d[g+4+3>>0]<<24;h=d[g+8>>0]|d[g+8+1>>0]<<8|d[g+8+2>>0]<<16|d[g+8+3>>0]<<24;i=d[g+8+4>>0]|d[g+8+4+1>>0]<<8|d[g+8+4+2>>0]<<16|d[g+8+4+3>>0]<<24;f=Km(e|0,f|0,56)|0;g=D;if((c+e+(0-(e&7))|0)==(c|0)){r=h^2037671283;l=i^1952801890;o=m^1886610805;k=p^1936682341;j=h^1852075885;s=i^1685025377;i=m^1852142177;h=p^1819895653}else{u=c;r=h^2037671283;l=i^1952801890;o=m^1886610805;n=p^1936682341;k=h^1852075885;j=i^1685025377;i=m^1852142177;h=p^1819895653;while(1){v=u;t=d[v>>0]|d[v+1>>0]<<8|d[v+2>>0]<<16|d[v+3>>0]<<24;v=d[v+4>>0]|d[v+4+1>>0]<<8|d[v+4+2>>0]<<16|d[v+4+3>>0]<<24;p=t^r;r=v^l;m=go(o|0,n|0,k|0,j|0)|0;n=D;q=Km(k|0,j|0,13)|0;s=D;x=Mm(k|0,j|0,51)|0;s=(s|D)^n;h=go(p|0,r|0,i|0,h|0)|0;i=D;o=Km(p|0,r|0,16)|0;j=D;k=Mm(p|0,r|0,48)|0;j=(j|D)^i;n=go((o|k)^h|0,j|0,n|0,m|0)|0;r=D;l=Km((o|k)^h|0,j|0,21)|0;p=D;j=Mm((o|k)^h|0,j|0,43)|0;p=(p|D)^r;i=go(h|0,i|0,(q|x)^m|0,s|0)|0;h=D;k=Km((q|x)^m|0,s|0,17)|0;o=D;s=Mm((q|x)^m|0,s|0,47)|0;o=h^(o|D);r=go(n|0,r|0,i^(k|s)|0,o|0)|0;m=D;x=Km(i^(k|s)|0,o|0,13)|0;q=D;o=Mm(i^(k|s)|0,o|0,51)|0;q=(q|D)^m;i=go((l|j)^n|0,p|0,h|0,i|0)|0;h=D;s=Km((l|j)^n|0,p|0,16)|0;k=D;p=Mm((l|j)^n|0,p|0,48)|0;k=(k|D)^h;m=go((s|p)^i|0,k|0,m|0,r|0)|0;n=D;j=Km((s|p)^i|0,k|0,21)|0;l=D;k=Mm((s|p)^i|0,k|0,43)|0;l=(l|D)^n;h=go(i|0,h|0,(x|o)^r|0,q|0)|0;i=D;p=Km((x|o)^r|0,q|0,17)|0;s=D;q=Mm((x|o)^r|0,q|0,47)|0;s=(s|D)^i;u=u+8|0;if((u|0)==(c+e+(0-(e&7))|0)){c=c+e+(0-(e&7))|0;r=(j|k)^m;o=m^t;k=n^v;j=(p|q)^h;break}else{r=(j|k)^m;o=m^t;n=n^v;k=(p|q)^h;j=s}}}switch(e&7|0){case 7:{f=Km(d[c+6>>0]|0|0,0,48)|0|f;g=D|g;w=5;break}case 6:{w=5;break}case 5:{w=6;break}case 4:{w=7;break}case 3:{w=8;break}case 2:{w=9;break}case 1:{w=10;break}default:{}}if((w|0)==5){x=Km(d[c+5>>0]|0|0,0,40)|0;g=D|g;f=x|f;w=6}if((w|0)==6){g=d[c+4>>0]|0|g;w=7}if((w|0)==7){x=Km(d[c+3>>0]|0|0,0,24)|0;f=x|f;g=D|g;w=8}if((w|0)==8){x=Km(d[c+2>>0]|0|0,0,16)|0;f=x|f;g=D|g;w=9}if((w|0)==9){x=Km(d[c+1>>0]|0|0,0,8)|0;f=x|f;g=D|g;w=10}if((w|0)==10)f=d[c>>0]|0|f;u=f^r;n=g^l;e=go(o|0,k|0,j|0,s|0)|0;q=D;m=Km(j|0,s|0,13)|0;r=D;p=Mm(j|0,s|0,51)|0;r=(r|D)^q;v=go(u|0,n|0,i|0,h|0)|0;c=D;w=Km(u|0,n|0,16)|0;x=D;n=Mm(u|0,n|0,48)|0;x=(x|D)^c;q=go((w|n)^v|0,x|0,q|0,e|0)|0;u=D;o=Km((w|n)^v|0,x|0,21)|0;t=D;x=Mm((w|n)^v|0,x|0,43)|0;t=(t|D)^u;c=go(v|0,c|0,(m|p)^e|0,r|0)|0;v=D;n=Km((m|p)^e|0,r|0,17)|0;w=D;r=Mm((m|p)^e|0,r|0,47)|0;w=v^(w|D);u=go(q|0,u|0,c^(n|r)|0,w|0)|0;e=D;p=Km(c^(n|r)|0,w|0,13)|0;s=D;w=Mm(c^(n|r)|0,w|0,51)|0;s=(s|D)^e;c=go((o|x)^q|0,t|0,v|0,c|0)|0;v=D;r=Km((o|x)^q|0,t|0,16)|0;n=D;t=Mm((o|x)^q|0,t|0,48)|0;n=(n|D)^v;e=go((r|t)^c|0,n|0,e|0,u|0)|0;q=D;x=Km((r|t)^c|0,n|0,21)|0;o=D;n=Mm((r|t)^c|0,n|0,43)|0;o=(o|D)^q;v=go(c|0,v|0,(p|w)^u|0,s|0)|0;c=D;t=Km((p|w)^u|0,s|0,17)|0;r=D;s=Mm((p|w)^u|0,s|0,47)|0;r=(r|D)^c;q=go(e^f|0,q^g|0,(t|s)^v|0,r|0)|0;u=D;w=Km((t|s)^v|0,r|0,13)|0;p=D;r=Mm((t|s)^v|0,r|0,51)|0;p=u^(p|D);v=go((x|n)^e|0,o|0,c^255|0,v|0)|0;c=D;s=Km((x|n)^e|0,o|0,16)|0;t=D;o=Mm((x|n)^e|0,o|0,48)|0;t=(t|D)^c;u=go((s|o)^v|0,t|0,u|0,q|0)|0;e=D;n=Km((s|o)^v|0,t|0,21)|0;x=D;t=Mm((s|o)^v|0,t|0,43)|0;x=(x|D)^e;c=go(v|0,c|0,q^(w|r)|0,p|0)|0;v=D;o=Km(q^(w|r)|0,p|0,17)|0;s=D;p=Mm(q^(w|r)|0,p|0,47)|0;s=(s|D)^v;e=go(u|0,e|0,(o|p)^c|0,s|0)|0;r=D;w=Km((o|p)^c|0,s|0,13)|0;q=D;s=Mm((o|p)^c|0,s|0,51)|0;q=(q|D)^r;c=go((n|t)^u|0,x|0,v|0,c|0)|0;v=D;p=Km((n|t)^u|0,x|0,16)|0;o=D;x=Mm((n|t)^u|0,x|0,48)|0;o=(o|D)^v;r=go((p|x)^c|0,o|0,r|0,e|0)|0;u=D;t=Km((p|x)^c|0,o|0,21)|0;n=D;o=Mm((p|x)^c|0,o|0,43)|0;n=(n|D)^u;v=go(c|0,v|0,(w|s)^e|0,q|0)|0;c=D;x=Km((w|s)^e|0,q|0,17)|0;p=D;q=Mm((w|s)^e|0,q|0,47)|0;p=(p|D)^c;u=go(r|0,u|0,(x|q)^v|0,p|0)|0;e=D;s=Km((x|q)^v|0,p|0,13)|0;w=D;p=Mm((x|q)^v|0,p|0,51)|0;w=(w|D)^e;v=go((t|o)^r|0,n|0,c|0,v|0)|0;c=D;q=Km((t|o)^r|0,n|0,16)|0;x=D;n=Mm((t|o)^r|0,n|0,48)|0;x=(x|D)^c;e=go((q|n)^v|0,x|0,e|0,u|0)|0;r=D;o=Km((q|n)^v|0,x|0,21)|0;t=D;x=Mm((q|n)^v|0,x|0,43)|0;t=(t|D)^r;c=go(v|0,c|0,(s|p)^u|0,w|0)|0;v=D;n=Km((s|p)^u|0,w|0,17)|0;q=D;w=Mm((s|p)^u|0,w|0,47)|0;q=(q|D)^v;r=go(e|0,r|0,(n|w)^c|0,q|0)|0;u=D;p=Km((n|w)^c|0,q|0,13)|0;s=D;q=Mm((n|w)^c|0,q|0,51)|0;u=(s|D)^u;c=go((o|x)^e|0,t|0,v|0,c|0)|0;v=D;s=Km((o|x)^e|0,t|0,16)|0;w=D;t=Mm((o|x)^e|0,t|0,48)|0;w=(w|D)^v;e=Km((s|t)^c|0,w|0,21)|0;x=D;w=Mm((s|t)^c|0,w|0,43)|0;x=x|D;v=go(c|0,v|0,(p|q)^r|0,u|0)|0;c=D;t=Km((p|q)^r|0,u|0,17)|0;s=D;u=Mm((p|q)^r|0,u|0,47)|0;x=(s|D)^c^v^x;a[b>>0]=(t|u)^v^c^(e|w);a[b+1>>0]=((t|u)^v^c^(e|w))>>8;a[b+2>>0]=((t|u)^v^c^(e|w))>>16;a[b+3>>0]=((t|u)^v^c^(e|w))>>24;a[b+4>>0]=x;a[b+4+1>>0]=x>>8;a[b+4+2>>0]=x>>16;a[b+4+3>>0]=x>>24;return}function kc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!a)return;h=c[12596]|0;if((a+-8|0)>>>0<h>>>0)Ta();b=c[a+-4>>2]|0;if((b&3|0)==1)Ta();n=a+-8+(b&-8)|0;do if(!(b&1)){e=c[a+-8>>2]|0;if(!(b&3))return;k=a+-8+(0-e)|0;j=e+(b&-8)|0;if(k>>>0<h>>>0)Ta();if((k|0)==(c[12597]|0)){a=c[n+4>>2]|0;if((a&3|0)!=3){q=k;f=j;break}c[12594]=j;c[n+4>>2]=a&-2;c[k+4>>2]=j|1;c[k+j>>2]=j;return}if(e>>>0<256){a=c[k+8>>2]|0;b=c[k+12>>2]|0;if((a|0)!=(50408+(e>>>3<<1<<2)|0)){if(a>>>0<h>>>0)Ta();if((c[a+12>>2]|0)!=(k|0))Ta()}if((b|0)==(a|0)){c[12592]=c[12592]&~(1<<(e>>>3));q=k;f=j;break}if((b|0)!=(50408+(e>>>3<<1<<2)|0)){if(b>>>0<h>>>0)Ta();if((c[b+8>>2]|0)!=(k|0))Ta();else d=b+8|0}else d=b+8|0;c[a+12>>2]=b;c[d>>2]=a;q=k;f=j;break}g=c[k+24>>2]|0;a=c[k+12>>2]|0;do if((a|0)==(k|0)){a=c[k+16+4>>2]|0;if(!a){a=c[k+16>>2]|0;if(!a){i=0;break}else e=k+16|0}else e=k+16+4|0;while(1){b=a+20|0;d=c[b>>2]|0;if(d|0){a=d;e=b;continue}b=a+16|0;d=c[b>>2]|0;if(!d)break;else{a=d;e=b}}if(e>>>0<h>>>0)Ta();else{c[e>>2]=0;i=a;break}}else{b=c[k+8>>2]|0;if(b>>>0<h>>>0)Ta();if((c[b+12>>2]|0)!=(k|0))Ta();if((c[a+8>>2]|0)==(k|0)){c[b+12>>2]=a;c[a+8>>2]=b;i=a;break}else Ta()}while(0);if(g){a=c[k+28>>2]|0;if((k|0)==(c[50672+(a<<2)>>2]|0)){c[50672+(a<<2)>>2]=i;if(!i){c[12593]=c[12593]&~(1<<a);q=k;f=j;break}}else{if(g>>>0<(c[12596]|0)>>>0)Ta();if((c[g+16>>2]|0)==(k|0))c[g+16>>2]=i;else c[g+20>>2]=i;if(!i){q=k;f=j;break}}b=c[12596]|0;if(i>>>0<b>>>0)Ta();c[i+24>>2]=g;a=c[k+16>>2]|0;do if(a|0)if(a>>>0<b>>>0)Ta();else{c[i+16>>2]=a;c[a+24>>2]=i;break}while(0);a=c[k+16+4>>2]|0;if(a)if(a>>>0<(c[12596]|0)>>>0)Ta();else{c[i+20>>2]=a;c[a+24>>2]=i;q=k;f=j;break}else{q=k;f=j}}else{q=k;f=j}}else{q=a+-8|0;f=b&-8}while(0);if(q>>>0>=n>>>0)Ta();d=c[n+4>>2]|0;if(!(d&1))Ta();if(!(d&2)){if((n|0)==(c[12598]|0)){p=(c[12595]|0)+f|0;c[12595]=p;c[12598]=q;c[q+4>>2]=p|1;if((q|0)!=(c[12597]|0))return;c[12597]=0;c[12594]=0;return}if((n|0)==(c[12597]|0)){p=(c[12594]|0)+f|0;c[12594]=p;c[12597]=q;c[q+4>>2]=p|1;c[q+p>>2]=p;return}f=(d&-8)+f|0;do if(d>>>0>=256){g=c[n+24>>2]|0;a=c[n+12>>2]|0;do if((a|0)==(n|0)){a=c[n+16+4>>2]|0;if(!a){a=c[n+16>>2]|0;if(!a){m=0;break}else e=n+16|0}else e=n+16+4|0;while(1){b=a+20|0;d=c[b>>2]|0;if(d|0){a=d;e=b;continue}b=a+16|0;d=c[b>>2]|0;if(!d)break;else{a=d;e=b}}if(e>>>0<(c[12596]|0)>>>0)Ta();else{c[e>>2]=0;m=a;break}}else{b=c[n+8>>2]|0;if(b>>>0<(c[12596]|0)>>>0)Ta();if((c[b+12>>2]|0)!=(n|0))Ta();if((c[a+8>>2]|0)==(n|0)){c[b+12>>2]=a;c[a+8>>2]=b;m=a;break}else Ta()}while(0);if(g|0){a=c[n+28>>2]|0;if((n|0)==(c[50672+(a<<2)>>2]|0)){c[50672+(a<<2)>>2]=m;if(!m){c[12593]=c[12593]&~(1<<a);break}}else{if(g>>>0<(c[12596]|0)>>>0)Ta();if((c[g+16>>2]|0)==(n|0))c[g+16>>2]=m;else c[g+20>>2]=m;if(!m)break}b=c[12596]|0;if(m>>>0<b>>>0)Ta();c[m+24>>2]=g;a=c[n+16>>2]|0;do if(a|0)if(a>>>0<b>>>0)Ta();else{c[m+16>>2]=a;c[a+24>>2]=m;break}while(0);a=c[n+16+4>>2]|0;if(a|0)if(a>>>0<(c[12596]|0)>>>0)Ta();else{c[m+20>>2]=a;c[a+24>>2]=m;break}}}else{a=c[n+8>>2]|0;b=c[n+12>>2]|0;if((a|0)!=(50408+(d>>>3<<1<<2)|0)){if(a>>>0<(c[12596]|0)>>>0)Ta();if((c[a+12>>2]|0)!=(n|0))Ta()}if((b|0)==(a|0)){c[12592]=c[12592]&~(1<<(d>>>3));break}if((b|0)!=(50408+(d>>>3<<1<<2)|0)){if(b>>>0<(c[12596]|0)>>>0)Ta();if((c[b+8>>2]|0)!=(n|0))Ta();else l=b+8|0}else l=b+8|0;c[a+12>>2]=b;c[l>>2]=a}while(0);c[q+4>>2]=f|1;c[q+f>>2]=f;if((q|0)==(c[12597]|0)){c[12594]=f;return}}else{c[n+4>>2]=d&-2;c[q+4>>2]=f|1;c[q+f>>2]=f}b=f>>>3;if(f>>>0<256){a=c[12592]|0;if(a&1<<b){a=c[50408+(b<<1<<2)+8>>2]|0;if(a>>>0<(c[12596]|0)>>>0)Ta();else{o=50408+(b<<1<<2)+8|0;p=a}}else{c[12592]=a|1<<b;o=50408+(b<<1<<2)+8|0;p=50408+(b<<1<<2)|0}c[o>>2]=q;c[p+12>>2]=q;c[q+8>>2]=p;c[q+12>>2]=50408+(b<<1<<2);return}a=f>>>8;if(a)if(f>>>0>16777215)d=31;else{d=a<<((a+1048320|0)>>>16&8)<<(((a<<((a+1048320|0)>>>16&8))+520192|0)>>>16&4);d=14-(((a<<((a+1048320|0)>>>16&8))+520192|0)>>>16&4|(a+1048320|0)>>>16&8|(d+245760|0)>>>16&2)+(d<<((d+245760|0)>>>16&2)>>>15)|0;d=f>>>(d+7|0)&1|d<<1}else d=0;e=50672+(d<<2)|0;c[q+28>>2]=d;c[q+20>>2]=0;c[q+16>>2]=0;a=c[12593]|0;b=1<<d;do if(a&b){d=f<<((d|0)==31?0:25-(d>>>1)|0);e=c[e>>2]|0;while(1){if((c[e+4>>2]&-8|0)==(f|0)){a=130;break}b=e+16+(d>>>31<<2)|0;a=c[b>>2]|0;if(!a){a=127;break}else{d=d<<1;e=a}}if((a|0)==127)if(b>>>0<(c[12596]|0)>>>0)Ta();else{c[b>>2]=q;c[q+24>>2]=e;c[q+12>>2]=q;c[q+8>>2]=q;break}else if((a|0)==130){a=e+8|0;b=c[a>>2]|0;p=c[12596]|0;if(b>>>0>=p>>>0&e>>>0>=p>>>0){c[b+12>>2]=q;c[a>>2]=q;c[q+8>>2]=b;c[q+12>>2]=e;c[q+24>>2]=0;break}else Ta()}}else{c[12593]=a|b;c[e>>2]=q;c[q+24>>2]=e;c[q+12>>2]=q;c[q+8>>2]=q}while(0);q=(c[12600]|0)+-1|0;c[12600]=q;if(!q)a=50824;else return;while(1){a=c[a>>2]|0;if(!a)break;else a=a+8|0}c[12600]=-1;return}function lc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c[a+4>>2]|0;do if(!(d&1)){l=c[a>>2]|0;if(!(d&3))return;j=c[12596]|0;if((a+(0-l)|0)>>>0<j>>>0)Ta();if((a+(0-l)|0)==(c[12597]|0)){d=c[a+b+4>>2]|0;if((d&3|0)!=3){q=a+(0-l)|0;h=l+b|0;break}c[12594]=l+b;c[a+b+4>>2]=d&-2;c[a+(0-l)+4>>2]=l+b|1;c[a+(0-l)+(l+b)>>2]=l+b;return}if(l>>>0<256){d=c[a+(0-l)+8>>2]|0;e=c[a+(0-l)+12>>2]|0;if((d|0)!=(50408+(l>>>3<<1<<2)|0)){if(d>>>0<j>>>0)Ta();if((c[d+12>>2]|0)!=(a+(0-l)|0))Ta()}if((e|0)==(d|0)){c[12592]=c[12592]&~(1<<(l>>>3));q=a+(0-l)|0;h=l+b|0;break}if((e|0)!=(50408+(l>>>3<<1<<2)|0)){if(e>>>0<j>>>0)Ta();if((c[e+8>>2]|0)!=(a+(0-l)|0))Ta();else f=e+8|0}else f=e+8|0;c[d+12>>2]=e;c[f>>2]=d;q=a+(0-l)|0;h=l+b|0;break}i=c[a+(0-l)+24>>2]|0;d=c[a+(0-l)+12>>2]|0;do if((d|0)==(a+(0-l)|0)){e=a+(0-l)+16|0;d=c[e+4>>2]|0;if(!d){d=c[e>>2]|0;if(!d){k=0;break}}else e=e+4|0;while(1){f=d+20|0;g=c[f>>2]|0;if(g|0){d=g;e=f;continue}f=d+16|0;g=c[f>>2]|0;if(!g)break;else{d=g;e=f}}if(e>>>0<j>>>0)Ta();else{c[e>>2]=0;k=d;break}}else{e=c[a+(0-l)+8>>2]|0;if(e>>>0<j>>>0)Ta();if((c[e+12>>2]|0)!=(a+(0-l)|0))Ta();if((c[d+8>>2]|0)==(a+(0-l)|0)){c[e+12>>2]=d;c[d+8>>2]=e;k=d;break}else Ta()}while(0);if(i){d=c[a+(0-l)+28>>2]|0;if((a+(0-l)|0)==(c[50672+(d<<2)>>2]|0)){c[50672+(d<<2)>>2]=k;if(!k){c[12593]=c[12593]&~(1<<d);q=a+(0-l)|0;h=l+b|0;break}}else{if(i>>>0<(c[12596]|0)>>>0)Ta();if((c[i+16>>2]|0)==(a+(0-l)|0))c[i+16>>2]=k;else c[i+20>>2]=k;if(!k){q=a+(0-l)|0;h=l+b|0;break}}e=c[12596]|0;if(k>>>0<e>>>0)Ta();c[k+24>>2]=i;d=c[a+(0-l)+16>>2]|0;do if(d|0)if(d>>>0<e>>>0)Ta();else{c[k+16>>2]=d;c[d+24>>2]=k;break}while(0);d=c[a+(0-l)+16+4>>2]|0;if(d)if(d>>>0<(c[12596]|0)>>>0)Ta();else{c[k+20>>2]=d;c[d+24>>2]=k;q=a+(0-l)|0;h=l+b|0;break}else{q=a+(0-l)|0;h=l+b|0}}else{q=a+(0-l)|0;h=l+b|0}}else{q=a;h=b}while(0);j=c[12596]|0;if((a+b|0)>>>0<j>>>0)Ta();f=c[a+b+4>>2]|0;if(!(f&2)){if((a+b|0)==(c[12598]|0)){p=(c[12595]|0)+h|0;c[12595]=p;c[12598]=q;c[q+4>>2]=p|1;if((q|0)!=(c[12597]|0))return;c[12597]=0;c[12594]=0;return}if((a+b|0)==(c[12597]|0)){p=(c[12594]|0)+h|0;c[12594]=p;c[12597]=q;c[q+4>>2]=p|1;c[q+p>>2]=p;return}h=(f&-8)+h|0;do if(f>>>0>=256){i=c[a+b+24>>2]|0;d=c[a+b+12>>2]|0;do if((d|0)==(a+b|0)){d=c[a+b+16+4>>2]|0;if(!d){d=c[a+b+16>>2]|0;if(!d){n=0;break}else g=a+b+16|0}else g=a+b+16+4|0;while(1){e=d+20|0;f=c[e>>2]|0;if(f|0){d=f;g=e;continue}e=d+16|0;f=c[e>>2]|0;if(!f)break;else{d=f;g=e}}if(g>>>0<j>>>0)Ta();else{c[g>>2]=0;n=d;break}}else{e=c[a+b+8>>2]|0;if(e>>>0<j>>>0)Ta();if((c[e+12>>2]|0)!=(a+b|0))Ta();if((c[d+8>>2]|0)==(a+b|0)){c[e+12>>2]=d;c[d+8>>2]=e;n=d;break}else Ta()}while(0);if(i|0){d=c[a+b+28>>2]|0;if((a+b|0)==(c[50672+(d<<2)>>2]|0)){c[50672+(d<<2)>>2]=n;if(!n){c[12593]=c[12593]&~(1<<d);break}}else{if(i>>>0<(c[12596]|0)>>>0)Ta();if((c[i+16>>2]|0)==(a+b|0))c[i+16>>2]=n;else c[i+20>>2]=n;if(!n)break}e=c[12596]|0;if(n>>>0<e>>>0)Ta();c[n+24>>2]=i;d=c[a+b+16>>2]|0;do if(d|0)if(d>>>0<e>>>0)Ta();else{c[n+16>>2]=d;c[d+24>>2]=n;break}while(0);d=c[a+b+16+4>>2]|0;if(d|0)if(d>>>0<(c[12596]|0)>>>0)Ta();else{c[n+20>>2]=d;c[d+24>>2]=n;break}}}else{d=c[a+b+8>>2]|0;e=c[a+b+12>>2]|0;if((d|0)!=(50408+(f>>>3<<1<<2)|0)){if(d>>>0<j>>>0)Ta();if((c[d+12>>2]|0)!=(a+b|0))Ta()}if((e|0)==(d|0)){c[12592]=c[12592]&~(1<<(f>>>3));break}if((e|0)!=(50408+(f>>>3<<1<<2)|0)){if(e>>>0<j>>>0)Ta();if((c[e+8>>2]|0)!=(a+b|0))Ta();else m=e+8|0}else m=e+8|0;c[d+12>>2]=e;c[m>>2]=d}while(0);c[q+4>>2]=h|1;c[q+h>>2]=h;if((q|0)==(c[12597]|0)){c[12594]=h;return}}else{c[a+b+4>>2]=f&-2;c[q+4>>2]=h|1;c[q+h>>2]=h}e=h>>>3;if(h>>>0<256){d=c[12592]|0;if(d&1<<e){d=c[50408+(e<<1<<2)+8>>2]|0;if(d>>>0<(c[12596]|0)>>>0)Ta();else{o=50408+(e<<1<<2)+8|0;p=d}}else{c[12592]=d|1<<e;o=50408+(e<<1<<2)+8|0;p=50408+(e<<1<<2)|0}c[o>>2]=q;c[p+12>>2]=q;c[q+8>>2]=p;c[q+12>>2]=50408+(e<<1<<2);return}d=h>>>8;if(d)if(h>>>0>16777215)f=31;else{f=d<<((d+1048320|0)>>>16&8)<<(((d<<((d+1048320|0)>>>16&8))+520192|0)>>>16&4);f=14-(((d<<((d+1048320|0)>>>16&8))+520192|0)>>>16&4|(d+1048320|0)>>>16&8|(f+245760|0)>>>16&2)+(f<<((f+245760|0)>>>16&2)>>>15)|0;f=h>>>(f+7|0)&1|f<<1}else f=0;g=50672+(f<<2)|0;c[q+28>>2]=f;c[q+20>>2]=0;c[q+16>>2]=0;d=c[12593]|0;e=1<<f;if(!(d&e)){c[12593]=d|e;c[g>>2]=q;c[q+24>>2]=g;c[q+12>>2]=q;c[q+8>>2]=q;return}f=h<<((f|0)==31?0:25-(f>>>1)|0);g=c[g>>2]|0;while(1){if((c[g+4>>2]&-8|0)==(h|0)){d=127;break}e=g+16+(f>>>31<<2)|0;d=c[e>>2]|0;if(!d){d=124;break}else{f=f<<1;g=d}}if((d|0)==124){if(e>>>0<(c[12596]|0)>>>0)Ta();c[e>>2]=q;c[q+24>>2]=g;c[q+12>>2]=q;c[q+8>>2]=q;return}else if((d|0)==127){d=g+8|0;e=c[d>>2]|0;p=c[12596]|0;if(!(e>>>0>=p>>>0&g>>>0>=p>>>0))Ta();c[e+12>>2]=q;c[d>>2]=q;c[q+8>>2]=e;c[q+12>>2]=g;c[q+24>>2]=0;return}}function mc(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;U=i;T=i=i+63&-64;i=i+64|0;if(!((g|0)==0&(h|0)==0)){if(h>>>0>63|(h|0)==63&g>>>0>4294967232)Ta();F=c[b>>2]|0;G=c[b+4>>2]|0;H=c[b+8>>2]|0;I=c[b+12>>2]|0;J=c[b+16>>2]|0;K=c[b+20>>2]|0;L=c[b+24>>2]|0;M=c[b+28>>2]|0;N=c[b+32>>2]|0;O=c[b+36>>2]|0;P=c[b+40>>2]|0;Q=c[b+44>>2]|0;R=c[b+56>>2]|0;S=c[b+60>>2]|0;j=0;l=c[b+48>>2]|0;C=c[b+52>>2]|0;while(1){E=h>>>0<0|(h|0)==0&g>>>0<64;if(E){j=T;k=j+64|0;do{a[j>>0]=0;j=j+1|0}while((j|0)<(k|0));j=0;do{a[T+j>>0]=a[e+j>>0]|0;j=j+1|0}while(0<h>>>0|0==(h|0)&j>>>0<g>>>0);e=T;B=T;j=f}else B=f;f=20;k=F;m=G;n=P;o=Q;p=l;q=C;r=R;s=S;t=H;u=I;v=J;w=K;x=L;y=M;z=N;A=O;do{ma=k+v|0;ba=ma^p;aa=(ba<<16|ba>>>16)+z|0;la=aa^v;ba=(la<<12|la>>>20)+ma^(ba<<16|ba>>>16);V=(ba<<8|ba>>>24)+aa^(la<<12|la>>>20);ia=m+w|0;X=ia^q;W=(X<<16|X>>>16)+A|0;ha=W^w;X=(ha<<12|ha>>>20)+ia^(X<<16|X>>>16);ja=(X<<8|X>>>24)+W^(ha<<12|ha>>>20);da=t+x|0;Y=da^r;ka=(Y<<16|Y>>>16)+n|0;ca=ka^x;Y=(ca<<12|ca>>>20)+da^(Y<<16|Y>>>16);ea=(Y<<8|Y>>>24)+ka^(ca<<12|ca>>>20);Z=u+y|0;ga=Z^s;fa=(ga<<16|ga>>>16)+o|0;_=fa^y;ga=(_<<12|_>>>20)+Z^(ga<<16|ga>>>16);$=(ga<<8|ga>>>24)+fa^(_<<12|_>>>20);ma=(ja<<7|ja>>>25)+((la<<12|la>>>20)+ma)|0;la=(ma^(ga<<8|ga>>>24))<<16|(ma^(ga<<8|ga>>>24))>>>16;ja=la+((Y<<8|Y>>>24)+ka)^(ja<<7|ja>>>25);k=(ja<<12|ja>>>20)+ma|0;ma=k^la;s=ma<<8|ma>>>24;n=s+(la+((Y<<8|Y>>>24)+ka))|0;ja=n^(ja<<12|ja>>>20);w=ja<<7|ja>>>25;ia=(ea<<7|ea>>>25)+((ha<<12|ha>>>20)+ia)|0;ha=(ia^(ba<<8|ba>>>24))<<16|(ia^(ba<<8|ba>>>24))>>>16;ea=ha+((ga<<8|ga>>>24)+fa)^(ea<<7|ea>>>25);m=(ea<<12|ea>>>20)+ia|0;ia=m^ha;p=ia<<8|ia>>>24;o=p+(ha+((ga<<8|ga>>>24)+fa))|0;ea=o^(ea<<12|ea>>>20);x=ea<<7|ea>>>25;da=($<<7|$>>>25)+((ca<<12|ca>>>20)+da)|0;ca=(da^(X<<8|X>>>24))<<16|(da^(X<<8|X>>>24))>>>16;$=ca+((ba<<8|ba>>>24)+aa)^($<<7|$>>>25);t=($<<12|$>>>20)+da|0;da=t^ca;q=da<<8|da>>>24;z=q+(ca+((ba<<8|ba>>>24)+aa))|0;$=z^($<<12|$>>>20);y=$<<7|$>>>25;Z=(V<<7|V>>>25)+((_<<12|_>>>20)+Z)|0;Y=(Z^(Y<<8|Y>>>24))<<16|(Z^(Y<<8|Y>>>24))>>>16;V=Y+((X<<8|X>>>24)+W)^(V<<7|V>>>25);u=(V<<12|V>>>20)+Z|0;Z=u^Y;r=Z<<8|Z>>>24;A=r+(Y+((X<<8|X>>>24)+W))|0;V=A^(V<<12|V>>>20);v=V<<7|V>>>25;f=f+-2|0}while((f|0)!=0);f=(d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24)^k+F;Z=e+4|0;Z=(d[Z>>0]|d[Z+1>>0]<<8|d[Z+2>>0]<<16|d[Z+3>>0]<<24)^m+G;_=e+8|0;_=(d[_>>0]|d[_+1>>0]<<8|d[_+2>>0]<<16|d[_+3>>0]<<24)^t+H;$=e+12|0;$=(d[$>>0]|d[$+1>>0]<<8|d[$+2>>0]<<16|d[$+3>>0]<<24)^u+I;aa=e+16|0;aa=(d[aa>>0]|d[aa+1>>0]<<8|d[aa+2>>0]<<16|d[aa+3>>0]<<24)^v+J;ba=e+20|0;ba=(d[ba>>0]|d[ba+1>>0]<<8|d[ba+2>>0]<<16|d[ba+3>>0]<<24)^w+K;ca=e+24|0;ca=(d[ca>>0]|d[ca+1>>0]<<8|d[ca+2>>0]<<16|d[ca+3>>0]<<24)^x+L;da=e+28|0;da=(d[da>>0]|d[da+1>>0]<<8|d[da+2>>0]<<16|d[da+3>>0]<<24)^y+M;ea=e+32|0;ea=(d[ea>>0]|d[ea+1>>0]<<8|d[ea+2>>0]<<16|d[ea+3>>0]<<24)^z+N;fa=e+36|0;fa=(d[fa>>0]|d[fa+1>>0]<<8|d[fa+2>>0]<<16|d[fa+3>>0]<<24)^A+O;ga=e+40|0;ga=(d[ga>>0]|d[ga+1>>0]<<8|d[ga+2>>0]<<16|d[ga+3>>0]<<24)^n+P;ha=e+44|0;ha=(d[ha>>0]|d[ha+1>>0]<<8|d[ha+2>>0]<<16|d[ha+3>>0]<<24)^o+Q;ia=e+48|0;ia=(d[ia>>0]|d[ia+1>>0]<<8|d[ia+2>>0]<<16|d[ia+3>>0]<<24)^p+l;ja=e+52|0;ja=(d[ja>>0]|d[ja+1>>0]<<8|d[ja+2>>0]<<16|d[ja+3>>0]<<24)^q+C;ka=e+56|0;ka=(d[ka>>0]|d[ka+1>>0]<<8|d[ka+2>>0]<<16|d[ka+3>>0]<<24)^r+R;la=e+60|0;la=(d[la>>0]|d[la+1>>0]<<8|d[la+2>>0]<<16|d[la+3>>0]<<24)^s+S;l=l+1|0;k=((l|0)==0&1)+C|0;a[B>>0]=f;a[B+1>>0]=f>>8;a[B+2>>0]=f>>16;a[B+3>>0]=f>>24;ma=B+4|0;a[ma>>0]=Z;a[ma+1>>0]=Z>>8;a[ma+2>>0]=Z>>16;a[ma+3>>0]=Z>>24;ma=B+8|0;a[ma>>0]=_;a[ma+1>>0]=_>>8;a[ma+2>>0]=_>>16;a[ma+3>>0]=_>>24;ma=B+12|0;a[ma>>0]=$;a[ma+1>>0]=$>>8;a[ma+2>>0]=$>>16;a[ma+3>>0]=$>>24;ma=B+16|0;a[ma>>0]=aa;a[ma+1>>0]=aa>>8;a[ma+2>>0]=aa>>16;a[ma+3>>0]=aa>>24;ma=B+20|0;a[ma>>0]=ba;a[ma+1>>0]=ba>>8;a[ma+2>>0]=ba>>16;a[ma+3>>0]=ba>>24;ma=B+24|0;a[ma>>0]=ca;a[ma+1>>0]=ca>>8;a[ma+2>>0]=ca>>16;a[ma+3>>0]=ca>>24;ma=B+28|0;a[ma>>0]=da;a[ma+1>>0]=da>>8;a[ma+2>>0]=da>>16;a[ma+3>>0]=da>>24;ma=B+32|0;a[ma>>0]=ea;a[ma+1>>0]=ea>>8;a[ma+2>>0]=ea>>16;a[ma+3>>0]=ea>>24;ma=B+36|0;a[ma>>0]=fa;a[ma+1>>0]=fa>>8;a[ma+2>>0]=fa>>16;a[ma+3>>0]=fa>>24;ma=B+40|0;a[ma>>0]=ga;a[ma+1>>0]=ga>>8;a[ma+2>>0]=ga>>16;a[ma+3>>0]=ga>>24;ma=B+44|0;a[ma>>0]=ha;a[ma+1>>0]=ha>>8;a[ma+2>>0]=ha>>16;a[ma+3>>0]=ha>>24;ma=B+48|0;a[ma>>0]=ia;a[ma+1>>0]=ia>>8;a[ma+2>>0]=ia>>16;a[ma+3>>0]=ia>>24;ma=B+52|0;a[ma>>0]=ja;a[ma+1>>0]=ja>>8;a[ma+2>>0]=ja>>16;a[ma+3>>0]=ja>>24;ma=B+56|0;a[ma>>0]=ka;a[ma+1>>0]=ka>>8;a[ma+2>>0]=ka>>16;a[ma+3>>0]=ka>>24;ma=B+60|0;a[ma>>0]=la;a[ma+1>>0]=la>>8;a[ma+2>>0]=la>>16;a[ma+3>>0]=la>>24;if(h>>>0<0|(h|0)==0&g>>>0<65)break;C=go(g|0,h|0,-64,-1)|0;e=e+64|0;f=B+64|0;h=D;g=C;C=k}if((E?g|0:0)?(a[j>>0]=f,(g|0)!=1):0){e=1;do{a[j+e>>0]=a[B+e>>0]|0;e=e+1|0}while((e|0)!=(g|0))}c[b+48>>2]=l;c[b+52>>2]=k}i=U;return}function nc(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,p=0,q=0;q=i;p=i=i+63&-64;i=i+112|0;if(b){n=Ro(e,53636)|0;b=c[n>>2]|0;if(d){Gb[c[b+44>>2]&127](p+108|0,n);d=c[p+108>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;Gb[c[(c[n>>2]|0)+32>>2]&127](p+96|0,n);if((a[l+11>>0]|0)<0){a[c[l>>2]>>0]=0;c[l+4>>2]=0}else{a[l>>0]=0;a[l+11>>0]=0}o=0;ba(142,l|0);f=o;o=0;if(f&1){f=Za(0)|0;xr(f)}c[l>>2]=c[p+96>>2];c[l+4>>2]=c[p+96+4>>2];c[l+8>>2]=c[p+96+8>>2];b=0;while(1){if((b|0)==3)break;c[p+96+(b<<2)>>2]=0;b=b+1|0}Oo(p+96|0);e=n}else{Gb[c[b+40>>2]&127](p+92|0,n);d=c[p+92>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;Gb[c[(c[n>>2]|0)+28>>2]&127](p+80|0,n);if((a[l+11>>0]|0)<0){a[c[l>>2]>>0]=0;c[l+4>>2]=0}else{a[l>>0]=0;a[l+11>>0]=0}o=0;ba(142,l|0);f=o;o=0;if(f&1){f=Za(0)|0;xr(f)}c[l>>2]=c[p+80>>2];c[l+4>>2]=c[p+80+4>>2];c[l+8>>2]=c[p+80+8>>2];b=0;while(1){if((b|0)==3)break;c[p+80+(b<<2)>>2]=0;b=b+1|0}Oo(p+80|0);e=n}a[g>>0]=Ib[c[(c[n>>2]|0)+12>>2]&127](n)|0;a[h>>0]=Ib[c[(c[n>>2]|0)+16>>2]&127](n)|0;Gb[c[(c[e>>2]|0)+20>>2]&127](p+68|0,n);if((a[j+11>>0]|0)<0){a[c[j>>2]>>0]=0;c[j+4>>2]=0}else{a[j>>0]=0;a[j+11>>0]=0}o=0;ba(142,j|0);h=o;o=0;if(h&1){h=Za(0)|0;xr(h)}c[j>>2]=c[p+68>>2];c[j+4>>2]=c[p+68+4>>2];c[j+8>>2]=c[p+68+8>>2];b=0;while(1){if((b|0)==3)break;c[p+68+(b<<2)>>2]=0;b=b+1|0}Oo(p+68|0);Gb[c[(c[e>>2]|0)+24>>2]&127](p+56|0,n);if((a[k+11>>0]|0)<0){a[c[k>>2]>>0]=0;c[k+4>>2]=0}else{a[k>>0]=0;a[k+11>>0]=0}o=0;ba(142,k|0);h=o;o=0;if(h&1){h=Za(0)|0;xr(h)}c[k>>2]=c[p+56>>2];c[k+4>>2]=c[p+56+4>>2];c[k+8>>2]=c[p+56+8>>2];b=0;while(1){if((b|0)==3)break;c[p+56+(b<<2)>>2]=0;b=b+1|0}Oo(p+56|0);b=Ib[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{n=Ro(e,53628)|0;b=c[n>>2]|0;if(d){Gb[c[b+44>>2]&127](p+52|0,n);d=c[p+52>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;Gb[c[(c[n>>2]|0)+32>>2]&127](p+40|0,n);if((a[l+11>>0]|0)<0){a[c[l>>2]>>0]=0;c[l+4>>2]=0}else{a[l>>0]=0;a[l+11>>0]=0}o=0;ba(142,l|0);f=o;o=0;if(f&1){f=Za(0)|0;xr(f)}c[l>>2]=c[p+40>>2];c[l+4>>2]=c[p+40+4>>2];c[l+8>>2]=c[p+40+8>>2];b=0;while(1){if((b|0)==3)break;c[p+40+(b<<2)>>2]=0;b=b+1|0}Oo(p+40|0);e=n}else{Gb[c[b+40>>2]&127](p+36|0,n);d=c[p+36>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;Gb[c[(c[n>>2]|0)+28>>2]&127](p+24|0,n);if((a[l+11>>0]|0)<0){a[c[l>>2]>>0]=0;c[l+4>>2]=0}else{a[l>>0]=0;a[l+11>>0]=0}o=0;ba(142,l|0);f=o;o=0;if(f&1){f=Za(0)|0;xr(f)}c[l>>2]=c[p+24>>2];c[l+4>>2]=c[p+24+4>>2];c[l+8>>2]=c[p+24+8>>2];b=0;while(1){if((b|0)==3)break;c[p+24+(b<<2)>>2]=0;b=b+1|0}Oo(p+24|0);e=n}a[g>>0]=Ib[c[(c[n>>2]|0)+12>>2]&127](n)|0;a[h>>0]=Ib[c[(c[n>>2]|0)+16>>2]&127](n)|0;Gb[c[(c[e>>2]|0)+20>>2]&127](p+12|0,n);if((a[j+11>>0]|0)<0){a[c[j>>2]>>0]=0;c[j+4>>2]=0}else{a[j>>0]=0;a[j+11>>0]=0}o=0;ba(142,j|0);h=o;o=0;if(h&1){h=Za(0)|0;xr(h)}c[j>>2]=c[p+12>>2];c[j+4>>2]=c[p+12+4>>2];c[j+8>>2]=c[p+12+8>>2];b=0;while(1){if((b|0)==3)break;c[p+12+(b<<2)>>2]=0;b=b+1|0}Oo(p+12|0);Gb[c[(c[e>>2]|0)+24>>2]&127](p,n);if((a[k+11>>0]|0)<0){a[c[k>>2]>>0]=0;c[k+4>>2]=0}else{a[k>>0]=0;a[k+11>>0]=0}o=0;ba(142,k|0);h=o;o=0;if(h&1){h=Za(0)|0;xr(h)}c[k>>2]=c[p>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];b=0;while(1){if((b|0)==3)break;c[p+(b<<2)>>2]=0;b=b+1|0}Oo(p);b=Ib[c[(c[n>>2]|0)+36>>2]&127](n)|0}c[m>>2]=b;i=q;return}function oc(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,p=0;p=i;n=i=i+63&-64;i=i+112|0;if(b){e=Ro(e,53652)|0;b=c[e>>2]|0;if(d){Gb[c[b+44>>2]&127](n+108|0,e);d=c[n+108>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;Gb[c[(c[e>>2]|0)+32>>2]&127](n+96|0,e);if((a[l+8+3>>0]|0)<0){c[c[l>>2]>>2]=0;c[l+4>>2]=0}else{c[l>>2]=0;a[l+8+3>>0]=0}o=0;ba(144,l|0);f=o;o=0;if(f&1){f=Za(0)|0;xr(f)}c[l>>2]=c[n+96>>2];c[l+4>>2]=c[n+96+4>>2];c[l+8>>2]=c[n+96+8>>2];b=0;while(1){if((b|0)==3)break;c[n+96+(b<<2)>>2]=0;b=b+1|0}Ao(n+96|0)}else{Gb[c[b+40>>2]&127](n+92|0,e);d=c[n+92>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;Gb[c[(c[e>>2]|0)+28>>2]&127](n+80|0,e);if((a[l+8+3>>0]|0)<0){c[c[l>>2]>>2]=0;c[l+4>>2]=0}else{c[l>>2]=0;a[l+8+3>>0]=0}o=0;ba(144,l|0);f=o;o=0;if(f&1){f=Za(0)|0;xr(f)}c[l>>2]=c[n+80>>2];c[l+4>>2]=c[n+80+4>>2];c[l+8>>2]=c[n+80+8>>2];b=0;while(1){if((b|0)==3)break;c[n+80+(b<<2)>>2]=0;b=b+1|0}Ao(n+80|0)}c[g>>2]=Ib[c[(c[e>>2]|0)+12>>2]&127](e)|0;c[h>>2]=Ib[c[(c[e>>2]|0)+16>>2]&127](e)|0;Gb[c[(c[e>>2]|0)+20>>2]&127](n+68|0,e);if((a[j+11>>0]|0)<0){a[c[j>>2]>>0]=0;c[j+4>>2]=0}else{a[j>>0]=0;a[j+11>>0]=0}o=0;ba(142,j|0);h=o;o=0;if(h&1){h=Za(0)|0;xr(h)}c[j>>2]=c[n+68>>2];c[j+4>>2]=c[n+68+4>>2];c[j+8>>2]=c[n+68+8>>2];b=0;while(1){if((b|0)==3)break;c[n+68+(b<<2)>>2]=0;b=b+1|0}Oo(n+68|0);Gb[c[(c[e>>2]|0)+24>>2]&127](n+56|0,e);if((a[k+8+3>>0]|0)<0){c[c[k>>2]>>2]=0;c[k+4>>2]=0}else{c[k>>2]=0;a[k+8+3>>0]=0}o=0;ba(144,k|0);h=o;o=0;if(h&1){h=Za(0)|0;xr(h)}c[k>>2]=c[n+56>>2];c[k+4>>2]=c[n+56+4>>2];c[k+8>>2]=c[n+56+8>>2];b=0;while(1){if((b|0)==3)break;c[n+56+(b<<2)>>2]=0;b=b+1|0}Ao(n+56|0);b=Ib[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{e=Ro(e,53644)|0;b=c[e>>2]|0;if(d){Gb[c[b+44>>2]&127](n+52|0,e);d=c[n+52>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;Gb[c[(c[e>>2]|0)+32>>2]&127](n+40|0,e);if((a[l+8+3>>0]|0)<0){c[c[l>>2]>>2]=0;c[l+4>>2]=0}else{c[l>>2]=0;a[l+8+3>>0]=0}o=0;ba(144,l|0);f=o;o=0;if(f&1){f=Za(0)|0;xr(f)}c[l>>2]=c[n+40>>2];c[l+4>>2]=c[n+40+4>>2];c[l+8>>2]=c[n+40+8>>2];b=0;while(1){if((b|0)==3)break;c[n+40+(b<<2)>>2]=0;b=b+1|0}Ao(n+40|0)}else{Gb[c[b+40>>2]&127](n+36|0,e);d=c[n+36>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;Gb[c[(c[e>>2]|0)+28>>2]&127](n+24|0,e);if((a[l+8+3>>0]|0)<0){c[c[l>>2]>>2]=0;c[l+4>>2]=0}else{c[l>>2]=0;a[l+8+3>>0]=0}o=0;ba(144,l|0);f=o;o=0;if(f&1){f=Za(0)|0;xr(f)}c[l>>2]=c[n+24>>2];c[l+4>>2]=c[n+24+4>>2];c[l+8>>2]=c[n+24+8>>2];b=0;while(1){if((b|0)==3)break;c[n+24+(b<<2)>>2]=0;b=b+1|0}Ao(n+24|0)}c[g>>2]=Ib[c[(c[e>>2]|0)+12>>2]&127](e)|0;c[h>>2]=Ib[c[(c[e>>2]|0)+16>>2]&127](e)|0;Gb[c[(c[e>>2]|0)+20>>2]&127](n+12|0,e);if((a[j+11>>0]|0)<0){a[c[j>>2]>>0]=0;c[j+4>>2]=0}else{a[j>>0]=0;a[j+11>>0]=0}o=0;ba(142,j|0);h=o;o=0;if(h&1){h=Za(0)|0;xr(h)}c[j>>2]=c[n+12>>2];c[j+4>>2]=c[n+12+4>>2];c[j+8>>2]=c[n+12+8>>2];b=0;while(1){if((b|0)==3)break;c[n+12+(b<<2)>>2]=0;b=b+1|0}Oo(n+12|0);Gb[c[(c[e>>2]|0)+24>>2]&127](n,e);if((a[k+8+3>>0]|0)<0){c[c[k>>2]>>2]=0;c[k+4>>2]=0}else{c[k>>2]=0;a[k+8+3>>0]=0}o=0;ba(144,k|0);h=o;o=0;if(h&1){h=Za(0)|0;xr(h)}c[k>>2]=c[n>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}Ao(n);b=Ib[c[(c[e>>2]|0)+36>>2]&127](e)|0}c[m>>2]=b;i=p;return}function pc(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a:do if(e>>>0>36){c[(gp()|0)>>2]=22;h=0;g=0}else{do{i=c[b+4>>2]|0;if(i>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=i+1;i=d[i>>0]|0}else i=Qf(b)|0}while((Vr(i)|0)!=0);b:do switch(i|0){case 43:case 45:{j=((i|0)==45)<<31>>31;i=c[b+4>>2]|0;if(i>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=i+1;i=d[i>>0]|0;p=j;break b}else{i=Qf(b)|0;p=j;break b}}default:p=0}while(0);do if((e|16|0)==16&(i|0)==48){i=c[b+4>>2]|0;if(i>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=i+1;i=d[i>>0]|0}else i=Qf(b)|0;if((i|32|0)!=120)if(!e){e=8;n=46;break}else{n=32;break}e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;i=d[e>>0]|0}else i=Qf(b)|0;if((d[43263+i>>0]|0)>15){g=(c[b+100>>2]|0)==0;if(!g)c[b+4>>2]=(c[b+4>>2]|0)+-1;if(!f){Ek(b,0);h=0;g=0;break a}if(g){h=0;g=0;break a}c[b+4>>2]=(c[b+4>>2]|0)+-1;h=0;g=0;break a}else{e=16;n=46}}else{e=(e|0)==0?10:e;if((d[43263+i>>0]|0)>>>0<e>>>0)n=32;else{if(c[b+100>>2]|0)c[b+4>>2]=(c[b+4>>2]|0)+-1;Ek(b,0);c[(gp()|0)>>2]=22;h=0;g=0;break a}}while(0);if((n|0)==32)if((e|0)==10){e=i+-48|0;if(e>>>0<10){j=0;do{j=(j*10|0)+e|0;e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;i=d[e>>0]|0}else i=Qf(b)|0;e=i+-48|0}while(e>>>0<10&j>>>0<429496729);f=0}else{j=0;f=0}e=i+-48|0;if(e>>>0<10){do{k=Pl(j|0,f|0,10,0)|0;l=D;m=((e|0)<0)<<31>>31;if(l>>>0>~m>>>0|(l|0)==(~m|0)&k>>>0>~e>>>0)break;j=go(k|0,l|0,e|0,m|0)|0;f=D;e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;i=d[e>>0]|0}else i=Qf(b)|0;e=i+-48|0}while(e>>>0<10&(f>>>0<429496729|(f|0)==429496729&j>>>0<2576980378));if(e>>>0>9){i=j;e=p}else{e=10;n=72}}else{i=j;e=p}}else n=46;c:do if((n|0)==46){if(!(e+-1&e)){n=a[43519+((e*23|0)>>>5&7)>>0]|0;j=a[43263+i>>0]|0;if((j&255)>>>0<e>>>0){f=j&255;k=0;do{k=f|k<<n;i=c[b+4>>2]|0;if(i>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=i+1;i=d[i>>0]|0}else i=Qf(b)|0;j=a[43263+i>>0]|0;f=j&255}while(k>>>0<134217728&f>>>0<e>>>0);f=0}else{f=0;k=0}l=Mm(-1,-1,n|0)|0;m=D;if((j&255)>>>0>=e>>>0|(f>>>0>m>>>0|(f|0)==(m|0)&k>>>0>l>>>0)){j=k;n=72;break}while(1){k=Km(k|0,f|0,n|0)|0;f=D;k=j&255|k;i=c[b+4>>2]|0;if(i>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=i+1;i=d[i>>0]|0}else i=Qf(b)|0;j=a[43263+i>>0]|0;if((j&255)>>>0>=e>>>0|(f>>>0>m>>>0|(f|0)==(m|0)&k>>>0>l>>>0)){j=k;n=72;break c}}}j=a[43263+i>>0]|0;if((j&255)>>>0<e>>>0){f=j&255;k=0;do{k=f+(S(k,e)|0)|0;i=c[b+4>>2]|0;if(i>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=i+1;i=d[i>>0]|0}else i=Qf(b)|0;j=a[43263+i>>0]|0;f=j&255}while(k>>>0<119304647&f>>>0<e>>>0);f=0}else{k=0;f=0}if((j&255)>>>0<e>>>0){n=tq(-1,-1,e|0,0)|0;o=D;while(1){if(f>>>0>o>>>0|(f|0)==(o|0)&k>>>0>n>>>0){j=k;n=72;break c}l=Pl(k|0,f|0,e|0,0)|0;m=D;j=j&255;if(m>>>0>4294967295|(m|0)==-1&l>>>0>~j>>>0){j=k;n=72;break c}k=go(j|0,0,l|0,m|0)|0;f=D;i=c[b+4>>2]|0;if(i>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=i+1;i=d[i>>0]|0}else i=Qf(b)|0;j=a[43263+i>>0]|0;if((j&255)>>>0>=e>>>0){j=k;n=72;break}}}else{j=k;n=72}}while(0);if((n|0)==72)if((d[43263+i>>0]|0)>>>0<e>>>0){do{i=c[b+4>>2]|0;if(i>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=i+1;i=d[i>>0]|0}else i=Qf(b)|0}while((d[43263+i>>0]|0)>>>0<e>>>0);c[(gp()|0)>>2]=34;f=h;i=g;e=(g&1|0)==0&0==0?p:0}else{i=j;e=p}if(c[b+100>>2]|0)c[b+4>>2]=(c[b+4>>2]|0)+-1;if(!(f>>>0<h>>>0|(f|0)==(h|0)&i>>>0<g>>>0)){if(!((g&1|0)!=0|0!=0|(e|0)!=0)){c[(gp()|0)>>2]=34;g=go(g|0,h|0,-1,-1)|0;h=D;break}if(f>>>0>h>>>0|(f|0)==(h|0)&i>>>0>g>>>0){c[(gp()|0)>>2]=34;break}}g=((e|0)<0)<<31>>31;g=Sm(i^e|0,f^g|0,e|0,g|0)|0;h=D}while(0);D=h;return g|0}function qc(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,p=0;p=i;n=i=i+63&-64;i=i+112|0;if(b){d=Ro(d,53652)|0;Gb[c[(c[d>>2]|0)+44>>2]&127](n+100|0,d);b=c[n+100>>2]|0;a[e>>0]=b;a[e+1>>0]=b>>8;a[e+2>>0]=b>>16;a[e+3>>0]=b>>24;Gb[c[(c[d>>2]|0)+32>>2]&127](n+88|0,d);if((a[l+8+3>>0]|0)<0){c[c[l>>2]>>2]=0;c[l+4>>2]=0}else{c[l>>2]=0;a[l+8+3>>0]=0}o=0;ba(144,l|0);e=o;o=0;if(e&1){e=Za(0)|0;xr(e)}c[l>>2]=c[n+88>>2];c[l+4>>2]=c[n+88+4>>2];c[l+8>>2]=c[n+88+8>>2];b=0;while(1){if((b|0)==3)break;c[n+88+(b<<2)>>2]=0;b=b+1|0}Ao(n+88|0);Gb[c[(c[d>>2]|0)+28>>2]&127](n+76|0,d);if((a[k+8+3>>0]|0)<0){c[c[k>>2]>>2]=0;c[k+4>>2]=0}else{c[k>>2]=0;a[k+8+3>>0]=0}o=0;ba(144,k|0);e=o;o=0;if(e&1){e=Za(0)|0;xr(e)}c[k>>2]=c[n+76>>2];c[k+4>>2]=c[n+76+4>>2];c[k+8>>2]=c[n+76+8>>2];b=0;while(1){if((b|0)==3)break;c[n+76+(b<<2)>>2]=0;b=b+1|0}Ao(n+76|0);c[f>>2]=Ib[c[(c[d>>2]|0)+12>>2]&127](d)|0;c[g>>2]=Ib[c[(c[d>>2]|0)+16>>2]&127](d)|0;Gb[c[(c[d>>2]|0)+20>>2]&127](n+64|0,d);if((a[h+11>>0]|0)<0){a[c[h>>2]>>0]=0;c[h+4>>2]=0}else{a[h>>0]=0;a[h+11>>0]=0}o=0;ba(142,h|0);g=o;o=0;if(g&1){g=Za(0)|0;xr(g)}c[h>>2]=c[n+64>>2];c[h+4>>2]=c[n+64+4>>2];c[h+8>>2]=c[n+64+8>>2];b=0;while(1){if((b|0)==3)break;c[n+64+(b<<2)>>2]=0;b=b+1|0}Oo(n+64|0);Gb[c[(c[d>>2]|0)+24>>2]&127](n+52|0,d);if((a[j+8+3>>0]|0)<0){c[c[j>>2]>>2]=0;c[j+4>>2]=0}else{c[j>>2]=0;a[j+8+3>>0]=0}o=0;ba(144,j|0);g=o;o=0;if(g&1){g=Za(0)|0;xr(g)}c[j>>2]=c[n+52>>2];c[j+4>>2]=c[n+52+4>>2];c[j+8>>2]=c[n+52+8>>2];b=0;while(1){if((b|0)==3)break;c[n+52+(b<<2)>>2]=0;b=b+1|0}Ao(n+52|0);b=Ib[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{d=Ro(d,53644)|0;Gb[c[(c[d>>2]|0)+44>>2]&127](n+48|0,d);b=c[n+48>>2]|0;a[e>>0]=b;a[e+1>>0]=b>>8;a[e+2>>0]=b>>16;a[e+3>>0]=b>>24;Gb[c[(c[d>>2]|0)+32>>2]&127](n+36|0,d);if((a[l+8+3>>0]|0)<0){c[c[l>>2]>>2]=0;c[l+4>>2]=0}else{c[l>>2]=0;a[l+8+3>>0]=0}o=0;ba(144,l|0);e=o;o=0;if(e&1){e=Za(0)|0;xr(e)}c[l>>2]=c[n+36>>2];c[l+4>>2]=c[n+36+4>>2];c[l+8>>2]=c[n+36+8>>2];b=0;while(1){if((b|0)==3)break;c[n+36+(b<<2)>>2]=0;b=b+1|0}Ao(n+36|0);Gb[c[(c[d>>2]|0)+28>>2]&127](n+24|0,d);if((a[k+8+3>>0]|0)<0){c[c[k>>2]>>2]=0;c[k+4>>2]=0}else{c[k>>2]=0;a[k+8+3>>0]=0}o=0;ba(144,k|0);e=o;o=0;if(e&1){e=Za(0)|0;xr(e)}c[k>>2]=c[n+24>>2];c[k+4>>2]=c[n+24+4>>2];c[k+8>>2]=c[n+24+8>>2];b=0;while(1){if((b|0)==3)break;c[n+24+(b<<2)>>2]=0;b=b+1|0}Ao(n+24|0);c[f>>2]=Ib[c[(c[d>>2]|0)+12>>2]&127](d)|0;c[g>>2]=Ib[c[(c[d>>2]|0)+16>>2]&127](d)|0;Gb[c[(c[d>>2]|0)+20>>2]&127](n+12|0,d);if((a[h+11>>0]|0)<0){a[c[h>>2]>>0]=0;c[h+4>>2]=0}else{a[h>>0]=0;a[h+11>>0]=0}o=0;ba(142,h|0);g=o;o=0;if(g&1){g=Za(0)|0;xr(g)}c[h>>2]=c[n+12>>2];c[h+4>>2]=c[n+12+4>>2];c[h+8>>2]=c[n+12+8>>2];b=0;while(1){if((b|0)==3)break;c[n+12+(b<<2)>>2]=0;b=b+1|0}Oo(n+12|0);Gb[c[(c[d>>2]|0)+24>>2]&127](n,d);if((a[j+8+3>>0]|0)<0){c[c[j>>2]>>2]=0;c[j+4>>2]=0}else{c[j>>2]=0;a[j+8+3>>0]=0}o=0;ba(144,j|0);g=o;o=0;if(g&1){g=Za(0)|0;xr(g)}c[j>>2]=c[n>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}Ao(n);b=Ib[c[(c[d>>2]|0)+36>>2]&127](d)|0}c[m>>2]=b;i=p;return}function rc(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,p=0;p=i;n=i=i+63&-64;i=i+112|0;if(b){d=Ro(d,53636)|0;Gb[c[(c[d>>2]|0)+44>>2]&127](n+100|0,d);b=c[n+100>>2]|0;a[e>>0]=b;a[e+1>>0]=b>>8;a[e+2>>0]=b>>16;a[e+3>>0]=b>>24;Gb[c[(c[d>>2]|0)+32>>2]&127](n+88|0,d);if((a[l+11>>0]|0)<0){a[c[l>>2]>>0]=0;c[l+4>>2]=0}else{a[l>>0]=0;a[l+11>>0]=0}o=0;ba(142,l|0);e=o;o=0;if(e&1){e=Za(0)|0;xr(e)}c[l>>2]=c[n+88>>2];c[l+4>>2]=c[n+88+4>>2];c[l+8>>2]=c[n+88+8>>2];b=0;while(1){if((b|0)==3)break;c[n+88+(b<<2)>>2]=0;b=b+1|0}Oo(n+88|0);Gb[c[(c[d>>2]|0)+28>>2]&127](n+76|0,d);if((a[k+11>>0]|0)<0){a[c[k>>2]>>0]=0;c[k+4>>2]=0}else{a[k>>0]=0;a[k+11>>0]=0}o=0;ba(142,k|0);e=o;o=0;if(e&1){e=Za(0)|0;xr(e)}c[k>>2]=c[n+76>>2];c[k+4>>2]=c[n+76+4>>2];c[k+8>>2]=c[n+76+8>>2];b=0;while(1){if((b|0)==3)break;c[n+76+(b<<2)>>2]=0;b=b+1|0}Oo(n+76|0);a[f>>0]=Ib[c[(c[d>>2]|0)+12>>2]&127](d)|0;a[g>>0]=Ib[c[(c[d>>2]|0)+16>>2]&127](d)|0;Gb[c[(c[d>>2]|0)+20>>2]&127](n+64|0,d);if((a[h+11>>0]|0)<0){a[c[h>>2]>>0]=0;c[h+4>>2]=0}else{a[h>>0]=0;a[h+11>>0]=0}o=0;ba(142,h|0);g=o;o=0;if(g&1){g=Za(0)|0;xr(g)}c[h>>2]=c[n+64>>2];c[h+4>>2]=c[n+64+4>>2];c[h+8>>2]=c[n+64+8>>2];b=0;while(1){if((b|0)==3)break;c[n+64+(b<<2)>>2]=0;b=b+1|0}Oo(n+64|0);Gb[c[(c[d>>2]|0)+24>>2]&127](n+52|0,d);if((a[j+11>>0]|0)<0){a[c[j>>2]>>0]=0;c[j+4>>2]=0}else{a[j>>0]=0;a[j+11>>0]=0}o=0;ba(142,j|0);g=o;o=0;if(g&1){g=Za(0)|0;xr(g)}c[j>>2]=c[n+52>>2];c[j+4>>2]=c[n+52+4>>2];c[j+8>>2]=c[n+52+8>>2];b=0;while(1){if((b|0)==3)break;c[n+52+(b<<2)>>2]=0;b=b+1|0}Oo(n+52|0);b=Ib[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{d=Ro(d,53628)|0;Gb[c[(c[d>>2]|0)+44>>2]&127](n+48|0,d);b=c[n+48>>2]|0;a[e>>0]=b;a[e+1>>0]=b>>8;a[e+2>>0]=b>>16;a[e+3>>0]=b>>24;Gb[c[(c[d>>2]|0)+32>>2]&127](n+36|0,d);if((a[l+11>>0]|0)<0){a[c[l>>2]>>0]=0;c[l+4>>2]=0}else{a[l>>0]=0;a[l+11>>0]=0}o=0;ba(142,l|0);e=o;o=0;if(e&1){e=Za(0)|0;xr(e)}c[l>>2]=c[n+36>>2];c[l+4>>2]=c[n+36+4>>2];c[l+8>>2]=c[n+36+8>>2];b=0;while(1){if((b|0)==3)break;c[n+36+(b<<2)>>2]=0;b=b+1|0}Oo(n+36|0);Gb[c[(c[d>>2]|0)+28>>2]&127](n+24|0,d);if((a[k+11>>0]|0)<0){a[c[k>>2]>>0]=0;c[k+4>>2]=0}else{a[k>>0]=0;a[k+11>>0]=0}o=0;ba(142,k|0);e=o;o=0;if(e&1){e=Za(0)|0;xr(e)}c[k>>2]=c[n+24>>2];c[k+4>>2]=c[n+24+4>>2];c[k+8>>2]=c[n+24+8>>2];b=0;while(1){if((b|0)==3)break;c[n+24+(b<<2)>>2]=0;b=b+1|0}Oo(n+24|0);a[f>>0]=Ib[c[(c[d>>2]|0)+12>>2]&127](d)|0;a[g>>0]=Ib[c[(c[d>>2]|0)+16>>2]&127](d)|0;Gb[c[(c[d>>2]|0)+20>>2]&127](n+12|0,d);if((a[h+11>>0]|0)<0){a[c[h>>2]>>0]=0;c[h+4>>2]=0}else{a[h>>0]=0;a[h+11>>0]=0}o=0;ba(142,h|0);g=o;o=0;if(g&1){g=Za(0)|0;xr(g)}c[h>>2]=c[n+12>>2];c[h+4>>2]=c[n+12+4>>2];c[h+8>>2]=c[n+12+8>>2];b=0;while(1){if((b|0)==3)break;c[n+12+(b<<2)>>2]=0;b=b+1|0}Oo(n+12|0);Gb[c[(c[d>>2]|0)+24>>2]&127](n,d);if((a[j+11>>0]|0)<0){a[c[j>>2]>>0]=0;c[j+4>>2]=0}else{a[j>>0]=0;a[j+11>>0]=0}o=0;ba(142,j|0);g=o;o=0;if(g&1){g=Za(0)|0;xr(g)}c[j>>2]=c[n>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}Oo(n);b=Ib[c[(c[d>>2]|0)+36>>2]&127](d)|0}c[m>>2]=b;i=p;return}function sc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0;p=i;r=i=i+63&-64;i=i+320|0;c[r+192>>2]=0;c[r+192+4>>2]=0;c[r+192+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[r+192+(b<<2)>>2]=0;b=b+1|0}b=Ll(f)|0;o=0;f=va(32,b|0,51948)|0;n=o;o=0;if(!(n&1)?(o=0,Ba(c[(c[f>>2]|0)+48>>2]|0,f|0,46787,46813,r+208|0)|0,n=o,o=0,!(n&1)):0){Vl(b);c[r+180>>2]=0;c[r+180+4>>2]=0;c[r+180+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[r+180+(b<<2)>>2]=0;b=b+1|0}n=r+180+11|0;if((a[n>>0]|0)<0)b=(c[r+180+8>>2]&2147483647)+-1|0;else b=10;o=0;da(59,r+180|0,b|0);m=o;o=0;a:do if(!(m&1)){k=(a[n>>0]|0)<0?c[r+180>>2]|0:r+180|0;c[r+176>>2]=k;c[r+8>>2]=r+16;c[r+4>>2]=0;f=c[d>>2]|0;b:while(1){if(f){b=c[f+12>>2]|0;if((b|0)==(c[f+16>>2]|0)){o=0;b=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;m=o;o=0;if(m&1){q=34;break}}else b=c[b>>2]|0;if((b|0)==-1){c[d>>2]=0;m=0;f=1}else{m=f;f=0}}else{m=0;f=1}j=c[e>>2]|0;do if(j){b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){o=0;b=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;l=o;o=0;if(l&1){q=34;break b}}else b=c[b>>2]|0;if((b|0)!=-1)if(f)break;else{b=k;break b}else{c[e>>2]=0;q=25;break}}else q=25;while(0);if((q|0)==25){q=0;if(f){j=0;b=k;break}else j=0}f=a[n>>0]|0;f=f<<24>>24<0?c[r+180+4>>2]|0:f&255;if((c[r+176>>2]|0)==(k+f|0)){o=0;da(59,r+180|0,f<<1|0);l=o;o=0;if(l&1){q=34;break}if((a[n>>0]|0)<0)b=(c[r+180+8>>2]&2147483647)+-1|0;else b=10;o=0;da(59,r+180|0,b|0);l=o;o=0;if(l&1){q=34;break}b=(a[n>>0]|0)<0?c[r+180>>2]|0:r+180|0;c[r+176>>2]=b+f}else b=k;k=m+12|0;f=c[k>>2]|0;l=m+16|0;if((f|0)==(c[l>>2]|0)){o=0;f=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;s=o;o=0;if(s&1){q=34;break}}else f=c[f>>2]|0;if(de(f,16,b,r+176|0,r+4|0,0,r+192|0,r+16|0,r+8|0,r+208|0)|0)break;f=c[k>>2]|0;if((f|0)==(c[l>>2]|0)){o=0;ha(c[(c[m>>2]|0)+40>>2]|0,m|0)|0;s=o;o=0;if(s&1){q=34;break}else{f=m;k=b;continue}}else{c[k>>2]=f+4;f=m;k=b;continue}}if((q|0)==34){b=Ya()|0;break}o=0;da(59,r+180|0,(c[r+176>>2]|0)-b|0);s=o;o=0;if(!(s&1)){l=a[n>>0]|0;n=c[r+180>>2]|0;s=To()|0;c[r>>2]=h;if((Jj(l<<24>>24<0?n:r+180|0,s,0,r)|0)!=1)c[g>>2]=4;if(m){b=c[m+12>>2]|0;if((b|0)==(c[m+16>>2]|0)){o=0;b=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;s=o;o=0;if(s&1){q=35;break}}else b=c[b>>2]|0;if((b|0)==-1){c[d>>2]=0;f=1}else f=0}else f=1;do if(j){b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){o=0;b=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;s=o;o=0;if(s&1){q=35;break a}}else b=c[b>>2]|0;if((b|0)!=-1)if(f)break;else{q=61;break}else{c[e>>2]=0;q=59;break}}else q=59;while(0);if((q|0)==59?f:0)q=61;if((q|0)==61)c[g>>2]=c[g>>2]|2;s=c[d>>2]|0;Oo(r+180|0);Oo(r+192|0);i=p;return s|0}else q=35}else q=35;while(0);if((q|0)==35)b=Ya()|0;Oo(r+180|0)}else{s=Ya()|0;Vl(b);b=s}Oo(r+192|0);Ra(b|0);return 0}function tc(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0;j=i;k=i=i+63&-64;i=i+320|0;h=k+280|0;g=h+32|0;do{a[h>>0]=a[e>>0]|0;h=h+1|0;e=e+1|0}while((h|0)<(g|0));a[k+280>>0]=(d[k+280>>0]|0)&248;a[k+280+31>>0]=(d[k+280+31>>0]|0)&63|64;Sc(k+240|0,f);Om(k+200|0);xo(k+160|0);Vg(k+120|0,k+240|0);Om(k+80|0);e=254;g=0;while(1){B=g;g=(d[k+280+((e|0)/8|0)>>0]|0)>>>(e&7)&1;B=g^B;ve(k+200|0,k+120|0,B);ve(k+160|0,k+80|0,B);Ff(k+40|0,k+120|0,k+80|0);Ff(k,k+200|0,k+160|0);Gf(k+200|0,k+200|0,k+160|0);Gf(k+160|0,k+120|0,k+80|0);fc(k+80|0,k+40|0,k+200|0);fc(k+160|0,k+160|0,k);ic(k+40|0,k);ic(k,k+200|0);Gf(k+120|0,k+80|0,k+160|0);Ff(k+160|0,k+80|0,k+160|0);fc(k+200|0,k,k+40|0);Ff(k,k,k+40|0);ic(k+160|0,k+160|0);B=c[k>>2]|0;A=c[k+4>>2]|0;z=c[k+8>>2]|0;y=c[k+12>>2]|0;x=c[k+16>>2]|0;s=c[k+20>>2]|0;v=c[k+24>>2]|0;E=c[k+28>>2]|0;t=c[k+32>>2]|0;C=c[k+36>>2]|0;B=Pl(B|0,((B|0)<0)<<31>>31|0,121666,0)|0;q=D;A=Pl(A|0,((A|0)<0)<<31>>31|0,121666,0)|0;r=D;z=Pl(z|0,((z|0)<0)<<31>>31|0,121666,0)|0;o=D;y=Pl(y|0,((y|0)<0)<<31>>31|0,121666,0)|0;p=D;x=Pl(x|0,((x|0)<0)<<31>>31|0,121666,0)|0;m=D;s=Pl(s|0,((s|0)<0)<<31>>31|0,121666,0)|0;n=D;v=Pl(v|0,((v|0)<0)<<31>>31|0,121666,0)|0;f=D;E=Pl(E|0,((E|0)<0)<<31>>31|0,121666,0)|0;l=D;t=Pl(t|0,((t|0)<0)<<31>>31|0,121666,0)|0;u=D;C=Pl(C|0,((C|0)<0)<<31>>31|0,121666,0)|0;h=D;F=go(C|0,h|0,16777216,0)|0;F=_l(F|0,D|0,25)|0;w=D;G=Pl(F|0,w|0,19,0)|0;q=go(G|0,D|0,B|0,q|0)|0;B=D;w=Km(F|0,w|0,25)|0;w=Sm(C|0,h|0,w|0,D|0)|0;h=D;C=go(A|0,r|0,16777216,0)|0;C=_l(C|0,D|0,25)|0;F=D;o=go(C|0,F|0,z|0,o|0)|0;z=D;F=Km(C|0,F|0,25)|0;F=Sm(A|0,r|0,F|0,D|0)|0;r=D;A=go(y|0,p|0,16777216,0)|0;A=_l(A|0,D|0,25)|0;C=D;m=go(A|0,C|0,x|0,m|0)|0;x=D;C=Km(A|0,C|0,25)|0;C=Sm(y|0,p|0,C|0,D|0)|0;p=D;y=go(s|0,n|0,16777216,0)|0;y=_l(y|0,D|0,25)|0;A=D;f=go(y|0,A|0,v|0,f|0)|0;v=D;A=Km(y|0,A|0,25)|0;A=Sm(s|0,n|0,A|0,D|0)|0;n=D;s=go(E|0,l|0,16777216,0)|0;s=_l(s|0,D|0,25)|0;y=D;u=go(s|0,y|0,t|0,u|0)|0;t=D;y=Km(s|0,y|0,25)|0;y=Sm(E|0,l|0,y|0,D|0)|0;l=D;E=go(q|0,B|0,33554432,0)|0;E=_l(E|0,D|0,26)|0;s=D;r=go(F|0,r|0,E|0,s|0)|0;s=Km(E|0,s|0,26)|0;s=Sm(q|0,B|0,s|0,D|0)|0;B=go(o|0,z|0,33554432,0)|0;B=_l(B|0,D|0,26)|0;q=D;p=go(C|0,p|0,B|0,q|0)|0;q=Km(B|0,q|0,26)|0;q=Sm(o|0,z|0,q|0,D|0)|0;z=go(m|0,x|0,33554432,0)|0;z=_l(z|0,D|0,26)|0;o=D;n=go(A|0,n|0,z|0,o|0)|0;o=Km(z|0,o|0,26)|0;o=Sm(m|0,x|0,o|0,D|0)|0;x=go(f|0,v|0,33554432,0)|0;x=_l(x|0,D|0,26)|0;m=D;l=go(y|0,l|0,x|0,m|0)|0;m=Km(x|0,m|0,26)|0;m=Sm(f|0,v|0,m|0,D|0)|0;v=go(u|0,t|0,33554432,0)|0;v=_l(v|0,D|0,26)|0;f=D;h=go(w|0,h|0,v|0,f|0)|0;f=Km(v|0,f|0,26)|0;f=Sm(u|0,t|0,f|0,D|0)|0;c[k+80>>2]=s;c[k+80+4>>2]=r;c[k+80+8>>2]=q;c[k+80+12>>2]=p;c[k+80+16>>2]=o;c[k+80+20>>2]=n;c[k+80+24>>2]=m;c[k+80+28>>2]=l;c[k+80+32>>2]=f;c[k+80+36>>2]=h;ic(k+120|0,k+120|0);Gf(k+40|0,k+40|0,k+80|0);fc(k+80|0,k+240|0,k+160|0);fc(k+160|0,k,k+40|0);if((e|0)<=0)break;else e=e+-1|0}ve(k+200|0,k+120|0,g);ve(k+160|0,k+80|0,g);od(k+160|0,k+160|0);fc(k+200|0,k+200|0,k+160|0);Ld(b,k+200|0);i=j;return 0}function uc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;x=i;l=i=i+63&-64;i=i+112|0;do if(((f-e|0)/12|0)>>>0>100){l=bc((f-e|0)/12|0)|0;if((l|0)==0?(o=0,Fa(20),w=o,o=0,w&1):0){k=0;p=6;break}k=l;p=11}else{k=0;p=11}while(0);a:do if((p|0)==11){p=e;r=0;n=(f-e|0)/12|0;q=l;while(1){if((p|0)==(f|0))break;m=a[p+8+3>>0]|0;if(m<<24>>24<0)m=c[p+4>>2]|0;else m=m&255;if(!m){a[q>>0]=2;m=r+1|0;n=n+-1|0}else{a[q>>0]=1;m=r}p=p+12|0;r=m;q=q+1|0}w=0;s=n;b:while(1){m=c[b>>2]|0;do if(m){n=c[m+12>>2]|0;if((n|0)==(c[m+16>>2]|0)){o=0;m=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;v=o;o=0;if(v&1){p=5;break b}}else m=c[n>>2]|0;if((m|0)==-1){c[b>>2]=0;p=1;break}else{p=(c[b>>2]|0)==0;break}}else p=1;while(0);if(!d){q=0;m=1;d=0}else{m=c[d+12>>2]|0;if((m|0)==(c[d+16>>2]|0)){o=0;m=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;v=o;o=0;if(v&1){p=5;break}}else m=c[m>>2]|0;v=(m|0)==-1;q=v?0:d;m=v;d=v?0:d}n=c[b>>2]|0;if(!((s|0)!=0&(p^m))){p=34;break}m=c[n+12>>2]|0;if((m|0)==(c[n+16>>2]|0)){o=0;m=ha(c[(c[n>>2]|0)+36>>2]|0,n|0)|0;v=o;o=0;if(v&1){p=5;break}}else m=c[m>>2]|0;if(!j){o=0;m=va(c[(c[g>>2]|0)+28>>2]|0,g|0,m|0)|0;v=o;o=0;if(v&1){p=5;break}}v=w+1|0;q=0;t=e;u=s;s=l;while(1){if((t|0)==(f|0))break;do if((a[s>>0]|0)==1){p=t+8+3|0;if((a[p>>0]|0)<0)n=c[t>>2]|0;else n=t;n=c[n+(w<<2)>>2]|0;if(!j){o=0;n=va(c[(c[g>>2]|0)+28>>2]|0,g|0,n|0)|0;y=o;o=0;if(y&1){p=4;break b}}if((m|0)!=(n|0)){a[s>>0]=0;n=q;p=u+-1|0;break}n=a[p>>0]|0;if(n<<24>>24<0)n=c[t+4>>2]|0;else n=n&255;if((n|0)==(v|0)){a[s>>0]=2;n=1;r=r+1|0;p=u+-1|0}else{n=1;p=u}}else{n=q;p=u}while(0);q=n;t=t+12|0;u=p;s=s+1|0}if(!q){w=v;s=u;continue}m=c[b>>2]|0;n=c[m+12>>2]|0;if((n|0)==(c[m+16>>2]|0)){o=0;ha(c[(c[m>>2]|0)+40>>2]|0,m|0)|0;y=o;o=0;if(y&1){p=5;break}}else c[m+12>>2]=n+4;if((r+u|0)>>>0>1){q=e;m=r;p=l}else{w=v;s=u;continue}while(1){if((q|0)==(f|0)){w=v;r=m;s=u;continue b}if((a[p>>0]|0)==2){n=a[q+8+3>>0]|0;if(n<<24>>24<0)n=c[q+4>>2]|0;else n=n&255;if((n|0)!=(v|0)){a[p>>0]=0;m=m+-1|0}}q=q+12|0;p=p+1|0}}if((p|0)==4){e=Ya()|0;break}else if((p|0)==5){e=Ya()|0;break}else if((p|0)==34){do if(n){m=c[n+12>>2]|0;if((m|0)==(c[n+16>>2]|0)){o=0;m=ha(c[(c[n>>2]|0)+36>>2]|0,n|0)|0;y=o;o=0;if(y&1){p=6;break a}}else m=c[m>>2]|0;if((m|0)==-1){c[b>>2]=0;n=1;break}else{n=(c[b>>2]|0)==0;break}}else n=1;while(0);if(q){m=c[q+12>>2]|0;if((m|0)==(c[q+16>>2]|0)){o=0;m=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;y=o;o=0;if(y&1){p=6;break}}else m=c[m>>2]|0;if((m|0)!=-1){if(!n)p=82}else p=80}else p=80;if((p|0)==80)if(n)p=82;if((p|0)==82)c[h>>2]=c[h>>2]|2;while(1){if((e|0)==(f|0)){p=86;break}if((a[l>>0]|0)==2)break;e=e+12|0;l=l+1|0}if((p|0)==86){c[h>>2]=c[h>>2]|4;e=f}if(k|0)kc(k);i=x;return e|0}}while(0);if((p|0)==6)e=Ya()|0;if(k|0)kc(k);Ra(e|0);return 0}function vc(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;y=i;m=i=i+63&-64;i=i+112|0;do if(((g-f|0)/12|0)>>>0>100){m=bc((g-f|0)/12|0)|0;if((m|0)==0?(o=0,Fa(20),x=o,o=0,x&1):0){l=0;s=6;break}l=m;s=11}else{l=0;s=11}while(0);a:do if((s|0)==11){q=f;s=0;p=(g-f|0)/12|0;r=m;while(1){if((q|0)==(g|0))break;n=a[q+11>>0]|0;if(n<<24>>24<0)n=c[q+4>>2]|0;else n=n&255;if(!n){a[r>>0]=2;n=s+1|0;p=p+-1|0}else{a[r>>0]=1;n=s}q=q+12|0;s=n;r=r+1|0}x=0;t=p;b:while(1){n=c[b>>2]|0;do if(n){if((c[n+12>>2]|0)==(c[n+16>>2]|0)){o=0;n=ha(c[(c[n>>2]|0)+36>>2]|0,n|0)|0;w=o;o=0;if(w&1){s=5;break b}if((n|0)==-1){c[b>>2]=0;n=0;break}else{n=c[b>>2]|0;break}}}else n=0;while(0);p=(n|0)==0;if(e)if((c[e+12>>2]|0)==(c[e+16>>2]|0)){o=0;n=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;w=o;o=0;if(w&1){s=5;break}r=(n|0)==-1?0:e;e=(n|0)==-1?0:e}else r=e;else{r=0;e=0}q=(r|0)==0;n=c[b>>2]|0;if(!((t|0)!=0&(p^q))){s=32;break}p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){o=0;n=ha(c[(c[n>>2]|0)+36>>2]|0,n|0)|0;w=o;o=0;if(w&1){s=5;break}}else n=d[p>>0]|0;n=n&255;if(!k){o=0;n=va(c[(c[h>>2]|0)+12>>2]|0,h|0,n|0)|0;w=o;o=0;if(w&1){s=5;break}}w=x+1|0;r=0;u=f;v=t;t=m;while(1){if((u|0)==(g|0))break;do if((a[t>>0]|0)==1){q=u+11|0;if((a[q>>0]|0)<0)p=c[u>>2]|0;else p=u;p=a[p+x>>0]|0;if(!k){o=0;p=va(c[(c[h>>2]|0)+12>>2]|0,h|0,p|0)|0;z=o;o=0;if(z&1){s=4;break b}}if(n<<24>>24!=p<<24>>24){a[t>>0]=0;p=r;q=v+-1|0;break}p=a[q>>0]|0;if(p<<24>>24<0)p=c[u+4>>2]|0;else p=p&255;if((p|0)==(w|0)){a[t>>0]=2;p=1;s=s+1|0;q=v+-1|0}else{p=1;q=v}}else{p=r;q=v}while(0);r=p;u=u+12|0;v=q;t=t+1|0}if(!r){x=w;t=v;continue}n=c[b>>2]|0;p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){o=0;ha(c[(c[n>>2]|0)+40>>2]|0,n|0)|0;z=o;o=0;if(z&1){s=5;break}}else c[n+12>>2]=p+1;if((s+v|0)>>>0>1){r=f;n=s;q=m}else{x=w;t=v;continue}while(1){if((r|0)==(g|0)){x=w;s=n;t=v;continue b}if((a[q>>0]|0)==2){p=a[r+11>>0]|0;if(p<<24>>24<0)p=c[r+4>>2]|0;else p=p&255;if((p|0)!=(w|0)){a[q>>0]=0;n=n+-1|0}}r=r+12|0;q=q+1|0}}if((s|0)==4){f=Ya()|0;break}else if((s|0)==5){f=Ya()|0;break}else if((s|0)==32){do if(n){if((c[n+12>>2]|0)==(c[n+16>>2]|0)){o=0;n=ha(c[(c[n>>2]|0)+36>>2]|0,n|0)|0;z=o;o=0;if(z&1){s=6;break a}if((n|0)==-1){c[b>>2]=0;n=0;break}else{n=c[b>>2]|0;break}}}else n=0;while(0);p=(n|0)==0;do if(!q){if((c[r+12>>2]|0)==(c[r+16>>2]|0)){o=0;n=ha(c[(c[r>>2]|0)+36>>2]|0,r|0)|0;z=o;o=0;if(z&1){s=6;break a}if((n|0)==-1){s=77;break}}if(!p)s=78}else s=77;while(0);if((s|0)==77)if(p)s=78;if((s|0)==78)c[j>>2]=c[j>>2]|2;while(1){if((f|0)==(g|0)){s=82;break}if((a[m>>0]|0)==2)break;f=f+12|0;m=m+1|0}if((s|0)==82){c[j>>2]=c[j>>2]|4;f=g}if(l|0)kc(l);i=y;return f|0}}while(0);if((s|0)==6)f=Ya()|0;if(l|0)kc(l);Ra(f|0);return 0}function wc(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0;q=i;s=i=i+63&-64;i=i+240|0;c[s+192>>2]=0;c[s+192+4>>2]=0;c[s+192+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[s+192+(b<<2)>>2]=0;b=b+1|0}b=Ll(g)|0;o=0;g=va(32,b|0,51916)|0;p=o;o=0;if(!(p&1)?(o=0,Ba(c[(c[g>>2]|0)+32>>2]|0,g|0,46787,46813,s+204|0)|0,p=o,o=0,!(p&1)):0){Vl(b);c[s+180>>2]=0;c[s+180+4>>2]=0;c[s+180+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[s+180+(b<<2)>>2]=0;b=b+1|0}p=s+180+11|0;if((a[p>>0]|0)<0)b=(c[s+180+8>>2]&2147483647)+-1|0;else b=10;o=0;da(59,s+180|0,b|0);n=o;o=0;a:do if(!(n&1)){m=(a[p>>0]|0)<0?c[s+180>>2]|0:s+180|0;c[s+176>>2]=m;c[s+8>>2]=s+16;c[s+4>>2]=0;b=c[e>>2]|0;b:while(1){if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)){o=0;g=ha(c[(c[b>>2]|0)+36>>2]|0,b|0)|0;n=o;o=0;if(n&1){r=33;break}if((g|0)==-1){c[e>>2]=0;b=0}}}else b=0;g=(b|0)==0;l=c[f>>2]|0;do if(l){if((c[l+12>>2]|0)!=(c[l+16>>2]|0))if(g)break;else{g=m;break b}o=0;k=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;n=o;o=0;if(n&1){r=33;break b}if((k|0)!=-1)if(g)break;else{g=m;break b}else{c[f>>2]=0;r=24;break}}else r=24;while(0);if((r|0)==24){r=0;if(g){b=0;l=0;g=m;break}else l=0}k=a[p>>0]|0;k=k<<24>>24<0?c[s+180+4>>2]|0:k&255;if((c[s+176>>2]|0)==(m+k|0)){o=0;da(59,s+180|0,k<<1|0);n=o;o=0;if(n&1){r=33;break}if((a[p>>0]|0)<0)g=(c[s+180+8>>2]&2147483647)+-1|0;else g=10;o=0;da(59,s+180|0,g|0);n=o;o=0;if(n&1){r=33;break}g=(a[p>>0]|0)<0?c[s+180>>2]|0:s+180|0;c[s+176>>2]=g+k}else g=m;m=b+12|0;k=c[m>>2]|0;n=b+16|0;if((k|0)==(c[n>>2]|0)){o=0;k=ha(c[(c[b>>2]|0)+36>>2]|0,b|0)|0;t=o;o=0;if(t&1){r=33;break}}else k=d[k>>0]|0;if(ce(k&255,16,g,s+176|0,s+4|0,0,s+192|0,s+16|0,s+8|0,s+204|0)|0)break;k=c[m>>2]|0;if((k|0)==(c[n>>2]|0)){o=0;ha(c[(c[b>>2]|0)+40>>2]|0,b|0)|0;t=o;o=0;if(t&1){r=33;break}else{m=g;continue}}else{c[m>>2]=k+1;m=g;continue}}if((r|0)==33){b=Ya()|0;break}o=0;da(59,s+180|0,(c[s+176>>2]|0)-g|0);t=o;o=0;if(!(t&1)){n=a[p>>0]|0;p=c[s+180>>2]|0;t=To()|0;c[s>>2]=j;if((Jj(n<<24>>24<0?p:s+180|0,t,0,s)|0)!=1)c[h>>2]=4;if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)){o=0;g=ha(c[(c[b>>2]|0)+36>>2]|0,b|0)|0;t=o;o=0;if(t&1){r=34;break}if((g|0)==-1){c[e>>2]=0;b=0}}}else b=0;g=(b|0)==0;do if(l){if((c[l+12>>2]|0)==(c[l+16>>2]|0)){o=0;b=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=34;break a}if((b|0)==-1){c[f>>2]=0;r=57;break}}if(!g)r=58}else r=57;while(0);if((r|0)==57?g:0)r=58;if((r|0)==58)c[h>>2]=c[h>>2]|2;t=c[e>>2]|0;Oo(s+180|0);Oo(s+192|0);i=q;return t|0}else r=34}else r=34;while(0);if((r|0)==34)b=Ya()|0;Oo(s+180|0)}else{t=Ya()|0;Vl(b);b=t}Oo(s+192|0);Ra(b|0);return 0}function xc(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=i;w=i=i+63&-64;i=i+16|0;n=Ll(h)|0;o=0;u=va(32,n|0,51916)|0;t=o;o=0;if(t&1){y=Ya()|0;Vl(n);Ra(y|0)}Vl(n);c[j>>2]=0;n=0;a:while(1){r=(l|0)!=(m|0);p=f;while(1){if(!(r&(n|0)==0)){n=p;l=g;break a}f=p;if(p)if((c[p+12>>2]|0)==(c[p+16>>2]|0)){s=(Ib[c[(c[p>>2]|0)+36>>2]&127](p)|0)==-1;n=s?0:p;f=s?0:f;s=s?0:p}else{n=p;s=p}else{n=0;s=0}q=(n|0)==0;p=g;do if(g){if((c[g+12>>2]|0)==(c[g+16>>2]|0)?(Ib[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1:0){g=0;x=12;break}if(!q){x=13;break a}}else{g=p;x=12}while(0);if((x|0)==12){x=0;if(q){n=0;g=0;x=13;break a}else{p=g;g=0}}if((Kb[c[(c[u>>2]|0)+36>>2]&63](u,a[l>>0]|0,0)|0)<<24>>24==37){x=16;break}f=a[l>>0]|0;if(f<<24>>24>-1?(v=c[u+8>>2]|0,b[v+(f<<24>>24<<1)>>1]&8192):0){x=25;break}p=n+12|0;f=c[p>>2]|0;q=n+16|0;if((f|0)==(c[q>>2]|0))f=Ib[c[(c[n>>2]|0)+36>>2]&127](n)|0;else f=d[f>>0]|0;t=Pb[c[(c[u>>2]|0)+12>>2]&63](u,f&255)|0;if(t<<24>>24==(Pb[c[(c[u>>2]|0)+12>>2]&63](u,a[l>>0]|0)|0)<<24>>24){x=50;break}c[j>>2]=4;n=4;p=s}b:do if((x|0)==16){x=0;q=l+1|0;if((q|0)==(m|0)){x=17;break a}s=Kb[c[(c[u>>2]|0)+36>>2]&63](u,a[q>>0]|0,0)|0;switch(s<<24>>24){case 48:case 69:{r=l+2|0;if((r|0)==(m|0)){x=22;break a}l=q;q=Kb[c[(c[u>>2]|0)+36>>2]&63](u,a[r>>0]|0,0)|0;n=s;break}default:{q=s;n=0}}t=c[(c[e>>2]|0)+36>>2]|0;c[w+4>>2]=f;c[w>>2]=p;c[w+8>>2]=c[w+4>>2];c[w+12>>2]=c[w>>2];l=l+2|0;f=Vb[t&31](e,w+8|0,w+12|0,h,j,k,q,n)|0}else if((x|0)==25){while(1){x=0;l=l+1|0;if((l|0)==(m|0)){l=m;break}f=a[l>>0]|0;if(f<<24>>24<=-1)break;if(!(b[v+(f<<24>>24<<1)>>1]&8192))break;else x=25}p=g;r=g;f=s;while(1){if(n){if((c[n+12>>2]|0)==(c[n+16>>2]|0)){t=(Ib[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1;n=t?0:n;f=t?0:f}}else n=0;q=(n|0)==0;do if(r){if((c[r+12>>2]|0)!=(c[r+16>>2]|0))if(q){t=p;s=r;break}else break b;if((Ib[c[(c[r>>2]|0)+36>>2]&127](r)|0)!=-1)if(q^(p|0)==0){t=p;s=p}else break b;else{p=0;g=0;x=36}}else x=36;while(0);if((x|0)==36){x=0;if(q)break b;else{t=p;s=0}}q=n+12|0;p=c[q>>2]|0;r=n+16|0;if((p|0)==(c[r>>2]|0))p=Ib[c[(c[n>>2]|0)+36>>2]&127](n)|0;else p=d[p>>0]|0;if((p&255)<<24>>24<=-1)break b;if(!(b[(c[u+8>>2]|0)+(p<<24>>24<<1)>>1]&8192))break b;p=c[q>>2]|0;if((p|0)==(c[r>>2]|0)){Ib[c[(c[n>>2]|0)+40>>2]&127](n)|0;p=t;r=s;continue}else{c[q>>2]=p+1;p=t;r=s;continue}}}else if((x|0)==50){x=0;f=c[p>>2]|0;if((f|0)==(c[q>>2]|0))Ib[c[(c[n>>2]|0)+40>>2]&127](n)|0;else c[p>>2]=f+1;l=l+1|0;f=s}while(0);n=c[j>>2]|0}if((x|0)==13){c[j>>2]=4;l=g}else if((x|0)==17){c[j>>2]=4;l=g}else if((x|0)==22){c[j>>2]=4;l=g}if(n){if((c[n+12>>2]|0)==(c[n+16>>2]|0)){w=(Ib[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1;n=w?0:n}}else n=0;g=(n|0)==0;do if(l){if((c[l+12>>2]|0)==(c[l+16>>2]|0)?(Ib[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1:0){x=63;break}if(!g)x=64}else x=63;while(0);if((x|0)==63?g:0)x=64;if((x|0)==64)c[j>>2]=c[j>>2]|2;i=y;return n|0}function yc(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;u=i;s=i=i+63&-64;i=i+16|0;k=Ll(e)|0;o=0;r=va(32,k|0,51948)|0;q=o;o=0;if(q&1){u=Ya()|0;Vl(k);Ra(u|0)}Vl(k);c[f>>2]=0;k=0;a:while(1){q=(h|0)!=(j|0);while(1){if(!(q&(k|0)==0)){k=b;b=d;break a}l=b;if(!b){k=0;n=1;p=l;b=0}else{k=c[b+12>>2]|0;if((k|0)==(c[b+16>>2]|0))k=Ib[c[(c[b>>2]|0)+36>>2]&127](b)|0;else k=c[k>>2]|0;m=(k|0)==-1;k=m?0:b;n=m;p=m?0:l;b=m?0:b}m=d;if(d){l=c[d+12>>2]|0;if((l|0)==(c[d+16>>2]|0))l=Ib[c[(c[d>>2]|0)+36>>2]&127](d)|0;else l=c[l>>2]|0;if((l|0)!=-1){if(!n){t=17;break a}}else{d=0;t=15}}else{d=m;t=15}if((t|0)==15){t=0;if(n){d=0;t=17;break a}else{m=d;d=0}}if((Kb[c[(c[r>>2]|0)+52>>2]&63](r,c[h>>2]|0,0)|0)<<24>>24==37){t=20;break}if(Kb[c[(c[r>>2]|0)+12>>2]&63](r,8192,c[h>>2]|0)|0){t=28;break}m=k+12|0;l=c[m>>2]|0;n=k+16|0;if((l|0)==(c[n>>2]|0))l=Ib[c[(c[k>>2]|0)+36>>2]&127](k)|0;else l=c[l>>2]|0;p=Pb[c[(c[r>>2]|0)+28>>2]&63](r,l)|0;if((p|0)==(Pb[c[(c[r>>2]|0)+28>>2]&63](r,c[h>>2]|0)|0)){t=54;break}c[f>>2]=4;k=4}b:do if((t|0)==20){t=0;b=h+4|0;if((b|0)==(j|0)){t=21;break a}n=Kb[c[(c[r>>2]|0)+52>>2]&63](r,c[b>>2]|0,0)|0;switch(n<<24>>24){case 48:case 69:{l=h+8|0;if((l|0)==(j|0)){t=26;break a}h=b;b=Kb[c[(c[r>>2]|0)+52>>2]&63](r,c[l>>2]|0,0)|0;k=n;break}default:{b=n;k=0}}q=c[(c[a>>2]|0)+36>>2]|0;c[s+4>>2]=p;c[s>>2]=m;c[s+8>>2]=c[s+4>>2];c[s+12>>2]=c[s>>2];h=h+8|0;b=Vb[q&31](a,s+8|0,s+12|0,e,f,g,b,k)|0}else if((t|0)==28){while(1){t=0;h=h+4|0;if((h|0)==(j|0)){h=j;break}if(Kb[c[(c[r>>2]|0)+12>>2]&63](r,8192,c[h>>2]|0)|0)t=28;else break}n=d;q=d;while(1){if(!k){m=1;k=0}else{l=c[k+12>>2]|0;if((l|0)==(c[k+16>>2]|0))l=Ib[c[(c[k>>2]|0)+36>>2]&127](k)|0;else l=c[l>>2]|0;p=(l|0)==-1;m=p;k=p?0:k;b=p?0:b}if(q){l=c[q+12>>2]|0;if((l|0)==(c[q+16>>2]|0))l=Ib[c[(c[q>>2]|0)+36>>2]&127](q)|0;else l=c[l>>2]|0;if((l|0)!=-1)if(m^(n|0)==0){l=n;q=n}else break b;else{l=0;d=0;t=41}}else{l=n;t=41}if((t|0)==41){t=0;if(m)break b;else q=0}n=k+12|0;m=c[n>>2]|0;p=k+16|0;if((m|0)==(c[p>>2]|0))m=Ib[c[(c[k>>2]|0)+36>>2]&127](k)|0;else m=c[m>>2]|0;if(!(Kb[c[(c[r>>2]|0)+12>>2]&63](r,8192,m)|0))break b;m=c[n>>2]|0;if((m|0)==(c[p>>2]|0)){Ib[c[(c[k>>2]|0)+40>>2]&127](k)|0;n=l;continue}else{c[n>>2]=m+4;n=l;continue}}}else if((t|0)==54){t=0;l=c[m>>2]|0;if((l|0)==(c[n>>2]|0))Ib[c[(c[k>>2]|0)+40>>2]&127](k)|0;else c[m>>2]=l+4;h=h+4|0}while(0);k=c[f>>2]|0}if((t|0)==17){c[f>>2]=4;b=d}else if((t|0)==21){c[f>>2]=4;b=d}else if((t|0)==26){c[f>>2]=4;b=d}if(!k){k=0;h=1}else{d=c[k+12>>2]|0;if((d|0)==(c[k+16>>2]|0))d=Ib[c[(c[k>>2]|0)+36>>2]&127](k)|0;else d=c[d>>2]|0;h=(d|0)==-1;k=h?0:k}if(b){d=c[b+12>>2]|0;if((d|0)==(c[b+16>>2]|0))d=Ib[c[(c[b>>2]|0)+36>>2]&127](b)|0;else d=c[d>>2]|0;if((d|0)!=-1){if(!h)t=72}else t=70}else t=70;if((t|0)==70?h:0)t=72;if((t|0)==72)c[f>>2]=c[f>>2]|2;i=u;return k|0}function zc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;u=i;v=i=i+63&-64;i=i+16|0;t=Ro(c[j>>2]|0,51916)|0;r=Ro(c[j>>2]|0,51928)|0;Gb[c[(c[r>>2]|0)+20>>2]&127](v,r);c[h>>2]=f;j=a[b>>0]|0;switch(j<<24>>24){case 43:case 45:{o=0;j=va(c[(c[t>>2]|0)+28>>2]|0,t|0,j|0)|0;s=o;o=0;if(s&1)s=6;else{l=c[h>>2]|0;c[h>>2]=l+1;a[l>>0]=j;l=b+1|0;s=8}break}default:{l=b;s=8}}a:do if((s|0)==8){b:do if((e-l|0)>1?(a[l>>0]|0)==48:0){k=l+1|0;switch(a[k>>0]|0){case 88:case 120:break;default:{j=l;s=17;break b}}o=0;j=va(c[(c[t>>2]|0)+28>>2]|0,t|0,48)|0;q=o;o=0;if(q&1){s=6;break a}q=c[h>>2]|0;c[h>>2]=q+1;a[q>>0]=j;l=l+2|0;o=0;j=va(c[(c[t>>2]|0)+28>>2]|0,t|0,a[k>>0]|0)|0;q=o;o=0;if(q&1){s=6;break a}q=c[h>>2]|0;c[h>>2]=q+1;a[q>>0]=j;j=l;while(1){if(j>>>0>=e>>>0){q=j;break b}q=a[j>>0]|0;To()|0;if(!(Js(q<<24>>24)|0)){q=j;break b}j=j+1|0}}else{j=l;s=17}while(0);c:do if((s|0)==17)while(1){s=0;if(j>>>0>=e>>>0){q=j;break c}q=a[j>>0]|0;To()|0;if(!(ts(q<<24>>24)|0)){q=j;break c}j=j+1|0;s=17}while(0);p=a[v+11>>0]|0;d:do if((p<<24>>24<0?c[v+4>>2]|0:p&255)|0){e:do if((l|0)!=(q|0)){j=q;k=l;while(1){j=j+-1|0;if(k>>>0>=j>>>0)break e;p=a[k>>0]|0;a[k>>0]=a[j>>0]|0;a[j>>0]=p;k=k+1|0}}while(0);o=0;n=ha(c[(c[r>>2]|0)+16>>2]|0,r|0)|0;p=o;o=0;if(p&1){s=6;break a}j=0;k=0;p=l;while(1){if(p>>>0>=q>>>0)break;m=a[((a[v+11>>0]|0)<0?c[v>>2]|0:v)+k>>0]|0;if(m<<24>>24>0&(j|0)==(m<<24>>24|0)){j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=n;j=a[v+11>>0]|0;m=0;k=(k>>>0<((j<<24>>24<0?c[v+4>>2]|0:j&255)+-1|0)>>>0&1)+k|0}else m=j;o=0;j=va(c[(c[t>>2]|0)+28>>2]|0,t|0,a[p>>0]|0)|0;w=o;o=0;if(w&1){s=5;break}w=c[h>>2]|0;c[h>>2]=w+1;a[w>>0]=j;j=m+1|0;p=p+1|0}if((s|0)==5){j=Ya()|0;break a}k=f+(l-b)|0;j=c[h>>2]|0;if((k|0)==(j|0))k=t;else while(1){j=j+-1|0;if(k>>>0>=j>>>0){k=t;break d}w=a[k>>0]|0;a[k>>0]=a[j>>0]|0;a[j>>0]=w;k=k+1|0}}else{o=0;Ba(c[(c[t>>2]|0)+32>>2]|0,t|0,l|0,q|0,c[h>>2]|0)|0;w=o;o=0;if(w&1){s=6;break a}c[h>>2]=(c[h>>2]|0)+(q-l);k=t}while(0);l=q;while(1){if(l>>>0>=e>>>0){j=l;break}j=a[l>>0]|0;if(j<<24>>24==46){s=39;break}o=0;j=va(c[(c[k>>2]|0)+28>>2]|0,t|0,j|0)|0;w=o;o=0;if(w&1){s=4;break}w=c[h>>2]|0;c[h>>2]=w+1;a[w>>0]=j;l=l+1|0}if((s|0)==4){j=Ya()|0;break}if((s|0)==39){o=0;j=ha(c[(c[r>>2]|0)+12>>2]|0,r|0)|0;w=o;o=0;if(w&1){s=6;break}w=c[h>>2]|0;c[h>>2]=w+1;a[w>>0]=j;j=l+1|0}o=0;Ba(c[(c[t>>2]|0)+32>>2]|0,t|0,j|0,e|0,c[h>>2]|0)|0;w=o;o=0;if(w&1)s=6;else{w=(c[h>>2]|0)+(e-j)|0;c[h>>2]=w;c[g>>2]=(d|0)==(e|0)?w:f+(d-b)|0;Oo(v);i=u;return}}while(0);if((s|0)==6)j=Ya()|0;Oo(v);Ra(j|0)}function Ac(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;u=i;v=i=i+63&-64;i=i+16|0;t=Ro(c[j>>2]|0,51948)|0;r=Ro(c[j>>2]|0,51956)|0;Gb[c[(c[r>>2]|0)+20>>2]&127](v,r);c[h>>2]=f;j=a[b>>0]|0;switch(j<<24>>24){case 43:case 45:{o=0;j=va(c[(c[t>>2]|0)+44>>2]|0,t|0,j|0)|0;s=o;o=0;if(s&1)s=6;else{l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=j;l=b+1|0;s=8}break}default:{l=b;s=8}}a:do if((s|0)==8){b:do if((e-l|0)>1?(a[l>>0]|0)==48:0){k=l+1|0;switch(a[k>>0]|0){case 88:case 120:break;default:{j=l;s=17;break b}}o=0;j=va(c[(c[t>>2]|0)+44>>2]|0,t|0,48)|0;q=o;o=0;if(q&1){s=6;break a}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=j;l=l+2|0;o=0;j=va(c[(c[t>>2]|0)+44>>2]|0,t|0,a[k>>0]|0)|0;q=o;o=0;if(q&1){s=6;break a}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=j;j=l;while(1){if(j>>>0>=e>>>0)break b;q=a[j>>0]|0;To()|0;if(!(Js(q<<24>>24)|0))break b;j=j+1|0}}else{j=l;s=17}while(0);c:do if((s|0)==17)while(1){s=0;if(j>>>0>=e>>>0)break c;q=a[j>>0]|0;To()|0;if(!(ts(q<<24>>24)|0))break c;j=j+1|0;s=17}while(0);q=a[v+11>>0]|0;d:do if((q<<24>>24<0?c[v+4>>2]|0:q&255)|0){e:do if((l|0)!=(j|0)){k=j;m=l;while(1){k=k+-1|0;if(m>>>0>=k>>>0)break e;q=a[m>>0]|0;a[m>>0]=a[k>>0]|0;a[k>>0]=q;m=m+1|0}}while(0);o=0;p=ha(c[(c[r>>2]|0)+16>>2]|0,r|0)|0;q=o;o=0;if(q&1){s=6;break a}m=0;n=0;q=l;while(1){if(q>>>0>=j>>>0)break;k=a[v+11>>0]|0;w=a[(k<<24>>24<0?c[v>>2]|0:v)+n>>0]|0;if(w<<24>>24>0&(m|0)==(w<<24>>24|0)){m=c[h>>2]|0;c[h>>2]=m+4;c[m>>2]=p;m=0;n=(n>>>0<((k<<24>>24<0?c[v+4>>2]|0:k&255)+-1|0)>>>0&1)+n|0}o=0;k=va(c[(c[t>>2]|0)+44>>2]|0,t|0,a[q>>0]|0)|0;w=o;o=0;if(w&1){s=5;break}w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=k;m=m+1|0;q=q+1|0}if((s|0)==5){j=Ya()|0;break a}k=f+(l-b<<2)|0;m=c[h>>2]|0;if((k|0)==(m|0))n=t;else{l=m;while(1){l=l+-4|0;if(k>>>0>=l>>>0){n=t;k=m;break d}w=c[k>>2]|0;c[k>>2]=c[l>>2];c[l>>2]=w;k=k+4|0}}}else{o=0;Ba(c[(c[t>>2]|0)+48>>2]|0,t|0,l|0,j|0,c[h>>2]|0)|0;w=o;o=0;if(w&1){s=6;break a}k=(c[h>>2]|0)+(j-l<<2)|0;c[h>>2]=k;n=t}while(0);l=j;while(1){if(l>>>0>=e>>>0){j=l;break}j=a[l>>0]|0;if(j<<24>>24==46){s=39;break}o=0;j=va(c[(c[n>>2]|0)+44>>2]|0,t|0,j|0)|0;w=o;o=0;if(w&1){s=4;break}k=c[h>>2]|0;c[h>>2]=k+4;c[k>>2]=j;k=k+4|0;l=l+1|0}if((s|0)==4){j=Ya()|0;break}if((s|0)==39){o=0;j=ha(c[(c[r>>2]|0)+12>>2]|0,r|0)|0;w=o;o=0;if(w&1){s=6;break}k=c[h>>2]|0;c[h>>2]=k+4;c[k>>2]=j;k=k+4|0;j=l+1|0}o=0;Ba(c[(c[t>>2]|0)+48>>2]|0,t|0,j|0,e|0,k|0)|0;w=o;o=0;if(w&1)s=6;else{w=(c[h>>2]|0)+(e-j<<2)|0;c[h>>2]=w;c[g>>2]=(d|0)==(e|0)?w:f+(d-b<<2)|0;Oo(v);i=u;return}}while(0);if((s|0)==6)j=Ya()|0;Oo(v);Ra(j|0)}function Bc(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,p=0,q=0;n=i;m=i=i+63&-64;i=i+16|0;c[g>>2]=0;k=Ll(f)|0;o=0;l=va(32,k|0,51948)|0;q=o;o=0;if(q&1){q=Ya()|0;Vl(k);Ra(q|0)}Vl(k);do switch(j<<24>>24|0){case 65:case 97:{th(b,h+24|0,d,c[e>>2]|0,g,l);p=28;break}case 104:case 66:case 98:{ph(b,h+16|0,d,c[e>>2]|0,g,l);p=28;break}case 99:{q=Ib[c[(c[b+8>>2]|0)+12>>2]&127](b+8|0)|0;p=a[q+8+3>>0]|0;j=p<<24>>24<0?c[q>>2]|0:q;c[d>>2]=yc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,j,j+((p<<24>>24<0?c[q+4>>2]|0:p&255)<<2)|0)|0;p=28;break}case 101:case 100:{pi(h+12|0,d,c[e>>2]|0,g,l);p=28;break}case 68:{c[d>>2]=yc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,38712,38744)|0;p=28;break}case 70:{c[d>>2]=yc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,38744,38776)|0;p=28;break}case 72:{Di(h+8|0,d,c[e>>2]|0,g,l);p=28;break}case 73:{li(h+8|0,d,c[e>>2]|0,g,l);p=28;break}case 106:{qi(h+28|0,d,c[e>>2]|0,g,l);p=28;break}case 109:{ui(h+16|0,d,c[e>>2]|0,g,l);p=28;break}case 77:{zi(h+4|0,d,c[e>>2]|0,g,l);p=28;break}case 116:case 110:{Md(d,c[e>>2]|0,g,l);p=28;break}case 112:{Df(b,h+8|0,d,c[e>>2]|0,g,l);p=28;break}case 114:{c[d>>2]=yc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,38776,38820)|0;p=28;break}case 82:{c[d>>2]=yc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,38820,38840)|0;p=28;break}case 83:{yi(h,d,c[e>>2]|0,g,l);p=28;break}case 84:{c[d>>2]=yc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,38840,38872)|0;p=28;break}case 119:{xi(h+24|0,d,c[e>>2]|0,g,l);p=28;break}case 120:{k=c[(c[b>>2]|0)+20>>2]|0;c[m+4>>2]=c[d>>2];c[m>>2]=c[e>>2];c[m+8>>2]=c[m+4>>2];c[m+12>>2]=c[m>>2];k=Hb[k&63](b,m+8|0,m+12|0,f,g,h)|0;break}case 88:{q=Ib[c[(c[b+8>>2]|0)+24>>2]&127](b+8|0)|0;p=a[q+8+3>>0]|0;j=p<<24>>24<0?c[q>>2]|0:q;c[d>>2]=yc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,j,j+((p<<24>>24<0?c[q+4>>2]|0:p&255)<<2)|0)|0;p=28;break}case 121:{Vh(h+20|0,d,c[e>>2]|0,g,l);p=28;break}case 89:{cj(h+20|0,d,c[e>>2]|0,g,l);p=28;break}case 37:{Ed(d,c[e>>2]|0,g,l);p=28;break}default:{c[g>>2]=c[g>>2]|4;p=28}}while(0);if((p|0)==28)k=c[d>>2]|0;i=n;return k|0}function Cc(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;z=d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24;B=d[e+4>>0]|d[e+4+1>>0]<<8|d[e+4+2>>0]<<16|d[e+4+3>>0]<<24;C=d[e+8>>0]|d[e+8+1>>0]<<8|d[e+8+2>>0]<<16|d[e+8+3>>0]<<24;D=d[e+12>>0]|d[e+12+1>>0]<<8|d[e+12+2>>0]<<16|d[e+12+3>>0]<<24;E=d[c>>0]|d[c+1>>0]<<8|d[c+2>>0]<<16|d[c+3>>0]<<24;F=d[c+4>>0]|d[c+4+1>>0]<<8|d[c+4+2>>0]<<16|d[c+4+3>>0]<<24;A=d[c+8>>0]|d[c+8+1>>0]<<8|d[c+8+2>>0]<<16|d[c+8+3>>0]<<24;v=d[c+12>>0]|d[c+12+1>>0]<<8|d[c+12+2>>0]<<16|d[c+12+3>>0]<<24;w=d[e+16>>0]|d[e+16+1>>0]<<8|d[e+16+2>>0]<<16|d[e+16+3>>0]<<24;x=d[e+20>>0]|d[e+20+1>>0]<<8|d[e+20+2>>0]<<16|d[e+20+3>>0]<<24;y=d[e+24>>0]|d[e+24+1>>0]<<8|d[e+24+2>>0]<<16|d[e+24+3>>0]<<24;c=d[e+28>>0]|d[e+28+1>>0]<<8|d[e+28+2>>0]<<16|d[e+28+3>>0]<<24;e=20;f=1634760805;g=z;h=2036477234;i=w;j=x;k=y;l=c;m=1797285236;n=B;o=C;p=D;q=857760878;r=E;s=F;t=A;u=v;while(1){P=f+j|0;P=(P>>>25|P<<7)^p;M=P+f|0;M=(M>>>23|M<<9)^t;J=((M+P|0)>>>19|M+P<<13)^j;S=((J+M|0)>>>14|J+M<<18)^f;L=g+q|0;L=(L>>>25|L<<7)^u;I=L+q|0;I=(I>>>23|I<<9)^k;V=((I+L|0)>>>19|I+L<<13)^g;O=((V+I|0)>>>14|V+I<<18)^q;H=r+h|0;H=(H>>>25|H<<7)^l;U=H+h|0;U=(U>>>23|U<<9)^n;R=((U+H|0)>>>19|U+H<<13)^r;K=((R+U|0)>>>14|R+U<<18)^h;T=i+m|0;T=o^(T>>>25|T<<7);Q=T+m|0;Q=(Q>>>23|Q<<9)^s;N=((Q+T|0)>>>19|Q+T<<13)^i;G=((N+Q|0)>>>14|N+Q<<18)^m;g=((S+T|0)>>>25|S+T<<7)^V;V=g+S|0;n=(V>>>23|V<<9)^U;U=n+g|0;o=(U>>>19|U<<13)^T;T=o+n|0;f=(T>>>14|T<<18)^S;r=((O+P|0)>>>25|O+P<<7)^R;R=r+O|0;s=(R>>>23|R<<9)^Q;Q=s+r|0;p=(Q>>>19|Q<<13)^P;P=p+s|0;q=(P>>>14|P<<18)^O;i=((K+L|0)>>>25|K+L<<7)^N;N=i+K|0;t=(N>>>23|N<<9)^M;M=t+i|0;u=(M>>>19|M<<13)^L;L=u+t|0;h=(L>>>14|L<<18)^K;j=((G+H|0)>>>25|G+H<<7)^J;J=j+G|0;k=(J>>>23|J<<9)^I;I=k+j|0;l=(I>>>19|I<<13)^H;H=l+k|0;m=(H>>>14|H<<18)^G;if((e|0)<=2)break;else e=e+-2|0}G=f+1634760805|0;H=g+z|0;I=n+B|0;J=o+C|0;K=p+D|0;L=q+857760878|0;M=r+E|0;N=s+F|0;O=t+A|0;P=u+v|0;Q=h+2036477234|0;R=i+w|0;S=j+x|0;T=k+y|0;U=l+c|0;V=m+1797285236|0;a[b>>0]=G;a[b+1>>0]=G>>8;a[b+2>>0]=G>>16;a[b+3>>0]=G>>24;a[b+4>>0]=H;a[b+4+1>>0]=H>>8;a[b+4+2>>0]=H>>16;a[b+4+3>>0]=H>>24;a[b+8>>0]=I;a[b+8+1>>0]=I>>8;a[b+8+2>>0]=I>>16;a[b+8+3>>0]=I>>24;a[b+12>>0]=J;a[b+12+1>>0]=J>>8;a[b+12+2>>0]=J>>16;a[b+12+3>>0]=J>>24;a[b+16>>0]=K;a[b+16+1>>0]=K>>8;a[b+16+2>>0]=K>>16;a[b+16+3>>0]=K>>24;a[b+20>>0]=L;a[b+20+1>>0]=L>>8;a[b+20+2>>0]=L>>16;a[b+20+3>>0]=L>>24;a[b+24>>0]=M;a[b+24+1>>0]=M>>8;a[b+24+2>>0]=M>>16;a[b+24+3>>0]=M>>24;a[b+28>>0]=N;a[b+28+1>>0]=N>>8;a[b+28+2>>0]=N>>16;a[b+28+3>>0]=N>>24;a[b+32>>0]=O;a[b+32+1>>0]=O>>8;a[b+32+2>>0]=O>>16;a[b+32+3>>0]=O>>24;a[b+36>>0]=P;a[b+36+1>>0]=P>>8;a[b+36+2>>0]=P>>16;a[b+36+3>>0]=P>>24;a[b+40>>0]=Q;a[b+40+1>>0]=Q>>8;a[b+40+2>>0]=Q>>16;a[b+40+3>>0]=Q>>24;a[b+44>>0]=R;a[b+44+1>>0]=R>>8;a[b+44+2>>0]=R>>16;a[b+44+3>>0]=R>>24;a[b+48>>0]=S;a[b+48+1>>0]=S>>8;a[b+48+2>>0]=S>>16;a[b+48+3>>0]=S>>24;a[b+52>>0]=T;a[b+52+1>>0]=T>>8;a[b+52+2>>0]=T>>16;a[b+52+3>>0]=T>>24;a[b+56>>0]=U;a[b+56+1>>0]=U>>8;a[b+56+2>>0]=U>>16;a[b+56+3>>0]=U>>24;a[b+60>>0]=V;a[b+60+1>>0]=V>>8;a[b+60+2>>0]=V>>16;a[b+60+3>>0]=V>>24;return}function Dc(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,p=0,q=0;n=i;m=i=i+63&-64;i=i+16|0;c[g>>2]=0;k=Ll(f)|0;o=0;l=va(32,k|0,51916)|0;q=o;o=0;if(q&1){q=Ya()|0;Vl(k);Ra(q|0)}Vl(k);do switch(j<<24>>24|0){case 65:case 97:{uh(b,h+24|0,d,c[e>>2]|0,g,l);p=28;break}case 104:case 66:case 98:{qh(b,h+16|0,d,c[e>>2]|0,g,l);p=28;break}case 99:{q=Ib[c[(c[b+8>>2]|0)+12>>2]&127](b+8|0)|0;p=a[q+11>>0]|0;j=p<<24>>24<0?c[q>>2]|0:q;c[d>>2]=xc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,j,j+(p<<24>>24<0?c[q+4>>2]|0:p&255)|0)|0;p=28;break}case 101:case 100:{ri(h+12|0,d,c[e>>2]|0,g,l);p=28;break}case 68:{c[d>>2]=xc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,47269,47277)|0;p=28;break}case 70:{c[d>>2]=xc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,47277,47285)|0;p=28;break}case 72:{Ei(h+8|0,d,c[e>>2]|0,g,l);p=28;break}case 73:{mi(h+8|0,d,c[e>>2]|0,g,l);p=28;break}case 106:{si(h+28|0,d,c[e>>2]|0,g,l);p=28;break}case 109:{vi(h+16|0,d,c[e>>2]|0,g,l);p=28;break}case 77:{Ci(h+4|0,d,c[e>>2]|0,g,l);p=28;break}case 116:case 110:{Pd(d,c[e>>2]|0,g,l);p=28;break}case 112:{Ef(b,h+8|0,d,c[e>>2]|0,g,l);p=28;break}case 114:{c[d>>2]=xc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,47285,47296)|0;p=28;break}case 82:{c[d>>2]=xc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,47296,47301)|0;p=28;break}case 83:{Bi(h,d,c[e>>2]|0,g,l);p=28;break}case 84:{c[d>>2]=xc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,47301,47309)|0;p=28;break}case 119:{Ai(h+24|0,d,c[e>>2]|0,g,l);p=28;break}case 120:{k=c[(c[b>>2]|0)+20>>2]|0;c[m+4>>2]=c[d>>2];c[m>>2]=c[e>>2];c[m+8>>2]=c[m+4>>2];c[m+12>>2]=c[m>>2];k=Hb[k&63](b,m+8|0,m+12|0,f,g,h)|0;break}case 88:{q=Ib[c[(c[b+8>>2]|0)+24>>2]&127](b+8|0)|0;p=a[q+11>>0]|0;j=p<<24>>24<0?c[q>>2]|0:q;c[d>>2]=xc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,j,j+(p<<24>>24<0?c[q+4>>2]|0:p&255)|0)|0;p=28;break}case 121:{Wh(h+20|0,d,c[e>>2]|0,g,l);p=28;break}case 89:{dj(h+20|0,d,c[e>>2]|0,g,l);p=28;break}case 37:{Jd(d,c[e>>2]|0,g,l);p=28;break}default:{c[g>>2]=c[g>>2]|4;p=28}}while(0);if((p|0)==28)k=c[d>>2]|0;i=n;return k|0}function Ec(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;r=i;t=i=i+63&-64;i=i+224|0;switch(c[f+4>>2]&74|0){case 64:{q=8;break}case 8:{q=16;break}case 0:{q=0;break}default:q=10}Jf(t+184|0,f,t+198|0,t+196|0);c[t+172>>2]=0;c[t+172+4>>2]=0;c[t+172+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[t+172+(f<<2)>>2]=0;f=f+1|0}p=t+172+11|0;if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);n=o;o=0;a:do if(n&1)s=30;else{k=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=k;c[t+4>>2]=t+8;c[t>>2]=0;n=a[t+196>>0]|0;j=b;l=e;b:while(1){if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;m=o;o=0;if(m&1){s=29;break}j=(f|0)==-1?0:j;b=(f|0)==-1?0:b}}else j=0;f=(j|0)==0;do if(l){if((c[l+12>>2]|0)!=(c[l+16>>2]|0))if(f){m=l;break}else{e=l;break b}o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;m=o;o=0;if(m&1){s=29;break b}if((e|0)!=-1)if(f)m=l;else{e=l;break b}else s=21}else s=21;while(0);if((s|0)==21){s=0;if(f){j=0;e=0;break}else m=0}e=a[p>>0]|0;e=e<<24>>24<0?c[t+172+4>>2]|0:e&255;if((c[t+168>>2]|0)==(k+e|0)){o=0;da(59,t+172|0,e<<1|0);l=o;o=0;if(l&1){s=29;break}if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);l=o;o=0;if(l&1){s=29;break}k=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=k+e}e=j+12|0;f=c[e>>2]|0;l=j+16|0;if((f|0)==(c[l>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=29;break}}else f=d[f>>0]|0;if(ce(f&255,q,k,t+168|0,t,n,t+184|0,t+8|0,t+4|0,t+198|0)|0){e=m;break}f=c[e>>2]|0;if((f|0)==(c[l>>2]|0)){o=0;ha(c[(c[j>>2]|0)+40>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=29;break}else{l=m;continue}}else{c[e>>2]=f+1;l=m;continue}}if((s|0)==29){f=Ya()|0;break}u=a[t+184+11>>0]|0;f=c[t+4>>2]|0;if(((u<<24>>24<0?c[t+184+4>>2]|0:u&255)|0)!=0?(f-(t+8)|0)<160:0){u=c[t>>2]|0;c[t+4>>2]=f+4;c[f>>2]=u;f=f+4|0}u=Zf(k,c[t+168>>2]|0,g,q)|0;c[h>>2]=u;c[h+4>>2]=D;kf(t+184|0,t+8|0,f,g);if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=30;break}j=(f|0)==-1?0:j;b=(f|0)==-1?0:b}}else j=0;j=(j|0)==0;do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)){o=0;f=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;u=o;o=0;if(u&1){s=30;break a}if((f|0)==-1){s=51;break}}if(!j)s=52}else s=51;while(0);if((s|0)==51?j:0)s=52;if((s|0)==52)c[g>>2]=c[g>>2]|2;Oo(t+172|0);Oo(t+184|0);i=r;return b|0}while(0);if((s|0)==30)f=Ya()|0;Oo(t+172|0);Oo(t+184|0);Ra(f|0);return 0}function Fc(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;r=i;t=i=i+63&-64;i=i+224|0;switch(c[f+4>>2]&74|0){case 64:{q=8;break}case 8:{q=16;break}case 0:{q=0;break}default:q=10}Jf(t+184|0,f,t+198|0,t+196|0);c[t+172>>2]=0;c[t+172+4>>2]=0;c[t+172+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[t+172+(f<<2)>>2]=0;f=f+1|0}p=t+172+11|0;if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);n=o;o=0;a:do if(n&1)s=30;else{k=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=k;c[t+4>>2]=t+8;c[t>>2]=0;n=a[t+196>>0]|0;j=b;l=e;b:while(1){if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;m=o;o=0;if(m&1){s=29;break}j=(f|0)==-1?0:j;b=(f|0)==-1?0:b}}else j=0;f=(j|0)==0;do if(l){if((c[l+12>>2]|0)!=(c[l+16>>2]|0))if(f){m=l;break}else{e=l;break b}o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;m=o;o=0;if(m&1){s=29;break b}if((e|0)!=-1)if(f)m=l;else{e=l;break b}else s=21}else s=21;while(0);if((s|0)==21){s=0;if(f){j=0;e=0;break}else m=0}e=a[p>>0]|0;e=e<<24>>24<0?c[t+172+4>>2]|0:e&255;if((c[t+168>>2]|0)==(k+e|0)){o=0;da(59,t+172|0,e<<1|0);l=o;o=0;if(l&1){s=29;break}if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);l=o;o=0;if(l&1){s=29;break}k=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=k+e}e=j+12|0;f=c[e>>2]|0;l=j+16|0;if((f|0)==(c[l>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=29;break}}else f=d[f>>0]|0;if(ce(f&255,q,k,t+168|0,t,n,t+184|0,t+8|0,t+4|0,t+198|0)|0){e=m;break}f=c[e>>2]|0;if((f|0)==(c[l>>2]|0)){o=0;ha(c[(c[j>>2]|0)+40>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=29;break}else{l=m;continue}}else{c[e>>2]=f+1;l=m;continue}}if((s|0)==29){f=Ya()|0;break}u=a[t+184+11>>0]|0;f=c[t+4>>2]|0;if(((u<<24>>24<0?c[t+184+4>>2]|0:u&255)|0)!=0?(f-(t+8)|0)<160:0){u=c[t>>2]|0;c[t+4>>2]=f+4;c[f>>2]=u;f=f+4|0}u=ag(k,c[t+168>>2]|0,g,q)|0;c[h>>2]=u;c[h+4>>2]=D;kf(t+184|0,t+8|0,f,g);if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=30;break}j=(f|0)==-1?0:j;b=(f|0)==-1?0:b}}else j=0;j=(j|0)==0;do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)){o=0;f=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;u=o;o=0;if(u&1){s=30;break a}if((f|0)==-1){s=51;break}}if(!j)s=52}else s=51;while(0);if((s|0)==51?j:0)s=52;if((s|0)==52)c[g>>2]=c[g>>2]|2;Oo(t+172|0);Oo(t+184|0);i=r;return b|0}while(0);if((s|0)==30)f=Ya()|0;Oo(t+172|0);Oo(t+184|0);Ra(f|0);return 0}function Gc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0;q=i;s=i=i+63&-64;i=i+304|0;switch(c[e+4>>2]&74|0){case 64:{p=8;break}case 8:{p=16;break}case 0:{p=0;break}default:p=10}If(s+184|0,e,s+200|0,s+196|0);c[s+172>>2]=0;c[s+172+4>>2]=0;c[s+172+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[s+172+(e<<2)>>2]=0;e=e+1|0}n=s+172+11|0;if((a[n>>0]|0)<0)e=(c[s+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,s+172|0,e|0);m=o;o=0;do if(m&1)r=31;else{h=(a[n>>0]|0)<0?c[s+172>>2]|0:s+172|0;c[s+168>>2]=h;c[s+4>>2]=s+8;c[s>>2]=0;m=c[s+196>>2]|0;j=b;while(1){if(!j){l=0;j=1}else{e=c[j+12>>2]|0;if((e|0)==(c[j+16>>2]|0)){o=0;e=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;l=o;o=0;if(l&1){r=30;break}}else e=c[e>>2]|0;k=(e|0)==-1;l=k?0:j;j=k;b=k?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;k=o;o=0;if(k&1){r=30;break}}else e=c[e>>2]|0;if((e|0)!=-1)if(j)k=d;else break;else r=22}else r=22;if((r|0)==22){r=0;if(j){d=0;break}else k=0}d=a[n>>0]|0;d=d<<24>>24<0?c[s+172+4>>2]|0:d&255;if((c[s+168>>2]|0)==(h+d|0)){o=0;da(59,s+172|0,d<<1|0);j=o;o=0;if(j&1){r=30;break}if((a[n>>0]|0)<0)e=(c[s+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,s+172|0,e|0);j=o;o=0;if(j&1){r=30;break}h=(a[n>>0]|0)<0?c[s+172>>2]|0:s+172|0;c[s+168>>2]=h+d}d=l+12|0;e=c[d>>2]|0;j=l+16|0;if((e|0)==(c[j>>2]|0)){o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=30;break}}else e=c[e>>2]|0;if(de(e,p,h,s+168|0,s,m,s+184|0,s+8|0,s+4|0,s+200|0)|0){d=k;break}e=c[d>>2]|0;if((e|0)==(c[j>>2]|0)){o=0;ha(c[(c[l>>2]|0)+40>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=30;break}else{j=l;d=k;continue}}else{c[d>>2]=e+4;j=l;d=k;continue}}if((r|0)==30){e=Ya()|0;break}t=a[s+184+11>>0]|0;e=c[s+4>>2]|0;if(((t<<24>>24<0?c[s+184+4>>2]|0:t&255)|0)!=0?(e-(s+8)|0)<160:0){t=c[s>>2]|0;c[s+4>>2]=e+4;c[e>>2]=t;e=e+4|0}t=Zf(h,c[s+168>>2]|0,f,p)|0;c[g>>2]=t;c[g+4>>2]=D;kf(s+184|0,s+8|0,e,f);if(!l)h=1;else{e=c[l+12>>2]|0;if((e|0)==(c[l+16>>2]|0)){o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=31;break}}else e=c[e>>2]|0;t=(e|0)==-1;h=t;b=t?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;t=o;o=0;if(t&1){r=31;break}}else e=c[e>>2]|0;if((e|0)!=-1){if(!h)r=55}else r=53}else r=53;if((r|0)==53?h:0)r=55;if((r|0)==55)c[f>>2]=c[f>>2]|2;Oo(s+172|0);Oo(s+184|0);i=q;return b|0}while(0);if((r|0)==31)e=Ya()|0;Oo(s+172|0);Oo(s+184|0);Ra(e|0);return 0}function Hc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0;q=i;s=i=i+63&-64;i=i+304|0;switch(c[e+4>>2]&74|0){case 64:{p=8;break}case 8:{p=16;break}case 0:{p=0;break}default:p=10}If(s+184|0,e,s+200|0,s+196|0);c[s+172>>2]=0;c[s+172+4>>2]=0;c[s+172+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[s+172+(e<<2)>>2]=0;e=e+1|0}n=s+172+11|0;if((a[n>>0]|0)<0)e=(c[s+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,s+172|0,e|0);m=o;o=0;do if(m&1)r=31;else{h=(a[n>>0]|0)<0?c[s+172>>2]|0:s+172|0;c[s+168>>2]=h;c[s+4>>2]=s+8;c[s>>2]=0;m=c[s+196>>2]|0;j=b;while(1){if(!j){l=0;j=1}else{e=c[j+12>>2]|0;if((e|0)==(c[j+16>>2]|0)){o=0;e=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;l=o;o=0;if(l&1){r=30;break}}else e=c[e>>2]|0;k=(e|0)==-1;l=k?0:j;j=k;b=k?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;k=o;o=0;if(k&1){r=30;break}}else e=c[e>>2]|0;if((e|0)!=-1)if(j)k=d;else break;else r=22}else r=22;if((r|0)==22){r=0;if(j){d=0;break}else k=0}d=a[n>>0]|0;d=d<<24>>24<0?c[s+172+4>>2]|0:d&255;if((c[s+168>>2]|0)==(h+d|0)){o=0;da(59,s+172|0,d<<1|0);j=o;o=0;if(j&1){r=30;break}if((a[n>>0]|0)<0)e=(c[s+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,s+172|0,e|0);j=o;o=0;if(j&1){r=30;break}h=(a[n>>0]|0)<0?c[s+172>>2]|0:s+172|0;c[s+168>>2]=h+d}d=l+12|0;e=c[d>>2]|0;j=l+16|0;if((e|0)==(c[j>>2]|0)){o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=30;break}}else e=c[e>>2]|0;if(de(e,p,h,s+168|0,s,m,s+184|0,s+8|0,s+4|0,s+200|0)|0){d=k;break}e=c[d>>2]|0;if((e|0)==(c[j>>2]|0)){o=0;ha(c[(c[l>>2]|0)+40>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=30;break}else{j=l;d=k;continue}}else{c[d>>2]=e+4;j=l;d=k;continue}}if((r|0)==30){e=Ya()|0;break}t=a[s+184+11>>0]|0;e=c[s+4>>2]|0;if(((t<<24>>24<0?c[s+184+4>>2]|0:t&255)|0)!=0?(e-(s+8)|0)<160:0){t=c[s>>2]|0;c[s+4>>2]=e+4;c[e>>2]=t;e=e+4|0}t=ag(h,c[s+168>>2]|0,f,p)|0;c[g>>2]=t;c[g+4>>2]=D;kf(s+184|0,s+8|0,e,f);if(!l)h=1;else{e=c[l+12>>2]|0;if((e|0)==(c[l+16>>2]|0)){o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=31;break}}else e=c[e>>2]|0;t=(e|0)==-1;h=t;b=t?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;t=o;o=0;if(t&1){r=31;break}}else e=c[e>>2]|0;if((e|0)!=-1){if(!h)r=55}else r=53}else r=53;if((r|0)==53?h:0)r=55;if((r|0)==55)c[f>>2]=c[f>>2]|2;Oo(s+172|0);Oo(s+184|0);i=q;return b|0}while(0);if((r|0)==31)e=Ya()|0;Oo(s+172|0);Oo(s+184|0);Ra(e|0);return 0}function Ic(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;s=i;u=i=i+63&-64;i=i+224|0;switch(c[g+4>>2]&74|0){case 64:{r=8;break}case 8:{r=16;break}case 0:{r=0;break}default:r=10}Jf(u+184|0,g,u+198|0,u+196|0);c[u+172>>2]=0;c[u+172+4>>2]=0;c[u+172+8>>2]=0;g=0;while(1){if((g|0)==3)break;c[u+172+(g<<2)>>2]=0;g=g+1|0}q=u+172+11|0;if((a[q>>0]|0)<0)g=(c[u+172+8>>2]&2147483647)+-1|0;else g=10;o=0;da(59,u+172|0,g|0);p=o;o=0;a:do if(p&1)t=30;else{l=(a[q>>0]|0)<0?c[u+172>>2]|0:u+172|0;c[u+168>>2]=l;c[u+4>>2]=u+8;c[u>>2]=0;p=a[u+196>>0]|0;k=e;m=f;b:while(1){if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)){o=0;g=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;n=o;o=0;if(n&1){t=29;break}k=(g|0)==-1?0:k;e=(g|0)==-1?0:e}}else k=0;g=(k|0)==0;do if(m){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))if(g){n=m;break}else{f=m;break b}o=0;f=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;n=o;o=0;if(n&1){t=29;break b}if((f|0)!=-1)if(g)n=m;else{f=m;break b}else t=21}else t=21;while(0);if((t|0)==21){t=0;if(g){k=0;f=0;break}else n=0}f=a[q>>0]|0;f=f<<24>>24<0?c[u+172+4>>2]|0:f&255;if((c[u+168>>2]|0)==(l+f|0)){o=0;da(59,u+172|0,f<<1|0);m=o;o=0;if(m&1){t=29;break}if((a[q>>0]|0)<0)g=(c[u+172+8>>2]&2147483647)+-1|0;else g=10;o=0;da(59,u+172|0,g|0);m=o;o=0;if(m&1){t=29;break}l=(a[q>>0]|0)<0?c[u+172>>2]|0:u+172|0;c[u+168>>2]=l+f}f=k+12|0;g=c[f>>2]|0;m=k+16|0;if((g|0)==(c[m>>2]|0)){o=0;g=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;v=o;o=0;if(v&1){t=29;break}}else g=d[g>>0]|0;if(ce(g&255,r,l,u+168|0,u,p,u+184|0,u+8|0,u+4|0,u+198|0)|0){f=n;break}g=c[f>>2]|0;if((g|0)==(c[m>>2]|0)){o=0;ha(c[(c[k>>2]|0)+40>>2]|0,k|0)|0;v=o;o=0;if(v&1){t=29;break}else{m=n;continue}}else{c[f>>2]=g+1;m=n;continue}}if((t|0)==29){g=Ya()|0;break}v=a[u+184+11>>0]|0;g=c[u+4>>2]|0;if(((v<<24>>24<0?c[u+184+4>>2]|0:v&255)|0)!=0?(g-(u+8)|0)<160:0){v=c[u>>2]|0;c[u+4>>2]=g+4;c[g>>2]=v;g=g+4|0}b[j>>1]=Pf(l,c[u+168>>2]|0,h,r)|0;kf(u+184|0,u+8|0,g,h);if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)){o=0;g=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;v=o;o=0;if(v&1){t=30;break}k=(g|0)==-1?0:k;e=(g|0)==-1?0:e}}else k=0;k=(k|0)==0;do if(f){if((c[f+12>>2]|0)==(c[f+16>>2]|0)){o=0;g=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;v=o;o=0;if(v&1){t=30;break a}if((g|0)==-1){t=51;break}}if(!k)t=52}else t=51;while(0);if((t|0)==51?k:0)t=52;if((t|0)==52)c[h>>2]=c[h>>2]|2;Oo(u+172|0);Oo(u+184|0);i=s;return e|0}while(0);if((t|0)==30)g=Ya()|0;Oo(u+172|0);Oo(u+184|0);Ra(g|0);return 0}function Jc(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;r=i;t=i=i+63&-64;i=i+224|0;switch(c[f+4>>2]&74|0){case 64:{q=8;break}case 8:{q=16;break}case 0:{q=0;break}default:q=10}Jf(t+184|0,f,t+198|0,t+196|0);c[t+172>>2]=0;c[t+172+4>>2]=0;c[t+172+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[t+172+(f<<2)>>2]=0;f=f+1|0}p=t+172+11|0;if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);n=o;o=0;a:do if(n&1)s=30;else{k=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=k;c[t+4>>2]=t+8;c[t>>2]=0;n=a[t+196>>0]|0;j=b;l=e;b:while(1){if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;m=o;o=0;if(m&1){s=29;break}j=(f|0)==-1?0:j;b=(f|0)==-1?0:b}}else j=0;f=(j|0)==0;do if(l){if((c[l+12>>2]|0)!=(c[l+16>>2]|0))if(f){m=l;break}else{e=l;break b}o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;m=o;o=0;if(m&1){s=29;break b}if((e|0)!=-1)if(f)m=l;else{e=l;break b}else s=21}else s=21;while(0);if((s|0)==21){s=0;if(f){j=0;e=0;break}else m=0}e=a[p>>0]|0;e=e<<24>>24<0?c[t+172+4>>2]|0:e&255;if((c[t+168>>2]|0)==(k+e|0)){o=0;da(59,t+172|0,e<<1|0);l=o;o=0;if(l&1){s=29;break}if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);l=o;o=0;if(l&1){s=29;break}k=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=k+e}e=j+12|0;f=c[e>>2]|0;l=j+16|0;if((f|0)==(c[l>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=29;break}}else f=d[f>>0]|0;if(ce(f&255,q,k,t+168|0,t,n,t+184|0,t+8|0,t+4|0,t+198|0)|0){e=m;break}f=c[e>>2]|0;if((f|0)==(c[l>>2]|0)){o=0;ha(c[(c[j>>2]|0)+40>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=29;break}else{l=m;continue}}else{c[e>>2]=f+1;l=m;continue}}if((s|0)==29){f=Ya()|0;break}u=a[t+184+11>>0]|0;f=c[t+4>>2]|0;if(((u<<24>>24<0?c[t+184+4>>2]|0:u&255)|0)!=0?(f-(t+8)|0)<160:0){u=c[t>>2]|0;c[t+4>>2]=f+4;c[f>>2]=u;f=f+4|0}c[h>>2]=Tf(k,c[t+168>>2]|0,g,q)|0;kf(t+184|0,t+8|0,f,g);if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=30;break}j=(f|0)==-1?0:j;b=(f|0)==-1?0:b}}else j=0;j=(j|0)==0;do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)){o=0;f=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;u=o;o=0;if(u&1){s=30;break a}if((f|0)==-1){s=51;break}}if(!j)s=52}else s=51;while(0);if((s|0)==51?j:0)s=52;if((s|0)==52)c[g>>2]=c[g>>2]|2;Oo(t+172|0);Oo(t+184|0);i=r;return b|0}while(0);if((s|0)==30)f=Ya()|0;Oo(t+172|0);Oo(t+184|0);Ra(f|0);return 0}function Kc(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;r=i;t=i=i+63&-64;i=i+224|0;switch(c[f+4>>2]&74|0){case 64:{q=8;break}case 8:{q=16;break}case 0:{q=0;break}default:q=10}Jf(t+184|0,f,t+198|0,t+196|0);c[t+172>>2]=0;c[t+172+4>>2]=0;c[t+172+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[t+172+(f<<2)>>2]=0;f=f+1|0}p=t+172+11|0;if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);n=o;o=0;a:do if(n&1)s=30;else{k=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=k;c[t+4>>2]=t+8;c[t>>2]=0;n=a[t+196>>0]|0;j=b;l=e;b:while(1){if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;m=o;o=0;if(m&1){s=29;break}j=(f|0)==-1?0:j;b=(f|0)==-1?0:b}}else j=0;f=(j|0)==0;do if(l){if((c[l+12>>2]|0)!=(c[l+16>>2]|0))if(f){m=l;break}else{e=l;break b}o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;m=o;o=0;if(m&1){s=29;break b}if((e|0)!=-1)if(f)m=l;else{e=l;break b}else s=21}else s=21;while(0);if((s|0)==21){s=0;if(f){j=0;e=0;break}else m=0}e=a[p>>0]|0;e=e<<24>>24<0?c[t+172+4>>2]|0:e&255;if((c[t+168>>2]|0)==(k+e|0)){o=0;da(59,t+172|0,e<<1|0);l=o;o=0;if(l&1){s=29;break}if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);l=o;o=0;if(l&1){s=29;break}k=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=k+e}e=j+12|0;f=c[e>>2]|0;l=j+16|0;if((f|0)==(c[l>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=29;break}}else f=d[f>>0]|0;if(ce(f&255,q,k,t+168|0,t,n,t+184|0,t+8|0,t+4|0,t+198|0)|0){e=m;break}f=c[e>>2]|0;if((f|0)==(c[l>>2]|0)){o=0;ha(c[(c[j>>2]|0)+40>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=29;break}else{l=m;continue}}else{c[e>>2]=f+1;l=m;continue}}if((s|0)==29){f=Ya()|0;break}u=a[t+184+11>>0]|0;f=c[t+4>>2]|0;if(((u<<24>>24<0?c[t+184+4>>2]|0:u&255)|0)!=0?(f-(t+8)|0)<160:0){u=c[t>>2]|0;c[t+4>>2]=f+4;c[f>>2]=u;f=f+4|0}c[h>>2]=tf(k,c[t+168>>2]|0,g,q)|0;kf(t+184|0,t+8|0,f,g);if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)){o=0;f=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;u=o;o=0;if(u&1){s=30;break}j=(f|0)==-1?0:j;b=(f|0)==-1?0:b}}else j=0;j=(j|0)==0;do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)){o=0;f=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;u=o;o=0;if(u&1){s=30;break a}if((f|0)==-1){s=51;break}}if(!j)s=52}else s=51;while(0);if((s|0)==51?j:0)s=52;if((s|0)==52)c[g>>2]=c[g>>2]|2;Oo(t+172|0);Oo(t+184|0);i=r;return b|0}while(0);if((s|0)==30)f=Ya()|0;Oo(t+172|0);Oo(t+184|0);Ra(f|0);return 0}function Lc(b,e,f,h,j){b=b|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;s=i;u=i=i+63&-64;i=i+240|0;of(u+184|0,f,u+200|0,u+199|0,u+198|0);c[u+172>>2]=0;c[u+172+4>>2]=0;c[u+172+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[u+172+(f<<2)>>2]=0;f=f+1|0}r=u+172+11|0;if((a[r>>0]|0)<0)f=(c[u+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,u+172|0,f|0);q=o;o=0;a:do if(q&1)t=26;else{l=(a[r>>0]|0)<0?c[u+172>>2]|0:u+172|0;c[u+168>>2]=l;c[u+4>>2]=u+8;c[u>>2]=0;a[u+197>>0]=1;a[u+196>>0]=69;p=a[u+199>>0]|0;q=a[u+198>>0]|0;k=b;m=e;b:while(1){if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)){o=0;f=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;n=o;o=0;if(n&1){t=25;break}k=(f|0)==-1?0:k;b=(f|0)==-1?0:b}}else k=0;f=(k|0)==0;do if(m){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))if(f){n=m;break}else{e=m;break b}o=0;e=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;n=o;o=0;if(n&1){t=25;break b}if((e|0)!=-1)if(f)n=m;else{e=m;break b}else t=17}else t=17;while(0);if((t|0)==17){t=0;if(f){k=0;e=0;break}else n=0}e=a[r>>0]|0;e=e<<24>>24<0?c[u+172+4>>2]|0:e&255;if((c[u+168>>2]|0)==(l+e|0)){o=0;da(59,u+172|0,e<<1|0);m=o;o=0;if(m&1){t=25;break}if((a[r>>0]|0)<0)f=(c[u+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,u+172|0,f|0);m=o;o=0;if(m&1){t=25;break}l=(a[r>>0]|0)<0?c[u+172>>2]|0:u+172|0;c[u+168>>2]=l+e}e=k+12|0;f=c[e>>2]|0;m=k+16|0;if((f|0)==(c[m>>2]|0)){o=0;f=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;v=o;o=0;if(v&1){t=25;break}}else f=d[f>>0]|0;if(Fd(f&255,u+197|0,u+196|0,l,u+168|0,p,q,u+184|0,u+8|0,u+4|0,u,u+200|0)|0){e=n;break}f=c[e>>2]|0;if((f|0)==(c[m>>2]|0)){o=0;ha(c[(c[k>>2]|0)+40>>2]|0,k|0)|0;v=o;o=0;if(v&1){t=25;break}else{m=n;continue}}else{c[e>>2]=f+1;m=n;continue}}if((t|0)==25){f=Ya()|0;break}v=a[u+184+11>>0]|0;f=c[u+4>>2]|0;if(!((a[u+197>>0]|0)==0?1:((v<<24>>24<0?c[u+184+4>>2]|0:v&255)|0)==0)?(f-(u+8)|0)<160:0){v=c[u>>2]|0;c[u+4>>2]=f+4;c[f>>2]=v;f=f+4|0}g[j>>2]=+bh(l,c[u+168>>2]|0,h);kf(u+184|0,u+8|0,f,h);if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)){o=0;f=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;v=o;o=0;if(v&1){t=26;break}k=(f|0)==-1?0:k;b=(f|0)==-1?0:b}}else k=0;k=(k|0)==0;do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)){o=0;f=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;v=o;o=0;if(v&1){t=26;break a}if((f|0)==-1){t=47;break}}if(!k)t=48}else t=47;while(0);if((t|0)==47?k:0)t=48;if((t|0)==48)c[h>>2]=c[h>>2]|2;Oo(u+172|0);Oo(u+184|0);i=s;return b|0}while(0);if((t|0)==26)f=Ya()|0;Oo(u+172|0);Oo(u+184|0);Ra(f|0);return 0}function Mc(b,e,f,g,j){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;s=i;u=i=i+63&-64;i=i+240|0;of(u+184|0,f,u+200|0,u+199|0,u+198|0);c[u+172>>2]=0;c[u+172+4>>2]=0;c[u+172+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[u+172+(f<<2)>>2]=0;f=f+1|0}r=u+172+11|0;if((a[r>>0]|0)<0)f=(c[u+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,u+172|0,f|0);q=o;o=0;a:do if(q&1)t=26;else{l=(a[r>>0]|0)<0?c[u+172>>2]|0:u+172|0;c[u+168>>2]=l;c[u+4>>2]=u+8;c[u>>2]=0;a[u+197>>0]=1;a[u+196>>0]=69;p=a[u+199>>0]|0;q=a[u+198>>0]|0;k=b;m=e;b:while(1){if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)){o=0;f=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;n=o;o=0;if(n&1){t=25;break}k=(f|0)==-1?0:k;b=(f|0)==-1?0:b}}else k=0;f=(k|0)==0;do if(m){if((c[m+12>>2]|0)!=(c[m+16>>2]|0))if(f){n=m;break}else{e=m;break b}o=0;e=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;n=o;o=0;if(n&1){t=25;break b}if((e|0)!=-1)if(f)n=m;else{e=m;break b}else t=17}else t=17;while(0);if((t|0)==17){t=0;if(f){k=0;e=0;break}else n=0}e=a[r>>0]|0;e=e<<24>>24<0?c[u+172+4>>2]|0:e&255;if((c[u+168>>2]|0)==(l+e|0)){o=0;da(59,u+172|0,e<<1|0);m=o;o=0;if(m&1){t=25;break}if((a[r>>0]|0)<0)f=(c[u+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,u+172|0,f|0);m=o;o=0;if(m&1){t=25;break}l=(a[r>>0]|0)<0?c[u+172>>2]|0:u+172|0;c[u+168>>2]=l+e}e=k+12|0;f=c[e>>2]|0;m=k+16|0;if((f|0)==(c[m>>2]|0)){o=0;f=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;v=o;o=0;if(v&1){t=25;break}}else f=d[f>>0]|0;if(Fd(f&255,u+197|0,u+196|0,l,u+168|0,p,q,u+184|0,u+8|0,u+4|0,u,u+200|0)|0){e=n;break}f=c[e>>2]|0;if((f|0)==(c[m>>2]|0)){o=0;ha(c[(c[k>>2]|0)+40>>2]|0,k|0)|0;v=o;o=0;if(v&1){t=25;break}else{m=n;continue}}else{c[e>>2]=f+1;m=n;continue}}if((t|0)==25){f=Ya()|0;break}v=a[u+184+11>>0]|0;f=c[u+4>>2]|0;if(!((a[u+197>>0]|0)==0?1:((v<<24>>24<0?c[u+184+4>>2]|0:v&255)|0)==0)?(f-(u+8)|0)<160:0){v=c[u>>2]|0;c[u+4>>2]=f+4;c[f>>2]=v;f=f+4|0}h[j>>3]=+bh(l,c[u+168>>2]|0,g);kf(u+184|0,u+8|0,f,g);if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)){o=0;f=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;v=o;o=0;if(v&1){t=26;break}k=(f|0)==-1?0:k;b=(f|0)==-1?0:b}}else k=0;k=(k|0)==0;do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)){o=0;f=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;v=o;o=0;if(v&1){t=26;break a}if((f|0)==-1){t=47;break}}if(!k)t=48}else t=47;while(0);if((t|0)==47?k:0)t=48;if((t|0)==48)c[g>>2]=c[g>>2]|2;Oo(u+172|0);Oo(u+184|0);i=s;return b|0}while(0);if((t|0)==26)f=Ya()|0;Oo(u+172|0);Oo(u+184|0);Ra(f|0);return 0}function Nc(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;r=i;t=i=i+63&-64;i=i+304|0;switch(c[f+4>>2]&74|0){case 64:{q=8;break}case 8:{q=16;break}case 0:{q=0;break}default:q=10}If(t+184|0,f,t+200|0,t+196|0);c[t+172>>2]=0;c[t+172+4>>2]=0;c[t+172+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[t+172+(f<<2)>>2]=0;f=f+1|0}p=t+172+11|0;if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);n=o;o=0;do if(n&1)s=31;else{j=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=j;c[t+4>>2]=t+8;c[t>>2]=0;n=c[t+196>>2]|0;k=d;while(1){if(!k){m=0;k=1}else{f=c[k+12>>2]|0;if((f|0)==(c[k+16>>2]|0)){o=0;f=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;m=o;o=0;if(m&1){s=30;break}}else f=c[f>>2]|0;l=(f|0)==-1;m=l?0:k;k=l;d=l?0:d}if(e){f=c[e+12>>2]|0;if((f|0)==(c[e+16>>2]|0)){o=0;f=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;l=o;o=0;if(l&1){s=30;break}}else f=c[f>>2]|0;if((f|0)!=-1)if(k)l=e;else break;else s=22}else s=22;if((s|0)==22){s=0;if(k){e=0;break}else l=0}e=a[p>>0]|0;e=e<<24>>24<0?c[t+172+4>>2]|0:e&255;if((c[t+168>>2]|0)==(j+e|0)){o=0;da(59,t+172|0,e<<1|0);k=o;o=0;if(k&1){s=30;break}if((a[p>>0]|0)<0)f=(c[t+172+8>>2]&2147483647)+-1|0;else f=10;o=0;da(59,t+172|0,f|0);k=o;o=0;if(k&1){s=30;break}j=(a[p>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=j+e}e=m+12|0;f=c[e>>2]|0;k=m+16|0;if((f|0)==(c[k>>2]|0)){o=0;f=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;u=o;o=0;if(u&1){s=30;break}}else f=c[f>>2]|0;if(de(f,q,j,t+168|0,t,n,t+184|0,t+8|0,t+4|0,t+200|0)|0){e=l;break}f=c[e>>2]|0;if((f|0)==(c[k>>2]|0)){o=0;ha(c[(c[m>>2]|0)+40>>2]|0,m|0)|0;u=o;o=0;if(u&1){s=30;break}else{k=m;e=l;continue}}else{c[e>>2]=f+4;k=m;e=l;continue}}if((s|0)==30){f=Ya()|0;break}u=a[t+184+11>>0]|0;f=c[t+4>>2]|0;if(((u<<24>>24<0?c[t+184+4>>2]|0:u&255)|0)!=0?(f-(t+8)|0)<160:0){u=c[t>>2]|0;c[t+4>>2]=f+4;c[f>>2]=u;f=f+4|0}b[h>>1]=Pf(j,c[t+168>>2]|0,g,q)|0;kf(t+184|0,t+8|0,f,g);if(!m)j=1;else{f=c[m+12>>2]|0;if((f|0)==(c[m+16>>2]|0)){o=0;f=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;u=o;o=0;if(u&1){s=31;break}}else f=c[f>>2]|0;u=(f|0)==-1;j=u;d=u?0:d}if(e){f=c[e+12>>2]|0;if((f|0)==(c[e+16>>2]|0)){o=0;f=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;u=o;o=0;if(u&1){s=31;break}}else f=c[f>>2]|0;if((f|0)!=-1){if(!j)s=55}else s=53}else s=53;if((s|0)==53?j:0)s=55;if((s|0)==55)c[g>>2]=c[g>>2]|2;Oo(t+172|0);Oo(t+184|0);i=r;return d|0}while(0);if((s|0)==31)f=Ya()|0;Oo(t+172|0);Oo(t+184|0);Ra(f|0);return 0}function Oc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0;q=i;s=i=i+63&-64;i=i+304|0;switch(c[e+4>>2]&74|0){case 64:{p=8;break}case 8:{p=16;break}case 0:{p=0;break}default:p=10}If(s+184|0,e,s+200|0,s+196|0);c[s+172>>2]=0;c[s+172+4>>2]=0;c[s+172+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[s+172+(e<<2)>>2]=0;e=e+1|0}n=s+172+11|0;if((a[n>>0]|0)<0)e=(c[s+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,s+172|0,e|0);m=o;o=0;do if(m&1)r=31;else{h=(a[n>>0]|0)<0?c[s+172>>2]|0:s+172|0;c[s+168>>2]=h;c[s+4>>2]=s+8;c[s>>2]=0;m=c[s+196>>2]|0;j=b;while(1){if(!j){l=0;j=1}else{e=c[j+12>>2]|0;if((e|0)==(c[j+16>>2]|0)){o=0;e=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;l=o;o=0;if(l&1){r=30;break}}else e=c[e>>2]|0;k=(e|0)==-1;l=k?0:j;j=k;b=k?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;k=o;o=0;if(k&1){r=30;break}}else e=c[e>>2]|0;if((e|0)!=-1)if(j)k=d;else break;else r=22}else r=22;if((r|0)==22){r=0;if(j){d=0;break}else k=0}d=a[n>>0]|0;d=d<<24>>24<0?c[s+172+4>>2]|0:d&255;if((c[s+168>>2]|0)==(h+d|0)){o=0;da(59,s+172|0,d<<1|0);j=o;o=0;if(j&1){r=30;break}if((a[n>>0]|0)<0)e=(c[s+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,s+172|0,e|0);j=o;o=0;if(j&1){r=30;break}h=(a[n>>0]|0)<0?c[s+172>>2]|0:s+172|0;c[s+168>>2]=h+d}d=l+12|0;e=c[d>>2]|0;j=l+16|0;if((e|0)==(c[j>>2]|0)){o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=30;break}}else e=c[e>>2]|0;if(de(e,p,h,s+168|0,s,m,s+184|0,s+8|0,s+4|0,s+200|0)|0){d=k;break}e=c[d>>2]|0;if((e|0)==(c[j>>2]|0)){o=0;ha(c[(c[l>>2]|0)+40>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=30;break}else{j=l;d=k;continue}}else{c[d>>2]=e+4;j=l;d=k;continue}}if((r|0)==30){e=Ya()|0;break}t=a[s+184+11>>0]|0;e=c[s+4>>2]|0;if(((t<<24>>24<0?c[s+184+4>>2]|0:t&255)|0)!=0?(e-(s+8)|0)<160:0){t=c[s>>2]|0;c[s+4>>2]=e+4;c[e>>2]=t;e=e+4|0}c[g>>2]=Tf(h,c[s+168>>2]|0,f,p)|0;kf(s+184|0,s+8|0,e,f);if(!l)h=1;else{e=c[l+12>>2]|0;if((e|0)==(c[l+16>>2]|0)){o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=31;break}}else e=c[e>>2]|0;t=(e|0)==-1;h=t;b=t?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;t=o;o=0;if(t&1){r=31;break}}else e=c[e>>2]|0;if((e|0)!=-1){if(!h)r=55}else r=53}else r=53;if((r|0)==53?h:0)r=55;if((r|0)==55)c[f>>2]=c[f>>2]|2;Oo(s+172|0);Oo(s+184|0);i=q;return b|0}while(0);if((r|0)==31)e=Ya()|0;Oo(s+172|0);Oo(s+184|0);Ra(e|0);return 0}function Pc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0;q=i;s=i=i+63&-64;i=i+304|0;switch(c[e+4>>2]&74|0){case 64:{p=8;break}case 8:{p=16;break}case 0:{p=0;break}default:p=10}If(s+184|0,e,s+200|0,s+196|0);c[s+172>>2]=0;c[s+172+4>>2]=0;c[s+172+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[s+172+(e<<2)>>2]=0;e=e+1|0}n=s+172+11|0;if((a[n>>0]|0)<0)e=(c[s+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,s+172|0,e|0);m=o;o=0;do if(m&1)r=31;else{h=(a[n>>0]|0)<0?c[s+172>>2]|0:s+172|0;c[s+168>>2]=h;c[s+4>>2]=s+8;c[s>>2]=0;m=c[s+196>>2]|0;j=b;while(1){if(!j){l=0;j=1}else{e=c[j+12>>2]|0;if((e|0)==(c[j+16>>2]|0)){o=0;e=ha(c[(c[j>>2]|0)+36>>2]|0,j|0)|0;l=o;o=0;if(l&1){r=30;break}}else e=c[e>>2]|0;k=(e|0)==-1;l=k?0:j;j=k;b=k?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;k=o;o=0;if(k&1){r=30;break}}else e=c[e>>2]|0;if((e|0)!=-1)if(j)k=d;else break;else r=22}else r=22;if((r|0)==22){r=0;if(j){d=0;break}else k=0}d=a[n>>0]|0;d=d<<24>>24<0?c[s+172+4>>2]|0:d&255;if((c[s+168>>2]|0)==(h+d|0)){o=0;da(59,s+172|0,d<<1|0);j=o;o=0;if(j&1){r=30;break}if((a[n>>0]|0)<0)e=(c[s+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,s+172|0,e|0);j=o;o=0;if(j&1){r=30;break}h=(a[n>>0]|0)<0?c[s+172>>2]|0:s+172|0;c[s+168>>2]=h+d}d=l+12|0;e=c[d>>2]|0;j=l+16|0;if((e|0)==(c[j>>2]|0)){o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=30;break}}else e=c[e>>2]|0;if(de(e,p,h,s+168|0,s,m,s+184|0,s+8|0,s+4|0,s+200|0)|0){d=k;break}e=c[d>>2]|0;if((e|0)==(c[j>>2]|0)){o=0;ha(c[(c[l>>2]|0)+40>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=30;break}else{j=l;d=k;continue}}else{c[d>>2]=e+4;j=l;d=k;continue}}if((r|0)==30){e=Ya()|0;break}t=a[s+184+11>>0]|0;e=c[s+4>>2]|0;if(((t<<24>>24<0?c[s+184+4>>2]|0:t&255)|0)!=0?(e-(s+8)|0)<160:0){t=c[s>>2]|0;c[s+4>>2]=e+4;c[e>>2]=t;e=e+4|0}c[g>>2]=tf(h,c[s+168>>2]|0,f,p)|0;kf(s+184|0,s+8|0,e,f);if(!l)h=1;else{e=c[l+12>>2]|0;if((e|0)==(c[l+16>>2]|0)){o=0;e=ha(c[(c[l>>2]|0)+36>>2]|0,l|0)|0;t=o;o=0;if(t&1){r=31;break}}else e=c[e>>2]|0;t=(e|0)==-1;h=t;b=t?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;t=o;o=0;if(t&1){r=31;break}}else e=c[e>>2]|0;if((e|0)!=-1){if(!h)r=55}else r=53}else r=53;if((r|0)==53?h:0)r=55;if((r|0)==55)c[f>>2]=c[f>>2]|2;Oo(s+172|0);Oo(s+184|0);i=q;return b|0}while(0);if((r|0)==31)e=Ya()|0;Oo(s+172|0);Oo(s+184|0);Ra(e|0);return 0}function Qc(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;r=i;t=i=i+63&-64;i=i+352|0;nf(t+184|0,e,t+208|0,t+200|0,t+196|0);c[t+172>>2]=0;c[t+172+4>>2]=0;c[t+172+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[t+172+(e<<2)>>2]=0;e=e+1|0}q=t+172+11|0;if((a[q>>0]|0)<0)e=(c[t+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,t+172|0,e|0);p=o;o=0;do if(p&1)s=27;else{j=(a[q>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=j;c[t+4>>2]=t+8;c[t>>2]=0;a[t+337>>0]=1;a[t+336>>0]=69;n=c[t+200>>2]|0;p=c[t+196>>2]|0;k=b;while(1){if(!k){m=0;k=1}else{e=c[k+12>>2]|0;if((e|0)==(c[k+16>>2]|0)){o=0;e=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;m=o;o=0;if(m&1){s=26;break}}else e=c[e>>2]|0;l=(e|0)==-1;m=l?0:k;k=l;b=l?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;l=o;o=0;if(l&1){s=26;break}}else e=c[e>>2]|0;if((e|0)!=-1)if(k)l=d;else break;else s=18}else s=18;if((s|0)==18){s=0;if(k){d=0;break}else l=0}d=a[q>>0]|0;d=d<<24>>24<0?c[t+172+4>>2]|0:d&255;if((c[t+168>>2]|0)==(j+d|0)){o=0;da(59,t+172|0,d<<1|0);k=o;o=0;if(k&1){s=26;break}if((a[q>>0]|0)<0)e=(c[t+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,t+172|0,e|0);k=o;o=0;if(k&1){s=26;break}j=(a[q>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=j+d}d=m+12|0;e=c[d>>2]|0;k=m+16|0;if((e|0)==(c[k>>2]|0)){o=0;e=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;u=o;o=0;if(u&1){s=26;break}}else e=c[e>>2]|0;if(Kd(e,t+337|0,t+336|0,j,t+168|0,n,p,t+184|0,t+8|0,t+4|0,t,t+208|0)|0){d=l;break}e=c[d>>2]|0;if((e|0)==(c[k>>2]|0)){o=0;ha(c[(c[m>>2]|0)+40>>2]|0,m|0)|0;u=o;o=0;if(u&1){s=26;break}else{k=m;d=l;continue}}else{c[d>>2]=e+4;k=m;d=l;continue}}if((s|0)==26){e=Ya()|0;break}u=a[t+184+11>>0]|0;e=c[t+4>>2]|0;if(!((a[t+337>>0]|0)==0?1:((u<<24>>24<0?c[t+184+4>>2]|0:u&255)|0)==0)?(e-(t+8)|0)<160:0){u=c[t>>2]|0;c[t+4>>2]=e+4;c[e>>2]=u;e=e+4|0}g[h>>2]=+bh(j,c[t+168>>2]|0,f);kf(t+184|0,t+8|0,e,f);if(!m)j=1;else{e=c[m+12>>2]|0;if((e|0)==(c[m+16>>2]|0)){o=0;e=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;u=o;o=0;if(u&1){s=27;break}}else e=c[e>>2]|0;u=(e|0)==-1;j=u;b=u?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;u=o;o=0;if(u&1){s=27;break}}else e=c[e>>2]|0;if((e|0)!=-1){if(!j)s=51}else s=49}else s=49;if((s|0)==49?j:0)s=51;if((s|0)==51)c[f>>2]=c[f>>2]|2;Oo(t+172|0);Oo(t+184|0);i=r;return b|0}while(0);if((s|0)==27)e=Ya()|0;Oo(t+172|0);Oo(t+184|0);Ra(e|0);return 0}function Rc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;r=i;t=i=i+63&-64;i=i+352|0;nf(t+184|0,e,t+208|0,t+200|0,t+196|0);c[t+172>>2]=0;c[t+172+4>>2]=0;c[t+172+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[t+172+(e<<2)>>2]=0;e=e+1|0}q=t+172+11|0;if((a[q>>0]|0)<0)e=(c[t+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,t+172|0,e|0);p=o;o=0;do if(p&1)s=27;else{j=(a[q>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=j;c[t+4>>2]=t+8;c[t>>2]=0;a[t+337>>0]=1;a[t+336>>0]=69;n=c[t+200>>2]|0;p=c[t+196>>2]|0;k=b;while(1){if(!k){m=0;k=1}else{e=c[k+12>>2]|0;if((e|0)==(c[k+16>>2]|0)){o=0;e=ha(c[(c[k>>2]|0)+36>>2]|0,k|0)|0;m=o;o=0;if(m&1){s=26;break}}else e=c[e>>2]|0;l=(e|0)==-1;m=l?0:k;k=l;b=l?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;l=o;o=0;if(l&1){s=26;break}}else e=c[e>>2]|0;if((e|0)!=-1)if(k)l=d;else break;else s=18}else s=18;if((s|0)==18){s=0;if(k){d=0;break}else l=0}d=a[q>>0]|0;d=d<<24>>24<0?c[t+172+4>>2]|0:d&255;if((c[t+168>>2]|0)==(j+d|0)){o=0;da(59,t+172|0,d<<1|0);k=o;o=0;if(k&1){s=26;break}if((a[q>>0]|0)<0)e=(c[t+172+8>>2]&2147483647)+-1|0;else e=10;o=0;da(59,t+172|0,e|0);k=o;o=0;if(k&1){s=26;break}j=(a[q>>0]|0)<0?c[t+172>>2]|0:t+172|0;c[t+168>>2]=j+d}d=m+12|0;e=c[d>>2]|0;k=m+16|0;if((e|0)==(c[k>>2]|0)){o=0;e=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;u=o;o=0;if(u&1){s=26;break}}else e=c[e>>2]|0;if(Kd(e,t+337|0,t+336|0,j,t+168|0,n,p,t+184|0,t+8|0,t+4|0,t,t+208|0)|0){d=l;break}e=c[d>>2]|0;if((e|0)==(c[k>>2]|0)){o=0;ha(c[(c[m>>2]|0)+40>>2]|0,m|0)|0;u=o;o=0;if(u&1){s=26;break}else{k=m;d=l;continue}}else{c[d>>2]=e+4;k=m;d=l;continue}}if((s|0)==26){e=Ya()|0;break}u=a[t+184+11>>0]|0;e=c[t+4>>2]|0;if(!((a[t+337>>0]|0)==0?1:((u<<24>>24<0?c[t+184+4>>2]|0:u&255)|0)==0)?(e-(t+8)|0)<160:0){u=c[t>>2]|0;c[t+4>>2]=e+4;c[e>>2]=u;e=e+4|0}h[g>>3]=+bh(j,c[t+168>>2]|0,f);kf(t+184|0,t+8|0,e,f);if(!m)j=1;else{e=c[m+12>>2]|0;if((e|0)==(c[m+16>>2]|0)){o=0;e=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;u=o;o=0;if(u&1){s=27;break}}else e=c[e>>2]|0;u=(e|0)==-1;j=u;b=u?0:b}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){o=0;e=ha(c[(c[d>>2]|0)+36>>2]|0,d|0)|0;u=o;o=0;if(u&1){s=27;break}}else e=c[e>>2]|0;if((e|0)!=-1){if(!j)s=51}else s=49}else s=49;if((s|0)==49?j:0)s=51;if((s|0)==51)c[f>>2]=c[f>>2]|2;Oo(t+172|0);Oo(t+184|0);i=r;return b|0}while(0);if((s|0)==27)e=Ya()|0;Oo(t+172|0);Oo(t+184|0);Ra(e|0);return 0}function Sc(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0;J=d[b>>0]|0;h=Km(d[b+1>>0]|0|0,0,8)|0;k=D;F=Km(d[b+2>>0]|0|0,0,16)|0;k=k|D;E=Km(d[b+3>>0]|0|0,0,24)|0;k=k|D;B=d[b+4>>0]|0;C=Km(d[b+5>>0]|0|0,0,8)|0;j=D;l=Km(d[b+6>>0]|0|0,0,16)|0;j=Km(C|B|l|0,j|D|0,6)|0;l=D;B=d[b+7>>0]|0;C=Km(d[b+8>>0]|0|0,0,8)|0;w=D;i=Km(d[b+9>>0]|0|0,0,16)|0;w=Km(C|B|i|0,w|D|0,5)|0;i=D;B=d[b+10>>0]|0;C=Km(d[b+11>>0]|0|0,0,8)|0;H=D;G=Km(d[b+12>>0]|0|0,0,16)|0;H=Km(C|B|G|0,H|D|0,3)|0;G=D;B=d[b+13>>0]|0;C=Km(d[b+14>>0]|0|0,0,8)|0;s=D;g=Km(d[b+15>>0]|0|0,0,16)|0;s=Km(C|B|g|0,s|D|0,2)|0;g=D;B=d[b+16>>0]|0;C=Km(d[b+17>>0]|0|0,0,8)|0;y=D;A=Km(d[b+18>>0]|0|0,0,16)|0;y=y|D;z=Km(d[b+19>>0]|0|0,0,24)|0;y=y|D;q=d[b+20>>0]|0;x=Km(d[b+21>>0]|0|0,0,8)|0;p=D;e=Km(d[b+22>>0]|0|0,0,16)|0;p=Km(x|q|e|0,p|D|0,7)|0;e=D;q=d[b+23>>0]|0;x=Km(d[b+24>>0]|0|0,0,8)|0;v=D;u=Km(d[b+25>>0]|0|0,0,16)|0;v=Km(x|q|u|0,v|D|0,5)|0;u=D;q=d[b+26>>0]|0;x=Km(d[b+27>>0]|0|0,0,8)|0;n=D;o=Km(d[b+28>>0]|0|0,0,16)|0;n=Km(x|q|o|0,n|D|0,4)|0;o=D;q=d[b+29>>0]|0;x=Km(d[b+30>>0]|0|0,0,8)|0;r=D;b=Km(d[b+31>>0]|0|0,0,16)|0;r=Km(x|q|b|0,r|D|0,2)|0;b=go(r&33554428|0,0,16777216,0)|0;b=Mm(b|0,D|0,25)|0;q=D;x=Sm(0,0,b|0,q|0)|0;k=go(x&19|0,0,h|J|F|E|0,k|0)|0;E=D;q=Km(b|0,q|0,25)|0;b=D;F=go(j|0,l|0,16777216,0)|0;F=Mm(F|0,D|0,25)|0;J=D;i=go(w|0,i|0,F|0,J|0)|0;w=D;J=Km(F|0,J|0,25)|0;J=Sm(j|0,l|0,J|0,D|0)|0;l=D;j=go(H|0,G|0,16777216,0)|0;j=Mm(j|0,D|0,25)|0;F=D;g=go(s|0,g|0,j|0,F|0)|0;s=D;F=Km(j|0,F|0,25)|0;j=D;h=go(C|B|A|z|0,y|0,16777216,0)|0;h=Mm(h|0,D|0,25)|0;x=D;e=go(p|0,e|0,h|0,x|0)|0;p=D;x=Km(h|0,x|0,25)|0;h=D;f=go(v|0,u|0,16777216,0)|0;f=Mm(f|0,D|0,25)|0;t=D;o=go(n|0,o|0,f|0,t|0)|0;n=D;t=Km(f|0,t|0,25)|0;f=D;I=go(k|0,E|0,33554432,0)|0;I=_l(I|0,D|0,26)|0;m=D;l=go(J|0,l|0,I|0,m|0)|0;m=Km(I|0,m|0,26)|0;m=Sm(k|0,E|0,m|0,D|0)|0;E=go(i|0,w|0,33554432,0)|0;E=_l(E|0,D|0,26)|0;k=D;G=go(E|0,k|0,H|0,G|0)|0;j=Sm(G|0,D|0,F|0,j|0)|0;k=Km(E|0,k|0,26)|0;k=Sm(i|0,w|0,k|0,D|0)|0;w=go(g|0,s|0,33554432,0)|0;w=_l(w|0,D|0,26)|0;i=D;y=go(w|0,i|0,C|B|A|z|0,y|0)|0;h=Sm(y|0,D|0,x|0,h|0)|0;i=Km(w|0,i|0,26)|0;i=Sm(g|0,s|0,i|0,D|0)|0;s=go(e|0,p|0,33554432,0)|0;s=_l(s|0,D|0,26)|0;g=D;u=go(s|0,g|0,v|0,u|0)|0;f=Sm(u|0,D|0,t|0,f|0)|0;g=Km(s|0,g|0,26)|0;g=Sm(e|0,p|0,g|0,D|0)|0;p=go(o|0,n|0,33554432,0)|0;p=_l(p|0,D|0,26)|0;e=D;r=go(r&33554428|0,0,p|0,e|0)|0;b=Sm(r|0,D|0,q|0,b|0)|0;e=Km(p|0,e|0,26)|0;e=Sm(o|0,n|0,e|0,D|0)|0;c[a>>2]=m;c[a+4>>2]=l;c[a+8>>2]=k;c[a+12>>2]=j;c[a+16>>2]=i;c[a+20>>2]=h;c[a+24>>2]=g;c[a+28>>2]=f;c[a+32>>2]=e;c[a+36>>2]=b;return}function Tc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;n=c[a+4>>2]|0;k=a+(n&-8)|0;i=c[12596]|0;if(!((n&3|0)!=1&a>>>0>=i>>>0&a>>>0<k>>>0))Ta();m=c[k+4>>2]|0;if(!(m&1))Ta();if(!(n&3)){if(b>>>0<256){a=0;return a|0}if((n&-8)>>>0>=(b+4|0)>>>0?((n&-8)-b|0)>>>0<=c[12712]<<1>>>0:0)return a|0;a=0;return a|0}if((n&-8)>>>0>=b>>>0){if(((n&-8)-b|0)>>>0<=15)return a|0;c[a+4>>2]=n&1|b|2;c[a+b+4>>2]=(n&-8)-b|3;c[a+b+((n&-8)-b)+4>>2]=c[a+b+((n&-8)-b)+4>>2]|1;lc(a+b|0,(n&-8)-b|0);return a|0}if((k|0)==(c[12598]|0)){d=(c[12595]|0)+(n&-8)|0;if(d>>>0<=b>>>0){a=0;return a|0}c[a+4>>2]=n&1|b|2;c[a+b+4>>2]=d-b|1;c[12598]=a+b;c[12595]=d-b;return a|0}if((k|0)==(c[12597]|0)){d=(c[12594]|0)+(n&-8)|0;if(d>>>0<b>>>0){a=0;return a|0}if((d-b|0)>>>0>15){c[a+4>>2]=n&1|b|2;c[a+b+4>>2]=d-b|1;c[a+b+(d-b)>>2]=d-b;c[a+b+(d-b)+4>>2]=c[a+b+(d-b)+4>>2]&-2;e=a+b|0;d=d-b|0}else{c[a+4>>2]=n&1|d|2;c[a+d+4>>2]=c[a+d+4>>2]|1;e=0;d=0}c[12594]=d;c[12597]=e;return a|0}if(m&2|0){a=0;return a|0}if(((m&-8)+(n&-8)|0)>>>0<b>>>0){a=0;return a|0}l=(m&-8)+(n&-8)-b|0;do if(m>>>0>=256){h=c[k+24>>2]|0;d=c[k+12>>2]|0;do if((d|0)==(k|0)){d=c[k+16+4>>2]|0;if(!d){d=c[k+16>>2]|0;if(!d){j=0;break}else g=k+16|0}else g=k+16+4|0;while(1){e=d+20|0;f=c[e>>2]|0;if(f|0){d=f;g=e;continue}e=d+16|0;f=c[e>>2]|0;if(!f)break;else{d=f;g=e}}if(g>>>0<i>>>0)Ta();else{c[g>>2]=0;j=d;break}}else{e=c[k+8>>2]|0;if(e>>>0<i>>>0)Ta();if((c[e+12>>2]|0)!=(k|0))Ta();if((c[d+8>>2]|0)==(k|0)){c[e+12>>2]=d;c[d+8>>2]=e;j=d;break}else Ta()}while(0);if(h|0){d=c[k+28>>2]|0;if((k|0)==(c[50672+(d<<2)>>2]|0)){c[50672+(d<<2)>>2]=j;if(!j){c[12593]=c[12593]&~(1<<d);break}}else{if(h>>>0<(c[12596]|0)>>>0)Ta();if((c[h+16>>2]|0)==(k|0))c[h+16>>2]=j;else c[h+20>>2]=j;if(!j)break}e=c[12596]|0;if(j>>>0<e>>>0)Ta();c[j+24>>2]=h;d=c[k+16>>2]|0;do if(d|0)if(d>>>0<e>>>0)Ta();else{c[j+16>>2]=d;c[d+24>>2]=j;break}while(0);d=c[k+16+4>>2]|0;if(d|0)if(d>>>0<(c[12596]|0)>>>0)Ta();else{c[j+20>>2]=d;c[d+24>>2]=j;break}}}else{d=c[k+8>>2]|0;e=c[k+12>>2]|0;if((d|0)!=(50408+(m>>>3<<1<<2)|0)){if(d>>>0<i>>>0)Ta();if((c[d+12>>2]|0)!=(k|0))Ta()}if((e|0)==(d|0)){c[12592]=c[12592]&~(1<<(m>>>3));break}if((e|0)!=(50408+(m>>>3<<1<<2)|0)){if(e>>>0<i>>>0)Ta();if((c[e+8>>2]|0)!=(k|0))Ta();else f=e+8|0}else f=e+8|0;c[d+12>>2]=e;c[f>>2]=d}while(0);if(l>>>0<16){c[a+4>>2]=(m&-8)+(n&-8)|n&1|2;c[a+((m&-8)+(n&-8))+4>>2]=c[a+((m&-8)+(n&-8))+4>>2]|1;return a|0}else{c[a+4>>2]=n&1|b|2;c[a+b+4>>2]=l|3;c[a+b+l+4>>2]=c[a+b+l+4>>2]|1;lc(a+b|0,l);return a|0}return 0}function Uc(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;s=i;u=i=i+63&-64;i=i+976|0;c[u+872>>2]=u+876;h[u>>3]=j;b=il(u+876|0,100,48324,u)|0;a:do if(b>>>0>99){l=To()|0;o=0;h[u+8>>3]=j;l=Ba(23,u+872|0,l|0,48324,u+8|0)|0;v=o;o=0;do if(!(v&1)){b=c[u+872>>2]|0;if((b|0)==0?(o=0,Fa(20),v=o,o=0,v&1):0){k=0;b=0;break}k=bc(l<<2)|0;if(k|0){m=b;r=k;v=b;w=8;break a}o=0;Fa(20);v=o;o=0;if(!(v&1)){m=b;r=0;v=b;w=8;break a}}else{k=0;b=0}while(0);l=Ya()|0}else{m=u+876|0;r=u+472|0;k=0;v=0;l=b;w=8}while(0);if((w|0)==8){b=Ll(f)|0;o=0;q=va(32,b|0,51948)|0;p=o;o=0;if(!(p&1)?(o=0,Ba(c[(c[q>>2]|0)+48>>2]|0,q|0,m|0,m+l|0,r|0)|0,p=o,o=0,!(p&1)):0){if(!l)p=0;else p=(a[m>>0]|0)==45;c[u+452>>2]=0;c[u+452+4>>2]=0;c[u+452+8>>2]=0;m=0;while(1){if((m|0)==3)break;c[u+452+(m<<2)>>2]=0;m=m+1|0}c[u+440>>2]=0;c[u+440+4>>2]=0;c[u+440+8>>2]=0;m=0;while(1){if((m|0)==3)break;c[u+440+(m<<2)>>2]=0;m=m+1|0}c[u+428>>2]=0;c[u+428+4>>2]=0;c[u+428+8>>2]=0;m=0;while(1){if((m|0)==3)break;c[u+428+(m<<2)>>2]=0;m=m+1|0}o=0;ta(21,e|0,p|0,b|0,u|0,u+468|0,u+464|0,u+452|0,u+440|0,u+428|0,u+424|0);n=o;o=0;if(!(n&1)){n=c[u+424>>2]|0;if((l|0)>(n|0)){e=a[u+428+8+3>>0]|0;m=a[u+440+8+3>>0]|0;m=(e<<24>>24<0?c[u+428+4>>2]|0:e&255)+(l-n<<1|1)+(m<<24>>24<0?c[u+440+4>>2]|0:m&255)|0}else{e=a[u+428+8+3>>0]|0;m=a[u+440+8+3>>0]|0;m=(e<<24>>24<0?c[u+428+4>>2]|0:e&255)+2+(m<<24>>24<0?c[u+440+4>>2]|0:m&255)|0}m=m+n|0;if(m>>>0>100){m=bc(m<<2)|0;if(!m){o=0;Fa(20);e=o;o=0;if(!(e&1)){e=m;m=0;w=32}}else{e=m;w=32}}else{e=0;m=u+24|0;w=32}if((w|0)==32){o=0;na(19,m|0,u+20|0,u+16|0,c[f+4>>2]|0,r|0,r+(l<<2)|0,q|0,p|0,u|0,c[u+468>>2]|0,c[u+464>>2]|0,u+452|0,u+440|0,u+428|0,n|0);w=o;o=0;if(!(w&1)?(o=0,t=fa(57,c[d>>2]|0,m|0,c[u+20>>2]|0,c[u+16>>2]|0,f|0,g|0)|0,w=o,o=0,!(w&1)):0){if(e)kc(e);Ao(u+428|0);Ao(u+440|0);Oo(u+452|0);Vl(b);if(k|0)kc(k);if(v|0)kc(v);i=s;return t|0}else m=e}l=Ya()|0;if(m)kc(m)}else l=Ya()|0;Ao(u+428|0);Ao(u+440|0);Oo(u+452|0)}else l=Ya()|0;Vl(b);b=v}if(k|0)kc(k);if(b|0)kc(b);Ra(l|0);return 0}function Vc(b,d){b=b|0;d=d|0;var e=0,f=0;c[b+4>>2]=d+-1;c[b>>2]=40560;o=0;da(64,b+8|0,28);e=o;o=0;if(e&1)d=Ya()|0;else{c[b+144>>2]=0;c[b+144+4>>2]=0;c[b+144+8>>2]=0;o=0;Da(26,b+144|0,46820,1);e=o;o=0;if(e&1)d=Ya()|0;else{e=c[b+8>>2]|0;d=c[b+12>>2]|0;while(1){if((d|0)==(e|0))break;f=d+-4|0;c[b+12>>2]=f;d=f}c[12453]=0;c[12452]=38224;o=0;ba(145,b|0);f=o;o=0;do if((((((((((((((!(f&1)?(c[12455]=0,c[12454]=38256,o=0,ba(146,b|0),f=o,o=0,!(f&1)):0)?(c[12457]=0,c[12456]=40580,a[49836]=0,c[12458]=41480,o=0,ba(147,b|0),f=o,o=0,!(f&1)):0)?(c[12461]=0,c[12460]=40776,o=0,ba(148,b|0),f=o,o=0,!(f&1)):0)?(c[12463]=0,c[12462]=40844,o=0,ba(149,b|0),f=o,o=0,!(f&1)):0)?(Ln(49856,1),o=0,ba(150,b|0),f=o,o=0,!(f&1)):0)?(c[12469]=0,c[12468]=40892,o=0,ba(151,b|0),f=o,o=0,!(f&1)):0)?(c[12471]=0,c[12470]=40940,o=0,ba(152,b|0),f=o,o=0,!(f&1)):0)?(Gj(49888,1),o=0,ba(153,b|0),f=o,o=0,!(f&1)):0)?(Dj(49912,1),o=0,ba(154,b|0),f=o,o=0,!(f&1)):0)?(c[12487]=0,c[12486]=38288,o=0,ba(155,b|0),f=o,o=0,!(f&1)):0)?(c[12489]=0,c[12488]=38352,o=0,ba(156,b|0),f=o,o=0,!(f&1)):0)?(c[12491]=0,c[12490]=38416,o=0,ba(157,b|0),f=o,o=0,!(f&1)):0)?(c[12493]=0,c[12492]=38468,o=0,ba(158,b|0),f=o,o=0,!(f&1)):0)?(c[12495]=0,c[12494]=40016,o=0,ba(159,b|0),f=o,o=0,!(f&1)):0){c[12497]=0;c[12496]=40072;o=0;ba(160,b|0);f=o;o=0;if(f&1)break;c[12499]=0;c[12498]=40128;o=0;ba(161,b|0);f=o;o=0;if(f&1)break;c[12501]=0;c[12500]=40184;o=0;ba(162,b|0);f=o;o=0;if(f&1)break;c[12503]=0;c[12502]=40240;o=0;ba(163,b|0);f=o;o=0;if(f&1)break;c[12505]=0;c[12504]=40268;o=0;ba(164,b|0);f=o;o=0;if(f&1)break;c[12507]=0;c[12506]=40296;o=0;ba(165,b|0);f=o;o=0;if(f&1)break;c[12509]=0;c[12508]=40324;o=0;ba(166,b|0);f=o;o=0;if(f&1)break;c[12511]=0;c[12510]=38520;c[12512]=38568;o=0;ba(167,b|0);f=o;o=0;if(f&1)break;c[12515]=0;c[12514]=38604;c[12516]=38652;o=0;ba(168,b|0);f=o;o=0;if(f&1)break;c[12519]=0;c[12518]=40756;c[12520]=To()|0;c[12518]=39968;o=0;ba(169,b|0);f=o;o=0;if(f&1)break;c[12523]=0;c[12522]=40756;c[12524]=To()|0;c[12522]=39992;o=0;ba(170,b|0);f=o;o=0;if(f&1)break;c[12527]=0;c[12526]=40352;o=0;ba(171,b|0);f=o;o=0;if(f&1)break;c[12529]=0;c[12528]=40384;o=0;ba(172,b|0);f=o;o=0;if(f&1)break;return}while(0);d=Ya()|0;Oo(b+144|0)}ti(b+8|0)}Ra(d|0)}function Wc(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;r=i;p=i=i+63&-64;i=i+240|0;Sc(a+40|0,b);c[a+80>>2]=1;e=a+84|0;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));ic(p+160|0,a+40|0);fc(p+120|0,p+160|0,2040);o=c[a+80>>2]|0;n=c[a+84>>2]|0;m=c[a+88>>2]|0;l=c[a+92>>2]|0;k=c[a+96>>2]|0;j=c[a+100>>2]|0;h=c[a+104>>2]|0;g=c[a+108>>2]|0;f=c[a+112>>2]|0;e=c[a+116>>2]|0;B=(c[p+160>>2]|0)-o|0;A=(c[p+160+4>>2]|0)-n|0;z=(c[p+160+8>>2]|0)-m|0;y=(c[p+160+12>>2]|0)-l|0;x=(c[p+160+16>>2]|0)-k|0;w=(c[p+160+20>>2]|0)-j|0;v=(c[p+160+24>>2]|0)-h|0;u=(c[p+160+28>>2]|0)-g|0;t=(c[p+160+32>>2]|0)-f|0;s=(c[p+160+36>>2]|0)-e|0;c[p+160>>2]=B;c[p+160+4>>2]=A;c[p+160+8>>2]=z;c[p+160+12>>2]=y;c[p+160+16>>2]=x;c[p+160+20>>2]=w;c[p+160+24>>2]=v;c[p+160+28>>2]=u;c[p+160+32>>2]=t;c[p+160+36>>2]=s;n=n+(c[p+120+4>>2]|0)|0;m=m+(c[p+120+8>>2]|0)|0;l=l+(c[p+120+12>>2]|0)|0;k=k+(c[p+120+16>>2]|0)|0;j=j+(c[p+120+20>>2]|0)|0;h=h+(c[p+120+24>>2]|0)|0;g=g+(c[p+120+28>>2]|0)|0;f=f+(c[p+120+32>>2]|0)|0;e=e+(c[p+120+36>>2]|0)|0;c[p+120>>2]=o+(c[p+120>>2]|0);c[p+120+4>>2]=n;c[p+120+8>>2]=m;c[p+120+12>>2]=l;c[p+120+16>>2]=k;c[p+120+20>>2]=j;c[p+120+24>>2]=h;c[p+120+28>>2]=g;c[p+120+32>>2]=f;c[p+120+36>>2]=e;ic(p+80|0,p+120|0);fc(p+80|0,p+80|0,p+120|0);ic(a,p+80|0);fc(a,a,p+120|0);fc(a,a,p+160|0);rd(a,a);fc(a,a,p+80|0);fc(a,a,p+160|0);ic(p+40|0,a);fc(p+40|0,p+40|0,p+120|0);e=c[p+40>>2]|0;f=c[p+40+4>>2]|0;g=c[p+40+8>>2]|0;h=c[p+40+12>>2]|0;j=c[p+40+16>>2]|0;k=c[p+40+20>>2]|0;l=c[p+40+24>>2]|0;m=c[p+40+28>>2]|0;n=c[p+40+32>>2]|0;o=c[p+40+36>>2]|0;c[p>>2]=e-B;c[p+4>>2]=f-A;c[p+8>>2]=g-z;c[p+12>>2]=h-y;c[p+16>>2]=j-x;c[p+20>>2]=k-w;c[p+24>>2]=l-v;c[p+28>>2]=m-u;c[p+32>>2]=n-t;c[p+36>>2]=o-s;Ld(p+200|0,p);if(ll(p+200|0,53876)|0){t=(c[p+160+4>>2]|0)+f|0;u=(c[p+160+8>>2]|0)+g|0;v=(c[p+160+12>>2]|0)+h|0;w=(c[p+160+16>>2]|0)+j|0;x=(c[p+160+20>>2]|0)+k|0;y=(c[p+160+24>>2]|0)+l|0;z=(c[p+160+28>>2]|0)+m|0;A=(c[p+160+32>>2]|0)+n|0;B=(c[p+160+36>>2]|0)+o|0;c[p>>2]=(c[p+160>>2]|0)+e;c[p+4>>2]=t;c[p+8>>2]=u;c[p+12>>2]=v;c[p+16>>2]=w;c[p+20>>2]=x;c[p+24>>2]=y;c[p+28>>2]=z;c[p+32>>2]=A;c[p+36>>2]=B;Ld(p+200|0,p);if(!(ll(p+200|0,53876)|0)){fc(a,a,2080);q=4}else e=-1}else q=4;if((q|0)==4){Ld(p+200|0,a);if(((d[p+200>>0]|0)&1|0)==((d[b+31>>0]|0)>>>7|0))xg(a,a);fc(a+120|0,a,a+40|0);e=0}i=r;return e|0}function Xc(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;s=i;u=i=i+63&-64;i=i+384|0;c[u+64>>2]=u+272;h[u>>3]=j;b=il(u+272|0,100,48324,u)|0;a:do if(b>>>0>99){l=To()|0;o=0;h[u+8>>3]=j;l=Ba(23,u+64|0,l|0,48324,u+8|0)|0;v=o;o=0;do if(!(v&1)){b=c[u+64>>2]|0;if((b|0)==0?(o=0,Fa(20),v=o,o=0,v&1):0){k=0;b=0;break}k=bc(l)|0;if(k|0){m=b;r=k;v=b;w=8;break a}o=0;Fa(20);v=o;o=0;if(!(v&1)){m=b;r=0;v=b;w=8;break a}}else{k=0;b=0}while(0);l=Ya()|0}else{m=u+272|0;r=u+172|0;k=0;v=0;l=b;w=8}while(0);if((w|0)==8){b=Ll(f)|0;o=0;q=va(32,b|0,51916)|0;p=o;o=0;if(!(p&1)?(o=0,Ba(c[(c[q>>2]|0)+32>>2]|0,q|0,m|0,m+l|0,r|0)|0,p=o,o=0,!(p&1)):0){if(!l)p=0;else p=(a[m>>0]|0)==45;c[u+52>>2]=0;c[u+52+4>>2]=0;c[u+52+8>>2]=0;m=0;while(1){if((m|0)==3)break;c[u+52+(m<<2)>>2]=0;m=m+1|0}c[u+40>>2]=0;c[u+40+4>>2]=0;c[u+40+8>>2]=0;m=0;while(1){if((m|0)==3)break;c[u+40+(m<<2)>>2]=0;m=m+1|0}c[u+28>>2]=0;c[u+28+4>>2]=0;c[u+28+8>>2]=0;m=0;while(1){if((m|0)==3)break;c[u+28+(m<<2)>>2]=0;m=m+1|0}o=0;ta(20,e|0,p|0,b|0,u|0,u+169|0,u+168|0,u+52|0,u+40|0,u+28|0,u+24|0);n=o;o=0;if(!(n&1)){n=c[u+24>>2]|0;if((l|0)>(n|0)){e=a[u+28+11>>0]|0;m=a[u+40+11>>0]|0;m=(e<<24>>24<0?c[u+28+4>>2]|0:e&255)+(l-n<<1|1)+(m<<24>>24<0?c[u+40+4>>2]|0:m&255)|0}else{e=a[u+28+11>>0]|0;m=a[u+40+11>>0]|0;m=(e<<24>>24<0?c[u+28+4>>2]|0:e&255)+2+(m<<24>>24<0?c[u+40+4>>2]|0:m&255)|0}m=m+n|0;if(m>>>0>100){m=bc(m)|0;if(!m){o=0;Fa(20);e=o;o=0;if(!(e&1)){e=m;m=0;w=32}}else{e=m;w=32}}else{e=0;m=u+68|0;w=32}if((w|0)==32){o=0;na(18,m|0,u+20|0,u+16|0,c[f+4>>2]|0,r|0,r+l|0,q|0,p|0,u|0,a[u+169>>0]|0,a[u+168>>0]|0,u+52|0,u+40|0,u+28|0,n|0);w=o;o=0;if(!(w&1)?(o=0,t=fa(56,c[d>>2]|0,m|0,c[u+20>>2]|0,c[u+16>>2]|0,f|0,g|0)|0,w=o,o=0,!(w&1)):0){if(e)kc(e);Oo(u+28|0);Oo(u+40|0);Oo(u+52|0);Vl(b);if(k|0)kc(k);if(v|0)kc(v);i=s;return t|0}else m=e}l=Ya()|0;if(m)kc(m)}else l=Ya()|0;Oo(u+28|0);Oo(u+40|0);Oo(u+52|0)}else l=Ya()|0;Vl(b);b=v}if(k|0)kc(k);if(b|0)kc(b);Ra(l|0);return 0}function Yc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;s=a[b+80>>0]|0?0:16777216;t=c[b+4>>2]|0;u=c[b+8>>2]|0;p=c[b+12>>2]|0;q=c[b+16>>2]|0;l=c[b+20>>2]|0;k=c[b+24>>2]|0;j=c[b+28>>2]|0;i=c[b+32>>2]|0;h=c[b+36>>2]|0;if(g>>>0>0|(g|0)==0&f>>>0>15){r=c[b>>2]|0;while(1){z=((d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24)&67108863)+l|0;A=e+3|0;A=((d[A>>0]|d[A+1>>0]<<8|d[A+2>>0]<<16|d[A+3>>0]<<24)>>>2&67108863)+k|0;y=e+6|0;y=((d[y>>0]|d[y+1>>0]<<8|d[y+2>>0]<<16|d[y+3>>0]<<24)>>>4&67108863)+j|0;x=e+9|0;x=((d[x>>0]|d[x+1>>0]<<8|d[x+2>>0]<<16|d[x+3>>0]<<24)>>>6)+i|0;l=e+12|0;l=((d[l>>0]|d[l+1>>0]<<8|d[l+2>>0]<<16|d[l+3>>0]<<24)>>>8|s)+h|0;h=Pl(z|0,0,r|0,0)|0;m=D;j=Pl(A|0,0,q*5|0,0)|0;m=go(j|0,D|0,h|0,m|0)|0;h=D;j=Pl(y|0,0,p*5|0,0)|0;j=go(m|0,h|0,j|0,D|0)|0;h=D;m=Pl(x|0,0,u*5|0,0)|0;m=go(j|0,h|0,m|0,D|0)|0;h=D;j=Pl(l|0,0,t*5|0,0)|0;j=go(m|0,h|0,j|0,D|0)|0;h=D;m=Pl(z|0,0,t|0,0)|0;n=D;w=Pl(A|0,0,r|0,0)|0;n=go(w|0,D|0,m|0,n|0)|0;m=D;w=Pl(y|0,0,q*5|0,0)|0;w=go(n|0,m|0,w|0,D|0)|0;m=D;n=Pl(x|0,0,p*5|0,0)|0;n=go(w|0,m|0,n|0,D|0)|0;m=D;w=Pl(l|0,0,u*5|0,0)|0;w=go(n|0,m|0,w|0,D|0)|0;m=D;n=Pl(z|0,0,u|0,0)|0;o=D;v=Pl(A|0,0,t|0,0)|0;o=go(v|0,D|0,n|0,o|0)|0;n=D;v=Pl(y|0,0,r|0,0)|0;v=go(o|0,n|0,v|0,D|0)|0;n=D;o=Pl(x|0,0,q*5|0,0)|0;o=go(v|0,n|0,o|0,D|0)|0;n=D;v=Pl(l|0,0,p*5|0,0)|0;v=go(o|0,n|0,v|0,D|0)|0;n=D;o=Pl(z|0,0,p|0,0)|0;i=D;k=Pl(A|0,0,u|0,0)|0;i=go(k|0,D|0,o|0,i|0)|0;o=D;k=Pl(y|0,0,t|0,0)|0;k=go(i|0,o|0,k|0,D|0)|0;o=D;i=Pl(x|0,0,r|0,0)|0;i=go(k|0,o|0,i|0,D|0)|0;o=D;k=Pl(l|0,0,q*5|0,0)|0;k=go(i|0,o|0,k|0,D|0)|0;o=D;i=Pl(z|0,0,q|0,0)|0;z=D;A=Pl(A|0,0,p|0,0)|0;z=go(A|0,D|0,i|0,z|0)|0;i=D;y=Pl(y|0,0,u|0,0)|0;y=go(z|0,i|0,y|0,D|0)|0;i=D;x=Pl(x|0,0,t|0,0)|0;x=go(y|0,i|0,x|0,D|0)|0;i=D;l=Pl(l|0,0,r|0,0)|0;l=go(x|0,i|0,l|0,D|0)|0;i=D;h=Mm(j|0,h|0,26)|0;h=go(w|0,m|0,h|0,0)|0;m=Mm(h|0,D|0,26)|0;m=go(v|0,n|0,m|0,0)|0;n=Mm(m|0,D|0,26)|0;n=go(k|0,o|0,n|0,0)|0;o=Mm(n|0,D|0,26)|0;o=go(l|0,i|0,o|0,0)|0;i=Mm(o|0,D|0,26)|0;f=go(f|0,g|0,-16,-1)|0;g=D;if(!(g>>>0>0|(g|0)==0&f>>>0>15)){e=(i*5|0)+j&67108863;k=(((i*5|0)+(j&67108863)|0)>>>26)+(h&67108863)|0;j=m&67108863;i=n&67108863;h=o&67108863;break}else{e=e+16|0;l=(i*5|0)+j&67108863;k=(((i*5|0)+(j&67108863)|0)>>>26)+(h&67108863)|0;j=m&67108863;i=n&67108863;h=o&67108863}}}else e=l;c[b+20>>2]=e;c[b+24>>2]=k;c[b+28>>2]=j;c[b+32>>2]=i;c[b+36>>2]=h;return}function Zc(d,e,f,g,h,i,j,k,l,m,n,o,p,q,r){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c[f>>2]=d;x=0;while(1){if((x|0)==4)break;a:do switch(a[l+x>>0]|0){case 0:{c[e>>2]=c[f>>2];break}case 1:{c[e>>2]=c[f>>2];v=Pb[c[(c[j>>2]|0)+28>>2]&63](j,32)|0;w=c[f>>2]|0;c[f>>2]=w+1;a[w>>0]=v;break}case 3:{s=a[q+11>>0]|0;if((s<<24>>24<0?c[q+4>>2]|0:s&255)|0){v=a[(s<<24>>24<0?c[q>>2]|0:q)>>0]|0;w=c[f>>2]|0;c[f>>2]=w+1;a[w>>0]=v}break}case 2:{s=a[p+11>>0]|0;w=s<<24>>24<0?c[p+4>>2]|0:s&255;if(!((g&512|0)==0|(w|0)==0)){u=s<<24>>24<0?c[p>>2]|0:p;v=c[f>>2]|0;s=v;t=u;while(1){if((t|0)==(u+w|0))break;a[s>>0]=a[t>>0]|0;s=s+1|0;t=t+1|0}c[f>>2]=v+w}break}case 4:{t=c[f>>2]|0;h=k?h+1|0:h;u=h;while(1){if(u>>>0>=i>>>0)break;s=a[u>>0]|0;if(s<<24>>24<=-1)break;if(!(b[(c[j+8>>2]|0)+(s<<24>>24<<1)>>1]&2048))break;u=u+1|0}if((r|0)>0){v=r;while(1){s=(v|0)>0;if(!(u>>>0>h>>>0&s))break;w=u+-1|0;y=a[w>>0]|0;s=c[f>>2]|0;c[f>>2]=s+1;a[s>>0]=y;u=w;v=v+-1|0}if(s)w=Pb[c[(c[j>>2]|0)+28>>2]&63](j,48)|0;else w=0;while(1){s=c[f>>2]|0;c[f>>2]=s+1;if((v|0)<=0)break;a[s>>0]=w;v=v+-1|0}a[s>>0]=m}b:do if((u|0)==(h|0)){w=Pb[c[(c[j>>2]|0)+28>>2]&63](j,48)|0;y=c[f>>2]|0;c[f>>2]=y+1;a[y>>0]=w}else{s=a[o+11>>0]|0;if(!((s<<24>>24<0?c[o+4>>2]|0:s&255)|0)){s=-1;v=0;w=0}else{s=a[(s<<24>>24<0?c[o>>2]|0:o)>>0]|0;v=0;w=0}while(1){if((u|0)==(h|0))break b;if((w|0)==(s|0)){s=c[f>>2]|0;c[f>>2]=s+1;a[s>>0]=n;v=v+1|0;s=a[o+11>>0]|0;if(v>>>0<(s<<24>>24<0?c[o+4>>2]|0:s&255)>>>0){s=a[(s<<24>>24<0?c[o>>2]|0:o)+v>>0]|0;s=s<<24>>24==127?-1:s<<24>>24;w=0}else{s=w;w=0}}y=u+-1|0;A=a[y>>0]|0;z=c[f>>2]|0;c[f>>2]=z+1;a[z>>0]=A;u=y;w=w+1|0}}while(0);s=c[f>>2]|0;if((t|0)!=(s|0))while(1){s=s+-1|0;if(t>>>0>=s>>>0)break a;A=a[t>>0]|0;a[t>>0]=a[s>>0]|0;a[s>>0]=A;t=t+1|0}break}default:{}}while(0);x=x+1|0}h=a[q+11>>0]|0;v=h<<24>>24<0?c[q+4>>2]|0:h&255;if(v>>>0>1){t=h<<24>>24<0?c[q>>2]|0:q;u=c[f>>2]|0;s=u;h=t;while(1){h=h+1|0;if((h|0)==(t+v|0))break;a[s>>0]=a[h>>0]|0;s=s+1|0}c[f>>2]=u+(v+-1)}switch(g&176|0){case 32:{c[e>>2]=c[f>>2];break}case 16:break;default:c[e>>2]=d}return}function _c(b,d,e,f,g,h,i,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c[e>>2]=b;z=0;while(1){if((z|0)==4)break;a:do switch(a[k+z>>0]|0){case 0:{c[d>>2]=c[e>>2];break}case 1:{c[d>>2]=c[e>>2];x=Pb[c[(c[i>>2]|0)+44>>2]&63](i,32)|0;y=c[e>>2]|0;c[e>>2]=y+4;c[y>>2]=x;break}case 3:{r=a[p+8+3>>0]|0;if((r<<24>>24<0?c[p+4>>2]|0:r&255)|0){x=c[(r<<24>>24<0?c[p>>2]|0:p)>>2]|0;y=c[e>>2]|0;c[e>>2]=y+4;c[y>>2]=x}break}case 2:{r=a[o+8+3>>0]|0;v=r<<24>>24<0?c[o+4>>2]|0:r&255;if(!((f&512|0)==0|(v|0)==0)){s=r<<24>>24<0?c[o>>2]|0:o;t=c[e>>2]|0;r=t;u=s;while(1){if((u|0)==(s+(v<<2)|0))break;c[r>>2]=c[u>>2];r=r+4|0;u=u+4|0}c[e>>2]=t+(v<<2)}break}case 4:{s=c[e>>2]|0;g=j?g+4|0:g;r=g;while(1){if(r>>>0>=h>>>0)break;if(!(Kb[c[(c[i>>2]|0)+12>>2]&63](i,2048,c[r>>2]|0)|0))break;r=r+4|0}if((q|0)>0){u=q;while(1){t=(u|0)>0;if(!(r>>>0>g>>>0&t))break;y=r+-4|0;w=c[y>>2]|0;x=c[e>>2]|0;c[e>>2]=x+4;c[x>>2]=w;r=y;u=u+-1|0}if(t)w=Pb[c[(c[i>>2]|0)+44>>2]&63](i,48)|0;else w=0;v=c[e>>2]|0;while(1){t=v+4|0;if((u|0)<=0)break;c[v>>2]=w;v=t;u=u+-1|0}c[e>>2]=t;c[v>>2]=l}if((r|0)==(g|0)){y=Pb[c[(c[i>>2]|0)+44>>2]&63](i,48)|0;r=c[e>>2]|0;c[e>>2]=r+4;c[r>>2]=y;r=r+4|0}else{x=a[n+11>>0]|0;y=x<<24>>24<0?c[n+4>>2]|0:x&255;if(!y){w=-1;t=0;v=0}else{w=a[(x<<24>>24<0?c[n>>2]|0:n)>>0]|0;t=0;v=0}while(1){if((r|0)==(g|0))break;u=c[e>>2]|0;if((v|0)==(w|0)){c[e>>2]=u+4;c[u>>2]=m;t=t+1|0;if(t>>>0<y>>>0){w=a[(x<<24>>24<0?c[n>>2]|0:n)+t>>0]|0;u=u+4|0;w=w<<24>>24==127?-1:w<<24>>24;v=0}else{u=u+4|0;w=v;v=0}}A=r+-4|0;B=c[A>>2]|0;c[e>>2]=u+4;c[u>>2]=B;r=A;v=v+1|0}r=c[e>>2]|0}if((s|0)!=(r|0))while(1){r=r+-4|0;if(s>>>0>=r>>>0)break a;B=c[s>>2]|0;c[s>>2]=c[r>>2];c[r>>2]=B;s=s+4|0}break}default:{}}while(0);z=z+1|0}g=a[p+8+3>>0]|0;u=g<<24>>24<0?c[p+4>>2]|0:g&255;if(u>>>0>1){r=g<<24>>24<0?c[p>>2]|0:p;s=c[e>>2]|0;g=s;t=r+4|0;while(1){if((t|0)==(r+(u<<2)|0))break;c[g>>2]=c[t>>2];g=g+4|0;t=t+4|0}c[e>>2]=s+((r+(u<<2)-(r+4)|0)>>>2<<2)}switch(f&176|0){case 32:{c[d>>2]=c[e>>2];break}case 16:break;default:c[d>>2]=b}return}function $c(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0;n=i;r=i=i+63&-64;i=i+576|0;c[r+56>>2]=r+64;c[r+56+4>>2]=140;p=Ll(g)|0;o=0;b=va(32,p|0,51948)|0;m=o;o=0;a:do if(!(m&1)?(a[r+564>>0]=0,o=0,k=ja(19,d|0,c[e>>2]|0,f|0,p|0,c[g+4>>2]|0,h|0,r+564|0,b|0,r+56|0,r+48|0,r+64+400|0)|0,m=o,o=0,!(m&1)):0){b:do if(k){o=0;Ba(c[(c[b>>2]|0)+48>>2]|0,b|0,48218,48228,r+8|0)|0;m=o;o=0;if(m&1){q=8;break a}f=c[r+48>>2]|0;g=c[r+56>>2]|0;if((f-g|0)>392){k=bc((f-g>>2)+2|0)|0;if(!k){o=0;Fa(20);m=o;o=0;if(!(m&1)){m=k;b=0;q=11}}else{m=k;b=k;q=11}}else{m=0;b=r+464|0;q=11}do if((q|0)==11){if(a[r+564>>0]|0){a[b>>0]=45;b=b+1|0}l=b;while(1){if(g>>>0>=f>>>0)break;k=c[g>>2]|0;b=r+8|0;while(1){if((b|0)==(r+8+40|0)){b=r+8+40|0;break}if((c[b>>2]|0)==(k|0))break;b=b+4|0}a[l>>0]=a[48218+(b-(r+8)>>2)>>0]|0;f=c[r+48>>2]|0;l=l+1|0;g=g+4|0}a[l>>0]=0;c[r>>2]=j;if((Ml(r+464|0,48103,r)|0)!=1?(o=0,ba(141,48107),j=o,o=0,j&1):0){k=m;break}if(m|0)kc(m);break b}while(0);b=Ya()|0;if(!k){k=b;f=r+56|0;break a}kc(k);k=b;f=r+56|0;break a}while(0);b=c[d>>2]|0;do if(b){k=c[b+12>>2]|0;if((k|0)==(c[b+16>>2]|0)){o=0;b=ha(c[(c[b>>2]|0)+36>>2]|0,b|0)|0;j=o;o=0;if(j&1){q=8;break a}}else b=c[k>>2]|0;if((b|0)==-1){c[d>>2]=0;f=1;break}else{f=(c[d>>2]|0)==0;break}}else f=1;while(0);b=c[e>>2]|0;do if(b){k=c[b+12>>2]|0;if((k|0)==(c[b+16>>2]|0)){o=0;b=ha(c[(c[b>>2]|0)+36>>2]|0,b|0)|0;j=o;o=0;if(j&1){q=8;break a}}else b=c[k>>2]|0;if((b|0)!=-1)if(f)break;else{q=40;break}else{c[e>>2]=0;q=38;break}}else q=38;while(0);if((q|0)==38?f:0)q=40;if((q|0)==40)c[h>>2]=c[h>>2]|2;k=c[d>>2]|0;Vl(p);b=c[r+56>>2]|0;c[r+56>>2]=0;if(b|0?(o=0,ba(c[r+56+4>>2]|0,b|0),r=o,o=0,r&1):0){r=Za(0)|0;xr(r)}i=n;return k|0}else q=8;while(0);if((q|0)==8){k=Ya()|0;f=r+56|0}Vl(p);b=c[f>>2]|0;c[f>>2]=0;if(b|0?(o=0,ba(c[r+56+4>>2]|0,b|0),r=o,o=0,r&1):0){r=Za(0)|0;xr(r)}Ra(k|0);return 0}function ad(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0;n=i;r=i=i+63&-64;i=i+240|0;c[r+8>>2]=r+128;c[r+8+4>>2]=140;p=Ll(g)|0;o=0;b=va(32,p|0,51916)|0;m=o;o=0;a:do if(!(m&1)?(a[r+126>>0]=0,o=0,k=ja(18,d|0,c[e>>2]|0,f|0,p|0,c[g+4>>2]|0,h|0,r+126|0,b|0,r+8|0,r+4|0,r+128+100|0)|0,m=o,o=0,!(m&1)):0){b:do if(k){o=0;Ba(c[(c[b>>2]|0)+32>>2]|0,b|0,48092,48102,r+116|0)|0;m=o;o=0;if(m&1){q=8;break a}f=c[r+4>>2]|0;g=c[r+8>>2]|0;if((f-g|0)>98){k=bc(f-g+2|0)|0;if(!k){o=0;Fa(20);m=o;o=0;if(!(m&1)){m=k;b=0;q=11}}else{m=k;b=k;q=11}}else{m=0;b=r+16|0;q=11}do if((q|0)==11){if(a[r+126>>0]|0){a[b>>0]=45;b=b+1|0}l=b;while(1){if(g>>>0>=f>>>0)break;k=a[g>>0]|0;b=r+116|0;while(1){if((b|0)==(r+116+10|0)){b=r+116+10|0;break}if((a[b>>0]|0)==k<<24>>24)break;b=b+1|0}a[l>>0]=a[48092+(b-(r+116))>>0]|0;f=c[r+4>>2]|0;l=l+1|0;g=g+1|0}a[l>>0]=0;c[r>>2]=j;if((Ml(r+16|0,48103,r)|0)!=1?(o=0,ba(141,48107),j=o,o=0,j&1):0){k=m;break}if(m|0)kc(m);break b}while(0);b=Ya()|0;if(!k){k=b;f=r+8|0;break a}kc(k);k=b;f=r+8|0;break a}while(0);b=c[d>>2]|0;do if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)){o=0;b=ha(c[(c[b>>2]|0)+36>>2]|0,b|0)|0;j=o;o=0;if(j&1){q=8;break a}if((b|0)==-1){c[d>>2]=0;b=0;break}else{b=c[d>>2]|0;break}}}else b=0;while(0);k=(b|0)==0;b=c[e>>2]|0;do if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)){o=0;b=ha(c[(c[b>>2]|0)+36>>2]|0,b|0)|0;j=o;o=0;if(j&1){q=8;break a}if((b|0)==-1){c[e>>2]=0;q=37;break}}if(!k)q=38}else q=37;while(0);if((q|0)==37?k:0)q=38;if((q|0)==38)c[h>>2]=c[h>>2]|2;k=c[d>>2]|0;Vl(p);b=c[r+8>>2]|0;c[r+8>>2]=0;if(b|0?(o=0,ba(c[r+8+4>>2]|0,b|0),r=o,o=0,r&1):0){r=Za(0)|0;xr(r)}i=n;return k|0}else q=8;while(0);if((q|0)==8){k=Ya()|0;f=r+8|0}Vl(p);b=c[f>>2]|0;c[f>>2]=0;if(b|0?(o=0,ba(c[r+8+4>>2]|0,b|0),r=o,o=0,r&1):0){r=Za(0)|0;xr(r)}Ra(k|0);return 0}function bd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=c[a>>2]|0;do if(g){h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=Ib[c[(c[g>>2]|0)+36>>2]&127](g)|0;else g=c[h>>2]|0;if((g|0)==-1){c[a>>2]=0;h=1;break}else{h=(c[a>>2]|0)==0;break}}else h=1;while(0);if(b){g=c[b+12>>2]|0;if((g|0)==(c[b+16>>2]|0))g=Ib[c[(c[b>>2]|0)+36>>2]&127](b)|0;else g=c[g>>2]|0;if((g|0)!=-1)if(h){i=b;n=16}else n=15;else n=13}else n=13;if((n|0)==13)if(h)n=15;else{i=0;n=16}a:do if((n|0)==15){c[d>>2]=c[d>>2]|6;g=0}else if((n|0)==16){g=c[a>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=Ib[c[(c[g>>2]|0)+36>>2]&127](g)|0;else g=c[h>>2]|0;if(!(Kb[c[(c[e>>2]|0)+12>>2]&63](e,2048,g)|0)){c[d>>2]=c[d>>2]|4;g=0;break}g=(Kb[c[(c[e>>2]|0)+52>>2]&63](e,g,0)|0)<<24>>24;h=c[a>>2]|0;b=c[h+12>>2]|0;if((b|0)==(c[h+16>>2]|0)){Ib[c[(c[h>>2]|0)+40>>2]&127](h)|0;l=f;j=i;f=i}else{c[h+12>>2]=b+4;l=f;j=i;f=i}while(1){g=g+-48|0;m=l+-1|0;h=c[a>>2]|0;do if(h){b=c[h+12>>2]|0;if((b|0)==(c[h+16>>2]|0))h=Ib[c[(c[h>>2]|0)+36>>2]&127](h)|0;else h=c[b>>2]|0;if((h|0)==-1){c[a>>2]=0;i=1;break}else{i=(c[a>>2]|0)==0;break}}else i=1;while(0);if(!f){k=j;f=0;h=1}else{h=c[f+12>>2]|0;if((h|0)==(c[f+16>>2]|0))h=Ib[c[(c[f>>2]|0)+36>>2]&127](f)|0;else h=c[h>>2]|0;h=(h|0)==-1;k=h?0:j;f=h?0:j;h=h|(j|0)==0}b=c[a>>2]|0;if(!((l|0)>1&(i^h)))break;h=c[b+12>>2]|0;if((h|0)==(c[b+16>>2]|0))h=Ib[c[(c[b>>2]|0)+36>>2]&127](b)|0;else h=c[h>>2]|0;if(!(Kb[c[(c[e>>2]|0)+12>>2]&63](e,2048,h)|0))break a;g=((Kb[c[(c[e>>2]|0)+52>>2]&63](e,h,0)|0)<<24>>24)+(g*10|0)|0;h=c[a>>2]|0;b=c[h+12>>2]|0;if((b|0)==(c[h+16>>2]|0)){Ib[c[(c[h>>2]|0)+40>>2]&127](h)|0;l=m;j=k;continue}else{c[h+12>>2]=b+4;l=m;j=k;continue}}do if(b){h=c[b+12>>2]|0;if((h|0)==(c[b+16>>2]|0))h=Ib[c[(c[b>>2]|0)+36>>2]&127](b)|0;else h=c[h>>2]|0;if((h|0)==-1){c[a>>2]=0;b=1;break}else{b=(c[a>>2]|0)==0;break}}else b=1;while(0);if(k){h=c[k+12>>2]|0;if((h|0)==(c[k+16>>2]|0))h=Ib[c[(c[k>>2]|0)+36>>2]&127](k)|0;else h=c[h>>2]|0;if((h|0)!=-1){if(b)break}else n=56}else n=56;if((n|0)==56?!b:0)break;c[d>>2]=c[d>>2]|2}while(0);return g|0}function cd(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=20;l=1634760805;m=d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24;n=2036477234;o=d[e+16>>0]|d[e+16+1>>0]<<8|d[e+16+2>>0]<<16|d[e+16+3>>0]<<24;p=d[e+20>>0]|d[e+20+1>>0]<<8|d[e+20+2>>0]<<16|d[e+20+3>>0]<<24;q=d[e+24>>0]|d[e+24+1>>0]<<8|d[e+24+2>>0]<<16|d[e+24+3>>0]<<24;r=d[e+28>>0]|d[e+28+1>>0]<<8|d[e+28+2>>0]<<16|d[e+28+3>>0]<<24;s=1797285236;t=d[e+4>>0]|d[e+4+1>>0]<<8|d[e+4+2>>0]<<16|d[e+4+3>>0]<<24;u=d[e+8>>0]|d[e+8+1>>0]<<8|d[e+8+2>>0]<<16|d[e+8+3>>0]<<24;f=d[e+12>>0]|d[e+12+1>>0]<<8|d[e+12+2>>0]<<16|d[e+12+3>>0]<<24;g=857760878;h=d[c>>0]|d[c+1>>0]<<8|d[c+2>>0]<<16|d[c+3>>0]<<24;i=d[c+4>>0]|d[c+4+1>>0]<<8|d[c+4+2>>0]<<16|d[c+4+3>>0]<<24;j=d[c+8>>0]|d[c+8+1>>0]<<8|d[c+8+2>>0]<<16|d[c+8+3>>0]<<24;e=d[c+12>>0]|d[c+12+1>>0]<<8|d[c+12+2>>0]<<16|d[c+12+3>>0]<<24;while(1){D=p+l|0;D=(D>>>25|D<<7)^f;A=D+l|0;A=(A>>>23|A<<9)^j;x=((A+D|0)>>>19|A+D<<13)^p;G=((x+A|0)>>>14|x+A<<18)^l;z=g+m|0;z=e^(z>>>25|z<<7);w=z+g|0;w=q^(w>>>23|w<<9);J=((w+z|0)>>>19|w+z<<13)^m;C=((J+w|0)>>>14|J+w<<18)^g;v=n+h|0;v=r^(v>>>25|v<<7);I=v+n|0;I=(I>>>23|I<<9)^t;F=((I+v|0)>>>19|I+v<<13)^h;y=((F+I|0)>>>14|F+I<<18)^n;H=s+o|0;H=(H>>>25|H<<7)^u;E=H+s|0;E=(E>>>23|E<<9)^i;B=((E+H|0)>>>19|E+H<<13)^o;c=((B+E|0)>>>14|B+E<<18)^s;m=((G+H|0)>>>25|G+H<<7)^J;J=m+G|0;t=(J>>>23|J<<9)^I;I=t+m|0;u=(I>>>19|I<<13)^H;H=u+t|0;l=(H>>>14|H<<18)^G;h=((C+D|0)>>>25|C+D<<7)^F;F=h+C|0;i=(F>>>23|F<<9)^E;E=i+h|0;f=(E>>>19|E<<13)^D;D=f+i|0;g=(D>>>14|D<<18)^C;o=((y+z|0)>>>25|y+z<<7)^B;B=o+y|0;j=(B>>>23|B<<9)^A;A=j+o|0;e=(A>>>19|A<<13)^z;z=e+j|0;n=(z>>>14|z<<18)^y;p=((c+v|0)>>>25|c+v<<7)^x;x=p+c|0;q=(x>>>23|x<<9)^w;w=q+p|0;r=(w>>>19|w<<13)^v;v=r+q|0;s=(v>>>14|v<<18)^c;if((k|0)<=2)break;else k=k+-2|0}a[b>>0]=l;a[b+1>>0]=l>>8;a[b+2>>0]=l>>16;a[b+3>>0]=l>>24;a[b+4>>0]=g;a[b+4+1>>0]=g>>8;a[b+4+2>>0]=g>>16;a[b+4+3>>0]=g>>24;a[b+8>>0]=n;a[b+8+1>>0]=n>>8;a[b+8+2>>0]=n>>16;a[b+8+3>>0]=n>>24;a[b+12>>0]=s;a[b+12+1>>0]=s>>8;a[b+12+2>>0]=s>>16;a[b+12+3>>0]=s>>24;a[b+16>>0]=h;a[b+16+1>>0]=h>>8;a[b+16+2>>0]=h>>16;a[b+16+3>>0]=h>>24;a[b+20>>0]=i;a[b+20+1>>0]=i>>8;a[b+20+2>>0]=i>>16;a[b+20+3>>0]=i>>24;a[b+24>>0]=j;a[b+24+1>>0]=j>>8;a[b+24+2>>0]=j>>16;a[b+24+3>>0]=j>>24;a[b+28>>0]=e;a[b+28+1>>0]=e>>8;a[b+28+2>>0]=e>>16;a[b+28+3>>0]=e>>24;return}function dd(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;r=i;t=i=i+63&-64;i=i+464|0;b=Ll(f)|0;o=0;q=va(32,b|0,51948)|0;p=o;o=0;do if(p&1)u=22;else{j=a[h+8+3>>0]|0;if(!((j<<24>>24<0?c[h+4>>2]|0:j&255)|0))p=0;else{j=c[(j<<24>>24<0?c[h>>2]|0:h)>>2]|0;o=0;k=va(c[(c[q>>2]|0)+44>>2]|0,q|0,45)|0;p=o;o=0;if(p&1){u=22;break}p=(j|0)==(k|0)}c[t+436>>2]=0;c[t+436+4>>2]=0;c[t+436+8>>2]=0;j=0;while(1){if((j|0)==3)break;c[t+436+(j<<2)>>2]=0;j=j+1|0}c[t+424>>2]=0;c[t+424+4>>2]=0;c[t+424+8>>2]=0;j=0;while(1){if((j|0)==3)break;c[t+424+(j<<2)>>2]=0;j=j+1|0}c[t+412>>2]=0;c[t+412+4>>2]=0;c[t+412+8>>2]=0;j=0;while(1){if((j|0)==3)break;c[t+412+(j<<2)>>2]=0;j=j+1|0}o=0;ta(21,e|0,p|0,b|0,t+456|0,t+452|0,t+448|0,t+436|0,t+424|0,t+412|0,t+408|0);n=o;o=0;if(!(n&1)){e=a[h+8+3>>0]|0;m=c[h+4>>2]|0;j=e<<24>>24<0?m:e&255;n=c[t+408>>2]|0;if((j|0)>(n|0)){k=a[t+412+8+3>>0]|0;l=a[t+424+8+3>>0]|0;j=(k<<24>>24<0?c[t+412+4>>2]|0:k&255)+(j-n<<1|1)+(l<<24>>24<0?c[t+424+4>>2]|0:l&255)|0}else{l=a[t+412+8+3>>0]|0;j=a[t+424+8+3>>0]|0;j=(l<<24>>24<0?c[t+412+4>>2]|0:l&255)+2+(j<<24>>24<0?c[t+424+4>>2]|0:j&255)|0}j=j+n|0;if(j>>>0>100){k=bc(j<<2)|0;if(!k){o=0;Fa(20);m=o;o=0;if(!(m&1)){m=c[h+4>>2]|0;e=a[h+8+3>>0]|0;l=k;j=0;u=26}}else{l=k;j=k;u=26}}else{l=0;j=t+8|0;u=26}if((u|0)==26){k=e<<24>>24<0;h=k?c[h>>2]|0:h;o=0;na(19,j|0,t+4|0,t|0,c[f+4>>2]|0,h|0,h+((k?m:e&255)<<2)|0,q|0,p|0,t+456|0,c[t+452>>2]|0,c[t+448>>2]|0,t+436|0,t+424|0,t+412|0,n|0);h=o;o=0;if(!(h&1)?(o=0,s=fa(57,c[d>>2]|0,j|0,c[t+4>>2]|0,c[t>>2]|0,f|0,g|0)|0,d=o,o=0,!(d&1)):0){if(l)kc(l);Ao(t+412|0);Ao(t+424|0);Oo(t+436|0);Vl(b);i=r;return s|0}else k=l}j=Ya()|0;if(k)kc(k)}else j=Ya()|0;Ao(t+412|0);Ao(t+424|0);Oo(t+436|0)}while(0);if((u|0)==22)j=Ya()|0;Vl(b);Ra(j|0);return 0}function ed(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;r=i;t=i=i+63&-64;i=i+160|0;b=Ll(f)|0;o=0;q=va(32,b|0,51916)|0;p=o;o=0;do if(p&1)u=22;else{j=a[h+11>>0]|0;if(!((j<<24>>24<0?c[h+4>>2]|0:j&255)|0))p=0;else{j=a[(j<<24>>24<0?c[h>>2]|0:h)>>0]|0;o=0;k=va(c[(c[q>>2]|0)+28>>2]|0,q|0,45)|0;p=o;o=0;if(p&1){u=22;break}p=j<<24>>24==k<<24>>24}c[t+36>>2]=0;c[t+36+4>>2]=0;c[t+36+8>>2]=0;j=0;while(1){if((j|0)==3)break;c[t+36+(j<<2)>>2]=0;j=j+1|0}c[t+24>>2]=0;c[t+24+4>>2]=0;c[t+24+8>>2]=0;j=0;while(1){if((j|0)==3)break;c[t+24+(j<<2)>>2]=0;j=j+1|0}c[t+12>>2]=0;c[t+12+4>>2]=0;c[t+12+8>>2]=0;j=0;while(1){if((j|0)==3)break;c[t+12+(j<<2)>>2]=0;j=j+1|0}o=0;ta(20,e|0,p|0,b|0,t+152|0,t+149|0,t+148|0,t+36|0,t+24|0,t+12|0,t+8|0);n=o;o=0;if(!(n&1)){l=a[h+11>>0]|0;e=c[h+4>>2]|0;j=l<<24>>24<0?e:l&255;n=c[t+8>>2]|0;if((j|0)>(n|0)){k=a[t+12+11>>0]|0;m=a[t+24+11>>0]|0;j=(k<<24>>24<0?c[t+12+4>>2]|0:k&255)+(j-n<<1|1)+(m<<24>>24<0?c[t+24+4>>2]|0:m&255)|0}else{m=a[t+12+11>>0]|0;j=a[t+24+11>>0]|0;j=(m<<24>>24<0?c[t+12+4>>2]|0:m&255)+2+(j<<24>>24<0?c[t+24+4>>2]|0:j&255)|0}j=j+n|0;if(j>>>0>100){k=bc(j)|0;if(!k){o=0;Fa(20);m=o;o=0;if(!(m&1)){m=a[h+11>>0]|0;e=c[h+4>>2]|0;l=k;j=0;u=26}}else{m=l;l=k;j=k;u=26}}else{m=l;l=0;j=t+48|0;u=26}if((u|0)==26){k=m<<24>>24<0;h=k?c[h>>2]|0:h;o=0;na(18,j|0,t+4|0,t|0,c[f+4>>2]|0,h|0,h+(k?e:m&255)|0,q|0,p|0,t+152|0,a[t+149>>0]|0,a[t+148>>0]|0,t+36|0,t+24|0,t+12|0,n|0);h=o;o=0;if(!(h&1)?(o=0,s=fa(56,c[d>>2]|0,j|0,c[t+4>>2]|0,c[t>>2]|0,f|0,g|0)|0,d=o,o=0,!(d&1)):0){if(l)kc(l);Oo(t+12|0);Oo(t+24|0);Oo(t+36|0);Vl(b);i=r;return s|0}else k=l}j=Ya()|0;if(k)kc(k)}else j=Ya()|0;Oo(t+12|0);Oo(t+24|0);Oo(t+36|0)}while(0);if((u|0)==22)j=Ya()|0;Vl(b);Ra(j|0);return 0}function fd(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=c[e>>2]|0;if((g|0)!=0?(i=c[g>>2]|0,(i|0)!=0):0)if(!b){g=f;j=h;k=15}else{c[g>>2]=0;l=b;g=f;j=i;k=35}else if(!b){g=f;k=7}else{i=b;g=f;k=6}a:while(1)if((k|0)==6){if(!g){k=25;break}else j=i;while(1){i=a[h>>0]|0;b:do if(((i&255)+-1|0)>>>0<127?g>>>0>4&(h&3|0)==0:0){i=j;do{j=c[h>>2]|0;if((j+-16843009|j)&-2139062144|0){b=i;i=j&255;break b}c[i>>2]=j&255;c[i+4>>2]=d[h+1>>0];c[i+8>>2]=d[h+2>>0];k=h;h=h+4|0;l=i;i=i+16|0;c[l+12>>2]=d[k+3>>0];g=g+-4|0}while(g>>>0>4);b=i;i=a[h>>0]|0}else b=j;while(0);j=i&255;if((j+-1|0)>>>0>=127)break;h=h+1|0;c[b>>2]=j;g=g+-1|0;if(!g){k=25;break a}else j=b+4|0}if((j+-194|0)>>>0>50){k=47;break}l=b;j=c[33840+(j+-194<<2)>>2]|0;h=h+1|0;k=35;continue}else if((k|0)==7){i=a[h>>0]|0;if(((i&255)+-1|0)>>>0<127?(h&3|0)==0:0){i=c[h>>2]|0;if(!((i+-16843009|i)&-2139062144)){do{h=h+4|0;g=g+-4|0;i=c[h>>2]|0}while(((i+-16843009|i)&-2139062144|0)==0);i=i&255}else i=i&255}j=i&255;if((j+-1|0)>>>0<127){g=g+-1|0;h=h+1|0;k=7;continue}if((j+-194|0)>>>0>50){k=47;break}i=c[33840+(j+-194<<2)>>2]|0;j=h+1|0;k=15;continue}else if((k|0)==15){l=(d[j>>0]|0)>>>3;if((l+-16|l+(i>>26))>>>0>7){k=16;break}h=j+1|0;if(i&33554432){if((a[h>>0]&-64)<<24>>24!=-128){k=19;break}h=j+2|0;if(i&524288){if((a[h>>0]&-64)<<24>>24!=-128){k=22;break}h=j+3|0}}g=g+-1|0;k=7;continue}else if((k|0)==35){i=d[h>>0]|0;if(((i>>>3)+-16|(i>>>3)+(j>>26))>>>0>7){k=36;break}b=h+1|0;k=i+-128|j<<6;if((k|0)<0){j=d[b>>0]|0;if((j&192|0)!=128){k=39;break}i=h+2|0;if((j+-128|k<<6|0)<0){i=d[i>>0]|0;if((i&192|0)!=128){k=42;break}j=i+-128|(j+-128|k<<6)<<6;h=h+3|0}else{j=j+-128|k<<6;h=i}}else{j=k;h=b}c[l>>2]=j;i=l+4|0;g=g+-1|0;k=6;continue}if((k|0)==16){h=j+-1|0;k=45}else if((k|0)==19){h=j+-1|0;k=45}else if((k|0)==22){h=j+-1|0;k=45}else if((k|0)==25)c[e>>2]=h;else if((k|0)==36){b=l;i=j;h=h+-1|0;k=45}else if((k|0)==39){g=l;f=h+-1|0;k=51}else if((k|0)==42){g=l;f=h+-1|0;k=51}if((k|0)==45)if(!i){i=a[h>>0]|0;k=47}else{g=b;f=h;k=51}if((k|0)==47)if(!(i<<24>>24)){if(b|0){c[b>>2]=0;c[e>>2]=0}f=f-g|0}else{g=b;f=h;k=51}if((k|0)==51){c[(gp()|0)>>2]=84;if(!g)f=-1;else{c[e>>2]=f;f=-1}}return f|0}function gd(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;s=i;t=i=i+63&-64;i=i+16|0;q=Ro(c[j>>2]|0,51916)|0;m=Ro(c[j>>2]|0,51928)|0;Gb[c[(c[m>>2]|0)+20>>2]&127](t,m);p=a[t+11>>0]|0;a:do if(!((p<<24>>24<0?c[t+4>>2]|0:p&255)|0)){o=0;Ba(c[(c[q>>2]|0)+32>>2]|0,q|0,b|0,e|0,f|0)|0;r=o;o=0;if(r&1)r=5;else{c[h>>2]=f+(e-b);k=b;j=f+(e-b)|0;r=30}}else{c[h>>2]=f;j=a[b>>0]|0;switch(j<<24>>24){case 43:case 45:{o=0;j=va(c[(c[q>>2]|0)+28>>2]|0,q|0,j|0)|0;p=o;o=0;if(p&1){r=5;break a}l=c[h>>2]|0;c[h>>2]=l+1;a[l>>0]=j;l=b+1|0;break}default:l=b}b:do if((e-l|0)>1?(a[l>>0]|0)==48:0){j=l+1|0;switch(a[j>>0]|0){case 88:case 120:break;default:break b}o=0;k=va(c[(c[q>>2]|0)+28>>2]|0,q|0,48)|0;p=o;o=0;if(p&1){r=5;break a}p=c[h>>2]|0;c[h>>2]=p+1;a[p>>0]=k;o=0;j=va(c[(c[q>>2]|0)+28>>2]|0,q|0,a[j>>0]|0)|0;p=o;o=0;if(p&1){r=5;break a}p=c[h>>2]|0;c[h>>2]=p+1;a[p>>0]=j;l=l+2|0}while(0);c:do if((l|0)!=(e|0)){j=e;k=l;while(1){j=j+-1|0;if(k>>>0>=j>>>0)break c;p=a[k>>0]|0;a[k>>0]=a[j>>0]|0;a[j>>0]=p;k=k+1|0}}while(0);o=0;n=ha(c[(c[m>>2]|0)+16>>2]|0,m|0)|0;p=o;o=0;if(!(p&1)){j=0;k=0;p=l;while(1){if(p>>>0>=e>>>0)break;m=a[((a[t+11>>0]|0)<0?c[t>>2]|0:t)+k>>0]|0;if(m<<24>>24!=0&(j|0)==(m<<24>>24|0)){j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=n;j=a[t+11>>0]|0;m=0;k=(k>>>0<((j<<24>>24<0?c[t+4>>2]|0:j&255)+-1|0)>>>0&1)+k|0}else m=j;o=0;j=va(c[(c[q>>2]|0)+28>>2]|0,q|0,a[p>>0]|0)|0;u=o;o=0;if(u&1){r=4;break}u=c[h>>2]|0;c[h>>2]=u+1;a[u>>0]=j;j=m+1|0;p=p+1|0}if((r|0)==4){j=Ya()|0;break}j=f+(l-b)|0;k=c[h>>2]|0;if((j|0)==(k|0)){k=b;r=30}else{while(1){k=k+-1|0;if(j>>>0>=k>>>0)break;u=a[j>>0]|0;a[j>>0]=a[k>>0]|0;a[k>>0]=u;j=j+1|0}k=b;j=c[h>>2]|0;r=30}}else r=5}while(0);if((r|0)==5)j=Ya()|0;else if((r|0)==30){c[g>>2]=(d|0)==(e|0)?j:f+(d-k)|0;Oo(t);i=s;return}Oo(t);Ra(j|0)}function hd(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0,s=0,t=0,u=0;s=i;t=i=i+63&-64;i=i+16|0;q=Ro(c[j>>2]|0,51948)|0;m=Ro(c[j>>2]|0,51956)|0;Gb[c[(c[m>>2]|0)+20>>2]&127](t,m);p=a[t+11>>0]|0;a:do if(!((p<<24>>24<0?c[t+4>>2]|0:p&255)|0)){o=0;Ba(c[(c[q>>2]|0)+48>>2]|0,q|0,b|0,e|0,f|0)|0;r=o;o=0;if(r&1)r=5;else{c[h>>2]=f+(e-b<<2);k=b;j=f+(e-b<<2)|0;r=29}}else{c[h>>2]=f;j=a[b>>0]|0;switch(j<<24>>24){case 43:case 45:{o=0;j=va(c[(c[q>>2]|0)+44>>2]|0,q|0,j|0)|0;p=o;o=0;if(p&1){r=5;break a}l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=j;l=b+1|0;break}default:l=b}b:do if((e-l|0)>1?(a[l>>0]|0)==48:0){j=l+1|0;switch(a[j>>0]|0){case 88:case 120:break;default:break b}o=0;k=va(c[(c[q>>2]|0)+44>>2]|0,q|0,48)|0;p=o;o=0;if(p&1){r=5;break a}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=k;o=0;j=va(c[(c[q>>2]|0)+44>>2]|0,q|0,a[j>>0]|0)|0;p=o;o=0;if(p&1){r=5;break a}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=j;l=l+2|0}while(0);c:do if((l|0)!=(e|0)){j=e;k=l;while(1){j=j+-1|0;if(k>>>0>=j>>>0)break c;p=a[k>>0]|0;a[k>>0]=a[j>>0]|0;a[j>>0]=p;k=k+1|0}}while(0);o=0;n=ha(c[(c[m>>2]|0)+16>>2]|0,m|0)|0;p=o;o=0;if(!(p&1)){k=0;m=0;p=l;while(1){if(p>>>0>=e>>>0)break;j=a[t+11>>0]|0;u=a[(j<<24>>24<0?c[t>>2]|0:t)+m>>0]|0;if(u<<24>>24!=0&(k|0)==(u<<24>>24|0)){k=c[h>>2]|0;c[h>>2]=k+4;c[k>>2]=n;k=0;m=(m>>>0<((j<<24>>24<0?c[t+4>>2]|0:j&255)+-1|0)>>>0&1)+m|0}o=0;j=va(c[(c[q>>2]|0)+44>>2]|0,q|0,a[p>>0]|0)|0;u=o;o=0;if(u&1){r=4;break}u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=j;k=k+1|0;p=p+1|0}if((r|0)==4){j=Ya()|0;break}j=f+(l-b<<2)|0;l=c[h>>2]|0;if((j|0)==(l|0)){k=b;r=29}else{k=l;while(1){k=k+-4|0;if(j>>>0>=k>>>0){k=b;j=l;r=29;break a}u=c[j>>2]|0;c[j>>2]=c[k>>2];c[k>>2]=u;j=j+4|0}}}else r=5}while(0);if((r|0)==5)j=Ya()|0;else if((r|0)==29){c[g>>2]=(d|0)==(e|0)?j:f+(d-k<<2)|0;Oo(t);i=s;return}Oo(t);Ra(j|0)}function id(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=c[a>>2]|0;do if(i){if((c[i+12>>2]|0)==(c[i+16>>2]|0))if((Ib[c[(c[i>>2]|0)+36>>2]&127](i)|0)==-1){c[a>>2]=0;i=0;break}else{i=c[a>>2]|0;break}}else i=0;while(0);i=(i|0)==0;do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(Ib[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){o=10;break}if(i){k=e;o=12}else o=11}else o=10;while(0);if((o|0)==10)if(i)o=11;else{k=0;o=12}a:do if((o|0)==11){c[f>>2]=c[f>>2]|6;i=0}else if((o|0)==12){i=c[a>>2]|0;e=c[i+12>>2]|0;if((e|0)==(c[i+16>>2]|0))i=Ib[c[(c[i>>2]|0)+36>>2]&127](i)|0;else i=d[e>>0]|0;e=i&255;if(e<<24>>24>-1?b[(c[g+8>>2]|0)+(i<<24>>24<<1)>>1]&2048:0){i=(Kb[c[(c[g>>2]|0)+36>>2]&63](g,e,0)|0)<<24>>24;e=c[a>>2]|0;j=c[e+12>>2]|0;if((j|0)==(c[e+16>>2]|0)){Ib[c[(c[e>>2]|0)+40>>2]&127](e)|0;l=k}else{c[e+12>>2]=j+1;l=k}while(1){i=i+-48|0;m=h+-1|0;e=c[a>>2]|0;do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0))if((Ib[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[a>>2]=0;e=0;break}else{e=c[a>>2]|0;break}}else e=0;while(0);j=(e|0)==0;if(k)if((c[k+12>>2]|0)==(c[k+16>>2]|0)){k=(Ib[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;n=k?0:l;k=k?0:l}else n=l;else{n=l;k=0}e=c[a>>2]|0;if(!((h|0)>1&(j^(k|0)==0)))break;j=c[e+12>>2]|0;if((j|0)==(c[e+16>>2]|0))e=Ib[c[(c[e>>2]|0)+36>>2]&127](e)|0;else e=d[j>>0]|0;j=e&255;if(j<<24>>24<=-1)break a;if(!(b[(c[g+8>>2]|0)+(e<<24>>24<<1)>>1]&2048))break a;i=((Kb[c[(c[g>>2]|0)+36>>2]&63](g,j,0)|0)<<24>>24)+(i*10|0)|0;e=c[a>>2]|0;j=c[e+12>>2]|0;if((j|0)==(c[e+16>>2]|0)){Ib[c[(c[e>>2]|0)+40>>2]&127](e)|0;h=m;l=n;continue}else{c[e+12>>2]=j+1;h=m;l=n;continue}}do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0))if((Ib[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[a>>2]=0;e=0;break}else{e=c[a>>2]|0;break}}else e=0;while(0);e=(e|0)==0;do if(n){if((c[n+12>>2]|0)==(c[n+16>>2]|0)?(Ib[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1:0){o=47;break}if(e)break a}else o=47;while(0);if((o|0)==47?!e:0)break;c[f>>2]=c[f>>2]|2;break}c[f>>2]=c[f>>2]|4;i=0}while(0);return i|0}function jd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!b)if(!e){if(f|0){c[f>>2]=(a>>>0)%(d>>>0);c[f+4>>2]=0}e=0;f=(a>>>0)/(d>>>0)>>>0;return (D=e,f)|0}else{if(!f){e=0;f=0;return (D=e,f)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;e=0;f=0;return (D=e,f)|0}do if(d){if(e|0){h=(U(e|0)|0)-(U(b|0)|0)|0;if(h>>>0<=31){n=h+1|0;i=a>>>((h+1|0)>>>0)&h-31>>31|b<<31-h;m=b>>>((h+1|0)>>>0)&h-31>>31;g=0;h=a<<31-h;break}if(!f){e=0;f=0;return (D=e,f)|0}c[f>>2]=a|0;c[f+4>>2]=b|b&0;e=0;f=0;return (D=e,f)|0}if(d-1&d|0){h=(U(d|0)|0)+33-(U(b|0)|0)|0;n=h;i=32-h-1>>31&b>>>((h-32|0)>>>0)|(b<<32-h|a>>>(h>>>0))&h-32>>31;m=h-32>>31&b>>>(h>>>0);g=a<<64-h&32-h>>31;h=(b<<64-h|a>>>((h-32|0)>>>0))&32-h>>31|a<<32-h&h-33>>31;break}if(f|0){c[f>>2]=d-1&a;c[f+4>>2]=0}if((d|0)==1){e=b|b&0;f=a|0|0;return (D=e,f)|0}else{f=lk(d|0)|0;e=b>>>(f>>>0)|0;f=b<<32-f|a>>>(f>>>0)|0;return (D=e,f)|0}}else{if(!e){if(f|0){c[f>>2]=(b>>>0)%(d>>>0);c[f+4>>2]=0}e=0;f=(b>>>0)/(d>>>0)>>>0;return (D=e,f)|0}if(!a){if(f|0){c[f>>2]=0;c[f+4>>2]=(b>>>0)%(e>>>0)}d=0;f=(b>>>0)/(e>>>0)>>>0;return (D=d,f)|0}if(!(e-1&e)){if(f|0){c[f>>2]=a|0;c[f+4>>2]=e-1&b|b&0}d=0;f=b>>>((lk(e|0)|0)>>>0);return (D=d,f)|0}h=(U(e|0)|0)-(U(b|0)|0)|0;if(h>>>0<=30){n=h+1|0;i=b<<31-h|a>>>((h+1|0)>>>0);m=b>>>((h+1|0)>>>0);g=0;h=a<<31-h;break}if(!f){e=0;f=0;return (D=e,f)|0}c[f>>2]=a|0;c[f+4>>2]=b|b&0;e=0;f=0;return (D=e,f)|0}while(0);if(!n){j=h;b=m;a=0;h=0}else{k=go(d|0|0,e|e&0|0,-1,-1)|0;l=D;j=h;b=m;a=n;h=0;do{p=j;j=g>>>31|j<<1;g=h|g<<1;p=i<<1|p>>>31|0;o=i>>>31|b<<1|0;Sm(k|0,l|0,p|0,o|0)|0;n=D;m=n>>31|((n|0)<0?-1:0)<<1;h=m&1;i=Sm(p|0,o|0,m&(d|0)|0,(((n|0)<0?-1:0)>>31|((n|0)<0?-1:0)<<1)&(e|e&0)|0)|0;b=D;a=a-1|0}while((a|0)!=0);a=0}if(f|0){c[f>>2]=i;c[f+4>>2]=b}o=(g|0)>>>31|j<<1|(0<<1|g>>>31)&0|a;p=(g<<1|0>>>31)&-2|h;return (D=o,p)|0}function kd(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0;q=i;r=i=i+63&-64;i=i+432|0;c[r+8>>2]=r+16;c[r+8+4>>2]=140;p=Ll(g)|0;o=0;l=va(32,p|0,51948)|0;b=o;o=0;a:do if(!(b&1)?(a[r+416>>0]=0,m=c[e>>2]|0,o=0,k=ja(19,d|0,m|0,f|0,p|0,c[g+4>>2]|0,h|0,r+416|0,l|0,r+8|0,r|0,r+16+400|0)|0,g=o,o=0,!(g&1)):0){if(k){if((a[j+8+3>>0]|0)<0){c[c[j>>2]>>2]=0;c[j+4>>2]=0}else{c[j>>2]=0;a[j+8+3>>0]=0}if(a[r+416>>0]|0){o=0;b=va(c[(c[l>>2]|0)+44>>2]|0,l|0,45)|0;g=o;o=0;if(g&1)break;o=0;da(62,j|0,b|0);g=o;o=0;if(g&1)break}o=0;b=va(c[(c[l>>2]|0)+44>>2]|0,l|0,48)|0;g=o;o=0;if(g&1)break;k=c[r>>2]|0;l=c[r+8>>2]|0;while(1){if(l>>>0>=(k+-4|0)>>>0)break;if((c[l>>2]|0)!=(b|0))break;l=l+4|0}o=0;Da(25,j|0,l|0,k|0);j=o;o=0;if(j&1)break}b=c[d>>2]|0;do if(b){k=c[b+12>>2]|0;if((k|0)==(c[b+16>>2]|0)){o=0;b=ha(c[(c[b>>2]|0)+36>>2]|0,b|0)|0;j=o;o=0;if(j&1)break a}else b=c[k>>2]|0;if((b|0)==-1){c[d>>2]=0;k=1;break}else{k=(c[d>>2]|0)==0;break}}else k=1;while(0);do if(m){b=c[m+12>>2]|0;if((b|0)==(c[m+16>>2]|0)){o=0;b=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;m=o;o=0;if(m&1)break a}else b=c[b>>2]|0;if((b|0)!=-1)if(k)break;else{n=31;break}else{c[e>>2]=0;n=29;break}}else n=29;while(0);if((n|0)==29?k:0)n=31;if((n|0)==31)c[h>>2]=c[h>>2]|2;k=c[d>>2]|0;Vl(p);b=c[r+8>>2]|0;c[r+8>>2]=0;if(b|0?(o=0,ba(c[r+8+4>>2]|0,b|0),r=o,o=0,r&1):0){r=Za(0)|0;xr(r)}i=q;return k|0}while(0);k=Ya()|0;Vl(p);b=c[r+8>>2]|0;c[r+8>>2]=0;if(b|0?(o=0,ba(c[r+8+4>>2]|0,b|0),r=o,o=0,r&1):0){r=Za(0)|0;xr(r)}Ra(k|0);return 0}function ld(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=i=i+63&-64;i=i+2400|0;uf(h+2136|0,d);uf(h+1880|0,f);Yf(h+480|0,e);qe(h+1760|0,e);Ig(h+320|0,h+1760|0);Rj(h,h+320|0);Xf(h+320|0,h,h+480|0);Rj(h+160|0,h+320|0);Yf(h+480+160|0,h+160|0);Xf(h+320|0,h,h+480+160|0);Rj(h+160|0,h+320|0);Yf(h+480+320|0,h+160|0);Xf(h+320|0,h,h+480+320|0);Rj(h+160|0,h+320|0);Yf(h+480+480|0,h+160|0);Xf(h+320|0,h,h+480+480|0);Rj(h+160|0,h+320|0);Yf(h+480+640|0,h+160|0);Xf(h+320|0,h,h+480+640|0);Rj(h+160|0,h+320|0);Yf(h+480+800|0,h+160|0);Xf(h+320|0,h,h+480+800|0);Rj(h+160|0,h+320|0);Yf(h+480+960|0,h+160|0);Xf(h+320|0,h,h+480+960|0);Rj(h+160|0,h+320|0);Yf(h+480+1120|0,h+160|0);e=b;d=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(d|0));c[b+40>>2]=1;e=b+44|0;d=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(d|0));c[b+80>>2]=1;e=b+84|0;d=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(d|0));d=255;while(1){if(a[h+2136+d>>0]|0){e=d;break}if(a[h+1880+d>>0]|0){e=d;break}e=d+-1|0;if((d|0)>0)d=e;else break}if((e|0)>-1)while(1){Ig(h+320|0,b);d=a[h+2136+e>>0]|0;if(d<<24>>24<=0){if(d<<24>>24<0){Rj(h+160|0,h+320|0);Wf(h+320|0,h+160|0,h+480+(((d<<24>>24|0)/-2|0)*160|0)|0)}}else{Rj(h+160|0,h+320|0);Xf(h+320|0,h+160|0,h+480+(((d<<24>>24|0)/2|0)*160|0)|0)}d=a[h+1880+e>>0]|0;if(d<<24>>24<=0){if(d<<24>>24<0){Rj(h+160|0,h+320|0);fg(h+320|0,h+160|0,2160+(((d<<24>>24|0)/-2|0)*120|0)|0)}}else{Rj(h+160|0,h+320|0);gg(h+320|0,h+160|0,2160+(((d<<24>>24|0)/2|0)*120|0)|0)}al(b,h+320|0);if((e|0)>0)e=e+-1|0;else break}i=g;return}function md(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,p=0,q=0,r=0;q=i;r=i=i+63&-64;i=i+128|0;c[r+8>>2]=r+20;c[r+8+4>>2]=140;p=Ll(g)|0;o=0;l=va(32,p|0,51916)|0;b=o;o=0;a:do if(!(b&1)?(a[r+16>>0]=0,m=c[e>>2]|0,o=0,k=ja(18,d|0,m|0,f|0,p|0,c[g+4>>2]|0,h|0,r+16|0,l|0,r+8|0,r|0,r+20+100|0)|0,g=o,o=0,!(g&1)):0){if(k){if((a[j+11>>0]|0)<0){a[c[j>>2]>>0]=0;c[j+4>>2]=0}else{a[j>>0]=0;a[j+11>>0]=0}if(a[r+16>>0]|0){o=0;b=va(c[(c[l>>2]|0)+28>>2]|0,l|0,45)|0;g=o;o=0;if(g&1)break;o=0;da(61,j|0,b|0);g=o;o=0;if(g&1)break}o=0;b=va(c[(c[l>>2]|0)+28>>2]|0,l|0,48)|0;g=o;o=0;if(g&1)break;k=c[r>>2]|0;l=c[r+8>>2]|0;while(1){if(l>>>0>=(k+-1|0)>>>0)break;if((a[l>>0]|0)!=b<<24>>24)break;l=l+1|0}o=0;Da(23,j|0,l|0,k|0);j=o;o=0;if(j&1)break}b=c[d>>2]|0;do if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)){o=0;b=ha(c[(c[b>>2]|0)+36>>2]|0,b|0)|0;j=o;o=0;if(j&1)break a;if((b|0)==-1){c[d>>2]=0;b=0;break}else{b=c[d>>2]|0;break}}}else b=0;while(0);k=(b|0)==0;do if(m){if((c[m+12>>2]|0)==(c[m+16>>2]|0)){o=0;b=ha(c[(c[m>>2]|0)+36>>2]|0,m|0)|0;m=o;o=0;if(m&1)break a;if((b|0)==-1){c[e>>2]=0;n=28;break}}if(!k)n=29}else n=28;while(0);if((n|0)==28?k:0)n=29;if((n|0)==29)c[h>>2]=c[h>>2]|2;k=c[d>>2]|0;Vl(p);b=c[r+8>>2]|0;c[r+8>>2]=0;if(b|0?(o=0,ba(c[r+8+4>>2]|0,b|0),r=o,o=0,r&1):0){r=Za(0)|0;xr(r)}i=q;return k|0}while(0);k=Ya()|0;Vl(p);b=c[r+8>>2]|0;c[r+8>>2]=0;if(b|0?(o=0,ba(c[r+8+4>>2]|0,b|0),r=o,o=0,r&1):0){r=Za(0)|0;xr(r)}Ra(k|0);return 0}function nd(a,b){a=+a;b=+b;var d=0,e=0,f=0,g=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0;h[k>>3]=a;d=c[k>>2]|0;o=c[k+4>>2]|0;h[k>>3]=b;m=c[k>>2]|0;n=c[k+4>>2]|0;j=Mm(d|0,o|0,52)|0;l=Mm(m|0,n|0,52)|0;g=Km(m|0,n|0,1)|0;i=D;a:do if(!((g|0)==0&(i|0)==0)?(q=+F(+b),h[k>>3]=q,f=c[k+4>>2]|0,!(f>>>0>2146435072|(f|0)==2146435072&(c[k>>2]|0)>>>0>0|(j&2047|0)==2047)):0){e=Km(d|0,o|0,1)|0;f=D;if(!(f>>>0>i>>>0|(f|0)==(i|0)&e>>>0>g>>>0))return +((e|0)==(g|0)&(f|0)==(i|0)?a*0.0:a);if(!(j&2047)){e=Km(d|0,o|0,12)|0;f=D;if((f|0)>-1|(f|0)==-1&e>>>0>4294967295){g=e;e=0;do{e=e+-1|0;g=Km(g|0,f|0,1)|0;f=D}while((f|0)>-1|(f|0)==-1&g>>>0>4294967295)}else e=0;d=Km(d|0,o|0,1-e|0)|0;f=D}else{f=o&1048575|1048576;e=j&2047}if(!(l&2047)){g=Km(m|0,n|0,12)|0;i=D;if((i|0)>-1|(i|0)==-1&g>>>0>4294967295){j=0;do{j=j+-1|0;g=Km(g|0,i|0,1)|0;i=D}while((i|0)>-1|(i|0)==-1&g>>>0>4294967295)}else j=0;m=Km(m|0,n|0,1-j|0)|0;n=D}else{n=n&1048575|1048576;j=l&2047}i=Sm(d|0,f|0,m|0,n|0)|0;g=D;b:do if((e|0)>(j|0)){l=(g|0)>-1|(g|0)==-1&i>>>0>4294967295;while(1){if(l)if((d|0)==(m|0)&(f|0)==(n|0))break;else{d=i;f=g}d=Km(d|0,f|0,1)|0;f=D;e=e+-1|0;i=Sm(d|0,f|0,m|0,n|0)|0;g=D;if((e|0)>(j|0))l=(g|0)>-1|(g|0)==-1&i>>>0>4294967295;else{j=(g|0)>-1|(g|0)==-1&i>>>0>4294967295;break b}}b=a*0.0;break a}else j=(g|0)>-1|(g|0)==-1&i>>>0>4294967295;while(0);if(j)if((d|0)==(m|0)&(f|0)==(n|0)){b=a*0.0;break}else{f=g;d=i}if(f>>>0<1048576|(f|0)==1048576&d>>>0<0)do{d=Km(d|0,f|0,1)|0;f=D;e=e+-1|0}while(f>>>0<1048576|(f|0)==1048576&d>>>0<0);if((e|0)>0){n=go(d|0,f|0,0,-1048576)|0;d=D;e=Km(e|0,0,52)|0;d=d|D;e=n|e}else{e=Mm(d|0,f|0,1-e|0)|0;d=D}c[k>>2]=e;c[k+4>>2]=d|o&-2147483648;b=+h[k>>3]}else p=3;while(0);if((p|0)==3)b=a*b/(a*b);return +b}function od(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=i=i+63&-64;i=i+160|0;ic(d+120|0,b);ic(d+80|0,d+120|0);ic(d+80|0,d+80|0);fc(d+80|0,b,d+80|0);fc(d+120|0,d+120|0,d+80|0);ic(d+40|0,d+120|0);fc(d+80|0,d+80|0,d+40|0);ic(d+40|0,d+80|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);fc(d+80|0,d+40|0,d+80|0);ic(d+40|0,d+80|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);fc(d+40|0,d+40|0,d+80|0);ic(d,d+40|0);b=1;do{ic(d,d);b=b+1|0}while((b|0)!=20);fc(d+40|0,d,d+40|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);ic(d+40|0,d+40|0);fc(d+80|0,d+40|0,d+80|0);ic(d+40|0,d+80|0);b=1;do{ic(d+40|0,d+40|0);b=b+1|0}while((b|0)!=50);fc(d+40|0,d+40|0,d+80|0);ic(d,d+40|0);b=1;do{ic(d,d);b=b+1|0}while((b|0)!=100);fc(d+40|0,d,d+40|0);ic(d+40|0,d+40|0);b=1;do{ic(d+40|0,d+40|0);b=b+1|0}while((b|0)!=50);fc(d+80|0,d+40|0,d+80|0);ic(d+80|0,d+80|0);ic(d+80|0,d+80|0);ic(d+80|0,d+80|0);ic(d+80|0,d+80|0);ic(d+80|0,d+80|0);fc(a,d+80|0,d+120|0);i=c;return}function pd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;a:do if((b|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)==(e|0)?(c[d+28>>2]|0)!=1:0)c[d+28>>2]=f}else{if((b|0)!=(c[d>>2]|0)){i=c[b+12>>2]|0;ni(b+16|0,d,e,f,g);if((i|0)<=1)break;h=c[b+8>>2]|0;if((h&2|0)==0?(c[d+36>>2]|0)!=1:0){if(!(h&1)){h=b+24|0;while(1){if(a[d+54>>0]|0)break a;if((c[d+36>>2]|0)==1)break a;ni(h,d,e,f,g);h=h+8|0;if(h>>>0>=(b+16+(i<<3)|0)>>>0)break a}}h=b+24|0;while(1){if(a[d+54>>0]|0)break a;if((c[d+36>>2]|0)==1?(c[d+24>>2]|0)==1:0)break a;ni(h,d,e,f,g);h=h+8|0;if(h>>>0>=(b+16+(i<<3)|0)>>>0)break a}}h=b+24|0;while(1){if(a[d+54>>0]|0)break a;ni(h,d,e,f,g);h=h+8|0;if(h>>>0>=(b+16+(i<<3)|0)>>>0)break a}}if((c[d+16>>2]|0)!=(e|0)?(c[d+20>>2]|0)!=(e|0):0){c[d+32>>2]=f;if((c[d+44>>2]|0)==4)break;f=b+16+(c[b+12>>2]<<3)|0;k=0;h=0;j=b+16|0;b:while(1){if(j>>>0>=f>>>0){i=20;break}a[d+52>>0]=0;a[d+53>>0]=0;ci(j,d,e,e,1,g);if(a[d+54>>0]|0){i=20;break}do if(a[d+53>>0]|0){if(!(a[d+52>>0]|0))if(!(c[b+8>>2]&1)){h=1;i=20;break b}else{i=k;h=1;break}if((c[d+24>>2]|0)==1){i=25;break b}if(!(c[b+8>>2]&2)){i=25;break b}else{i=1;h=1}}else i=k;while(0);k=i;j=j+8|0}do if((i|0)==20){if((!k?(c[d+20>>2]=e,c[d+40>>2]=(c[d+40>>2]|0)+1,(c[d+36>>2]|0)==1):0)?(c[d+24>>2]|0)==2:0){a[d+54>>0]=1;if(h){i=25;break}else{h=4;break}}if(h)i=25;else h=4}while(0);if((i|0)==25)h=3;c[d+44>>2]=h;break}if((f|0)==1)c[d+32>>2]=1}while(0);return}function qd(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;k=i=i+63&-64;i=i+224|0;c[k+16>>2]=0;c[k+16+4>>2]=0;c[k+16+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[k+16+(e<<2)>>2]=0;e=e+1|0}c[k+8+4>>2]=0;c[k+8>>2]=40416;d=a[h+8+3>>0]|0;g=d<<24>>24<0?c[h>>2]|0:h;d=g+((d<<24>>24<0?c[h+4>>2]|0:d&255)<<2)|0;e=0;a:while(1){if(!((e|0)!=2&g>>>0<d>>>0)){g=16;break}c[k+176>>2]=g;o=0;f=Ha(c[(c[k+8>>2]|0)+12>>2]|0,k+8|0,k+184|0,g|0,d|0,k+176|0,k+192|0,k+192+32|0,k+180|0)|0;h=o;o=0;if(h&1){g=14;break}if((f|0)==2?1:(c[k+176>>2]|0)==(g|0)){g=8;break}else e=k+192|0;while(1){if(e>>>0>=(c[k+180>>2]|0)>>>0)break;o=0;da(61,k+16|0,a[e>>0]|0);h=o;o=0;if(h&1){g=13;break a}e=e+1|0}g=c[k+176>>2]|0;e=f}if((g|0)==8){o=0;ba(141,47843);o=0;e=Ya()|0;g=15}else if((g|0)==13){e=Ya()|0;g=15}else if((g|0)==14){e=Ya()|0;g=15}else if((g|0)==16){e=(a[k+16+11>>0]|0)<0?c[k+16>>2]|0:k+16|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;g=0;while(1){if((g|0)==3)break;c[b+(g<<2)>>2]=0;g=g+1|0}g=et(e)|0;c[k+4>>2]=0;c[k>>2]=40464;d=g+(Zg(g)|0)|0;e=0;b:while(1){if(!((e|0)!=2&g>>>0<d>>>0)){g=28;break}c[k+28>>2]=g;o=0;f=Ha(c[(c[k>>2]|0)+16>>2]|0,k|0,k+168|0,g|0,((d-g|0)>32?g+32|0:d)|0,k+28|0,k+40|0,k+40+128|0,k+32|0)|0;h=o;o=0;if(h&1){g=30;break}if((f|0)==2?1:(c[k+28>>2]|0)==(g|0)){g=23;break}else e=k+40|0;while(1){if(e>>>0>=(c[k+32>>2]|0)>>>0)break;o=0;da(62,b|0,c[e>>2]|0);h=o;o=0;if(h&1){g=29;break b}e=e+4|0}g=c[k+28>>2]|0;e=f}if((g|0)==23){o=0;ba(141,47843);o=0;e=Ya()|0}else if((g|0)==28){Oo(k+16|0);i=j;return}else if((g|0)==29)e=Ya()|0;else if((g|0)==30)e=Ya()|0;Ao(b)}Oo(k+16|0);Ra(e|0)}function rd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;d=i;e=i=i+63&-64;i=i+128|0;ic(e+80|0,b);ic(e+40|0,e+80|0);ic(e+40|0,e+40|0);fc(e+40|0,b,e+40|0);fc(e+80|0,e+80|0,e+40|0);ic(e+80|0,e+80|0);fc(e+80|0,e+40|0,e+80|0);ic(e+40|0,e+80|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);fc(e+80|0,e+40|0,e+80|0);ic(e+40|0,e+80|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);fc(e+40|0,e+40|0,e+80|0);ic(e,e+40|0);c=1;do{ic(e,e);c=c+1|0}while((c|0)!=20);fc(e+40|0,e,e+40|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);ic(e+40|0,e+40|0);fc(e+80|0,e+40|0,e+80|0);ic(e+40|0,e+80|0);c=1;do{ic(e+40|0,e+40|0);c=c+1|0}while((c|0)!=50);fc(e+40|0,e+40|0,e+80|0);ic(e,e+40|0);c=1;do{ic(e,e);c=c+1|0}while((c|0)!=100);fc(e+40|0,e,e+40|0);ic(e+40|0,e+40|0);c=1;do{ic(e+40|0,e+40|0);c=c+1|0}while((c|0)!=50);fc(e+80|0,e+40|0,e+80|0);ic(e+80|0,e+80|0);ic(e+80|0,e+80|0);fc(a,e+80|0,b);i=d;return}function sd(e,f,g,h,i,j,k,l){e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;c[g>>2]=e;c[j>>2]=h;if(((((l&4|0)!=0?(m=c[g>>2]|0,(f-m|0)>2):0)?(a[m>>0]|0)==-17:0)?(a[m+1>>0]|0)==-69:0)?(a[m+2>>0]|0)==-65:0){c[g>>2]=m+3;n=f}else n=f;a:while(1){h=c[g>>2]|0;if(h>>>0>=f>>>0){m=0;break}o=c[j>>2]|0;if(o>>>0>=i>>>0){m=1;break}p=a[h>>0]|0;if((p&255)>>>0>k>>>0){m=2;break}do if(p<<24>>24>-1){b[o>>1]=p&255;c[g>>2]=h+1}else{if((p&255)<194){m=2;break a}if((p&255)<224){if((n-h|0)<2){m=1;break a}m=d[h+1>>0]|0;if((m&192|0)!=128){m=2;break a}if((m&63|(p&255)<<6&1984)>>>0>k>>>0){m=2;break a}b[o>>1]=m&63|(p&255)<<6&1984;c[g>>2]=h+2;break}if((p&255)<240){if((n-h|0)<3){m=1;break a}m=a[h+1>>0]|0;e=a[h+2>>0]|0;switch(p&255|0){case 224:{if((m&-32)<<24>>24!=-96){m=2;break a}break}case 237:{if((m&-32)<<24>>24!=-128){m=2;break a}break}default:if((m&-64)<<24>>24!=-128){m=2;break a}}if((e&192|0)!=128){m=2;break a}if((((m&255)<<6&4032|(p&255)<<12|e&63)&65535)>>>0>k>>>0){m=2;break a}b[o>>1]=(m&255)<<6&4032|(p&255)<<12|e&63;c[g>>2]=h+3;break}if((p&255)>=245){m=2;break a}if((n-h|0)<4){m=1;break a}e=a[h+1>>0]|0;l=a[h+2>>0]|0;m=a[h+3>>0]|0;switch(p&255|0){case 240:{if((e+112&255)>=48){m=2;break a}break}case 244:{if((e&-16)<<24>>24!=-128){m=2;break a}break}default:if((e&-64)<<24>>24!=-128){m=2;break a}}if((l&192|0)!=128){m=2;break a}if((m&192|0)!=128){m=2;break a}if((i-o|0)<4){m=1;break a}if(((e&255)<<12&258048|(p&7)<<18|(l&255)<<6&4032|m&63)>>>0>k>>>0){m=2;break a}b[o>>1]=(e&255)<<2&60|(l&255)>>>4&3|(((e&255)>>>4&3|(p&7)<<2)<<6)+16320|55296;c[j>>2]=o+2;b[o+2>>1]=m&63|(l&255)<<6&960|56320;c[g>>2]=(c[g>>2]|0)+4}while(0);c[j>>2]=(c[j>>2]|0)+2}return m|0}function td(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0;q=i;p=i=i+63&-64;i=i+336|0;c[p>>2]=37;c[p+4>>2]=0;g=lf(p+1|0,47041,c[d+4>>2]|0)|0;c[p+296>>2]=p+300;a=To()|0;if(g){c[p+8>>2]=c[d+8>>2];h[p+8+8>>3]=f;a=ij(p+300|0,30,a,p,p+8|0)|0}else{h[p+24>>3]=f;a=ij(p+300|0,30,a,p,p+24|0)|0}do if((a|0)>29){a=To()|0;if(g){o=0;c[p+32>>2]=c[d+8>>2];h[p+32+8>>3]=f;a=Ba(23,p+296|0,a|0,p|0,p+32|0)|0;n=o;o=0;if(!(n&1))r=9}else{o=0;h[p+48>>3]=f;a=Ba(23,p+296|0,a|0,p|0,p+48|0)|0;n=o;o=0;if(!(n&1))r=9}if((r|0)==9){g=c[p+296>>2]|0;if(g|0){j=g;k=g;n=g;r=11;break}o=0;Fa(20);n=o;o=0;if(!(n&1)){j=0;k=g;n=g;r=11;break}}a=Ya()|0}else{j=p+300|0;k=p+300|0;n=0;r=11}while(0);if((r|0)==11){l=k+a|0;m=Tg(k,l,c[d+4>>2]|0)|0;do if((k|0)==(p+300|0)){a=p+300|0;k=p+68|0;g=0;r=16}else{g=bc(a<<3)|0;if(!g){o=0;Fa(20);r=o;o=0;if(r&1){g=0;r=14;break}else a=j}else a=k;k=g;r=16}while(0);do if((r|0)==16){j=Ll(d)|0;c[p+56>>2]=j;o=0;ra(21,a|0,m|0,l|0,k|0,p+64|0,p+60|0,p+56|0);m=o;o=0;if(m&1){a=Ya()|0;Vl(j);break}Vl(j);o=0;a=fa(57,c[b>>2]|0,k|0,c[p+64>>2]|0,c[p+60>>2]|0,d|0,e|0)|0;r=o;o=0;if(r&1)r=14;else{c[b>>2]=a;if(g|0)kc(g);if(n|0)kc(n);i=q;return a|0}}while(0);if((r|0)==14)a=Ya()|0;if(g|0)kc(g);if(n)kc(n)}Ra(a|0);return 0}function ud(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0;q=i;p=i=i+63&-64;i=i+336|0;c[p>>2]=37;c[p+4>>2]=0;g=lf(p+1|0,55997,c[d+4>>2]|0)|0;c[p+296>>2]=p+300;a=To()|0;if(g){c[p+8>>2]=c[d+8>>2];h[p+8+8>>3]=f;a=ij(p+300|0,30,a,p,p+8|0)|0}else{h[p+24>>3]=f;a=ij(p+300|0,30,a,p,p+24|0)|0}do if((a|0)>29){a=To()|0;if(g){o=0;c[p+32>>2]=c[d+8>>2];h[p+32+8>>3]=f;a=Ba(23,p+296|0,a|0,p|0,p+32|0)|0;n=o;o=0;if(!(n&1))r=9}else{o=0;h[p+48>>3]=f;a=Ba(23,p+296|0,a|0,p|0,p+48|0)|0;n=o;o=0;if(!(n&1))r=9}if((r|0)==9){g=c[p+296>>2]|0;if(g|0){j=g;k=g;n=g;r=11;break}o=0;Fa(20);n=o;o=0;if(!(n&1)){j=0;k=g;n=g;r=11;break}}a=Ya()|0}else{j=p+300|0;k=p+300|0;n=0;r=11}while(0);if((r|0)==11){l=k+a|0;m=Tg(k,l,c[d+4>>2]|0)|0;do if((k|0)==(p+300|0)){a=p+300|0;k=p+68|0;g=0;r=16}else{g=bc(a<<3)|0;if(!g){o=0;Fa(20);r=o;o=0;if(r&1){g=0;r=14;break}else a=j}else a=k;k=g;r=16}while(0);do if((r|0)==16){j=Ll(d)|0;c[p+56>>2]=j;o=0;ra(21,a|0,m|0,l|0,k|0,p+64|0,p+60|0,p+56|0);m=o;o=0;if(m&1){a=Ya()|0;Vl(j);break}Vl(j);o=0;a=fa(57,c[b>>2]|0,k|0,c[p+64>>2]|0,c[p+60>>2]|0,d|0,e|0)|0;r=o;o=0;if(r&1)r=14;else{c[b>>2]=a;if(g|0)kc(g);if(n|0)kc(n);i=q;return a|0}}while(0);if((r|0)==14)a=Ya()|0;if(g|0)kc(g);if(n)kc(n)}Ra(a|0);return 0}function vd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0;q=i;p=i=i+63&-64;i=i+160|0;c[p>>2]=37;c[p+4>>2]=0;g=lf(p+1|0,47041,c[d+4>>2]|0)|0;c[p+68>>2]=p+130;a=To()|0;if(g){c[p+8>>2]=c[d+8>>2];h[p+8+8>>3]=f;a=ij(p+130|0,30,a,p,p+8|0)|0}else{h[p+24>>3]=f;a=ij(p+130|0,30,a,p,p+24|0)|0}do if((a|0)>29){a=To()|0;if(g){o=0;c[p+32>>2]=c[d+8>>2];h[p+32+8>>3]=f;a=Ba(23,p+68|0,a|0,p|0,p+32|0)|0;n=o;o=0;if(!(n&1))r=9}else{o=0;h[p+48>>3]=f;a=Ba(23,p+68|0,a|0,p|0,p+48|0)|0;n=o;o=0;if(!(n&1))r=9}if((r|0)==9){g=c[p+68>>2]|0;if(g|0){j=g;k=g;n=g;r=11;break}o=0;Fa(20);n=o;o=0;if(!(n&1)){j=0;k=g;n=g;r=11;break}}a=Ya()|0}else{j=p+130|0;k=p+130|0;n=0;r=11}while(0);if((r|0)==11){l=k+a|0;m=Tg(k,l,c[d+4>>2]|0)|0;do if((k|0)==(p+130|0)){a=p+130|0;k=p+72|0;g=0;r=16}else{g=bc(a<<1)|0;if(!g){o=0;Fa(20);r=o;o=0;if(r&1){g=0;r=14;break}else a=j}else a=k;k=g;r=16}while(0);do if((r|0)==16){j=Ll(d)|0;c[p+56>>2]=j;o=0;ra(19,a|0,m|0,l|0,k|0,p+64|0,p+60|0,p+56|0);m=o;o=0;if(m&1){a=Ya()|0;Vl(j);break}Vl(j);o=0;a=fa(56,c[b>>2]|0,k|0,c[p+64>>2]|0,c[p+60>>2]|0,d|0,e|0)|0;r=o;o=0;if(r&1)r=14;else{c[b>>2]=a;if(g|0)kc(g);if(n|0)kc(n);i=q;return a|0}}while(0);if((r|0)==14)a=Ya()|0;if(g|0)kc(g);if(n)kc(n)}Ra(a|0);return 0}
function Yb(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;g=i;h=i=i+63&-64;i=i+720|0;e=0;do{k=b+(e<<3)|0;p=d[k+7>>0]|0;q=Km(d[k+6>>0]|0|0,0,8)|0;j=D;o=Km(d[k+5>>0]|0|0,0,16)|0;j=j|D;n=Km(d[k+4>>0]|0|0,0,24)|0;j=j|D|(d[k+3>>0]|0);m=Km(d[k+2>>0]|0|0,0,40)|0;j=j|D;l=Km(d[k+1>>0]|0|0,0,48)|0;j=j|D;k=Km(d[k>>0]|0|0,0,56)|0;f=h+80+(e<<3)|0;c[f>>2]=q|p|o|n|m|l|k;c[f+4>>2]=j|D;e=e+1|0}while((e|0)!=16);b=c[h+80>>2]|0;e=c[h+80+4>>2]|0;f=16;do{s=h+80+(f+-2<<3)|0;w=c[s>>2]|0;s=c[s+4>>2]|0;r=Mm(w|0,s|0,19)|0;k=D;j=Km(w|0,s|0,45)|0;k=k|D;u=Mm(w|0,s|0,61)|0;v=D;t=Km(w|0,s|0,3)|0;v=v|D;s=Mm(w|0,s|0,6)|0;k=v^D^k;v=h+80+(f+-7<<3)|0;w=c[v>>2]|0;v=c[v+4>>2]|0;o=h+80+(f+-15<<3)|0;y=b;b=c[o>>2]|0;x=e;e=c[o+4>>2]|0;o=Mm(b|0,e|0,1)|0;p=D;q=Km(b|0,e|0,63)|0;p=p|D;l=Mm(b|0,e|0,8)|0;z=D;m=Km(b|0,e|0,56)|0;z=z|D;n=Mm(b|0,e|0,7)|0;p=z^D^p;v=go(y|0,x|0,w|0,v|0)|0;k=go(v|0,D|0,(u|t)^s^(r|j)|0,k|0)|0;p=go(k|0,D|0,(l|m)^n^(o|q)|0,p|0)|0;q=h+80+(f<<3)|0;c[q>>2]=p;c[q+4>>2]=D;f=f+1|0}while((f|0)!=80);b=h+16|0;e=a;f=b+64|0;do{c[b>>2]=c[e>>2];b=b+4|0;e=e+4|0}while((b|0)<(f|0));G=h+16+56|0;x=c[G>>2]|0;E=c[G+4>>2]|0;w=h+16+32|0;I=c[w>>2]|0;H=c[w+4>>2]|0;b=Mm(I|0,H|0,14)|0;z=D;F=Km(I|0,H|0,50)|0;z=z|D;l=Mm(I|0,H|0,18)|0;A=D;L=Km(I|0,H|0,46)|0;A=z^(A|D);z=Mm(I|0,H|0,41)|0;J=D;K=Km(I|0,H|0,23)|0;J=A^(J|D);A=h+16+40|0;M=c[A>>2]|0;f=c[A+4>>2]|0;k=h+16+48|0;p=c[k>>2]|0;j=c[k+4>>2]|0;r=c[h+80>>2]|0;y=c[h+80+4>>2]|0;E=go(x|0,E|0,-685199838,1116352408)|0;y=go(E|0,D|0,r|0,y|0)|0;J=go(y|0,D|0,(b|F)^(l|L)^(z|K)|0,J|0)|0;J=go(J|0,D|0,(p^M)&I^p|0,(j^f)&H^j|0)|0;K=D;z=c[h+16>>2]|0;L=c[h+16+4>>2]|0;l=Mm(z|0,L|0,28)|0;F=D;b=Km(z|0,L|0,36)|0;F=F|D;y=Mm(z|0,L|0,34)|0;r=D;E=Km(z|0,L|0,30)|0;r=F^(r|D);F=Mm(z|0,L|0,39)|0;x=D;m=Km(z|0,L|0,25)|0;C=h+16+8|0;o=c[C>>2]|0;q=c[C+4>>2]|0;B=h+16+16|0;e=c[B>>2]|0;s=c[B+4>>2]|0;x=go((e|o)&z|e&o|0,(s|q)&L|s&q|0,(l|b)^(y|E)^(F|m)|0,r^(x|D)|0)|0;r=D;m=h+16+24|0;F=go(c[m>>2]|0,c[m+4>>2]|0,J|0,K|0)|0;E=D;c[m>>2]=F;c[m+4>>2]=E;K=go(x|0,r|0,J|0,K|0)|0;J=D;c[G>>2]=K;c[G+4>>2]=J;r=Mm(F|0,E|0,14)|0;x=D;y=Km(F|0,E|0,50)|0;x=x|D;b=Mm(F|0,E|0,18)|0;l=D;u=Km(F|0,E|0,46)|0;l=x^(l|D);x=Mm(F|0,E|0,41)|0;t=D;v=Km(F|0,E|0,23)|0;t=l^(t|D);l=c[h+80+8>>2]|0;n=c[h+80+8+4>>2]|0;j=go(p|0,j|0,602891725,1899447441)|0;t=go(j|0,D|0,(r|y)^(b|u)^(x|v)|0,t|0)|0;n=go(t|0,D|0,l|0,n|0)|0;H=go(n|0,D|0,(M^I)&F^M|0,(f^H)&E^f|0)|0;I=D;n=Mm(K|0,J|0,28)|0;l=D;t=Km(K|0,J|0,36)|0;l=l|D;v=Mm(K|0,J|0,34)|0;x=D;u=Km(K|0,J|0,30)|0;x=l^(x|D);l=Mm(K|0,J|0,39)|0;b=D;y=Km(K|0,J|0,25)|0;b=go((o|z)&K|o&z|0,(q|L)&J|q&L|0,(n|t)^(v|u)^(l|y)|0,x^(b|D)|0)|0;x=D;s=go(e|0,s|0,H|0,I|0)|0;e=D;c[B>>2]=s;c[B+4>>2]=e;I=go(b|0,x|0,H|0,I|0)|0;H=D;c[k>>2]=I;c[k+4>>2]=H;x=Mm(s|0,e|0,14)|0;b=D;y=Km(s|0,e|0,50)|0;b=b|D;l=Mm(s|0,e|0,18)|0;u=D;v=Km(s|0,e|0,46)|0;u=b^(u|D);b=Mm(s|0,e|0,41)|0;t=D;n=Km(s|0,e|0,23)|0;t=u^(t|D);u=c[w>>2]|0;r=c[w+4>>2]|0;j=c[h+80+16>>2]|0;p=c[h+80+16+4>>2]|0;f=go(M|0,f|0,-330482897,-1245643825)|0;t=go(f|0,D|0,(x|y)^(l|v)^(b|n)|0,t|0)|0;p=go(t|0,D|0,j|0,p|0)|0;p=go(p|0,D|0,(u^F)&s^u|0,(r^E)&e^r|0)|0;j=D;t=Mm(I|0,H|0,28)|0;n=D;b=Km(I|0,H|0,36)|0;n=n|D;v=Mm(I|0,H|0,34)|0;l=D;y=Km(I|0,H|0,30)|0;l=n^(l|D);n=Mm(I|0,H|0,39)|0;x=D;f=Km(I|0,H|0,25)|0;x=go((z|K)&I|z&K|0,(L|J)&H|L&J|0,(t|b)^(v|y)^(n|f)|0,l^(x|D)|0)|0;l=D;q=go(o|0,q|0,p|0,j|0)|0;o=D;c[C>>2]=q;c[C+4>>2]=o;j=go(x|0,l|0,p|0,j|0)|0;p=D;c[A>>2]=j;c[A+4>>2]=p;l=Mm(q|0,o|0,14)|0;x=D;f=Km(q|0,o|0,50)|0;x=x|D;n=Mm(q|0,o|0,18)|0;y=D;v=Km(q|0,o|0,46)|0;y=x^(y|D);x=Mm(q|0,o|0,41)|0;b=D;t=Km(q|0,o|0,23)|0;b=y^(b|D);y=c[h+80+24>>2]|0;J=c[h+80+24+4>>2]|0;r=go(u|0,r|0,-2121671748,-373957723)|0;b=go(r|0,D|0,(l|f)^(n|v)^(x|t)|0,b|0)|0;J=go(b|0,D|0,y|0,J|0)|0;J=go(J|0,D|0,(F^s)&q^F|0,(E^e)&o^E|0)|0;y=D;b=Mm(j|0,p|0,28)|0;t=D;x=Km(j|0,p|0,36)|0;t=t|D;v=Mm(j|0,p|0,34)|0;n=D;f=Km(j|0,p|0,30)|0;n=t^(n|D);t=Mm(j|0,p|0,39)|0;l=D;r=Km(j|0,p|0,25)|0;u=c[G>>2]|0;K=c[G+4>>2]|0;l=go((u|I)&j|u&I|0,(K|H)&p|K&H|0,(b|x)^(v|f)^(t|r)|0,n^(l|D)|0)|0;n=D;L=go(z|0,L|0,J|0,y|0)|0;z=D;c[h+16>>2]=L;c[h+16+4>>2]=z;y=go(l|0,n|0,J|0,y|0)|0;J=D;c[w>>2]=y;c[w+4>>2]=J;n=Mm(L|0,z|0,14)|0;l=D;r=Km(L|0,z|0,50)|0;l=l|D;t=Mm(L|0,z|0,18)|0;f=D;v=Km(L|0,z|0,46)|0;f=l^(f|D);l=Mm(L|0,z|0,41)|0;x=D;b=Km(L|0,z|0,23)|0;x=f^(x|D);f=c[h+80+32>>2]|0;H=c[h+80+32+4>>2]|0;E=go(F|0,E|0,-213338824,961987163)|0;x=go(E|0,D|0,(n|r)^(t|v)^(l|b)|0,x|0)|0;H=go(x|0,D|0,f|0,H|0)|0;H=go(H|0,D|0,(s^q)&L^s|0,(e^o)&z^e|0)|0;f=D;x=Mm(y|0,J|0,28)|0;b=D;l=Km(y|0,J|0,36)|0;b=b|D;v=Mm(y|0,J|0,34)|0;t=D;r=Km(y|0,J|0,30)|0;t=b^(t|D);b=Mm(y|0,J|0,39)|0;n=D;E=Km(y|0,J|0,25)|0;F=c[k>>2]|0;I=c[k+4>>2]|0;n=go((F|j)&y|F&j|0,(I|p)&J|I&p|0,(x|l)^(v|r)^(b|E)|0,t^(n|D)|0)|0;t=D;K=go(u|0,K|0,H|0,f|0)|0;u=D;c[G>>2]=K;c[G+4>>2]=u;f=go(n|0,t|0,H|0,f|0)|0;H=D;c[m>>2]=f;c[m+4>>2]=H;t=Mm(K|0,u|0,14)|0;n=D;E=Km(K|0,u|0,50)|0;n=n|D;b=Mm(K|0,u|0,18)|0;r=D;v=Km(K|0,u|0,46)|0;r=n^(r|D);n=Mm(K|0,u|0,41)|0;l=D;x=Km(K|0,u|0,23)|0;l=r^(l|D);r=c[h+80+40>>2]|0;p=c[h+80+40+4>>2]|0;e=go(s|0,e|0,-1241133031,1508970993)|0;l=go(e|0,D|0,(t|E)^(b|v)^(n|x)|0,l|0)|0;p=go(l|0,D|0,r|0,p|0)|0;p=go(p|0,D|0,(q^L)&K^q|0,(o^z)&u^o|0)|0;r=D;l=Mm(f|0,H|0,28)|0;x=D;n=Km(f|0,H|0,36)|0;x=x|D;v=Mm(f|0,H|0,34)|0;b=D;E=Km(f|0,H|0,30)|0;b=x^(b|D);x=Mm(f|0,H|0,39)|0;t=D;e=Km(f|0,H|0,25)|0;s=c[A>>2]|0;j=c[A+4>>2]|0;t=go((s|y)&f|s&y|0,(j|J)&H|j&J|0,(l|n)^(v|E)^(x|e)|0,b^(t|D)|0)|0;b=D;I=go(F|0,I|0,p|0,r|0)|0;F=D;c[k>>2]=I;c[k+4>>2]=F;r=go(t|0,b|0,p|0,r|0)|0;p=D;c[B>>2]=r;c[B+4>>2]=p;b=Mm(I|0,F|0,14)|0;t=D;e=Km(I|0,F|0,50)|0;t=t|D;x=Mm(I|0,F|0,18)|0;E=D;v=Km(I|0,F|0,46)|0;E=t^(E|D);t=Mm(I|0,F|0,41)|0;n=D;l=Km(I|0,F|0,23)|0;n=E^(n|D);E=c[h+80+48>>2]|0;J=c[h+80+48+4>>2]|0;o=go(q|0,o|0,-1357295717,-1841331548)|0;n=go(o|0,D|0,(b|e)^(x|v)^(t|l)|0,n|0)|0;J=go(n|0,D|0,E|0,J|0)|0;J=go(J|0,D|0,(L^K)&I^L|0,(z^u)&F^z|0)|0;E=D;n=Mm(r|0,p|0,28)|0;l=D;t=Km(r|0,p|0,36)|0;l=l|D;v=Mm(r|0,p|0,34)|0;x=D;e=Km(r|0,p|0,30)|0;x=l^(x|D);l=Mm(r|0,p|0,39)|0;b=D;o=Km(r|0,p|0,25)|0;q=c[w>>2]|0;y=c[w+4>>2]|0;b=go((q|f)&r|q&f|0,(y|H)&p|y&H|0,(n|t)^(v|e)^(l|o)|0,x^(b|D)|0)|0;x=D;j=go(s|0,j|0,J|0,E|0)|0;s=D;c[A>>2]=j;c[A+4>>2]=s;E=go(b|0,x|0,J|0,E|0)|0;J=D;c[C>>2]=E;c[C+4>>2]=J;x=Mm(j|0,s|0,14)|0;b=D;o=Km(j|0,s|0,50)|0;b=b|D;l=Mm(j|0,s|0,18)|0;e=D;v=Km(j|0,s|0,46)|0;e=b^(e|D);b=Mm(j|0,s|0,41)|0;t=D;n=Km(j|0,s|0,23)|0;t=e^(t|D);e=c[h+80+56>>2]|0;H=c[h+80+56+4>>2]|0;z=go(L|0,z|0,-630357736,-1424204075)|0;t=go(z|0,D|0,(x|o)^(l|v)^(b|n)|0,t|0)|0;H=go(t|0,D|0,e|0,H|0)|0;H=go(H|0,D|0,(K^I)&j^K|0,(u^F)&s^u|0)|0;e=D;t=Mm(E|0,J|0,28)|0;n=D;b=Km(E|0,J|0,36)|0;n=n|D;v=Mm(E|0,J|0,34)|0;l=D;o=Km(E|0,J|0,30)|0;l=n^(l|D);n=Mm(E|0,J|0,39)|0;x=D;z=Km(E|0,J|0,25)|0;L=c[m>>2]|0;f=c[m+4>>2]|0;x=go((L|r)&E|L&r|0,(f|p)&J|f&p|0,(t|b)^(v|o)^(n|z)|0,l^(x|D)|0)|0;l=D;y=go(q|0,y|0,H|0,e|0)|0;q=D;c[w>>2]=y;c[w+4>>2]=q;e=go(x|0,l|0,H|0,e|0)|0;H=D;c[h+16>>2]=e;c[h+16+4>>2]=H;l=Mm(y|0,q|0,14)|0;x=D;z=Km(y|0,q|0,50)|0;x=x|D;n=Mm(y|0,q|0,18)|0;o=D;v=Km(y|0,q|0,46)|0;o=x^(o|D);x=Mm(y|0,q|0,41)|0;b=D;t=Km(y|0,q|0,23)|0;b=o^(b|D);o=c[h+80+64>>2]|0;p=c[h+80+64+4>>2]|0;u=go(K|0,u|0,-1560083902,-670586216)|0;b=go(u|0,D|0,(l|z)^(n|v)^(x|t)|0,b|0)|0;p=go(b|0,D|0,o|0,p|0)|0;p=go(p|0,D|0,(I^j)&y^I|0,(F^s)&q^F|0)|0;o=D;b=Mm(e|0,H|0,28)|0;t=D;x=Km(e|0,H|0,36)|0;t=t|D;v=Mm(e|0,H|0,34)|0;n=D;z=Km(e|0,H|0,30)|0;n=t^(n|D);t=Mm(e|0,H|0,39)|0;l=D;u=Km(e|0,H|0,25)|0;K=c[B>>2]|0;r=c[B+4>>2]|0;l=go((K|E)&e|K&E|0,(r|J)&H|r&J|0,(b|x)^(v|z)^(t|u)|0,n^(l|D)|0)|0;n=D;f=go(L|0,f|0,p|0,o|0)|0;L=D;c[m>>2]=f;c[m+4>>2]=L;o=go(l|0,n|0,p|0,o|0)|0;p=D;c[G>>2]=o;c[G+4>>2]=p;n=Mm(f|0,L|0,14)|0;l=D;u=Km(f|0,L|0,50)|0;l=l|D;t=Mm(f|0,L|0,18)|0;z=D;v=Km(f|0,L|0,46)|0;z=l^(z|D);l=Mm(f|0,L|0,41)|0;x=D;b=Km(f|0,L|0,23)|0;x=z^(x|D);z=c[h+80+72>>2]|0;J=c[h+80+72+4>>2]|0;F=go(I|0,F|0,1164996542,310598401)|0;x=go(F|0,D|0,(n|u)^(t|v)^(l|b)|0,x|0)|0;J=go(x|0,D|0,z|0,J|0)|0;J=go(J|0,D|0,(j^y)&f^j|0,(s^q)&L^s|0)|0;z=D;x=Mm(o|0,p|0,28)|0;b=D;l=Km(o|0,p|0,36)|0;b=b|D;v=Mm(o|0,p|0,34)|0;t=D;u=Km(o|0,p|0,30)|0;t=b^(t|D);b=Mm(o|0,p|0,39)|0;n=D;F=Km(o|0,p|0,25)|0;I=c[C>>2]|0;E=c[C+4>>2]|0;n=go((I|e)&o|I&e|0,(E|H)&p|E&H|0,(x|l)^(v|u)^(b|F)|0,t^(n|D)|0)|0;t=D;r=go(K|0,r|0,J|0,z|0)|0;K=D;c[B>>2]=r;c[B+4>>2]=K;z=go(n|0,t|0,J|0,z|0)|0;J=D;c[k>>2]=z;c[k+4>>2]=J;t=Mm(r|0,K|0,14)|0;n=D;F=Km(r|0,K|0,50)|0;n=n|D;b=Mm(r|0,K|0,18)|0;u=D;v=Km(r|0,K|0,46)|0;u=n^(u|D);n=Mm(r|0,K|0,41)|0;l=D;x=Km(r|0,K|0,23)|0;l=u^(l|D);u=c[h+80+80>>2]|0;H=c[h+80+80+4>>2]|0;s=go(j|0,s|0,1323610764,607225278)|0;l=go(s|0,D|0,(t|F)^(b|v)^(n|x)|0,l|0)|0;H=go(l|0,D|0,u|0,H|0)|0;H=go(H|0,D|0,(y^f)&r^y|0,(q^L)&K^q|0)|0;u=D;l=Mm(z|0,J|0,28)|0;x=D;n=Km(z|0,J|0,36)|0;x=x|D;v=Mm(z|0,J|0,34)|0;b=D;F=Km(z|0,J|0,30)|0;b=x^(b|D);x=Mm(z|0,J|0,39)|0;t=D;s=Km(z|0,J|0,25)|0;j=c[h+16>>2]|0;e=c[h+16+4>>2]|0;t=go((j|o)&z|j&o|0,(e|p)&J|e&p|0,(l|n)^(v|F)^(x|s)|0,b^(t|D)|0)|0;b=D;E=go(I|0,E|0,H|0,u|0)|0;I=D;c[C>>2]=E;c[C+4>>2]=I;u=go(t|0,b|0,H|0,u|0)|0;H=D;c[A>>2]=u;c[A+4>>2]=H;b=Mm(E|0,I|0,14)|0;t=D;s=Km(E|0,I|0,50)|0;t=t|D;x=Mm(E|0,I|0,18)|0;F=D;v=Km(E|0,I|0,46)|0;F=t^(F|D);t=Mm(E|0,I|0,41)|0;n=D;l=Km(E|0,I|0,23)|0;n=F^(n|D);F=c[h+80+88>>2]|0;p=c[h+80+88+4>>2]|0;q=go(y|0,q|0,-704662302,1426881987)|0;n=go(q|0,D|0,(b|s)^(x|v)^(t|l)|0,n|0)|0;p=go(n|0,D|0,F|0,p|0)|0;p=go(p|0,D|0,(f^r)&E^f|0,(L^K)&I^L|0)|0;F=D;n=Mm(u|0,H|0,28)|0;l=D;t=Km(u|0,H|0,36)|0;l=l|D;v=Mm(u|0,H|0,34)|0;x=D;s=Km(u|0,H|0,30)|0;x=l^(x|D);l=Mm(u|0,H|0,39)|0;b=D;q=Km(u|0,H|0,25)|0;y=c[G>>2]|0;o=c[G+4>>2]|0;b=go((y|z)&u|y&z|0,(o|J)&H|o&J|0,(n|t)^(v|s)^(l|q)|0,x^(b|D)|0)|0;x=D;e=go(j|0,e|0,p|0,F|0)|0;j=D;c[h+16>>2]=e;c[h+16+4>>2]=j;F=go(b|0,x|0,p|0,F|0)|0;p=D;c[w>>2]=F;c[w+4>>2]=p;x=Mm(e|0,j|0,14)|0;b=D;q=Km(e|0,j|0,50)|0;b=b|D;l=Mm(e|0,j|0,18)|0;s=D;v=Km(e|0,j|0,46)|0;s=b^(s|D);b=Mm(e|0,j|0,41)|0;t=D;n=Km(e|0,j|0,23)|0;t=s^(t|D);s=c[h+80+96>>2]|0;J=c[h+80+96+4>>2]|0;L=go(f|0,L|0,-226784913,1925078388)|0;t=go(L|0,D|0,(x|q)^(l|v)^(b|n)|0,t|0)|0;J=go(t|0,D|0,s|0,J|0)|0;J=go(J|0,D|0,(r^E)&e^r|0,(K^I)&j^K|0)|0;s=D;t=Mm(F|0,p|0,28)|0;n=D;b=Km(F|0,p|0,36)|0;n=n|D;v=Mm(F|0,p|0,34)|0;l=D;q=Km(F|0,p|0,30)|0;l=n^(l|D);n=Mm(F|0,p|0,39)|0;x=D;L=Km(F|0,p|0,25)|0;f=c[k>>2]|0;z=c[k+4>>2]|0;x=go((f|u)&F|f&u|0,(z|H)&p|z&H|0,(t|b)^(v|q)^(n|L)|0,l^(x|D)|0)|0;l=D;o=go(y|0,o|0,J|0,s|0)|0;y=D;c[G>>2]=o;c[G+4>>2]=y;s=go(x|0,l|0,J|0,s|0)|0;J=D;c[m>>2]=s;c[m+4>>2]=J;l=Mm(o|0,y|0,14)|0;x=D;L=Km(o|0,y|0,50)|0;x=x|D;n=Mm(o|0,y|0,18)|0;q=D;v=Km(o|0,y|0,46)|0;q=x^(q|D);x=Mm(o|0,y|0,41)|0;b=D;t=Km(o|0,y|0,23)|0;b=q^(b|D);q=c[h+80+104>>2]|0;H=c[h+80+104+4>>2]|0;K=go(r|0,K|0,991336113,-2132889090)|0;b=go(K|0,D|0,(l|L)^(n|v)^(x|t)|0,b|0)|0;H=go(b|0,D|0,q|0,H|0)|0;H=go(H|0,D|0,(E^e)&o^E|0,(I^j)&y^I|0)|0;q=D;b=Mm(s|0,J|0,28)|0;t=D;x=Km(s|0,J|0,36)|0;t=t|D;v=Mm(s|0,J|0,34)|0;n=D;L=Km(s|0,J|0,30)|0;n=t^(n|D);t=Mm(s|0,J|0,39)|0;l=D;K=Km(s|0,J|0,25)|0;r=c[A>>2]|0;u=c[A+4>>2]|0;l=go((r|F)&s|r&F|0,(u|p)&J|u&p|0,(b|x)^(v|L)^(t|K)|0,n^(l|D)|0)|0;n=D;z=go(f|0,z|0,H|0,q|0)|0;f=D;c[k>>2]=z;c[k+4>>2]=f;q=go(l|0,n|0,H|0,q|0)|0;H=D;c[B>>2]=q;c[B+4>>2]=H;n=Mm(z|0,f|0,14)|0;l=D;K=Km(z|0,f|0,50)|0;l=l|D;t=Mm(z|0,f|0,18)|0;L=D;v=Km(z|0,f|0,46)|0;L=l^(L|D);l=Mm(z|0,f|0,41)|0;x=D;b=Km(z|0,f|0,23)|0;x=L^(x|D);L=c[h+80+112>>2]|0;p=c[h+80+112+4>>2]|0;I=go(E|0,I|0,633803317,-1680079193)|0;x=go(I|0,D|0,(n|K)^(t|v)^(l|b)|0,x|0)|0;p=go(x|0,D|0,L|0,p|0)|0;p=go(p|0,D|0,(e^o)&z^e|0,(j^y)&f^j|0)|0;L=D;x=Mm(q|0,H|0,28)|0;b=D;l=Km(q|0,H|0,36)|0;b=b|D;v=Mm(q|0,H|0,34)|0;t=D;K=Km(q|0,H|0,30)|0;t=b^(t|D);b=Mm(q|0,H|0,39)|0;n=D;I=Km(q|0,H|0,25)|0;E=c[w>>2]|0;F=c[w+4>>2]|0;n=go((E|s)&q|E&s|0,(F|J)&H|F&J|0,(x|l)^(v|K)^(b|I)|0,t^(n|D)|0)|0;t=D;u=go(r|0,u|0,p|0,L|0)|0;r=D;c[A>>2]=u;c[A+4>>2]=r;L=go(n|0,t|0,p|0,L|0)|0;p=D;c[C>>2]=L;c[C+4>>2]=p;t=Mm(u|0,r|0,14)|0;n=D;I=Km(u|0,r|0,50)|0;n=n|D;b=Mm(u|0,r|0,18)|0;K=D;v=Km(u|0,r|0,46)|0;K=n^(K|D);n=Mm(u|0,r|0,41)|0;l=D;x=Km(u|0,r|0,23)|0;l=K^(l|D);K=c[h+80+120>>2]|0;J=c[h+80+120+4>>2]|0;j=go(e|0,j|0,-815192428,-1046744716)|0;l=go(j|0,D|0,(t|I)^(b|v)^(n|x)|0,l|0)|0;J=go(l|0,D|0,K|0,J|0)|0;J=go(J|0,D|0,(o^z)&u^o|0,(y^f)&r^y|0)|0;K=D;l=Mm(L|0,p|0,28)|0;x=D;n=Km(L|0,p|0,36)|0;x=x|D;v=Mm(L|0,p|0,34)|0;b=D;I=Km(L|0,p|0,30)|0;b=x^(b|D);x=Mm(L|0,p|0,39)|0;t=D;j=Km(L|0,p|0,25)|0;e=c[m>>2]|0;s=c[m+4>>2]|0;t=go((e|q)&L|e&q|0,(s|H)&p|s&H|0,(l|n)^(v|I)^(x|j)|0,b^(t|D)|0)|0;b=D;F=go(E|0,F|0,J|0,K|0)|0;E=D;c[w>>2]=F;c[w+4>>2]=E;K=go(t|0,b|0,J|0,K|0)|0;J=D;c[h+16>>2]=K;c[h+16+4>>2]=J;b=Mm(F|0,E|0,14)|0;t=D;j=Km(F|0,E|0,50)|0;t=t|D;x=Mm(F|0,E|0,18)|0;I=D;v=Km(F|0,E|0,46)|0;I=t^(I|D);t=Mm(F|0,E|0,41)|0;n=D;l=Km(F|0,E|0,23)|0;n=I^(n|D);I=c[h+80+128>>2]|0;H=c[h+80+128+4>>2]|0;y=go(o|0,y|0,-1628353838,-459576895)|0;n=go(y|0,D|0,(b|j)^(x|v)^(t|l)|0,n|0)|0;H=go(n|0,D|0,I|0,H|0)|0;H=go(H|0,D|0,(z^u)&F^z|0,(f^r)&E^f|0)|0;I=D;n=Mm(K|0,J|0,28)|0;l=D;t=Km(K|0,J|0,36)|0;l=l|D;v=Mm(K|0,J|0,34)|0;x=D;j=Km(K|0,J|0,30)|0;x=l^(x|D);l=Mm(K|0,J|0,39)|0;b=D;y=Km(K|0,J|0,25)|0;o=c[B>>2]|0;q=c[B+4>>2]|0;b=go((o|L)&K|o&L|0,(q|p)&J|q&p|0,(n|t)^(v|j)^(l|y)|0,x^(b|D)|0)|0;x=D;s=go(e|0,s|0,H|0,I|0)|0;e=D;c[m>>2]=s;c[m+4>>2]=e;I=go(b|0,x|0,H|0,I|0)|0;H=D;c[G>>2]=I;c[G+4>>2]=H;x=Mm(s|0,e|0,14)|0;b=D;y=Km(s|0,e|0,50)|0;b=b|D;l=Mm(s|0,e|0,18)|0;j=D;v=Km(s|0,e|0,46)|0;j=b^(j|D);b=Mm(s|0,e|0,41)|0;t=D;n=Km(s|0,e|0,23)|0;t=j^(t|D);j=c[h+80+136>>2]|0;p=c[h+80+136+4>>2]|0;f=go(z|0,f|0,944711139,-272742522)|0;t=go(f|0,D|0,(x|y)^(l|v)^(b|n)|0,t|0)|0;p=go(t|0,D|0,j|0,p|0)|0;p=go(p|0,D|0,(u^F)&s^u|0,(r^E)&e^r|0)|0;j=D;t=Mm(I|0,H|0,28)|0;n=D;b=Km(I|0,H|0,36)|0;n=n|D;v=Mm(I|0,H|0,34)|0;l=D;y=Km(I|0,H|0,30)|0;l=n^(l|D);n=Mm(I|0,H|0,39)|0;x=D;f=Km(I|0,H|0,25)|0;z=c[C>>2]|0;L=c[C+4>>2]|0;x=go((z|K)&I|z&K|0,(L|J)&H|L&J|0,(t|b)^(v|y)^(n|f)|0,l^(x|D)|0)|0;l=D;q=go(o|0,q|0,p|0,j|0)|0;o=D;c[B>>2]=q;c[B+4>>2]=o;j=go(x|0,l|0,p|0,j|0)|0;p=D;c[k>>2]=j;c[k+4>>2]=p;l=Mm(q|0,o|0,14)|0;x=D;f=Km(q|0,o|0,50)|0;x=x|D;n=Mm(q|0,o|0,18)|0;y=D;v=Km(q|0,o|0,46)|0;y=x^(y|D);x=Mm(q|0,o|0,41)|0;b=D;t=Km(q|0,o|0,23)|0;b=y^(b|D);y=c[h+80+144>>2]|0;J=c[h+80+144+4>>2]|0;r=go(u|0,r|0,-1953704523,264347078)|0;b=go(r|0,D|0,(l|f)^(n|v)^(x|t)|0,b|0)|0;J=go(b|0,D|0,y|0,J|0)|0;J=go(J|0,D|0,(F^s)&q^F|0,(E^e)&o^E|0)|0;y=D;b=Mm(j|0,p|0,28)|0;t=D;x=Km(j|0,p|0,36)|0;t=t|D;v=Mm(j|0,p|0,34)|0;n=D;f=Km(j|0,p|0,30)|0;n=t^(n|D);t=Mm(j|0,p|0,39)|0;l=D;r=Km(j|0,p|0,25)|0;u=c[h+16>>2]|0;K=c[h+16+4>>2]|0;l=go((u|I)&j|u&I|0,(K|H)&p|K&H|0,(b|x)^(v|f)^(t|r)|0,n^(l|D)|0)|0;n=D;L=go(z|0,L|0,J|0,y|0)|0;z=D;c[C>>2]=L;c[C+4>>2]=z;y=go(l|0,n|0,J|0,y|0)|0;J=D;c[A>>2]=y;c[A+4>>2]=J;n=Mm(L|0,z|0,14)|0;l=D;r=Km(L|0,z|0,50)|0;l=l|D;t=Mm(L|0,z|0,18)|0;f=D;v=Km(L|0,z|0,46)|0;f=l^(f|D);l=Mm(L|0,z|0,41)|0;x=D;b=Km(L|0,z|0,23)|0;x=f^(x|D);f=c[h+80+152>>2]|0;H=c[h+80+152+4>>2]|0;E=go(F|0,E|0,2007800933,604807628)|0;x=go(E|0,D|0,(n|r)^(t|v)^(l|b)|0,x|0)|0;H=go(x|0,D|0,f|0,H|0)|0;H=go(H|0,D|0,(s^q)&L^s|0,(e^o)&z^e|0)|0;f=D;x=Mm(y|0,J|0,28)|0;b=D;l=Km(y|0,J|0,36)|0;b=b|D;v=Mm(y|0,J|0,34)|0;t=D;r=Km(y|0,J|0,30)|0;t=b^(t|D);b=Mm(y|0,J|0,39)|0;n=D;E=Km(y|0,J|0,25)|0;F=c[G>>2]|0;I=c[G+4>>2]|0;n=go((F|j)&y|F&j|0,(I|p)&J|I&p|0,(x|l)^(v|r)^(b|E)|0,t^(n|D)|0)|0;t=D;K=go(u|0,K|0,H|0,f|0)|0;u=D;c[h+16>>2]=K;c[h+16+4>>2]=u;f=go(n|0,t|0,H|0,f|0)|0;H=D;c[w>>2]=f;c[w+4>>2]=H;t=Mm(K|0,u|0,14)|0;n=D;E=Km(K|0,u|0,50)|0;n=n|D;b=Mm(K|0,u|0,18)|0;r=D;v=Km(K|0,u|0,46)|0;r=n^(r|D);n=Mm(K|0,u|0,41)|0;l=D;x=Km(K|0,u|0,23)|0;l=r^(l|D);r=c[h+80+160>>2]|0;p=c[h+80+160+4>>2]|0;e=go(s|0,e|0,1495990901,770255983)|0;l=go(e|0,D|0,(t|E)^(b|v)^(n|x)|0,l|0)|0;p=go(l|0,D|0,r|0,p|0)|0;p=go(p|0,D|0,(q^L)&K^q|0,(o^z)&u^o|0)|0;r=D;l=Mm(f|0,H|0,28)|0;x=D;n=Km(f|0,H|0,36)|0;x=x|D;v=Mm(f|0,H|0,34)|0;b=D;E=Km(f|0,H|0,30)|0;b=x^(b|D);x=Mm(f|0,H|0,39)|0;t=D;e=Km(f|0,H|0,25)|0;s=c[k>>2]|0;j=c[k+4>>2]|0;t=go((s|y)&f|s&y|0,(j|J)&H|j&J|0,(l|n)^(v|E)^(x|e)|0,b^(t|D)|0)|0;b=D;I=go(F|0,I|0,p|0,r|0)|0;F=D;c[G>>2]=I;c[G+4>>2]=F;r=go(t|0,b|0,p|0,r|0)|0;p=D;c[m>>2]=r;c[m+4>>2]=p;b=Mm(I|0,F|0,14)|0;t=D;e=Km(I|0,F|0,50)|0;t=t|D;x=Mm(I|0,F|0,18)|0;E=D;v=Km(I|0,F|0,46)|0;E=t^(E|D);t=Mm(I|0,F|0,41)|0;n=D;l=Km(I|0,F|0,23)|0;n=E^(n|D);E=c[h+80+168>>2]|0;J=c[h+80+168+4>>2]|0;o=go(q|0,o|0,1856431235,1249150122)|0;n=go(o|0,D|0,(b|e)^(x|v)^(t|l)|0,n|0)|0;J=go(n|0,D|0,E|0,J|0)|0;J=go(J|0,D|0,(L^K)&I^L|0,(z^u)&F^z|0)|0;E=D;n=Mm(r|0,p|0,28)|0;l=D;t=Km(r|0,p|0,36)|0;l=l|D;v=Mm(r|0,p|0,34)|0;x=D;e=Km(r|0,p|0,30)|0;x=l^(x|D);l=Mm(r|0,p|0,39)|0;b=D;o=Km(r|0,p|0,25)|0;q=c[A>>2]|0;y=c[A+4>>2]|0;b=go((q|f)&r|q&f|0,(y|H)&p|y&H|0,(n|t)^(v|e)^(l|o)|0,x^(b|D)|0)|0;x=D;j=go(s|0,j|0,J|0,E|0)|0;s=D;c[k>>2]=j;c[k+4>>2]=s;E=go(b|0,x|0,J|0,E|0)|0;J=D;c[B>>2]=E;c[B+4>>2]=J;x=Mm(j|0,s|0,14)|0;b=D;o=Km(j|0,s|0,50)|0;b=b|D;l=Mm(j|0,s|0,18)|0;e=D;v=Km(j|0,s|0,46)|0;e=b^(e|D);b=Mm(j|0,s|0,41)|0;t=D;n=Km(j|0,s|0,23)|0;t=e^(t|D);e=c[h+80+176>>2]|0;H=c[h+80+176+4>>2]|0;z=go(L|0,z|0,-1119749164,1555081692)|0;t=go(z|0,D|0,(x|o)^(l|v)^(b|n)|0,t|0)|0;H=go(t|0,D|0,e|0,H|0)|0;H=go(H|0,D|0,(K^I)&j^K|0,(u^F)&s^u|0)|0;e=D;t=Mm(E|0,J|0,28)|0;n=D;b=Km(E|0,J|0,36)|0;n=n|D;v=Mm(E|0,J|0,34)|0;l=D;o=Km(E|0,J|0,30)|0;l=n^(l|D);n=Mm(E|0,J|0,39)|0;x=D;z=Km(E|0,J|0,25)|0;L=c[w>>2]|0;f=c[w+4>>2]|0;x=go((L|r)&E|L&r|0,(f|p)&J|f&p|0,(t|b)^(v|o)^(n|z)|0,l^(x|D)|0)|0;l=D;y=go(q|0,y|0,H|0,e|0)|0;q=D;c[A>>2]=y;c[A+4>>2]=q;e=go(x|0,l|0,H|0,e|0)|0;H=D;c[C>>2]=e;c[C+4>>2]=H;l=Mm(y|0,q|0,14)|0;x=D;z=Km(y|0,q|0,50)|0;x=x|D;n=Mm(y|0,q|0,18)|0;o=D;v=Km(y|0,q|0,46)|0;o=x^(o|D);x=Mm(y|0,q|0,41)|0;b=D;t=Km(y|0,q|0,23)|0;b=o^(b|D);o=c[h+80+184>>2]|0;p=c[h+80+184+4>>2]|0;u=go(K|0,u|0,-2096016459,1996064986)|0;b=go(u|0,D|0,(l|z)^(n|v)^(x|t)|0,b|0)|0;p=go(b|0,D|0,o|0,p|0)|0;p=go(p|0,D|0,(I^j)&y^I|0,(F^s)&q^F|0)|0;o=D;b=Mm(e|0,H|0,28)|0;t=D;x=Km(e|0,H|0,36)|0;t=t|D;v=Mm(e|0,H|0,34)|0;n=D;z=Km(e|0,H|0,30)|0;n=t^(n|D);t=Mm(e|0,H|0,39)|0;l=D;u=Km(e|0,H|0,25)|0;K=c[m>>2]|0;r=c[m+4>>2]|0;l=go((K|E)&e|K&E|0,(r|J)&H|r&J|0,(b|x)^(v|z)^(t|u)|0,n^(l|D)|0)|0;n=D;f=go(L|0,f|0,p|0,o|0)|0;L=D;c[w>>2]=f;c[w+4>>2]=L;o=go(l|0,n|0,p|0,o|0)|0;p=D;c[h+16>>2]=o;c[h+16+4>>2]=p;n=Mm(f|0,L|0,14)|0;l=D;u=Km(f|0,L|0,50)|0;l=l|D;t=Mm(f|0,L|0,18)|0;z=D;v=Km(f|0,L|0,46)|0;z=l^(z|D);l=Mm(f|0,L|0,41)|0;x=D;b=Km(f|0,L|0,23)|0;x=z^(x|D);z=c[h+80+192>>2]|0;J=c[h+80+192+4>>2]|0;F=go(I|0,F|0,-295247957,-1740746414)|0;x=go(F|0,D|0,(n|u)^(t|v)^(l|b)|0,x|0)|0;J=go(x|0,D|0,z|0,J|0)|0;J=go(J|0,D|0,(j^y)&f^j|0,(s^q)&L^s|0)|0;z=D;x=Mm(o|0,p|0,28)|0;b=D;l=Km(o|0,p|0,36)|0;b=b|D;v=Mm(o|0,p|0,34)|0;t=D;u=Km(o|0,p|0,30)|0;t=b^(t|D);b=Mm(o|0,p|0,39)|0;n=D;F=Km(o|0,p|0,25)|0;I=c[B>>2]|0;E=c[B+4>>2]|0;n=go((I|e)&o|I&e|0,(E|H)&p|E&H|0,(x|l)^(v|u)^(b|F)|0,t^(n|D)|0)|0;t=D;r=go(K|0,r|0,J|0,z|0)|0;K=D;c[m>>2]=r;c[m+4>>2]=K;z=go(n|0,t|0,J|0,z|0)|0;J=D;c[G>>2]=z;c[G+4>>2]=J;t=Mm(r|0,K|0,14)|0;n=D;F=Km(r|0,K|0,50)|0;n=n|D;b=Mm(r|0,K|0,18)|0;u=D;v=Km(r|0,K|0,46)|0;u=n^(u|D);n=Mm(r|0,K|0,41)|0;l=D;x=Km(r|0,K|0,23)|0;l=u^(l|D);u=c[h+80+200>>2]|0;H=c[h+80+200+4>>2]|0;s=go(j|0,s|0,766784016,-1473132947)|0;l=go(s|0,D|0,(t|F)^(b|v)^(n|x)|0,l|0)|0;H=go(l|0,D|0,u|0,H|0)|0;H=go(H|0,D|0,(y^f)&r^y|0,(q^L)&K^q|0)|0;u=D;l=Mm(z|0,J|0,28)|0;x=D;n=Km(z|0,J|0,36)|0;x=x|D;v=Mm(z|0,J|0,34)|0;b=D;F=Km(z|0,J|0,30)|0;b=x^(b|D);x=Mm(z|0,J|0,39)|0;t=D;s=Km(z|0,J|0,25)|0;j=c[C>>2]|0;e=c[C+4>>2]|0;t=go((j|o)&z|j&o|0,(e|p)&J|e&p|0,(l|n)^(v|F)^(x|s)|0,b^(t|D)|0)|0;b=D;E=go(I|0,E|0,H|0,u|0)|0;I=D;c[B>>2]=E;c[B+4>>2]=I;u=go(t|0,b|0,H|0,u|0)|0;H=D;c[k>>2]=u;c[k+4>>2]=H;b=Mm(E|0,I|0,14)|0;t=D;s=Km(E|0,I|0,50)|0;t=t|D;x=Mm(E|0,I|0,18)|0;F=D;v=Km(E|0,I|0,46)|0;F=t^(F|D);t=Mm(E|0,I|0,41)|0;n=D;l=Km(E|0,I|0,23)|0;n=F^(n|D);F=c[h+80+208>>2]|0;p=c[h+80+208+4>>2]|0;q=go(y|0,q|0,-1728372417,-1341970488)|0;n=go(q|0,D|0,(b|s)^(x|v)^(t|l)|0,n|0)|0;p=go(n|0,D|0,F|0,p|0)|0;p=go(p|0,D|0,(f^r)&E^f|0,(L^K)&I^L|0)|0;F=D;n=Mm(u|0,H|0,28)|0;l=D;t=Km(u|0,H|0,36)|0;l=l|D;v=Mm(u|0,H|0,34)|0;x=D;s=Km(u|0,H|0,30)|0;x=l^(x|D);l=Mm(u|0,H|0,39)|0;b=D;q=Km(u|0,H|0,25)|0;y=c[h+16>>2]|0;o=c[h+16+4>>2]|0;b=go((y|z)&u|y&z|0,(o|J)&H|o&J|0,(n|t)^(v|s)^(l|q)|0,x^(b|D)|0)|0;x=D;e=go(j|0,e|0,p|0,F|0)|0;j=D;c[C>>2]=e;c[C+4>>2]=j;F=go(b|0,x|0,p|0,F|0)|0;p=D;c[A>>2]=F;c[A+4>>2]=p;x=Mm(e|0,j|0,14)|0;b=D;q=Km(e|0,j|0,50)|0;b=b|D;l=Mm(e|0,j|0,18)|0;s=D;v=Km(e|0,j|0,46)|0;s=b^(s|D);b=Mm(e|0,j|0,41)|0;t=D;n=Km(e|0,j|0,23)|0;t=s^(t|D);s=c[h+80+216>>2]|0;J=c[h+80+216+4>>2]|0;L=go(f|0,L|0,-1091629340,-1084653625)|0;t=go(L|0,D|0,(x|q)^(l|v)^(b|n)|0,t|0)|0;J=go(t|0,D|0,s|0,J|0)|0;J=go(J|0,D|0,(r^E)&e^r|0,(K^I)&j^K|0)|0;s=D;t=Mm(F|0,p|0,28)|0;n=D;b=Km(F|0,p|0,36)|0;n=n|D;v=Mm(F|0,p|0,34)|0;l=D;q=Km(F|0,p|0,30)|0;l=n^(l|D);n=Mm(F|0,p|0,39)|0;x=D;L=Km(F|0,p|0,25)|0;f=c[G>>2]|0;z=c[G+4>>2]|0;x=go((f|u)&F|f&u|0,(z|H)&p|z&H|0,(t|b)^(v|q)^(n|L)|0,l^(x|D)|0)|0;l=D;o=go(y|0,o|0,J|0,s|0)|0;y=D;c[h+16>>2]=o;c[h+16+4>>2]=y;s=go(x|0,l|0,J|0,s|0)|0;J=D;c[w>>2]=s;c[w+4>>2]=J;l=Mm(o|0,y|0,14)|0;x=D;L=Km(o|0,y|0,50)|0;x=x|D;n=Mm(o|0,y|0,18)|0;q=D;v=Km(o|0,y|0,46)|0;q=x^(q|D);x=Mm(o|0,y|0,41)|0;b=D;t=Km(o|0,y|0,23)|0;b=q^(b|D);q=c[h+80+224>>2]|0;H=c[h+80+224+4>>2]|0;K=go(r|0,K|0,1034457026,-958395405)|0;b=go(K|0,D|0,(l|L)^(n|v)^(x|t)|0,b|0)|0;H=go(b|0,D|0,q|0,H|0)|0;H=go(H|0,D|0,(E^e)&o^E|0,(I^j)&y^I|0)|0;q=D;b=Mm(s|0,J|0,28)|0;t=D;x=Km(s|0,J|0,36)|0;t=t|D;v=Mm(s|0,J|0,34)|0;n=D;L=Km(s|0,J|0,30)|0;n=t^(n|D);t=Mm(s|0,J|0,39)|0;l=D;K=Km(s|0,J|0,25)|0;r=c[k>>2]|0;u=c[k+4>>2]|0;l=go((r|F)&s|r&F|0,(u|p)&J|u&p|0,(b|x)^(v|L)^(t|K)|0,n^(l|D)|0)|0;n=D;z=go(f|0,z|0,H|0,q|0)|0;f=D;c[G>>2]=z;c[G+4>>2]=f;q=go(l|0,n|0,H|0,q|0)|0;H=D;c[m>>2]=q;c[m+4>>2]=H;n=Mm(z|0,f|0,14)|0;l=D;K=Km(z|0,f|0,50)|0;l=l|D;t=Mm(z|0,f|0,18)|0;L=D;v=Km(z|0,f|0,46)|0;L=l^(L|D);l=Mm(z|0,f|0,41)|0;x=D;b=Km(z|0,f|0,23)|0;x=L^(x|D);L=c[h+80+232>>2]|0;p=c[h+80+232+4>>2]|0;I=go(E|0,I|0,-1828018395,-710438585)|0;x=go(I|0,D|0,(n|K)^(t|v)^(l|b)|0,x|0)|0;p=go(x|0,D|0,L|0,p|0)|0;p=go(p|0,D|0,(e^o)&z^e|0,(j^y)&f^j|0)|0;L=D;x=Mm(q|0,H|0,28)|0;b=D;l=Km(q|0,H|0,36)|0;b=b|D;v=Mm(q|0,H|0,34)|0;t=D;K=Km(q|0,H|0,30)|0;t=b^(t|D);b=Mm(q|0,H|0,39)|0;n=D;I=Km(q|0,H|0,25)|0;E=c[A>>2]|0;F=c[A+4>>2]|0;n=go((E|s)&q|E&s|0,(F|J)&H|F&J|0,(x|l)^(v|K)^(b|I)|0,t^(n|D)|0)|0;t=D;u=go(r|0,u|0,p|0,L|0)|0;r=D;c[k>>2]=u;c[k+4>>2]=r;L=go(n|0,t|0,p|0,L|0)|0;p=D;c[B>>2]=L;c[B+4>>2]=p;t=Mm(u|0,r|0,14)|0;n=D;I=Km(u|0,r|0,50)|0;n=n|D;b=Mm(u|0,r|0,18)|0;K=D;v=Km(u|0,r|0,46)|0;K=n^(K|D);n=Mm(u|0,r|0,41)|0;l=D;x=Km(u|0,r|0,23)|0;l=K^(l|D);K=c[h+80+240>>2]|0;J=c[h+80+240+4>>2]|0;j=go(e|0,j|0,-536640913,113926993)|0;l=go(j|0,D|0,(t|I)^(b|v)^(n|x)|0,l|0)|0;J=go(l|0,D|0,K|0,J|0)|0;J=go(J|0,D|0,(o^z)&u^o|0,(y^f)&r^y|0)|0;K=D;l=Mm(L|0,p|0,28)|0;x=D;n=Km(L|0,p|0,36)|0;x=x|D;v=Mm(L|0,p|0,34)|0;b=D;I=Km(L|0,p|0,30)|0;b=x^(b|D);x=Mm(L|0,p|0,39)|0;t=D;j=Km(L|0,p|0,25)|0;e=c[w>>2]|0;s=c[w+4>>2]|0;t=go((e|q)&L|e&q|0,(s|H)&p|s&H|0,(l|n)^(v|I)^(x|j)|0,b^(t|D)|0)|0;b=D;F=go(E|0,F|0,J|0,K|0)|0;E=D;c[A>>2]=F;c[A+4>>2]=E;K=go(t|0,b|0,J|0,K|0)|0;J=D;c[C>>2]=K;c[C+4>>2]=J;b=Mm(F|0,E|0,14)|0;t=D;j=Km(F|0,E|0,50)|0;t=t|D;x=Mm(F|0,E|0,18)|0;I=D;v=Km(F|0,E|0,46)|0;I=t^(I|D);t=Mm(F|0,E|0,41)|0;n=D;l=Km(F|0,E|0,23)|0;n=I^(n|D);I=c[h+80+248>>2]|0;H=c[h+80+248+4>>2]|0;y=go(o|0,y|0,168717936,338241895)|0;n=go(y|0,D|0,(b|j)^(x|v)^(t|l)|0,n|0)|0;H=go(n|0,D|0,I|0,H|0)|0;H=go(H|0,D|0,(z^u)&F^z|0,(f^r)&E^f|0)|0;I=D;n=Mm(K|0,J|0,28)|0;l=D;t=Km(K|0,J|0,36)|0;l=l|D;v=Mm(K|0,J|0,34)|0;x=D;j=Km(K|0,J|0,30)|0;x=l^(x|D);l=Mm(K|0,J|0,39)|0;b=D;y=Km(K|0,J|0,25)|0;o=c[m>>2]|0;q=c[m+4>>2]|0;b=go((o|L)&K|o&L|0,(q|p)&J|q&p|0,(n|t)^(v|j)^(l|y)|0,x^(b|D)|0)|0;x=D;s=go(e|0,s|0,H|0,I|0)|0;e=D;c[w>>2]=s;c[w+4>>2]=e;I=go(b|0,x|0,H|0,I|0)|0;H=D;c[h+16>>2]=I;c[h+16+4>>2]=H;x=Mm(s|0,e|0,14)|0;b=D;y=Km(s|0,e|0,50)|0;b=b|D;l=Mm(s|0,e|0,18)|0;j=D;v=Km(s|0,e|0,46)|0;j=b^(j|D);b=Mm(s|0,e|0,41)|0;t=D;n=Km(s|0,e|0,23)|0;t=j^(t|D);j=c[h+80+256>>2]|0;p=c[h+80+256+4>>2]|0;f=go(z|0,f|0,1188179964,666307205)|0;t=go(f|0,D|0,(x|y)^(l|v)^(b|n)|0,t|0)|0;p=go(t|0,D|0,j|0,p|0)|0;p=go(p|0,D|0,(u^F)&s^u|0,(r^E)&e^r|0)|0;j=D;t=Mm(I|0,H|0,28)|0;n=D;b=Km(I|0,H|0,36)|0;n=n|D;v=Mm(I|0,H|0,34)|0;l=D;y=Km(I|0,H|0,30)|0;l=n^(l|D);n=Mm(I|0,H|0,39)|0;x=D;f=Km(I|0,H|0,25)|0;z=c[B>>2]|0;L=c[B+4>>2]|0;x=go((z|K)&I|z&K|0,(L|J)&H|L&J|0,(t|b)^(v|y)^(n|f)|0,l^(x|D)|0)|0;l=D;q=go(o|0,q|0,p|0,j|0)|0;o=D;c[m>>2]=q;c[m+4>>2]=o;j=go(x|0,l|0,p|0,j|0)|0;p=D;c[G>>2]=j;c[G+4>>2]=p;l=Mm(q|0,o|0,14)|0;x=D;f=Km(q|0,o|0,50)|0;x=x|D;n=Mm(q|0,o|0,18)|0;y=D;v=Km(q|0,o|0,46)|0;y=x^(y|D);x=Mm(q|0,o|0,41)|0;b=D;t=Km(q|0,o|0,23)|0;b=y^(b|D);y=c[h+80+264>>2]|0;J=c[h+80+264+4>>2]|0;r=go(u|0,r|0,1546045734,773529912)|0;b=go(r|0,D|0,(l|f)^(n|v)^(x|t)|0,b|0)|0;J=go(b|0,D|0,y|0,J|0)|0;J=go(J|0,D|0,(F^s)&q^F|0,(E^e)&o^E|0)|0;y=D;b=Mm(j|0,p|0,28)|0;t=D;x=Km(j|0,p|0,36)|0;t=t|D;v=Mm(j|0,p|0,34)|0;n=D;f=Km(j|0,p|0,30)|0;n=t^(n|D);t=Mm(j|0,p|0,39)|0;l=D;r=Km(j|0,p|0,25)|0;u=c[C>>2]|0;K=c[C+4>>2]|0;l=go((u|I)&j|u&I|0,(K|H)&p|K&H|0,(b|x)^(v|f)^(t|r)|0,n^(l|D)|0)|0;n=D;L=go(z|0,L|0,J|0,y|0)|0;z=D;c[B>>2]=L;c[B+4>>2]=z;y=go(l|0,n|0,J|0,y|0)|0;J=D;c[k>>2]=y;c[k+4>>2]=J;n=Mm(L|0,z|0,14)|0;l=D;r=Km(L|0,z|0,50)|0;l=l|D;t=Mm(L|0,z|0,18)|0;f=D;v=Km(L|0,z|0,46)|0;f=l^(f|D);l=Mm(L|0,z|0,41)|0;x=D;b=Km(L|0,z|0,23)|0;x=f^(x|D);f=c[h+80+272>>2]|0;H=c[h+80+272+4>>2]|0;E=go(F|0,E|0,1522805485,1294757372)|0;x=go(E|0,D|0,(n|r)^(t|v)^(l|b)|0,x|0)|0;H=go(x|0,D|0,f|0,H|0)|0;H=go(H|0,D|0,(s^q)&L^s|0,(e^o)&z^e|0)|0;f=D;x=Mm(y|0,J|0,28)|0;b=D;l=Km(y|0,J|0,36)|0;b=b|D;v=Mm(y|0,J|0,34)|0;t=D;r=Km(y|0,J|0,30)|0;t=b^(t|D);b=Mm(y|0,J|0,39)|0;n=D;E=Km(y|0,J|0,25)|0;F=c[h+16>>2]|0;I=c[h+16+4>>2]|0;n=go((F|j)&y|F&j|0,(I|p)&J|I&p|0,(x|l)^(v|r)^(b|E)|0,t^(n|D)|0)|0;t=D;K=go(u|0,K|0,H|0,f|0)|0;u=D;c[C>>2]=K;c[C+4>>2]=u;f=go(n|0,t|0,H|0,f|0)|0;H=D;c[A>>2]=f;c[A+4>>2]=H;t=Mm(K|0,u|0,14)|0;n=D;E=Km(K|0,u|0,50)|0;n=n|D;b=Mm(K|0,u|0,18)|0;r=D;v=Km(K|0,u|0,46)|0;r=n^(r|D);n=Mm(K|0,u|0,41)|0;l=D;x=Km(K|0,u|0,23)|0;l=r^(l|D);r=c[h+80+280>>2]|0;p=c[h+80+280+4>>2]|0;e=go(s|0,e|0,-1651133473,1396182291)|0;l=go(e|0,D|0,(t|E)^(b|v)^(n|x)|0,l|0)|0;p=go(l|0,D|0,r|0,p|0)|0;p=go(p|0,D|0,(q^L)&K^q|0,(o^z)&u^o|0)|0;r=D;l=Mm(f|0,H|0,28)|0;x=D;n=Km(f|0,H|0,36)|0;x=x|D;v=Mm(f|0,H|0,34)|0;b=D;E=Km(f|0,H|0,30)|0;b=x^(b|D);x=Mm(f|0,H|0,39)|0;t=D;e=Km(f|0,H|0,25)|0;s=c[G>>2]|0;j=c[G+4>>2]|0;t=go((s|y)&f|s&y|0,(j|J)&H|j&J|0,(l|n)^(v|E)^(x|e)|0,b^(t|D)|0)|0;b=D;I=go(F|0,I|0,p|0,r|0)|0;F=D;c[h+16>>2]=I;c[h+16+4>>2]=F;r=go(t|0,b|0,p|0,r|0)|0;p=D;c[w>>2]=r;c[w+4>>2]=p;b=Mm(I|0,F|0,14)|0;t=D;e=Km(I|0,F|0,50)|0;t=t|D;x=Mm(I|0,F|0,18)|0;E=D;v=Km(I|0,F|0,46)|0;E=t^(E|D);t=Mm(I|0,F|0,41)|0;n=D;l=Km(I|0,F|0,23)|0;n=E^(n|D);E=c[h+80+288>>2]|0;J=c[h+80+288+4>>2]|0;o=go(q|0,o|0,-1951439906,1695183700)|0;n=go(o|0,D|0,(b|e)^(x|v)^(t|l)|0,n|0)|0;J=go(n|0,D|0,E|0,J|0)|0;J=go(J|0,D|0,(L^K)&I^L|0,(z^u)&F^z|0)|0;E=D;n=Mm(r|0,p|0,28)|0;l=D;t=Km(r|0,p|0,36)|0;l=l|D;v=Mm(r|0,p|0,34)|0;x=D;e=Km(r|0,p|0,30)|0;x=l^(x|D);l=Mm(r|0,p|0,39)|0;b=D;o=Km(r|0,p|0,25)|0;q=c[k>>2]|0;y=c[k+4>>2]|0;b=go((q|f)&r|q&f|0,(y|H)&p|y&H|0,(n|t)^(v|e)^(l|o)|0,x^(b|D)|0)|0;x=D;j=go(s|0,j|0,J|0,E|0)|0;s=D;c[G>>2]=j;c[G+4>>2]=s;E=go(b|0,x|0,J|0,E|0)|0;J=D;c[m>>2]=E;c[m+4>>2]=J;x=Mm(j|0,s|0,14)|0;b=D;o=Km(j|0,s|0,50)|0;b=b|D;l=Mm(j|0,s|0,18)|0;e=D;v=Km(j|0,s|0,46)|0;e=b^(e|D);b=Mm(j|0,s|0,41)|0;t=D;n=Km(j|0,s|0,23)|0;t=e^(t|D);e=c[h+80+296>>2]|0;H=c[h+80+296+4>>2]|0;z=go(L|0,z|0,1014477480,1986661051)|0;t=go(z|0,D|0,(x|o)^(l|v)^(b|n)|0,t|0)|0;H=go(t|0,D|0,e|0,H|0)|0;H=go(H|0,D|0,(K^I)&j^K|0,(u^F)&s^u|0)|0;e=D;t=Mm(E|0,J|0,28)|0;n=D;b=Km(E|0,J|0,36)|0;n=n|D;v=Mm(E|0,J|0,34)|0;l=D;o=Km(E|0,J|0,30)|0;l=n^(l|D);n=Mm(E|0,J|0,39)|0;x=D;z=Km(E|0,J|0,25)|0;L=c[A>>2]|0;f=c[A+4>>2]|0;x=go((L|r)&E|L&r|0,(f|p)&J|f&p|0,(t|b)^(v|o)^(n|z)|0,l^(x|D)|0)|0;l=D;y=go(q|0,y|0,H|0,e|0)|0;q=D;c[k>>2]=y;c[k+4>>2]=q;e=go(x|0,l|0,H|0,e|0)|0;H=D;c[B>>2]=e;c[B+4>>2]=H;l=Mm(y|0,q|0,14)|0;x=D;z=Km(y|0,q|0,50)|0;x=x|D;n=Mm(y|0,q|0,18)|0;o=D;v=Km(y|0,q|0,46)|0;o=x^(o|D);x=Mm(y|0,q|0,41)|0;b=D;t=Km(y|0,q|0,23)|0;b=o^(b|D);o=c[h+80+304>>2]|0;p=c[h+80+304+4>>2]|0;u=go(K|0,u|0,1206759142,-2117940946)|0;b=go(u|0,D|0,(l|z)^(n|v)^(x|t)|0,b|0)|0;p=go(b|0,D|0,o|0,p|0)|0;p=go(p|0,D|0,(I^j)&y^I|0,(F^s)&q^F|0)|0;o=D;b=Mm(e|0,H|0,28)|0;t=D;x=Km(e|0,H|0,36)|0;t=t|D;v=Mm(e|0,H|0,34)|0;n=D;z=Km(e|0,H|0,30)|0;n=t^(n|D);t=Mm(e|0,H|0,39)|0;l=D;u=Km(e|0,H|0,25)|0;K=c[w>>2]|0;r=c[w+4>>2]|0;l=go((K|E)&e|K&E|0,(r|J)&H|r&J|0,(b|x)^(v|z)^(t|u)|0,n^(l|D)|0)|0;n=D;f=go(L|0,f|0,p|0,o|0)|0;L=D;c[A>>2]=f;c[A+4>>2]=L;o=go(l|0,n|0,p|0,o|0)|0;p=D;c[C>>2]=o;c[C+4>>2]=p;n=Mm(f|0,L|0,14)|0;l=D;u=Km(f|0,L|0,50)|0;l=l|D;t=Mm(f|0,L|0,18)|0;z=D;v=Km(f|0,L|0,46)|0;z=l^(z|D);l=Mm(f|0,L|0,41)|0;x=D;b=Km(f|0,L|0,23)|0;x=z^(x|D);z=c[h+80+312>>2]|0;J=c[h+80+312+4>>2]|0;F=go(I|0,F|0,344077627,-1838011259)|0;x=go(F|0,D|0,(n|u)^(t|v)^(l|b)|0,x|0)|0;J=go(x|0,D|0,z|0,J|0)|0;J=go(J|0,D|0,(j^y)&f^j|0,(s^q)&L^s|0)|0;z=D;x=Mm(o|0,p|0,28)|0;b=D;l=Km(o|0,p|0,36)|0;b=b|D;v=Mm(o|0,p|0,34)|0;t=D;u=Km(o|0,p|0,30)|0;t=b^(t|D);b=Mm(o|0,p|0,39)|0;n=D;F=Km(o|0,p|0,25)|0;I=c[m>>2]|0;E=c[m+4>>2]|0;n=go((I|e)&o|I&e|0,(E|H)&p|E&H|0,(x|l)^(v|u)^(b|F)|0,t^(n|D)|0)|0;t=D;r=go(K|0,r|0,J|0,z|0)|0;K=D;c[w>>2]=r;c[w+4>>2]=K;z=go(n|0,t|0,J|0,z|0)|0;J=D;c[h+16>>2]=z;c[h+16+4>>2]=J;t=Mm(r|0,K|0,14)|0;n=D;F=Km(r|0,K|0,50)|0;n=n|D;b=Mm(r|0,K|0,18)|0;u=D;v=Km(r|0,K|0,46)|0;u=n^(u|D);n=Mm(r|0,K|0,41)|0;l=D;x=Km(r|0,K|0,23)|0;l=u^(l|D);u=c[h+80+320>>2]|0;H=c[h+80+320+4>>2]|0;s=go(j|0,s|0,1290863460,-1564481375)|0;l=go(s|0,D|0,(t|F)^(b|v)^(n|x)|0,l|0)|0;H=go(l|0,D|0,u|0,H|0)|0;H=go(H|0,D|0,(y^f)&r^y|0,(q^L)&K^q|0)|0;u=D;l=Mm(z|0,J|0,28)|0;x=D;n=Km(z|0,J|0,36)|0;x=x|D;v=Mm(z|0,J|0,34)|0;b=D;F=Km(z|0,J|0,30)|0;b=x^(b|D);x=Mm(z|0,J|0,39)|0;t=D;s=Km(z|0,J|0,25)|0;j=c[B>>2]|0;e=c[B+4>>2]|0;t=go((j|o)&z|j&o|0,(e|p)&J|e&p|0,(l|n)^(v|F)^(x|s)|0,b^(t|D)|0)|0;b=D;E=go(I|0,E|0,H|0,u|0)|0;I=D;c[m>>2]=E;c[m+4>>2]=I;u=go(t|0,b|0,H|0,u|0)|0;H=D;c[G>>2]=u;c[G+4>>2]=H;b=Mm(E|0,I|0,14)|0;t=D;s=Km(E|0,I|0,50)|0;t=t|D;x=Mm(E|0,I|0,18)|0;F=D;v=Km(E|0,I|0,46)|0;F=t^(F|D);t=Mm(E|0,I|0,41)|0;n=D;l=Km(E|0,I|0,23)|0;n=F^(n|D);F=c[h+80+328>>2]|0;p=c[h+80+328+4>>2]|0;q=go(y|0,q|0,-1136513023,-1474664885)|0;n=go(q|0,D|0,(b|s)^(x|v)^(t|l)|0,n|0)|0;p=go(n|0,D|0,F|0,p|0)|0;p=go(p|0,D|0,(f^r)&E^f|0,(L^K)&I^L|0)|0;F=D;n=Mm(u|0,H|0,28)|0;l=D;t=Km(u|0,H|0,36)|0;l=l|D;v=Mm(u|0,H|0,34)|0;x=D;s=Km(u|0,H|0,30)|0;x=l^(x|D);l=Mm(u|0,H|0,39)|0;b=D;q=Km(u|0,H|0,25)|0;y=c[C>>2]|0;o=c[C+4>>2]|0;b=go((y|z)&u|y&z|0,(o|J)&H|o&J|0,(n|t)^(v|s)^(l|q)|0,x^(b|D)|0)|0;x=D;e=go(j|0,e|0,p|0,F|0)|0;j=D;c[B>>2]=e;c[B+4>>2]=j;F=go(b|0,x|0,p|0,F|0)|0;p=D;c[k>>2]=F;c[k+4>>2]=p;x=Mm(e|0,j|0,14)|0;b=D;q=Km(e|0,j|0,50)|0;b=b|D;l=Mm(e|0,j|0,18)|0;s=D;v=Km(e|0,j|0,46)|0;s=b^(s|D);b=Mm(e|0,j|0,41)|0;t=D;n=Km(e|0,j|0,23)|0;t=s^(t|D);s=c[h+80+336>>2]|0;J=c[h+80+336+4>>2]|0;L=go(f|0,L|0,-789014639,-1035236496)|0;t=go(L|0,D|0,(x|q)^(l|v)^(b|n)|0,t|0)|0;J=go(t|0,D|0,s|0,J|0)|0;J=go(J|0,D|0,(r^E)&e^r|0,(K^I)&j^K|0)|0;s=D;t=Mm(F|0,p|0,28)|0;n=D;b=Km(F|0,p|0,36)|0;n=n|D;v=Mm(F|0,p|0,34)|0;l=D;q=Km(F|0,p|0,30)|0;l=n^(l|D);n=Mm(F|0,p|0,39)|0;x=D;L=Km(F|0,p|0,25)|0;f=c[h+16>>2]|0;z=c[h+16+4>>2]|0;x=go((f|u)&F|f&u|0,(z|H)&p|z&H|0,(t|b)^(v|q)^(n|L)|0,l^(x|D)|0)|0;l=D;o=go(y|0,o|0,J|0,s|0)|0;y=D;c[C>>2]=o;c[C+4>>2]=y;s=go(x|0,l|0,J|0,s|0)|0;J=D;c[A>>2]=s;c[A+4>>2]=J;l=Mm(o|0,y|0,14)|0;x=D;L=Km(o|0,y|0,50)|0;x=x|D;n=Mm(o|0,y|0,18)|0;q=D;v=Km(o|0,y|0,46)|0;q=x^(q|D);x=Mm(o|0,y|0,41)|0;b=D;t=Km(o|0,y|0,23)|0;b=q^(b|D);q=c[h+80+344>>2]|0;H=c[h+80+344+4>>2]|0;K=go(r|0,K|0,106217008,-949202525)|0;b=go(K|0,D|0,(l|L)^(n|v)^(x|t)|0,b|0)|0;H=go(b|0,D|0,q|0,H|0)|0;H=go(H|0,D|0,(E^e)&o^E|0,(I^j)&y^I|0)|0;q=D;b=Mm(s|0,J|0,28)|0;t=D;x=Km(s|0,J|0,36)|0;t=t|D;v=Mm(s|0,J|0,34)|0;n=D;L=Km(s|0,J|0,30)|0;n=t^(n|D);t=Mm(s|0,J|0,39)|0;l=D;K=Km(s|0,J|0,25)|0;r=c[G>>2]|0;u=c[G+4>>2]|0;l=go((r|F)&s|r&F|0,(u|p)&J|u&p|0,(b|x)^(v|L)^(t|K)|0,n^(l|D)|0)|0;n=D;z=go(f|0,z|0,H|0,q|0)|0;f=D;c[h+16>>2]=z;c[h+16+4>>2]=f;q=go(l|0,n|0,H|0,q|0)|0;H=D;c[w>>2]=q;c[w+4>>2]=H;n=Mm(z|0,f|0,14)|0;l=D;K=Km(z|0,f|0,50)|0;l=l|D;t=Mm(z|0,f|0,18)|0;L=D;v=Km(z|0,f|0,46)|0;L=l^(L|D);l=Mm(z|0,f|0,41)|0;x=D;b=Km(z|0,f|0,23)|0;x=L^(x|D);L=c[h+80+352>>2]|0;p=c[h+80+352+4>>2]|0;I=go(E|0,I|0,-688958952,-778901479)|0;x=go(I|0,D|0,(n|K)^(t|v)^(l|b)|0,x|0)|0;p=go(x|0,D|0,L|0,p|0)|0;p=go(p|0,D|0,(e^o)&z^e|0,(j^y)&f^j|0)|0;L=D;x=Mm(q|0,H|0,28)|0;b=D;l=Km(q|0,H|0,36)|0;b=b|D;v=Mm(q|0,H|0,34)|0;t=D;K=Km(q|0,H|0,30)|0;t=b^(t|D);b=Mm(q|0,H|0,39)|0;n=D;I=Km(q|0,H|0,25)|0;E=c[k>>2]|0;F=c[k+4>>2]|0;n=go((E|s)&q|E&s|0,(F|J)&H|F&J|0,(x|l)^(v|K)^(b|I)|0,t^(n|D)|0)|0;t=D;u=go(r|0,u|0,p|0,L|0)|0;r=D;c[G>>2]=u;c[G+4>>2]=r;L=go(n|0,t|0,p|0,L|0)|0;p=D;c[m>>2]=L;c[m+4>>2]=p;t=Mm(u|0,r|0,14)|0;n=D;I=Km(u|0,r|0,50)|0;n=n|D;b=Mm(u|0,r|0,18)|0;K=D;v=Km(u|0,r|0,46)|0;K=n^(K|D);n=Mm(u|0,r|0,41)|0;l=D;x=Km(u|0,r|0,23)|0;l=K^(l|D);K=c[h+80+360>>2]|0;J=c[h+80+360+4>>2]|0;j=go(e|0,j|0,1432725776,-694614492)|0;l=go(j|0,D|0,(t|I)^(b|v)^(n|x)|0,l|0)|0;J=go(l|0,D|0,K|0,J|0)|0;J=go(J|0,D|0,(o^z)&u^o|0,(y^f)&r^y|0)|0;K=D;l=Mm(L|0,p|0,28)|0;x=D;n=Km(L|0,p|0,36)|0;x=x|D;v=Mm(L|0,p|0,34)|0;b=D;I=Km(L|0,p|0,30)|0;b=x^(b|D);x=Mm(L|0,p|0,39)|0;t=D;j=Km(L|0,p|0,25)|0;e=c[A>>2]|0;s=c[A+4>>2]|0;t=go((e|q)&L|e&q|0,(s|H)&p|s&H|0,(l|n)^(v|I)^(x|j)|0,b^(t|D)|0)|0;b=D;F=go(E|0,F|0,J|0,K|0)|0;E=D;c[k>>2]=F;c[k+4>>2]=E;K=go(t|0,b|0,J|0,K|0)|0;J=D;c[B>>2]=K;c[B+4>>2]=J;b=Mm(F|0,E|0,14)|0;t=D;j=Km(F|0,E|0,50)|0;t=t|D;x=Mm(F|0,E|0,18)|0;I=D;v=Km(F|0,E|0,46)|0;I=t^(I|D);t=Mm(F|0,E|0,41)|0;n=D;l=Km(F|0,E|0,23)|0;n=I^(n|D);I=c[h+80+368>>2]|0;H=c[h+80+368+4>>2]|0;y=go(o|0,y|0,1467031594,-200395387)|0;n=go(y|0,D|0,(b|j)^(x|v)^(t|l)|0,n|0)|0;H=go(n|0,D|0,I|0,H|0)|0;H=go(H|0,D|0,(z^u)&F^z|0,(f^r)&E^f|0)|0;I=D;n=Mm(K|0,J|0,28)|0;l=D;t=Km(K|0,J|0,36)|0;l=l|D;v=Mm(K|0,J|0,34)|0;x=D;j=Km(K|0,J|0,30)|0;x=l^(x|D);l=Mm(K|0,J|0,39)|0;b=D;y=Km(K|0,J|0,25)|0;o=c[w>>2]|0;q=c[w+4>>2]|0;b=go((o|L)&K|o&L|0,(q|p)&J|q&p|0,(n|t)^(v|j)^(l|y)|0,x^(b|D)|0)|0;x=D;s=go(e|0,s|0,H|0,I|0)|0;e=D;c[A>>2]=s;c[A+4>>2]=e;I=go(b|0,x|0,H|0,I|0)|0;H=D;c[C>>2]=I;c[C+4>>2]=H;x=Mm(s|0,e|0,14)|0;b=D;y=Km(s|0,e|0,50)|0;b=b|D;l=Mm(s|0,e|0,18)|0;j=D;v=Km(s|0,e|0,46)|0;j=b^(j|D);b=Mm(s|0,e|0,41)|0;t=D;n=Km(s|0,e|0,23)|0;t=j^(t|D);j=c[h+80+376>>2]|0;p=c[h+80+376+4>>2]|0;f=go(z|0,f|0,851169720,275423344)|0;t=go(f|0,D|0,(x|y)^(l|v)^(b|n)|0,t|0)|0;p=go(t|0,D|0,j|0,p|0)|0;p=go(p|0,D|0,(u^F)&s^u|0,(r^E)&e^r|0)|0;j=D;t=Mm(I|0,H|0,28)|0;n=D;b=Km(I|0,H|0,36)|0;n=n|D;v=Mm(I|0,H|0,34)|0;l=D;y=Km(I|0,H|0,30)|0;l=n^(l|D);n=Mm(I|0,H|0,39)|0;x=D;f=Km(I|0,H|0,25)|0;z=c[m>>2]|0;L=c[m+4>>2]|0;x=go((z|K)&I|z&K|0,(L|J)&H|L&J|0,(t|b)^(v|y)^(n|f)|0,l^(x|D)|0)|0;l=D;q=go(o|0,q|0,p|0,j|0)|0;o=D;c[w>>2]=q;c[w+4>>2]=o;j=go(x|0,l|0,p|0,j|0)|0;p=D;c[h+16>>2]=j;c[h+16+4>>2]=p;l=Mm(q|0,o|0,14)|0;x=D;f=Km(q|0,o|0,50)|0;x=x|D;n=Mm(q|0,o|0,18)|0;y=D;v=Km(q|0,o|0,46)|0;y=x^(y|D);x=Mm(q|0,o|0,41)|0;b=D;t=Km(q|0,o|0,23)|0;b=y^(b|D);y=c[h+80+384>>2]|0;J=c[h+80+384+4>>2]|0;r=go(u|0,r|0,-1194143544,430227734)|0;b=go(r|0,D|0,(l|f)^(n|v)^(x|t)|0,b|0)|0;J=go(b|0,D|0,y|0,J|0)|0;J=go(J|0,D|0,(F^s)&q^F|0,(E^e)&o^E|0)|0;y=D;b=Mm(j|0,p|0,28)|0;t=D;x=Km(j|0,p|0,36)|0;t=t|D;v=Mm(j|0,p|0,34)|0;n=D;f=Km(j|0,p|0,30)|0;n=t^(n|D);t=Mm(j|0,p|0,39)|0;l=D;r=Km(j|0,p|0,25)|0;u=c[B>>2]|0;K=c[B+4>>2]|0;l=go((u|I)&j|u&I|0,(K|H)&p|K&H|0,(b|x)^(v|f)^(t|r)|0,n^(l|D)|0)|0;n=D;L=go(z|0,L|0,J|0,y|0)|0;z=D;c[m>>2]=L;c[m+4>>2]=z;y=go(l|0,n|0,J|0,y|0)|0;J=D;c[G>>2]=y;c[G+4>>2]=J;n=Mm(L|0,z|0,14)|0;l=D;r=Km(L|0,z|0,50)|0;l=l|D;t=Mm(L|0,z|0,18)|0;f=D;v=Km(L|0,z|0,46)|0;f=l^(f|D);l=Mm(L|0,z|0,41)|0;x=D;b=Km(L|0,z|0,23)|0;x=f^(x|D);f=c[h+80+392>>2]|0;H=c[h+80+392+4>>2]|0;E=go(F|0,E|0,1363258195,506948616)|0;x=go(E|0,D|0,(n|r)^(t|v)^(l|b)|0,x|0)|0;H=go(x|0,D|0,f|0,H|0)|0;H=go(H|0,D|0,(s^q)&L^s|0,(e^o)&z^e|0)|0;f=D;x=Mm(y|0,J|0,28)|0;b=D;l=Km(y|0,J|0,36)|0;b=b|D;v=Mm(y|0,J|0,34)|0;t=D;r=Km(y|0,J|0,30)|0;t=b^(t|D);b=Mm(y|0,J|0,39)|0;n=D;E=Km(y|0,J|0,25)|0;F=c[C>>2]|0;I=c[C+4>>2]|0;n=go((F|j)&y|F&j|0,(I|p)&J|I&p|0,(x|l)^(v|r)^(b|E)|0,t^(n|D)|0)|0;t=D;K=go(u|0,K|0,H|0,f|0)|0;u=D;c[B>>2]=K;c[B+4>>2]=u;f=go(n|0,t|0,H|0,f|0)|0;H=D;c[k>>2]=f;c[k+4>>2]=H;t=Mm(K|0,u|0,14)|0;n=D;E=Km(K|0,u|0,50)|0;n=n|D;b=Mm(K|0,u|0,18)|0;r=D;v=Km(K|0,u|0,46)|0;r=n^(r|D);n=Mm(K|0,u|0,41)|0;l=D;x=Km(K|0,u|0,23)|0;l=r^(l|D);r=c[h+80+400>>2]|0;p=c[h+80+400+4>>2]|0;e=go(s|0,e|0,-544281703,659060556)|0;l=go(e|0,D|0,(t|E)^(b|v)^(n|x)|0,l|0)|0;p=go(l|0,D|0,r|0,p|0)|0;p=go(p|0,D|0,(q^L)&K^q|0,(o^z)&u^o|0)|0;r=D;l=Mm(f|0,H|0,28)|0;x=D;n=Km(f|0,H|0,36)|0;x=x|D;v=Mm(f|0,H|0,34)|0;b=D;E=Km(f|0,H|0,30)|0;b=x^(b|D);x=Mm(f|0,H|0,39)|0;t=D;e=Km(f|0,H|0,25)|0;s=c[h+16>>2]|0;j=c[h+16+4>>2]|0;t=go((s|y)&f|s&y|0,(j|J)&H|j&J|0,(l|n)^(v|E)^(x|e)|0,b^(t|D)|0)|0;b=D;I=go(F|0,I|0,p|0,r|0)|0;F=D;c[C>>2]=I;c[C+4>>2]=F;r=go(t|0,b|0,p|0,r|0)|0;p=D;c[A>>2]=r;c[A+4>>2]=p;b=Mm(I|0,F|0,14)|0;t=D;e=Km(I|0,F|0,50)|0;t=t|D;x=Mm(I|0,F|0,18)|0;E=D;v=Km(I|0,F|0,46)|0;E=t^(E|D);t=Mm(I|0,F|0,41)|0;n=D;l=Km(I|0,F|0,23)|0;n=E^(n|D);E=c[h+80+408>>2]|0;J=c[h+80+408+4>>2]|0;o=go(q|0,o|0,-509917016,883997877)|0;n=go(o|0,D|0,(b|e)^(x|v)^(t|l)|0,n|0)|0;J=go(n|0,D|0,E|0,J|0)|0;J=go(J|0,D|0,(L^K)&I^L|0,(z^u)&F^z|0)|0;E=D;n=Mm(r|0,p|0,28)|0;l=D;t=Km(r|0,p|0,36)|0;l=l|D;v=Mm(r|0,p|0,34)|0;x=D;e=Km(r|0,p|0,30)|0;x=l^(x|D);l=Mm(r|0,p|0,39)|0;b=D;o=Km(r|0,p|0,25)|0;q=c[G>>2]|0;y=c[G+4>>2]|0;b=go((q|f)&r|q&f|0,(y|H)&p|y&H|0,(n|t)^(v|e)^(l|o)|0,x^(b|D)|0)|0;x=D;j=go(s|0,j|0,J|0,E|0)|0;s=D;c[h+16>>2]=j;c[h+16+4>>2]=s;E=go(b|0,x|0,J|0,E|0)|0;J=D;c[w>>2]=E;c[w+4>>2]=J;x=Mm(j|0,s|0,14)|0;b=D;o=Km(j|0,s|0,50)|0;b=b|D;l=Mm(j|0,s|0,18)|0;e=D;v=Km(j|0,s|0,46)|0;e=b^(e|D);b=Mm(j|0,s|0,41)|0;t=D;n=Km(j|0,s|0,23)|0;t=e^(t|D);e=c[h+80+416>>2]|0;H=c[h+80+416+4>>2]|0;z=go(L|0,z|0,-976659869,958139571)|0;t=go(z|0,D|0,(x|o)^(l|v)^(b|n)|0,t|0)|0;H=go(t|0,D|0,e|0,H|0)|0;H=go(H|0,D|0,(K^I)&j^K|0,(u^F)&s^u|0)|0;e=D;t=Mm(E|0,J|0,28)|0;n=D;b=Km(E|0,J|0,36)|0;n=n|D;v=Mm(E|0,J|0,34)|0;l=D;o=Km(E|0,J|0,30)|0;l=n^(l|D);n=Mm(E|0,J|0,39)|0;x=D;z=Km(E|0,J|0,25)|0;L=c[k>>2]|0;f=c[k+4>>2]|0;x=go((L|r)&E|L&r|0,(f|p)&J|f&p|0,(t|b)^(v|o)^(n|z)|0,l^(x|D)|0)|0;l=D;y=go(q|0,y|0,H|0,e|0)|0;q=D;c[G>>2]=y;c[G+4>>2]=q;e=go(x|0,l|0,H|0,e|0)|0;H=D;c[m>>2]=e;c[m+4>>2]=H;l=Mm(y|0,q|0,14)|0;x=D;z=Km(y|0,q|0,50)|0;x=x|D;n=Mm(y|0,q|0,18)|0;o=D;v=Km(y|0,q|0,46)|0;o=x^(o|D);x=Mm(y|0,q|0,41)|0;b=D;t=Km(y|0,q|0,23)|0;b=o^(b|D);o=c[h+80+424>>2]|0;p=c[h+80+424+4>>2]|0;u=go(K|0,u|0,-482243893,1322822218)|0;b=go(u|0,D|0,(l|z)^(n|v)^(x|t)|0,b|0)|0;p=go(b|0,D|0,o|0,p|0)|0;p=go(p|0,D|0,(I^j)&y^I|0,(F^s)&q^F|0)|0;o=D;b=Mm(e|0,H|0,28)|0;t=D;x=Km(e|0,H|0,36)|0;t=t|D;v=Mm(e|0,H|0,34)|0;n=D;z=Km(e|0,H|0,30)|0;n=t^(n|D);t=Mm(e|0,H|0,39)|0;l=D;u=Km(e|0,H|0,25)|0;K=c[A>>2]|0;r=c[A+4>>2]|0;l=go((K|E)&e|K&E|0,(r|J)&H|r&J|0,(b|x)^(v|z)^(t|u)|0,n^(l|D)|0)|0;n=D;f=go(L|0,f|0,p|0,o|0)|0;L=D;c[k>>2]=f;c[k+4>>2]=L;o=go(l|0,n|0,p|0,o|0)|0;p=D;c[B>>2]=o;c[B+4>>2]=p;n=Mm(f|0,L|0,14)|0;l=D;u=Km(f|0,L|0,50)|0;l=l|D;t=Mm(f|0,L|0,18)|0;z=D;v=Km(f|0,L|0,46)|0;z=l^(z|D);l=Mm(f|0,L|0,41)|0;x=D;b=Km(f|0,L|0,23)|0;x=z^(x|D);z=c[h+80+432>>2]|0;J=c[h+80+432+4>>2]|0;F=go(I|0,F|0,2003034995,1537002063)|0;x=go(F|0,D|0,(n|u)^(t|v)^(l|b)|0,x|0)|0;J=go(x|0,D|0,z|0,J|0)|0;J=go(J|0,D|0,(j^y)&f^j|0,(s^q)&L^s|0)|0;z=D;x=Mm(o|0,p|0,28)|0;b=D;l=Km(o|0,p|0,36)|0;b=b|D;v=Mm(o|0,p|0,34)|0;t=D;u=Km(o|0,p|0,30)|0;t=b^(t|D);b=Mm(o|0,p|0,39)|0;n=D;F=Km(o|0,p|0,25)|0;I=c[w>>2]|0;E=c[w+4>>2]|0;n=go((I|e)&o|I&e|0,(E|H)&p|E&H|0,(x|l)^(v|u)^(b|F)|0,t^(n|D)|0)|0;t=D;r=go(K|0,r|0,J|0,z|0)|0;K=D;c[A>>2]=r;c[A+4>>2]=K;z=go(n|0,t|0,J|0,z|0)|0;J=D;c[C>>2]=z;c[C+4>>2]=J;t=Mm(r|0,K|0,14)|0;n=D;F=Km(r|0,K|0,50)|0;n=n|D;b=Mm(r|0,K|0,18)|0;u=D;v=Km(r|0,K|0,46)|0;u=n^(u|D);n=Mm(r|0,K|0,41)|0;l=D;x=Km(r|0,K|0,23)|0;l=u^(l|D);u=c[h+80+440>>2]|0;H=c[h+80+440+4>>2]|0;s=go(j|0,s|0,-692930397,1747873779)|0;l=go(s|0,D|0,(t|F)^(b|v)^(n|x)|0,l|0)|0;H=go(l|0,D|0,u|0,H|0)|0;H=go(H|0,D|0,(y^f)&r^y|0,(q^L)&K^q|0)|0;u=D;l=Mm(z|0,J|0,28)|0;x=D;n=Km(z|0,J|0,36)|0;x=x|D;v=Mm(z|0,J|0,34)|0;b=D;F=Km(z|0,J|0,30)|0;b=x^(b|D);x=Mm(z|0,J|0,39)|0;t=D;s=Km(z|0,J|0,25)|0;j=c[m>>2]|0;e=c[m+4>>2]|0;t=go((j|o)&z|j&o|0,(e|p)&J|e&p|0,(l|n)^(v|F)^(x|s)|0,b^(t|D)|0)|0;b=D;E=go(I|0,E|0,H|0,u|0)|0;I=D;c[w>>2]=E;c[w+4>>2]=I;u=go(t|0,b|0,H|0,u|0)|0;H=D;c[h+16>>2]=u;c[h+16+4>>2]=H;b=Mm(E|0,I|0,14)|0;t=D;s=Km(E|0,I|0,50)|0;t=t|D;x=Mm(E|0,I|0,18)|0;F=D;v=Km(E|0,I|0,46)|0;F=t^(F|D);t=Mm(E|0,I|0,41)|0;n=D;l=Km(E|0,I|0,23)|0;n=F^(n|D);F=c[h+80+448>>2]|0;p=c[h+80+448+4>>2]|0;q=go(y|0,q|0,1575990012,1955562222)|0;n=go(q|0,D|0,(b|s)^(x|v)^(t|l)|0,n|0)|0;p=go(n|0,D|0,F|0,p|0)|0;p=go(p|0,D|0,(f^r)&E^f|0,(L^K)&I^L|0)|0;F=D;n=Mm(u|0,H|0,28)|0;l=D;t=Km(u|0,H|0,36)|0;l=l|D;v=Mm(u|0,H|0,34)|0;x=D;s=Km(u|0,H|0,30)|0;x=l^(x|D);l=Mm(u|0,H|0,39)|0;b=D;q=Km(u|0,H|0,25)|0;y=c[B>>2]|0;o=c[B+4>>2]|0;b=go((y|z)&u|y&z|0,(o|J)&H|o&J|0,(n|t)^(v|s)^(l|q)|0,x^(b|D)|0)|0;x=D;e=go(j|0,e|0,p|0,F|0)|0;j=D;c[m>>2]=e;c[m+4>>2]=j;F=go(b|0,x|0,p|0,F|0)|0;p=D;c[G>>2]=F;c[G+4>>2]=p;x=Mm(e|0,j|0,14)|0;b=D;q=Km(e|0,j|0,50)|0;b=b|D;l=Mm(e|0,j|0,18)|0;s=D;v=Km(e|0,j|0,46)|0;s=b^(s|D);b=Mm(e|0,j|0,41)|0;t=D;n=Km(e|0,j|0,23)|0;t=s^(t|D);s=c[h+80+456>>2]|0;J=c[h+80+456+4>>2]|0;L=go(f|0,L|0,1125592928,2024104815)|0;t=go(L|0,D|0,(x|q)^(l|v)^(b|n)|0,t|0)|0;J=go(t|0,D|0,s|0,J|0)|0;J=go(J|0,D|0,(r^E)&e^r|0,(K^I)&j^K|0)|0;s=D;t=Mm(F|0,p|0,28)|0;n=D;b=Km(F|0,p|0,36)|0;n=n|D;v=Mm(F|0,p|0,34)|0;l=D;q=Km(F|0,p|0,30)|0;l=n^(l|D);n=Mm(F|0,p|0,39)|0;x=D;L=Km(F|0,p|0,25)|0;f=c[C>>2]|0;z=c[C+4>>2]|0;x=go((f|u)&F|f&u|0,(z|H)&p|z&H|0,(t|b)^(v|q)^(n|L)|0,l^(x|D)|0)|0;l=D;o=go(y|0,o|0,J|0,s|0)|0;y=D;c[B>>2]=o;c[B+4>>2]=y;s=go(x|0,l|0,J|0,s|0)|0;J=D;c[k>>2]=s;c[k+4>>2]=J;l=Mm(o|0,y|0,14)|0;x=D;L=Km(o|0,y|0,50)|0;x=x|D;n=Mm(o|0,y|0,18)|0;q=D;v=Km(o|0,y|0,46)|0;q=x^(q|D);x=Mm(o|0,y|0,41)|0;b=D;t=Km(o|0,y|0,23)|0;b=q^(b|D);q=c[h+80+464>>2]|0;H=c[h+80+464+4>>2]|0;K=go(r|0,K|0,-1578062990,-2067236844)|0;b=go(K|0,D|0,(l|L)^(n|v)^(x|t)|0,b|0)|0;H=go(b|0,D|0,q|0,H|0)|0;H=go(H|0,D|0,(E^e)&o^E|0,(I^j)&y^I|0)|0;q=D;b=Mm(s|0,J|0,28)|0;t=D;x=Km(s|0,J|0,36)|0;t=t|D;v=Mm(s|0,J|0,34)|0;n=D;L=Km(s|0,J|0,30)|0;n=t^(n|D);t=Mm(s|0,J|0,39)|0;l=D;K=Km(s|0,J|0,25)|0;r=c[h+16>>2]|0;u=c[h+16+4>>2]|0;l=go((r|F)&s|r&F|0,(u|p)&J|u&p|0,(b|x)^(v|L)^(t|K)|0,n^(l|D)|0)|0;n=D;z=go(f|0,z|0,H|0,q|0)|0;f=D;c[C>>2]=z;c[C+4>>2]=f;q=go(l|0,n|0,H|0,q|0)|0;H=D;c[A>>2]=q;c[A+4>>2]=H;n=Mm(z|0,f|0,14)|0;l=D;K=Km(z|0,f|0,50)|0;l=l|D;t=Mm(z|0,f|0,18)|0;L=D;v=Km(z|0,f|0,46)|0;L=l^(L|D);l=Mm(z|0,f|0,41)|0;x=D;b=Km(z|0,f|0,23)|0;x=L^(x|D);L=c[h+80+472>>2]|0;p=c[h+80+472+4>>2]|0;I=go(E|0,I|0,442776044,-1933114872)|0;x=go(I|0,D|0,(n|K)^(t|v)^(l|b)|0,x|0)|0;p=go(x|0,D|0,L|0,p|0)|0;p=go(p|0,D|0,(e^o)&z^e|0,(j^y)&f^j|0)|0;L=D;x=Mm(q|0,H|0,28)|0;b=D;l=Km(q|0,H|0,36)|0;b=b|D;v=Mm(q|0,H|0,34)|0;t=D;K=Km(q|0,H|0,30)|0;t=b^(t|D);b=Mm(q|0,H|0,39)|0;n=D;I=Km(q|0,H|0,25)|0;E=c[G>>2]|0;F=c[G+4>>2]|0;n=go((E|s)&q|E&s|0,(F|J)&H|F&J|0,(x|l)^(v|K)^(b|I)|0,t^(n|D)|0)|0;t=D;u=go(r|0,u|0,p|0,L|0)|0;r=D;c[h+16>>2]=u;c[h+16+4>>2]=r;L=go(n|0,t|0,p|0,L|0)|0;p=D;c[w>>2]=L;c[w+4>>2]=p;t=Mm(u|0,r|0,14)|0;n=D;I=Km(u|0,r|0,50)|0;n=n|D;b=Mm(u|0,r|0,18)|0;K=D;v=Km(u|0,r|0,46)|0;K=n^(K|D);n=Mm(u|0,r|0,41)|0;l=D;x=Km(u|0,r|0,23)|0;l=K^(l|D);K=c[h+80+480>>2]|0;J=c[h+80+480+4>>2]|0;j=go(e|0,j|0,593698344,-1866530822)|0;l=go(j|0,D|0,(t|I)^(b|v)^(n|x)|0,l|0)|0;J=go(l|0,D|0,K|0,J|0)|0;J=go(J|0,D|0,(o^z)&u^o|0,(y^f)&r^y|0)|0;K=D;l=Mm(L|0,p|0,28)|0;x=D;n=Km(L|0,p|0,36)|0;x=x|D;v=Mm(L|0,p|0,34)|0;b=D;I=Km(L|0,p|0,30)|0;b=x^(b|D);x=Mm(L|0,p|0,39)|0;t=D;j=Km(L|0,p|0,25)|0;e=c[k>>2]|0;s=c[k+4>>2]|0;t=go((e|q)&L|e&q|0,(s|H)&p|s&H|0,(l|n)^(v|I)^(x|j)|0,b^(t|D)|0)|0;b=D;F=go(E|0,F|0,J|0,K|0)|0;E=D;c[G>>2]=F;c[G+4>>2]=E;K=go(t|0,b|0,J|0,K|0)|0;J=D;c[m>>2]=K;c[m+4>>2]=J;b=Mm(F|0,E|0,14)|0;t=D;j=Km(F|0,E|0,50)|0;t=t|D;x=Mm(F|0,E|0,18)|0;I=D;v=Km(F|0,E|0,46)|0;I=t^(I|D);t=Mm(F|0,E|0,41)|0;n=D;l=Km(F|0,E|0,23)|0;n=I^(n|D);I=c[h+80+488>>2]|0;H=c[h+80+488+4>>2]|0;y=go(o|0,y|0,-561857047,-1538233109)|0;n=go(y|0,D|0,(b|j)^(x|v)^(t|l)|0,n|0)|0;H=go(n|0,D|0,I|0,H|0)|0;H=go(H|0,D|0,(z^u)&F^z|0,(f^r)&E^f|0)|0;I=D;n=Mm(K|0,J|0,28)|0;l=D;t=Km(K|0,J|0,36)|0;l=l|D;v=Mm(K|0,J|0,34)|0;x=D;j=Km(K|0,J|0,30)|0;x=l^(x|D);l=Mm(K|0,J|0,39)|0;b=D;y=Km(K|0,J|0,25)|0;o=c[A>>2]|0;q=c[A+4>>2]|0;b=go((o|L)&K|o&L|0,(q|p)&J|q&p|0,(n|t)^(v|j)^(l|y)|0,x^(b|D)|0)|0;x=D;s=go(e|0,s|0,H|0,I|0)|0;e=D;c[k>>2]=s;c[k+4>>2]=e;I=go(b|0,x|0,H|0,I|0)|0;H=D;c[B>>2]=I;c[B+4>>2]=H;x=Mm(s|0,e|0,14)|0;b=D;y=Km(s|0,e|0,50)|0;b=b|D;l=Mm(s|0,e|0,18)|0;j=D;v=Km(s|0,e|0,46)|0;j=b^(j|D);b=Mm(s|0,e|0,41)|0;t=D;n=Km(s|0,e|0,23)|0;t=j^(t|D);j=c[h+80+496>>2]|0;p=c[h+80+496+4>>2]|0;f=go(z|0,f|0,-1295615723,-1090935817)|0;t=go(f|0,D|0,(x|y)^(l|v)^(b|n)|0,t|0)|0;p=go(t|0,D|0,j|0,p|0)|0;p=go(p|0,D|0,(u^F)&s^u|0,(r^E)&e^r|0)|0;j=D;t=Mm(I|0,H|0,28)|0;n=D;b=Km(I|0,H|0,36)|0;n=n|D;v=Mm(I|0,H|0,34)|0;l=D;y=Km(I|0,H|0,30)|0;l=n^(l|D);n=Mm(I|0,H|0,39)|0;x=D;f=Km(I|0,H|0,25)|0;z=c[w>>2]|0;L=c[w+4>>2]|0;x=go((z|K)&I|z&K|0,(L|J)&H|L&J|0,(t|b)^(v|y)^(n|f)|0,l^(x|D)|0)|0;l=D;q=go(o|0,q|0,p|0,j|0)|0;o=D;c[A>>2]=q;c[A+4>>2]=o;j=go(x|0,l|0,p|0,j|0)|0;p=D;c[C>>2]=j;c[C+4>>2]=p;l=Mm(q|0,o|0,14)|0;x=D;f=Km(q|0,o|0,50)|0;x=x|D;n=Mm(q|0,o|0,18)|0;y=D;v=Km(q|0,o|0,46)|0;y=x^(y|D);x=Mm(q|0,o|0,41)|0;b=D;t=Km(q|0,o|0,23)|0;b=y^(b|D);y=c[h+80+504>>2]|0;J=c[h+80+504+4>>2]|0;r=go(u|0,r|0,-479046869,-965641998)|0;b=go(r|0,D|0,(l|f)^(n|v)^(x|t)|0,b|0)|0;J=go(b|0,D|0,y|0,J|0)|0;J=go(J|0,D|0,(F^s)&q^F|0,(E^e)&o^E|0)|0;y=D;b=Mm(j|0,p|0,28)|0;t=D;x=Km(j|0,p|0,36)|0;t=t|D;v=Mm(j|0,p|0,34)|0;n=D;f=Km(j|0,p|0,30)|0;n=t^(n|D);t=Mm(j|0,p|0,39)|0;l=D;r=Km(j|0,p|0,25)|0;u=c[m>>2]|0;K=c[m+4>>2]|0;l=go((u|I)&j|u&I|0,(K|H)&p|K&H|0,(b|x)^(v|f)^(t|r)|0,n^(l|D)|0)|0;n=D;L=go(z|0,L|0,J|0,y|0)|0;z=D;c[w>>2]=L;c[w+4>>2]=z;y=go(l|0,n|0,J|0,y|0)|0;J=D;c[h+16>>2]=y;c[h+16+4>>2]=J;n=Mm(L|0,z|0,14)|0;l=D;r=Km(L|0,z|0,50)|0;l=l|D;t=Mm(L|0,z|0,18)|0;f=D;v=Km(L|0,z|0,46)|0;f=l^(f|D);l=Mm(L|0,z|0,41)|0;x=D;b=Km(L|0,z|0,23)|0;x=f^(x|D);f=c[h+80+512>>2]|0;H=c[h+80+512+4>>2]|0;E=go(F|0,E|0,-366583396,-903397682)|0;x=go(E|0,D|0,(n|r)^(t|v)^(l|b)|0,x|0)|0;H=go(x|0,D|0,f|0,H|0)|0;H=go(H|0,D|0,(s^q)&L^s|0,(e^o)&z^e|0)|0;f=D;x=Mm(y|0,J|0,28)|0;b=D;l=Km(y|0,J|0,36)|0;b=b|D;v=Mm(y|0,J|0,34)|0;t=D;r=Km(y|0,J|0,30)|0;t=b^(t|D);b=Mm(y|0,J|0,39)|0;n=D;E=Km(y|0,J|0,25)|0;F=c[B>>2]|0;I=c[B+4>>2]|0;n=go((F|j)&y|F&j|0,(I|p)&J|I&p|0,(x|l)^(v|r)^(b|E)|0,t^(n|D)|0)|0;t=D;K=go(u|0,K|0,H|0,f|0)|0;u=D;c[m>>2]=K;c[m+4>>2]=u;f=go(n|0,t|0,H|0,f|0)|0;H=D;c[G>>2]=f;c[G+4>>2]=H;t=Mm(K|0,u|0,14)|0;n=D;E=Km(K|0,u|0,50)|0;n=n|D;b=Mm(K|0,u|0,18)|0;r=D;v=Km(K|0,u|0,46)|0;r=n^(r|D);n=Mm(K|0,u|0,41)|0;l=D;x=Km(K|0,u|0,23)|0;l=r^(l|D);r=c[h+80+520>>2]|0;p=c[h+80+520+4>>2]|0;e=go(s|0,e|0,566280711,-779700025)|0;l=go(e|0,D|0,(t|E)^(b|v)^(n|x)|0,l|0)|0;p=go(l|0,D|0,r|0,p|0)|0;p=go(p|0,D|0,(q^L)&K^q|0,(o^z)&u^o|0)|0;r=D;l=Mm(f|0,H|0,28)|0;x=D;n=Km(f|0,H|0,36)|0;x=x|D;v=Mm(f|0,H|0,34)|0;b=D;E=Km(f|0,H|0,30)|0;b=x^(b|D);x=Mm(f|0,H|0,39)|0;t=D;e=Km(f|0,H|0,25)|0;s=c[C>>2]|0;j=c[C+4>>2]|0;t=go((s|y)&f|s&y|0,(j|J)&H|j&J|0,(l|n)^(v|E)^(x|e)|0,b^(t|D)|0)|0;b=D;I=go(F|0,I|0,p|0,r|0)|0;F=D;c[B>>2]=I;c[B+4>>2]=F;r=go(t|0,b|0,p|0,r|0)|0;p=D;c[k>>2]=r;c[k+4>>2]=p;b=Mm(I|0,F|0,14)|0;t=D;e=Km(I|0,F|0,50)|0;t=t|D;x=Mm(I|0,F|0,18)|0;E=D;v=Km(I|0,F|0,46)|0;E=t^(E|D);t=Mm(I|0,F|0,41)|0;n=D;l=Km(I|0,F|0,23)|0;n=E^(n|D);E=c[h+80+528>>2]|0;J=c[h+80+528+4>>2]|0;o=go(q|0,o|0,-840897762,-354779690)|0;n=go(o|0,D|0,(b|e)^(x|v)^(t|l)|0,n|0)|0;J=go(n|0,D|0,E|0,J|0)|0;J=go(J|0,D|0,(L^K)&I^L|0,(z^u)&F^z|0)|0;E=D;n=Mm(r|0,p|0,28)|0;l=D;t=Km(r|0,p|0,36)|0;l=l|D;v=Mm(r|0,p|0,34)|0;x=D;e=Km(r|0,p|0,30)|0;x=l^(x|D);l=Mm(r|0,p|0,39)|0;b=D;o=Km(r|0,p|0,25)|0;q=c[h+16>>2]|0;y=c[h+16+4>>2]|0;b=go((q|f)&r|q&f|0,(y|H)&p|y&H|0,(n|t)^(v|e)^(l|o)|0,x^(b|D)|0)|0;x=D;j=go(s|0,j|0,J|0,E|0)|0;s=D;c[C>>2]=j;c[C+4>>2]=s;E=go(b|0,x|0,J|0,E|0)|0;J=D;c[A>>2]=E;c[A+4>>2]=J;x=Mm(j|0,s|0,14)|0;b=D;o=Km(j|0,s|0,50)|0;b=b|D;l=Mm(j|0,s|0,18)|0;e=D;v=Km(j|0,s|0,46)|0;e=b^(e|D);b=Mm(j|0,s|0,41)|0;t=D;n=Km(j|0,s|0,23)|0;t=e^(t|D);e=c[h+80+536>>2]|0;H=c[h+80+536+4>>2]|0;z=go(L|0,z|0,-294727304,-176337025)|0;t=go(z|0,D|0,(x|o)^(l|v)^(b|n)|0,t|0)|0;H=go(t|0,D|0,e|0,H|0)|0;H=go(H|0,D|0,(K^I)&j^K|0,(u^F)&s^u|0)|0;e=D;t=Mm(E|0,J|0,28)|0;n=D;b=Km(E|0,J|0,36)|0;n=n|D;v=Mm(E|0,J|0,34)|0;l=D;o=Km(E|0,J|0,30)|0;l=n^(l|D);n=Mm(E|0,J|0,39)|0;x=D;z=Km(E|0,J|0,25)|0;L=c[G>>2]|0;f=c[G+4>>2]|0;x=go((L|r)&E|L&r|0,(f|p)&J|f&p|0,(t|b)^(v|o)^(n|z)|0,l^(x|D)|0)|0;l=D;y=go(q|0,y|0,H|0,e|0)|0;q=D;c[h+16>>2]=y;c[h+16+4>>2]=q;e=go(x|0,l|0,H|0,e|0)|0;H=D;c[w>>2]=e;c[w+4>>2]=H;l=Mm(y|0,q|0,14)|0;x=D;z=Km(y|0,q|0,50)|0;x=x|D;n=Mm(y|0,q|0,18)|0;o=D;v=Km(y|0,q|0,46)|0;o=x^(o|D);x=Mm(y|0,q|0,41)|0;b=D;t=Km(y|0,q|0,23)|0;b=o^(b|D);o=c[h+80+544>>2]|0;p=c[h+80+544+4>>2]|0;u=go(K|0,u|0,1914138554,116418474)|0;b=go(u|0,D|0,(l|z)^(n|v)^(x|t)|0,b|0)|0;p=go(b|0,D|0,o|0,p|0)|0;p=go(p|0,D|0,(I^j)&y^I|0,(F^s)&q^F|0)|0;o=D;b=Mm(e|0,H|0,28)|0;t=D;x=Km(e|0,H|0,36)|0;t=t|D;v=Mm(e|0,H|0,34)|0;n=D;z=Km(e|0,H|0,30)|0;n=t^(n|D);t=Mm(e|0,H|0,39)|0;l=D;u=Km(e|0,H|0,25)|0;K=c[k>>2]|0;r=c[k+4>>2]|0;l=go((K|E)&e|K&E|0,(r|J)&H|r&J|0,(b|x)^(v|z)^(t|u)|0,n^(l|D)|0)|0;n=D;f=go(L|0,f|0,p|0,o|0)|0;L=D;c[G>>2]=f;c[G+4>>2]=L;o=go(l|0,n|0,p|0,o|0)|0;p=D;c[m>>2]=o;c[m+4>>2]=p;n=Mm(f|0,L|0,14)|0;l=D;u=Km(f|0,L|0,50)|0;l=l|D;t=Mm(f|0,L|0,18)|0;z=D;v=Km(f|0,L|0,46)|0;z=l^(z|D);l=Mm(f|0,L|0,41)|0;x=D;b=Km(f|0,L|0,23)|0;x=z^(x|D);z=c[h+80+552>>2]|0;J=c[h+80+552+4>>2]|0;F=go(I|0,F|0,-1563912026,174292421)|0;x=go(F|0,D|0,(n|u)^(t|v)^(l|b)|0,x|0)|0;J=go(x|0,D|0,z|0,J|0)|0;J=go(J|0,D|0,(j^y)&f^j|0,(s^q)&L^s|0)|0;z=D;x=Mm(o|0,p|0,28)|0;b=D;l=Km(o|0,p|0,36)|0;b=b|D;v=Mm(o|0,p|0,34)|0;t=D;u=Km(o|0,p|0,30)|0;t=b^(t|D);b=Mm(o|0,p|0,39)|0;n=D;F=Km(o|0,p|0,25)|0;I=c[A>>2]|0;E=c[A+4>>2]|0;n=go((I|e)&o|I&e|0,(E|H)&p|E&H|0,(x|l)^(v|u)^(b|F)|0,t^(n|D)|0)|0;t=D;r=go(K|0,r|0,J|0,z|0)|0;K=D;c[k>>2]=r;c[k+4>>2]=K;z=go(n|0,t|0,J|0,z|0)|0;J=D;c[B>>2]=z;c[B+4>>2]=J;t=Mm(r|0,K|0,14)|0;n=D;F=Km(r|0,K|0,50)|0;n=n|D;b=Mm(r|0,K|0,18)|0;u=D;v=Km(r|0,K|0,46)|0;u=n^(u|D);n=Mm(r|0,K|0,41)|0;l=D;x=Km(r|0,K|0,23)|0;l=u^(l|D);u=c[h+80+560>>2]|0;H=c[h+80+560+4>>2]|0;s=go(j|0,s|0,-1090974290,289380356)|0;l=go(s|0,D|0,(t|F)^(b|v)^(n|x)|0,l|0)|0;H=go(l|0,D|0,u|0,H|0)|0;H=go(H|0,D|0,(y^f)&r^y|0,(q^L)&K^q|0)|0;u=D;l=Mm(z|0,J|0,28)|0;x=D;n=Km(z|0,J|0,36)|0;x=x|D;v=Mm(z|0,J|0,34)|0;b=D;F=Km(z|0,J|0,30)|0;b=x^(b|D);x=Mm(z|0,J|0,39)|0;t=D;s=Km(z|0,J|0,25)|0;j=c[w>>2]|0;e=c[w+4>>2]|0;t=go((j|o)&z|j&o|0,(e|p)&J|e&p|0,(l|n)^(v|F)^(x|s)|0,b^(t|D)|0)|0;b=D;E=go(I|0,E|0,H|0,u|0)|0;I=D;c[A>>2]=E;c[A+4>>2]=I;u=go(t|0,b|0,H|0,u|0)|0;H=D;c[C>>2]=u;c[C+4>>2]=H;b=Mm(E|0,I|0,14)|0;t=D;s=Km(E|0,I|0,50)|0;t=t|D;x=Mm(E|0,I|0,18)|0;F=D;v=Km(E|0,I|0,46)|0;F=t^(F|D);t=Mm(E|0,I|0,41)|0;n=D;l=Km(E|0,I|0,23)|0;n=F^(n|D);F=c[h+80+568>>2]|0;p=c[h+80+568+4>>2]|0;q=go(y|0,q|0,320620315,460393269)|0;n=go(q|0,D|0,(b|s)^(x|v)^(t|l)|0,n|0)|0;p=go(n|0,D|0,F|0,p|0)|0;p=go(p|0,D|0,(f^r)&E^f|0,(L^K)&I^L|0)|0;F=D;n=Mm(u|0,H|0,28)|0;l=D;t=Km(u|0,H|0,36)|0;l=l|D;v=Mm(u|0,H|0,34)|0;x=D;s=Km(u|0,H|0,30)|0;x=l^(x|D);l=Mm(u|0,H|0,39)|0;b=D;q=Km(u|0,H|0,25)|0;y=c[m>>2]|0;o=c[m+4>>2]|0;b=go((y|z)&u|y&z|0,(o|J)&H|o&J|0,(n|t)^(v|s)^(l|q)|0,x^(b|D)|0)|0;x=D;e=go(j|0,e|0,p|0,F|0)|0;j=D;c[w>>2]=e;c[w+4>>2]=j;F=go(b|0,x|0,p|0,F|0)|0;p=D;c[h+16>>2]=F;c[h+16+4>>2]=p;x=Mm(e|0,j|0,14)|0;b=D;q=Km(e|0,j|0,50)|0;b=b|D;l=Mm(e|0,j|0,18)|0;s=D;v=Km(e|0,j|0,46)|0;s=b^(s|D);b=Mm(e|0,j|0,41)|0;t=D;n=Km(e|0,j|0,23)|0;t=s^(t|D);s=c[h+80+576>>2]|0;J=c[h+80+576+4>>2]|0;L=go(f|0,L|0,587496836,685471733)|0;t=go(L|0,D|0,(x|q)^(l|v)^(b|n)|0,t|0)|0;J=go(t|0,D|0,s|0,J|0)|0;J=go(J|0,D|0,(r^E)&e^r|0,(K^I)&j^K|0)|0;s=D;t=Mm(F|0,p|0,28)|0;n=D;b=Km(F|0,p|0,36)|0;n=n|D;v=Mm(F|0,p|0,34)|0;l=D;q=Km(F|0,p|0,30)|0;l=n^(l|D);n=Mm(F|0,p|0,39)|0;x=D;L=Km(F|0,p|0,25)|0;f=c[B>>2]|0;z=c[B+4>>2]|0;x=go((f|u)&F|f&u|0,(z|H)&p|z&H|0,(t|b)^(v|q)^(n|L)|0,l^(x|D)|0)|0;l=D;o=go(y|0,o|0,J|0,s|0)|0;y=D;c[m>>2]=o;c[m+4>>2]=y;s=go(x|0,l|0,J|0,s|0)|0;J=D;c[G>>2]=s;c[G+4>>2]=J;l=Mm(o|0,y|0,14)|0;x=D;L=Km(o|0,y|0,50)|0;x=x|D;n=Mm(o|0,y|0,18)|0;q=D;v=Km(o|0,y|0,46)|0;q=x^(q|D);x=Mm(o|0,y|0,41)|0;b=D;t=Km(o|0,y|0,23)|0;b=q^(b|D);q=c[h+80+584>>2]|0;H=c[h+80+584+4>>2]|0;K=go(r|0,K|0,1086792851,852142971)|0;b=go(K|0,D|0,(l|L)^(n|v)^(x|t)|0,b|0)|0;H=go(b|0,D|0,q|0,H|0)|0;H=go(H|0,D|0,(E^e)&o^E|0,(I^j)&y^I|0)|0;q=D;b=Mm(s|0,J|0,28)|0;t=D;x=Km(s|0,J|0,36)|0;t=t|D;v=Mm(s|0,J|0,34)|0;n=D;L=Km(s|0,J|0,30)|0;n=t^(n|D);t=Mm(s|0,J|0,39)|0;l=D;K=Km(s|0,J|0,25)|0;r=c[C>>2]|0;u=c[C+4>>2]|0;l=go((r|F)&s|r&F|0,(u|p)&J|u&p|0,(b|x)^(v|L)^(t|K)|0,n^(l|D)|0)|0;n=D;z=go(f|0,z|0,H|0,q|0)|0;f=D;c[B>>2]=z;c[B+4>>2]=f;q=go(l|0,n|0,H|0,q|0)|0;H=D;c[k>>2]=q;c[k+4>>2]=H;n=Mm(z|0,f|0,14)|0;l=D;K=Km(z|0,f|0,50)|0;l=l|D;t=Mm(z|0,f|0,18)|0;L=D;v=Km(z|0,f|0,46)|0;L=l^(L|D);l=Mm(z|0,f|0,41)|0;x=D;b=Km(z|0,f|0,23)|0;x=L^(x|D);L=c[h+80+592>>2]|0;p=c[h+80+592+4>>2]|0;I=go(E|0,I|0,365543100,1017036298)|0;x=go(I|0,D|0,(n|K)^(t|v)^(l|b)|0,x|0)|0;p=go(x|0,D|0,L|0,p|0)|0;p=go(p|0,D|0,(e^o)&z^e|0,(j^y)&f^j|0)|0;L=D;x=Mm(q|0,H|0,28)|0;b=D;l=Km(q|0,H|0,36)|0;b=b|D;v=Mm(q|0,H|0,34)|0;t=D;K=Km(q|0,H|0,30)|0;t=b^(t|D);b=Mm(q|0,H|0,39)|0;n=D;I=Km(q|0,H|0,25)|0;E=c[h+16>>2]|0;F=c[h+16+4>>2]|0;n=go((E|s)&q|E&s|0,(F|J)&H|F&J|0,(x|l)^(v|K)^(b|I)|0,t^(n|D)|0)|0;t=D;u=go(r|0,u|0,p|0,L|0)|0;r=D;c[C>>2]=u;c[C+4>>2]=r;L=go(n|0,t|0,p|0,L|0)|0;p=D;c[A>>2]=L;c[A+4>>2]=p;t=Mm(u|0,r|0,14)|0;n=D;I=Km(u|0,r|0,50)|0;n=n|D;b=Mm(u|0,r|0,18)|0;K=D;v=Km(u|0,r|0,46)|0;K=n^(K|D);n=Mm(u|0,r|0,41)|0;l=D;x=Km(u|0,r|0,23)|0;l=K^(l|D);K=c[h+80+600>>2]|0;J=c[h+80+600+4>>2]|0;j=go(e|0,j|0,-1676669620,1126000580)|0;l=go(j|0,D|0,(t|I)^(b|v)^(n|x)|0,l|0)|0;J=go(l|0,D|0,K|0,J|0)|0;J=go(J|0,D|0,(o^z)&u^o|0,(y^f)&r^y|0)|0;K=D;l=Mm(L|0,p|0,28)|0;x=D;n=Km(L|0,p|0,36)|0;x=x|D;v=Mm(L|0,p|0,34)|0;b=D;I=Km(L|0,p|0,30)|0;b=x^(b|D);x=Mm(L|0,p|0,39)|0;t=D;j=Km(L|0,p|0,25)|0;e=c[G>>2]|0;s=c[G+4>>2]|0;t=go((e|q)&L|e&q|0,(s|H)&p|s&H|0,(l|n)^(v|I)^(x|j)|0,b^(t|D)|0)|0;b=D;F=go(E|0,F|0,J|0,K|0)|0;E=D;c[h+16>>2]=F;c[h+16+4>>2]=E;K=go(t|0,b|0,J|0,K|0)|0;J=D;c[w>>2]=K;c[w+4>>2]=J;b=Mm(F|0,E|0,14)|0;t=D;j=Km(F|0,E|0,50)|0;t=t|D;x=Mm(F|0,E|0,18)|0;I=D;v=Km(F|0,E|0,46)|0;I=t^(I|D);t=Mm(F|0,E|0,41)|0;n=D;l=Km(F|0,E|0,23)|0;n=I^(n|D);I=c[h+80+608>>2]|0;H=c[h+80+608+4>>2]|0;y=go(o|0,y|0,-885112138,1288033470)|0;n=go(y|0,D|0,(b|j)^(x|v)^(t|l)|0,n|0)|0;H=go(n|0,D|0,I|0,H|0)|0;H=go(H|0,D|0,(z^u)&F^z|0,(f^r)&E^f|0)|0;I=D;n=Mm(K|0,J|0,28)|0;l=D;t=Km(K|0,J|0,36)|0;l=l|D;v=Mm(K|0,J|0,34)|0;x=D;j=Km(K|0,J|0,30)|0;x=l^(x|D);l=Mm(K|0,J|0,39)|0;b=D;y=Km(K|0,J|0,25)|0;o=c[k>>2]|0;q=c[k+4>>2]|0;b=go((o|L)&K|o&L|0,(q|p)&J|q&p|0,(n|t)^(v|j)^(l|y)|0,x^(b|D)|0)|0;x=D;s=go(e|0,s|0,H|0,I|0)|0;e=D;c[G>>2]=s;c[G+4>>2]=e;I=go(b|0,x|0,H|0,I|0)|0;H=D;c[m>>2]=I;c[m+4>>2]=H;x=Mm(s|0,e|0,14)|0;b=D;G=Km(s|0,e|0,50)|0;b=b|D;y=Mm(s|0,e|0,18)|0;l=D;j=Km(s|0,e|0,46)|0;l=b^(l|D);b=Mm(s|0,e|0,41)|0;v=D;t=Km(s|0,e|0,23)|0;v=l^(v|D);l=c[h+80+616>>2]|0;n=c[h+80+616+4>>2]|0;f=go(z|0,f|0,-60457430,1501505948)|0;v=go(f|0,D|0,(x|G)^(y|j)^(b|t)|0,v|0)|0;n=go(v|0,D|0,l|0,n|0)|0;n=go(n|0,D|0,(u^F)&s^u|0,(r^E)&e^r|0)|0;l=D;v=Mm(I|0,H|0,28)|0;t=D;b=Km(I|0,H|0,36)|0;t=t|D;j=Mm(I|0,H|0,34)|0;y=D;G=Km(I|0,H|0,30)|0;y=t^(y|D);t=Mm(I|0,H|0,39)|0;x=D;f=Km(I|0,H|0,25)|0;z=c[A>>2]|0;p=c[A+4>>2]|0;x=go((z|K)&I|z&K|0,(p|J)&H|p&J|0,(v|b)^(j|G)^(t|f)|0,y^(x|D)|0)|0;y=D;q=go(o|0,q|0,n|0,l|0)|0;o=D;c[k>>2]=q;c[k+4>>2]=o;l=go(x|0,y|0,n|0,l|0)|0;n=D;c[B>>2]=l;c[B+4>>2]=n;B=Mm(q|0,o|0,14)|0;y=D;x=Km(q|0,o|0,50)|0;y=y|D;k=Mm(q|0,o|0,18)|0;f=D;t=Km(q|0,o|0,46)|0;f=y^(f|D);y=Mm(q|0,o|0,41)|0;G=D;j=Km(q|0,o|0,23)|0;G=f^(G|D);f=c[h+80+624>>2]|0;b=c[h+80+624+4>>2]|0;r=go(u|0,r|0,987167468,1607167915)|0;G=go(r|0,D|0,(B|x)^(k|t)^(y|j)|0,G|0)|0;b=go(G|0,D|0,f|0,b|0)|0;b=go(b|0,D|0,(F^s)&q^F|0,(E^e)&o^E|0)|0;f=D;G=Mm(l|0,n|0,28)|0;j=D;y=Km(l|0,n|0,36)|0;j=j|D;t=Mm(l|0,n|0,34)|0;k=D;x=Km(l|0,n|0,30)|0;k=j^(k|D);j=Mm(l|0,n|0,39)|0;B=D;r=Km(l|0,n|0,25)|0;u=c[w>>2]|0;v=c[w+4>>2]|0;B=go((u|I)&l|u&I|0,(v|H)&n|v&H|0,(G|y)^(t|x)^(j|r)|0,k^(B|D)|0)|0;k=D;p=go(z|0,p|0,b|0,f|0)|0;z=D;c[A>>2]=p;c[A+4>>2]=z;f=go(B|0,k|0,b|0,f|0)|0;b=D;c[C>>2]=f;c[C+4>>2]=b;C=Mm(p|0,z|0,14)|0;k=D;B=Km(p|0,z|0,50)|0;k=k|D;A=Mm(p|0,z|0,18)|0;r=D;j=Km(p|0,z|0,46)|0;r=k^(r|D);k=Mm(p|0,z|0,41)|0;x=D;t=Km(p|0,z|0,23)|0;x=r^(x|D);r=c[h+80+632>>2]|0;y=c[h+80+632+4>>2]|0;E=go(F|0,E|0,1246189591,1816402316)|0;x=go(E|0,D|0,(C|B)^(A|j)^(k|t)|0,x|0)|0;y=go(x|0,D|0,r|0,y|0)|0;e=go(y|0,D|0,(s^q)&p^s|0,(e^o)&z^e|0)|0;z=D;c[h+8>>2]=e;c[h+8+4>>2]=z;o=Mm(f|0,b|0,28)|0;s=D;p=Km(f|0,b|0,36)|0;s=s|D;q=Mm(f|0,b|0,34)|0;y=D;r=Km(f|0,b|0,30)|0;y=s^(y|D);s=Mm(f|0,b|0,39)|0;x=D;t=Km(f|0,b|0,25)|0;k=c[m>>2]|0;m=c[m+4>>2]|0;x=go((k|l)&f|k&l|0,(m|n)&b|m&n|0,(o|p)^(q|r)^(s|t)|0,y^(x|D)|0)|0;y=D;c[h>>2]=x;c[h+4>>2]=y;v=go(u|0,v|0,e|0,z|0)|0;c[w>>2]=v;c[w+4>>2]=D;z=go(x|0,y|0,e|0,z|0)|0;e=D;c[h+16>>2]=z;c[h+16+4>>2]=e;e=go(c[a>>2]|0,c[a+4>>2]|0,z|0,e|0)|0;c[a>>2]=e;c[a+4>>2]=D;e=1;while(1){M=a+(e<<3)|0;b=go(c[M>>2]|0,c[M+4>>2]|0,f|0,b|0)|0;c[M>>2]=b;c[M+4>>2]=D;b=e+1|0;if((b|0)==8)break;e=b;f=c[h+16+(b<<3)>>2]|0;b=c[h+16+(b<<3)+4>>2]|0}_j(h+80|0,640);_j(h+16|0,64);_j(h+8|0,8);_j(h,8);i=g;return}function Zb(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;O=i;P=i=i+63&-64;i=i+128|0;o=d[b>>0]|d[b+1>>0]<<8|d[b+2>>0]<<16|d[b+3>>0]<<24;x=d[b+4>>0]|d[b+4+1>>0]<<8|d[b+4+2>>0]<<16|d[b+4+3>>0]<<24;L=d[b+8>>0]|d[b+8+1>>0]<<8|d[b+8+2>>0]<<16|d[b+8+3>>0]<<24;l=d[b+8+4>>0]|d[b+8+4+1>>0]<<8|d[b+8+4+2>>0]<<16|d[b+8+4+3>>0]<<24;m=d[b+16>>0]|d[b+16+1>>0]<<8|d[b+16+2>>0]<<16|d[b+16+3>>0]<<24;n=d[b+16+4>>0]|d[b+16+4+1>>0]<<8|d[b+16+4+2>>0]<<16|d[b+16+4+3>>0]<<24;p=d[b+24>>0]|d[b+24+1>>0]<<8|d[b+24+2>>0]<<16|d[b+24+3>>0]<<24;q=d[b+24+4>>0]|d[b+24+4+1>>0]<<8|d[b+24+4+2>>0]<<16|d[b+24+4+3>>0]<<24;r=d[b+32>>0]|d[b+32+1>>0]<<8|d[b+32+2>>0]<<16|d[b+32+3>>0]<<24;s=d[b+32+4>>0]|d[b+32+4+1>>0]<<8|d[b+32+4+2>>0]<<16|d[b+32+4+3>>0]<<24;t=d[b+40>>0]|d[b+40+1>>0]<<8|d[b+40+2>>0]<<16|d[b+40+3>>0]<<24;u=d[b+40+4>>0]|d[b+40+4+1>>0]<<8|d[b+40+4+2>>0]<<16|d[b+40+4+3>>0]<<24;v=d[b+48>>0]|d[b+48+1>>0]<<8|d[b+48+2>>0]<<16|d[b+48+3>>0]<<24;w=d[b+48+4>>0]|d[b+48+4+1>>0]<<8|d[b+48+4+2>>0]<<16|d[b+48+4+3>>0]<<24;y=d[b+56>>0]|d[b+56+1>>0]<<8|d[b+56+2>>0]<<16|d[b+56+3>>0]<<24;z=d[b+56+4>>0]|d[b+56+4+1>>0]<<8|d[b+56+4+2>>0]<<16|d[b+56+4+3>>0]<<24;A=d[b+64>>0]|d[b+64+1>>0]<<8|d[b+64+2>>0]<<16|d[b+64+3>>0]<<24;B=d[b+64+4>>0]|d[b+64+4+1>>0]<<8|d[b+64+4+2>>0]<<16|d[b+64+4+3>>0]<<24;C=d[b+72>>0]|d[b+72+1>>0]<<8|d[b+72+2>>0]<<16|d[b+72+3>>0]<<24;E=d[b+72+4>>0]|d[b+72+4+1>>0]<<8|d[b+72+4+2>>0]<<16|d[b+72+4+3>>0]<<24;F=d[b+80>>0]|d[b+80+1>>0]<<8|d[b+80+2>>0]<<16|d[b+80+3>>0]<<24;G=d[b+80+4>>0]|d[b+80+4+1>>0]<<8|d[b+80+4+2>>0]<<16|d[b+80+4+3>>0]<<24;H=d[b+88>>0]|d[b+88+1>>0]<<8|d[b+88+2>>0]<<16|d[b+88+3>>0]<<24;I=d[b+88+4>>0]|d[b+88+4+1>>0]<<8|d[b+88+4+2>>0]<<16|d[b+88+4+3>>0]<<24;J=d[b+96>>0]|d[b+96+1>>0]<<8|d[b+96+2>>0]<<16|d[b+96+3>>0]<<24;K=d[b+96+4>>0]|d[b+96+4+1>>0]<<8|d[b+96+4+2>>0]<<16|d[b+96+4+3>>0]<<24;M=d[b+104>>0]|d[b+104+1>>0]<<8|d[b+104+2>>0]<<16|d[b+104+3>>0]<<24;N=d[b+104+4>>0]|d[b+104+4+1>>0]<<8|d[b+104+4+2>>0]<<16|d[b+104+4+3>>0]<<24;h=d[b+112>>0]|d[b+112+1>>0]<<8|d[b+112+2>>0]<<16|d[b+112+3>>0]<<24;j=d[b+112+4>>0]|d[b+112+4+1>>0]<<8|d[b+112+4+2>>0]<<16|d[b+112+4+3>>0]<<24;k=d[b+120>>0]|d[b+120+1>>0]<<8|d[b+120+2>>0]<<16|d[b+120+3>>0]<<24;b=d[b+120+4>>0]|d[b+120+4+1>>0]<<8|d[b+120+4+2>>0]<<16|d[b+120+4+3>>0]<<24;e=P;f=a;g=e+64|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(g|0));c[P+80>>2]=-23791573;c[P+80+4>>2]=1013904242;c[P+88>>2]=1595750129;c[P+88+4>>2]=-1521486534;f=c[a+64>>2]^-1377402159;ha=c[a+64+4>>2]^1359893119;aa=c[a+72>>2]^725511199;W=c[a+72+4>>2]^-1694144372;e=c[a+80>>2]^-79577749;Y=c[a+80+4>>2]^528734635;ka=c[a+88>>2]^327033209;ga=c[a+88+4>>2]^1541459225;c[P+120>>2]=ka;c[P+120+4>>2]=ga;U=c[P+32>>2]|0;da=c[P+32+4>>2]|0;la=go(U|0,da|0,c[P>>2]|0,c[P+4>>2]|0)|0;la=go(la|0,D|0,o|0,x|0)|0;ja=D;Z=go(ha^ja|0,f^la|0,-205731576,1779033703)|0;ea=D;_=Mm(U^Z|0,da^ea|0,24)|0;X=D;da=Km(U^Z|0,da^ea|0,40)|0;X=D|X;U=go(da|_|0,X|0,la|0,ja|0)|0;U=go(U|0,D|0,L|0,l|0)|0;Q=D;c[P>>2]=U;c[P+4>>2]=Q;$=Mm(ha^ja^U|0,f^la^Q|0,16)|0;g=D;la=Km(ha^ja^U|0,f^la^Q|0,48)|0;g=D|g;c[P+96>>2]=la|$;c[P+96+4>>2]=g;ea=go(la|$|0,g|0,Z|0,ea|0)|0;Z=D;c[P+64>>2]=ea;c[P+64+4>>2]=Z;g=Mm((da|_)^ea|0,X^Z|0,63)|0;$=D;Z=Km((da|_)^ea|0,X^Z|0,1)|0;c[P+32>>2]=Z|g;c[P+32+4>>2]=D|$;$=c[P+40>>2]|0;g=c[P+40+4>>2]|0;Z=go($|0,g|0,c[P+8>>2]|0,c[P+8+4>>2]|0)|0;Z=go(Z|0,D|0,m|0,n|0)|0;X=D;ea=go(W^X|0,aa^Z|0,-2067093701,-1150833019)|0;_=D;da=Mm($^ea|0,g^_|0,24)|0;la=D;g=Km($^ea|0,g^_|0,40)|0;la=D|la;$=go(g|da|0,la|0,Z|0,X|0)|0;$=go($|0,D|0,p|0,q|0)|0;f=D;c[P+8>>2]=$;c[P+8+4>>2]=f;ja=Mm(W^X^$|0,aa^Z^f|0,16)|0;ha=D;Z=Km(W^X^$|0,aa^Z^f|0,48)|0;ha=D|ha;c[P+104>>2]=Z|ja;c[P+104+4>>2]=ha;_=go(Z|ja|0,ha|0,ea|0,_|0)|0;ea=D;c[P+72>>2]=_;c[P+72+4>>2]=ea;ha=Mm((g|da)^_|0,la^ea|0,63)|0;ja=D;ea=Km((g|da)^_|0,la^ea|0,1)|0;ja=D|ja;la=c[P+48>>2]|0;_=c[P+48+4>>2]|0;da=go(la|0,_|0,c[P+16>>2]|0,c[P+16+4>>2]|0)|0;da=go(da|0,D|0,r|0,s|0)|0;g=D;Z=go(Y^g|0,e^da|0,-23791573,1013904242)|0;aa=D;X=Mm(la^Z|0,_^aa|0,24)|0;W=D;_=Km(la^Z|0,_^aa|0,40)|0;W=D|W;la=go(_|X|0,W|0,da|0,g|0)|0;la=go(la|0,D|0,t|0,u|0)|0;V=D;c[P+16>>2]=la;c[P+16+4>>2]=V;ia=Mm(Y^g^la|0,e^da^V|0,16)|0;fa=D;da=Km(Y^g^la|0,e^da^V|0,48)|0;fa=D|fa;c[P+112>>2]=da|ia;c[P+112+4>>2]=fa;aa=go(da|ia|0,fa|0,Z|0,aa|0)|0;Z=D;fa=Mm((_|X)^aa|0,W^Z|0,63)|0;ia=D;W=Km((_|X)^aa|0,W^Z|0,1)|0;ia=D|ia;X=c[P+56>>2]|0;_=c[P+56+4>>2]|0;da=go(X|0,_|0,c[P+24>>2]|0,c[P+24+4>>2]|0)|0;da=go(da|0,D|0,v|0,w|0)|0;e=D;g=go(ga^e|0,ka^da|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;Y=D;R=Mm(X^g|0,_^Y|0,24)|0;ba=D;_=Km(X^g|0,_^Y|0,40)|0;ba=D|ba;X=go(_|R|0,ba|0,da|0,e|0)|0;X=go(X|0,D|0,y|0,z|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;ca=Mm(ga^e^X|0,ka^da^S|0,16)|0;ma=D;da=Km(ga^e^X|0,ka^da^S|0,48)|0;ma=D|ma;Y=go(da|ca|0,ma|0,g|0,Y|0)|0;g=D;ka=Mm((_|R)^Y|0,ba^g|0,63)|0;e=D;ba=Km((_|R)^Y|0,ba^g|0,1)|0;e=D|e;Q=go(ea|ha|0,ja|0,U|0,Q|0)|0;Q=go(Q|0,D|0,A|0,B|0)|0;U=D;Z=go(ma^U|0,(da|ca)^Q|0,aa|0,Z|0)|0;aa=D;R=Mm((ea|ha)^Z|0,ja^aa|0,24)|0;_=D;ja=Km((ea|ha)^Z|0,ja^aa|0,40)|0;_=D|_;ha=go(ja|R|0,_|0,Q|0,U|0)|0;ha=go(ha|0,D|0,C|0,E|0)|0;ea=D;c[P>>2]=ha;c[P+4>>2]=ea;ga=Mm(ma^U^ha|0,(da|ca)^Q^ea|0,16)|0;T=D;Q=Km(ma^U^ha|0,(da|ca)^Q^ea|0,48)|0;T=D|T;c[P+120>>2]=Q|ga;c[P+120+4>>2]=T;aa=go(Q|ga|0,T|0,Z|0,aa|0)|0;Z=D;c[P+80>>2]=aa;c[P+80+4>>2]=Z;T=Mm((ja|R)^aa|0,_^Z|0,63)|0;ga=D;Z=Km((ja|R)^aa|0,_^Z|0,1)|0;c[P+40>>2]=Z|T;c[P+40+4>>2]=D|ga;f=go(W|fa|0,ia|0,$|0,f|0)|0;f=go(f|0,D|0,F|0,G|0)|0;$=D;ga=c[P+96>>2]^f;T=c[P+96+4>>2]^$;g=go(T|0,ga|0,Y|0,g|0)|0;Y=D;Z=Mm((W|fa)^g|0,ia^Y|0,24)|0;_=D;ia=Km((W|fa)^g|0,ia^Y|0,40)|0;_=D|_;$=go(ia|Z|0,_|0,f|0,$|0)|0;$=go($|0,D|0,H|0,I|0)|0;f=D;c[P+8>>2]=$;c[P+8+4>>2]=f;fa=Mm(T^$|0,ga^f|0,16)|0;W=D;ga=Km(T^$|0,ga^f|0,48)|0;W=D|W;Y=go(ga|fa|0,W|0,g|0,Y|0)|0;g=D;c[P+88>>2]=Y;c[P+88+4>>2]=g;T=Mm((ia|Z)^Y|0,_^g|0,63)|0;aa=D;g=Km((ia|Z)^Y|0,_^g|0,1)|0;c[P+48>>2]=g|T;c[P+48+4>>2]=D|aa;V=go(ba|ka|0,e|0,la|0,V|0)|0;V=go(V|0,D|0,J|0,K|0)|0;la=D;aa=c[P+104>>2]^V;T=c[P+104+4>>2]^la;g=go(T|0,aa|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;_=D;Y=Mm((ba|ka)^g|0,e^_|0,24)|0;Z=D;e=Km((ba|ka)^g|0,e^_|0,40)|0;Z=D|Z;la=go(e|Y|0,Z|0,V|0,la|0)|0;la=go(la|0,D|0,M|0,N|0)|0;V=D;c[P+16>>2]=la;c[P+16+4>>2]=V;ka=Mm(T^la|0,aa^V|0,16)|0;ba=D;aa=Km(T^la|0,aa^V|0,48)|0;ba=D|ba;_=go(aa|ka|0,ba|0,g|0,_|0)|0;g=D;T=Mm((e|Y)^_|0,Z^g|0,63)|0;ia=D;Z=Km((e|Y)^_|0,Z^g|0,1)|0;c[P+56>>2]=Z|T;c[P+56+4>>2]=D|ia;ia=c[P+32>>2]|0;T=c[P+32+4>>2]|0;S=go(ia|0,T|0,X|0,S|0)|0;S=go(S|0,D|0,h|0,j|0)|0;X=D;Z=c[P+112>>2]^S;Y=c[P+112+4>>2]^X;e=go(Y|0,Z|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;R=D;ja=Mm(ia^e|0,T^R|0,24)|0;Q=D;T=Km(ia^e|0,T^R|0,40)|0;Q=D|Q;X=go(T|ja|0,Q|0,S|0,X|0)|0;X=go(X|0,D|0,k|0,b|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;ia=Mm(Y^X|0,Z^S|0,16)|0;ca=D;Z=Km(Y^X|0,Z^S|0,48)|0;ca=D|ca;R=go(Z|ia|0,ca|0,e|0,R|0)|0;e=D;Y=Mm((T|ja)^R|0,Q^e|0,63)|0;da=D;Q=Km((T|ja)^R|0,Q^e|0,1)|0;da=D|da;ea=go(Q|Y|0,da|0,ha|0,ea|0)|0;ea=go(ea|0,D|0,h|0,j|0)|0;ha=D;g=go(W^ha|0,(ga|fa)^ea|0,_|0,g|0)|0;_=D;ja=Mm((Q|Y)^g|0,da^_|0,24)|0;T=D;da=Km((Q|Y)^g|0,da^_|0,40)|0;T=D|T;Y=go(da|ja|0,T|0,ea|0,ha|0)|0;Y=go(Y|0,D|0,F|0,G|0)|0;Q=D;c[P>>2]=Y;c[P+4>>2]=Q;U=Mm(W^ha^Y|0,(ga|fa)^ea^Q|0,16)|0;ma=D;ea=Km(W^ha^Y|0,(ga|fa)^ea^Q|0,48)|0;ma=D|ma;c[P+96>>2]=ea|U;c[P+96+4>>2]=ma;_=go(ea|U|0,ma|0,g|0,_|0)|0;g=D;c[P+64>>2]=_;c[P+64+4>>2]=g;ma=Mm((da|ja)^_|0,T^g|0,63)|0;U=D;g=Km((da|ja)^_|0,T^g|0,1)|0;c[P+32>>2]=g|ma;c[P+32+4>>2]=D|U;U=c[P+40>>2]|0;ma=c[P+40+4>>2]|0;f=go(U|0,ma|0,$|0,f|0)|0;f=go(f|0,D|0,r|0,s|0)|0;$=D;e=go(ba^$|0,(aa|ka)^f|0,R|0,e|0)|0;R=D;g=Mm(U^e|0,ma^R|0,24)|0;T=D;ma=Km(U^e|0,ma^R|0,40)|0;T=D|T;U=go(ma|g|0,T|0,f|0,$|0)|0;U=go(U|0,D|0,A|0,B|0)|0;_=D;c[P+8>>2]=U;c[P+8+4>>2]=_;ja=Mm(ba^$^U|0,(aa|ka)^f^_|0,16)|0;da=D;f=Km(ba^$^U|0,(aa|ka)^f^_|0,48)|0;da=D|da;c[P+104>>2]=f|ja;c[P+104+4>>2]=da;R=go(f|ja|0,da|0,e|0,R|0)|0;e=D;c[P+72>>2]=R;c[P+72+4>>2]=e;da=Mm((ma|g)^R|0,T^e|0,63)|0;ja=D;e=Km((ma|g)^R|0,T^e|0,1)|0;ja=D|ja;T=c[P+48>>2]|0;R=c[P+48+4>>2]|0;V=go(T|0,R|0,la|0,V|0)|0;V=go(V|0,D|0,C|0,E|0)|0;la=D;g=go(ca^la|0,(Z|ia)^V|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;ma=D;f=Mm(T^g|0,R^ma|0,24)|0;ka=D;R=Km(T^g|0,R^ma|0,40)|0;ka=D|ka;T=go(R|f|0,ka|0,V|0,la|0)|0;T=go(T|0,D|0,k|0,b|0)|0;aa=D;c[P+16>>2]=T;c[P+16+4>>2]=aa;$=Mm(ca^la^T|0,(Z|ia)^V^aa|0,16)|0;ba=D;V=Km(ca^la^T|0,(Z|ia)^V^aa|0,48)|0;ba=D|ba;c[P+112>>2]=V|$;c[P+112+4>>2]=ba;ma=go(V|$|0,ba|0,g|0,ma|0)|0;g=D;ba=Mm((R|f)^ma|0,ka^g|0,63)|0;$=D;ka=Km((R|f)^ma|0,ka^g|0,1)|0;$=D|$;f=c[P+56>>2]|0;R=c[P+56+4>>2]|0;S=go(f|0,R|0,X|0,S|0)|0;S=go(S|0,D|0,M|0,N|0)|0;X=D;V=c[P+120>>2]^S;ia=c[P+120+4>>2]^X;Z=go(ia|0,V|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;la=D;ca=Mm(f^Z|0,R^la|0,24)|0;ea=D;R=Km(f^Z|0,R^la|0,40)|0;ea=D|ea;X=go(R|ca|0,ea|0,S|0,X|0)|0;X=go(X|0,D|0,v|0,w|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;f=Mm(ia^X|0,V^S|0,16)|0;fa=D;V=Km(ia^X|0,V^S|0,48)|0;fa=D|fa;la=go(V|f|0,fa|0,Z|0,la|0)|0;Z=D;ia=Mm((R|ca)^la|0,ea^Z|0,63)|0;ga=D;ea=Km((R|ca)^la|0,ea^Z|0,1)|0;ga=D|ga;Q=go(e|da|0,ja|0,Y|0,Q|0)|0;Q=go(Q|0,D|0,L|0,l|0)|0;Y=D;g=go(fa^Y|0,(V|f)^Q|0,ma|0,g|0)|0;ma=D;ca=Mm((e|da)^g|0,ja^ma|0,24)|0;R=D;ja=Km((e|da)^g|0,ja^ma|0,40)|0;R=D|R;da=go(ja|ca|0,R|0,Q|0,Y|0)|0;da=go(da|0,D|0,J|0,K|0)|0;e=D;c[P>>2]=da;c[P+4>>2]=e;ha=Mm(fa^Y^da|0,(V|f)^Q^e|0,16)|0;W=D;Q=Km(fa^Y^da|0,(V|f)^Q^e|0,48)|0;W=D|W;c[P+120>>2]=Q|ha;c[P+120+4>>2]=W;ma=go(Q|ha|0,W|0,g|0,ma|0)|0;g=D;c[P+80>>2]=ma;c[P+80+4>>2]=g;W=Mm((ja|ca)^ma|0,R^g|0,63)|0;ha=D;g=Km((ja|ca)^ma|0,R^g|0,1)|0;c[P+40>>2]=g|W;c[P+40+4>>2]=D|ha;_=go(ka|ba|0,$|0,U|0,_|0)|0;_=go(_|0,D|0,o|0,x|0)|0;U=D;ha=c[P+96>>2]^_;W=c[P+96+4>>2]^U;Z=go(W|0,ha|0,la|0,Z|0)|0;la=D;g=Mm((ka|ba)^Z|0,$^la|0,24)|0;R=D;$=Km((ka|ba)^Z|0,$^la|0,40)|0;R=D|R;U=go($|g|0,R|0,_|0,U|0)|0;U=go(U|0,D|0,m|0,n|0)|0;_=D;c[P+8>>2]=U;c[P+8+4>>2]=_;ba=Mm(W^U|0,ha^_|0,16)|0;ka=D;ha=Km(W^U|0,ha^_|0,48)|0;ka=D|ka;la=go(ha|ba|0,ka|0,Z|0,la|0)|0;Z=D;c[P+88>>2]=la;c[P+88+4>>2]=Z;W=Mm(($|g)^la|0,R^Z|0,63)|0;ma=D;Z=Km(($|g)^la|0,R^Z|0,1)|0;c[P+48>>2]=Z|W;c[P+48+4>>2]=D|ma;aa=go(ea|ia|0,ga|0,T|0,aa|0)|0;aa=go(aa|0,D|0,H|0,I|0)|0;T=D;ma=c[P+104>>2]^aa;W=c[P+104+4>>2]^T;Z=go(W|0,ma|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;R=D;la=Mm((ea|ia)^Z|0,ga^R|0,24)|0;g=D;ga=Km((ea|ia)^Z|0,ga^R|0,40)|0;g=D|g;T=go(ga|la|0,g|0,aa|0,T|0)|0;T=go(T|0,D|0,y|0,z|0)|0;aa=D;c[P+16>>2]=T;c[P+16+4>>2]=aa;ia=Mm(W^T|0,ma^aa|0,16)|0;ea=D;ma=Km(W^T|0,ma^aa|0,48)|0;ea=D|ea;R=go(ma|ia|0,ea|0,Z|0,R|0)|0;Z=D;W=Mm((ga|la)^R|0,g^Z|0,63)|0;$=D;g=Km((ga|la)^R|0,g^Z|0,1)|0;c[P+56>>2]=g|W;c[P+56+4>>2]=D|$;$=c[P+32>>2]|0;W=c[P+32+4>>2]|0;S=go($|0,W|0,X|0,S|0)|0;S=go(S|0,D|0,t|0,u|0)|0;X=D;g=c[P+112>>2]^S;la=c[P+112+4>>2]^X;ga=go(la|0,g|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;ca=D;ja=Mm($^ga|0,W^ca|0,24)|0;Q=D;W=Km($^ga|0,W^ca|0,40)|0;Q=D|Q;X=go(W|ja|0,Q|0,S|0,X|0)|0;X=go(X|0,D|0,p|0,q|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;$=Mm(la^X|0,g^S|0,16)|0;f=D;g=Km(la^X|0,g^S|0,48)|0;f=D|f;ca=go(g|$|0,f|0,ga|0,ca|0)|0;ga=D;la=Mm((W|ja)^ca|0,Q^ga|0,63)|0;V=D;Q=Km((W|ja)^ca|0,Q^ga|0,1)|0;V=D|V;e=go(Q|la|0,V|0,da|0,e|0)|0;e=go(e|0,D|0,H|0,I|0)|0;da=D;Z=go(ka^da|0,(ha|ba)^e|0,R|0,Z|0)|0;R=D;ja=Mm((Q|la)^Z|0,V^R|0,24)|0;W=D;V=Km((Q|la)^Z|0,V^R|0,40)|0;W=D|W;la=go(V|ja|0,W|0,e|0,da|0)|0;la=go(la|0,D|0,A|0,B|0)|0;Q=D;c[P>>2]=la;c[P+4>>2]=Q;Y=Mm(ka^da^la|0,(ha|ba)^e^Q|0,16)|0;fa=D;e=Km(ka^da^la|0,(ha|ba)^e^Q|0,48)|0;fa=D|fa;c[P+96>>2]=e|Y;c[P+96+4>>2]=fa;R=go(e|Y|0,fa|0,Z|0,R|0)|0;Z=D;c[P+64>>2]=R;c[P+64+4>>2]=Z;fa=Mm((V|ja)^R|0,W^Z|0,63)|0;Y=D;Z=Km((V|ja)^R|0,W^Z|0,1)|0;c[P+32>>2]=Z|fa;c[P+32+4>>2]=D|Y;Y=c[P+40>>2]|0;fa=c[P+40+4>>2]|0;_=go(Y|0,fa|0,U|0,_|0)|0;_=go(_|0,D|0,J|0,K|0)|0;U=D;ga=go(ea^U|0,(ma|ia)^_|0,ca|0,ga|0)|0;ca=D;Z=Mm(Y^ga|0,fa^ca|0,24)|0;W=D;fa=Km(Y^ga|0,fa^ca|0,40)|0;W=D|W;Y=go(fa|Z|0,W|0,_|0,U|0)|0;Y=go(Y|0,D|0,o|0,x|0)|0;R=D;c[P+8>>2]=Y;c[P+8+4>>2]=R;ja=Mm(ea^U^Y|0,(ma|ia)^_^R|0,16)|0;V=D;_=Km(ea^U^Y|0,(ma|ia)^_^R|0,48)|0;V=D|V;c[P+104>>2]=_|ja;c[P+104+4>>2]=V;ca=go(_|ja|0,V|0,ga|0,ca|0)|0;ga=D;c[P+72>>2]=ca;c[P+72+4>>2]=ga;V=Mm((fa|Z)^ca|0,W^ga|0,63)|0;ja=D;ga=Km((fa|Z)^ca|0,W^ga|0,1)|0;ja=D|ja;W=c[P+48>>2]|0;ca=c[P+48+4>>2]|0;aa=go(W|0,ca|0,T|0,aa|0)|0;aa=go(aa|0,D|0,t|0,u|0)|0;T=D;Z=go(f^T|0,(g|$)^aa|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;fa=D;_=Mm(W^Z|0,ca^fa|0,24)|0;ia=D;ca=Km(W^Z|0,ca^fa|0,40)|0;ia=D|ia;W=go(ca|_|0,ia|0,aa|0,T|0)|0;W=go(W|0,D|0,m|0,n|0)|0;ma=D;c[P+16>>2]=W;c[P+16+4>>2]=ma;U=Mm(f^T^W|0,(g|$)^aa^ma|0,16)|0;ea=D;aa=Km(f^T^W|0,(g|$)^aa^ma|0,48)|0;ea=D|ea;c[P+112>>2]=aa|U;c[P+112+4>>2]=ea;fa=go(aa|U|0,ea|0,Z|0,fa|0)|0;Z=D;ea=Mm((ca|_)^fa|0,ia^Z|0,63)|0;U=D;ia=Km((ca|_)^fa|0,ia^Z|0,1)|0;U=D|U;_=c[P+56>>2]|0;ca=c[P+56+4>>2]|0;S=go(_|0,ca|0,X|0,S|0)|0;S=go(S|0,D|0,k|0,b|0)|0;X=D;aa=c[P+120>>2]^S;$=c[P+120+4>>2]^X;g=go($|0,aa|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;T=D;f=Mm(_^g|0,ca^T|0,24)|0;e=D;ca=Km(_^g|0,ca^T|0,40)|0;e=D|e;X=go(ca|f|0,e|0,S|0,X|0)|0;X=go(X|0,D|0,M|0,N|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;_=Mm($^X|0,aa^S|0,16)|0;ba=D;aa=Km($^X|0,aa^S|0,48)|0;ba=D|ba;T=go(aa|_|0,ba|0,g|0,T|0)|0;g=D;$=Mm((ca|f)^T|0,e^g|0,63)|0;ha=D;e=Km((ca|f)^T|0,e^g|0,1)|0;ha=D|ha;Q=go(ga|V|0,ja|0,la|0,Q|0)|0;Q=go(Q|0,D|0,F|0,G|0)|0;la=D;Z=go(ba^la|0,(aa|_)^Q|0,fa|0,Z|0)|0;fa=D;f=Mm((ga|V)^Z|0,ja^fa|0,24)|0;ca=D;ja=Km((ga|V)^Z|0,ja^fa|0,40)|0;ca=D|ca;V=go(ja|f|0,ca|0,Q|0,la|0)|0;V=go(V|0,D|0,h|0,j|0)|0;ga=D;c[P>>2]=V;c[P+4>>2]=ga;da=Mm(ba^la^V|0,(aa|_)^Q^ga|0,16)|0;ka=D;Q=Km(ba^la^V|0,(aa|_)^Q^ga|0,48)|0;ka=D|ka;c[P+120>>2]=Q|da;c[P+120+4>>2]=ka;fa=go(Q|da|0,ka|0,Z|0,fa|0)|0;Z=D;c[P+80>>2]=fa;c[P+80+4>>2]=Z;ka=Mm((ja|f)^fa|0,ca^Z|0,63)|0;da=D;Z=Km((ja|f)^fa|0,ca^Z|0,1)|0;c[P+40>>2]=Z|ka;c[P+40+4>>2]=D|da;R=go(ia|ea|0,U|0,Y|0,R|0)|0;R=go(R|0,D|0,p|0,q|0)|0;Y=D;da=c[P+96>>2]^R;ka=c[P+96+4>>2]^Y;g=go(ka|0,da|0,T|0,g|0)|0;T=D;Z=Mm((ia|ea)^g|0,U^T|0,24)|0;ca=D;U=Km((ia|ea)^g|0,U^T|0,40)|0;ca=D|ca;Y=go(U|Z|0,ca|0,R|0,Y|0)|0;Y=go(Y|0,D|0,v|0,w|0)|0;R=D;c[P+8>>2]=Y;c[P+8+4>>2]=R;ea=Mm(ka^Y|0,da^R|0,16)|0;ia=D;da=Km(ka^Y|0,da^R|0,48)|0;ia=D|ia;T=go(da|ea|0,ia|0,g|0,T|0)|0;g=D;c[P+88>>2]=T;c[P+88+4>>2]=g;ka=Mm((U|Z)^T|0,ca^g|0,63)|0;fa=D;g=Km((U|Z)^T|0,ca^g|0,1)|0;c[P+48>>2]=g|ka;c[P+48+4>>2]=D|fa;ma=go(e|$|0,ha|0,W|0,ma|0)|0;ma=go(ma|0,D|0,y|0,z|0)|0;W=D;fa=c[P+104>>2]^ma;ka=c[P+104+4>>2]^W;g=go(ka|0,fa|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;ca=D;T=Mm((e|$)^g|0,ha^ca|0,24)|0;Z=D;ha=Km((e|$)^g|0,ha^ca|0,40)|0;Z=D|Z;W=go(ha|T|0,Z|0,ma|0,W|0)|0;W=go(W|0,D|0,L|0,l|0)|0;ma=D;c[P+16>>2]=W;c[P+16+4>>2]=ma;$=Mm(ka^W|0,fa^ma|0,16)|0;e=D;fa=Km(ka^W|0,fa^ma|0,48)|0;e=D|e;ca=go(fa|$|0,e|0,g|0,ca|0)|0;g=D;ka=Mm((ha|T)^ca|0,Z^g|0,63)|0;U=D;Z=Km((ha|T)^ca|0,Z^g|0,1)|0;c[P+56>>2]=Z|ka;c[P+56+4>>2]=D|U;U=c[P+32>>2]|0;ka=c[P+32+4>>2]|0;S=go(U|0,ka|0,X|0,S|0)|0;S=go(S|0,D|0,C|0,E|0)|0;X=D;Z=c[P+112>>2]^S;T=c[P+112+4>>2]^X;ha=go(T|0,Z|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;f=D;ja=Mm(U^ha|0,ka^f|0,24)|0;Q=D;ka=Km(U^ha|0,ka^f|0,40)|0;Q=D|Q;X=go(ka|ja|0,Q|0,S|0,X|0)|0;X=go(X|0,D|0,r|0,s|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;U=Mm(T^X|0,Z^S|0,16)|0;_=D;Z=Km(T^X|0,Z^S|0,48)|0;_=D|_;f=go(Z|U|0,_|0,ha|0,f|0)|0;ha=D;T=Mm((ka|ja)^f|0,Q^ha|0,63)|0;aa=D;Q=Km((ka|ja)^f|0,Q^ha|0,1)|0;aa=D|aa;ga=go(Q|T|0,aa|0,V|0,ga|0)|0;ga=go(ga|0,D|0,y|0,z|0)|0;V=D;g=go(ia^V|0,(da|ea)^ga|0,ca|0,g|0)|0;ca=D;ja=Mm((Q|T)^g|0,aa^ca|0,24)|0;ka=D;aa=Km((Q|T)^g|0,aa^ca|0,40)|0;ka=D|ka;T=go(aa|ja|0,ka|0,ga|0,V|0)|0;T=go(T|0,D|0,C|0,E|0)|0;Q=D;c[P>>2]=T;c[P+4>>2]=Q;la=Mm(ia^V^T|0,(da|ea)^ga^Q|0,16)|0;ba=D;ga=Km(ia^V^T|0,(da|ea)^ga^Q|0,48)|0;ba=D|ba;c[P+96>>2]=ga|la;c[P+96+4>>2]=ba;ca=go(ga|la|0,ba|0,g|0,ca|0)|0;g=D;c[P+64>>2]=ca;c[P+64+4>>2]=g;ba=Mm((aa|ja)^ca|0,ka^g|0,63)|0;la=D;g=Km((aa|ja)^ca|0,ka^g|0,1)|0;c[P+32>>2]=g|ba;c[P+32+4>>2]=D|la;la=c[P+40>>2]|0;ba=c[P+40+4>>2]|0;R=go(la|0,ba|0,Y|0,R|0)|0;R=go(R|0,D|0,p|0,q|0)|0;Y=D;ha=go(e^Y|0,(fa|$)^R|0,f|0,ha|0)|0;f=D;g=Mm(la^ha|0,ba^f|0,24)|0;ka=D;ba=Km(la^ha|0,ba^f|0,40)|0;ka=D|ka;la=go(ba|g|0,ka|0,R|0,Y|0)|0;la=go(la|0,D|0,L|0,l|0)|0;ca=D;c[P+8>>2]=la;c[P+8+4>>2]=ca;ja=Mm(e^Y^la|0,(fa|$)^R^ca|0,16)|0;aa=D;R=Km(e^Y^la|0,(fa|$)^R^ca|0,48)|0;aa=D|aa;c[P+104>>2]=R|ja;c[P+104+4>>2]=aa;f=go(R|ja|0,aa|0,ha|0,f|0)|0;ha=D;c[P+72>>2]=f;c[P+72+4>>2]=ha;aa=Mm((ba|g)^f|0,ka^ha|0,63)|0;ja=D;ha=Km((ba|g)^f|0,ka^ha|0,1)|0;ja=D|ja;ka=c[P+48>>2]|0;f=c[P+48+4>>2]|0;ma=go(ka|0,f|0,W|0,ma|0)|0;ma=go(ma|0,D|0,M|0,N|0)|0;W=D;g=go(_^W|0,(Z|U)^ma|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;ba=D;R=Mm(ka^g|0,f^ba|0,24)|0;$=D;f=Km(ka^g|0,f^ba|0,40)|0;$=D|$;ka=go(f|R|0,$|0,ma|0,W|0)|0;ka=go(ka|0,D|0,J|0,K|0)|0;fa=D;c[P+16>>2]=ka;c[P+16+4>>2]=fa;Y=Mm(_^W^ka|0,(Z|U)^ma^fa|0,16)|0;e=D;ma=Km(_^W^ka|0,(Z|U)^ma^fa|0,48)|0;e=D|e;c[P+112>>2]=ma|Y;c[P+112+4>>2]=e;ba=go(ma|Y|0,e|0,g|0,ba|0)|0;g=D;e=Mm((f|R)^ba|0,$^g|0,63)|0;Y=D;$=Km((f|R)^ba|0,$^g|0,1)|0;Y=D|Y;R=c[P+56>>2]|0;f=c[P+56+4>>2]|0;S=go(R|0,f|0,X|0,S|0)|0;S=go(S|0,D|0,H|0,I|0)|0;X=D;ma=c[P+120>>2]^S;U=c[P+120+4>>2]^X;Z=go(U|0,ma|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;W=D;_=Mm(R^Z|0,f^W|0,24)|0;ga=D;f=Km(R^Z|0,f^W|0,40)|0;ga=D|ga;X=go(f|_|0,ga|0,S|0,X|0)|0;X=go(X|0,D|0,h|0,j|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;R=Mm(U^X|0,ma^S|0,16)|0;ea=D;ma=Km(U^X|0,ma^S|0,48)|0;ea=D|ea;W=go(ma|R|0,ea|0,Z|0,W|0)|0;Z=D;U=Mm((f|_)^W|0,ga^Z|0,63)|0;da=D;ga=Km((f|_)^W|0,ga^Z|0,1)|0;da=D|da;Q=go(ha|aa|0,ja|0,T|0,Q|0)|0;Q=go(Q|0,D|0,m|0,n|0)|0;T=D;g=go(ea^T|0,(ma|R)^Q|0,ba|0,g|0)|0;ba=D;_=Mm((ha|aa)^g|0,ja^ba|0,24)|0;f=D;ja=Km((ha|aa)^g|0,ja^ba|0,40)|0;f=D|f;aa=go(ja|_|0,f|0,Q|0,T|0)|0;aa=go(aa|0,D|0,v|0,w|0)|0;ha=D;c[P>>2]=aa;c[P+4>>2]=ha;V=Mm(ea^T^aa|0,(ma|R)^Q^ha|0,16)|0;ia=D;Q=Km(ea^T^aa|0,(ma|R)^Q^ha|0,48)|0;ia=D|ia;c[P+120>>2]=Q|V;c[P+120+4>>2]=ia;ba=go(Q|V|0,ia|0,g|0,ba|0)|0;g=D;c[P+80>>2]=ba;c[P+80+4>>2]=g;ia=Mm((ja|_)^ba|0,f^g|0,63)|0;V=D;g=Km((ja|_)^ba|0,f^g|0,1)|0;c[P+40>>2]=g|ia;c[P+40+4>>2]=D|V;ca=go($|e|0,Y|0,la|0,ca|0)|0;ca=go(ca|0,D|0,t|0,u|0)|0;la=D;V=c[P+96>>2]^ca;ia=c[P+96+4>>2]^la;Z=go(ia|0,V|0,W|0,Z|0)|0;W=D;g=Mm(($|e)^Z|0,Y^W|0,24)|0;f=D;Y=Km(($|e)^Z|0,Y^W|0,40)|0;f=D|f;la=go(Y|g|0,f|0,ca|0,la|0)|0;la=go(la|0,D|0,F|0,G|0)|0;ca=D;c[P+8>>2]=la;c[P+8+4>>2]=ca;e=Mm(ia^la|0,V^ca|0,16)|0;$=D;V=Km(ia^la|0,V^ca|0,48)|0;$=D|$;W=go(V|e|0,$|0,Z|0,W|0)|0;Z=D;c[P+88>>2]=W;c[P+88+4>>2]=Z;ia=Mm((Y|g)^W|0,f^Z|0,63)|0;ba=D;Z=Km((Y|g)^W|0,f^Z|0,1)|0;c[P+48>>2]=Z|ia;c[P+48+4>>2]=D|ba;fa=go(ga|U|0,da|0,ka|0,fa|0)|0;fa=go(fa|0,D|0,r|0,s|0)|0;ka=D;ba=c[P+104>>2]^fa;ia=c[P+104+4>>2]^ka;Z=go(ia|0,ba|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;f=D;W=Mm((ga|U)^Z|0,da^f|0,24)|0;g=D;da=Km((ga|U)^Z|0,da^f|0,40)|0;g=D|g;ka=go(da|W|0,g|0,fa|0,ka|0)|0;ka=go(ka|0,D|0,o|0,x|0)|0;fa=D;c[P+16>>2]=ka;c[P+16+4>>2]=fa;U=Mm(ia^ka|0,ba^fa|0,16)|0;ga=D;ba=Km(ia^ka|0,ba^fa|0,48)|0;ga=D|ga;f=go(ba|U|0,ga|0,Z|0,f|0)|0;Z=D;ia=Mm((da|W)^f|0,g^Z|0,63)|0;Y=D;g=Km((da|W)^f|0,g^Z|0,1)|0;c[P+56>>2]=g|ia;c[P+56+4>>2]=D|Y;Y=c[P+32>>2]|0;ia=c[P+32+4>>2]|0;S=go(Y|0,ia|0,X|0,S|0)|0;S=go(S|0,D|0,k|0,b|0)|0;X=D;g=c[P+112>>2]^S;W=c[P+112+4>>2]^X;da=go(W|0,g|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;_=D;ja=Mm(Y^da|0,ia^_|0,24)|0;Q=D;ia=Km(Y^da|0,ia^_|0,40)|0;Q=D|Q;X=go(ia|ja|0,Q|0,S|0,X|0)|0;X=go(X|0,D|0,A|0,B|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;Y=Mm(W^X|0,g^S|0,16)|0;R=D;g=Km(W^X|0,g^S|0,48)|0;R=D|R;_=go(g|Y|0,R|0,da|0,_|0)|0;da=D;W=Mm((ia|ja)^_|0,Q^da|0,63)|0;ma=D;Q=Km((ia|ja)^_|0,Q^da|0,1)|0;ma=D|ma;ha=go(Q|W|0,ma|0,aa|0,ha|0)|0;ha=go(ha|0,D|0,C|0,E|0)|0;aa=D;Z=go($^aa|0,(V|e)^ha|0,f|0,Z|0)|0;f=D;ja=Mm((Q|W)^Z|0,ma^f|0,24)|0;ia=D;ma=Km((Q|W)^Z|0,ma^f|0,40)|0;ia=D|ia;W=go(ma|ja|0,ia|0,ha|0,aa|0)|0;W=go(W|0,D|0,o|0,x|0)|0;Q=D;c[P>>2]=W;c[P+4>>2]=Q;T=Mm($^aa^W|0,(V|e)^ha^Q|0,16)|0;ea=D;ha=Km($^aa^W|0,(V|e)^ha^Q|0,48)|0;ea=D|ea;c[P+96>>2]=ha|T;c[P+96+4>>2]=ea;f=go(ha|T|0,ea|0,Z|0,f|0)|0;Z=D;c[P+64>>2]=f;c[P+64+4>>2]=Z;ea=Mm((ma|ja)^f|0,ia^Z|0,63)|0;T=D;Z=Km((ma|ja)^f|0,ia^Z|0,1)|0;c[P+32>>2]=Z|ea;c[P+32+4>>2]=D|T;T=c[P+40>>2]|0;ea=c[P+40+4>>2]|0;ca=go(T|0,ea|0,la|0,ca|0)|0;ca=go(ca|0,D|0,t|0,u|0)|0;la=D;da=go(ga^la|0,(ba|U)^ca|0,_|0,da|0)|0;_=D;Z=Mm(T^da|0,ea^_|0,24)|0;ia=D;ea=Km(T^da|0,ea^_|0,40)|0;ia=D|ia;T=go(ea|Z|0,ia|0,ca|0,la|0)|0;T=go(T|0,D|0,y|0,z|0)|0;f=D;c[P+8>>2]=T;c[P+8+4>>2]=f;ja=Mm(ga^la^T|0,(ba|U)^ca^f|0,16)|0;ma=D;ca=Km(ga^la^T|0,(ba|U)^ca^f|0,48)|0;ma=D|ma;c[P+104>>2]=ca|ja;c[P+104+4>>2]=ma;_=go(ca|ja|0,ma|0,da|0,_|0)|0;da=D;c[P+72>>2]=_;c[P+72+4>>2]=da;ma=Mm((ea|Z)^_|0,ia^da|0,63)|0;ja=D;da=Km((ea|Z)^_|0,ia^da|0,1)|0;ja=D|ja;ia=c[P+48>>2]|0;_=c[P+48+4>>2]|0;fa=go(ia|0,_|0,ka|0,fa|0)|0;fa=go(fa|0,D|0,m|0,n|0)|0;ka=D;Z=go(R^ka|0,(g|Y)^fa|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;ea=D;ca=Mm(ia^Z|0,_^ea|0,24)|0;U=D;_=Km(ia^Z|0,_^ea|0,40)|0;U=D|U;ia=go(_|ca|0,U|0,fa|0,ka|0)|0;ia=go(ia|0,D|0,r|0,s|0)|0;ba=D;c[P+16>>2]=ia;c[P+16+4>>2]=ba;la=Mm(R^ka^ia|0,(g|Y)^fa^ba|0,16)|0;ga=D;fa=Km(R^ka^ia|0,(g|Y)^fa^ba|0,48)|0;ga=D|ga;c[P+112>>2]=fa|la;c[P+112+4>>2]=ga;ea=go(fa|la|0,ga|0,Z|0,ea|0)|0;Z=D;ga=Mm((_|ca)^ea|0,U^Z|0,63)|0;la=D;U=Km((_|ca)^ea|0,U^Z|0,1)|0;la=D|la;ca=c[P+56>>2]|0;_=c[P+56+4>>2]|0;S=go(ca|0,_|0,X|0,S|0)|0;S=go(S|0,D|0,F|0,G|0)|0;X=D;fa=c[P+120>>2]^S;Y=c[P+120+4>>2]^X;g=go(Y|0,fa|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;ka=D;R=Mm(ca^g|0,_^ka|0,24)|0;ha=D;_=Km(ca^g|0,_^ka|0,40)|0;ha=D|ha;X=go(_|R|0,ha|0,S|0,X|0)|0;X=go(X|0,D|0,k|0,b|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;ca=Mm(Y^X|0,fa^S|0,16)|0;e=D;fa=Km(Y^X|0,fa^S|0,48)|0;e=D|e;ka=go(fa|ca|0,e|0,g|0,ka|0)|0;g=D;Y=Mm((_|R)^ka|0,ha^g|0,63)|0;V=D;ha=Km((_|R)^ka|0,ha^g|0,1)|0;V=D|V;Q=go(da|ma|0,ja|0,W|0,Q|0)|0;Q=go(Q|0,D|0,h|0,j|0)|0;W=D;Z=go(e^W|0,(fa|ca)^Q|0,ea|0,Z|0)|0;ea=D;R=Mm((da|ma)^Z|0,ja^ea|0,24)|0;_=D;ja=Km((da|ma)^Z|0,ja^ea|0,40)|0;_=D|_;ma=go(ja|R|0,_|0,Q|0,W|0)|0;ma=go(ma|0,D|0,L|0,l|0)|0;da=D;c[P>>2]=ma;c[P+4>>2]=da;aa=Mm(e^W^ma|0,(fa|ca)^Q^da|0,16)|0;$=D;Q=Km(e^W^ma|0,(fa|ca)^Q^da|0,48)|0;$=D|$;c[P+120>>2]=Q|aa;c[P+120+4>>2]=$;ea=go(Q|aa|0,$|0,Z|0,ea|0)|0;Z=D;c[P+80>>2]=ea;c[P+80+4>>2]=Z;$=Mm((ja|R)^ea|0,_^Z|0,63)|0;aa=D;Z=Km((ja|R)^ea|0,_^Z|0,1)|0;c[P+40>>2]=Z|$;c[P+40+4>>2]=D|aa;f=go(U|ga|0,la|0,T|0,f|0)|0;f=go(f|0,D|0,H|0,I|0)|0;T=D;aa=c[P+96>>2]^f;$=c[P+96+4>>2]^T;g=go($|0,aa|0,ka|0,g|0)|0;ka=D;Z=Mm((U|ga)^g|0,la^ka|0,24)|0;_=D;la=Km((U|ga)^g|0,la^ka|0,40)|0;_=D|_;T=go(la|Z|0,_|0,f|0,T|0)|0;T=go(T|0,D|0,J|0,K|0)|0;f=D;c[P+8>>2]=T;c[P+8+4>>2]=f;ga=Mm($^T|0,aa^f|0,16)|0;U=D;aa=Km($^T|0,aa^f|0,48)|0;U=D|U;ka=go(aa|ga|0,U|0,g|0,ka|0)|0;g=D;c[P+88>>2]=ka;c[P+88+4>>2]=g;$=Mm((la|Z)^ka|0,_^g|0,63)|0;ea=D;g=Km((la|Z)^ka|0,_^g|0,1)|0;c[P+48>>2]=g|$;c[P+48+4>>2]=D|ea;ba=go(ha|Y|0,V|0,ia|0,ba|0)|0;ba=go(ba|0,D|0,v|0,w|0)|0;ia=D;ea=c[P+104>>2]^ba;$=c[P+104+4>>2]^ia;g=go($|0,ea|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;_=D;ka=Mm((ha|Y)^g|0,V^_|0,24)|0;Z=D;V=Km((ha|Y)^g|0,V^_|0,40)|0;Z=D|Z;ia=go(V|ka|0,Z|0,ba|0,ia|0)|0;ia=go(ia|0,D|0,A|0,B|0)|0;ba=D;c[P+16>>2]=ia;c[P+16+4>>2]=ba;Y=Mm($^ia|0,ea^ba|0,16)|0;ha=D;ea=Km($^ia|0,ea^ba|0,48)|0;ha=D|ha;_=go(ea|Y|0,ha|0,g|0,_|0)|0;g=D;$=Mm((V|ka)^_|0,Z^g|0,63)|0;la=D;Z=Km((V|ka)^_|0,Z^g|0,1)|0;c[P+56>>2]=Z|$;c[P+56+4>>2]=D|la;la=c[P+32>>2]|0;$=c[P+32+4>>2]|0;S=go(la|0,$|0,X|0,S|0)|0;S=go(S|0,D|0,p|0,q|0)|0;X=D;Z=c[P+112>>2]^S;ka=c[P+112+4>>2]^X;V=go(ka|0,Z|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;R=D;ja=Mm(la^V|0,$^R|0,24)|0;Q=D;$=Km(la^V|0,$^R|0,40)|0;Q=D|Q;X=go($|ja|0,Q|0,S|0,X|0)|0;X=go(X|0,D|0,M|0,N|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;la=Mm(ka^X|0,Z^S|0,16)|0;ca=D;Z=Km(ka^X|0,Z^S|0,48)|0;ca=D|ca;R=go(Z|la|0,ca|0,V|0,R|0)|0;V=D;ka=Mm(($|ja)^R|0,Q^V|0,63)|0;fa=D;Q=Km(($|ja)^R|0,Q^V|0,1)|0;fa=D|fa;da=go(Q|ka|0,fa|0,ma|0,da|0)|0;da=go(da|0,D|0,m|0,n|0)|0;ma=D;g=go(U^ma|0,(aa|ga)^da|0,_|0,g|0)|0;_=D;ja=Mm((Q|ka)^g|0,fa^_|0,24)|0;$=D;fa=Km((Q|ka)^g|0,fa^_|0,40)|0;$=D|$;ka=go(fa|ja|0,$|0,da|0,ma|0)|0;ka=go(ka|0,D|0,J|0,K|0)|0;Q=D;c[P>>2]=ka;c[P+4>>2]=Q;W=Mm(U^ma^ka|0,(aa|ga)^da^Q|0,16)|0;e=D;da=Km(U^ma^ka|0,(aa|ga)^da^Q|0,48)|0;e=D|e;c[P+96>>2]=da|W;c[P+96+4>>2]=e;_=go(da|W|0,e|0,g|0,_|0)|0;g=D;c[P+64>>2]=_;c[P+64+4>>2]=g;e=Mm((fa|ja)^_|0,$^g|0,63)|0;W=D;g=Km((fa|ja)^_|0,$^g|0,1)|0;c[P+32>>2]=g|e;c[P+32+4>>2]=D|W;W=c[P+40>>2]|0;e=c[P+40+4>>2]|0;f=go(W|0,e|0,T|0,f|0)|0;f=go(f|0,D|0,v|0,w|0)|0;T=D;V=go(ha^T|0,(ea|Y)^f|0,R|0,V|0)|0;R=D;g=Mm(W^V|0,e^R|0,24)|0;$=D;e=Km(W^V|0,e^R|0,40)|0;$=D|$;W=go(e|g|0,$|0,f|0,T|0)|0;W=go(W|0,D|0,F|0,G|0)|0;_=D;c[P+8>>2]=W;c[P+8+4>>2]=_;ja=Mm(ha^T^W|0,(ea|Y)^f^_|0,16)|0;fa=D;f=Km(ha^T^W|0,(ea|Y)^f^_|0,48)|0;fa=D|fa;c[P+104>>2]=f|ja;c[P+104+4>>2]=fa;R=go(f|ja|0,fa|0,V|0,R|0)|0;V=D;c[P+72>>2]=R;c[P+72+4>>2]=V;fa=Mm((e|g)^R|0,$^V|0,63)|0;ja=D;V=Km((e|g)^R|0,$^V|0,1)|0;ja=D|ja;$=c[P+48>>2]|0;R=c[P+48+4>>2]|0;ba=go($|0,R|0,ia|0,ba|0)|0;ba=go(ba|0,D|0,o|0,x|0)|0;ia=D;g=go(ca^ia|0,(Z|la)^ba|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;e=D;f=Mm($^g|0,R^e|0,24)|0;Y=D;R=Km($^g|0,R^e|0,40)|0;Y=D|Y;$=go(R|f|0,Y|0,ba|0,ia|0)|0;$=go($|0,D|0,H|0,I|0)|0;ea=D;c[P+16>>2]=$;c[P+16+4>>2]=ea;T=Mm(ca^ia^$|0,(Z|la)^ba^ea|0,16)|0;ha=D;ba=Km(ca^ia^$|0,(Z|la)^ba^ea|0,48)|0;ha=D|ha;c[P+112>>2]=ba|T;c[P+112+4>>2]=ha;e=go(ba|T|0,ha|0,g|0,e|0)|0;g=D;ha=Mm((R|f)^e|0,Y^g|0,63)|0;T=D;Y=Km((R|f)^e|0,Y^g|0,1)|0;T=D|T;f=c[P+56>>2]|0;R=c[P+56+4>>2]|0;S=go(f|0,R|0,X|0,S|0)|0;S=go(S|0,D|0,A|0,B|0)|0;X=D;ba=c[P+120>>2]^S;la=c[P+120+4>>2]^X;Z=go(la|0,ba|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;ia=D;ca=Mm(f^Z|0,R^ia|0,24)|0;da=D;R=Km(f^Z|0,R^ia|0,40)|0;da=D|da;X=go(R|ca|0,da|0,S|0,X|0)|0;X=go(X|0,D|0,p|0,q|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;f=Mm(la^X|0,ba^S|0,16)|0;ga=D;ba=Km(la^X|0,ba^S|0,48)|0;ga=D|ga;ia=go(ba|f|0,ga|0,Z|0,ia|0)|0;Z=D;la=Mm((R|ca)^ia|0,da^Z|0,63)|0;aa=D;da=Km((R|ca)^ia|0,da^Z|0,1)|0;aa=D|aa;Q=go(V|fa|0,ja|0,ka|0,Q|0)|0;Q=go(Q|0,D|0,r|0,s|0)|0;ka=D;g=go(ga^ka|0,(ba|f)^Q|0,e|0,g|0)|0;e=D;ca=Mm((V|fa)^g|0,ja^e|0,24)|0;R=D;ja=Km((V|fa)^g|0,ja^e|0,40)|0;R=D|R;fa=go(ja|ca|0,R|0,Q|0,ka|0)|0;fa=go(fa|0,D|0,M|0,N|0)|0;V=D;c[P>>2]=fa;c[P+4>>2]=V;ma=Mm(ga^ka^fa|0,(ba|f)^Q^V|0,16)|0;U=D;Q=Km(ga^ka^fa|0,(ba|f)^Q^V|0,48)|0;U=D|U;c[P+120>>2]=Q|ma;c[P+120+4>>2]=U;e=go(Q|ma|0,U|0,g|0,e|0)|0;g=D;c[P+80>>2]=e;c[P+80+4>>2]=g;U=Mm((ja|ca)^e|0,R^g|0,63)|0;ma=D;g=Km((ja|ca)^e|0,R^g|0,1)|0;c[P+40>>2]=g|U;c[P+40+4>>2]=D|ma;_=go(Y|ha|0,T|0,W|0,_|0)|0;_=go(_|0,D|0,y|0,z|0)|0;W=D;ma=c[P+96>>2]^_;U=c[P+96+4>>2]^W;Z=go(U|0,ma|0,ia|0,Z|0)|0;ia=D;g=Mm((Y|ha)^Z|0,T^ia|0,24)|0;R=D;T=Km((Y|ha)^Z|0,T^ia|0,40)|0;R=D|R;W=go(T|g|0,R|0,_|0,W|0)|0;W=go(W|0,D|0,t|0,u|0)|0;_=D;c[P+8>>2]=W;c[P+8+4>>2]=_;ha=Mm(U^W|0,ma^_|0,16)|0;Y=D;ma=Km(U^W|0,ma^_|0,48)|0;Y=D|Y;ia=go(ma|ha|0,Y|0,Z|0,ia|0)|0;Z=D;c[P+88>>2]=ia;c[P+88+4>>2]=Z;U=Mm((T|g)^ia|0,R^Z|0,63)|0;e=D;Z=Km((T|g)^ia|0,R^Z|0,1)|0;c[P+48>>2]=Z|U;c[P+48+4>>2]=D|e;ea=go(da|la|0,aa|0,$|0,ea|0)|0;ea=go(ea|0,D|0,k|0,b|0)|0;$=D;e=c[P+104>>2]^ea;U=c[P+104+4>>2]^$;Z=go(U|0,e|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;R=D;ia=Mm((da|la)^Z|0,aa^R|0,24)|0;g=D;aa=Km((da|la)^Z|0,aa^R|0,40)|0;g=D|g;$=go(aa|ia|0,g|0,ea|0,$|0)|0;$=go($|0,D|0,h|0,j|0)|0;ea=D;c[P+16>>2]=$;c[P+16+4>>2]=ea;la=Mm(U^$|0,e^ea|0,16)|0;da=D;e=Km(U^$|0,e^ea|0,48)|0;da=D|da;R=go(e|la|0,da|0,Z|0,R|0)|0;Z=D;U=Mm((aa|ia)^R|0,g^Z|0,63)|0;T=D;g=Km((aa|ia)^R|0,g^Z|0,1)|0;c[P+56>>2]=g|U;c[P+56+4>>2]=D|T;T=c[P+32>>2]|0;U=c[P+32+4>>2]|0;S=go(T|0,U|0,X|0,S|0)|0;S=go(S|0,D|0,L|0,l|0)|0;X=D;g=c[P+112>>2]^S;ia=c[P+112+4>>2]^X;aa=go(ia|0,g|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;ca=D;ja=Mm(T^aa|0,U^ca|0,24)|0;Q=D;U=Km(T^aa|0,U^ca|0,40)|0;Q=D|Q;X=go(U|ja|0,Q|0,S|0,X|0)|0;X=go(X|0,D|0,C|0,E|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;T=Mm(ia^X|0,g^S|0,16)|0;f=D;g=Km(ia^X|0,g^S|0,48)|0;f=D|f;ca=go(g|T|0,f|0,aa|0,ca|0)|0;aa=D;ia=Mm((U|ja)^ca|0,Q^aa|0,63)|0;ba=D;Q=Km((U|ja)^ca|0,Q^aa|0,1)|0;ba=D|ba;V=go(Q|ia|0,ba|0,fa|0,V|0)|0;V=go(V|0,D|0,J|0,K|0)|0;fa=D;Z=go(Y^fa|0,(ma|ha)^V|0,R|0,Z|0)|0;R=D;ja=Mm((Q|ia)^Z|0,ba^R|0,24)|0;U=D;ba=Km((Q|ia)^Z|0,ba^R|0,40)|0;U=D|U;ia=go(ba|ja|0,U|0,V|0,fa|0)|0;ia=go(ia|0,D|0,t|0,u|0)|0;Q=D;c[P>>2]=ia;c[P+4>>2]=Q;ka=Mm(Y^fa^ia|0,(ma|ha)^V^Q|0,16)|0;ga=D;V=Km(Y^fa^ia|0,(ma|ha)^V^Q|0,48)|0;ga=D|ga;c[P+96>>2]=V|ka;c[P+96+4>>2]=ga;R=go(V|ka|0,ga|0,Z|0,R|0)|0;Z=D;c[P+64>>2]=R;c[P+64+4>>2]=Z;ga=Mm((ba|ja)^R|0,U^Z|0,63)|0;ka=D;Z=Km((ba|ja)^R|0,U^Z|0,1)|0;c[P+32>>2]=Z|ga;c[P+32+4>>2]=D|ka;ka=c[P+40>>2]|0;ga=c[P+40+4>>2]|0;_=go(ka|0,ga|0,W|0,_|0)|0;_=go(_|0,D|0,L|0,l|0)|0;W=D;aa=go(da^W|0,(e|la)^_|0,ca|0,aa|0)|0;ca=D;Z=Mm(ka^aa|0,ga^ca|0,24)|0;U=D;ga=Km(ka^aa|0,ga^ca|0,40)|0;U=D|U;ka=go(ga|Z|0,U|0,_|0,W|0)|0;ka=go(ka|0,D|0,k|0,b|0)|0;R=D;c[P+8>>2]=ka;c[P+8+4>>2]=R;ja=Mm(da^W^ka|0,(e|la)^_^R|0,16)|0;ba=D;_=Km(da^W^ka|0,(e|la)^_^R|0,48)|0;ba=D|ba;c[P+104>>2]=_|ja;c[P+104+4>>2]=ba;ca=go(_|ja|0,ba|0,aa|0,ca|0)|0;aa=D;c[P+72>>2]=ca;c[P+72+4>>2]=aa;ba=Mm((ga|Z)^ca|0,U^aa|0,63)|0;ja=D;aa=Km((ga|Z)^ca|0,U^aa|0,1)|0;ja=D|ja;U=c[P+48>>2]|0;ca=c[P+48+4>>2]|0;ea=go(U|0,ca|0,$|0,ea|0)|0;ea=go(ea|0,D|0,h|0,j|0)|0;$=D;Z=go(f^$|0,(g|T)^ea|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;ga=D;_=Mm(U^Z|0,ca^ga|0,24)|0;la=D;ca=Km(U^Z|0,ca^ga|0,40)|0;la=D|la;U=go(ca|_|0,la|0,ea|0,$|0)|0;U=go(U|0,D|0,M|0,N|0)|0;e=D;c[P+16>>2]=U;c[P+16+4>>2]=e;W=Mm(f^$^U|0,(g|T)^ea^e|0,16)|0;da=D;ea=Km(f^$^U|0,(g|T)^ea^e|0,48)|0;da=D|da;c[P+112>>2]=ea|W;c[P+112+4>>2]=da;ga=go(ea|W|0,da|0,Z|0,ga|0)|0;Z=D;da=Mm((ca|_)^ga|0,la^Z|0,63)|0;W=D;la=Km((ca|_)^ga|0,la^Z|0,1)|0;W=D|W;_=c[P+56>>2]|0;ca=c[P+56+4>>2]|0;S=go(_|0,ca|0,X|0,S|0)|0;S=go(S|0,D|0,r|0,s|0)|0;X=D;ea=c[P+120>>2]^S;T=c[P+120+4>>2]^X;g=go(T|0,ea|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;$=D;f=Mm(_^g|0,ca^$|0,24)|0;V=D;ca=Km(_^g|0,ca^$|0,40)|0;V=D|V;X=go(ca|f|0,V|0,S|0,X|0)|0;X=go(X|0,D|0,F|0,G|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;_=Mm(T^X|0,ea^S|0,16)|0;ha=D;ea=Km(T^X|0,ea^S|0,48)|0;ha=D|ha;$=go(ea|_|0,ha|0,g|0,$|0)|0;g=D;T=Mm((ca|f)^$|0,V^g|0,63)|0;ma=D;V=Km((ca|f)^$|0,V^g|0,1)|0;ma=D|ma;Q=go(aa|ba|0,ja|0,ia|0,Q|0)|0;Q=go(Q|0,D|0,o|0,x|0)|0;ia=D;Z=go(ha^ia|0,(ea|_)^Q|0,ga|0,Z|0)|0;ga=D;f=Mm((aa|ba)^Z|0,ja^ga|0,24)|0;ca=D;ja=Km((aa|ba)^Z|0,ja^ga|0,40)|0;ca=D|ca;ba=go(ja|f|0,ca|0,Q|0,ia|0)|0;ba=go(ba|0,D|0,y|0,z|0)|0;aa=D;c[P>>2]=ba;c[P+4>>2]=aa;fa=Mm(ha^ia^ba|0,(ea|_)^Q^aa|0,16)|0;Y=D;Q=Km(ha^ia^ba|0,(ea|_)^Q^aa|0,48)|0;Y=D|Y;c[P+120>>2]=Q|fa;c[P+120+4>>2]=Y;ga=go(Q|fa|0,Y|0,Z|0,ga|0)|0;Z=D;c[P+80>>2]=ga;c[P+80+4>>2]=Z;Y=Mm((ja|f)^ga|0,ca^Z|0,63)|0;fa=D;Z=Km((ja|f)^ga|0,ca^Z|0,1)|0;c[P+40>>2]=Z|Y;c[P+40+4>>2]=D|fa;R=go(la|da|0,W|0,ka|0,R|0)|0;R=go(R|0,D|0,v|0,w|0)|0;ka=D;fa=c[P+96>>2]^R;Y=c[P+96+4>>2]^ka;g=go(Y|0,fa|0,$|0,g|0)|0;$=D;Z=Mm((la|da)^g|0,W^$|0,24)|0;ca=D;W=Km((la|da)^g|0,W^$|0,40)|0;ca=D|ca;ka=go(W|Z|0,ca|0,R|0,ka|0)|0;ka=go(ka|0,D|0,p|0,q|0)|0;R=D;c[P+8>>2]=ka;c[P+8+4>>2]=R;da=Mm(Y^ka|0,fa^R|0,16)|0;la=D;fa=Km(Y^ka|0,fa^R|0,48)|0;la=D|la;$=go(fa|da|0,la|0,g|0,$|0)|0;g=D;c[P+88>>2]=$;c[P+88+4>>2]=g;Y=Mm((W|Z)^$|0,ca^g|0,63)|0;ga=D;g=Km((W|Z)^$|0,ca^g|0,1)|0;c[P+48>>2]=g|Y;c[P+48+4>>2]=D|ga;e=go(V|T|0,ma|0,U|0,e|0)|0;e=go(e|0,D|0,C|0,E|0)|0;U=D;ga=c[P+104>>2]^e;Y=c[P+104+4>>2]^U;g=go(Y|0,ga|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;ca=D;$=Mm((V|T)^g|0,ma^ca|0,24)|0;Z=D;ma=Km((V|T)^g|0,ma^ca|0,40)|0;Z=D|Z;U=go(ma|$|0,Z|0,e|0,U|0)|0;U=go(U|0,D|0,m|0,n|0)|0;e=D;c[P+16>>2]=U;c[P+16+4>>2]=e;T=Mm(Y^U|0,ga^e|0,16)|0;V=D;ga=Km(Y^U|0,ga^e|0,48)|0;V=D|V;ca=go(ga|T|0,V|0,g|0,ca|0)|0;g=D;Y=Mm((ma|$)^ca|0,Z^g|0,63)|0;W=D;Z=Km((ma|$)^ca|0,Z^g|0,1)|0;c[P+56>>2]=Z|Y;c[P+56+4>>2]=D|W;W=c[P+32>>2]|0;Y=c[P+32+4>>2]|0;S=go(W|0,Y|0,X|0,S|0)|0;S=go(S|0,D|0,A|0,B|0)|0;X=D;Z=c[P+112>>2]^S;$=c[P+112+4>>2]^X;ma=go($|0,Z|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;f=D;ja=Mm(W^ma|0,Y^f|0,24)|0;Q=D;Y=Km(W^ma|0,Y^f|0,40)|0;Q=D|Q;X=go(Y|ja|0,Q|0,S|0,X|0)|0;X=go(X|0,D|0,H|0,I|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;W=Mm($^X|0,Z^S|0,16)|0;_=D;Z=Km($^X|0,Z^S|0,48)|0;_=D|_;f=go(Z|W|0,_|0,ma|0,f|0)|0;ma=D;$=Mm((Y|ja)^f|0,Q^ma|0,63)|0;ea=D;Q=Km((Y|ja)^f|0,Q^ma|0,1)|0;ea=D|ea;aa=go(Q|$|0,ea|0,ba|0,aa|0)|0;aa=go(aa|0,D|0,M|0,N|0)|0;ba=D;g=go(la^ba|0,(fa|da)^aa|0,ca|0,g|0)|0;ca=D;ja=Mm((Q|$)^g|0,ea^ca|0,24)|0;Y=D;ea=Km((Q|$)^g|0,ea^ca|0,40)|0;Y=D|Y;$=go(ea|ja|0,Y|0,aa|0,ba|0)|0;$=go($|0,D|0,H|0,I|0)|0;Q=D;c[P>>2]=$;c[P+4>>2]=Q;ia=Mm(la^ba^$|0,(fa|da)^aa^Q|0,16)|0;ha=D;aa=Km(la^ba^$|0,(fa|da)^aa^Q|0,48)|0;ha=D|ha;c[P+96>>2]=aa|ia;c[P+96+4>>2]=ha;ca=go(aa|ia|0,ha|0,g|0,ca|0)|0;g=D;c[P+64>>2]=ca;c[P+64+4>>2]=g;ha=Mm((ea|ja)^ca|0,Y^g|0,63)|0;ia=D;g=Km((ea|ja)^ca|0,Y^g|0,1)|0;c[P+32>>2]=g|ha;c[P+32+4>>2]=D|ia;ia=c[P+40>>2]|0;ha=c[P+40+4>>2]|0;R=go(ia|0,ha|0,ka|0,R|0)|0;R=go(R|0,D|0,y|0,z|0)|0;ka=D;ma=go(V^ka|0,(ga|T)^R|0,f|0,ma|0)|0;f=D;g=Mm(ia^ma|0,ha^f|0,24)|0;Y=D;ha=Km(ia^ma|0,ha^f|0,40)|0;Y=D|Y;ia=go(ha|g|0,Y|0,R|0,ka|0)|0;ia=go(ia|0,D|0,h|0,j|0)|0;ca=D;c[P+8>>2]=ia;c[P+8+4>>2]=ca;ja=Mm(V^ka^ia|0,(ga|T)^R^ca|0,16)|0;ea=D;R=Km(V^ka^ia|0,(ga|T)^R^ca|0,48)|0;ea=D|ea;c[P+104>>2]=R|ja;c[P+104+4>>2]=ea;f=go(R|ja|0,ea|0,ma|0,f|0)|0;ma=D;c[P+72>>2]=f;c[P+72+4>>2]=ma;ea=Mm((ha|g)^f|0,Y^ma|0,63)|0;ja=D;ma=Km((ha|g)^f|0,Y^ma|0,1)|0;ja=D|ja;Y=c[P+48>>2]|0;f=c[P+48+4>>2]|0;e=go(Y|0,f|0,U|0,e|0)|0;e=go(e|0,D|0,J|0,K|0)|0;U=D;g=go(_^U|0,(Z|W)^e|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;ha=D;R=Mm(Y^g|0,f^ha|0,24)|0;T=D;f=Km(Y^g|0,f^ha|0,40)|0;T=D|T;Y=go(f|R|0,T|0,e|0,U|0)|0;Y=go(Y|0,D|0,L|0,l|0)|0;ga=D;c[P+16>>2]=Y;c[P+16+4>>2]=ga;ka=Mm(_^U^Y|0,(Z|W)^e^ga|0,16)|0;V=D;e=Km(_^U^Y|0,(Z|W)^e^ga|0,48)|0;V=D|V;c[P+112>>2]=e|ka;c[P+112+4>>2]=V;ha=go(e|ka|0,V|0,g|0,ha|0)|0;g=D;V=Mm((f|R)^ha|0,T^g|0,63)|0;ka=D;T=Km((f|R)^ha|0,T^g|0,1)|0;ka=D|ka;R=c[P+56>>2]|0;f=c[P+56+4>>2]|0;S=go(R|0,f|0,X|0,S|0)|0;S=go(S|0,D|0,p|0,q|0)|0;X=D;e=c[P+120>>2]^S;W=c[P+120+4>>2]^X;Z=go(W|0,e|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;U=D;_=Mm(R^Z|0,f^U|0,24)|0;aa=D;f=Km(R^Z|0,f^U|0,40)|0;aa=D|aa;X=go(f|_|0,aa|0,S|0,X|0)|0;X=go(X|0,D|0,C|0,E|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;R=Mm(W^X|0,e^S|0,16)|0;da=D;e=Km(W^X|0,e^S|0,48)|0;da=D|da;U=go(e|R|0,da|0,Z|0,U|0)|0;Z=D;W=Mm((f|_)^U|0,aa^Z|0,63)|0;fa=D;aa=Km((f|_)^U|0,aa^Z|0,1)|0;fa=D|fa;Q=go(ma|ea|0,ja|0,$|0,Q|0)|0;Q=go(Q|0,D|0,t|0,u|0)|0;$=D;g=go(da^$|0,(e|R)^Q|0,ha|0,g|0)|0;ha=D;_=Mm((ma|ea)^g|0,ja^ha|0,24)|0;f=D;ja=Km((ma|ea)^g|0,ja^ha|0,40)|0;f=D|f;ea=go(ja|_|0,f|0,Q|0,$|0)|0;ea=go(ea|0,D|0,o|0,x|0)|0;ma=D;c[P>>2]=ea;c[P+4>>2]=ma;ba=Mm(da^$^ea|0,(e|R)^Q^ma|0,16)|0;la=D;Q=Km(da^$^ea|0,(e|R)^Q^ma|0,48)|0;la=D|la;c[P+120>>2]=Q|ba;c[P+120+4>>2]=la;ha=go(Q|ba|0,la|0,g|0,ha|0)|0;g=D;c[P+80>>2]=ha;c[P+80+4>>2]=g;la=Mm((ja|_)^ha|0,f^g|0,63)|0;ba=D;g=Km((ja|_)^ha|0,f^g|0,1)|0;c[P+40>>2]=g|la;c[P+40+4>>2]=D|ba;ca=go(T|V|0,ka|0,ia|0,ca|0)|0;ca=go(ca|0,D|0,k|0,b|0)|0;ia=D;ba=c[P+96>>2]^ca;la=c[P+96+4>>2]^ia;Z=go(la|0,ba|0,U|0,Z|0)|0;U=D;g=Mm((T|V)^Z|0,ka^U|0,24)|0;f=D;ka=Km((T|V)^Z|0,ka^U|0,40)|0;f=D|f;ia=go(ka|g|0,f|0,ca|0,ia|0)|0;ia=go(ia|0,D|0,r|0,s|0)|0;ca=D;c[P+8>>2]=ia;c[P+8+4>>2]=ca;V=Mm(la^ia|0,ba^ca|0,16)|0;T=D;ba=Km(la^ia|0,ba^ca|0,48)|0;T=D|T;U=go(ba|V|0,T|0,Z|0,U|0)|0;Z=D;c[P+88>>2]=U;c[P+88+4>>2]=Z;la=Mm((ka|g)^U|0,f^Z|0,63)|0;ha=D;Z=Km((ka|g)^U|0,f^Z|0,1)|0;c[P+48>>2]=Z|la;c[P+48+4>>2]=D|ha;ga=go(aa|W|0,fa|0,Y|0,ga|0)|0;ga=go(ga|0,D|0,A|0,B|0)|0;Y=D;ha=c[P+104>>2]^ga;la=c[P+104+4>>2]^Y;Z=go(la|0,ha|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;f=D;U=Mm((aa|W)^Z|0,fa^f|0,24)|0;g=D;fa=Km((aa|W)^Z|0,fa^f|0,40)|0;g=D|g;Y=go(fa|U|0,g|0,ga|0,Y|0)|0;Y=go(Y|0,D|0,v|0,w|0)|0;ga=D;c[P+16>>2]=Y;c[P+16+4>>2]=ga;W=Mm(la^Y|0,ha^ga|0,16)|0;aa=D;ha=Km(la^Y|0,ha^ga|0,48)|0;aa=D|aa;f=go(ha|W|0,aa|0,Z|0,f|0)|0;Z=D;la=Mm((fa|U)^f|0,g^Z|0,63)|0;ka=D;g=Km((fa|U)^f|0,g^Z|0,1)|0;c[P+56>>2]=g|la;c[P+56+4>>2]=D|ka;ka=c[P+32>>2]|0;la=c[P+32+4>>2]|0;S=go(ka|0,la|0,X|0,S|0)|0;S=go(S|0,D|0,m|0,n|0)|0;X=D;g=c[P+112>>2]^S;U=c[P+112+4>>2]^X;fa=go(U|0,g|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;_=D;ja=Mm(ka^fa|0,la^_|0,24)|0;Q=D;la=Km(ka^fa|0,la^_|0,40)|0;Q=D|Q;X=go(la|ja|0,Q|0,S|0,X|0)|0;X=go(X|0,D|0,F|0,G|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;ka=Mm(U^X|0,g^S|0,16)|0;R=D;g=Km(U^X|0,g^S|0,48)|0;R=D|R;_=go(g|ka|0,R|0,fa|0,_|0)|0;fa=D;U=Mm((la|ja)^_|0,Q^fa|0,63)|0;e=D;Q=Km((la|ja)^_|0,Q^fa|0,1)|0;e=D|e;ma=go(Q|U|0,e|0,ea|0,ma|0)|0;ma=go(ma|0,D|0,v|0,w|0)|0;ea=D;Z=go(T^ea|0,(ba|V)^ma|0,f|0,Z|0)|0;f=D;ja=Mm((Q|U)^Z|0,e^f|0,24)|0;la=D;e=Km((Q|U)^Z|0,e^f|0,40)|0;la=D|la;U=go(e|ja|0,la|0,ma|0,ea|0)|0;U=go(U|0,D|0,k|0,b|0)|0;Q=D;c[P>>2]=U;c[P+4>>2]=Q;$=Mm(T^ea^U|0,(ba|V)^ma^Q|0,16)|0;da=D;ma=Km(T^ea^U|0,(ba|V)^ma^Q|0,48)|0;da=D|da;c[P+96>>2]=ma|$;c[P+96+4>>2]=da;f=go(ma|$|0,da|0,Z|0,f|0)|0;Z=D;c[P+64>>2]=f;c[P+64+4>>2]=Z;da=Mm((e|ja)^f|0,la^Z|0,63)|0;$=D;Z=Km((e|ja)^f|0,la^Z|0,1)|0;c[P+32>>2]=Z|da;c[P+32+4>>2]=D|$;$=c[P+40>>2]|0;da=c[P+40+4>>2]|0;ca=go($|0,da|0,ia|0,ca|0)|0;ca=go(ca|0,D|0,h|0,j|0)|0;ia=D;fa=go(aa^ia|0,(ha|W)^ca|0,_|0,fa|0)|0;_=D;Z=Mm($^fa|0,da^_|0,24)|0;la=D;da=Km($^fa|0,da^_|0,40)|0;la=D|la;$=go(da|Z|0,la|0,ca|0,ia|0)|0;$=go($|0,D|0,C|0,E|0)|0;f=D;c[P+8>>2]=$;c[P+8+4>>2]=f;ja=Mm(aa^ia^$|0,(ha|W)^ca^f|0,16)|0;e=D;ca=Km(aa^ia^$|0,(ha|W)^ca^f|0,48)|0;e=D|e;c[P+104>>2]=ca|ja;c[P+104+4>>2]=e;_=go(ca|ja|0,e|0,fa|0,_|0)|0;fa=D;c[P+72>>2]=_;c[P+72+4>>2]=fa;e=Mm((da|Z)^_|0,la^fa|0,63)|0;ja=D;fa=Km((da|Z)^_|0,la^fa|0,1)|0;ja=D|ja;la=c[P+48>>2]|0;_=c[P+48+4>>2]|0;ga=go(la|0,_|0,Y|0,ga|0)|0;ga=go(ga|0,D|0,H|0,I|0)|0;Y=D;Z=go(R^Y|0,(g|ka)^ga|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;da=D;ca=Mm(la^Z|0,_^da|0,24)|0;W=D;_=Km(la^Z|0,_^da|0,40)|0;W=D|W;la=go(_|ca|0,W|0,ga|0,Y|0)|0;la=go(la|0,D|0,p|0,q|0)|0;ha=D;c[P+16>>2]=la;c[P+16+4>>2]=ha;ia=Mm(R^Y^la|0,(g|ka)^ga^ha|0,16)|0;aa=D;ga=Km(R^Y^la|0,(g|ka)^ga^ha|0,48)|0;aa=D|aa;c[P+112>>2]=ga|ia;c[P+112+4>>2]=aa;da=go(ga|ia|0,aa|0,Z|0,da|0)|0;Z=D;aa=Mm((_|ca)^da|0,W^Z|0,63)|0;ia=D;W=Km((_|ca)^da|0,W^Z|0,1)|0;ia=D|ia;ca=c[P+56>>2]|0;_=c[P+56+4>>2]|0;S=go(ca|0,_|0,X|0,S|0)|0;S=go(S|0,D|0,o|0,x|0)|0;X=D;ga=c[P+120>>2]^S;ka=c[P+120+4>>2]^X;g=go(ka|0,ga|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;Y=D;R=Mm(ca^g|0,_^Y|0,24)|0;ma=D;_=Km(ca^g|0,_^Y|0,40)|0;ma=D|ma;X=go(_|R|0,ma|0,S|0,X|0)|0;X=go(X|0,D|0,A|0,B|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;ca=Mm(ka^X|0,ga^S|0,16)|0;V=D;ga=Km(ka^X|0,ga^S|0,48)|0;V=D|V;Y=go(ga|ca|0,V|0,g|0,Y|0)|0;g=D;ka=Mm((_|R)^Y|0,ma^g|0,63)|0;ba=D;ma=Km((_|R)^Y|0,ma^g|0,1)|0;ba=D|ba;Q=go(fa|e|0,ja|0,U|0,Q|0)|0;Q=go(Q|0,D|0,J|0,K|0)|0;U=D;Z=go(V^U|0,(ga|ca)^Q|0,da|0,Z|0)|0;da=D;R=Mm((fa|e)^Z|0,ja^da|0,24)|0;_=D;ja=Km((fa|e)^Z|0,ja^da|0,40)|0;_=D|_;e=go(ja|R|0,_|0,Q|0,U|0)|0;e=go(e|0,D|0,m|0,n|0)|0;fa=D;c[P>>2]=e;c[P+4>>2]=fa;ea=Mm(V^U^e|0,(ga|ca)^Q^fa|0,16)|0;T=D;Q=Km(V^U^e|0,(ga|ca)^Q^fa|0,48)|0;T=D|T;c[P+120>>2]=Q|ea;c[P+120+4>>2]=T;da=go(Q|ea|0,T|0,Z|0,da|0)|0;Z=D;c[P+80>>2]=da;c[P+80+4>>2]=Z;T=Mm((ja|R)^da|0,_^Z|0,63)|0;ea=D;Z=Km((ja|R)^da|0,_^Z|0,1)|0;c[P+40>>2]=Z|T;c[P+40+4>>2]=D|ea;f=go(W|aa|0,ia|0,$|0,f|0)|0;f=go(f|0,D|0,M|0,N|0)|0;$=D;ea=c[P+96>>2]^f;T=c[P+96+4>>2]^$;g=go(T|0,ea|0,Y|0,g|0)|0;Y=D;Z=Mm((W|aa)^g|0,ia^Y|0,24)|0;_=D;ia=Km((W|aa)^g|0,ia^Y|0,40)|0;_=D|_;$=go(ia|Z|0,_|0,f|0,$|0)|0;$=go($|0,D|0,y|0,z|0)|0;f=D;c[P+8>>2]=$;c[P+8+4>>2]=f;aa=Mm(T^$|0,ea^f|0,16)|0;W=D;ea=Km(T^$|0,ea^f|0,48)|0;W=D|W;Y=go(ea|aa|0,W|0,g|0,Y|0)|0;g=D;c[P+88>>2]=Y;c[P+88+4>>2]=g;T=Mm((ia|Z)^Y|0,_^g|0,63)|0;da=D;g=Km((ia|Z)^Y|0,_^g|0,1)|0;c[P+48>>2]=g|T;c[P+48+4>>2]=D|da;ha=go(ma|ka|0,ba|0,la|0,ha|0)|0;ha=go(ha|0,D|0,L|0,l|0)|0;la=D;da=c[P+104>>2]^ha;T=c[P+104+4>>2]^la;g=go(T|0,da|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;_=D;Y=Mm((ma|ka)^g|0,ba^_|0,24)|0;Z=D;ba=Km((ma|ka)^g|0,ba^_|0,40)|0;Z=D|Z;la=go(ba|Y|0,Z|0,ha|0,la|0)|0;la=go(la|0,D|0,r|0,s|0)|0;ha=D;c[P+16>>2]=la;c[P+16+4>>2]=ha;ka=Mm(T^la|0,da^ha|0,16)|0;ma=D;da=Km(T^la|0,da^ha|0,48)|0;ma=D|ma;_=go(da|ka|0,ma|0,g|0,_|0)|0;g=D;T=Mm((ba|Y)^_|0,Z^g|0,63)|0;ia=D;Z=Km((ba|Y)^_|0,Z^g|0,1)|0;c[P+56>>2]=Z|T;c[P+56+4>>2]=D|ia;ia=c[P+32>>2]|0;T=c[P+32+4>>2]|0;S=go(ia|0,T|0,X|0,S|0)|0;S=go(S|0,D|0,F|0,G|0)|0;X=D;Z=c[P+112>>2]^S;Y=c[P+112+4>>2]^X;ba=go(Y|0,Z|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;R=D;ja=Mm(ia^ba|0,T^R|0,24)|0;Q=D;T=Km(ia^ba|0,T^R|0,40)|0;Q=D|Q;X=go(T|ja|0,Q|0,S|0,X|0)|0;X=go(X|0,D|0,t|0,u|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;ia=Mm(Y^X|0,Z^S|0,16)|0;ca=D;Z=Km(Y^X|0,Z^S|0,48)|0;ca=D|ca;R=go(Z|ia|0,ca|0,ba|0,R|0)|0;ba=D;Y=Mm((T|ja)^R|0,Q^ba|0,63)|0;ga=D;Q=Km((T|ja)^R|0,Q^ba|0,1)|0;ga=D|ga;fa=go(Q|Y|0,ga|0,e|0,fa|0)|0;fa=go(fa|0,D|0,F|0,G|0)|0;e=D;g=go(W^e|0,(ea|aa)^fa|0,_|0,g|0)|0;_=D;ja=Mm((Q|Y)^g|0,ga^_|0,24)|0;T=D;ga=Km((Q|Y)^g|0,ga^_|0,40)|0;T=D|T;Y=go(ga|ja|0,T|0,fa|0,e|0)|0;Y=go(Y|0,D|0,m|0,n|0)|0;Q=D;c[P>>2]=Y;c[P+4>>2]=Q;U=Mm(W^e^Y|0,(ea|aa)^fa^Q|0,16)|0;V=D;fa=Km(W^e^Y|0,(ea|aa)^fa^Q|0,48)|0;V=D|V;c[P+96>>2]=fa|U;c[P+96+4>>2]=V;_=go(fa|U|0,V|0,g|0,_|0)|0;g=D;c[P+64>>2]=_;c[P+64+4>>2]=g;V=Mm((ga|ja)^_|0,T^g|0,63)|0;U=D;g=Km((ga|ja)^_|0,T^g|0,1)|0;c[P+32>>2]=g|V;c[P+32+4>>2]=D|U;U=c[P+40>>2]|0;V=c[P+40+4>>2]|0;f=go(U|0,V|0,$|0,f|0)|0;f=go(f|0,D|0,A|0,B|0)|0;$=D;ba=go(ma^$|0,(da|ka)^f|0,R|0,ba|0)|0;R=D;g=Mm(U^ba|0,V^R|0,24)|0;T=D;V=Km(U^ba|0,V^R|0,40)|0;T=D|T;U=go(V|g|0,T|0,f|0,$|0)|0;U=go(U|0,D|0,r|0,s|0)|0;_=D;c[P+8>>2]=U;c[P+8+4>>2]=_;ja=Mm(ma^$^U|0,(da|ka)^f^_|0,16)|0;ga=D;f=Km(ma^$^U|0,(da|ka)^f^_|0,48)|0;ga=D|ga;c[P+104>>2]=f|ja;c[P+104+4>>2]=ga;R=go(f|ja|0,ga|0,ba|0,R|0)|0;ba=D;c[P+72>>2]=R;c[P+72+4>>2]=ba;ga=Mm((V|g)^R|0,T^ba|0,63)|0;ja=D;ba=Km((V|g)^R|0,T^ba|0,1)|0;ja=D|ja;T=c[P+48>>2]|0;R=c[P+48+4>>2]|0;ha=go(T|0,R|0,la|0,ha|0)|0;ha=go(ha|0,D|0,y|0,z|0)|0;la=D;g=go(ca^la|0,(Z|ia)^ha|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;V=D;f=Mm(T^g|0,R^V|0,24)|0;ka=D;R=Km(T^g|0,R^V|0,40)|0;ka=D|ka;T=go(R|f|0,ka|0,ha|0,la|0)|0;T=go(T|0,D|0,v|0,w|0)|0;da=D;c[P+16>>2]=T;c[P+16+4>>2]=da;$=Mm(ca^la^T|0,(Z|ia)^ha^da|0,16)|0;ma=D;ha=Km(ca^la^T|0,(Z|ia)^ha^da|0,48)|0;ma=D|ma;c[P+112>>2]=ha|$;c[P+112+4>>2]=ma;V=go(ha|$|0,ma|0,g|0,V|0)|0;g=D;ma=Mm((R|f)^V|0,ka^g|0,63)|0;$=D;ka=Km((R|f)^V|0,ka^g|0,1)|0;$=D|$;f=c[P+56>>2]|0;R=c[P+56+4>>2]|0;S=go(f|0,R|0,X|0,S|0)|0;S=go(S|0,D|0,L|0,l|0)|0;X=D;ha=c[P+120>>2]^S;ia=c[P+120+4>>2]^X;Z=go(ia|0,ha|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;la=D;ca=Mm(f^Z|0,R^la|0,24)|0;fa=D;R=Km(f^Z|0,R^la|0,40)|0;fa=D|fa;X=go(R|ca|0,fa|0,S|0,X|0)|0;X=go(X|0,D|0,t|0,u|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;f=Mm(ia^X|0,ha^S|0,16)|0;aa=D;ha=Km(ia^X|0,ha^S|0,48)|0;aa=D|aa;la=go(ha|f|0,aa|0,Z|0,la|0)|0;Z=D;ia=Mm((R|ca)^la|0,fa^Z|0,63)|0;ea=D;fa=Km((R|ca)^la|0,fa^Z|0,1)|0;ea=D|ea;Q=go(ba|ga|0,ja|0,Y|0,Q|0)|0;Q=go(Q|0,D|0,k|0,b|0)|0;Y=D;g=go(aa^Y|0,(ha|f)^Q|0,V|0,g|0)|0;V=D;ca=Mm((ba|ga)^g|0,ja^V|0,24)|0;R=D;ja=Km((ba|ga)^g|0,ja^V|0,40)|0;R=D|R;ga=go(ja|ca|0,R|0,Q|0,Y|0)|0;ga=go(ga|0,D|0,H|0,I|0)|0;ba=D;c[P>>2]=ga;c[P+4>>2]=ba;e=Mm(aa^Y^ga|0,(ha|f)^Q^ba|0,16)|0;W=D;Q=Km(aa^Y^ga|0,(ha|f)^Q^ba|0,48)|0;W=D|W;c[P+120>>2]=Q|e;c[P+120+4>>2]=W;V=go(Q|e|0,W|0,g|0,V|0)|0;g=D;c[P+80>>2]=V;c[P+80+4>>2]=g;W=Mm((ja|ca)^V|0,R^g|0,63)|0;e=D;g=Km((ja|ca)^V|0,R^g|0,1)|0;c[P+40>>2]=g|W;c[P+40+4>>2]=D|e;_=go(ka|ma|0,$|0,U|0,_|0)|0;_=go(_|0,D|0,C|0,E|0)|0;U=D;e=c[P+96>>2]^_;W=c[P+96+4>>2]^U;Z=go(W|0,e|0,la|0,Z|0)|0;la=D;g=Mm((ka|ma)^Z|0,$^la|0,24)|0;R=D;$=Km((ka|ma)^Z|0,$^la|0,40)|0;R=D|R;U=go($|g|0,R|0,_|0,U|0)|0;U=go(U|0,D|0,h|0,j|0)|0;_=D;c[P+8>>2]=U;c[P+8+4>>2]=_;ma=Mm(W^U|0,e^_|0,16)|0;ka=D;e=Km(W^U|0,e^_|0,48)|0;ka=D|ka;la=go(e|ma|0,ka|0,Z|0,la|0)|0;Z=D;c[P+88>>2]=la;c[P+88+4>>2]=Z;W=Mm(($|g)^la|0,R^Z|0,63)|0;V=D;Z=Km(($|g)^la|0,R^Z|0,1)|0;c[P+48>>2]=Z|W;c[P+48+4>>2]=D|V;da=go(fa|ia|0,ea|0,T|0,da|0)|0;da=go(da|0,D|0,p|0,q|0)|0;T=D;V=c[P+104>>2]^da;W=c[P+104+4>>2]^T;Z=go(W|0,V|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;R=D;la=Mm((fa|ia)^Z|0,ea^R|0,24)|0;g=D;ea=Km((fa|ia)^Z|0,ea^R|0,40)|0;g=D|g;T=go(ea|la|0,g|0,da|0,T|0)|0;T=go(T|0,D|0,J|0,K|0)|0;da=D;c[P+16>>2]=T;c[P+16+4>>2]=da;ia=Mm(W^T|0,V^da|0,16)|0;fa=D;V=Km(W^T|0,V^da|0,48)|0;fa=D|fa;R=go(V|ia|0,fa|0,Z|0,R|0)|0;Z=D;W=Mm((ea|la)^R|0,g^Z|0,63)|0;$=D;g=Km((ea|la)^R|0,g^Z|0,1)|0;c[P+56>>2]=g|W;c[P+56+4>>2]=D|$;$=c[P+32>>2]|0;W=c[P+32+4>>2]|0;S=go($|0,W|0,X|0,S|0)|0;S=go(S|0,D|0,M|0,N|0)|0;X=D;g=c[P+112>>2]^S;la=c[P+112+4>>2]^X;ea=go(la|0,g|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;ca=D;ja=Mm($^ea|0,W^ca|0,24)|0;Q=D;W=Km($^ea|0,W^ca|0,40)|0;Q=D|Q;X=go(W|ja|0,Q|0,S|0,X|0)|0;X=go(X|0,D|0,o|0,x|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;$=Mm(la^X|0,g^S|0,16)|0;f=D;g=Km(la^X|0,g^S|0,48)|0;f=D|f;ca=go(g|$|0,f|0,ea|0,ca|0)|0;ea=D;la=Mm((W|ja)^ca|0,Q^ea|0,63)|0;ha=D;Q=Km((W|ja)^ca|0,Q^ea|0,1)|0;ha=D|ha;ba=go(Q|la|0,ha|0,ga|0,ba|0)|0;ba=go(ba|0,D|0,o|0,x|0)|0;ga=D;Z=go(ka^ga|0,(e|ma)^ba|0,R|0,Z|0)|0;R=D;ja=Mm((Q|la)^Z|0,ha^R|0,24)|0;W=D;ha=Km((Q|la)^Z|0,ha^R|0,40)|0;W=D|W;la=go(ha|ja|0,W|0,ba|0,ga|0)|0;la=go(la|0,D|0,L|0,l|0)|0;Q=D;c[P>>2]=la;c[P+4>>2]=Q;Y=Mm(ka^ga^la|0,(e|ma)^ba^Q|0,16)|0;aa=D;ba=Km(ka^ga^la|0,(e|ma)^ba^Q|0,48)|0;aa=D|aa;c[P+96>>2]=ba|Y;c[P+96+4>>2]=aa;R=go(ba|Y|0,aa|0,Z|0,R|0)|0;Z=D;c[P+64>>2]=R;c[P+64+4>>2]=Z;aa=Mm((ha|ja)^R|0,W^Z|0,63)|0;Y=D;Z=Km((ha|ja)^R|0,W^Z|0,1)|0;c[P+32>>2]=Z|aa;c[P+32+4>>2]=D|Y;Y=c[P+40>>2]|0;aa=c[P+40+4>>2]|0;_=go(Y|0,aa|0,U|0,_|0)|0;_=go(_|0,D|0,m|0,n|0)|0;U=D;ea=go(fa^U|0,(V|ia)^_|0,ca|0,ea|0)|0;ca=D;Z=Mm(Y^ea|0,aa^ca|0,24)|0;W=D;aa=Km(Y^ea|0,aa^ca|0,40)|0;W=D|W;Y=go(aa|Z|0,W|0,_|0,U|0)|0;Y=go(Y|0,D|0,p|0,q|0)|0;R=D;c[P+8>>2]=Y;c[P+8+4>>2]=R;ja=Mm(fa^U^Y|0,(V|ia)^_^R|0,16)|0;ha=D;_=Km(fa^U^Y|0,(V|ia)^_^R|0,48)|0;ha=D|ha;c[P+104>>2]=_|ja;c[P+104+4>>2]=ha;ca=go(_|ja|0,ha|0,ea|0,ca|0)|0;ea=D;c[P+72>>2]=ca;c[P+72+4>>2]=ea;ha=Mm((aa|Z)^ca|0,W^ea|0,63)|0;ja=D;ea=Km((aa|Z)^ca|0,W^ea|0,1)|0;ja=D|ja;W=c[P+48>>2]|0;ca=c[P+48+4>>2]|0;da=go(W|0,ca|0,T|0,da|0)|0;da=go(da|0,D|0,r|0,s|0)|0;T=D;Z=go(f^T|0,(g|$)^da|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;aa=D;_=Mm(W^Z|0,ca^aa|0,24)|0;ia=D;ca=Km(W^Z|0,ca^aa|0,40)|0;ia=D|ia;W=go(ca|_|0,ia|0,da|0,T|0)|0;W=go(W|0,D|0,t|0,u|0)|0;V=D;c[P+16>>2]=W;c[P+16+4>>2]=V;U=Mm(f^T^W|0,(g|$)^da^V|0,16)|0;fa=D;da=Km(f^T^W|0,(g|$)^da^V|0,48)|0;fa=D|fa;c[P+112>>2]=da|U;c[P+112+4>>2]=fa;aa=go(da|U|0,fa|0,Z|0,aa|0)|0;Z=D;fa=Mm((ca|_)^aa|0,ia^Z|0,63)|0;U=D;ia=Km((ca|_)^aa|0,ia^Z|0,1)|0;U=D|U;_=c[P+56>>2]|0;ca=c[P+56+4>>2]|0;S=go(_|0,ca|0,X|0,S|0)|0;S=go(S|0,D|0,v|0,w|0)|0;X=D;da=c[P+120>>2]^S;$=c[P+120+4>>2]^X;g=go($|0,da|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;T=D;f=Mm(_^g|0,ca^T|0,24)|0;ba=D;ca=Km(_^g|0,ca^T|0,40)|0;ba=D|ba;X=go(ca|f|0,ba|0,S|0,X|0)|0;X=go(X|0,D|0,y|0,z|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;_=Mm($^X|0,da^S|0,16)|0;ma=D;da=Km($^X|0,da^S|0,48)|0;ma=D|ma;T=go(da|_|0,ma|0,g|0,T|0)|0;g=D;$=Mm((ca|f)^T|0,ba^g|0,63)|0;e=D;ba=Km((ca|f)^T|0,ba^g|0,1)|0;e=D|e;Q=go(ea|ha|0,ja|0,la|0,Q|0)|0;Q=go(Q|0,D|0,A|0,B|0)|0;la=D;Z=go(ma^la|0,(da|_)^Q|0,aa|0,Z|0)|0;aa=D;f=Mm((ea|ha)^Z|0,ja^aa|0,24)|0;ca=D;ja=Km((ea|ha)^Z|0,ja^aa|0,40)|0;ca=D|ca;ha=go(ja|f|0,ca|0,Q|0,la|0)|0;ha=go(ha|0,D|0,C|0,E|0)|0;ea=D;c[P>>2]=ha;c[P+4>>2]=ea;ga=Mm(ma^la^ha|0,(da|_)^Q^ea|0,16)|0;ka=D;Q=Km(ma^la^ha|0,(da|_)^Q^ea|0,48)|0;ka=D|ka;c[P+120>>2]=Q|ga;c[P+120+4>>2]=ka;aa=go(Q|ga|0,ka|0,Z|0,aa|0)|0;Z=D;c[P+80>>2]=aa;c[P+80+4>>2]=Z;ka=Mm((ja|f)^aa|0,ca^Z|0,63)|0;ga=D;Z=Km((ja|f)^aa|0,ca^Z|0,1)|0;c[P+40>>2]=Z|ka;c[P+40+4>>2]=D|ga;R=go(ia|fa|0,U|0,Y|0,R|0)|0;R=go(R|0,D|0,F|0,G|0)|0;Y=D;ga=c[P+96>>2]^R;ka=c[P+96+4>>2]^Y;g=go(ka|0,ga|0,T|0,g|0)|0;T=D;Z=Mm((ia|fa)^g|0,U^T|0,24)|0;ca=D;U=Km((ia|fa)^g|0,U^T|0,40)|0;ca=D|ca;Y=go(U|Z|0,ca|0,R|0,Y|0)|0;Y=go(Y|0,D|0,H|0,I|0)|0;R=D;c[P+8>>2]=Y;c[P+8+4>>2]=R;fa=Mm(ka^Y|0,ga^R|0,16)|0;ia=D;ga=Km(ka^Y|0,ga^R|0,48)|0;ia=D|ia;T=go(ga|fa|0,ia|0,g|0,T|0)|0;g=D;c[P+88>>2]=T;c[P+88+4>>2]=g;ka=Mm((U|Z)^T|0,ca^g|0,63)|0;aa=D;g=Km((U|Z)^T|0,ca^g|0,1)|0;c[P+48>>2]=g|ka;c[P+48+4>>2]=D|aa;V=go(ba|$|0,e|0,W|0,V|0)|0;V=go(V|0,D|0,J|0,K|0)|0;W=D;aa=c[P+104>>2]^V;ka=c[P+104+4>>2]^W;g=go(ka|0,aa|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;ca=D;T=Mm((ba|$)^g|0,e^ca|0,24)|0;Z=D;e=Km((ba|$)^g|0,e^ca|0,40)|0;Z=D|Z;W=go(e|T|0,Z|0,V|0,W|0)|0;W=go(W|0,D|0,M|0,N|0)|0;V=D;c[P+16>>2]=W;c[P+16+4>>2]=V;$=Mm(ka^W|0,aa^V|0,16)|0;ba=D;aa=Km(ka^W|0,aa^V|0,48)|0;ba=D|ba;ca=go(aa|$|0,ba|0,g|0,ca|0)|0;g=D;ka=Mm((e|T)^ca|0,Z^g|0,63)|0;U=D;Z=Km((e|T)^ca|0,Z^g|0,1)|0;c[P+56>>2]=Z|ka;c[P+56+4>>2]=D|U;U=c[P+32>>2]|0;ka=c[P+32+4>>2]|0;S=go(U|0,ka|0,X|0,S|0)|0;S=go(S|0,D|0,h|0,j|0)|0;X=D;Z=c[P+112>>2]^S;T=c[P+112+4>>2]^X;e=go(T|0,Z|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;f=D;ja=Mm(U^e|0,ka^f|0,24)|0;Q=D;ka=Km(U^e|0,ka^f|0,40)|0;Q=D|Q;X=go(ka|ja|0,Q|0,S|0,X|0)|0;X=go(X|0,D|0,k|0,b|0)|0;S=D;c[P+24>>2]=X;c[P+24+4>>2]=S;U=Mm(T^X|0,Z^S|0,16)|0;_=D;Z=Km(T^X|0,Z^S|0,48)|0;_=D|_;f=go(Z|U|0,_|0,e|0,f|0)|0;e=D;T=Mm((ka|ja)^f|0,Q^e|0,63)|0;da=D;Q=Km((ka|ja)^f|0,Q^e|0,1)|0;da=D|da;ea=go(Q|T|0,da|0,ha|0,ea|0)|0;ea=go(ea|0,D|0,h|0,j|0)|0;ha=D;g=go(ia^ha|0,(ga|fa)^ea|0,ca|0,g|0)|0;h=D;ca=Mm((Q|T)^g|0,da^h|0,24)|0;j=D;da=Km((Q|T)^g|0,da^h|0,40)|0;j=D|j;T=go(da|ca|0,j|0,ea|0,ha|0)|0;T=go(T|0,D|0,F|0,G|0)|0;Q=D;c[P>>2]=T;c[P+4>>2]=Q;G=Mm(ia^ha^T|0,(ga|fa)^ea^Q|0,16)|0;F=D;ea=Km(ia^ha^T|0,(ga|fa)^ea^Q|0,48)|0;F=D|F;c[P+96>>2]=ea|G;c[P+96+4>>2]=F;F=go(ea|G|0,F|0,g|0,h|0)|0;h=D;c[P+64>>2]=F;c[P+64+4>>2]=h;G=Mm((da|ca)^F|0,j^h|0,63)|0;g=D;h=Km((da|ca)^F|0,j^h|0,1)|0;c[P+32>>2]=h|G;c[P+32+4>>2]=D|g;g=c[P+40>>2]|0;G=c[P+40+4>>2]|0;R=go(g|0,G|0,Y|0,R|0)|0;R=go(R|0,D|0,r|0,s|0)|0;h=D;e=go(ba^h|0,(aa|$)^R|0,f|0,e|0)|0;f=D;F=Mm(g^e|0,G^f|0,24)|0;Y=D;G=Km(g^e|0,G^f|0,40)|0;Y=D|Y;s=go(G|F|0,Y|0,R|0,h|0)|0;s=go(s|0,D|0,A|0,B|0)|0;r=D;c[P+8>>2]=s;c[P+8+4>>2]=r;g=Mm(ba^h^s|0,(aa|$)^R^r|0,16)|0;B=D;R=Km(ba^h^s|0,(aa|$)^R^r|0,48)|0;B=D|B;c[P+104>>2]=R|g;c[P+104+4>>2]=B;B=go(R|g|0,B|0,e|0,f|0)|0;f=D;c[P+72>>2]=B;c[P+72+4>>2]=f;e=Mm((G|F)^B|0,Y^f|0,63)|0;g=D;f=Km((G|F)^B|0,Y^f|0,1)|0;g=D|g;B=c[P+48>>2]|0;Y=c[P+48+4>>2]|0;F=go(B|0,Y|0,W|0,V|0)|0;F=go(F|0,D|0,C|0,E|0)|0;G=D;V=go(_^G|0,(Z|U)^F|0,c[P+80>>2]|0,c[P+80+4>>2]|0)|0;W=D;R=Mm(B^V|0,Y^W|0,24)|0;h=D;Y=Km(B^V|0,Y^W|0,40)|0;h=D|h;B=go(Y|R|0,h|0,F|0,G|0)|0;B=go(B|0,D|0,k|0,b|0)|0;C=D;c[P+16>>2]=B;c[P+16+4>>2]=C;k=Mm(_^G^B|0,(Z|U)^F^C|0,16)|0;j=D;F=Km(_^G^B|0,(Z|U)^F^C|0,48)|0;j=D|j;c[P+112>>2]=F|k;c[P+112+4>>2]=j;W=go(F|k|0,j|0,V|0,W|0)|0;V=D;j=Mm((Y|R)^W|0,h^V|0,63)|0;k=D;h=Km((Y|R)^W|0,h^V|0,1)|0;k=D|k;R=c[P+56>>2]|0;Y=c[P+56+4>>2]|0;F=go(R|0,Y|0,X|0,S|0)|0;F=go(F|0,D|0,M|0,N|0)|0;G=D;S=c[P+120>>2]^F;A=c[P+120+4>>2]^G;M=go(A|0,S|0,c[P+88>>2]|0,c[P+88+4>>2]|0)|0;E=D;X=Mm(R^M|0,Y^E|0,24)|0;N=D;Y=Km(R^M|0,Y^E|0,40)|0;N=D|N;G=go(Y|X|0,N|0,F|0,G|0)|0;G=go(G|0,D|0,v|0,w|0)|0;F=D;c[P+24>>2]=G;c[P+24+4>>2]=F;R=Mm(A^G|0,S^F|0,16)|0;U=D;S=Km(A^G|0,S^F|0,48)|0;U=D|U;E=go(S|R|0,U|0,M|0,E|0)|0;M=D;A=Mm((Y|X)^E|0,N^M|0,63)|0;b=D;w=Km((Y|X)^E|0,N^M|0,1)|0;b=D|b;Q=go(f|e|0,g|0,T|0,Q|0)|0;Q=go(Q|0,D|0,L|0,l|0)|0;T=D;v=go(U^T|0,(S|R)^Q|0,W|0,V|0)|0;N=D;l=Mm((f|e)^v|0,g^N|0,24)|0;L=D;g=Km((f|e)^v|0,g^N|0,40)|0;L=D|L;e=go(g|l|0,L|0,Q|0,T|0)|0;e=go(e|0,D|0,J|0,K|0)|0;f=D;c[P>>2]=e;c[P+4>>2]=f;J=Mm(U^T^e|0,(S|R)^Q^f|0,16)|0;K=D;Q=Km(U^T^e|0,(S|R)^Q^f|0,48)|0;K=D|K;c[P+120>>2]=Q|J;c[P+120+4>>2]=K;N=go(Q|J|0,K|0,v|0,N|0)|0;K=D;c[P+80>>2]=N;c[P+80+4>>2]=K;J=Mm((g|l)^N|0,L^K|0,63)|0;v=D;K=Km((g|l)^N|0,L^K|0,1)|0;c[P+40>>2]=K|J;c[P+40+4>>2]=D|v;v=go(h|j|0,k|0,s|0,r|0)|0;v=go(v|0,D|0,o|0,x|0)|0;r=D;s=c[P+96>>2]^v;o=c[P+96+4>>2]^r;M=go(o|0,s|0,E|0,M|0)|0;E=D;J=Mm((h|j)^M|0,k^E|0,24)|0;K=D;x=Km((h|j)^M|0,k^E|0,40)|0;K=D|K;r=go(x|J|0,K|0,v|0,r|0)|0;r=go(r|0,D|0,m|0,n|0)|0;v=D;c[P+8>>2]=r;c[P+8+4>>2]=v;L=Mm(o^r|0,s^v|0,16)|0;N=D;v=Km(o^r|0,s^v|0,48)|0;N=D|N;c[P+96>>2]=v|L;c[P+96+4>>2]=N;E=go(v|L|0,N|0,M|0,E|0)|0;M=D;c[P+88>>2]=E;c[P+88+4>>2]=M;N=Mm((x|J)^E|0,K^M|0,63)|0;L=D;M=Km((x|J)^E|0,K^M|0,1)|0;c[P+48>>2]=M|N;c[P+48+4>>2]=D|L;L=go(w|A|0,b|0,B|0,C|0)|0;L=go(L|0,D|0,H|0,I|0)|0;C=D;N=c[P+104>>2]^L;B=c[P+104+4>>2]^C;H=go(B|0,N|0,c[P+64>>2]|0,c[P+64+4>>2]|0)|0;M=D;K=Mm((w|A)^H|0,b^M|0,24)|0;E=D;J=Km((w|A)^H|0,b^M|0,40)|0;E=D|E;C=go(J|K|0,E|0,L|0,C|0)|0;C=go(C|0,D|0,y|0,z|0)|0;L=D;c[P+16>>2]=C;c[P+16+4>>2]=L;b=Mm(B^C|0,N^L|0,16)|0;I=D;L=Km(B^C|0,N^L|0,48)|0;I=D|I;c[P+104>>2]=L|b;c[P+104+4>>2]=I;M=go(L|b|0,I|0,H|0,M|0)|0;H=D;c[P+64>>2]=M;c[P+64+4>>2]=H;I=Mm((J|K)^M|0,E^H|0,63)|0;b=D;H=Km((J|K)^M|0,E^H|0,1)|0;c[P+56>>2]=H|I;c[P+56+4>>2]=D|b;b=c[P+32>>2]|0;I=c[P+32+4>>2]|0;H=go(b|0,I|0,G|0,F|0)|0;H=go(H|0,D|0,t|0,u|0)|0;F=D;G=c[P+112>>2]^H;E=c[P+112+4>>2]^F;M=go(E|0,G|0,c[P+72>>2]|0,c[P+72+4>>2]|0)|0;K=D;J=Mm(b^M|0,I^K|0,24)|0;L=D;I=Km(b^M|0,I^K|0,40)|0;L=D|L;F=go(I|J|0,L|0,H|0,F|0)|0;F=go(F|0,D|0,p|0,q|0)|0;H=D;c[P+24>>2]=F;c[P+24+4>>2]=H;b=Mm(E^F|0,G^H|0,16)|0;N=D;H=Km(E^F|0,G^H|0,48)|0;N=D|N;c[P+112>>2]=H|b;c[P+112+4>>2]=N;K=go(H|b|0,N|0,M|0,K|0)|0;M=D;c[P+72>>2]=K;c[P+72+4>>2]=M;N=Mm((I|J)^K|0,L^M|0,63)|0;b=D;M=Km((I|J)^K|0,L^M|0,1)|0;c[P+32>>2]=M|N;c[P+32+4>>2]=D|b;b=0;while(1){ma=a+(b<<3)|0;ka=P+(b+8<<3)|0;la=f^c[ma+4>>2]^c[ka+4>>2];c[ma>>2]=e^c[ma>>2]^c[ka>>2];c[ma+4>>2]=la;b=b+1|0;if((b|0)==8)break;e=c[P+(b<<3)>>2]|0;f=c[P+(b<<3)+4>>2]|0}i=O;return}function _b(b,c,e,f){b=b|0;c=c|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0;O=d[c>>0]|0;P=Km(d[c+1>>0]|0|0,0,8)|0;jb=D;j=d[c+2>>0]|0;db=Km(j|0,0,16)|0;Ma=Km(d[c+3>>0]|0|0,0,8)|0;qb=D;A=Km(d[c+4>>0]|0|0,0,16)|0;qb=qb|D;nb=d[c+5>>0]|0;z=Km(nb|0,0,24)|0;qb=Mm(Ma|j|A|z|0,qb|D|0,5)|0;z=Km(d[c+6>>0]|0|0,0,8)|0;A=D;j=d[c+7>>0]|0;Ma=Km(j|0,0,16)|0;A=Mm(z|nb|Ma|0,A|D|0,2)|0;Ma=Km(d[c+8>>0]|0|0,0,8)|0;nb=D;z=Km(d[c+9>>0]|0|0,0,16)|0;nb=nb|D;ca=d[c+10>>0]|0;lb=Km(ca|0,0,24)|0;nb=Mm(Ma|j|z|lb|0,nb|D|0,7)|0;lb=Km(d[c+11>>0]|0|0,0,8)|0;z=D;j=Km(d[c+12>>0]|0|0,0,16)|0;z=z|D;Ma=d[c+13>>0]|0;ra=Km(Ma|0,0,24)|0;z=Mm(lb|ca|j|ra|0,z|D|0,4)|0;ra=Km(d[c+14>>0]|0|0,0,8)|0;j=D;ca=d[c+15>>0]|0;lb=Km(ca|0,0,16)|0;j=Mm(ra|Ma|lb|0,j|D|0,1)|0;lb=Km(d[c+16>>0]|0|0,0,8)|0;Ma=D;ra=Km(d[c+17>>0]|0|0,0,16)|0;Ma=Ma|D;Ca=d[c+18>>0]|0;I=Km(Ca|0,0,24)|0;Ma=Mm(lb|ca|ra|I|0,Ma|D|0,6)|0;I=Km(d[c+19>>0]|0|0,0,8)|0;ra=D;ca=Km(d[c+20>>0]|0|0,0,16)|0;ra=Mm(I|Ca|ca|0,ra|D|0,3)|0;ca=D;Ca=d[c+21>>0]|0;I=Km(d[c+22>>0]|0|0,0,8)|0;lb=D;eb=d[c+23>>0]|0;Ja=Km(eb|0,0,16)|0;ba=Km(d[c+24>>0]|0|0,0,8)|0;La=D;sc=Km(d[c+25>>0]|0|0,0,16)|0;La=La|D;o=d[c+26>>0]|0;rb=Km(o|0,0,24)|0;La=Mm(ba|eb|sc|rb|0,La|D|0,5)|0;rb=Km(d[c+27>>0]|0|0,0,8)|0;sc=D;eb=d[c+28>>0]|0;ba=Km(eb|0,0,16)|0;sc=Mm(rb|o|ba|0,sc|D|0,2)|0;ba=Km(d[c+29>>0]|0|0,0,8)|0;o=D;rb=Km(d[c+30>>0]|0|0,0,16)|0;o=o|D;Da=Km(d[c+31>>0]|0|0,0,24)|0;o=Mm(ba|eb|rb|Da|0,o|D|0,7)|0;Da=D;rb=d[e>>0]|0;eb=Km(d[e+1>>0]|0|0,0,8)|0;ba=D;Ta=d[e+2>>0]|0;aa=Km(Ta|0,0,16)|0;m=Km(d[e+3>>0]|0|0,0,8)|0;Ya=D;q=Km(d[e+4>>0]|0|0,0,16)|0;Ya=Ya|D;p=d[e+5>>0]|0;ea=Km(p|0,0,24)|0;Ya=Mm(m|Ta|q|ea|0,Ya|D|0,5)|0;ea=Km(d[e+6>>0]|0|0,0,8)|0;q=D;Ta=d[e+7>>0]|0;m=Km(Ta|0,0,16)|0;q=Mm(ea|p|m|0,q|D|0,2)|0;m=Km(d[e+8>>0]|0|0,0,8)|0;p=D;ea=Km(d[e+9>>0]|0|0,0,16)|0;p=p|D;wc=d[e+10>>0]|0;wa=Km(wc|0,0,24)|0;p=Mm(m|Ta|ea|wa|0,p|D|0,7)|0;wa=Km(d[e+11>>0]|0|0,0,8)|0;ea=D;Ta=Km(d[e+12>>0]|0|0,0,16)|0;ea=ea|D;m=d[e+13>>0]|0;zc=Km(m|0,0,24)|0;ea=Mm(wa|wc|Ta|zc|0,ea|D|0,4)|0;zc=Km(d[e+14>>0]|0|0,0,8)|0;Ta=D;wc=d[e+15>>0]|0;wa=Km(wc|0,0,16)|0;Ta=Mm(zc|m|wa|0,Ta|D|0,1)|0;wa=Km(d[e+16>>0]|0|0,0,8)|0;m=D;zc=Km(d[e+17>>0]|0|0,0,16)|0;m=m|D;ub=d[e+18>>0]|0;uc=Km(ub|0,0,24)|0;m=Mm(wa|wc|zc|uc|0,m|D|0,6)|0;uc=Km(d[e+19>>0]|0|0,0,8)|0;zc=D;wc=Km(d[e+20>>0]|0|0,0,16)|0;zc=Mm(uc|ub|wc|0,zc|D|0,3)|0;wc=D;ub=d[e+21>>0]|0;uc=Km(d[e+22>>0]|0|0,0,8)|0;wa=D;pc=d[e+23>>0]|0;na=Km(pc|0,0,16)|0;W=Km(d[e+24>>0]|0|0,0,8)|0;Ia=D;K=Km(d[e+25>>0]|0|0,0,16)|0;Ia=Ia|D;x=d[e+26>>0]|0;qc=Km(x|0,0,24)|0;Ia=Mm(W|pc|K|qc|0,Ia|D|0,5)|0;qc=Km(d[e+27>>0]|0|0,0,8)|0;K=D;pc=d[e+28>>0]|0;W=Km(pc|0,0,16)|0;K=Mm(qc|x|W|0,K|D|0,2)|0;W=Km(d[e+29>>0]|0|0,0,8)|0;x=D;qc=Km(d[e+30>>0]|0|0,0,16)|0;x=x|D;Ba=Km(d[e+31>>0]|0|0,0,24)|0;x=Mm(W|pc|qc|Ba|0,x|D|0,7)|0;Ba=D;qc=d[f>>0]|0;pc=Km(d[f+1>>0]|0|0,0,8)|0;W=D;y=d[f+2>>0]|0;rc=Km(y|0,0,16)|0;Qa=Km(d[f+3>>0]|0|0,0,8)|0;xa=D;Fa=Km(d[f+4>>0]|0|0,0,16)|0;xa=xa|D;ib=d[f+5>>0]|0;za=Km(ib|0,0,24)|0;xa=Mm(Qa|y|Fa|za|0,xa|D|0,5)|0;za=Km(d[f+6>>0]|0|0,0,8)|0;Fa=D;y=d[f+7>>0]|0;Qa=Km(y|0,0,16)|0;Fa=Mm(za|ib|Qa|0,Fa|D|0,2)|0;Qa=Km(d[f+8>>0]|0|0,0,8)|0;ib=D;za=Km(d[f+9>>0]|0|0,0,16)|0;ib=ib|D;h=d[f+10>>0]|0;Y=Km(h|0,0,24)|0;ib=Mm(Qa|y|za|Y|0,ib|D|0,7)|0;Y=Km(d[f+11>>0]|0|0,0,8)|0;za=D;y=Km(d[f+12>>0]|0|0,0,16)|0;za=za|D;Qa=d[f+13>>0]|0;B=Km(Qa|0,0,24)|0;za=Mm(Y|h|y|B|0,za|D|0,4)|0;B=Km(d[f+14>>0]|0|0,0,8)|0;y=D;h=d[f+15>>0]|0;Y=Km(h|0,0,16)|0;y=Mm(B|Qa|Y|0,y|D|0,1)|0;Y=Km(d[f+16>>0]|0|0,0,8)|0;Qa=D;B=Km(d[f+17>>0]|0|0,0,16)|0;Qa=Qa|D;sa=d[f+18>>0]|0;H=Km(sa|0,0,24)|0;Qa=Mm(Y|h|B|H|0,Qa|D|0,6)|0;H=Km(d[f+19>>0]|0|0,0,8)|0;B=D;h=Km(d[f+20>>0]|0|0,0,16)|0;B=Mm(H|sa|h|0,B|D|0,3)|0;h=D;sa=d[f+21>>0]|0;H=Km(d[f+22>>0]|0|0,0,8)|0;Y=D;ma=d[f+23>>0]|0;Z=Km(ma|0,0,16)|0;ua=Km(d[f+24>>0]|0|0,0,8)|0;G=D;N=Km(d[f+25>>0]|0|0,0,16)|0;G=G|D;c=d[f+26>>0]|0;Aa=Km(c|0,0,24)|0;G=Mm(ua|ma|N|Aa|0,G|D|0,5)|0;Aa=Km(d[f+27>>0]|0|0,0,8)|0;N=D;ma=d[f+28>>0]|0;ua=Km(ma|0,0,16)|0;N=Mm(Aa|c|ua|0,N|D|0,2)|0;ua=Km(d[f+29>>0]|0|0,0,8)|0;c=D;Aa=Km(d[f+30>>0]|0|0,0,16)|0;c=c|D;i=Km(d[f+31>>0]|0|0,0,24)|0;c=Mm(ua|ma|Aa|i|0,c|D|0,7)|0;i=D;Aa=Pl(eb|rb|aa&2031616|0,ba|0,P|O|db&2031616|0,jb|0)|0;Aa=go(pc|qc|rc&2031616|0,W|0,Aa|0,D|0)|0;W=D;rc=Pl(Ya&2097151|0,0,P|O|db&2031616|0,jb|0)|0;qc=D;pc=Pl(eb|rb|aa&2031616|0,ba|0,qb&2097151|0,0)|0;ma=D;ua=Pl(q&2097151|0,0,P|O|db&2031616|0,jb|0)|0;Ea=D;va=Pl(Ya&2097151|0,0,qb&2097151|0,0)|0;kc=D;ia=Pl(eb|rb|aa&2031616|0,ba|0,A&2097151|0,0)|0;ia=go(va|0,kc|0,ia|0,D|0)|0;Ea=go(ia|0,D|0,ua|0,Ea|0)|0;Fa=go(Ea|0,D|0,Fa&2097151|0,0)|0;Ea=D;ua=Pl(p&2097151|0,0,P|O|db&2031616|0,jb|0)|0;ia=D;kc=Pl(q&2097151|0,0,qb&2097151|0,0)|0;va=D;oc=Pl(Ya&2097151|0,0,A&2097151|0,0)|0;nc=D;mc=Pl(eb|rb|aa&2031616|0,ba|0,nb&2097151|0,0)|0;lc=D;Ha=Pl(ea&2097151|0,0,P|O|db&2031616|0,jb|0)|0;ya=D;bc=Pl(p&2097151|0,0,qb&2097151|0,0)|0;u=D;dc=Pl(q&2097151|0,0,A&2097151|0,0)|0;Ga=D;ec=Pl(Ya&2097151|0,0,nb&2097151|0,0)|0;fc=D;cc=Pl(eb|rb|aa&2031616|0,ba|0,z&2097151|0,0)|0;cc=go(ec|0,fc|0,cc|0,D|0)|0;Ga=go(cc|0,D|0,dc|0,Ga|0)|0;u=go(Ga|0,D|0,bc|0,u|0)|0;ya=go(u|0,D|0,Ha|0,ya|0)|0;za=go(ya|0,D|0,za&2097151|0,0)|0;ya=D;Ha=Pl(Ta&2097151|0,0,P|O|db&2031616|0,jb|0)|0;u=D;bc=Pl(ea&2097151|0,0,qb&2097151|0,0)|0;Ga=D;dc=Pl(p&2097151|0,0,A&2097151|0,0)|0;cc=D;fc=Pl(q&2097151|0,0,nb&2097151|0,0)|0;ec=D;jc=Pl(Ya&2097151|0,0,z&2097151|0,0)|0;ic=D;hc=Pl(eb|rb|aa&2031616|0,ba|0,j&2097151|0,0)|0;gc=D;X=Pl(m&2097151|0,0,P|O|db&2031616|0,jb|0)|0;Ra=D;Qb=Pl(Ta&2097151|0,0,qb&2097151|0,0)|0;da=D;Sb=Pl(ea&2097151|0,0,A&2097151|0,0)|0;Pb=D;Ub=Pl(p&2097151|0,0,nb&2097151|0,0)|0;Rb=D;Wb=Pl(q&2097151|0,0,z&2097151|0,0)|0;Tb=D;Xb=Pl(Ya&2097151|0,0,j&2097151|0,0)|0;Yb=D;Vb=Pl(eb|rb|aa&2031616|0,ba|0,Ma&2097151|0,0)|0;Vb=go(Xb|0,Yb|0,Vb|0,D|0)|0;Tb=go(Vb|0,D|0,Wb|0,Tb|0)|0;Rb=go(Tb|0,D|0,Ub|0,Rb|0)|0;Pb=go(Rb|0,D|0,Sb|0,Pb|0)|0;da=go(Pb|0,D|0,Qb|0,da|0)|0;Ra=go(da|0,D|0,X|0,Ra|0)|0;Qa=go(Ra|0,D|0,Qa&2097151|0,0)|0;Ra=D;X=Pl(zc|0,wc|0,P|O|db&2031616|0,jb|0)|0;da=D;Qb=Pl(m&2097151|0,0,qb&2097151|0,0)|0;Pb=D;Sb=Pl(Ta&2097151|0,0,A&2097151|0,0)|0;Rb=D;Ub=Pl(ea&2097151|0,0,nb&2097151|0,0)|0;Tb=D;Wb=Pl(p&2097151|0,0,z&2097151|0,0)|0;Vb=D;Yb=Pl(q&2097151|0,0,j&2097151|0,0)|0;Xb=D;ac=Pl(Ya&2097151|0,0,Ma&2097151|0,0)|0;$b=D;_b=Pl(eb|rb|aa&2031616|0,ba|0,ra|0,ca|0)|0;Zb=D;ta=Pl(uc|ub|na&2031616|0,wa|0,P|O|db&2031616|0,jb|0)|0;yb=D;zb=Pl(zc|0,wc|0,qb&2097151|0,0)|0;Ab=D;Bb=Pl(m&2097151|0,0,A&2097151|0,0)|0;Cb=D;Db=Pl(Ta&2097151|0,0,nb&2097151|0,0)|0;Eb=D;Fb=Pl(ea&2097151|0,0,z&2097151|0,0)|0;Gb=D;Hb=Pl(p&2097151|0,0,j&2097151|0,0)|0;Ib=D;Jb=Pl(q&2097151|0,0,Ma&2097151|0,0)|0;Kb=D;Mb=Pl(Ya&2097151|0,0,ra|0,ca|0)|0;Nb=D;Ob=Pl(eb|rb|aa&2031616|0,ba|0,I|Ca|Ja&2031616|0,lb|0)|0;Ob=go(Mb|0,Nb|0,Ob|0,D|0)|0;Kb=go(Ob|0,D|0,Jb|0,Kb|0)|0;Ib=go(Kb|0,D|0,Hb|0,Ib|0)|0;Gb=go(Ib|0,D|0,Fb|0,Gb|0)|0;Eb=go(Gb|0,D|0,Db|0,Eb|0)|0;Cb=go(Eb|0,D|0,Bb|0,Cb|0)|0;Ab=go(Cb|0,D|0,zb|0,Ab|0)|0;yb=go(Ab|0,D|0,ta|0,yb|0)|0;Y=go(yb|0,D|0,H|sa|Z&2031616|0,Y|0)|0;Z=D;sa=Pl(Ia&2097151|0,0,P|O|db&2031616|0,jb|0)|0;H=D;yb=Pl(uc|ub|na&2031616|0,wa|0,qb&2097151|0,0)|0;ta=D;Ab=Pl(zc|0,wc|0,A&2097151|0,0)|0;zb=D;Cb=Pl(m&2097151|0,0,nb&2097151|0,0)|0;Bb=D;Eb=Pl(Ta&2097151|0,0,z&2097151|0,0)|0;Db=D;Gb=Pl(ea&2097151|0,0,j&2097151|0,0)|0;Fb=D;Ib=Pl(p&2097151|0,0,Ma&2097151|0,0)|0;Hb=D;Kb=Pl(q&2097151|0,0,ra|0,ca|0)|0;Jb=D;Ob=Pl(Ya&2097151|0,0,I|Ca|Ja&2031616|0,lb|0)|0;Nb=D;Mb=Pl(eb|rb|aa&2031616|0,ba|0,La&2097151|0,0)|0;Lb=D;ab=Pl(K&2097151|0,0,P|O|db&2031616|0,jb|0)|0;M=D;Q=Pl(Ia&2097151|0,0,qb&2097151|0,0)|0;bb=D;ob=Pl(uc|ub|na&2031616|0,wa|0,A&2097151|0,0)|0;R=D;J=Pl(zc|0,wc|0,nb&2097151|0,0)|0;pb=D;Oa=Pl(m&2097151|0,0,z&2097151|0,0)|0;C=D;gb=Pl(Ta&2097151|0,0,j&2097151|0,0)|0;Pa=D;U=Pl(ea&2097151|0,0,Ma&2097151|0,0)|0;hb=D;Wa=Pl(p&2097151|0,0,ra|0,ca|0)|0;V=D;xb=Pl(q&2097151|0,0,I|Ca|Ja&2031616|0,lb|0)|0;Xa=D;fa=Pl(Ya&2097151|0,0,La&2097151|0,0)|0;w=D;wb=Pl(eb|rb|aa&2031616|0,ba|0,sc&2097151|0,0)|0;wb=go(fa|0,w|0,wb|0,D|0)|0;Xa=go(wb|0,D|0,xb|0,Xa|0)|0;V=go(Xa|0,D|0,Wa|0,V|0)|0;hb=go(V|0,D|0,U|0,hb|0)|0;Pa=go(hb|0,D|0,gb|0,Pa|0)|0;C=go(Pa|0,D|0,Oa|0,C|0)|0;pb=go(C|0,D|0,J|0,pb|0)|0;R=go(pb|0,D|0,ob|0,R|0)|0;bb=go(R|0,D|0,Q|0,bb|0)|0;M=go(bb|0,D|0,ab|0,M|0)|0;N=go(M|0,D|0,N&2097151|0,0)|0;M=D;jb=Pl(x|0,Ba|0,P|O|db&2031616|0,jb|0)|0;db=D;O=Pl(K&2097151|0,0,qb&2097151|0,0)|0;P=D;ab=Pl(Ia&2097151|0,0,A&2097151|0,0)|0;bb=D;Q=Pl(uc|ub|na&2031616|0,wa|0,nb&2097151|0,0)|0;R=D;ob=Pl(zc|0,wc|0,z&2097151|0,0)|0;pb=D;J=Pl(m&2097151|0,0,j&2097151|0,0)|0;C=D;Oa=Pl(Ta&2097151|0,0,Ma&2097151|0,0)|0;Pa=D;gb=Pl(ea&2097151|0,0,ra|0,ca|0)|0;hb=D;U=Pl(p&2097151|0,0,I|Ca|Ja&2031616|0,lb|0)|0;V=D;Wa=Pl(q&2097151|0,0,La&2097151|0,0)|0;Xa=D;xb=Pl(Ya&2097151|0,0,sc&2097151|0,0)|0;wb=D;ba=Pl(eb|rb|aa&2031616|0,ba|0,o|0,Da|0)|0;aa=D;qb=Pl(x|0,Ba|0,qb&2097151|0,0)|0;rb=D;eb=Pl(K&2097151|0,0,A&2097151|0,0)|0;w=D;fa=Pl(Ia&2097151|0,0,nb&2097151|0,0)|0;fb=D;ha=Pl(uc|ub|na&2031616|0,wa|0,z&2097151|0,0)|0;$=D;sb=Pl(zc|0,wc|0,j&2097151|0,0)|0;kb=D;la=Pl(m&2097151|0,0,Ma&2097151|0,0)|0;tb=D;qa=Pl(Ta&2097151|0,0,ra|0,ca|0)|0;ka=D;Na=Pl(ea&2097151|0,0,I|Ca|Ja&2031616|0,lb|0)|0;pa=D;Za=Pl(p&2097151|0,0,La&2097151|0,0)|0;ga=D;mb=Pl(q&2097151|0,0,sc&2097151|0,0)|0;v=D;Ya=Pl(Ya&2097151|0,0,o|0,Da|0)|0;Ya=go(mb|0,v|0,Ya|0,D|0)|0;ga=go(Ya|0,D|0,Za|0,ga|0)|0;pa=go(ga|0,D|0,Na|0,pa|0)|0;ka=go(pa|0,D|0,qa|0,ka|0)|0;tb=go(ka|0,D|0,la|0,tb|0)|0;kb=go(tb|0,D|0,sb|0,kb|0)|0;$=go(kb|0,D|0,ha|0,$|0)|0;fb=go($|0,D|0,fa|0,fb|0)|0;w=go(fb|0,D|0,eb|0,w|0)|0;rb=go(w|0,D|0,qb|0,rb|0)|0;qb=D;A=Pl(x|0,Ba|0,A&2097151|0,0)|0;w=D;eb=Pl(K&2097151|0,0,nb&2097151|0,0)|0;fb=D;fa=Pl(Ia&2097151|0,0,z&2097151|0,0)|0;$=D;ha=Pl(uc|ub|na&2031616|0,wa|0,j&2097151|0,0)|0;kb=D;sb=Pl(zc|0,wc|0,Ma&2097151|0,0)|0;tb=D;la=Pl(m&2097151|0,0,ra|0,ca|0)|0;ka=D;qa=Pl(Ta&2097151|0,0,I|Ca|Ja&2031616|0,lb|0)|0;pa=D;Na=Pl(ea&2097151|0,0,La&2097151|0,0)|0;ga=D;Za=Pl(p&2097151|0,0,sc&2097151|0,0)|0;Ya=D;q=Pl(q&2097151|0,0,o|0,Da|0)|0;v=D;nb=Pl(x|0,Ba|0,nb&2097151|0,0)|0;mb=D;_a=Pl(K&2097151|0,0,z&2097151|0,0)|0;r=D;E=Pl(Ia&2097151|0,0,j&2097151|0,0)|0;$a=D;n=Pl(uc|ub|na&2031616|0,wa|0,Ma&2097151|0,0)|0;t=D;_=Pl(zc|0,wc|0,ra|0,ca|0)|0;g=D;ja=Pl(m&2097151|0,0,I|Ca|Ja&2031616|0,lb|0)|0;s=D;oa=Pl(Ta&2097151|0,0,La&2097151|0,0)|0;F=D;vb=Pl(ea&2097151|0,0,sc&2097151|0,0)|0;l=D;p=Pl(p&2097151|0,0,o|0,Da|0)|0;p=go(vb|0,l|0,p|0,D|0)|0;F=go(p|0,D|0,oa|0,F|0)|0;s=go(F|0,D|0,ja|0,s|0)|0;g=go(s|0,D|0,_|0,g|0)|0;t=go(g|0,D|0,n|0,t|0)|0;$a=go(t|0,D|0,E|0,$a|0)|0;r=go($a|0,D|0,_a|0,r|0)|0;mb=go(r|0,D|0,nb|0,mb|0)|0;nb=D;z=Pl(x|0,Ba|0,z&2097151|0,0)|0;r=D;_a=Pl(K&2097151|0,0,j&2097151|0,0)|0;$a=D;E=Pl(Ia&2097151|0,0,Ma&2097151|0,0)|0;t=D;n=Pl(uc|ub|na&2031616|0,wa|0,ra|0,ca|0)|0;g=D;_=Pl(zc|0,wc|0,I|Ca|Ja&2031616|0,lb|0)|0;s=D;ja=Pl(m&2097151|0,0,La&2097151|0,0)|0;F=D;oa=Pl(Ta&2097151|0,0,sc&2097151|0,0)|0;p=D;ea=Pl(ea&2097151|0,0,o|0,Da|0)|0;l=D;j=Pl(x|0,Ba|0,j&2097151|0,0)|0;vb=D;e=Pl(K&2097151|0,0,Ma&2097151|0,0)|0;L=D;T=Pl(Ia&2097151|0,0,ra|0,ca|0)|0;Ka=D;Va=Pl(uc|ub|na&2031616|0,wa|0,I|Ca|Ja&2031616|0,lb|0)|0;S=D;Sa=Pl(zc|0,wc|0,La&2097151|0,0)|0;Ua=D;f=Pl(m&2097151|0,0,sc&2097151|0,0)|0;k=D;Ta=Pl(Ta&2097151|0,0,o|0,Da|0)|0;Ta=go(f|0,k|0,Ta|0,D|0)|0;Ua=go(Ta|0,D|0,Sa|0,Ua|0)|0;S=go(Ua|0,D|0,Va|0,S|0)|0;Ka=go(S|0,D|0,T|0,Ka|0)|0;L=go(Ka|0,D|0,e|0,L|0)|0;vb=go(L|0,D|0,j|0,vb|0)|0;j=D;Ma=Pl(x|0,Ba|0,Ma&2097151|0,0)|0;L=D;e=Pl(K&2097151|0,0,ra|0,ca|0)|0;Ka=D;T=Pl(Ia&2097151|0,0,I|Ca|Ja&2031616|0,lb|0)|0;S=D;Va=Pl(uc|ub|na&2031616|0,wa|0,La&2097151|0,0)|0;Ua=D;Sa=Pl(zc|0,wc|0,sc&2097151|0,0)|0;Ta=D;m=Pl(m&2097151|0,0,o|0,Da|0)|0;k=D;ca=Pl(x|0,Ba|0,ra|0,ca|0)|0;f=D;ra=Pl(K&2097151|0,0,I|Ca|Ja&2031616|0,lb|0)|0;cb=D;vc=Pl(Ia&2097151|0,0,La&2097151|0,0)|0;tc=D;yc=Pl(uc|ub|na&2031616|0,wa|0,sc&2097151|0,0)|0;xc=D;wc=Pl(zc|0,wc|0,o|0,Da|0)|0;wc=go(yc|0,xc|0,wc|0,D|0)|0;tc=go(wc|0,D|0,vc|0,tc|0)|0;cb=go(tc|0,D|0,ra|0,cb|0)|0;f=go(cb|0,D|0,ca|0,f|0)|0;ca=D;lb=Pl(x|0,Ba|0,I|Ca|Ja&2031616|0,lb|0)|0;Ja=D;Ca=Pl(K&2097151|0,0,La&2097151|0,0)|0;I=D;cb=Pl(Ia&2097151|0,0,sc&2097151|0,0)|0;ra=D;wa=Pl(uc|ub|na&2031616|0,wa|0,o|0,Da|0)|0;na=D;La=Pl(x|0,Ba|0,La&2097151|0,0)|0;ub=D;uc=Pl(K&2097151|0,0,sc&2097151|0,0)|0;tc=D;Ia=Pl(Ia&2097151|0,0,o|0,Da|0)|0;Ia=go(uc|0,tc|0,Ia|0,D|0)|0;ub=go(Ia|0,D|0,La|0,ub|0)|0;La=D;sc=Pl(x|0,Ba|0,sc&2097151|0,0)|0;Ia=D;K=Pl(K&2097151|0,0,o|0,Da|0)|0;K=go(sc|0,Ia|0,K|0,D|0)|0;Ia=D;Da=Pl(x|0,Ba|0,o|0,Da|0)|0;o=D;Ba=go(Aa|0,W|0,1048576,0)|0;Ba=Mm(Ba|0,D|0,21)|0;x=D;ma=go(rc|0,qc|0,pc|0,ma|0)|0;ma=go(ma|0,D|0,Ba|0,x|0)|0;xa=go(ma|0,D|0,xa&2097151|0,0)|0;ma=D;x=Km(Ba|0,x|0,21)|0;x=Sm(Aa|0,W|0,x|0,D|0)|0;W=D;Aa=go(Fa|0,Ea|0,1048576,0)|0;Aa=Mm(Aa|0,D|0,21)|0;Ba=D;lc=go(oc|0,nc|0,mc|0,lc|0)|0;va=go(lc|0,D|0,kc|0,va|0)|0;ia=go(va|0,D|0,ua|0,ia|0)|0;ib=go(ia|0,D|0,ib&2097151|0,0)|0;ib=go(ib|0,D|0,Aa|0,Ba|0)|0;ia=D;Ba=Km(Aa|0,Ba|0,21)|0;Aa=D;ua=go(za|0,ya|0,1048576,0)|0;ua=_l(ua|0,D|0,21)|0;va=D;gc=go(jc|0,ic|0,hc|0,gc|0)|0;ec=go(gc|0,D|0,fc|0,ec|0)|0;cc=go(ec|0,D|0,dc|0,cc|0)|0;Ga=go(cc|0,D|0,bc|0,Ga|0)|0;u=go(Ga|0,D|0,Ha|0,u|0)|0;y=go(u|0,D|0,y&2097151|0,0)|0;y=go(y|0,D|0,ua|0,va|0)|0;u=D;va=Km(ua|0,va|0,21)|0;ua=D;Ha=go(Qa|0,Ra|0,1048576,0)|0;Ha=_l(Ha|0,D|0,21)|0;Ga=D;Zb=go(ac|0,$b|0,_b|0,Zb|0)|0;Xb=go(Zb|0,D|0,Yb|0,Xb|0)|0;Vb=go(Xb|0,D|0,Wb|0,Vb|0)|0;Tb=go(Vb|0,D|0,Ub|0,Tb|0)|0;Rb=go(Tb|0,D|0,Sb|0,Rb|0)|0;Pb=go(Rb|0,D|0,Qb|0,Pb|0)|0;da=go(Pb|0,D|0,X|0,da|0)|0;h=go(da|0,D|0,B|0,h|0)|0;h=go(h|0,D|0,Ha|0,Ga|0)|0;B=D;Ga=Km(Ha|0,Ga|0,21)|0;Ha=D;da=go(Y|0,Z|0,1048576,0)|0;da=_l(da|0,D|0,21)|0;X=D;Lb=go(Ob|0,Nb|0,Mb|0,Lb|0)|0;Jb=go(Lb|0,D|0,Kb|0,Jb|0)|0;Hb=go(Jb|0,D|0,Ib|0,Hb|0)|0;Fb=go(Hb|0,D|0,Gb|0,Fb|0)|0;Db=go(Fb|0,D|0,Eb|0,Db|0)|0;Bb=go(Db|0,D|0,Cb|0,Bb|0)|0;zb=go(Bb|0,D|0,Ab|0,zb|0)|0;ta=go(zb|0,D|0,yb|0,ta|0)|0;H=go(ta|0,D|0,sa|0,H|0)|0;G=go(H|0,D|0,G&2097151|0,0)|0;G=go(G|0,D|0,da|0,X|0)|0;H=D;X=Km(da|0,X|0,21)|0;da=D;sa=go(N|0,M|0,1048576,0)|0;sa=_l(sa|0,D|0,21)|0;ta=D;aa=go(xb|0,wb|0,ba|0,aa|0)|0;Xa=go(aa|0,D|0,Wa|0,Xa|0)|0;V=go(Xa|0,D|0,U|0,V|0)|0;hb=go(V|0,D|0,gb|0,hb|0)|0;Pa=go(hb|0,D|0,Oa|0,Pa|0)|0;C=go(Pa|0,D|0,J|0,C|0)|0;pb=go(C|0,D|0,ob|0,pb|0)|0;R=go(pb|0,D|0,Q|0,R|0)|0;bb=go(R|0,D|0,ab|0,bb|0)|0;P=go(bb|0,D|0,O|0,P|0)|0;db=go(P|0,D|0,jb|0,db|0)|0;i=go(db|0,D|0,c|0,i|0)|0;i=go(i|0,D|0,sa|0,ta|0)|0;c=D;ta=Km(sa|0,ta|0,21)|0;sa=D;db=go(rb|0,qb|0,1048576,0)|0;db=_l(db|0,D|0,21)|0;jb=D;v=go(Za|0,Ya|0,q|0,v|0)|0;ga=go(v|0,D|0,Na|0,ga|0)|0;pa=go(ga|0,D|0,qa|0,pa|0)|0;ka=go(pa|0,D|0,la|0,ka|0)|0;tb=go(ka|0,D|0,sb|0,tb|0)|0;kb=go(tb|0,D|0,ha|0,kb|0)|0;$=go(kb|0,D|0,fa|0,$|0)|0;fb=go($|0,D|0,eb|0,fb|0)|0;w=go(fb|0,D|0,A|0,w|0)|0;w=go(w|0,D|0,db|0,jb|0)|0;A=D;jb=Km(db|0,jb|0,21)|0;db=D;fb=go(mb|0,nb|0,1048576,0)|0;fb=_l(fb|0,D|0,21)|0;eb=D;l=go(oa|0,p|0,ea|0,l|0)|0;F=go(l|0,D|0,ja|0,F|0)|0;s=go(F|0,D|0,_|0,s|0)|0;g=go(s|0,D|0,n|0,g|0)|0;t=go(g|0,D|0,E|0,t|0)|0;$a=go(t|0,D|0,_a|0,$a|0)|0;r=go($a|0,D|0,z|0,r|0)|0;r=go(r|0,D|0,fb|0,eb|0)|0;z=D;eb=Km(fb|0,eb|0,21)|0;fb=D;$a=go(vb|0,j|0,1048576,0)|0;$a=_l($a|0,D|0,21)|0;_a=D;k=go(Sa|0,Ta|0,m|0,k|0)|0;Ua=go(k|0,D|0,Va|0,Ua|0)|0;S=go(Ua|0,D|0,T|0,S|0)|0;Ka=go(S|0,D|0,e|0,Ka|0)|0;L=go(Ka|0,D|0,Ma|0,L|0)|0;L=go(L|0,D|0,$a|0,_a|0)|0;Ma=D;_a=Km($a|0,_a|0,21)|0;$a=D;Ka=go(f|0,ca|0,1048576,0)|0;Ka=_l(Ka|0,D|0,21)|0;e=D;na=go(cb|0,ra|0,wa|0,na|0)|0;I=go(na|0,D|0,Ca|0,I|0)|0;Ja=go(I|0,D|0,lb|0,Ja|0)|0;Ja=go(Ja|0,D|0,Ka|0,e|0)|0;lb=D;e=Km(Ka|0,e|0,21)|0;e=Sm(f|0,ca|0,e|0,D|0)|0;ca=D;f=go(ub|0,La|0,1048576,0)|0;f=_l(f|0,D|0,21)|0;Ka=D;Ia=go(K|0,Ia|0,f|0,Ka|0)|0;K=D;Ka=Km(f|0,Ka|0,21)|0;Ka=Sm(ub|0,La|0,Ka|0,D|0)|0;La=D;ub=go(Da|0,o|0,1048576,0)|0;ub=_l(ub|0,D|0,21)|0;f=D;I=Km(ub|0,f|0,21)|0;I=Sm(Da|0,o|0,I|0,D|0)|0;o=D;Da=go(xa|0,ma|0,1048576,0)|0;Da=Mm(Da|0,D|0,21)|0;Ca=D;na=Km(Da|0,Ca|0,21)|0;na=Sm(xa|0,ma|0,na|0,D|0)|0;ma=D;xa=go(ib|0,ia|0,1048576,0)|0;xa=_l(xa|0,D|0,21)|0;wa=D;ra=Km(xa|0,wa|0,21)|0;ra=Sm(ib|0,ia|0,ra|0,D|0)|0;ia=D;ib=go(y|0,u|0,1048576,0)|0;ib=_l(ib|0,D|0,21)|0;cb=D;S=Km(ib|0,cb|0,21)|0;T=D;Ua=go(h|0,B|0,1048576,0)|0;Ua=_l(Ua|0,D|0,21)|0;Va=D;k=Km(Ua|0,Va|0,21)|0;m=D;Ta=go(G|0,H|0,1048576,0)|0;Ta=_l(Ta|0,D|0,21)|0;Sa=D;t=Km(Ta|0,Sa|0,21)|0;E=D;g=go(i|0,c|0,1048576,0)|0;g=_l(g|0,D|0,21)|0;n=D;s=Km(g|0,n|0,21)|0;_=D;F=go(w|0,A|0,1048576,0)|0;F=_l(F|0,D|0,21)|0;ja=D;l=Km(F|0,ja|0,21)|0;ea=D;p=go(r|0,z|0,1048576,0)|0;p=_l(p|0,D|0,21)|0;oa=D;$=Km(p|0,oa|0,21)|0;fa=D;kb=go(L|0,Ma|0,1048576,0)|0;kb=_l(kb|0,D|0,21)|0;ha=D;ca=go(kb|0,ha|0,e|0,ca|0)|0;e=D;ha=Km(kb|0,ha|0,21)|0;ha=Sm(L|0,Ma|0,ha|0,D|0)|0;Ma=D;L=go(Ja|0,lb|0,1048576,0)|0;L=_l(L|0,D|0,21)|0;kb=D;La=go(L|0,kb|0,Ka|0,La|0)|0;Ka=D;kb=Km(L|0,kb|0,21)|0;kb=Sm(Ja|0,lb|0,kb|0,D|0)|0;lb=D;Ja=go(Ia|0,K|0,1048576,0)|0;Ja=_l(Ja|0,D|0,21)|0;L=D;o=go(Ja|0,L|0,I|0,o|0)|0;I=D;L=Km(Ja|0,L|0,21)|0;L=Sm(Ia|0,K|0,L|0,D|0)|0;K=D;Ia=Pl(ub|0,f|0,666643,0)|0;Ja=D;tb=Pl(ub|0,f|0,470296,0)|0;sb=D;ka=Pl(ub|0,f|0,654183,0)|0;la=D;pa=Pl(ub|0,f|0,-997805,-1)|0;qa=D;ga=Pl(ub|0,f|0,136657,0)|0;Na=D;f=Pl(ub|0,f|0,-683901,-1)|0;f=go(vb|0,j|0,f|0,D|0)|0;$a=Sm(f|0,D|0,_a|0,$a|0)|0;oa=go($a|0,D|0,p|0,oa|0)|0;p=D;$a=Pl(o|0,I|0,666643,0)|0;_a=D;f=Pl(o|0,I|0,470296,0)|0;j=D;vb=Pl(o|0,I|0,654183,0)|0;ub=D;v=Pl(o|0,I|0,-997805,-1)|0;q=D;Ya=Pl(o|0,I|0,136657,0)|0;Za=D;I=Pl(o|0,I|0,-683901,-1)|0;o=D;P=Pl(L|0,K|0,666643,0)|0;O=D;bb=Pl(L|0,K|0,470296,0)|0;ab=D;R=Pl(L|0,K|0,654183,0)|0;Q=D;pb=Pl(L|0,K|0,-997805,-1)|0;ob=D;C=Pl(L|0,K|0,136657,0)|0;J=D;K=Pl(L|0,K|0,-683901,-1)|0;L=D;qa=go(mb|0,nb|0,pa|0,qa|0)|0;Za=go(qa|0,D|0,Ya|0,Za|0)|0;L=go(Za|0,D|0,K|0,L|0)|0;fb=Sm(L|0,D|0,eb|0,fb|0)|0;ja=go(fb|0,D|0,F|0,ja|0)|0;F=D;fb=Pl(La|0,Ka|0,666643,0)|0;eb=D;L=Pl(La|0,Ka|0,470296,0)|0;K=D;Za=Pl(La|0,Ka|0,654183,0)|0;Ya=D;qa=Pl(La|0,Ka|0,-997805,-1)|0;pa=D;nb=Pl(La|0,Ka|0,136657,0)|0;mb=D;Ka=Pl(La|0,Ka|0,-683901,-1)|0;La=D;Pa=Pl(kb|0,lb|0,666643,0)|0;Oa=D;hb=Pl(kb|0,lb|0,470296,0)|0;gb=D;V=Pl(kb|0,lb|0,654183,0)|0;U=D;Xa=Pl(kb|0,lb|0,-997805,-1)|0;Wa=D;aa=Pl(kb|0,lb|0,136657,0)|0;ba=D;lb=Pl(kb|0,lb|0,-683901,-1)|0;kb=D;sb=go(vb|0,ub|0,tb|0,sb|0)|0;qb=go(sb|0,D|0,rb|0,qb|0)|0;ob=go(qb|0,D|0,pb|0,ob|0)|0;mb=go(ob|0,D|0,nb|0,mb|0)|0;kb=go(mb|0,D|0,lb|0,kb|0)|0;db=Sm(kb|0,D|0,jb|0,db|0)|0;n=go(db|0,D|0,g|0,n|0)|0;g=D;db=Pl(ca|0,e|0,666643,0)|0;db=go(ib|0,cb|0,db|0,D|0)|0;Ra=go(db|0,D|0,Qa|0,Ra|0)|0;Ha=Sm(Ra|0,D|0,Ga|0,Ha|0)|0;Ga=D;Ra=Pl(ca|0,e|0,470296,0)|0;Qa=D;db=Pl(ca|0,e|0,654183,0)|0;cb=D;eb=go(hb|0,gb|0,fb|0,eb|0)|0;cb=go(eb|0,D|0,db|0,cb|0)|0;Va=go(cb|0,D|0,Ua|0,Va|0)|0;Z=go(Va|0,D|0,Y|0,Z|0)|0;da=Sm(Z|0,D|0,X|0,da|0)|0;X=D;Z=Pl(ca|0,e|0,-997805,-1)|0;Y=D;Va=Pl(ca|0,e|0,136657,0)|0;Ua=D;_a=go(bb|0,ab|0,$a|0,_a|0)|0;Ya=go(_a|0,D|0,Za|0,Ya|0)|0;Wa=go(Ya|0,D|0,Xa|0,Wa|0)|0;Ua=go(Wa|0,D|0,Va|0,Ua|0)|0;Sa=go(Ua|0,D|0,Ta|0,Sa|0)|0;M=go(Sa|0,D|0,N|0,M|0)|0;sa=Sm(M|0,D|0,ta|0,sa|0)|0;ta=D;e=Pl(ca|0,e|0,-683901,-1)|0;ca=D;M=go(Ha|0,Ga|0,1048576,0)|0;M=_l(M|0,D|0,21)|0;N=D;Oa=go(Ra|0,Qa|0,Pa|0,Oa|0)|0;B=go(Oa|0,D|0,h|0,B|0)|0;m=Sm(B|0,D|0,k|0,m|0)|0;m=go(m|0,D|0,M|0,N|0)|0;k=D;N=Km(M|0,N|0,21)|0;M=D;B=go(da|0,X|0,1048576,0)|0;B=_l(B|0,D|0,21)|0;h=D;O=go(L|0,K|0,P|0,O|0)|0;U=go(O|0,D|0,V|0,U|0)|0;Y=go(U|0,D|0,Z|0,Y|0)|0;H=go(Y|0,D|0,G|0,H|0)|0;E=Sm(H|0,D|0,t|0,E|0)|0;E=go(E|0,D|0,B|0,h|0)|0;t=D;h=Km(B|0,h|0,21)|0;B=D;H=go(sa|0,ta|0,1048576,0)|0;H=_l(H|0,D|0,21)|0;G=D;Ja=go(f|0,j|0,Ia|0,Ja|0)|0;Q=go(Ja|0,D|0,R|0,Q|0)|0;pa=go(Q|0,D|0,qa|0,pa|0)|0;ba=go(pa|0,D|0,aa|0,ba|0)|0;ca=go(ba|0,D|0,e|0,ca|0)|0;c=go(ca|0,D|0,i|0,c|0)|0;_=Sm(c|0,D|0,s|0,_|0)|0;_=go(_|0,D|0,H|0,G|0)|0;s=D;G=Km(H|0,G|0,21)|0;H=D;c=go(n|0,g|0,1048576,0)|0;c=_l(c|0,D|0,21)|0;i=D;la=go(v|0,q|0,ka|0,la|0)|0;J=go(la|0,D|0,C|0,J|0)|0;La=go(J|0,D|0,Ka|0,La|0)|0;A=go(La|0,D|0,w|0,A|0)|0;ea=Sm(A|0,D|0,l|0,ea|0)|0;ea=go(ea|0,D|0,c|0,i|0)|0;l=D;i=Km(c|0,i|0,21)|0;i=Sm(n|0,g|0,i|0,D|0)|0;g=D;n=go(ja|0,F|0,1048576,0)|0;n=_l(n|0,D|0,21)|0;c=D;Na=go(I|0,o|0,ga|0,Na|0)|0;z=go(Na|0,D|0,r|0,z|0)|0;fa=Sm(z|0,D|0,$|0,fa|0)|0;fa=go(fa|0,D|0,n|0,c|0)|0;$=D;c=Km(n|0,c|0,21)|0;c=Sm(ja|0,F|0,c|0,D|0)|0;F=D;ja=go(oa|0,p|0,1048576,0)|0;ja=_l(ja|0,D|0,21)|0;n=D;Ma=go(ja|0,n|0,ha|0,Ma|0)|0;ha=D;n=Km(ja|0,n|0,21)|0;n=Sm(oa|0,p|0,n|0,D|0)|0;p=D;oa=go(m|0,k|0,1048576,0)|0;oa=_l(oa|0,D|0,21)|0;ja=D;z=Km(oa|0,ja|0,21)|0;r=D;Na=go(E|0,t|0,1048576,0)|0;Na=_l(Na|0,D|0,21)|0;ga=D;o=Km(Na|0,ga|0,21)|0;I=D;A=go(_|0,s|0,1048576,0)|0;A=_l(A|0,D|0,21)|0;w=D;g=go(A|0,w|0,i|0,g|0)|0;i=D;w=Km(A|0,w|0,21)|0;w=Sm(_|0,s|0,w|0,D|0)|0;s=D;_=go(ea|0,l|0,1048576,0)|0;_=_l(_|0,D|0,21)|0;A=D;F=go(_|0,A|0,c|0,F|0)|0;c=D;A=Km(_|0,A|0,21)|0;A=Sm(ea|0,l|0,A|0,D|0)|0;l=D;ea=go(fa|0,$|0,1048576,0)|0;ea=_l(ea|0,D|0,21)|0;_=D;p=go(ea|0,_|0,n|0,p|0)|0;n=D;_=Km(ea|0,_|0,21)|0;_=Sm(fa|0,$|0,_|0,D|0)|0;$=D;fa=Pl(Ma|0,ha|0,666643,0)|0;ea=D;La=Pl(Ma|0,ha|0,470296,0)|0;Ka=D;J=Pl(Ma|0,ha|0,654183,0)|0;C=D;la=Pl(Ma|0,ha|0,-997805,-1)|0;ka=D;q=Pl(Ma|0,ha|0,136657,0)|0;v=D;ha=Pl(Ma|0,ha|0,-683901,-1)|0;ha=go(Na|0,ga|0,ha|0,D|0)|0;ta=go(ha|0,D|0,sa|0,ta|0)|0;H=Sm(ta|0,D|0,G|0,H|0)|0;G=D;ta=Pl(p|0,n|0,666643,0)|0;sa=D;ha=Pl(p|0,n|0,470296,0)|0;ga=D;Na=Pl(p|0,n|0,654183,0)|0;Ma=D;ca=Pl(p|0,n|0,-997805,-1)|0;e=D;ba=Pl(p|0,n|0,136657,0)|0;aa=D;n=Pl(p|0,n|0,-683901,-1)|0;p=D;pa=Pl(_|0,$|0,666643,0)|0;pa=go(ra|0,ia|0,pa|0,D|0)|0;ia=D;ra=Pl(_|0,$|0,470296,0)|0;qa=D;Q=Pl(_|0,$|0,654183,0)|0;R=D;Ja=Pl(_|0,$|0,-997805,-1)|0;Ia=D;j=Pl(_|0,$|0,136657,0)|0;f=D;$=Pl(_|0,$|0,-683901,-1)|0;_=D;ka=go(ba|0,aa|0,la|0,ka|0)|0;_=go(ka|0,D|0,$|0,_|0)|0;ja=go(_|0,D|0,oa|0,ja|0)|0;X=go(ja|0,D|0,da|0,X|0)|0;B=Sm(X|0,D|0,h|0,B|0)|0;h=D;X=Pl(F|0,c|0,666643,0)|0;da=D;ja=Pl(F|0,c|0,470296,0)|0;ja=go(pa|0,ia|0,ja|0,D|0)|0;ia=D;pa=Pl(F|0,c|0,654183,0)|0;oa=D;_=Pl(F|0,c|0,-997805,-1)|0;$=D;ka=Pl(F|0,c|0,136657,0)|0;la=D;c=Pl(F|0,c|0,-683901,-1)|0;F=D;aa=Pl(A|0,l|0,666643,0)|0;ba=D;Y=Pl(A|0,l|0,470296,0)|0;Z=D;U=Pl(A|0,l|0,654183,0)|0;V=D;O=Pl(A|0,l|0,-997805,-1)|0;P=D;K=Pl(A|0,l|0,136657,0)|0;L=D;l=Pl(A|0,l|0,-683901,-1)|0;A=D;Ka=go(Na|0,Ma|0,La|0,Ka|0)|0;Ia=go(Ka|0,D|0,Ja|0,Ia|0)|0;Ga=go(Ia|0,D|0,Ha|0,Ga|0)|0;M=Sm(Ga|0,D|0,N|0,M|0)|0;la=go(M|0,D|0,ka|0,la|0)|0;A=go(la|0,D|0,l|0,A|0)|0;l=D;la=Pl(g|0,i|0,666643,0)|0;W=go(la|0,D|0,x|0,W|0)|0;x=D;la=Pl(g|0,i|0,470296,0)|0;ka=D;M=Pl(g|0,i|0,654183,0)|0;N=D;Ca=go(Fa|0,Ea|0,Da|0,Ca|0)|0;Aa=Sm(Ca|0,D|0,Ba|0,Aa|0)|0;da=go(Aa|0,D|0,X|0,da|0)|0;N=go(da|0,D|0,M|0,N|0)|0;Z=go(N|0,D|0,Y|0,Z|0)|0;Y=D;N=Pl(g|0,i|0,-997805,-1)|0;M=D;da=Pl(g|0,i|0,136657,0)|0;X=D;wa=go(za|0,ya|0,xa|0,wa|0)|0;ua=Sm(wa|0,D|0,va|0,ua|0)|0;sa=go(ua|0,D|0,ta|0,sa|0)|0;qa=go(sa|0,D|0,ra|0,qa|0)|0;oa=go(qa|0,D|0,pa|0,oa|0)|0;X=go(oa|0,D|0,da|0,X|0)|0;P=go(X|0,D|0,O|0,P|0)|0;O=D;i=Pl(g|0,i|0,-683901,-1)|0;g=D;X=go(W|0,x|0,1048576,0)|0;X=_l(X|0,D|0,21)|0;da=D;ka=go(na|0,ma|0,la|0,ka|0)|0;ba=go(ka|0,D|0,aa|0,ba|0)|0;ba=go(ba|0,D|0,X|0,da|0)|0;aa=D;da=Km(X|0,da|0,21)|0;da=Sm(W|0,x|0,da|0,D|0)|0;x=D;W=go(Z|0,Y|0,1048576,0)|0;W=_l(W|0,D|0,21)|0;X=D;M=go(ja|0,ia|0,N|0,M|0)|0;V=go(M|0,D|0,U|0,V|0)|0;V=go(V|0,D|0,W|0,X|0)|0;U=D;X=Km(W|0,X|0,21)|0;W=D;M=go(P|0,O|0,1048576,0)|0;M=_l(M|0,D|0,21)|0;N=D;ea=go(ha|0,ga|0,fa|0,ea|0)|0;u=go(ea|0,D|0,y|0,u|0)|0;R=go(u|0,D|0,Q|0,R|0)|0;T=Sm(R|0,D|0,S|0,T|0)|0;$=go(T|0,D|0,_|0,$|0)|0;g=go($|0,D|0,i|0,g|0)|0;L=go(g|0,D|0,K|0,L|0)|0;L=go(L|0,D|0,M|0,N|0)|0;K=D;N=Km(M|0,N|0,21)|0;M=D;g=go(A|0,l|0,1048576,0)|0;g=_l(g|0,D|0,21)|0;i=D;C=go(ca|0,e|0,J|0,C|0)|0;f=go(C|0,D|0,j|0,f|0)|0;k=go(f|0,D|0,m|0,k|0)|0;r=Sm(k|0,D|0,z|0,r|0)|0;F=go(r|0,D|0,c|0,F|0)|0;F=go(F|0,D|0,g|0,i|0)|0;c=D;i=Km(g|0,i|0,21)|0;i=Sm(A|0,l|0,i|0,D|0)|0;l=D;A=go(B|0,h|0,1048576,0)|0;A=_l(A|0,D|0,21)|0;g=D;v=go(n|0,p|0,q|0,v|0)|0;t=go(v|0,D|0,E|0,t|0)|0;I=Sm(t|0,D|0,o|0,I|0)|0;I=go(I|0,D|0,A|0,g|0)|0;o=D;g=Km(A|0,g|0,21)|0;g=Sm(B|0,h|0,g|0,D|0)|0;h=D;B=go(H|0,G|0,1048576,0)|0;B=_l(B|0,D|0,21)|0;A=D;s=go(w|0,s|0,B|0,A|0)|0;w=D;A=Km(B|0,A|0,21)|0;B=D;t=go(ba|0,aa|0,1048576,0)|0;t=_l(t|0,D|0,21)|0;E=D;v=Km(t|0,E|0,21)|0;q=D;p=go(V|0,U|0,1048576,0)|0;p=_l(p|0,D|0,21)|0;n=D;r=Km(p|0,n|0,21)|0;z=D;k=go(L|0,K|0,1048576,0)|0;k=_l(k|0,D|0,21)|0;m=D;l=go(i|0,l|0,k|0,m|0)|0;i=D;m=Km(k|0,m|0,21)|0;k=D;f=go(F|0,c|0,1048576,0)|0;f=_l(f|0,D|0,21)|0;j=D;h=go(g|0,h|0,f|0,j|0)|0;g=D;j=Km(f|0,j|0,21)|0;j=Sm(F|0,c|0,j|0,D|0)|0;c=D;F=go(I|0,o|0,1048576,0)|0;F=_l(F|0,D|0,21)|0;f=D;C=Km(F|0,f|0,21)|0;C=Sm(I|0,o|0,C|0,D|0)|0;o=D;I=go(s|0,w|0,1048576,0)|0;I=_l(I|0,D|0,21)|0;J=D;e=Km(I|0,J|0,21)|0;e=Sm(s|0,w|0,e|0,D|0)|0;w=D;s=Pl(I|0,J|0,666643,0)|0;s=go(da|0,x|0,s|0,D|0)|0;x=D;da=Pl(I|0,J|0,470296,0)|0;ca=D;$=Pl(I|0,J|0,654183,0)|0;_=D;T=Pl(I|0,J|0,-997805,-1)|0;S=D;R=Pl(I|0,J|0,136657,0)|0;Q=D;J=Pl(I|0,J|0,-683901,-1)|0;I=D;u=_l(s|0,x|0,21)|0;y=D;aa=go(da|0,ca|0,ba|0,aa|0)|0;q=Sm(aa|0,D|0,v|0,q|0)|0;q=go(q|0,D|0,u|0,y|0)|0;v=D;y=Km(u|0,y|0,21)|0;y=Sm(s|0,x|0,y|0,D|0)|0;x=D;s=_l(q|0,v|0,21)|0;u=D;Y=go($|0,_|0,Z|0,Y|0)|0;W=Sm(Y|0,D|0,X|0,W|0)|0;E=go(W|0,D|0,t|0,E|0)|0;E=go(E|0,D|0,s|0,u|0)|0;t=D;u=Km(s|0,u|0,21)|0;u=Sm(q|0,v|0,u|0,D|0)|0;v=D;q=_l(E|0,t|0,21)|0;s=D;S=go(V|0,U|0,T|0,S|0)|0;z=Sm(S|0,D|0,r|0,z|0)|0;z=go(z|0,D|0,q|0,s|0)|0;r=D;s=Km(q|0,s|0,21)|0;s=Sm(E|0,t|0,s|0,D|0)|0;t=D;E=_l(z|0,r|0,21)|0;q=D;O=go(R|0,Q|0,P|0,O|0)|0;M=Sm(O|0,D|0,N|0,M|0)|0;n=go(M|0,D|0,p|0,n|0)|0;n=go(n|0,D|0,E|0,q|0)|0;p=D;q=Km(E|0,q|0,21)|0;q=Sm(z|0,r|0,q|0,D|0)|0;r=D;z=_l(n|0,p|0,21)|0;E=D;I=go(L|0,K|0,J|0,I|0)|0;k=Sm(I|0,D|0,m|0,k|0)|0;k=go(k|0,D|0,z|0,E|0)|0;m=D;E=Km(z|0,E|0,21)|0;E=Sm(n|0,p|0,E|0,D|0)|0;p=D;n=_l(k|0,m|0,21)|0;z=D;i=go(l|0,i|0,n|0,z|0)|0;l=D;z=Km(n|0,z|0,21)|0;z=Sm(k|0,m|0,z|0,D|0)|0;m=D;k=_l(i|0,l|0,21)|0;n=D;c=go(k|0,n|0,j|0,c|0)|0;j=D;n=Km(k|0,n|0,21)|0;n=Sm(i|0,l|0,n|0,D|0)|0;l=D;i=_l(c|0,j|0,21)|0;k=D;g=go(h|0,g|0,i|0,k|0)|0;h=D;k=Km(i|0,k|0,21)|0;k=Sm(c|0,j|0,k|0,D|0)|0;j=D;c=_l(g|0,h|0,21)|0;i=D;o=go(c|0,i|0,C|0,o|0)|0;C=D;i=Km(c|0,i|0,21)|0;i=Sm(g|0,h|0,i|0,D|0)|0;h=D;g=_l(o|0,C|0,21)|0;c=D;f=go(H|0,G|0,F|0,f|0)|0;B=Sm(f|0,D|0,A|0,B|0)|0;B=go(B|0,D|0,g|0,c|0)|0;A=D;c=Km(g|0,c|0,21)|0;c=Sm(o|0,C|0,c|0,D|0)|0;C=D;o=_l(B|0,A|0,21)|0;g=D;w=go(o|0,g|0,e|0,w|0)|0;e=D;g=Km(o|0,g|0,21)|0;g=Sm(B|0,A|0,g|0,D|0)|0;A=D;B=_l(w|0,e|0,21)|0;o=D;f=Km(B|0,o|0,21)|0;f=Sm(w|0,e|0,f|0,D|0)|0;e=D;w=Pl(B|0,o|0,666643,0)|0;x=go(w|0,D|0,y|0,x|0)|0;y=D;w=Pl(B|0,o|0,470296,0)|0;w=go(u|0,v|0,w|0,D|0)|0;v=D;u=Pl(B|0,o|0,654183,0)|0;u=go(s|0,t|0,u|0,D|0)|0;t=D;s=Pl(B|0,o|0,-997805,-1)|0;s=go(q|0,r|0,s|0,D|0)|0;r=D;q=Pl(B|0,o|0,136657,0)|0;q=go(E|0,p|0,q|0,D|0)|0;p=D;o=Pl(B|0,o|0,-683901,-1)|0;o=go(z|0,m|0,o|0,D|0)|0;m=D;z=_l(x|0,y|0,21)|0;B=D;v=go(w|0,v|0,z|0,B|0)|0;w=D;B=Km(z|0,B|0,21)|0;B=Sm(x|0,y|0,B|0,D|0)|0;y=D;x=_l(v|0,w|0,21)|0;z=D;t=go(u|0,t|0,x|0,z|0)|0;u=D;z=Km(x|0,z|0,21)|0;z=Sm(v|0,w|0,z|0,D|0)|0;w=D;v=_l(t|0,u|0,21)|0;x=D;r=go(s|0,r|0,v|0,x|0)|0;s=D;x=Km(v|0,x|0,21)|0;x=Sm(t|0,u|0,x|0,D|0)|0;u=D;t=_l(r|0,s|0,21)|0;v=D;p=go(q|0,p|0,t|0,v|0)|0;q=D;v=Km(t|0,v|0,21)|0;v=Sm(r|0,s|0,v|0,D|0)|0;s=D;r=_l(p|0,q|0,21)|0;t=D;m=go(o|0,m|0,r|0,t|0)|0;o=D;t=Km(r|0,t|0,21)|0;t=Sm(p|0,q|0,t|0,D|0)|0;q=D;p=_l(m|0,o|0,21)|0;r=D;l=go(p|0,r|0,n|0,l|0)|0;n=D;r=Km(p|0,r|0,21)|0;r=Sm(m|0,o|0,r|0,D|0)|0;o=D;m=_l(l|0,n|0,21)|0;p=D;j=go(m|0,p|0,k|0,j|0)|0;k=D;p=Km(m|0,p|0,21)|0;p=Sm(l|0,n|0,p|0,D|0)|0;n=D;l=_l(j|0,k|0,21)|0;m=D;h=go(l|0,m|0,i|0,h|0)|0;i=D;m=Km(l|0,m|0,21)|0;m=Sm(j|0,k|0,m|0,D|0)|0;k=D;j=_l(h|0,i|0,21)|0;l=D;C=go(j|0,l|0,c|0,C|0)|0;c=D;l=Km(j|0,l|0,21)|0;l=Sm(h|0,i|0,l|0,D|0)|0;i=D;h=_l(C|0,c|0,21)|0;j=D;A=go(h|0,j|0,g|0,A|0)|0;g=D;j=Km(h|0,j|0,21)|0;j=Sm(C|0,c|0,j|0,D|0)|0;c=D;C=_l(A|0,g|0,21)|0;h=D;e=go(C|0,h|0,f|0,e|0)|0;f=D;h=Km(C|0,h|0,21)|0;h=Sm(A|0,g|0,h|0,D|0)|0;g=D;a[b>>0]=B;A=Mm(B|0,y|0,8)|0;a[b+1>>0]=A;y=Mm(B|0,y|0,16)|0;B=D;A=Km(z|0,w|0,5)|0;a[b+2>>0]=A|y;y=Mm(z|0,w|0,3)|0;a[b+3>>0]=y;y=Mm(z|0,w|0,11)|0;a[b+4>>0]=y;w=Mm(z|0,w|0,19)|0;z=D;y=Km(x|0,u|0,2)|0;a[b+5>>0]=y|w;w=Mm(x|0,u|0,6)|0;a[b+6>>0]=w;u=Mm(x|0,u|0,14)|0;x=D;w=Km(v|0,s|0,7)|0;a[b+7>>0]=w|u;u=Mm(v|0,s|0,1)|0;a[b+8>>0]=u;u=Mm(v|0,s|0,9)|0;a[b+9>>0]=u;s=Mm(v|0,s|0,17)|0;v=D;u=Km(t|0,q|0,4)|0;a[b+10>>0]=u|s;s=Mm(t|0,q|0,4)|0;a[b+11>>0]=s;s=Mm(t|0,q|0,12)|0;a[b+12>>0]=s;q=Mm(t|0,q|0,20)|0;t=D;s=Km(r|0,o|0,1)|0;a[b+13>>0]=s|q;q=Mm(r|0,o|0,7)|0;a[b+14>>0]=q;o=Mm(r|0,o|0,15)|0;r=D;q=Km(p|0,n|0,6)|0;a[b+15>>0]=q|o;o=Mm(p|0,n|0,2)|0;a[b+16>>0]=o;o=Mm(p|0,n|0,10)|0;a[b+17>>0]=o;n=Mm(p|0,n|0,18)|0;p=D;o=Km(m|0,k|0,3)|0;a[b+18>>0]=o|n;n=Mm(m|0,k|0,5)|0;a[b+19>>0]=n;k=Mm(m|0,k|0,13)|0;a[b+20>>0]=k;a[b+21>>0]=l;k=Mm(l|0,i|0,8)|0;a[b+22>>0]=k;i=Mm(l|0,i|0,16)|0;l=D;k=Km(j|0,c|0,5)|0;a[b+23>>0]=k|i;i=Mm(j|0,c|0,3)|0;a[b+24>>0]=i;i=Mm(j|0,c|0,11)|0;a[b+25>>0]=i;c=Mm(j|0,c|0,19)|0;j=D;i=Km(h|0,g|0,2)|0;a[b+26>>0]=i|c;c=Mm(h|0,g|0,6)|0;a[b+27>>0]=c;g=Mm(h|0,g|0,14)|0;h=D;c=Km(e|0,f|0,7)|0;a[b+28>>0]=g|c;c=Mm(e|0,f|0,1)|0;a[b+29>>0]=c;c=Mm(e|0,f|0,9)|0;a[b+30>>0]=c;f=Mm(e|0,f|0,17)|0;a[b+31>>0]=f;return}function $b(b,e,f,g,h,j,k,l,m,n,p){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=i;D=i=i+63&-64;i=i+512|0;c[D+96>>2]=p;c[D+88>>2]=D+104;c[D+88+4>>2]=140;c[D+80>>2]=D+104;c[D+76>>2]=D+104+400;c[D+56>>2]=0;c[D+56+4>>2]=0;c[D+56+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[D+56+(p<<2)>>2]=0;p=p+1|0}c[D+44>>2]=0;c[D+44+4>>2]=0;c[D+44+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[D+44+(p<<2)>>2]=0;p=p+1|0}c[D+32>>2]=0;c[D+32+4>>2]=0;c[D+32+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[D+32+(p<<2)>>2]=0;p=p+1|0}c[D+20>>2]=0;c[D+20+4>>2]=0;c[D+20+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[D+20+(p<<2)>>2]=0;p=p+1|0}c[D+8>>2]=0;c[D+8+4>>2]=0;c[D+8+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[D+8+(p<<2)>>2]=0;p=p+1|0}o=0;ta(19,f|0,g|0,D+504|0,D+72|0,D+68|0,D+56|0,D+44|0,D+32|0,D+20|0,D+4|0);B=o;o=0;a:do if(B&1)p=Ya()|0;else{c[n>>2]=c[m>>2];x=D+32+8+3|0;y=D+20+8+3|0;z=D+44+8+3|0;v=D+104|0;w=0;B=0;b:while(1){if(w>>>0>=4){A=257;break}p=c[b>>2]|0;do if(p){f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+36>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=39;break b}}else p=c[f>>2]|0;if((p|0)==-1){c[b>>2]=0;f=1;break}else{f=(c[b>>2]|0)==0;break}}else f=1;while(0);if(e){p=c[e+12>>2]|0;if((p|0)==(c[e+16>>2]|0)){o=0;p=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;u=o;o=0;if(u&1){A=39;break}}else p=c[p>>2]|0;if((p|0)!=-1){if(!f){A=257;break}}else A=31}else A=31;if((A|0)==31){A=0;if(f){e=0;A=257;break}else e=0}c:do switch(a[D+504+w>>0]|0){case 1:{if((w|0)!=3){p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+36>>2]|0,p|0)|0;A=o;o=0;if(A&1){A=39;break b}}else p=c[f>>2]|0;o=0;p=la(c[(c[l>>2]|0)+12>>2]|0,l|0,8192,p|0)|0;A=o;o=0;if(A&1){A=39;break b}if(!p){A=57;break b}p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+40>>2]|0,p|0)|0;A=o;o=0;if(A&1){A=39;break b}}else{c[p+12>>2]=f+4;p=c[f>>2]|0}o=0;da(62,D+8|0,p|0);A=o;o=0;if(A&1){A=39;break b}else{q=e;g=e;A=59}}else{p=v;f=B}break}case 0:{if((w|0)==3){p=v;f=B}else{q=e;g=e;A=59}break}case 3:{f=a[x>>0]|0;p=f<<24>>24<0?c[D+32+4>>2]|0:f&255;g=a[y>>0]|0;q=g<<24>>24<0?c[D+20+4>>2]|0:g&255;if((p|0)==(0-q|0)){p=v;f=B}else{if(!p){p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+36>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=39;break b}g=a[y>>0]|0}else p=c[f>>2]|0;if((p|0)!=(c[(g<<24>>24<0?c[D+20>>2]|0:D+20|0)>>2]|0)){p=v;f=B;break c}p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;ha(c[(c[p>>2]|0)+40>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=39;break b}f=a[y>>0]|0}else{c[p+12>>2]=f+4;f=g}a[k>>0]=1;p=v;f=(f<<24>>24<0?c[D+20+4>>2]|0:f&255)>>>0>1?D+20|0:B;break c}r=c[b>>2]|0;s=c[r+12>>2]|0;g=c[r+16>>2]|0;if(!q){if((s|0)==(g|0)){o=0;p=ha(c[(c[r>>2]|0)+36>>2]|0,r|0)|0;u=o;o=0;if(u&1){A=39;break b}g=a[x>>0]|0}else{p=c[s>>2]|0;g=f}if((p|0)!=(c[(g<<24>>24<0?c[D+32>>2]|0:D+32|0)>>2]|0)){a[k>>0]=1;p=v;f=B;break c}p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;ha(c[(c[p>>2]|0)+40>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=39;break b}f=a[x>>0]|0}else{c[p+12>>2]=f+4;f=g}p=v;f=(f<<24>>24<0?c[D+32+4>>2]|0:f&255)>>>0>1?D+32|0:B;break c}if((s|0)==(g|0)){o=0;p=ha(c[(c[r>>2]|0)+36>>2]|0,r|0)|0;u=o;o=0;if(u&1){A=39;break b}g=c[b>>2]|0;f=a[x>>0]|0;r=g;s=c[g+12>>2]|0;g=c[g+16>>2]|0}else p=c[s>>2]|0;q=r+12|0;g=(s|0)==(g|0);if((p|0)==(c[(f<<24>>24<0?c[D+32>>2]|0:D+32|0)>>2]|0)){if(g){o=0;ha(c[(c[r>>2]|0)+40>>2]|0,r|0)|0;u=o;o=0;if(u&1){A=39;break b}f=a[x>>0]|0}else c[q>>2]=s+4;p=v;f=(f<<24>>24<0?c[D+32+4>>2]|0:f&255)>>>0>1?D+32|0:B;break c}if(g){o=0;p=ha(c[(c[r>>2]|0)+36>>2]|0,r|0)|0;u=o;o=0;if(u&1){A=39;break b}}else p=c[s>>2]|0;g=a[y>>0]|0;if((p|0)!=(c[(g<<24>>24<0?c[D+20>>2]|0:D+20|0)>>2]|0)){A=125;break b}p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;ha(c[(c[p>>2]|0)+40>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=39;break b}f=a[y>>0]|0}else{c[p+12>>2]=f+4;f=g}a[k>>0]=1;p=v;f=(f<<24>>24<0?c[D+20+4>>2]|0:f&255)>>>0>1?D+20|0:B}break}case 2:{if(!(w>>>0<2|(B|0)!=0)?!((h&512|0)!=0|(w|0)==2&(a[D+504+3>>0]|0)!=0):0){p=v;f=0;break c}p=a[z>>0]|0;f=c[D+44>>2]|0;q=p<<24>>24<0?f:D+44|0;d:do if((w|0)!=0?(d[D+504+(w+-1)>>0]|0)<2:0){g=f;u=q;while(1){t=p<<24>>24<0;f=u;if((f|0)==((t?g:D+44|0)+((t?c[D+44+4>>2]|0:p&255)<<2)|0)){f=g;break}o=0;p=la(c[(c[l>>2]|0)+12>>2]|0,l|0,8192,c[f>>2]|0)|0;t=o;o=0;if(t&1){A=36;break b}if(!p){A=133;break}p=a[z>>0]|0;g=c[D+44>>2]|0;u=f+4|0}if((A|0)==133){A=0;p=a[z>>0]|0;f=c[D+44>>2]|0}g=p<<24>>24<0?f:D+44|0;t=u-g>>2;q=a[D+8+8+3>>0]|0;r=q<<24>>24<0?c[D+8+4>>2]|0:q&255;if(t>>>0>r>>>0){s=e;r=e}else{s=(q<<24>>24<0?c[D+8>>2]|0:D+8|0)+(r<<2)|0;r=g;q=s+(0-t<<2)|0;while(1){if((q|0)==(s|0)){s=e;r=e;g=u;break d}if((c[q>>2]|0)!=(c[r>>2]|0)){s=e;r=e;break d}r=r+4|0;q=q+4|0}}}else{s=e;r=e;g=q}while(0);while(1){u=p<<24>>24<0;p=(u?f:D+44|0)+((u?c[D+44+4>>2]|0:p&255)<<2)|0;if((g|0)==(p|0))break;p=c[b>>2]|0;do if(p){f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+36>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=35;break b}}else p=c[f>>2]|0;if((p|0)==-1){c[b>>2]=0;f=1;break}else{f=(c[b>>2]|0)==0;break}}else f=1;while(0);if(r){p=c[r+12>>2]|0;if((p|0)==(c[r+16>>2]|0)){o=0;p=ha(c[(c[r>>2]|0)+36>>2]|0,r|0)|0;u=o;o=0;if(u&1){A=35;break b}}else p=c[p>>2]|0;if((p|0)!=-1)if(f^(s|0)==0){q=s;r=s}else{p=g;break}else{p=0;e=0;A=153}}else{p=s;A=153}if((A|0)==153){A=0;if(f){p=g;break}else{q=p;r=0}}p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+36>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=35;break b}}else p=c[f>>2]|0;if((p|0)!=(c[g>>2]|0)){p=g;break}p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;ha(c[(c[p>>2]|0)+40>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=35;break b}}else c[p+12>>2]=f+4;s=q;p=a[z>>0]|0;f=c[D+44>>2]|0;g=g+4|0}if(h&512|0?(u=a[z>>0]|0,(p|0)!=((u<<24>>24<0?c[D+44>>2]|0:D+44|0)+((u<<24>>24<0?c[D+44+4>>2]|0:u&255)<<2)|0)):0){A=165;break b}else{p=v;f=B}break}case 4:{u=c[D+68>>2]|0;s=e;q=e;p=v;r=0;while(1){f=c[b>>2]|0;do if(f){g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0)){o=0;f=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;v=o;o=0;if(v&1){A=38;break b}}else f=c[g>>2]|0;if((f|0)==-1){c[b>>2]=0;g=1;break}else{g=(c[b>>2]|0)==0;break}}else g=1;while(0);if(q){f=c[q+12>>2]|0;if((f|0)==(c[q+16>>2]|0)){o=0;f=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=38;break b}}else f=c[f>>2]|0;if((f|0)!=-1)if(g^(s|0)==0){f=s;t=s}else break;else{f=0;e=0;A=178}}else{f=s;A=178}if((A|0)==178){A=0;if(g){s=f;break}else t=0}g=c[b>>2]|0;q=c[g+12>>2]|0;if((q|0)==(c[g+16>>2]|0)){o=0;g=ha(c[(c[g>>2]|0)+36>>2]|0,g|0)|0;v=o;o=0;if(v&1){A=38;break b}}else g=c[q>>2]|0;o=0;q=la(c[(c[l>>2]|0)+12>>2]|0,l|0,2048,g|0)|0;v=o;o=0;if(v&1){A=38;break b}if(q){q=c[n>>2]|0;if((q|0)==(c[D+96>>2]|0)){o=0;Da(24,m|0,n|0,D+96|0);v=o;o=0;if(v&1){A=38;break b}q=c[n>>2]|0}c[n>>2]=q+4;c[q>>2]=g;r=r+1|0}else{v=a[D+56+11>>0]|0;if(!((g|0)==(u|0)&(r|0?((v<<24>>24<0?c[D+56+4>>2]|0:v&255)|0)!=0:0))){s=f;break}if((p|0)==(c[D+76>>2]|0)){o=0;Da(22,D+88|0,D+80|0,D+76|0);v=o;o=0;if(v&1){A=38;break b}p=c[D+80>>2]|0}v=p+4|0;c[D+80>>2]=v;c[p>>2]=r;p=v;r=0}g=c[b>>2]|0;q=c[g+12>>2]|0;if((q|0)==(c[g+16>>2]|0)){o=0;ha(c[(c[g>>2]|0)+40>>2]|0,g|0)|0;v=o;o=0;if(v&1){A=38;break b}else{s=f;q=t;continue}}else{c[g+12>>2]=q+4;s=f;q=t;continue}}if(r|0?(c[D+88>>2]|0)!=(p|0):0){if((p|0)==(c[D+76>>2]|0)){o=0;Da(22,D+88|0,D+80|0,D+76|0);v=o;o=0;if(v&1){A=39;break b}p=c[D+80>>2]|0}v=p+4|0;c[D+80>>2]=v;c[p>>2]=r;p=v}q=c[D+4>>2]|0;e:do if((q|0)>0){f=c[b>>2]|0;do if(f){g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0)){o=0;f=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;v=o;o=0;if(v&1){A=39;break b}}else f=c[g>>2]|0;if((f|0)==-1){c[b>>2]=0;g=1;break}else{g=(c[b>>2]|0)==0;break}}else g=1;while(0);if(s){f=c[s+12>>2]|0;if((f|0)==(c[s+16>>2]|0)){o=0;f=ha(c[(c[s>>2]|0)+36>>2]|0,s|0)|0;v=o;o=0;if(v&1){A=39;break b}}else f=c[f>>2]|0;if((f|0)!=-1)if(g)r=s;else{A=221;break b}else{e=0;A=215}}else A=215;if((A|0)==215){A=0;if(g){A=221;break b}else r=0}f=c[b>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0)){o=0;f=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;v=o;o=0;if(v&1){A=39;break b}}else f=c[g>>2]|0;if((f|0)!=(c[D+72>>2]|0)){A=221;break b}f=c[b>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0)){o=0;ha(c[(c[f>>2]|0)+40>>2]|0,f|0)|0;v=o;o=0;if(v&1){A=39;break b}else s=r}else{c[f+12>>2]=g+4;s=r}while(1){if((q|0)<=0)break e;f=c[b>>2]|0;do if(f){g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0)){o=0;f=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;v=o;o=0;if(v&1){A=37;break b}}else f=c[g>>2]|0;if((f|0)==-1){c[b>>2]=0;g=1;break}else{g=(c[b>>2]|0)==0;break}}else g=1;while(0);do if(r){f=c[r+12>>2]|0;if((f|0)==(c[r+16>>2]|0)){o=0;f=ha(c[(c[r>>2]|0)+36>>2]|0,r|0)|0;v=o;o=0;if(v&1){A=37;break b}}else f=c[f>>2]|0;if((f|0)==-1){f=0;e=0;A=238;break}if(g^(s|0)==0){t=s;r=s}else{A=245;break b}}else{f=s;A=238}while(0);if((A|0)==238){A=0;if(g){A=245;break b}else{t=f;r=0}}f=c[b>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0)){o=0;f=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;v=o;o=0;if(v&1){A=37;break b}}else f=c[g>>2]|0;o=0;f=la(c[(c[l>>2]|0)+12>>2]|0,l|0,2048,f|0)|0;v=o;o=0;if(v&1){A=37;break b}if(!f){A=245;break b}if((c[n>>2]|0)==(c[D+96>>2]|0)?(o=0,Da(24,m|0,n|0,D+96|0),v=o,o=0,v&1):0){A=37;break b}f=c[b>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0)){o=0;f=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;v=o;o=0;if(v&1){A=37;break b}}else f=c[g>>2]|0;g=c[n>>2]|0;c[n>>2]=g+4;c[g>>2]=f;q=q+-1|0;c[D+4>>2]=q;f=c[b>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0)){o=0;ha(c[(c[f>>2]|0)+40>>2]|0,f|0)|0;v=o;o=0;if(v&1){A=37;break b}else{s=t;continue}}else{c[f+12>>2]=g+4;s=t;continue}}}while(0);if((c[n>>2]|0)==(c[m>>2]|0)){A=255;break b}else f=B;break}default:{p=v;f=B}}while(0);f:do if((A|0)==59)while(1){A=0;p=c[b>>2]|0;do if(p){f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+36>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=34;break b}}else p=c[f>>2]|0;if((p|0)==-1){c[b>>2]=0;f=1;break}else{f=(c[b>>2]|0)==0;break}}else f=1;while(0);if(g){p=c[g+12>>2]|0;if((p|0)==(c[g+16>>2]|0)){o=0;p=ha(c[(c[g>>2]|0)+36>>2]|0,g|0)|0;u=o;o=0;if(u&1){A=34;break b}}else p=c[p>>2]|0;if((p|0)!=-1)if(f^(q|0)==0){r=q;g=q}else{p=v;f=B;break f}else{p=0;e=0;A=71}}else{p=q;A=71}if((A|0)==71){A=0;if(f){p=v;f=B;break f}else{r=p;g=0}}p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+36>>2]|0,p|0)|0;u=o;o=0;if(u&1){A=34;break b}}else p=c[f>>2]|0;o=0;p=la(c[(c[l>>2]|0)+12>>2]|0,l|0,8192,p|0)|0;u=o;o=0;if(u&1){A=34;break b}if(!p){p=v;f=B;break f}p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+40>>2]|0,p|0)|0;A=o;o=0;if(A&1){A=34;break b}}else{c[p+12>>2]=f+4;p=c[f>>2]|0}o=0;da(62,D+8|0,p|0);A=o;o=0;if(A&1){A=34;break b}else{q=r;A=59}}while(0);v=p;w=w+1|0;B=f}g:switch(A|0){case 34:{p=Ya()|0;break a}case 35:{p=Ya()|0;break a}case 36:{p=Ya()|0;break a}case 37:{p=Ya()|0;break a}case 38:{p=Ya()|0;break a}case 39:{p=Ya()|0;break a}case 57:{c[j>>2]=c[j>>2]|4;p=0;break}case 125:{c[j>>2]=c[j>>2]|4;p=0;break}case 165:{c[j>>2]=c[j>>2]|4;p=0;break}case 221:{c[j>>2]=c[j>>2]|4;p=0;break}case 245:{c[j>>2]=c[j>>2]|4;p=0;break}case 255:{c[j>>2]=c[j>>2]|4;p=0;break}case 257:{h:do if(B|0){q=B+8+3|0;r=B+4|0;g=1;i:while(1){p=a[q>>0]|0;if(p<<24>>24<0)p=c[r>>2]|0;else p=p&255;if(g>>>0>=p>>>0)break h;p=c[b>>2]|0;do if(p){f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+36>>2]|0,p|0)|0;n=o;o=0;if(n&1){A=33;break i}}else p=c[f>>2]|0;if((p|0)==-1){c[b>>2]=0;f=1;break}else{f=(c[b>>2]|0)==0;break}}else f=1;while(0);if(e){p=c[e+12>>2]|0;if((p|0)==(c[e+16>>2]|0)){o=0;p=ha(c[(c[e>>2]|0)+36>>2]|0,e|0)|0;n=o;o=0;if(n&1){A=33;break}}else p=c[p>>2]|0;if((p|0)!=-1){if(!f){A=283;break}}else A=275}else A=275;if((A|0)==275){A=0;if(f){A=283;break}else e=0}p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;p=ha(c[(c[p>>2]|0)+36>>2]|0,p|0)|0;n=o;o=0;if(n&1){A=33;break}}else p=c[f>>2]|0;if((a[q>>0]|0)<0)f=c[B>>2]|0;else f=B;if((p|0)!=(c[f+(g<<2)>>2]|0)){A=283;break}g=g+1|0;p=c[b>>2]|0;f=c[p+12>>2]|0;if((f|0)==(c[p+16>>2]|0)){o=0;ha(c[(c[p>>2]|0)+40>>2]|0,p|0)|0;n=o;o=0;if(n&1){A=33;break}else continue}else{c[p+12>>2]=f+4;continue}}if((A|0)==33){p=Ya()|0;break a}else if((A|0)==283){c[j>>2]=c[j>>2]|4;p=0;break g}}while(0);e=c[D+88>>2]|0;if((e|0)!=(v|0)){c[D>>2]=0;kf(D+56|0,e,v,D);if(!(c[D>>2]|0)){p=1;break}else{c[j>>2]=c[j>>2]|4;p=0;break}}else p=1;break}}Ao(D+8|0);Ao(D+20|0);Ao(D+32|0);Ao(D+44|0);Oo(D+56|0);e=c[D+88>>2]|0;c[D+88>>2]=0;if(e|0?(o=0,ba(c[D+88+4>>2]|0,e|0),D=o,o=0,D&1):0){D=Za(0)|0;xr(D)}i=C;return p|0}while(0);Ao(D+8|0);Ao(D+20|0);Ao(D+32|0);Ao(D+44|0);Oo(D+56|0);e=c[D+88>>2]|0;c[D+88>>2]=0;if(e|0?(o=0,ba(c[D+88+4>>2]|0,e|0),D=o,o=0,D&1):0){D=Za(0)|0;xr(D)}Ra(p|0);return 0}function ac(e,f,g,h,j,k,l,m,n,p,q){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=i;D=i=i+63&-64;i=i+512|0;c[D+88>>2]=q;c[D+80>>2]=D+96;c[D+80+4>>2]=140;c[D+72>>2]=D+96;c[D+68>>2]=D+96+400;c[D+56>>2]=0;c[D+56+4>>2]=0;c[D+56+8>>2]=0;q=0;while(1){if((q|0)==3)break;c[D+56+(q<<2)>>2]=0;q=q+1|0}c[D+44>>2]=0;c[D+44+4>>2]=0;c[D+44+8>>2]=0;q=0;while(1){if((q|0)==3)break;c[D+44+(q<<2)>>2]=0;q=q+1|0}c[D+32>>2]=0;c[D+32+4>>2]=0;c[D+32+8>>2]=0;q=0;while(1){if((q|0)==3)break;c[D+32+(q<<2)>>2]=0;q=q+1|0}c[D+20>>2]=0;c[D+20+4>>2]=0;c[D+20+8>>2]=0;q=0;while(1){if((q|0)==3)break;c[D+20+(q<<2)>>2]=0;q=q+1|0}c[D+8>>2]=0;c[D+8+4>>2]=0;c[D+8+8>>2]=0;q=0;while(1){if((q|0)==3)break;c[D+8+(q<<2)>>2]=0;q=q+1|0}o=0;ta(18,g|0,h|0,D+500|0,D+497|0,D+496|0,D+56|0,D+44|0,D+32|0,D+20|0,D+4|0);B=o;o=0;a:do if(B&1)q=Ya()|0;else{c[p>>2]=c[n>>2];y=D+32+11|0;z=D+20+11|0;w=D+96|0;x=0;B=0;b:while(1){if(x>>>0>=4){A=249;break}q=c[e>>2]|0;do if(q){if((c[q+12>>2]|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=37;break b}if((q|0)==-1){c[e>>2]=0;q=0;break}else{q=c[e>>2]|0;break}}}else q=0;while(0);q=(q|0)==0;do if(f){if((c[f+12>>2]|0)!=(c[f+16>>2]|0))if(q)break;else{A=249;break b}o=0;g=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;v=o;o=0;if(v&1){A=37;break b}if((g|0)!=-1){if(!q){A=249;break b}}else A=30}else A=30;while(0);if((A|0)==30){A=0;if(q){f=0;A=249;break}else f=0}c:do switch(a[D+500+x>>0]|0){case 1:{if((x|0)!=3){q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;A=o;o=0;if(A&1){A=37;break b}}else q=d[g>>0]|0;if((q&255)<<24>>24<=-1){A=55;break b}if(!(b[(c[m+8>>2]|0)+(q<<24>>24<<1)>>1]&8192)){A=55;break b}q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+40>>2]|0,q|0)|0;A=o;o=0;if(A&1){A=37;break b}}else{c[q+12>>2]=g+1;q=d[g>>0]|0}o=0;da(61,D+8|0,q&255|0);A=o;o=0;if(A&1){A=37;break b}else{q=f;r=f;A=57}}else{q=w;g=B}break}case 0:{if((x|0)==3){q=w;g=B}else{q=f;r=f;A=57}break}case 3:{g=a[y>>0]|0;q=g<<24>>24<0?c[D+32+4>>2]|0:g&255;h=a[z>>0]|0;r=h<<24>>24<0?c[D+20+4>>2]|0:h&255;if((q|0)==(0-r|0)){q=w;g=B}else{if(!q){q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=37;break b}h=a[z>>0]|0}else q=d[g>>0]|0;if((q&255)<<24>>24!=(a[(h<<24>>24<0?c[D+20>>2]|0:D+20|0)>>0]|0)){q=w;g=B;break c}q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;ha(c[(c[q>>2]|0)+40>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=37;break b}g=a[z>>0]|0}else{c[q+12>>2]=g+1;g=h}a[l>>0]=1;q=w;g=(g<<24>>24<0?c[D+20+4>>2]|0:g&255)>>>0>1?D+20|0:B;break c}s=c[e>>2]|0;t=c[s+12>>2]|0;h=c[s+16>>2]|0;if(!r){if((t|0)==(h|0)){o=0;q=ha(c[(c[s>>2]|0)+36>>2]|0,s|0)|0;v=o;o=0;if(v&1){A=37;break b}h=a[y>>0]|0}else{q=d[t>>0]|0;h=g}if((q&255)<<24>>24!=(a[(h<<24>>24<0?c[D+32>>2]|0:D+32|0)>>0]|0)){a[l>>0]=1;q=w;g=B;break c}q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;ha(c[(c[q>>2]|0)+40>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=37;break b}g=a[y>>0]|0}else{c[q+12>>2]=g+1;g=h}q=w;g=(g<<24>>24<0?c[D+32+4>>2]|0:g&255)>>>0>1?D+32|0:B;break c}if((t|0)==(h|0)){o=0;q=ha(c[(c[s>>2]|0)+36>>2]|0,s|0)|0;v=o;o=0;if(v&1){A=37;break b}h=c[e>>2]|0;g=a[y>>0]|0;s=h;t=c[h+12>>2]|0;h=c[h+16>>2]|0}else q=d[t>>0]|0;r=s+12|0;h=(t|0)==(h|0);if((q&255)<<24>>24==(a[(g<<24>>24<0?c[D+32>>2]|0:D+32|0)>>0]|0)){if(h){o=0;ha(c[(c[s>>2]|0)+40>>2]|0,s|0)|0;v=o;o=0;if(v&1){A=37;break b}g=a[y>>0]|0}else c[r>>2]=t+1;q=w;g=(g<<24>>24<0?c[D+32+4>>2]|0:g&255)>>>0>1?D+32|0:B;break c}if(h){o=0;q=ha(c[(c[s>>2]|0)+36>>2]|0,s|0)|0;v=o;o=0;if(v&1){A=37;break b}}else q=d[t>>0]|0;h=a[z>>0]|0;if((q&255)<<24>>24!=(a[(h<<24>>24<0?c[D+20>>2]|0:D+20|0)>>0]|0)){A=122;break b}q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;ha(c[(c[q>>2]|0)+40>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=37;break b}g=a[z>>0]|0}else{c[q+12>>2]=g+1;g=h}a[l>>0]=1;q=w;g=(g<<24>>24<0?c[D+20+4>>2]|0:g&255)>>>0>1?D+20|0:B}break}case 2:{if(!(x>>>0<2|(B|0)!=0)?!((j&512|0)!=0|(x|0)==2&(a[D+500+3>>0]|0)!=0):0){q=w;g=0;break c}t=a[D+44+11>>0]|0;u=c[D+44>>2]|0;g=t<<24>>24<0?u:D+44|0;d:do if((x|0)!=0?(d[D+500+(x+-1)>>0]|0)<2:0){q=g+(t<<24>>24<0?c[D+44+4>>2]|0:t&255)|0;v=g;while(1){h=v;if((h|0)==(q|0))break;r=a[h>>0]|0;if(r<<24>>24<=-1)break;if(!(b[(c[m+8>>2]|0)+(r<<24>>24<<1)>>1]&8192))break;v=h+1|0}s=v-g|0;q=a[D+8+11>>0]|0;h=q<<24>>24<0?c[D+8+4>>2]|0:q&255;if(s>>>0<=h>>>0){r=(q<<24>>24<0?c[D+8>>2]|0:D+8|0)+h|0;h=g;q=r+(0-s)|0;while(1){if((q|0)==(r|0)){s=f;h=t;q=u;r=f;g=v;break d}if((a[q>>0]|0)!=(a[h>>0]|0)){s=f;h=t;q=u;r=f;break d}h=h+1|0;q=q+1|0}}else{s=f;h=t;q=u;r=f}}else{s=f;h=t;q=u;r=f}while(0);e:while(1){t=h<<24>>24<0;q=(t?q:D+44|0)+(t?c[D+44+4>>2]|0:h&255)|0;t=g;if((t|0)==(q|0))break;q=c[e>>2]|0;do if(q){if((c[q+12>>2]|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=34;break b}if((q|0)==-1){c[e>>2]=0;q=0;break}else{q=c[e>>2]|0;break}}}else q=0;while(0);g=(q|0)==0;do if(r){if((c[r+12>>2]|0)!=(c[r+16>>2]|0))if(g){h=s;break}else{q=t;break e}o=0;q=ha(c[(c[r>>2]|0)+36>>2]|0,r|0)|0;v=o;o=0;if(v&1){A=34;break b}if((q|0)!=-1)if(g^(s|0)==0){h=s;r=s}else{q=t;break e}else{q=0;f=0;A=149}}else{q=s;A=149}while(0);if((A|0)==149){A=0;if(g){q=t;break}else{h=q;r=0}}q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=34;break b}}else q=d[g>>0]|0;if((q&255)<<24>>24!=(a[t>>0]|0)){q=t;break}q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;ha(c[(c[q>>2]|0)+40>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=34;break b}}else c[q+12>>2]=g+1;s=h;h=a[D+44+11>>0]|0;q=c[D+44>>2]|0;g=t+1|0}if(j&512|0?(v=a[D+44+11>>0]|0,(q|0)!=((v<<24>>24<0?c[D+44>>2]|0:D+44|0)+(v<<24>>24<0?c[D+44+4>>2]|0:v&255)|0)):0){A=161;break b}else{q=w;g=B}break}case 4:{v=a[D+496>>0]|0;g=f;t=f;q=w;u=0;f:while(1){h=c[e>>2]|0;do if(h){if((c[h+12>>2]|0)==(c[h+16>>2]|0)){o=0;h=ha(c[(c[h>>2]|0)+36>>2]|0,h|0)|0;w=o;o=0;if(w&1){A=36;break b}if((h|0)==-1){c[e>>2]=0;h=0;break}else{h=c[e>>2]|0;break}}}else h=0;while(0);r=(h|0)==0;do if(t){if((c[t+12>>2]|0)!=(c[t+16>>2]|0))if(r){s=g;break}else{s=g;break f}o=0;h=ha(c[(c[t>>2]|0)+36>>2]|0,t|0)|0;w=o;o=0;if(w&1){A=36;break b}if((h|0)!=-1)if(r^(g|0)==0){s=g;t=g}else{s=g;break f}else{g=0;f=0;A=173}}else A=173;while(0);if((A|0)==173){A=0;if(r){s=g;break}else{s=g;t=0}}g=c[e>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0)){o=0;g=ha(c[(c[g>>2]|0)+36>>2]|0,g|0)|0;w=o;o=0;if(w&1){A=36;break b}}else g=d[h>>0]|0;h=g&255;if(h<<24>>24>-1?(b[(c[m+8>>2]|0)+(g<<24>>24<<1)>>1]&2048)!=0:0){g=c[p>>2]|0;if((g|0)==(c[D+88>>2]|0)){o=0;Da(21,n|0,p|0,D+88|0);w=o;o=0;if(w&1){A=36;break b}g=c[p>>2]|0}c[p>>2]=g+1;a[g>>0]=h;r=u+1|0}else{w=a[D+56+11>>0]|0;if(!(h<<24>>24==v<<24>>24&(u|0?((w<<24>>24<0?c[D+56+4>>2]|0:w&255)|0)!=0:0)))break;if((q|0)==(c[D+68>>2]|0)){o=0;Da(22,D+80|0,D+72|0,D+68|0);w=o;o=0;if(w&1){A=36;break b}q=c[D+72>>2]|0}r=q+4|0;c[D+72>>2]=r;c[q>>2]=u;q=r;r=0}g=c[e>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0)){o=0;ha(c[(c[g>>2]|0)+40>>2]|0,g|0)|0;w=o;o=0;if(w&1){A=36;break b}else{g=s;u=r;continue}}else{c[g+12>>2]=h+1;g=s;u=r;continue}}if(u|0?(c[D+80>>2]|0)!=(q|0):0){if((q|0)==(c[D+68>>2]|0)){o=0;Da(22,D+80|0,D+72|0,D+68|0);w=o;o=0;if(w&1){A=37;break b}q=c[D+72>>2]|0}w=q+4|0;c[D+72>>2]=w;c[q>>2]=u;q=w}r=c[D+4>>2]|0;g:do if((r|0)>0){g=c[e>>2]|0;do if(g){if((c[g+12>>2]|0)==(c[g+16>>2]|0)){o=0;g=ha(c[(c[g>>2]|0)+36>>2]|0,g|0)|0;w=o;o=0;if(w&1){A=37;break b}if((g|0)==-1){c[e>>2]=0;g=0;break}else{g=c[e>>2]|0;break}}}else g=0;while(0);h=(g|0)==0;do if(s){if((c[s+12>>2]|0)==(c[s+16>>2]|0)){o=0;g=ha(c[(c[s>>2]|0)+36>>2]|0,s|0)|0;w=o;o=0;if(w&1){A=37;break b}if((g|0)==-1){f=0;A=209;break}}if(!h){A=214;break b}}else A=209;while(0);if((A|0)==209){A=0;if(h){A=214;break b}else s=0}g=c[e>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0)){o=0;g=ha(c[(c[g>>2]|0)+36>>2]|0,g|0)|0;w=o;o=0;if(w&1){A=37;break b}}else g=d[h>>0]|0;if((g&255)<<24>>24!=(a[D+497>>0]|0)){A=214;break b}g=c[e>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0)){o=0;ha(c[(c[g>>2]|0)+40>>2]|0,g|0)|0;w=o;o=0;if(w&1){A=37;break b}else{g=s;t=s}}else{c[g+12>>2]=h+1;g=s;t=s}while(1){if((r|0)<=0)break g;h=c[e>>2]|0;do if(h){if((c[h+12>>2]|0)==(c[h+16>>2]|0)){o=0;h=ha(c[(c[h>>2]|0)+36>>2]|0,h|0)|0;w=o;o=0;if(w&1){A=35;break b}if((h|0)==-1){c[e>>2]=0;h=0;break}else{h=c[e>>2]|0;break}}}else h=0;while(0);s=(h|0)==0;do if(t){if((c[t+12>>2]|0)!=(c[t+16>>2]|0))if(s){s=g;break}else{A=237;break b}o=0;h=ha(c[(c[t>>2]|0)+36>>2]|0,t|0)|0;w=o;o=0;if(w&1){A=35;break b}if((h|0)==-1){g=0;f=0;A=230;break}if(s^(g|0)==0){s=g;t=g}else{A=237;break b}}else A=230;while(0);if((A|0)==230){A=0;if(s){A=237;break b}else{s=g;t=0}}g=c[e>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0)){o=0;g=ha(c[(c[g>>2]|0)+36>>2]|0,g|0)|0;w=o;o=0;if(w&1){A=35;break b}}else g=d[h>>0]|0;if((g&255)<<24>>24<=-1){A=237;break b}if(!(b[(c[m+8>>2]|0)+(g<<24>>24<<1)>>1]&2048)){A=237;break b}if((c[p>>2]|0)==(c[D+88>>2]|0)?(o=0,Da(21,n|0,p|0,D+88|0),w=o,o=0,w&1):0){A=35;break b}g=c[e>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0)){o=0;g=ha(c[(c[g>>2]|0)+36>>2]|0,g|0)|0;w=o;o=0;if(w&1){A=35;break b}}else g=d[h>>0]|0;h=c[p>>2]|0;c[p>>2]=h+1;a[h>>0]=g;r=r+-1|0;c[D+4>>2]=r;g=c[e>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0)){o=0;ha(c[(c[g>>2]|0)+40>>2]|0,g|0)|0;w=o;o=0;if(w&1){A=35;break b}else{g=s;continue}}else{c[g+12>>2]=h+1;g=s;continue}}}while(0);if((c[p>>2]|0)==(c[n>>2]|0)){A=247;break b}else g=B;break}default:{q=w;g=B}}while(0);h:do if((A|0)==57)while(1){A=0;g=c[e>>2]|0;do if(g){if((c[g+12>>2]|0)==(c[g+16>>2]|0)){o=0;g=ha(c[(c[g>>2]|0)+36>>2]|0,g|0)|0;v=o;o=0;if(v&1){A=33;break b}if((g|0)==-1){c[e>>2]=0;g=0;break}else{g=c[e>>2]|0;break}}}else g=0;while(0);h=(g|0)==0;do if(r){if((c[r+12>>2]|0)!=(c[r+16>>2]|0))if(h){h=q;break}else{q=w;g=B;break h}o=0;g=ha(c[(c[r>>2]|0)+36>>2]|0,r|0)|0;v=o;o=0;if(v&1){A=33;break b}if((g|0)!=-1)if(h^(q|0)==0){h=q;r=q}else{q=w;g=B;break h}else{q=0;f=0;A=68}}else A=68;while(0);if((A|0)==68){A=0;if(h){q=w;g=B;break h}else{h=q;r=0}}q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;v=o;o=0;if(v&1){A=33;break b}}else q=d[g>>0]|0;if((q&255)<<24>>24<=-1){q=w;g=B;break h}if(!(b[(c[m+8>>2]|0)+(q<<24>>24<<1)>>1]&8192)){q=w;g=B;break h}q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+40>>2]|0,q|0)|0;A=o;o=0;if(A&1){A=33;break b}}else{c[q+12>>2]=g+1;q=d[g>>0]|0}o=0;da(61,D+8|0,q&255|0);A=o;o=0;if(A&1){A=33;break b}else{q=h;A=57}}while(0);w=q;x=x+1|0;B=g}i:switch(A|0){case 33:{q=Ya()|0;break a}case 34:{q=Ya()|0;break a}case 35:{q=Ya()|0;break a}case 36:{q=Ya()|0;break a}case 37:{q=Ya()|0;break a}case 55:{c[k>>2]=c[k>>2]|4;q=0;break}case 122:{c[k>>2]=c[k>>2]|4;q=0;break}case 161:{c[k>>2]=c[k>>2]|4;q=0;break}case 214:{c[k>>2]=c[k>>2]|4;q=0;break}case 237:{c[k>>2]=c[k>>2]|4;q=0;break}case 247:{c[k>>2]=c[k>>2]|4;q=0;break}case 249:{j:do if(B|0){r=B+11|0;s=B+4|0;h=1;k:while(1){q=a[r>>0]|0;if(q<<24>>24<0)q=c[s>>2]|0;else q=q&255;if(h>>>0>=q>>>0)break j;q=c[e>>2]|0;do if(q){if((c[q+12>>2]|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;p=o;o=0;if(p&1){A=32;break k}if((q|0)==-1){c[e>>2]=0;q=0;break}else{q=c[e>>2]|0;break}}}else q=0;while(0);q=(q|0)==0;do if(f){if((c[f+12>>2]|0)==(c[f+16>>2]|0)){o=0;g=ha(c[(c[f>>2]|0)+36>>2]|0,f|0)|0;p=o;o=0;if(p&1){A=32;break k}if((g|0)==-1){A=266;break}}if(!q){A=273;break k}}else A=266;while(0);if((A|0)==266){A=0;if(q){A=273;break}else f=0}q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;q=ha(c[(c[q>>2]|0)+36>>2]|0,q|0)|0;p=o;o=0;if(p&1){A=32;break}}else q=d[g>>0]|0;if((a[r>>0]|0)<0)g=c[B>>2]|0;else g=B;if((q&255)<<24>>24!=(a[g+h>>0]|0)){A=273;break}h=h+1|0;q=c[e>>2]|0;g=c[q+12>>2]|0;if((g|0)==(c[q+16>>2]|0)){o=0;ha(c[(c[q>>2]|0)+40>>2]|0,q|0)|0;p=o;o=0;if(p&1){A=32;break}else continue}else{c[q+12>>2]=g+1;continue}}if((A|0)==32){q=Ya()|0;break a}else if((A|0)==273){c[k>>2]=c[k>>2]|4;q=0;break i}}while(0);f=c[D+80>>2]|0;if((f|0)!=(w|0)){c[D>>2]=0;kf(D+56|0,f,w,D);if(!(c[D>>2]|0)){q=1;break}else{c[k>>2]=c[k>>2]|4;q=0;break}}else q=1;break}}Oo(D+8|0);Oo(D+20|0);Oo(D+32|0);Oo(D+44|0);Oo(D+56|0);f=c[D+80>>2]|0;c[D+80>>2]=0;if(f|0?(o=0,ba(c[D+80+4>>2]|0,f|0),D=o,o=0,D&1):0){D=Za(0)|0;xr(D)}i=C;return q|0}while(0);Oo(D+8|0);Oo(D+20|0);Oo(D+32|0);Oo(D+44|0);Oo(D+56|0);f=c[D+80>>2]|0;c[D+80>>2]=0;if(f|0?(o=0,ba(c[D+80+4>>2]|0,f|0),D=o,o=0,D&1):0){D=Za(0)|0;xr(D)}Ra(q|0);return 0}function bc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;G=i;o=i=i+63&-64;i=i+16|0;do if(a>>>0<245){p=a>>>0<11?16:a+11&-8;g=c[12592]|0;if(g>>>(p>>>3)&3|0){a=50408+((g>>>(p>>>3)&1^1)+(p>>>3)<<1<<2)|0;b=c[a+8>>2]|0;d=c[b+8>>2]|0;do if((a|0)!=(d|0)){if(d>>>0<(c[12596]|0)>>>0)Ta();if((c[d+12>>2]|0)==(b|0)){c[d+12>>2]=a;c[a+8>>2]=d;break}else Ta()}else c[12592]=g&~(1<<(g>>>(p>>>3)&1^1)+(p>>>3));while(0);F=(g>>>(p>>>3)&1^1)+(p>>>3)<<3;c[b+4>>2]=F|3;c[b+F+4>>2]=c[b+F+4>>2]|1;F=b+8|0;i=G;return F|0}b=c[12594]|0;if(p>>>0>b>>>0){if(g>>>(p>>>3)|0){a=g>>>(p>>>3)<<(p>>>3)&(2<<(p>>>3)|0-(2<<(p>>>3)));f=((a&0-a)+-1|0)>>>(((a&0-a)+-1|0)>>>12&16);e=f>>>(f>>>5&8)>>>(f>>>(f>>>5&8)>>>2&4);e=(f>>>5&8|((a&0-a)+-1|0)>>>12&16|f>>>(f>>>5&8)>>>2&4|e>>>1&2|e>>>(e>>>1&2)>>>1&1)+(e>>>(e>>>1&2)>>>(e>>>(e>>>1&2)>>>1&1))|0;f=c[50408+(e<<1<<2)+8>>2]|0;a=c[f+8>>2]|0;do if((50408+(e<<1<<2)|0)!=(a|0)){if(a>>>0<(c[12596]|0)>>>0)Ta();if((c[a+12>>2]|0)==(f|0)){c[a+12>>2]=50408+(e<<1<<2);c[50408+(e<<1<<2)+8>>2]=a;h=c[12594]|0;break}else Ta()}else{c[12592]=g&~(1<<e);h=b}while(0);c[f+4>>2]=p|3;c[f+p+4>>2]=(e<<3)-p|1;c[f+p+((e<<3)-p)>>2]=(e<<3)-p;if(h|0){d=c[12597]|0;b=h>>>3;a=c[12592]|0;if(a&1<<b){a=c[50408+(b<<1<<2)+8>>2]|0;if(a>>>0<(c[12596]|0)>>>0)Ta();else{j=50408+(b<<1<<2)+8|0;k=a}}else{c[12592]=a|1<<b;j=50408+(b<<1<<2)+8|0;k=50408+(b<<1<<2)|0}c[j>>2]=d;c[k+12>>2]=d;c[d+8>>2]=k;c[d+12>>2]=50408+(b<<1<<2)}c[12594]=(e<<3)-p;c[12597]=f+p;F=f+8|0;i=G;return F|0}a=c[12593]|0;if(a){j=((a&0-a)+-1|0)>>>(((a&0-a)+-1|0)>>>12&16);k=j>>>(j>>>5&8)>>>(j>>>(j>>>5&8)>>>2&4);k=c[50672+((j>>>5&8|((a&0-a)+-1|0)>>>12&16|j>>>(j>>>5&8)>>>2&4|k>>>1&2|k>>>(k>>>1&2)>>>1&1)+(k>>>(k>>>1&2)>>>(k>>>(k>>>1&2)>>>1&1))<<2)>>2]|0;j=(c[k+4>>2]&-8)-p|0;b=k;while(1){a=c[b+16>>2]|0;if(!a){a=c[b+20>>2]|0;if(!a)break}b=(c[a+4>>2]&-8)-p|0;F=b>>>0<j>>>0;j=F?b:j;b=a;k=F?a:k}f=c[12596]|0;if(k>>>0<f>>>0)Ta();h=k+p|0;if(k>>>0>=h>>>0)Ta();g=c[k+24>>2]|0;a=c[k+12>>2]|0;do if((a|0)==(k|0)){b=k+20|0;a=c[b>>2]|0;if(!a){b=k+16|0;a=c[b>>2]|0;if(!a){l=0;break}}while(1){d=a+20|0;e=c[d>>2]|0;if(e|0){a=e;b=d;continue}d=a+16|0;e=c[d>>2]|0;if(!e)break;else{a=e;b=d}}if(b>>>0<f>>>0)Ta();else{c[b>>2]=0;l=a;break}}else{b=c[k+8>>2]|0;if(b>>>0<f>>>0)Ta();if((c[b+12>>2]|0)!=(k|0))Ta();if((c[a+8>>2]|0)==(k|0)){c[b+12>>2]=a;c[a+8>>2]=b;l=a;break}else Ta()}while(0);do if(g|0){a=c[k+28>>2]|0;if((k|0)==(c[50672+(a<<2)>>2]|0)){c[50672+(a<<2)>>2]=l;if(!l){c[12593]=c[12593]&~(1<<a);break}}else{if(g>>>0<(c[12596]|0)>>>0)Ta();if((c[g+16>>2]|0)==(k|0))c[g+16>>2]=l;else c[g+20>>2]=l;if(!l)break}b=c[12596]|0;if(l>>>0<b>>>0)Ta();c[l+24>>2]=g;a=c[k+16>>2]|0;do if(a|0)if(a>>>0<b>>>0)Ta();else{c[l+16>>2]=a;c[a+24>>2]=l;break}while(0);a=c[k+20>>2]|0;if(a|0)if(a>>>0<(c[12596]|0)>>>0)Ta();else{c[l+20>>2]=a;c[a+24>>2]=l;break}}while(0);if(j>>>0<16){F=j+p|0;c[k+4>>2]=F|3;F=k+F+4|0;c[F>>2]=c[F>>2]|1}else{c[k+4>>2]=p|3;c[h+4>>2]=j|1;c[h+j>>2]=j;b=c[12594]|0;if(b|0){d=c[12597]|0;a=c[12592]|0;if(a&1<<(b>>>3)){a=c[50408+(b>>>3<<1<<2)+8>>2]|0;if(a>>>0<(c[12596]|0)>>>0)Ta();else{m=50408+(b>>>3<<1<<2)+8|0;n=a}}else{c[12592]=a|1<<(b>>>3);m=50408+(b>>>3<<1<<2)+8|0;n=50408+(b>>>3<<1<<2)|0}c[m>>2]=d;c[n+12>>2]=d;c[d+8>>2]=n;c[d+12>>2]=50408+(b>>>3<<1<<2)}c[12594]=j;c[12597]=h}F=k+8|0;i=G;return F|0}}}else if(a>>>0<=4294967231){p=a+11&-8;j=c[12593]|0;if(j){if((a+11|0)>>>8)if(p>>>0>16777215)h=31;else{h=(a+11|0)>>>8<<((((a+11|0)>>>8)+1048320|0)>>>16&8);h=14-((h+520192|0)>>>16&4|(((a+11|0)>>>8)+1048320|0)>>>16&8|((h<<((h+520192|0)>>>16&4))+245760|0)>>>16&2)+(h<<((h+520192|0)>>>16&4)<<(((h<<((h+520192|0)>>>16&4))+245760|0)>>>16&2)>>>15)|0;h=p>>>(h+7|0)&1|h<<1}else h=0;b=c[50672+(h<<2)>>2]|0;a:do if(!b){d=0-p|0;a=0;b=0;y=86}else{d=0-p|0;a=0;f=p<<((h|0)==31?0:25-(h>>>1)|0);g=b;b=0;while(1){e=c[g+4>>2]&-8;if((e-p|0)>>>0<d>>>0)if((e|0)==(p|0)){d=e-p|0;a=g;b=g;y=90;break a}else{d=e-p|0;b=g}e=c[g+20>>2]|0;g=c[g+16+(f>>>31<<2)>>2]|0;a=(e|0)==0|(e|0)==(g|0)?a:e;e=(g|0)==0;if(e){y=86;break}else f=f<<(e&1^1)}}while(0);if((y|0)==86){if((a|0)==0&(b|0)==0){a=2<<h;if(!(j&(a|0-a)))break;m=(j&(a|0-a)&0-(j&(a|0-a)))+-1|0;n=m>>>(m>>>12&16)>>>(m>>>(m>>>12&16)>>>5&8);a=n>>>(n>>>2&4)>>>(n>>>(n>>>2&4)>>>1&2);a=c[50672+((m>>>(m>>>12&16)>>>5&8|m>>>12&16|n>>>2&4|n>>>(n>>>2&4)>>>1&2|a>>>1&1)+(a>>>(a>>>1&1))<<2)>>2]|0}if(!a){j=d;k=b}else y=90}if((y|0)==90)while(1){y=0;n=(c[a+4>>2]&-8)-p|0;e=n>>>0<d>>>0;d=e?n:d;b=e?a:b;e=c[a+16>>2]|0;if(e|0){a=e;y=90;continue}a=c[a+20>>2]|0;if(!a){j=d;k=b;break}else y=90}if((k|0)!=0?j>>>0<((c[12594]|0)-p|0)>>>0:0){f=c[12596]|0;if(k>>>0<f>>>0)Ta();h=k+p|0;if(k>>>0>=h>>>0)Ta();g=c[k+24>>2]|0;a=c[k+12>>2]|0;do if((a|0)==(k|0)){b=k+20|0;a=c[b>>2]|0;if(!a){b=k+16|0;a=c[b>>2]|0;if(!a){r=0;break}}while(1){d=a+20|0;e=c[d>>2]|0;if(e|0){a=e;b=d;continue}d=a+16|0;e=c[d>>2]|0;if(!e)break;else{a=e;b=d}}if(b>>>0<f>>>0)Ta();else{c[b>>2]=0;r=a;break}}else{b=c[k+8>>2]|0;if(b>>>0<f>>>0)Ta();if((c[b+12>>2]|0)!=(k|0))Ta();if((c[a+8>>2]|0)==(k|0)){c[b+12>>2]=a;c[a+8>>2]=b;r=a;break}else Ta()}while(0);do if(g|0){a=c[k+28>>2]|0;if((k|0)==(c[50672+(a<<2)>>2]|0)){c[50672+(a<<2)>>2]=r;if(!r){c[12593]=c[12593]&~(1<<a);break}}else{if(g>>>0<(c[12596]|0)>>>0)Ta();if((c[g+16>>2]|0)==(k|0))c[g+16>>2]=r;else c[g+20>>2]=r;if(!r)break}b=c[12596]|0;if(r>>>0<b>>>0)Ta();c[r+24>>2]=g;a=c[k+16>>2]|0;do if(a|0)if(a>>>0<b>>>0)Ta();else{c[r+16>>2]=a;c[a+24>>2]=r;break}while(0);a=c[k+20>>2]|0;if(a|0)if(a>>>0<(c[12596]|0)>>>0)Ta();else{c[r+20>>2]=a;c[a+24>>2]=r;break}}while(0);do if(j>>>0>=16){c[k+4>>2]=p|3;c[h+4>>2]=j|1;c[h+j>>2]=j;b=j>>>3;if(j>>>0<256){a=c[12592]|0;if(a&1<<b){a=c[50408+(b<<1<<2)+8>>2]|0;if(a>>>0<(c[12596]|0)>>>0)Ta();else{s=50408+(b<<1<<2)+8|0;t=a}}else{c[12592]=a|1<<b;s=50408+(b<<1<<2)+8|0;t=50408+(b<<1<<2)|0}c[s>>2]=h;c[t+12>>2]=h;c[h+8>>2]=t;c[h+12>>2]=50408+(b<<1<<2);break}a=j>>>8;if(a)if(j>>>0>16777215)d=31;else{d=a<<((a+1048320|0)>>>16&8)<<(((a<<((a+1048320|0)>>>16&8))+520192|0)>>>16&4);d=14-(((a<<((a+1048320|0)>>>16&8))+520192|0)>>>16&4|(a+1048320|0)>>>16&8|(d+245760|0)>>>16&2)+(d<<((d+245760|0)>>>16&2)>>>15)|0;d=j>>>(d+7|0)&1|d<<1}else d=0;e=50672+(d<<2)|0;c[h+28>>2]=d;c[h+16+4>>2]=0;c[h+16>>2]=0;a=c[12593]|0;b=1<<d;if(!(a&b)){c[12593]=a|b;c[e>>2]=h;c[h+24>>2]=e;c[h+12>>2]=h;c[h+8>>2]=h;break}d=j<<((d|0)==31?0:25-(d>>>1)|0);e=c[e>>2]|0;while(1){if((c[e+4>>2]&-8|0)==(j|0)){y=148;break}b=e+16+(d>>>31<<2)|0;a=c[b>>2]|0;if(!a){y=145;break}else{d=d<<1;e=a}}if((y|0)==145)if(b>>>0<(c[12596]|0)>>>0)Ta();else{c[b>>2]=h;c[h+24>>2]=e;c[h+12>>2]=h;c[h+8>>2]=h;break}else if((y|0)==148){a=e+8|0;b=c[a>>2]|0;F=c[12596]|0;if(b>>>0>=F>>>0&e>>>0>=F>>>0){c[b+12>>2]=h;c[a>>2]=h;c[h+8>>2]=b;c[h+12>>2]=e;c[h+24>>2]=0;break}else Ta()}}else{F=j+p|0;c[k+4>>2]=F|3;F=k+F+4|0;c[F>>2]=c[F>>2]|1}while(0);F=k+8|0;i=G;return F|0}}}else p=-1;while(0);d=c[12594]|0;if(d>>>0>=p>>>0){a=d-p|0;b=c[12597]|0;if(a>>>0>15){F=b+p|0;c[12597]=F;c[12594]=a;c[F+4>>2]=a|1;c[F+a>>2]=a;c[b+4>>2]=p|3}else{c[12594]=0;c[12597]=0;c[b+4>>2]=d|3;c[b+d+4>>2]=c[b+d+4>>2]|1}F=b+8|0;i=G;return F|0}a=c[12595]|0;if(a>>>0>p>>>0){D=a-p|0;c[12595]=D;F=c[12598]|0;E=F+p|0;c[12598]=E;c[E+4>>2]=D|1;c[F+4>>2]=p|3;F=F+8|0;i=G;return F|0}if(!(c[12710]|0)){c[12712]=4096;c[12711]=4096;c[12713]=-1;c[12714]=-1;c[12715]=0;c[12703]=0;c[o>>2]=o&-16^1431655768;c[12710]=o&-16^1431655768}f=p+48|0;d=c[12712]|0;g=p+47|0;h=d+g&0-d;if(h>>>0<=p>>>0){F=0;i=G;return F|0}a=c[12702]|0;if(a|0?(t=c[12700]|0,(t+h|0)>>>0<=t>>>0|(t+h|0)>>>0>a>>>0):0){F=0;i=G;return F|0}b:do if(!(c[12703]&4)){b=c[12598]|0;c:do if(b){e=50816;while(1){a=c[e>>2]|0;if(a>>>0<=b>>>0?(q=e+4|0,(a+(c[q>>2]|0)|0)>>>0>b>>>0):0)break;a=c[e+8>>2]|0;if(!a){y=171;break c}else e=a}a=d+g-(c[12595]|0)&0-d;if(a>>>0<2147483647){b=cb(a|0)|0;if((b|0)==((c[e>>2]|0)+(c[q>>2]|0)|0)){if((b|0)!=(-1|0)){h=b;g=a;y=191;break b}}else y=181}}else y=171;while(0);do if((y|0)==171?(u=cb(0)|0,(u|0)!=(-1|0)):0){a=c[12711]|0;if(!(a+-1&u))a=h;else a=h-u+(a+-1+u&0-a)|0;b=c[12700]|0;d=b+a|0;if(a>>>0>p>>>0&a>>>0<2147483647){t=c[12702]|0;if(t|0?d>>>0<=b>>>0|d>>>0>t>>>0:0)break;b=cb(a|0)|0;if((b|0)==(u|0)){h=u;g=a;y=191;break b}else y=181}}while(0);d:do if((y|0)==181){d=0-a|0;do if(f>>>0>a>>>0&(a>>>0<2147483647&(b|0)!=(-1|0))?(v=c[12712]|0,v=g-a+v&0-v,v>>>0<2147483647):0)if((cb(v|0)|0)==(-1|0)){cb(d|0)|0;break d}else{a=v+a|0;break}while(0);if((b|0)!=(-1|0)){h=b;g=a;y=191;break b}}while(0);c[12703]=c[12703]|4;y=188}else y=188;while(0);if((((y|0)==188?h>>>0<2147483647:0)?(w=cb(h|0)|0,x=cb(0)|0,w>>>0<x>>>0&((w|0)!=(-1|0)&(x|0)!=(-1|0))):0)?(x-w|0)>>>0>(p+40|0)>>>0:0){h=w;g=x-w|0;y=191}if((y|0)==191){a=(c[12700]|0)+g|0;c[12700]=a;if(a>>>0>(c[12701]|0)>>>0)c[12701]=a;l=c[12598]|0;do if(l){f=50816;while(1){a=c[f>>2]|0;b=f+4|0;d=c[b>>2]|0;if((h|0)==(a+d|0)){y=201;break}e=c[f+8>>2]|0;if(!e)break;else f=e}if(((y|0)==201?(c[f+12>>2]&8|0)==0:0)?l>>>0<h>>>0&l>>>0>=a>>>0:0){c[b>>2]=d+g;E=(l+8&7|0)==0?0:0-(l+8)&7;F=g-E+(c[12595]|0)|0;c[12598]=l+E;c[12595]=F;c[l+E+4>>2]=F|1;c[l+E+F+4>>2]=40;c[12599]=c[12714];break}a=c[12596]|0;if(h>>>0<a>>>0){c[12596]=h;k=h}else k=a;b=h+g|0;a=50816;while(1){if((c[a>>2]|0)==(b|0)){y=209;break}a=c[a+8>>2]|0;if(!a){b=50816;break}}if((y|0)==209)if(!(c[a+12>>2]&8)){c[a>>2]=h;n=a+4|0;c[n>>2]=(c[n>>2]|0)+g;n=h+8|0;n=h+((n&7|0)==0?0:0-n&7)|0;a=b+((b+8&7|0)==0?0:0-(b+8)&7)|0;m=n+p|0;j=a-n-p|0;c[n+4>>2]=p|3;do if((a|0)!=(l|0)){if((a|0)==(c[12597]|0)){F=(c[12594]|0)+j|0;c[12594]=F;c[12597]=m;c[m+4>>2]=F|1;c[m+F>>2]=F;break}h=c[a+4>>2]|0;if((h&3|0)==1){e:do if(h>>>0>=256){g=c[a+24>>2]|0;b=c[a+12>>2]|0;do if((b|0)==(a|0)){b=c[a+16+4>>2]|0;if(!b){b=c[a+16>>2]|0;if(!b){D=0;break}else f=a+16|0}else f=a+16+4|0;while(1){d=b+20|0;e=c[d>>2]|0;if(e|0){b=e;f=d;continue}d=b+16|0;e=c[d>>2]|0;if(!e)break;else{b=e;f=d}}if(f>>>0<k>>>0)Ta();else{c[f>>2]=0;D=b;break}}else{d=c[a+8>>2]|0;if(d>>>0<k>>>0)Ta();if((c[d+12>>2]|0)!=(a|0))Ta();if((c[b+8>>2]|0)==(a|0)){c[d+12>>2]=b;c[b+8>>2]=d;D=b;break}else Ta()}while(0);if(!g)break;b=c[a+28>>2]|0;do if((a|0)!=(c[50672+(b<<2)>>2]|0)){if(g>>>0<(c[12596]|0)>>>0)Ta();if((c[g+16>>2]|0)==(a|0))c[g+16>>2]=D;else c[g+20>>2]=D;if(!D)break e}else{c[50672+(b<<2)>>2]=D;if(D|0)break;c[12593]=c[12593]&~(1<<b);break e}while(0);d=c[12596]|0;if(D>>>0<d>>>0)Ta();c[D+24>>2]=g;b=c[a+16>>2]|0;do if(b|0)if(b>>>0<d>>>0)Ta();else{c[D+16>>2]=b;c[b+24>>2]=D;break}while(0);b=c[a+16+4>>2]|0;if(!b)break;if(b>>>0<(c[12596]|0)>>>0)Ta();else{c[D+20>>2]=b;c[b+24>>2]=D;break}}else{b=c[a+8>>2]|0;d=c[a+12>>2]|0;do if((b|0)!=(50408+(h>>>3<<1<<2)|0)){if(b>>>0<k>>>0)Ta();if((c[b+12>>2]|0)==(a|0))break;Ta()}while(0);if((d|0)==(b|0)){c[12592]=c[12592]&~(1<<(h>>>3));break}do if((d|0)==(50408+(h>>>3<<1<<2)|0))B=d+8|0;else{if(d>>>0<k>>>0)Ta();if((c[d+8>>2]|0)==(a|0)){B=d+8|0;break}Ta()}while(0);c[b+12>>2]=d;c[B>>2]=b}while(0);a=a+(h&-8)|0;f=(h&-8)+j|0}else f=j;b=a+4|0;c[b>>2]=c[b>>2]&-2;c[m+4>>2]=f|1;c[m+f>>2]=f;b=f>>>3;if(f>>>0<256){a=c[12592]|0;do if(!(a&1<<b)){c[12592]=a|1<<b;E=50408+(b<<1<<2)+8|0;F=50408+(b<<1<<2)|0}else{a=c[50408+(b<<1<<2)+8>>2]|0;if(a>>>0>=(c[12596]|0)>>>0){E=50408+(b<<1<<2)+8|0;F=a;break}Ta()}while(0);c[E>>2]=m;c[F+12>>2]=m;c[m+8>>2]=F;c[m+12>>2]=50408+(b<<1<<2);break}a=f>>>8;do if(!a)d=0;else{if(f>>>0>16777215){d=31;break}d=a<<((a+1048320|0)>>>16&8)<<(((a<<((a+1048320|0)>>>16&8))+520192|0)>>>16&4);d=14-(((a<<((a+1048320|0)>>>16&8))+520192|0)>>>16&4|(a+1048320|0)>>>16&8|(d+245760|0)>>>16&2)+(d<<((d+245760|0)>>>16&2)>>>15)|0;d=f>>>(d+7|0)&1|d<<1}while(0);e=50672+(d<<2)|0;c[m+28>>2]=d;c[m+16+4>>2]=0;c[m+16>>2]=0;a=c[12593]|0;b=1<<d;if(!(a&b)){c[12593]=a|b;c[e>>2]=m;c[m+24>>2]=e;c[m+12>>2]=m;c[m+8>>2]=m;break}d=f<<((d|0)==31?0:25-(d>>>1)|0);e=c[e>>2]|0;while(1){if((c[e+4>>2]&-8|0)==(f|0)){y=279;break}b=e+16+(d>>>31<<2)|0;a=c[b>>2]|0;if(!a){y=276;break}else{d=d<<1;e=a}}if((y|0)==276)if(b>>>0<(c[12596]|0)>>>0)Ta();else{c[b>>2]=m;c[m+24>>2]=e;c[m+12>>2]=m;c[m+8>>2]=m;break}else if((y|0)==279){a=e+8|0;b=c[a>>2]|0;F=c[12596]|0;if(b>>>0>=F>>>0&e>>>0>=F>>>0){c[b+12>>2]=m;c[a>>2]=m;c[m+8>>2]=b;c[m+12>>2]=e;c[m+24>>2]=0;break}else Ta()}}else{F=(c[12595]|0)+j|0;c[12595]=F;c[12598]=m;c[m+4>>2]=F|1}while(0);F=n+8|0;i=G;return F|0}else b=50816;while(1){a=c[b>>2]|0;if(a>>>0<=l>>>0?(z=a+(c[b+4>>2]|0)|0,z>>>0>l>>>0):0)break;b=c[b+8>>2]|0}f=z+-47+((z+-47+8&7|0)==0?0:0-(z+-47+8)&7)|0;f=f>>>0<(l+16|0)>>>0?l:f;a=h+8|0;a=(a&7|0)==0?0:0-a&7;F=h+a|0;a=g+-40-a|0;c[12598]=F;c[12595]=a;c[F+4>>2]=a|1;c[F+a+4>>2]=40;c[12599]=c[12714];c[f+4>>2]=27;c[f+8>>2]=c[12704];c[f+8+4>>2]=c[12705];c[f+8+8>>2]=c[12706];c[f+8+12>>2]=c[12707];c[12704]=h;c[12705]=g;c[12707]=0;c[12706]=f+8;a=f+24|0;do{a=a+4|0;c[a>>2]=7}while((a+4|0)>>>0<z>>>0);if((f|0)!=(l|0)){c[f+4>>2]=c[f+4>>2]&-2;c[l+4>>2]=f-l|1;c[f>>2]=f-l;if((f-l|0)>>>0<256){b=50408+((f-l|0)>>>3<<1<<2)|0;a=c[12592]|0;if(a&1<<((f-l|0)>>>3)){a=c[b+8>>2]|0;if(a>>>0<(c[12596]|0)>>>0)Ta();else{A=b+8|0;C=a}}else{c[12592]=a|1<<((f-l|0)>>>3);A=b+8|0;C=b}c[A>>2]=l;c[C+12>>2]=l;c[l+8>>2]=C;c[l+12>>2]=b;break}if((f-l|0)>>>8)if((f-l|0)>>>0>16777215)d=31;else{d=(f-l|0)>>>8<<((((f-l|0)>>>8)+1048320|0)>>>16&8);d=14-((d+520192|0)>>>16&4|(((f-l|0)>>>8)+1048320|0)>>>16&8|((d<<((d+520192|0)>>>16&4))+245760|0)>>>16&2)+(d<<((d+520192|0)>>>16&4)<<(((d<<((d+520192|0)>>>16&4))+245760|0)>>>16&2)>>>15)|0;d=(f-l|0)>>>(d+7|0)&1|d<<1}else d=0;e=50672+(d<<2)|0;c[l+28>>2]=d;c[l+20>>2]=0;c[l+16>>2]=0;a=c[12593]|0;b=1<<d;if(!(a&b)){c[12593]=a|b;c[e>>2]=l;c[l+24>>2]=e;c[l+12>>2]=l;c[l+8>>2]=l;break}d=f-l<<((d|0)==31?0:25-(d>>>1)|0);e=c[e>>2]|0;while(1){if((c[e+4>>2]&-8|0)==(f-l|0)){y=305;break}b=e+16+(d>>>31<<2)|0;a=c[b>>2]|0;if(!a){y=302;break}else{d=d<<1;e=a}}if((y|0)==302)if(b>>>0<(c[12596]|0)>>>0)Ta();else{c[b>>2]=l;c[l+24>>2]=e;c[l+12>>2]=l;c[l+8>>2]=l;break}else if((y|0)==305){a=e+8|0;b=c[a>>2]|0;F=c[12596]|0;if(b>>>0>=F>>>0&e>>>0>=F>>>0){c[b+12>>2]=l;c[a>>2]=l;c[l+8>>2]=b;c[l+12>>2]=e;c[l+24>>2]=0;break}else Ta()}}}else{F=c[12596]|0;if((F|0)==0|h>>>0<F>>>0)c[12596]=h;c[12704]=h;c[12705]=g;c[12707]=0;c[12601]=c[12710];c[12600]=-1;a=0;do{F=50408+(a<<1<<2)|0;c[F+12>>2]=F;c[F+8>>2]=F;a=a+1|0}while((a|0)!=32);F=h+8|0;F=(F&7|0)==0?0:0-F&7;E=h+F|0;F=g+-40-F|0;c[12598]=E;c[12595]=F;c[E+4>>2]=F|1;c[E+F+4>>2]=40;c[12599]=c[12714]}while(0);a=c[12595]|0;if(a>>>0>p>>>0){D=a-p|0;c[12595]=D;F=c[12598]|0;E=F+p|0;c[12598]=E;c[E+4>>2]=D|1;c[F+4>>2]=p|3;F=F+8|0;i=G;return F|0}}c[(gp()|0)>>2]=12;F=0;i=G;return F|0}function cc(b){b=b|0;var c=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0;e=d[b>>0]|0;j=Km(d[b+1>>0]|0|0,0,8)|0;S=D;_=d[b+2>>0]|0;x=Km(_|0,0,16)|0;Z=Km(d[b+3>>0]|0|0,0,8)|0;C=D;Y=Km(d[b+4>>0]|0|0,0,16)|0;C=C|D;m=d[b+5>>0]|0;n=Km(m|0,0,24)|0;C=Mm(Z|_|Y|n|0,C|D|0,5)|0;n=Km(d[b+6>>0]|0|0,0,8)|0;Y=D;_=d[b+7>>0]|0;Z=Km(_|0,0,16)|0;Y=Mm(n|m|Z|0,Y|D|0,2)|0;Z=Km(d[b+8>>0]|0|0,0,8)|0;m=D;n=Km(d[b+9>>0]|0|0,0,16)|0;m=m|D;na=d[b+10>>0]|0;va=Km(na|0,0,24)|0;m=Mm(Z|_|n|va|0,m|D|0,7)|0;va=Km(d[b+11>>0]|0|0,0,8)|0;n=D;_=Km(d[b+12>>0]|0|0,0,16)|0;n=n|D;Z=d[b+13>>0]|0;oa=Km(Z|0,0,24)|0;n=Mm(va|na|_|oa|0,n|D|0,4)|0;oa=Km(d[b+14>>0]|0|0,0,8)|0;_=D;na=d[b+15>>0]|0;va=Km(na|0,0,16)|0;_=Mm(oa|Z|va|0,_|D|0,1)|0;va=Km(d[b+16>>0]|0|0,0,8)|0;Z=D;oa=Km(d[b+17>>0]|0|0,0,16)|0;Z=Z|D;xa=d[b+18>>0]|0;ya=Km(xa|0,0,24)|0;Z=Mm(va|na|oa|ya|0,Z|D|0,6)|0;ya=Km(d[b+19>>0]|0|0,0,8)|0;oa=D;na=Km(d[b+20>>0]|0|0,0,16)|0;oa=Mm(ya|xa|na|0,oa|D|0,3)|0;na=D;xa=d[b+21>>0]|0;ya=Km(d[b+22>>0]|0|0,0,8)|0;va=D;N=d[b+23>>0]|0;wa=Km(N|0,0,16)|0;U=Km(d[b+24>>0]|0|0,0,8)|0;ka=D;ua=Km(d[b+25>>0]|0|0,0,16)|0;ka=ka|D;fa=d[b+26>>0]|0;Ca=Km(fa|0,0,24)|0;ka=Mm(U|N|ua|Ca|0,ka|D|0,5)|0;Ca=Km(d[b+27>>0]|0|0,0,8)|0;ua=D;N=d[b+28>>0]|0;U=Km(N|0,0,16)|0;ua=Mm(Ca|fa|U|0,ua|D|0,2)|0;U=Km(d[b+29>>0]|0|0,0,8)|0;fa=D;Ca=Km(d[b+30>>0]|0|0,0,16)|0;fa=fa|D;A=d[b+31>>0]|0;g=Km(A|0,0,24)|0;fa=Mm(U|N|Ca|g|0,fa|D|0,7)|0;g=Km(d[b+32>>0]|0|0,0,8)|0;Ca=D;N=Km(d[b+33>>0]|0|0,0,16)|0;Ca=Ca|D;U=d[b+34>>0]|0;I=Km(U|0,0,24)|0;Ca=Mm(g|A|N|I|0,Ca|D|0,4)|0;I=Km(d[b+35>>0]|0|0,0,8)|0;N=D;A=d[b+36>>0]|0;g=Km(A|0,0,16)|0;N=Mm(I|U|g|0,N|D|0,1)|0;g=Km(d[b+37>>0]|0|0,0,8)|0;U=D;I=Km(d[b+38>>0]|0|0,0,16)|0;U=U|D;K=d[b+39>>0]|0;L=Km(K|0,0,24)|0;U=Mm(g|A|I|L|0,U|D|0,6)|0;L=Km(d[b+40>>0]|0|0,0,8)|0;I=D;A=Km(d[b+41>>0]|0|0,0,16)|0;I=Mm(L|K|A|0,I|D|0,3)|0;A=D;K=d[b+42>>0]|0;L=Km(d[b+43>>0]|0|0,0,8)|0;g=D;X=d[b+44>>0]|0;W=Km(X|0,0,16)|0;G=Km(d[b+45>>0]|0|0,0,8)|0;t=D;ha=Km(d[b+46>>0]|0|0,0,16)|0;t=t|D;Da=d[b+47>>0]|0;u=Km(Da|0,0,24)|0;t=Mm(G|X|ha|u|0,t|D|0,5)|0;u=Km(d[b+48>>0]|0|0,0,8)|0;ha=D;X=d[b+49>>0]|0;G=Km(X|0,0,16)|0;ha=Mm(u|Da|G|0,ha|D|0,2)|0;G=Km(d[b+50>>0]|0|0,0,8)|0;Da=D;u=Km(d[b+51>>0]|0|0,0,16)|0;Da=Da|D;s=d[b+52>>0]|0;q=Km(s|0,0,24)|0;Da=Mm(G|X|u|q|0,Da|D|0,7)|0;q=Km(d[b+53>>0]|0|0,0,8)|0;u=D;X=Km(d[b+54>>0]|0|0,0,16)|0;u=u|D;G=d[b+55>>0]|0;f=Km(G|0,0,24)|0;u=Mm(q|s|X|f|0,u|D|0,4)|0;f=Km(d[b+56>>0]|0|0,0,8)|0;X=D;s=d[b+57>>0]|0;q=Km(s|0,0,16)|0;X=Mm(f|G|q|0,X|D|0,1)|0;q=Km(d[b+58>>0]|0|0,0,8)|0;G=D;f=Km(d[b+59>>0]|0|0,0,16)|0;G=G|D;E=d[b+60>>0]|0;v=Km(E|0,0,24)|0;G=Mm(q|s|f|v|0,G|D|0,6)|0;v=Km(d[b+61>>0]|0|0,0,8)|0;f=D;s=Km(d[b+62>>0]|0|0,0,16)|0;f=f|D;q=Km(d[b+63>>0]|0|0,0,24)|0;f=Mm(v|E|s|q|0,f|D|0,3)|0;q=D;s=Pl(f|0,q|0,666643,0)|0;E=D;v=Pl(f|0,q|0,470296,0)|0;o=D;B=Pl(f|0,q|0,654183,0)|0;Q=D;$=Pl(f|0,q|0,-997805,-1)|0;i=D;h=Pl(f|0,q|0,136657,0)|0;p=D;q=Pl(f|0,q|0,-683901,-1)|0;g=go(q|0,D|0,L|K|W&2031616|0,g|0)|0;W=D;K=Pl(G&2097151|0,0,666643,0)|0;L=D;q=Pl(G&2097151|0,0,470296,0)|0;f=D;qa=Pl(G&2097151|0,0,654183,0)|0;l=D;J=Pl(G&2097151|0,0,-997805,-1)|0;w=D;V=Pl(G&2097151|0,0,136657,0)|0;P=D;G=Pl(G&2097151|0,0,-683901,-1)|0;r=D;c=Pl(X&2097151|0,0,666643,0)|0;O=D;T=Pl(X&2097151|0,0,470296,0)|0;ga=D;aa=Pl(X&2097151|0,0,654183,0)|0;y=D;za=Pl(X&2097151|0,0,-997805,-1)|0;pa=D;H=Pl(X&2097151|0,0,136657,0)|0;k=D;X=Pl(X&2097151|0,0,-683901,-1)|0;U=go(X|0,D|0,U&2097151|0,0)|0;P=go(U|0,D|0,V|0,P|0)|0;i=go(P|0,D|0,$|0,i|0)|0;$=D;P=Pl(u&2097151|0,0,666643,0)|0;V=D;U=Pl(u&2097151|0,0,470296,0)|0;X=D;ra=Pl(u&2097151|0,0,654183,0)|0;z=D;ca=Pl(u&2097151|0,0,-997805,-1)|0;ba=D;Ba=Pl(u&2097151|0,0,136657,0)|0;Aa=D;u=Pl(u&2097151|0,0,-683901,-1)|0;M=D;F=Pl(Da&2097151|0,0,666643,0)|0;R=D;la=Pl(Da&2097151|0,0,470296,0)|0;ma=D;ja=Pl(Da&2097151|0,0,654183,0)|0;ia=D;ta=Pl(Da&2097151|0,0,-997805,-1)|0;sa=D;ea=Pl(Da&2097151|0,0,136657,0)|0;da=D;Da=Pl(Da&2097151|0,0,-683901,-1)|0;Ca=go(Da|0,D|0,Ca&2097151|0,0)|0;Aa=go(Ca|0,D|0,Ba|0,Aa|0)|0;pa=go(Aa|0,D|0,za|0,pa|0)|0;l=go(pa|0,D|0,qa|0,l|0)|0;o=go(l|0,D|0,v|0,o|0)|0;v=D;l=Pl(ha&2097151|0,0,666643,0)|0;Z=go(l|0,D|0,Z&2097151|0,0)|0;l=D;qa=Pl(ha&2097151|0,0,470296,0)|0;pa=D;za=Pl(ha&2097151|0,0,654183,0)|0;va=go(za|0,D|0,ya|xa|wa&2031616|0,va|0)|0;ma=go(va|0,D|0,la|0,ma|0)|0;V=go(ma|0,D|0,P|0,V|0)|0;P=D;ma=Pl(ha&2097151|0,0,-997805,-1)|0;la=D;va=Pl(ha&2097151|0,0,136657,0)|0;ua=go(va|0,D|0,ua&2097151|0,0)|0;sa=go(ua|0,D|0,ta|0,sa|0)|0;z=go(sa|0,D|0,ra|0,z|0)|0;ga=go(z|0,D|0,T|0,ga|0)|0;L=go(ga|0,D|0,K|0,L|0)|0;K=D;ha=Pl(ha&2097151|0,0,-683901,-1)|0;ga=D;T=go(Z|0,l|0,1048576,0)|0;T=Mm(T|0,D|0,21)|0;z=D;na=go(qa|0,pa|0,oa|0,na|0)|0;na=go(na|0,D|0,T|0,z|0)|0;R=go(na|0,D|0,F|0,R|0)|0;F=D;z=Km(T|0,z|0,21)|0;z=Sm(Z|0,l|0,z|0,D|0)|0;l=D;Z=go(V|0,P|0,1048576,0)|0;Z=Mm(Z|0,D|0,21)|0;T=D;ka=go(ma|0,la|0,ka&2097151|0,0)|0;ia=go(ka|0,D|0,ja|0,ia|0)|0;X=go(ia|0,D|0,U|0,X|0)|0;O=go(X|0,D|0,c|0,O|0)|0;O=go(O|0,D|0,Z|0,T|0)|0;c=D;T=Km(Z|0,T|0,21)|0;Z=D;X=go(L|0,K|0,1048576,0)|0;X=_l(X|0,D|0,21)|0;U=D;fa=go(ha|0,ga|0,fa&2097151|0,0)|0;da=go(fa|0,D|0,ea|0,da|0)|0;ba=go(da|0,D|0,ca|0,ba|0)|0;y=go(ba|0,D|0,aa|0,y|0)|0;f=go(y|0,D|0,q|0,f|0)|0;E=go(f|0,D|0,s|0,E|0)|0;E=go(E|0,D|0,X|0,U|0)|0;s=D;U=Km(X|0,U|0,21)|0;X=D;f=go(o|0,v|0,1048576,0)|0;f=_l(f|0,D|0,21)|0;q=D;N=go(u|0,M|0,N&2097151|0,0)|0;k=go(N|0,D|0,H|0,k|0)|0;w=go(k|0,D|0,J|0,w|0)|0;Q=go(w|0,D|0,B|0,Q|0)|0;Q=go(Q|0,D|0,f|0,q|0)|0;B=D;q=Km(f|0,q|0,21)|0;q=Sm(o|0,v|0,q|0,D|0)|0;v=D;o=go(i|0,$|0,1048576,0)|0;o=_l(o|0,D|0,21)|0;f=D;A=go(G|0,r|0,I|0,A|0)|0;p=go(A|0,D|0,h|0,p|0)|0;p=go(p|0,D|0,o|0,f|0)|0;h=D;f=Km(o|0,f|0,21)|0;f=Sm(i|0,$|0,f|0,D|0)|0;$=D;i=go(g|0,W|0,1048576,0)|0;i=_l(i|0,D|0,21)|0;o=D;t=go(i|0,o|0,t&2097151|0,0)|0;A=D;o=Km(i|0,o|0,21)|0;o=Sm(g|0,W|0,o|0,D|0)|0;W=D;g=go(R|0,F|0,1048576,0)|0;g=Mm(g|0,D|0,21)|0;i=D;I=Km(g|0,i|0,21)|0;I=Sm(R|0,F|0,I|0,D|0)|0;F=D;R=go(O|0,c|0,1048576,0)|0;R=_l(R|0,D|0,21)|0;r=D;G=Km(R|0,r|0,21)|0;G=Sm(O|0,c|0,G|0,D|0)|0;c=D;O=go(E|0,s|0,1048576,0)|0;O=_l(O|0,D|0,21)|0;w=D;v=go(q|0,v|0,O|0,w|0)|0;q=D;w=Km(O|0,w|0,21)|0;w=Sm(E|0,s|0,w|0,D|0)|0;s=D;E=go(Q|0,B|0,1048576,0)|0;E=_l(E|0,D|0,21)|0;O=D;$=go(E|0,O|0,f|0,$|0)|0;f=D;O=Km(E|0,O|0,21)|0;O=Sm(Q|0,B|0,O|0,D|0)|0;B=D;Q=go(p|0,h|0,1048576,0)|0;Q=_l(Q|0,D|0,21)|0;E=D;W=go(Q|0,E|0,o|0,W|0)|0;o=D;E=Km(Q|0,E|0,21)|0;E=Sm(p|0,h|0,E|0,D|0)|0;h=D;p=Pl(t|0,A|0,666643,0)|0;_=go(p|0,D|0,_&2097151|0,0)|0;p=D;Q=Pl(t|0,A|0,470296,0)|0;Q=go(z|0,l|0,Q|0,D|0)|0;l=D;z=Pl(t|0,A|0,654183,0)|0;z=go(I|0,F|0,z|0,D|0)|0;F=D;I=Pl(t|0,A|0,-997805,-1)|0;J=D;k=Pl(t|0,A|0,136657,0)|0;k=go(G|0,c|0,k|0,D|0)|0;c=D;A=Pl(t|0,A|0,-683901,-1)|0;t=D;r=go(L|0,K|0,R|0,r|0)|0;X=Sm(r|0,D|0,U|0,X|0)|0;t=go(X|0,D|0,A|0,t|0)|0;A=D;X=Pl(W|0,o|0,666643,0)|0;n=go(X|0,D|0,n&2097151|0,0)|0;X=D;U=Pl(W|0,o|0,470296,0)|0;U=go(_|0,p|0,U|0,D|0)|0;p=D;_=Pl(W|0,o|0,654183,0)|0;_=go(Q|0,l|0,_|0,D|0)|0;l=D;Q=Pl(W|0,o|0,-997805,-1)|0;Q=go(z|0,F|0,Q|0,D|0)|0;F=D;z=Pl(W|0,o|0,136657,0)|0;r=D;o=Pl(W|0,o|0,-683901,-1)|0;o=go(k|0,c|0,o|0,D|0)|0;c=D;k=Pl(E|0,h|0,666643,0)|0;m=go(k|0,D|0,m&2097151|0,0)|0;k=D;W=Pl(E|0,h|0,470296,0)|0;W=go(n|0,X|0,W|0,D|0)|0;X=D;n=Pl(E|0,h|0,654183,0)|0;n=go(U|0,p|0,n|0,D|0)|0;p=D;U=Pl(E|0,h|0,-997805,-1)|0;U=go(_|0,l|0,U|0,D|0)|0;l=D;_=Pl(E|0,h|0,136657,0)|0;_=go(Q|0,F|0,_|0,D|0)|0;F=D;h=Pl(E|0,h|0,-683901,-1)|0;E=D;i=go(V|0,P|0,g|0,i|0)|0;Z=Sm(i|0,D|0,T|0,Z|0)|0;J=go(Z|0,D|0,I|0,J|0)|0;r=go(J|0,D|0,z|0,r|0)|0;E=go(r|0,D|0,h|0,E|0)|0;h=D;r=Pl($|0,f|0,666643,0)|0;z=D;J=Pl($|0,f|0,470296,0)|0;I=D;Z=Pl($|0,f|0,654183,0)|0;T=D;i=Pl($|0,f|0,-997805,-1)|0;g=D;P=Pl($|0,f|0,136657,0)|0;P=go(U|0,l|0,P|0,D|0)|0;l=D;f=Pl($|0,f|0,-683901,-1)|0;f=go(_|0,F|0,f|0,D|0)|0;F=D;_=Pl(O|0,B|0,666643,0)|0;$=D;U=Pl(O|0,B|0,470296,0)|0;V=D;Q=Pl(O|0,B|0,654183,0)|0;R=D;K=Pl(O|0,B|0,-997805,-1)|0;L=D;G=Pl(O|0,B|0,136657,0)|0;H=D;B=Pl(O|0,B|0,-683901,-1)|0;B=go(P|0,l|0,B|0,D|0)|0;l=D;P=Pl(v|0,q|0,666643,0)|0;S=go(P|0,D|0,j|e|x&2031616|0,S|0)|0;x=D;e=Pl(v|0,q|0,470296,0)|0;j=D;P=Pl(v|0,q|0,654183,0)|0;Y=go(P|0,D|0,Y&2097151|0,0)|0;z=go(Y|0,D|0,r|0,z|0)|0;V=go(z|0,D|0,U|0,V|0)|0;U=D;z=Pl(v|0,q|0,-997805,-1)|0;r=D;Y=Pl(v|0,q|0,136657,0)|0;Y=go(W|0,X|0,Y|0,D|0)|0;T=go(Y|0,D|0,Z|0,T|0)|0;L=go(T|0,D|0,K|0,L|0)|0;K=D;q=Pl(v|0,q|0,-683901,-1)|0;v=D;T=go(S|0,x|0,1048576,0)|0;T=_l(T|0,D|0,21)|0;Z=D;C=go(e|0,j|0,C&2097151|0,0)|0;$=go(C|0,D|0,_|0,$|0)|0;$=go($|0,D|0,T|0,Z|0)|0;_=D;Z=Km(T|0,Z|0,21)|0;Z=Sm(S|0,x|0,Z|0,D|0)|0;x=D;S=go(V|0,U|0,1048576,0)|0;S=_l(S|0,D|0,21)|0;T=D;r=go(m|0,k|0,z|0,r|0)|0;I=go(r|0,D|0,J|0,I|0)|0;R=go(I|0,D|0,Q|0,R|0)|0;R=go(R|0,D|0,S|0,T|0)|0;Q=D;T=Km(S|0,T|0,21)|0;S=D;I=go(L|0,K|0,1048576,0)|0;I=_l(I|0,D|0,21)|0;J=D;v=go(n|0,p|0,q|0,v|0)|0;g=go(v|0,D|0,i|0,g|0)|0;H=go(g|0,D|0,G|0,H|0)|0;H=go(H|0,D|0,I|0,J|0)|0;G=D;J=Km(I|0,J|0,21)|0;I=D;g=go(B|0,l|0,1048576,0)|0;g=_l(g|0,D|0,21)|0;i=D;F=go(f|0,F|0,g|0,i|0)|0;f=D;i=Km(g|0,i|0,21)|0;i=Sm(B|0,l|0,i|0,D|0)|0;l=D;B=go(E|0,h|0,1048576,0)|0;B=_l(B|0,D|0,21)|0;g=D;c=go(o|0,c|0,B|0,g|0)|0;o=D;g=Km(B|0,g|0,21)|0;g=Sm(E|0,h|0,g|0,D|0)|0;h=D;E=go(t|0,A|0,1048576,0)|0;E=_l(E|0,D|0,21)|0;B=D;s=go(w|0,s|0,E|0,B|0)|0;w=D;B=Km(E|0,B|0,21)|0;B=Sm(t|0,A|0,B|0,D|0)|0;A=D;t=go($|0,_|0,1048576,0)|0;t=_l(t|0,D|0,21)|0;E=D;v=Km(t|0,E|0,21)|0;q=D;p=go(R|0,Q|0,1048576,0)|0;p=_l(p|0,D|0,21)|0;n=D;r=Km(p|0,n|0,21)|0;z=D;k=go(H|0,G|0,1048576,0)|0;k=_l(k|0,D|0,21)|0;m=D;l=go(i|0,l|0,k|0,m|0)|0;i=D;m=Km(k|0,m|0,21)|0;k=D;C=go(F|0,f|0,1048576,0)|0;C=_l(C|0,D|0,21)|0;j=D;h=go(g|0,h|0,C|0,j|0)|0;g=D;j=Km(C|0,j|0,21)|0;j=Sm(F|0,f|0,j|0,D|0)|0;f=D;F=go(c|0,o|0,1048576,0)|0;F=_l(F|0,D|0,21)|0;C=D;A=go(B|0,A|0,F|0,C|0)|0;B=D;C=Km(F|0,C|0,21)|0;C=Sm(c|0,o|0,C|0,D|0)|0;o=D;c=go(s|0,w|0,1048576,0)|0;c=_l(c|0,D|0,21)|0;F=D;e=Km(c|0,F|0,21)|0;e=Sm(s|0,w|0,e|0,D|0)|0;w=D;s=Pl(c|0,F|0,666643,0)|0;s=go(Z|0,x|0,s|0,D|0)|0;x=D;Z=Pl(c|0,F|0,470296,0)|0;Y=D;X=Pl(c|0,F|0,654183,0)|0;W=D;P=Pl(c|0,F|0,-997805,-1)|0;O=D;N=Pl(c|0,F|0,136657,0)|0;M=D;F=Pl(c|0,F|0,-683901,-1)|0;c=D;u=_l(s|0,x|0,21)|0;y=D;Y=go($|0,_|0,Z|0,Y|0)|0;Y=go(Y|0,D|0,u|0,y|0)|0;q=Sm(Y|0,D|0,v|0,q|0)|0;v=D;y=Km(u|0,y|0,21)|0;y=Sm(s|0,x|0,y|0,D|0)|0;x=D;s=_l(q|0,v|0,21)|0;u=D;U=go(X|0,W|0,V|0,U|0)|0;S=Sm(U|0,D|0,T|0,S|0)|0;E=go(S|0,D|0,t|0,E|0)|0;E=go(E|0,D|0,s|0,u|0)|0;t=D;u=Km(s|0,u|0,21)|0;u=Sm(q|0,v|0,u|0,D|0)|0;v=D;q=_l(E|0,t|0,21)|0;s=D;O=go(R|0,Q|0,P|0,O|0)|0;z=Sm(O|0,D|0,r|0,z|0)|0;z=go(z|0,D|0,q|0,s|0)|0;r=D;s=Km(q|0,s|0,21)|0;s=Sm(E|0,t|0,s|0,D|0)|0;t=D;E=_l(z|0,r|0,21)|0;q=D;K=go(N|0,M|0,L|0,K|0)|0;I=Sm(K|0,D|0,J|0,I|0)|0;n=go(I|0,D|0,p|0,n|0)|0;n=go(n|0,D|0,E|0,q|0)|0;p=D;q=Km(E|0,q|0,21)|0;q=Sm(z|0,r|0,q|0,D|0)|0;r=D;z=_l(n|0,p|0,21)|0;E=D;c=go(H|0,G|0,F|0,c|0)|0;k=Sm(c|0,D|0,m|0,k|0)|0;k=go(k|0,D|0,z|0,E|0)|0;m=D;E=Km(z|0,E|0,21)|0;E=Sm(n|0,p|0,E|0,D|0)|0;p=D;n=_l(k|0,m|0,21)|0;z=D;i=go(l|0,i|0,n|0,z|0)|0;l=D;z=Km(n|0,z|0,21)|0;z=Sm(k|0,m|0,z|0,D|0)|0;m=D;k=_l(i|0,l|0,21)|0;n=D;f=go(k|0,n|0,j|0,f|0)|0;j=D;n=Km(k|0,n|0,21)|0;n=Sm(i|0,l|0,n|0,D|0)|0;l=D;i=_l(f|0,j|0,21)|0;k=D;g=go(h|0,g|0,i|0,k|0)|0;h=D;k=Km(i|0,k|0,21)|0;k=Sm(f|0,j|0,k|0,D|0)|0;j=D;f=_l(g|0,h|0,21)|0;i=D;o=go(f|0,i|0,C|0,o|0)|0;C=D;i=Km(f|0,i|0,21)|0;i=Sm(g|0,h|0,i|0,D|0)|0;h=D;g=_l(o|0,C|0,21)|0;f=D;B=go(A|0,B|0,g|0,f|0)|0;A=D;f=Km(g|0,f|0,21)|0;f=Sm(o|0,C|0,f|0,D|0)|0;C=D;o=_l(B|0,A|0,21)|0;g=D;w=go(o|0,g|0,e|0,w|0)|0;e=D;g=Km(o|0,g|0,21)|0;g=Sm(B|0,A|0,g|0,D|0)|0;A=D;B=_l(w|0,e|0,21)|0;o=D;c=Km(B|0,o|0,21)|0;c=Sm(w|0,e|0,c|0,D|0)|0;e=D;w=Pl(B|0,o|0,666643,0)|0;x=go(w|0,D|0,y|0,x|0)|0;y=D;w=Pl(B|0,o|0,470296,0)|0;w=go(u|0,v|0,w|0,D|0)|0;v=D;u=Pl(B|0,o|0,654183,0)|0;u=go(s|0,t|0,u|0,D|0)|0;t=D;s=Pl(B|0,o|0,-997805,-1)|0;s=go(q|0,r|0,s|0,D|0)|0;r=D;q=Pl(B|0,o|0,136657,0)|0;q=go(E|0,p|0,q|0,D|0)|0;p=D;o=Pl(B|0,o|0,-683901,-1)|0;o=go(z|0,m|0,o|0,D|0)|0;m=D;z=_l(x|0,y|0,21)|0;B=D;v=go(w|0,v|0,z|0,B|0)|0;w=D;B=Km(z|0,B|0,21)|0;B=Sm(x|0,y|0,B|0,D|0)|0;y=D;x=_l(v|0,w|0,21)|0;z=D;t=go(u|0,t|0,x|0,z|0)|0;u=D;z=Km(x|0,z|0,21)|0;z=Sm(v|0,w|0,z|0,D|0)|0;w=D;v=_l(t|0,u|0,21)|0;x=D;r=go(s|0,r|0,v|0,x|0)|0;s=D;x=Km(v|0,x|0,21)|0;x=Sm(t|0,u|0,x|0,D|0)|0;u=D;t=_l(r|0,s|0,21)|0;v=D;p=go(q|0,p|0,t|0,v|0)|0;q=D;v=Km(t|0,v|0,21)|0;v=Sm(r|0,s|0,v|0,D|0)|0;s=D;r=_l(p|0,q|0,21)|0;t=D;m=go(o|0,m|0,r|0,t|0)|0;o=D;t=Km(r|0,t|0,21)|0;t=Sm(p|0,q|0,t|0,D|0)|0;q=D;p=_l(m|0,o|0,21)|0;r=D;l=go(p|0,r|0,n|0,l|0)|0;n=D;r=Km(p|0,r|0,21)|0;r=Sm(m|0,o|0,r|0,D|0)|0;o=D;m=_l(l|0,n|0,21)|0;p=D;j=go(m|0,p|0,k|0,j|0)|0;k=D;p=Km(m|0,p|0,21)|0;p=Sm(l|0,n|0,p|0,D|0)|0;n=D;l=_l(j|0,k|0,21)|0;m=D;h=go(l|0,m|0,i|0,h|0)|0;i=D;m=Km(l|0,m|0,21)|0;m=Sm(j|0,k|0,m|0,D|0)|0;k=D;j=_l(h|0,i|0,21)|0;l=D;C=go(j|0,l|0,f|0,C|0)|0;f=D;l=Km(j|0,l|0,21)|0;l=Sm(h|0,i|0,l|0,D|0)|0;i=D;h=_l(C|0,f|0,21)|0;j=D;A=go(h|0,j|0,g|0,A|0)|0;g=D;j=Km(h|0,j|0,21)|0;j=Sm(C|0,f|0,j|0,D|0)|0;f=D;C=_l(A|0,g|0,21)|0;h=D;e=go(C|0,h|0,c|0,e|0)|0;c=D;h=Km(C|0,h|0,21)|0;h=Sm(A|0,g|0,h|0,D|0)|0;g=D;a[b>>0]=B;A=Mm(B|0,y|0,8)|0;a[b+1>>0]=A;y=Mm(B|0,y|0,16)|0;B=D;A=Km(z|0,w|0,5)|0;a[b+2>>0]=A|y;y=Mm(z|0,w|0,3)|0;a[b+3>>0]=y;y=Mm(z|0,w|0,11)|0;a[b+4>>0]=y;w=Mm(z|0,w|0,19)|0;z=D;y=Km(x|0,u|0,2)|0;a[b+5>>0]=y|w;w=Mm(x|0,u|0,6)|0;a[b+6>>0]=w;u=Mm(x|0,u|0,14)|0;x=D;w=Km(v|0,s|0,7)|0;a[b+7>>0]=w|u;u=Mm(v|0,s|0,1)|0;a[b+8>>0]=u;u=Mm(v|0,s|0,9)|0;a[b+9>>0]=u;s=Mm(v|0,s|0,17)|0;v=D;u=Km(t|0,q|0,4)|0;a[b+10>>0]=u|s;s=Mm(t|0,q|0,4)|0;a[b+11>>0]=s;s=Mm(t|0,q|0,12)|0;a[b+12>>0]=s;q=Mm(t|0,q|0,20)|0;t=D;s=Km(r|0,o|0,1)|0;a[b+13>>0]=s|q;q=Mm(r|0,o|0,7)|0;a[b+14>>0]=q;o=Mm(r|0,o|0,15)|0;r=D;q=Km(p|0,n|0,6)|0;a[b+15>>0]=q|o;o=Mm(p|0,n|0,2)|0;a[b+16>>0]=o;o=Mm(p|0,n|0,10)|0;a[b+17>>0]=o;n=Mm(p|0,n|0,18)|0;p=D;o=Km(m|0,k|0,3)|0;a[b+18>>0]=o|n;n=Mm(m|0,k|0,5)|0;a[b+19>>0]=n;k=Mm(m|0,k|0,13)|0;a[b+20>>0]=k;a[b+21>>0]=l;k=Mm(l|0,i|0,8)|0;a[b+22>>0]=k;i=Mm(l|0,i|0,16)|0;l=D;k=Km(j|0,f|0,5)|0;a[b+23>>0]=k|i;i=Mm(j|0,f|0,3)|0;a[b+24>>0]=i;i=Mm(j|0,f|0,11)|0;a[b+25>>0]=i;f=Mm(j|0,f|0,19)|0;j=D;i=Km(h|0,g|0,2)|0;a[b+26>>0]=i|f;f=Mm(h|0,g|0,6)|0;a[b+27>>0]=f;g=Mm(h|0,g|0,14)|0;h=D;f=Km(e|0,c|0,7)|0;a[b+28>>0]=g|f;f=Mm(e|0,c|0,1)|0;a[b+29>>0]=f;f=Mm(e|0,c|0,9)|0;a[b+30>>0]=f;c=Mm(e|0,c|0,17)|0;a[b+31>>0]=c;return}function dc(b,e,f){b=b|0;e=e|0;f=f|0;var g=0.0,h=0,j=0.0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0,r=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,G=0,H=0,I=0,J=0.0;I=i;C=i=i+63&-64;i=i+512|0;switch(e|0){case 0:{H=24;E=-149;A=4;break}case 1:{H=53;E=-1074;A=4;break}case 2:{H=53;E=-1074;A=4;break}default:g=0.0}a:do if((A|0)==4){do{e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0}else e=Qf(b)|0}while((Vr(e)|0)!=0);b:do switch(e|0){case 43:case 45:{h=1-(((e|0)==45&1)<<1)|0;e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0;G=h;break b}else{e=Qf(b)|0;G=h;break b}}default:G=1}while(0);h=e;e=0;do{if((h|32|0)!=(a[45948+e>>0]|0))break;do if(e>>>0<7){h=c[b+4>>2]|0;if(h>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=h+1;h=d[h>>0]|0;break}else{h=Qf(b)|0;break}}while(0);e=e+1|0}while(e>>>0<8);c:do switch(e|0){case 8:break;case 3:{A=23;break}default:{if((f|0)!=0&e>>>0>3)if((e|0)==8)break c;else{A=23;break c}d:do if(!e){e=0;do{if((h|32|0)!=(a[45957+e>>0]|0))break d;do if(e>>>0<2){h=c[b+4>>2]|0;if(h>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=h+1;h=d[h>>0]|0;break}else{h=Qf(b)|0;break}}while(0);e=e+1|0}while(e>>>0<3)}while(0);switch(e|0){case 3:{e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0}else e=Qf(b)|0;if((e|0)==40)e=1;else{if(!(c[b+100>>2]|0)){g=s;break a}c[b+4>>2]=(c[b+4>>2]|0)+-1;g=s;break a}while(1){h=c[b+4>>2]|0;if(h>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=h+1;h=d[h>>0]|0}else h=Qf(b)|0;if(!((h+-48|0)>>>0<10|(h+-65|0)>>>0<26)?!((h|0)==95|(h+-97|0)>>>0<26):0)break;e=e+1|0}if((h|0)==41){g=s;break a}h=(c[b+100>>2]|0)==0;if(!h)c[b+4>>2]=(c[b+4>>2]|0)+-1;if(!f){c[(gp()|0)>>2]=22;Ek(b,0);g=0.0;break a}if(!e){g=s;break a}while(1){e=e+-1|0;if(!h)c[b+4>>2]=(c[b+4>>2]|0)+-1;if(!e){g=s;break a}}}case 0:{do if((h|0)==48){e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0}else e=Qf(b)|0;if((e|32|0)!=120){if(!(c[b+100>>2]|0)){e=48;break}c[b+4>>2]=(c[b+4>>2]|0)+-1;e=48;break}e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0;k=0}else{e=Qf(b)|0;k=0}e:while(1){switch(e|0){case 46:{A=74;break e}case 48:break;default:{y=0;l=0;x=0;h=0;u=k;w=0;v=0;o=1.0;k=0;g=0.0;break e}}e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0;k=1;continue}else{e=Qf(b)|0;k=1;continue}}if((A|0)==74){e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0}else e=Qf(b)|0;if((e|0)==48){k=0;h=0;do{e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0}else e=Qf(b)|0;k=go(k|0,h|0,-1,-1)|0;h=D}while((e|0)==48);y=0;l=0;x=k;u=1;w=1;v=0;o=1.0;k=0;g=0.0}else{y=0;l=0;x=0;h=0;u=k;w=1;v=0;o=1.0;k=0;g=0.0}}while(1){n=e+-48|0;m=e|32;if(n>>>0>=10){q=(e|0)==46;if(!(q|(m+-97|0)>>>0<6))break;if(q)if(!w){q=l;h=y;n=y;w=1;m=v;j=o}else{e=46;break}else A=86}else A=86;if((A|0)==86){A=0;e=(e|0)>57?m+-87|0:n;do if(!((y|0)<0|(y|0)==0&l>>>0<8)){if((y|0)<0|(y|0)==0&l>>>0<14){r=o*.0625;m=v;j=r;g=g+r*+(e|0);break}if((v|0)!=0|(e|0)==0){m=v;j=o}else{m=1;j=o;g=g+o*.5}}else{m=v;j=o;k=e+(k<<4)|0}while(0);l=go(l|0,y|0,1,0)|0;q=x;n=D;u=1}e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;y=n;x=q;e=d[e>>0]|0;v=m;o=j;continue}else{y=n;x=q;e=Qf(b)|0;v=m;o=j;continue}}if(!u){e=(c[b+100>>2]|0)==0;if(!e)c[b+4>>2]=(c[b+4>>2]|0)+-1;if(f){if(!e?(z=c[b+4>>2]|0,c[b+4>>2]=z+-1,w|0):0)c[b+4>>2]=z+-2}else Ek(b,0);g=+(G|0)*0.0;break a}m=(w|0)==0;n=m?l:x;m=m?y:h;if((y|0)<0|(y|0)==0&l>>>0<8){h=y;do{k=k<<4;l=go(l|0,h|0,1,0)|0;h=D}while((h|0)<0|(h|0)==0&l>>>0<8)}if((e|32|0)==112){h=Vd(b,f)|0;e=D;if((h|0)==0&(e|0)==-2147483648){if(!f){Ek(b,0);g=0.0;break a}if(!(c[b+100>>2]|0)){h=0;e=0}else{c[b+4>>2]=(c[b+4>>2]|0)+-1;h=0;e=0}}}else if(!(c[b+100>>2]|0)){h=0;e=0}else{c[b+4>>2]=(c[b+4>>2]|0)+-1;h=0;e=0}C=Km(n|0,m|0,2)|0;C=go(C|0,D|0,-32,-1)|0;e=go(C|0,D|0,h|0,e|0)|0;h=D;if(!k){g=+(G|0)*0.0;break a}if((h|0)>0|(h|0)==0&e>>>0>(0-E|0)>>>0){c[(gp()|0)>>2]=34;g=+(G|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break a}C=E+-106|0;if((h|0)<(((C|0)<0)<<31>>31|0)|(h|0)==(((C|0)<0)<<31>>31|0)&e>>>0<C>>>0){c[(gp()|0)>>2]=34;g=+(G|0)*2.2250738585072014e-308*2.2250738585072014e-308;break a}if((k|0)>-1)while(1){C=!(g>=.5);k=C&1|k<<1;g=g+(C?g:g+-1.0);e=go(e|0,h|0,-1,-1)|0;h=D;if((k|0)>-1)k=k^1;else{l=e;k=k^1;o=g;break}}else{l=e;o=g}e=Sm(32,0,E|0,((E|0)<0)<<31>>31|0)|0;e=go(l|0,h|0,e|0,D|0)|0;E=D;if(0>(E|0)|0==(E|0)&H>>>0>e>>>0)if((e|0)<0){e=0;A=127}else A=125;else{e=H;A=125}if((A|0)==125)if((e|0)<53)A=127;else{h=e;j=+(G|0);g=0.0}if((A|0)==127){g=+(G|0);h=e;j=g;g=+os(+Pg(1.0,84-e|0),g)}H=(k&1|0)==0&(o!=0.0&(h|0)<32);g=j*(H?0.0:o)+(g+j*+(((H&1)+k|0)>>>0))-g;if(!(g!=0.0))c[(gp()|0)>>2]=34;g=+ps(g,l);break a}else e=h;while(0);B=E+H|0;l=0;f:while(1){switch(e|0){case 46:{A=138;break f}case 48:break;default:{h=0;k=0;q=0;break f}}e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0;l=1;continue}else{e=Qf(b)|0;l=1;continue}}if((A|0)==138){e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0}else e=Qf(b)|0;if((e|0)==48){h=0;e=0;while(1){h=go(h|0,e|0,-1,-1)|0;k=D;e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0}else e=Qf(b)|0;if((e|0)==48)e=k;else{l=1;q=1;break}}}else{h=0;k=0;q=1}}c[C>>2]=0;n=e+-48|0;m=(e|0)==46;g:do if(m|n>>>0<10){u=0;x=0;y=0;z=0;A=0;h:while(1){do if(m)if(!q){h=u;k=x;q=1;v=A}else break h;else{v=go(u|0,x|0,1,0)|0;m=D;w=(e|0)!=48;if((z|0)>=125){if(!w){u=v;x=m;v=A;break}c[C+496>>2]=c[C+496>>2]|1;u=v;x=m;v=A;break}l=C+(z<<2)|0;if(y)n=e+-48+((c[l>>2]|0)*10|0)|0;c[l>>2]=n;n=y+1|0;u=v;x=m;l=1;y=(n|0)==9?0:n;z=((n|0)==9&1)+z|0;v=w?v:A}while(0);e=c[b+4>>2]|0;if(e>>>0<(c[b+100>>2]|0)>>>0){c[b+4>>2]=e+1;e=d[e>>0]|0}else e=Qf(b)|0;n=e+-48|0;m=(e|0)==46;if(!(m|n>>>0<10)){n=z;m=v;A=161;break g}else A=v}q=x;l=(l|0)!=0;e=y;n=z;m=A;A=169}else{u=0;x=0;y=0;n=0;m=0;A=161}while(0);do if((A|0)==161){z=(q|0)==0;h=z?u:h;k=z?x:k;l=(l|0)!=0;if(!((e|32|0)==101&l))if((e|0)>-1){q=x;e=y;A=169;break}else{q=x;e=y;A=171;break}l=Vd(b,f)|0;e=D;if((l|0)==0&(e|0)==-2147483648){if(!f){Ek(b,0);g=0.0;break}if(!(c[b+100>>2]|0)){l=0;e=0}else{c[b+4>>2]=(c[b+4>>2]|0)+-1;l=0;e=0}}h=go(l|0,e|0,h|0,k|0)|0;k=D;q=x;e=y;A=173}while(0);if((A|0)==169)if(c[b+100>>2]|0){c[b+4>>2]=(c[b+4>>2]|0)+-1;if(l)A=173;else A=172}else A=171;if((A|0)==171)if(l)A=173;else A=172;do if((A|0)==172){c[(gp()|0)>>2]=22;Ek(b,0);g=0.0}else if((A|0)==173){l=c[C>>2]|0;if(!l){g=+(G|0)*0.0;break}if(((q|0)<0|(q|0)==0&u>>>0<10)&((h|0)==(u|0)&(k|0)==(q|0))?H>>>0>30|(l>>>H|0)==0:0){g=+(G|0)*+(l>>>0);break}b=(E|0)/-2|0;if((k|0)>(((b|0)<0)<<31>>31|0)|(k|0)==(((b|0)<0)<<31>>31|0)&h>>>0>b>>>0){c[(gp()|0)>>2]=34;g=+(G|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break}b=E+-106|0;if((k|0)<(((b|0)<0)<<31>>31|0)|(k|0)==(((b|0)<0)<<31>>31|0)&h>>>0<b>>>0){c[(gp()|0)>>2]=34;g=+(G|0)*2.2250738585072014e-308*2.2250738585072014e-308;break}if(!e)l=n;else{if((e|0)<9){k=C+(n<<2)|0;l=c[k>>2]|0;do{l=l*10|0;e=e+1|0}while((e|0)!=9);c[k>>2]=l}l=n+1|0}if((m|0)<9?(m|0)<=(h|0)&(h|0)<18:0){if((h|0)==9){g=+(G|0)*+((c[C>>2]|0)>>>0);break}if((h|0)<9){g=+(G|0)*+((c[C>>2]|0)>>>0)/+(c[37568+(8-h<<2)>>2]|0);break}b=H+27+(S(h,-3)|0)|0;e=c[C>>2]|0;if((b|0)>30|(e>>>b|0)==0){g=+(G|0)*+(e>>>0)*+(c[37568+(h+-10<<2)>>2]|0);break}}e=(h|0)%9|0;if(!e){k=0;e=0}else{q=(h|0)>-1?e:e+9|0;e=c[37568+(8-q<<2)>>2]|0;if(l){k=0;m=0;n=0;do{z=C+(n<<2)|0;f=c[z>>2]|0;b=((f>>>0)/(e>>>0)|0)+m|0;c[z>>2]=b;m=S((f>>>0)%(e>>>0)|0,1e9/(e|0)|0)|0;b=(n|0)==(k|0)&(b|0)==0;n=n+1|0;h=b?h+-9|0:h;k=b?n&127:k}while((n|0)!=(l|0));if(m){c[C+(l<<2)>>2]=m;l=l+1|0}}else{k=0;l=0}e=0;h=9-q+h|0}i:while(1){u=(h|0)<18;v=(h|0)==18;w=C+(k<<2)|0;do{if(!u){if(!v){x=l;break i}if((c[w>>2]|0)>>>0>=9007199){h=18;x=l;break i}}n=0;m=l+127|0;while(1){q=m&127;m=Km(c[C+(q<<2)>>2]|0,0,29)|0;m=go(m|0,D|0,n|0,0)|0;n=D;if(n>>>0>0|(n|0)==0&m>>>0>1e9){b=tq(m|0,n|0,1e9,0)|0;m=nl(m|0,n|0,1e9,0)|0;n=b}else n=0;c[C+(q<<2)>>2]=m;b=(q|0)==(k|0);l=(q|0)!=(l+127&127|0)|b?l:(m|0)==0?q:l;if(b)break;else m=q+-1|0}e=e+-29|0}while(!(n|0));k=k+127&127;if((k|0)==(l|0)){b=l+127&127;l=C+((l+126&127)<<2)|0;c[l>>2]=c[l>>2]|c[C+(b<<2)>>2];l=b}c[C+(k<<2)>>2]=n;h=h+9|0}j:while(1){l=x+1&127;w=C+((x+127&127)<<2)|0;while(1){u=(h|0)==18;v=(h|0)>27?9:1;while(1){n=k&127;q=(n|0)==(x|0);do if(!q){m=c[C+(n<<2)>>2]|0;if(m>>>0<9007199){A=219;break}if(m>>>0>9007199)break;m=k+1&127;if((m|0)==(x|0)){A=219;break}m=c[C+(m<<2)>>2]|0;if(m>>>0<254740991){A=219;break}if(!(m>>>0>254740991|u^1)){h=n;l=x;break j}}else A=219;while(0);if((A|0)==219?(A=0,u):0){A=220;break j}e=e+v|0;if((k|0)==(x|0))k=x;else break}m=k;n=0;do{z=C+(k<<2)|0;f=c[z>>2]|0;b=(f>>>v)+n|0;c[z>>2]=b;n=S(f&(1<<v)+-1,1e9>>>v)|0;b=(k|0)==(m|0)&(b|0)==0;k=k+1&127;h=b?h+-9|0:h;m=b?k:m}while((k|0)!=(x|0));if(!n){k=m;continue}if((l|0)!=(m|0))break;c[w>>2]=c[w>>2]|1;k=m}c[C+(x<<2)>>2]=n;k=m;x=l}if((A|0)==220)if(q){c[C+(l+-1<<2)>>2]=0;h=x}else{h=n;l=x}g=+((c[C+(h<<2)>>2]|0)>>>0);h=k+1&127;if((h|0)==(l|0)){l=k+2&127;c[C+(l+-1<<2)>>2]=0}r=+(G|0);j=r*(g*1.0e9+ +((c[C+(h<<2)>>2]|0)>>>0));u=e+53|0;n=u-E|0;q=(n|0)<(H|0);m=q?((n|0)<0?0:n):H;if((m|0)<53){J=+os(+Pg(1.0,105-m|0),j);o=+Cs(j,+Pg(1.0,53-m|0));p=J;g=o;o=J+(j-o)}else{p=0.0;g=0.0;o=j}h=k+2&127;do if((h|0)==(l|0))j=g;else{h=c[C+(h<<2)>>2]|0;do if(h>>>0>=5e8){if(h>>>0>5e8){g=r*.75+g;break}if((k+3&127|0)==(l|0)){g=r*.5+g;break}else{g=r*.75+g;break}}else{if((h|0)==0?(k+3&127|0)==(l|0):0)break;g=r*.25+g}while(0);if((53-m|0)<=1){j=g;break}if(+Cs(g,1.0)!=0.0){j=g;break}j=g+1.0}while(0);g=o+j-p;do if((u&2147483647|0)>(-2-B|0)){if(!(+F(+g)>=9007199254740992.0))h=q&1;else{h=q&(m|0)==(n|0)?0:q&1;e=e+1|0;g=g*.5}if((e+50|0)<=(0-B|0)?!(j!=0.0&(h|0)!=0):0)break;c[(gp()|0)>>2]=34}while(0);g=+ps(g,e)}while(0);break a}default:{if(c[b+100>>2]|0)c[b+4>>2]=(c[b+4>>2]|0)+-1;c[(gp()|0)>>2]=22;Ek(b,0);g=0.0;break a}}}}while(0);if((A|0)==23){h=(c[b+100>>2]|0)==0;if(!h)c[b+4>>2]=(c[b+4>>2]|0)+-1;if((f|0)!=0&e>>>0>3)do{if(!h)c[b+4>>2]=(c[b+4>>2]|0)+-1;e=e+-1|0}while(e>>>0>3)}g=+(G|0)*t}while(0);i=I;return +g}
function wd(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,p=0,q=0,r=0;q=i;p=i=i+63&-64;i=i+160|0;c[p>>2]=37;c[p+4>>2]=0;g=lf(p+1|0,55997,c[d+4>>2]|0)|0;c[p+68>>2]=p+130;a=To()|0;if(g){c[p+8>>2]=c[d+8>>2];h[p+8+8>>3]=f;a=ij(p+130|0,30,a,p,p+8|0)|0}else{h[p+24>>3]=f;a=ij(p+130|0,30,a,p,p+24|0)|0}do if((a|0)>29){a=To()|0;if(g){o=0;c[p+32>>2]=c[d+8>>2];h[p+32+8>>3]=f;a=Ba(23,p+68|0,a|0,p|0,p+32|0)|0;n=o;o=0;if(!(n&1))r=9}else{o=0;h[p+48>>3]=f;a=Ba(23,p+68|0,a|0,p|0,p+48|0)|0;n=o;o=0;if(!(n&1))r=9}if((r|0)==9){g=c[p+68>>2]|0;if(g|0){j=g;k=g;n=g;r=11;break}o=0;Fa(20);n=o;o=0;if(!(n&1)){j=0;k=g;n=g;r=11;break}}a=Ya()|0}else{j=p+130|0;k=p+130|0;n=0;r=11}while(0);if((r|0)==11){l=k+a|0;m=Tg(k,l,c[d+4>>2]|0)|0;do if((k|0)==(p+130|0)){a=p+130|0;k=p+72|0;g=0;r=16}else{g=bc(a<<1)|0;if(!g){o=0;Fa(20);r=o;o=0;if(r&1){g=0;r=14;break}else a=j}else a=k;k=g;r=16}while(0);do if((r|0)==16){j=Ll(d)|0;c[p+56>>2]=j;o=0;ra(19,a|0,m|0,l|0,k|0,p+64|0,p+60|0,p+56|0);m=o;o=0;if(m&1){a=Ya()|0;Vl(j);break}Vl(j);o=0;a=fa(56,c[b>>2]|0,k|0,c[p+64>>2]|0,c[p+60>>2]|0,d|0,e|0)|0;r=o;o=0;if(r&1)r=14;else{c[b>>2]=a;if(g|0)kc(g);if(n|0)kc(n);i=q;return a|0}}while(0);if((r|0)==14)a=Ya()|0;if(g|0)kc(g);if(n)kc(n)}Ra(a|0);return 0}function xd(d,f,g,h,i,j,k,l){d=d|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0;c[g>>2]=d;c[j>>2]=h;if(l&2)if((i-h|0)<3)d=1;else{c[j>>2]=h+1;a[h>>0]=-17;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=-69;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=-65;m=4}else m=4;a:do if((m|0)==4){d=c[g>>2]|0;while(1){if(d>>>0>=f>>>0){d=0;break a}h=b[d>>1]|0;if((h&65535)>>>0>k>>>0){d=2;break a}do if((h&65535)<128){d=c[j>>2]|0;if((i-d|0)<1){d=1;break a}c[j>>2]=d+1;a[d>>0]=h}else{if((h&65535)<2048){d=c[j>>2]|0;if((i-d|0)<2){d=1;break a}c[j>>2]=d+1;a[d>>0]=(h&65535)>>>6|192;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=h&63|128;break}if((h&65535)<55296){d=c[j>>2]|0;if((i-d|0)<3){d=1;break a}c[j>>2]=d+1;a[d>>0]=(h&65535)>>>12|224;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=(h&65535)>>>6&63|128;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=h&63|128;break}if((h&65535)>=56320){if((h&65535)<57344){d=2;break a}d=c[j>>2]|0;if((i-d|0)<3){d=1;break a}c[j>>2]=d+1;a[d>>0]=(h&65535)>>>12|224;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=(h&65535)>>>6&63|128;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=h&63|128;break}if((f-d|0)<4){d=1;break a}d=d+2|0;l=e[d>>1]|0;if((l&64512|0)!=56320){d=2;break a}if((i-(c[j>>2]|0)|0)<4){d=1;break a}if((((h&960)<<10)+65536|(h&65535)<<10&64512|l&1023)>>>0>k>>>0){d=2;break a}c[g>>2]=d;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=(((h&960)>>>6)+1|0)>>>2|240;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=(h&65535)>>>2&15|((h&960)>>>6)+1<<4&48|128;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=(h&65535)<<4&48|l>>>6&15|128;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=l&63|128}while(0);d=(c[g>>2]|0)+2|0;c[g>>2]=d}}while(0);return d|0}function yd(b,e,f,g,h,i,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;c[f>>2]=b;c[i>>2]=g;if(((((k&4|0)!=0?(l=c[f>>2]|0,(e-l|0)>2):0)?(a[l>>0]|0)==-17:0)?(a[l+1>>0]|0)==-69:0)?(a[l+2>>0]|0)==-65:0){c[f>>2]=l+3;g=e}else g=e;a:while(1){m=c[f>>2]|0;if(m>>>0>=e>>>0){l=0;break}n=c[i>>2]|0;if(n>>>0>=h>>>0){l=1;break}o=a[m>>0]|0;do if(o<<24>>24>-1){if((o&255)>>>0>j>>>0){l=2;break a}c[n>>2]=o&255;c[f>>2]=m+1}else{if((o&255)<194){l=2;break a}if((o&255)<224){if((g-m|0)<2){l=1;break a}l=d[m+1>>0]|0;if((l&192|0)!=128){l=2;break a}if((l&63|(o&255)<<6&1984)>>>0>j>>>0){l=2;break a}c[n>>2]=l&63|(o&255)<<6&1984;c[f>>2]=m+2;break}if((o&255)<240){if((g-m|0)<3){l=1;break a}l=a[m+1>>0]|0;b=a[m+2>>0]|0;switch(o&255|0){case 224:{if((l&-32)<<24>>24!=-96){l=2;break a}break}case 237:{if((l&-32)<<24>>24!=-128){l=2;break a}break}default:if((l&-64)<<24>>24!=-128){l=2;break a}}if((b&192|0)!=128){l=2;break a}if(((l&255)<<6&4032|(o&255)<<12&61440|b&63)>>>0>j>>>0){l=2;break a}c[n>>2]=(l&255)<<6&4032|(o&255)<<12&61440|b&63;c[f>>2]=m+3;break}if((o&255)>=245){l=2;break a}if((g-m|0)<4){l=1;break a}l=a[m+1>>0]|0;b=a[m+2>>0]|0;k=a[m+3>>0]|0;switch(o&255|0){case 240:{if((l+112&255)>=48){l=2;break a}break}case 244:{if((l&-16)<<24>>24!=-128){l=2;break a}break}default:if((l&-64)<<24>>24!=-128){l=2;break a}}if((b&192|0)!=128){l=2;break a}if((k&192|0)!=128){l=2;break a}if(((l&255)<<12&258048|(o&255)<<18&1835008|(b&255)<<6&4032|k&63)>>>0>j>>>0){l=2;break a}c[n>>2]=(l&255)<<12&258048|(o&255)<<18&1835008|(b&255)<<6&4032|k&63;c[f>>2]=m+4}while(0);c[i>>2]=(c[i>>2]|0)+4}return l|0}function zd(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;if((((g&4|0)!=0?(c-b|0)>2:0)?(a[b>>0]|0)==-17:0)?(a[b+1>>0]|0)==-69:0){g=(a[b+2>>0]|0)==-65?b+3|0:b;h=0}else{g=b;h=0}a:while(1){if(!(h>>>0<e>>>0&g>>>0<c>>>0)){h=40;break}m=a[g>>0]|0;if((m&255)>>>0>f>>>0){h=40;break}do if(m<<24>>24>-1)g=g+1|0;else{if((m&255)<194){h=40;break a}if((m&255)<224){if((c-g|0)<2){h=40;break a}i=d[g+1>>0]|0;if((i&192|0)!=128){h=40;break a}if((i&63|(m&255)<<6&1984)>>>0>f>>>0){h=40;break a}else{g=g+2|0;break}}if((m&255)<240){k=g;if((c-k|0)<3){h=40;break a}i=a[g+1>>0]|0;j=a[g+2>>0]|0;switch(m&255|0){case 224:{if((i&-32)<<24>>24!=-96){h=19;break a}break}case 237:{if((i&-32)<<24>>24!=-128){h=21;break a}break}default:if((i&-64)<<24>>24!=-128){h=23;break a}}if((j&192|0)!=128){h=40;break a}if(((i&255)<<6&4032|(m&255)<<12&61440|j&63)>>>0>f>>>0){h=40;break a}else{g=g+3|0;break}}if((m&255)>=245){h=40;break a}l=g;if((e-h|0)>>>0<2|(c-l|0)<4){h=40;break a}i=a[g+1>>0]|0;j=a[g+2>>0]|0;k=a[g+3>>0]|0;switch(m&255|0){case 240:{if((i+112&255)>=48){h=30;break a}break}case 244:{if((i&-16)<<24>>24!=-128){h=32;break a}break}default:if((i&-64)<<24>>24!=-128){h=34;break a}}if((j&192|0)!=128){h=40;break a}if((k&192|0)!=128){h=40;break a}if(((i&255)<<12&258048|(m&255)<<18&1835008|(j&255)<<6&4032|k&63)>>>0>f>>>0){h=40;break a}g=g+4|0;h=h+1|0}while(0);h=h+1|0}if((h|0)==19)g=k-b|0;else if((h|0)==21)g=k-b|0;else if((h|0)==23)g=k-b|0;else if((h|0)==30)g=l-b|0;else if((h|0)==32)g=l-b|0;else if((h|0)==34)g=l-b|0;else if((h|0)==40)g=g-b|0;return g|0}function Ad(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;k=i;l=i=i+63&-64;i=i+48|0;a:do if(!(c[f+4>>2]&1)){c[l+8>>2]=-1;j=c[(c[b>>2]|0)+16>>2]|0;c[l+4>>2]=c[d>>2];c[l>>2]=c[e>>2];c[l+12>>2]=c[l+4>>2];c[l+16>>2]=c[l>>2];b=Hb[j&63](b,l+12|0,l+16|0,f,g,l+8|0)|0;c[d>>2]=b;switch(c[l+8>>2]|0){case 0:{a[h>>0]=0;break}case 1:{a[h>>0]=1;break}default:{a[h>>0]=1;c[g>>2]=4}}}else{b=Ll(f)|0;o=0;j=va(32,b|0,51948)|0;m=o;o=0;do if(!(m&1)){Vl(b);b=Ll(f)|0;o=0;f=va(32,b|0,51956)|0;m=o;o=0;if(m&1){m=Ya()|0;Vl(b);b=m;break}Vl(b);o=0;da(c[(c[f>>2]|0)+24>>2]|0,l+16|0,f|0);m=o;o=0;if(!(m&1)){o=0;da(c[(c[f>>2]|0)+28>>2]|0,l+16+12|0,f|0);m=o;o=0;if(!(m&1)){o=0;b=X(25,d|0,c[e>>2]|0,l+16|0,l+16+24|0,j|0,g|0,1)|0;m=o;o=0;if(m&1){b=Ya()|0;Ao(l+16+12|0);Ao(l+16|0);break}else{a[h>>0]=(b|0)==(l+16|0)&1;b=c[d>>2]|0;Ao(l+16+12|0);Ao(l+16|0);break a}}else f=l+16+12|0}else f=l+16|0;b=Ya()|0;j=D;if((l+16|0)!=(f|0))do{f=f+-12|0;Ao(f)}while((f|0)!=(l+16|0))}else{m=Ya()|0;Vl(b);b=m}while(0);Ra(b|0)}while(0);i=k;return b|0}function Bd(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;k=i;l=i=i+63&-64;i=i+48|0;a:do if(!(c[f+4>>2]&1)){c[l+8>>2]=-1;j=c[(c[b>>2]|0)+16>>2]|0;c[l+4>>2]=c[d>>2];c[l>>2]=c[e>>2];c[l+12>>2]=c[l+4>>2];c[l+16>>2]=c[l>>2];b=Hb[j&63](b,l+12|0,l+16|0,f,g,l+8|0)|0;c[d>>2]=b;switch(c[l+8>>2]|0){case 0:{a[h>>0]=0;break}case 1:{a[h>>0]=1;break}default:{a[h>>0]=1;c[g>>2]=4}}}else{b=Ll(f)|0;o=0;j=va(32,b|0,51916)|0;m=o;o=0;do if(!(m&1)){Vl(b);b=Ll(f)|0;o=0;f=va(32,b|0,51928)|0;m=o;o=0;if(m&1){m=Ya()|0;Vl(b);b=m;break}Vl(b);o=0;da(c[(c[f>>2]|0)+24>>2]|0,l+16|0,f|0);m=o;o=0;if(!(m&1)){o=0;da(c[(c[f>>2]|0)+28>>2]|0,l+16+12|0,f|0);m=o;o=0;if(!(m&1)){o=0;b=X(24,d|0,c[e>>2]|0,l+16|0,l+16+24|0,j|0,g|0,1)|0;m=o;o=0;if(m&1){b=Ya()|0;Oo(l+16+12|0);Oo(l+16|0);break}else{a[h>>0]=(b|0)==(l+16|0)&1;b=c[d>>2]|0;Oo(l+16+12|0);Oo(l+16|0);break a}}else f=l+16+12|0}else f=l+16|0;b=Ya()|0;j=D;if((l+16|0)!=(f|0))do{f=f+-12|0;Oo(f)}while((f|0)!=(l+16|0))}else{m=Ya()|0;Vl(b);b=m}while(0);Ra(b|0)}while(0);i=k;return b|0}function Cd(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;if((((g&4|0)!=0?(c-b|0)>2:0)?(a[b>>0]|0)==-17:0)?(a[b+1>>0]|0)==-69:0){g=(a[b+2>>0]|0)==-65?b+3|0:b;m=0}else{g=b;m=0}a:while(1){if(!(m>>>0<e>>>0&g>>>0<c>>>0)){h=40;break}l=a[g>>0]|0;do if(l<<24>>24<=-1){if((l&255)<194){h=40;break a}if((l&255)<224){if((c-g|0)<2){h=40;break a}h=d[g+1>>0]|0;if((h&192|0)!=128){h=40;break a}if((h&63|(l&255)<<6&1984)>>>0>f>>>0){h=40;break a}g=g+2|0;break}if((l&255)<240){j=g;if((c-j|0)<3){h=40;break a}h=a[g+1>>0]|0;i=a[g+2>>0]|0;switch(l&255|0){case 224:{if((h&-32)<<24>>24!=-96){h=20;break a}break}case 237:{if((h&-32)<<24>>24!=-128){h=22;break a}break}default:if((h&-64)<<24>>24!=-128){h=24;break a}}if((i&192|0)!=128){h=40;break a}if(((h&255)<<6&4032|(l&255)<<12&61440|i&63)>>>0>f>>>0){h=40;break a}else{g=g+3|0;break}}if((l&255)>=245){h=40;break a}k=g;if((c-k|0)<4){h=40;break a}h=a[g+1>>0]|0;i=a[g+2>>0]|0;j=a[g+3>>0]|0;switch(l&255|0){case 240:{if((h+112&255)>=48){h=31;break a}break}case 244:{if((h&-16)<<24>>24!=-128){h=33;break a}break}default:if((h&-64)<<24>>24!=-128){h=35;break a}}if((i&192|0)!=128){h=40;break a}if((j&192|0)!=128){h=40;break a}if(((h&255)<<12&258048|(l&255)<<18&1835008|(i&255)<<6&4032|j&63)>>>0>f>>>0){h=40;break a}else g=g+4|0}else{if((l&255)>>>0>f>>>0){h=40;break a}g=g+1|0}while(0);m=m+1|0}if((h|0)==20)g=j-b|0;else if((h|0)==22)g=j-b|0;else if((h|0)==24)g=j-b|0;else if((h|0)==31)g=k-b|0;else if((h|0)==33)g=k-b|0;else if((h|0)==35)g=k-b|0;else if((h|0)==40)g=g-b|0;return g|0}function Dd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;h=i=i+63&-64;i=i+128|0;e=Mm(d<<24>>24|0,((d<<24>>24|0)<0)<<31>>31|0,63)|0;c[a>>2]=1;f=a+4|0;j=f+36|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(j|0));c[a+40>>2]=1;f=a+44|0;j=f+76|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(j|0));o=(d<<24>>24)-((d<<24>>24&0-e)<<1)&255;kl(a,3120+(b*960|0)|0,((o^1)+-1|0)>>>31&255);kl(a,3120+(b*960|0)+120|0,((o^2)+-1|0)>>>31&255);kl(a,3120+(b*960|0)+240|0,((o^3)+-1|0)>>>31&255);kl(a,3120+(b*960|0)+360|0,((o^4)+-1|0)>>>31&255);kl(a,3120+(b*960|0)+480|0,((o^5)+-1|0)>>>31&255);kl(a,3120+(b*960|0)+600|0,((o^6)+-1|0)>>>31&255);kl(a,3120+(b*960|0)+720|0,((o^7)+-1|0)>>>31&255);kl(a,3120+(b*960|0)+840|0,((o^8)+-1|0)>>>31&255);o=c[a+44>>2]|0;n=c[a+48>>2]|0;m=c[a+52>>2]|0;l=c[a+56>>2]|0;k=c[a+60>>2]|0;d=c[a+64>>2]|0;b=c[a+68>>2]|0;f=c[a+72>>2]|0;j=c[a+76>>2]|0;c[h>>2]=c[a+40>>2];c[h+4>>2]=o;c[h+8>>2]=n;c[h+12>>2]=m;c[h+16>>2]=l;c[h+20>>2]=k;c[h+24>>2]=d;c[h+28>>2]=b;c[h+32>>2]=f;c[h+36>>2]=j;j=c[a+4>>2]|0;f=c[a+8>>2]|0;b=c[a+12>>2]|0;d=c[a+16>>2]|0;k=c[a+20>>2]|0;l=c[a+24>>2]|0;m=c[a+28>>2]|0;n=c[a+32>>2]|0;o=c[a+36>>2]|0;c[h+40>>2]=c[a>>2];c[h+44>>2]=j;c[h+48>>2]=f;c[h+52>>2]=b;c[h+56>>2]=d;c[h+60>>2]=k;c[h+64>>2]=l;c[h+68>>2]=m;c[h+72>>2]=n;c[h+76>>2]=o;o=0-(c[a+84>>2]|0)|0;n=0-(c[a+88>>2]|0)|0;m=0-(c[a+92>>2]|0)|0;l=0-(c[a+96>>2]|0)|0;k=0-(c[a+100>>2]|0)|0;d=0-(c[a+104>>2]|0)|0;b=0-(c[a+108>>2]|0)|0;f=0-(c[a+112>>2]|0)|0;j=0-(c[a+116>>2]|0)|0;c[h+80>>2]=0-(c[a+80>>2]|0);c[h+84>>2]=o;c[h+88>>2]=n;c[h+92>>2]=m;c[h+96>>2]=l;c[h+100>>2]=k;c[h+104>>2]=d;c[h+108>>2]=b;c[h+112>>2]=f;c[h+116>>2]=j;kl(a,h,e&255);i=g;return}function Ed(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=c[a>>2]|0;do if(f){g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0))f=Ib[c[(c[f>>2]|0)+36>>2]&127](f)|0;else f=c[g>>2]|0;if((f|0)==-1){c[a>>2]=0;g=1;break}else{g=(c[a>>2]|0)==0;break}}else g=1;while(0);if(b){f=c[b+12>>2]|0;if((f|0)==(c[b+16>>2]|0))f=Ib[c[(c[b>>2]|0)+36>>2]&127](b)|0;else f=c[f>>2]|0;if((f|0)!=-1)if(g){h=b;i=16}else i=15;else i=13}else i=13;if((i|0)==13)if(g)i=15;else{h=0;i=16}do if((i|0)==15)c[d>>2]=c[d>>2]|6;else if((i|0)==16){f=c[a>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0))f=Ib[c[(c[f>>2]|0)+36>>2]&127](f)|0;else f=c[g>>2]|0;if((Kb[c[(c[e>>2]|0)+52>>2]&63](e,f,0)|0)<<24>>24!=37){c[d>>2]=c[d>>2]|4;break}f=c[a>>2]|0;g=c[f+12>>2]|0;b=c[f+16>>2]|0;if((g|0)==(b|0)){Ib[c[(c[f>>2]|0)+40>>2]&127](f)|0;f=c[a>>2]|0;if(!f)g=1;else{g=c[f+12>>2]|0;b=c[f+16>>2]|0;i=25}}else{c[f+12>>2]=g+4;g=g+4|0;i=25}do if((i|0)==25){if((g|0)==(b|0))f=Ib[c[(c[f>>2]|0)+36>>2]&127](f)|0;else f=c[g>>2]|0;if((f|0)==-1){c[a>>2]=0;g=1;break}else{g=(c[a>>2]|0)==0;break}}while(0);if(h){f=c[h+12>>2]|0;if((f|0)==(c[h+16>>2]|0))f=Ib[c[(c[h>>2]|0)+36>>2]&127](h)|0;else f=c[f>>2]|0;if((f|0)!=-1){if(g)break}else i=36}else i=36;if((i|0)==36?!g:0)break;c[d>>2]=c[d>>2]|2}while(0);return}function Fd(b,e,f,g,h,i,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0;a:do if(b<<24>>24==i<<24>>24)if(a[e>>0]|0){a[e>>0]=0;f=c[h>>2]|0;c[h>>2]=f+1;a[f>>0]=46;f=a[k+11>>0]|0;if(((f<<24>>24<0?c[k+4>>2]|0:f&255)|0)!=0?(p=c[m>>2]|0,(p-l|0)<160):0){l=c[n>>2]|0;c[m>>2]=p+4;c[p>>2]=l;p=0}else p=0}else p=-1;else{if(b<<24>>24==j<<24>>24?(j=a[k+11>>0]|0,(j<<24>>24<0?c[k+4>>2]|0:j&255)|0):0){if(!(a[e>>0]|0)){p=-1;break}p=c[m>>2]|0;if((p-l|0)>=160){p=0;break}l=c[n>>2]|0;c[m>>2]=p+4;c[p>>2]=l;c[n>>2]=0;p=0;break}p=o;while(1){if((p|0)==(o+32|0)){p=o+32|0;break}if((a[p>>0]|0)==b<<24>>24)break;p=p+1|0}p=p-o|0;if((p|0)>31)p=-1;else{i=a[46787+p>>0]|0;switch(p|0){case 24:case 25:{p=c[h>>2]|0;if((p|0)!=(g|0)?(d[p+-1>>0]&95|0)!=(d[f>>0]&127|0):0){p=-1;break a}c[h>>2]=p+1;a[p>>0]=i;p=0;break a}case 23:case 22:{a[f>>0]=80;p=c[h>>2]|0;c[h>>2]=p+1;a[p>>0]=i;p=0;break a}default:{if((((i&95|0)==(a[f>>0]|0)?(a[f>>0]=i&95|128,a[e>>0]|0):0)?(a[e>>0]=0,f=a[k+11>>0]|0,(f<<24>>24<0?c[k+4>>2]|0:f&255)|0):0)?(q=c[m>>2]|0,(q-l|0)<160):0){l=c[n>>2]|0;c[m>>2]=q+4;c[q>>2]=l}m=c[h>>2]|0;c[h>>2]=m+1;a[m>>0]=i;if((p|0)>21){p=0;break a}c[n>>2]=(c[n>>2]|0)+1;p=0;break a}}}}while(0);return p|0}function Gd(b){b=b|0;var d=0;if((a[49744]|0)==0?Jp(49744)|0:0){if((a[49752]|0)==0?Jp(49752)|0:0){b=52972;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[b+(d<<2)>>2]=0;d=d+1|0}b=b+12|0}while((b|0)!=53260);rb(137,0,n|0)|0}ym(52972,39212);ym(52984,39244);ym(52996,39280);ym(53008,39304);ym(53020,39328);ym(53032,39344);ym(53044,39364);ym(53056,39384);ym(53068,39412);ym(53080,39452);ym(53092,39484);ym(53104,39520);ym(53116,39556);ym(53128,39572);ym(53140,39588);ym(53152,39604);ym(53164,39328);ym(53176,39620);ym(53188,39636);ym(53200,39652);ym(53212,39668);ym(53224,39684);ym(53236,39700);ym(53248,39716);c[13315]=52972}return c[13315]|0}function Hd(b){b=b|0;var d=0;if((a[49664]|0)==0?Jp(49664)|0:0){if((a[49672]|0)==0?Jp(49672)|0:0){b=52160;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[b+(d<<2)>>2]=0;d=d+1|0}b=b+12|0}while((b|0)!=52448);rb(133,0,n|0)|0}zm(52160,47394);zm(52172,47402);zm(52184,47411);zm(52196,47417);zm(52208,47423);zm(52220,47427);zm(52232,47432);zm(52244,47437);zm(52256,47444);zm(52268,47454);zm(52280,47462);zm(52292,47471);zm(52304,47480);zm(52316,47484);zm(52328,47488);zm(52340,47492);zm(52352,47423);zm(52364,47496);zm(52376,47500);zm(52388,47504);zm(52400,47508);zm(52412,47512);zm(52424,47516);zm(52436,47520);c[13112]=52160}return c[13112]|0}function Id(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;q=i;p=i=i+63&-64;i=i+16|0;l=e;while(1){if((l|0)==(f|0)){l=f;break}if(!(a[l>>0]|0))break;l=l+1|0}c[k>>2]=h;c[g>>2]=e;while(1){if((h|0)==(j|0)|(e|0)==(f|0)){h=33;break}o=c[d+4>>2]|0;c[p>>2]=c[d>>2];c[p+4>>2]=o;o=l;m=zo(c[b+8>>2]|0)|0;n=ge(h,g,o-e|0,j-h>>2,d)|0;if(m|0)zo(m)|0;if((n|0)==-1){l=h;h=10;break}h=(c[k>>2]|0)+(n<<2)|0;c[k>>2]=h;if((h|0)==(j|0)){h=30;break}e=c[g>>2]|0;if((l|0)==(f|0))l=f;else{l=zo(c[b+8>>2]|0)|0;e=Be(h,e,1,d)|0;if(l|0)zo(l)|0;if(e|0){e=2;h=29;break}c[k>>2]=(c[k>>2]|0)+4;e=(c[g>>2]|0)+1|0;c[g>>2]=e;l=e;while(1){if((l|0)==(f|0)){l=f;break}if(!(a[l>>0]|0))break;l=l+1|0}h=c[k>>2]|0}}do if((h|0)==10){a:while(1){c[k>>2]=l;if((e|0)==(c[g>>2]|0)){h=19;break}h=zo(c[b+8>>2]|0)|0;l=Be(l,e,o-e|0,p)|0;if(h|0)zo(h)|0;switch(l|0){case -1:{h=15;break a}case -2:{h=16;break a}case 0:{e=e+1|0;break}default:e=e+l|0}l=(c[k>>2]|0)+4|0;h=10}if((h|0)==15){c[g>>2]=e;e=2;h=29;break}else if((h|0)==16){c[g>>2]=e;e=1;h=29;break}else if((h|0)==19){c[g>>2]=e;e=(e|0)!=(f|0)&1;h=29;break}}else if((h|0)==30){e=c[g>>2]|0;h=33}while(0);if((h|0)!=29)if((h|0)==33)e=(e|0)!=(f|0)&1;i=q;return e|0}function Jd(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=c[a>>2]|0;do if(g){if((c[g+12>>2]|0)==(c[g+16>>2]|0))if((Ib[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1){c[a>>2]=0;g=0;break}else{g=c[a>>2]|0;break}}else g=0;while(0);g=(g|0)==0;do if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(Ib[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){i=10;break}if(g){h=b;i=12}else i=11}else i=10;while(0);if((i|0)==10)if(g)i=11;else{h=0;i=12}a:do if((i|0)==11)c[e>>2]=c[e>>2]|6;else if((i|0)==12){g=c[a>>2]|0;b=c[g+12>>2]|0;if((b|0)==(c[g+16>>2]|0))g=Ib[c[(c[g>>2]|0)+36>>2]&127](g)|0;else g=d[b>>0]|0;if((Kb[c[(c[f>>2]|0)+36>>2]&63](f,g&255,0)|0)<<24>>24!=37){c[e>>2]=c[e>>2]|4;break}g=c[a>>2]|0;b=c[g+12>>2]|0;f=c[g+16>>2]|0;if((b|0)==(f|0)){Ib[c[(c[g>>2]|0)+40>>2]&127](g)|0;g=c[a>>2]|0;if(!g)g=0;else{b=c[g+12>>2]|0;f=c[g+16>>2]|0;i=21}}else{c[g+12>>2]=b+1;b=b+1|0;i=21}do if((i|0)==21)if((b|0)==(f|0))if((Ib[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1){c[a>>2]=0;g=0;break}else{g=c[a>>2]|0;break}while(0);g=(g|0)==0;do if(h){if((c[h+12>>2]|0)==(c[h+16>>2]|0)?(Ib[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1:0){i=29;break}if(g)break a}else i=29;while(0);if((i|0)==29?!g:0)break;c[e>>2]=c[e>>2]|2}while(0);return}function Kd(b,e,f,g,h,i,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0;a:do if((b|0)==(i|0))if(a[e>>0]|0){a[e>>0]=0;f=c[h>>2]|0;c[h>>2]=f+1;a[f>>0]=46;f=a[k+11>>0]|0;if(((f<<24>>24<0?c[k+4>>2]|0:f&255)|0)!=0?(p=c[m>>2]|0,(p-l|0)<160):0){l=c[n>>2]|0;c[m>>2]=p+4;c[p>>2]=l;p=0}else p=0}else p=-1;else{if((b|0)==(j|0)?(j=a[k+11>>0]|0,(j<<24>>24<0?c[k+4>>2]|0:j&255)|0):0){if(!(a[e>>0]|0)){p=-1;break}p=c[m>>2]|0;if((p-l|0)>=160){p=0;break}l=c[n>>2]|0;c[m>>2]=p+4;c[p>>2]=l;c[n>>2]=0;p=0;break}p=o;while(1){if((p|0)==(o+128|0)){p=o+128|0;break}if((c[p>>2]|0)==(b|0))break;p=p+4|0}p=p-o|0;if((p|0)<=124){i=a[46787+(p>>2)>>0]|0;switch(p>>2|0){case 24:case 25:{p=c[h>>2]|0;if((p|0)!=(g|0)?(d[p+-1>>0]&95|0)!=(d[f>>0]&127|0):0){p=-1;break a}c[h>>2]=p+1;a[p>>0]=i;p=0;break a}case 23:case 22:{a[f>>0]=80;break}default:if((((i&95|0)==(a[f>>0]|0)?(a[f>>0]=i&95|128,a[e>>0]|0):0)?(a[e>>0]=0,f=a[k+11>>0]|0,(f<<24>>24<0?c[k+4>>2]|0:f&255)|0):0)?(q=c[m>>2]|0,(q-l|0)<160):0){l=c[n>>2]|0;c[m>>2]=q+4;c[q>>2]=l}}m=c[h>>2]|0;c[h>>2]=m+1;a[m>>0]=i;if((p|0)>84)p=0;else{c[n>>2]=(c[n>>2]|0)+1;p=0}}else p=-1}while(0);return p|0}function Ld(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;m=c[d>>2]|0;h=c[d+4>>2]|0;i=c[d+8>>2]|0;j=c[d+12>>2]|0;p=c[d+16>>2]|0;f=c[d+20>>2]|0;g=c[d+24>>2]|0;n=c[d+28>>2]|0;e=c[d+32>>2]|0;d=c[d+36>>2]|0;o=((((((((((((((d*19|0)+16777216|0)>>>25)+m>>26)+h>>25)+i>>26)+j>>25)+p>>26)+f>>25)+g>>26)+n>>25)+e>>26)+d>>25)*19|0)+m>>26;m=((((((((((((((d*19|0)+16777216|0)>>>25)+m>>26)+h>>25)+i>>26)+j>>25)+p>>26)+f>>25)+g>>26)+n>>25)+e>>26)+d>>25)*19|0)+m-(o<<26)|0;l=o+h-(o+h>>25<<25)|0;k=(o+h>>25)+i-((o+h>>25)+i>>26<<26)|0;q=((o+h>>25)+i>>26)+j>>25;j=((o+h>>25)+i>>26)+j-(q<<25)|0;i=q+p-(q+p>>26<<26)|0;h=(q+p>>26)+f-((q+p>>26)+f>>25<<25)|0;o=((q+p>>26)+f>>25)+g>>26;g=((q+p>>26)+f>>25)+g-(o<<26)|0;f=o+n-(o+n>>25<<25)|0;d=((o+n>>25)+e>>26)+d|0;e=(o+n>>25)+e-((o+n>>25)+e>>26<<26)|0;a[b>>0]=m;a[b+1>>0]=m>>>8;a[b+2>>0]=m>>>16;a[b+3>>0]=l<<2|m>>>24;a[b+4>>0]=l>>>6;a[b+5>>0]=l>>>14;a[b+6>>0]=k<<3|l>>>22;a[b+7>>0]=k>>>5;a[b+8>>0]=k>>>13;a[b+9>>0]=j<<5|k>>>21;a[b+10>>0]=j>>>3;a[b+11>>0]=j>>>11;a[b+12>>0]=i<<6|j>>>19;a[b+13>>0]=i>>>2;a[b+14>>0]=i>>>10;a[b+15>>0]=i>>>18;a[b+16>>0]=h;a[b+17>>0]=h>>>8;a[b+18>>0]=h>>>16;a[b+19>>0]=g<<1|h>>>24;a[b+20>>0]=g>>>7;a[b+21>>0]=g>>>15;a[b+22>>0]=f<<3|g>>>23;a[b+23>>0]=f>>>5;a[b+24>>0]=f>>>13;a[b+25>>0]=e<<4|f>>>21;a[b+26>>0]=e>>>4;a[b+27>>0]=e>>>12;a[b+28>>0]=e>>>20|(d&33554431)<<6;a[b+29>>0]=d>>>2;a[b+30>>0]=d>>>10;a[b+31>>0]=(d&33554431)>>>18;return}function Md(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;while(1){f=c[a>>2]|0;do if(f){g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0))f=Ib[c[(c[f>>2]|0)+36>>2]&127](f)|0;else f=c[g>>2]|0;if((f|0)==-1){c[a>>2]=0;g=1;break}else{g=(c[a>>2]|0)==0;break}}else g=1;while(0);if(b){f=c[b+12>>2]|0;if((f|0)==(c[b+16>>2]|0))f=Ib[c[(c[b>>2]|0)+36>>2]&127](b)|0;else f=c[f>>2]|0;if((f|0)!=-1){if(!g){g=b;break}}else h=14}else h=14;if((h|0)==14){h=0;if(g){g=0;break}else b=0}f=c[a>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0))f=Ib[c[(c[f>>2]|0)+36>>2]&127](f)|0;else f=c[g>>2]|0;if(!(Kb[c[(c[e>>2]|0)+12>>2]&63](e,8192,f)|0)){g=b;break}f=c[a>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0)){Ib[c[(c[f>>2]|0)+40>>2]&127](f)|0;continue}else{c[f+12>>2]=g+4;continue}}b=c[a>>2]|0;do if(b){f=c[b+12>>2]|0;if((f|0)==(c[b+16>>2]|0))b=Ib[c[(c[b>>2]|0)+36>>2]&127](b)|0;else b=c[f>>2]|0;if((b|0)==-1){c[a>>2]=0;f=1;break}else{f=(c[a>>2]|0)==0;break}}else f=1;while(0);if(g){b=c[g+12>>2]|0;if((b|0)==(c[g+16>>2]|0))b=Ib[c[(c[g>>2]|0)+36>>2]&127](g)|0;else b=c[b>>2]|0;if((b|0)!=-1){if(!f)h=37}else h=35}else h=35;if((h|0)==35?f:0)h=37;if((h|0)==37)c[d>>2]=c[d>>2]|2;return}function Nd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;j=i;h=i=i+63&-64;i=i+16|0;a:do if(!(c[e+4>>2]&1)){k=c[(c[b>>2]|0)+24>>2]|0;c[h>>2]=c[d>>2];c[h+4>>2]=c[h>>2];f=Qb[k&63](b,h+4|0,e,f,g&1)|0}else{f=Ll(e)|0;o=0;e=va(32,f|0,51928)|0;k=o;o=0;do if(!(k&1)){Vl(f);f=c[e>>2]|0;if(g)Gb[c[f+24>>2]&127](h+4|0,e);else Gb[c[f+28>>2]&127](h+4|0,e);k=a[h+4+11>>0]|0;g=c[h+4>>2]|0;f=k;e=g;g=k<<24>>24<0?g:h+4|0;b:while(1){k=f<<24>>24<0;if((g|0)==((k?e:h+4|0)+(k?c[h+4+4>>2]|0:f&255)|0)){e=9;break}f=a[g>>0]|0;e=c[d>>2]|0;do if(e|0){b=c[e+24>>2]|0;if((b|0)!=(c[e+28>>2]|0)){c[e+24>>2]=b+1;a[b>>0]=f;break}o=0;f=va(c[(c[e>>2]|0)+52>>2]|0,e|0,f&255|0)|0;k=o;o=0;if(k&1){e=18;break b}if((f|0)==-1)c[d>>2]=0}while(0);f=a[h+4+11>>0]|0;e=c[h+4>>2]|0;g=g+1|0}if((e|0)==9){f=c[d>>2]|0;Oo(h+4|0);break a}else if((e|0)==18){f=Ya()|0;Oo(h+4|0);break}}else{k=Ya()|0;Vl(f);f=k}while(0);Ra(f|0)}while(0);i=j;return f|0}function Od(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;s=i;t=i=i+63&-64;i=i+112|0;if(!((f|0)==0&(g|0)==0)){n=t+16|0;m=n+32|0;do{a[n>>0]=a[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(m|0));n=d[h+4>>0]|d[h+4+1>>0]<<8|d[h+4+2>>0]<<16|d[h+4+3>>0]<<24;c[t>>2]=d[h>>0]|d[h+1>>0]<<8|d[h+2>>0]<<16|d[h+3>>0]<<24;c[t+4>>2]=n;a[t+8>>0]=j;n=Mm(j|0,k|0,8)|0;a[t+9>>0]=n;n=Mm(j|0,k|0,16)|0;a[t+10>>0]=n;n=Mm(j|0,k|0,24)|0;a[t+11>>0]=n;a[t+12>>0]=k;n=Mm(j|0,k|0,40)|0;a[t+13>>0]=n;n=Mm(j|0,k|0,48)|0;a[t+14>>0]=n;n=Mm(j|0,k|0,56)|0;a[t+15>>0]=n;if(g>>>0>0|(g|0)==0&f>>>0>63){do{Cc(t+48|0,t,t+16|0);l=0;do{a[b+l>>0]=a[t+48+l>>0]^a[e+l>>0];l=l+1|0}while((l|0)!=64);m=8;l=1;while(1){n=t+m|0;l=(d[n>>0]|0)+l|0;a[n>>0]=l;m=m+1|0;if((m|0)==16)break;else l=l>>>8}f=go(f|0,g|0,-64,-1)|0;g=D;b=b+64|0;e=e+64|0}while(g>>>0>0|(g|0)==0&f>>>0>63);if(!((f|0)==0&(g|0)==0)){p=b;q=f;r=e;o=8}}else{p=b;q=f;r=e;o=8}if((o|0)==8?(Cc(t+48|0,t,t+16|0),q|0):0){l=0;do{a[p+l>>0]=a[t+48+l>>0]^a[r+l>>0];l=l+1|0}while((l|0)!=(q|0))}_j(t+48|0,64);_j(t+16|0,32)}i=s;return}function Pd(a,e,f,g){a=a|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;a:while(1){h=c[a>>2]|0;do if(h){if((c[h+12>>2]|0)==(c[h+16>>2]|0))if((Ib[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[a>>2]=0;h=0;break}else{h=c[a>>2]|0;break}}else h=0;while(0);h=(h|0)==0;do if(e){if((c[e+12>>2]|0)!=(c[e+16>>2]|0))if(h)break;else{h=e;break a}if((Ib[c[(c[e>>2]|0)+36>>2]&127](e)|0)!=-1){if(!h){h=e;break a}}else j=11}else j=11;while(0);if((j|0)==11){j=0;if(h){h=0;break}else e=0}h=c[a>>2]|0;i=c[h+12>>2]|0;if((i|0)==(c[h+16>>2]|0))h=Ib[c[(c[h>>2]|0)+36>>2]&127](h)|0;else h=d[i>>0]|0;if((h&255)<<24>>24<=-1){h=e;break}if(!(b[(c[g+8>>2]|0)+(h<<24>>24<<1)>>1]&8192)){h=e;break}h=c[a>>2]|0;i=c[h+12>>2]|0;if((i|0)==(c[h+16>>2]|0)){Ib[c[(c[h>>2]|0)+40>>2]&127](h)|0;continue}else{c[h+12>>2]=i+1;continue}}e=c[a>>2]|0;do if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0))if((Ib[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[a>>2]=0;e=0;break}else{e=c[a>>2]|0;break}}else e=0;while(0);e=(e|0)==0;do if(h){if((c[h+12>>2]|0)==(c[h+16>>2]|0)?(Ib[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1:0){j=30;break}if(!e)j=31}else j=30;while(0);if((j|0)==30?e:0)j=31;if((j|0)==31)c[f>>2]=c[f>>2]|2;return}function Qd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;j=i;h=i=i+63&-64;i=i+16|0;a:do if(!(c[e+4>>2]&1)){k=c[(c[b>>2]|0)+24>>2]|0;c[h>>2]=c[d>>2];c[h+4>>2]=c[h>>2];f=Qb[k&63](b,h+4|0,e,f,g&1)|0}else{f=Ll(e)|0;o=0;e=va(32,f|0,51956)|0;k=o;o=0;do if(!(k&1)){Vl(f);f=c[e>>2]|0;if(g)Gb[c[f+24>>2]&127](h+4|0,e);else Gb[c[f+28>>2]&127](h+4|0,e);k=a[h+4+8+3>>0]|0;g=c[h+4>>2]|0;f=k;e=g;g=k<<24>>24<0?g:h+4|0;while(1){k=f<<24>>24<0;if((g|0)==((k?e:h+4|0)+((k?c[h+4+4>>2]|0:f&255)<<2)|0)){e=9;break}f=c[g>>2]|0;e=c[d>>2]|0;if(e|0){b=c[e+24>>2]|0;if((b|0)==(c[e+28>>2]|0)){o=0;f=va(c[(c[e>>2]|0)+52>>2]|0,e|0,f|0)|0;k=o;o=0;if(k&1){e=18;break}}else{c[e+24>>2]=b+4;c[b>>2]=f}if((f|0)==-1)c[d>>2]=0}f=a[h+4+8+3>>0]|0;e=c[h+4>>2]|0;g=g+4|0}if((e|0)==9){f=c[d>>2]|0;Ao(h+4|0);break a}else if((e|0)==18){f=Ya()|0;Ao(h+4|0);break}}else{k=Ya()|0;Vl(f);f=k}while(0);Ra(f|0)}while(0);i=j;return f|0}function Rd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;o=c[b+72>>2]|0;m=c[b+72+4>>2]|0;k=Mm(o|0,m|0,3)|0;l=Km(e|0,f|0,3)|0;n=D;i=Mm(e|0,f|0,61)|0;j=D;m=go(o|0,m|0,l|0,n|0)|0;o=D;c[b+72>>2]=m;c[b+72+4>>2]=o;g=c[b+64>>2]|0;h=c[b+64+4>>2]|0;if(o>>>0<n>>>0|(o|0)==(n|0)&m>>>0<l>>>0){g=go(g|0,h|0,1,0)|0;h=D;c[b+64>>2]=g;c[b+64+4>>2]=h}j=go(g|0,h|0,i|0,j|0)|0;c[b+64>>2]=j;c[b+64+4>>2]=D;j=Sm(128,0,k&127|0,0)|0;g=D;if(g>>>0>f>>>0|(g|0)==(f|0)&j>>>0>e>>>0){if(!((e|0)==0&(f|0)==0)){g=0;h=0;do{n=a[d+g>>0]|0;o=go(g|0,h|0,k&127|0,0)|0;a[b+80+o>>0]=n;g=go(g|0,h|0,1,0)|0;h=D}while(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0)}}else{if(!((j|0)==0&(g|0)==0)){h=0;i=0;do{n=a[d+h>>0]|0;o=go(h|0,i|0,k&127|0,0)|0;a[b+80+o>>0]=n;h=go(h|0,i|0,1,0)|0;i=D}while(i>>>0<g>>>0|(i|0)==(g|0)&h>>>0<j>>>0)}Yb(b,b+80|0);g=Sm(e|0,f|0,j|0,g|0)|0;h=D;if(h>>>0>0|(h|0)==0&g>>>0>127){i=d+j|0;do{Yb(b,i);i=i+128|0;g=go(g|0,h|0,-128,-1)|0;h=D}while(h>>>0>0|(h|0)==0&g>>>0>127);j=i}else j=d+j|0;g=g&127;if(!((g|0)==0&0==0)){h=0;i=0;do{a[b+80+h>>0]=a[j+h>>0]|0;h=go(h|0,i|0,1,0)|0;i=D}while(i>>>0<0|(i|0)==0&h>>>0<g>>>0)}}return}function Sd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0;a:do if(b>>>0<=20)do switch(b|0){case 9:{e=(c[d>>2]|0)+(4-1)&~(4-1);b=c[e>>2]|0;c[d>>2]=e+4;c[a>>2]=b;break a}case 10:{b=(c[d>>2]|0)+(4-1)&~(4-1);e=c[b>>2]|0;c[d>>2]=b+4;c[a>>2]=e;c[a+4>>2]=((e|0)<0)<<31>>31;break a}case 11:{b=(c[d>>2]|0)+(4-1)&~(4-1);e=c[b>>2]|0;c[d>>2]=b+4;c[a>>2]=e;c[a+4>>2]=0;break a}case 12:{f=(c[d>>2]|0)+(8-1)&~(8-1);b=c[f>>2]|0;e=c[f+4>>2]|0;c[d>>2]=f+8;c[a>>2]=b;c[a+4>>2]=e;break a}case 13:{e=(c[d>>2]|0)+(4-1)&~(4-1);f=c[e>>2]|0;c[d>>2]=e+4;c[a>>2]=(f&65535)<<16>>16;c[a+4>>2]=(((f&65535)<<16>>16|0)<0)<<31>>31;break a}case 14:{e=(c[d>>2]|0)+(4-1)&~(4-1);f=c[e>>2]|0;c[d>>2]=e+4;c[a>>2]=f&65535;c[a+4>>2]=0;break a}case 15:{e=(c[d>>2]|0)+(4-1)&~(4-1);f=c[e>>2]|0;c[d>>2]=e+4;c[a>>2]=(f&255)<<24>>24;c[a+4>>2]=(((f&255)<<24>>24|0)<0)<<31>>31;break a}case 16:{e=(c[d>>2]|0)+(4-1)&~(4-1);f=c[e>>2]|0;c[d>>2]=e+4;c[a>>2]=f&255;c[a+4>>2]=0;break a}case 17:{f=(c[d>>2]|0)+(8-1)&~(8-1);g=+h[f>>3];c[d>>2]=f+8;h[a>>3]=g;break a}case 18:{f=(c[d>>2]|0)+(8-1)&~(8-1);g=+h[f>>3];c[d>>2]=f+8;h[a>>3]=g;break a}default:break a}while(0);while(0);return}function Td(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;o=i;n=i=i+63&-64;i=i+16|0;d=e;while(1){if((d|0)==(f|0)){d=f;break}if(!(c[d>>2]|0))break;d=d+4|0}c[k>>2]=h;c[g>>2]=e;a:while(1){if((h|0)==(j|0)|(e|0)==(f|0)){p=33;break}l=zo(c[b+8>>2]|0)|0;m=Ae(h,g,d-e>>2,j-h|0)|0;if(l|0)zo(l)|0;switch(m|0){case -1:{p=10;break a}case 0:{e=1;break a}default:{}}h=(c[k>>2]|0)+m|0;c[k>>2]=h;if((h|0)==(j|0)){p=32;break}if((d|0)==(f|0)){e=c[g>>2]|0;d=f;continue}e=zo(c[b+8>>2]|0)|0;h=pg(n,0)|0;if(e|0)zo(e)|0;if((h|0)==-1){e=2;p=31;break}if(h>>>0>(j-(c[k>>2]|0)|0)>>>0){e=1;p=31;break}else e=n;while(1){if(!h)break;l=a[e>>0]|0;m=c[k>>2]|0;c[k>>2]=m+1;a[m>>0]=l;h=h+-1|0;e=e+1|0}e=(c[g>>2]|0)+4|0;c[g>>2]=e;h=e;while(1){if((h|0)==(f|0)){d=f;break}if(!(c[h>>2]|0)){d=h;break}h=h+4|0}h=c[k>>2]|0}if((p|0)==10){c[k>>2]=h;while(1){if((e|0)==(c[g>>2]|0))break;f=c[e>>2]|0;d=zo(c[b+8>>2]|0)|0;h=pg(h,f)|0;if(d|0)zo(d)|0;if((h|0)==-1)break;h=(c[k>>2]|0)+h|0;c[k>>2]=h;e=e+4|0}c[g>>2]=e;e=2}else if((p|0)!=31)if((p|0)==32){e=c[g>>2]|0;p=33}if((p|0)==33)e=(e|0)!=(f|0)&1;i=o;return e|0}function Ud(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=c[b+56>>2]|0;g=c[b+56+4>>2]|0;if(!((f|0)==0&(g|0)==0)){a[b+64+f>>0]=1;e=go(f|0,g|0,1,0)|0;h=D;if(h>>>0<0|(h|0)==0&e>>>0<16){h=Sm(14,0,f|0,g|0)|0;ei(b+64+e|0,0,h+1|0)|0}a[b+80>>0]=1;Yc(b,b+64|0,16,0)}g=c[b+24>>2]|0;h=(c[b+28>>2]|0)+(g>>>26)|0;k=(h>>>26)+(c[b+32>>2]|0)|0;i=(k>>>26)+(c[b+36>>2]|0)|0;e=((i>>>26)*5|0)+(c[b+20>>2]|0)|0;l=((((e&67108863)+5|0)>>>26)+((e>>>26)+(g&67108863))|0)>>>26;j=(i|-67108864)+((((l+(h&67108863)|0)>>>26)+(k&67108863)|0)>>>26)|0;g=(((e&67108863)+5|0)>>>26)+((e>>>26)+(g&67108863))&67108863&(j>>>31)+-1|j>>31&(e>>>26)+(g&67108863);k=((l+(h&67108863)|0)>>>26)+k&67108863&(j>>>31)+-1|j>>31&(k&67108863);e=go(e+5&67108863&(j>>>31)+-1|j>>31&(e&67108863)|g<<26|0,0,c[b+40>>2]|0,0)|0;f=D;g=go(g>>>6|(l+h&67108863&(j>>>31)+-1|j>>31&(h&67108863))<<20|0,0,c[b+44>>2]|0,0)|0;f=go(g|0,D|0,f|0,0)|0;g=D;h=go((l+h&67108863&(j>>>31)+-1|j>>31&(h&67108863))>>>12|k<<14|0,0,c[b+48>>2]|0,0)|0;g=go(h|0,D|0,g|0,0)|0;h=D;i=go(k>>>18|((j>>>31)+-1&j|j>>31&i)<<8|0,0,c[b+52>>2]|0,0)|0;h=go(i|0,D|0,h|0,0)|0;a[d>>0]=e;a[d+1>>0]=e>>8;a[d+2>>0]=e>>16;a[d+3>>0]=e>>24;a[d+4>>0]=f;a[d+4+1>>0]=f>>8;a[d+4+2>>0]=f>>16;a[d+4+3>>0]=f>>24;a[d+8>>0]=g;a[d+8+1>>0]=g>>8;a[d+8+2>>0]=g>>16;a[d+8+3>>0]=g>>24;a[d+12>>0]=h;a[d+12+1>>0]=h>>8;a[d+12+2>>0]=h>>16;a[d+12+3>>0]=h>>24;_j(b,88);return}function Vd(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=c[a+4>>2]|0;if(e>>>0<(c[a+100>>2]|0)>>>0){c[a+4>>2]=e+1;e=d[e>>0]|0}else e=Qf(a)|0;switch(e|0){case 43:case 45:{f=(e|0)==45&1;e=c[a+4>>2]|0;if(e>>>0<(c[a+100>>2]|0)>>>0){c[a+4>>2]=e+1;e=d[e>>0]|0}else e=Qf(a)|0;if((b|0)!=0&(e+-48|0)>>>0>9?(c[a+100>>2]|0)!=0:0)c[a+4>>2]=(c[a+4>>2]|0)+-1;break}default:f=0}if((e+-48|0)>>>0>9)if(!(c[a+100>>2]|0)){f=-2147483648;e=0}else{c[a+4>>2]=(c[a+4>>2]|0)+-1;f=-2147483648;e=0}else{h=0;do{h=e+-48+(h*10|0)|0;e=c[a+4>>2]|0;if(e>>>0<(c[a+100>>2]|0)>>>0){c[a+4>>2]=e+1;e=d[e>>0]|0}else e=Qf(a)|0;b=(e+-48|0)>>>0<10}while(b&(h|0)<214748364);g=((h|0)<0)<<31>>31;if(b){b=h;do{g=Pl(b|0,g|0,10,0)|0;b=D;e=go(e|0,((e|0)<0)<<31>>31|0,-48,-1)|0;b=go(e|0,D|0,g|0,b|0)|0;g=D;e=c[a+4>>2]|0;if(e>>>0<(c[a+100>>2]|0)>>>0){c[a+4>>2]=e+1;e=d[e>>0]|0}else e=Qf(a)|0}while((e+-48|0)>>>0<10&((g|0)<21474836|(g|0)==21474836&b>>>0<2061584302))}else b=h;if((e+-48|0)>>>0<10)do{e=c[a+4>>2]|0;if(e>>>0<(c[a+100>>2]|0)>>>0){c[a+4>>2]=e+1;e=d[e>>0]|0}else e=Qf(a)|0}while((e+-48|0)>>>0<10);if(c[a+100>>2]|0)c[a+4>>2]=(c[a+4>>2]|0)+-1;a=(f|0)!=0;e=Sm(0,0,b|0,g|0)|0;f=a?D:g;e=a?e:b}D=f;return e|0}function Wd(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0;c[e>>2]=b;c[h>>2]=f;if(j&2)if((g-f|0)<3)b=1;else{c[h>>2]=f+1;a[f>>0]=-17;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=-69;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=-65;k=4}else k=4;a:do if((k|0)==4){b=c[e>>2]|0;while(1){if(b>>>0>=d>>>0){b=0;break a}j=c[b>>2]|0;if(j>>>0>i>>>0|(j&-2048|0)==55296){b=2;break a}do if(j>>>0>=128){if(j>>>0<2048){b=c[h>>2]|0;if((g-b|0)<2){b=1;break a}c[h>>2]=b+1;a[b>>0]=j>>>6|192;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=j&63|128;break}b=c[h>>2]|0;if(j>>>0<65536){if((g-b|0)<3){b=1;break a}c[h>>2]=b+1;a[b>>0]=j>>>12|224;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=j>>>6&63|128;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=j&63|128;break}else{if((g-b|0)<4){b=1;break a}c[h>>2]=b+1;a[b>>0]=j>>>18|240;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=j>>>12&63|128;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=j>>>6&63|128;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=j&63|128;break}}else{b=c[h>>2]|0;if((g-b|0)<1){b=1;break a}c[h>>2]=b+1;a[b>>0]=j}while(0);b=(c[e>>2]|0)+4|0;c[e>>2]=b}}while(0);return b|0}function Xd(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;m=i;k=i=i+63&-64;i=i+32|0;if(a[b+52>>0]|0){f=c[b+48>>2]|0;if(e){c[b+48>>2]=-1;a[b+52>>0]=0}}else{f=c[b+44>>2]|0;f=(f|0)>1?f:1;h=0;while(1){if((h|0)>=(f|0)){l=8;break}g=ji(c[b+32>>2]|0)|0;if((g|0)==-1){f=-1;break}a[k+16+h>>0]=g;h=h+1|0}if((l|0)==8){do if(!(a[b+53>>0]|0)){a:while(1){n=c[b+40>>2]|0;g=c[n>>2]|0;h=c[n+4>>2]|0;o=c[b+36>>2]|0;j=k+16+f|0;switch(Vb[c[(c[o>>2]|0)+16>>2]&31](o,n,k+16|0,j,k+4|0,k+8|0,k+8+1|0,k)|0){case 3:{l=15;break a}case 2:{l=17;break a}case 1:break;default:break a}o=c[b+40>>2]|0;c[o>>2]=g;c[o+4>>2]=h;if((f|0)==8){l=17;break}g=ji(c[b+32>>2]|0)|0;if((g|0)==-1){l=17;break}a[j>>0]=g;f=f+1|0}if((l|0)==15)a[k+8>>0]=a[k+16>>0]|0;else if((l|0)==17){f=-1;break}l=18}else{a[k+8>>0]=a[k+16>>0]|0;l=18}while(0);b:do if((l|0)==18){if(e){f=a[k+8>>0]|0;c[b+48>>2]=f&255}else{while(1){if((f|0)<=0)break;f=f+-1|0;if((Ii(d[k+16+f>>0]|0,c[b+32>>2]|0)|0)==-1){f=-1;break b}}f=a[k+8>>0]|0}f=f&255}while(0)}}i=m;return f|0}function Yd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;l=i;j=i=i+63&-64;i=i+32|0;if(a[b+52>>0]|0){e=c[b+48>>2]|0;if(d){c[b+48>>2]=-1;a[b+52>>0]=0}}else{e=c[b+44>>2]|0;e=(e|0)>1?e:1;g=0;while(1){if((g|0)>=(e|0)){k=8;break}f=ji(c[b+32>>2]|0)|0;if((f|0)==-1){e=-1;break}a[j+16+g>>0]=f;g=g+1|0}if((k|0)==8){do if(!(a[b+53>>0]|0)){a:while(1){m=c[b+40>>2]|0;f=c[m>>2]|0;g=c[m+4>>2]|0;n=c[b+36>>2]|0;h=j+16+e|0;switch(Vb[c[(c[n>>2]|0)+16>>2]&31](n,m,j+16|0,h,j+4|0,j+8|0,j+8+4|0,j)|0){case 3:{k=15;break a}case 2:{k=17;break a}case 1:break;default:break a}n=c[b+40>>2]|0;c[n>>2]=f;c[n+4>>2]=g;if((e|0)==8){k=17;break}f=ji(c[b+32>>2]|0)|0;if((f|0)==-1){k=17;break}a[h>>0]=f;e=e+1|0}if((k|0)==15)c[j+8>>2]=a[j+16>>0];else if((k|0)==17){e=-1;break}k=18}else{c[j+8>>2]=a[j+16>>0];k=18}while(0);b:do if((k|0)==18){if(d){e=c[j+8>>2]|0;c[b+48>>2]=e;break}while(1){if((e|0)<=0)break;e=e+-1|0;if((Ii(a[j+16+e>>0]|0,c[b+32>>2]|0)|0)==-1){e=-1;break b}}e=c[j+8>>2]|0}while(0)}}i=l;return e|0}function Zd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;k=i;j=i=i+63&-64;i=i+16|0;a:do if(!b){f=c[d>>2]|0;b=c[f>>2]|0;if(!b)e=0;else{e=0;do{if(b>>>0>127){b=pg(j,b)|0;if((b|0)==-1){e=-1;break a}}else b=1;e=b+e|0;f=f+4|0;b=c[f>>2]|0}while((b|0)!=0)}}else{b:do if(e>>>0>3){f=e;g=c[d>>2]|0;while(1){h=c[g>>2]|0;if((h+-1|0)>>>0>126){if(!h)break;h=pg(b,h)|0;if((h|0)==-1){e=-1;break a}b=b+h|0;f=f-h|0}else{a[b>>0]=h;b=b+1|0;f=f+-1|0;g=c[d>>2]|0}g=g+4|0;c[d>>2]=g;if(f>>>0<=3)break b}a[b>>0]=0;c[d>>2]=0;e=e-f|0;break a}else f=e;while(0);if(f){g=c[d>>2]|0;while(1){h=c[g>>2]|0;if((h+-1|0)>>>0>126){if(!h){g=19;break}h=pg(j,h)|0;if((h|0)==-1){e=-1;break a}if(f>>>0<h>>>0){g=22;break}pg(b,c[g>>2]|0)|0;b=b+h|0;f=f-h|0}else{a[b>>0]=h;b=b+1|0;f=f+-1|0;g=c[d>>2]|0}g=g+4|0;c[d>>2]=g;if(!f)break a}if((g|0)==19){a[b>>0]=0;c[d>>2]=0;e=e-f|0;break}else if((g|0)==22){e=e-f|0;break}}}while(0);i=k;return e|0}function _d(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;f=a[b+8+3>>0]|0;if(f<<24>>24<0){i=c[b+4>>2]|0;d=(c[b+8>>2]&2147483647)+-1|0}else{i=f&255;d=1}if(i>>>0<2)h=1;else h=(i+4&-4)+-1|0;a:do if((h|0)!=(d|0)){do if((h|0)==1){e=c[b>>2]|0;if(f<<24>>24<0){d=b;f=0;g=21}else{Fp(b,e,(f&255)+1|0);Zs(e);g=24}}else{e=h+1|0;do if(h>>>0>d>>>0)if(e>>>0>1073741823){b=db(4)|0;ls(b);sb(b|0,1944,114)}else{d=Wi(e<<2)|0;break}else{if(e>>>0<=1073741823){o=0;d=ha(85,e<<2|0)|0;g=o;o=0;if(!(g&1))break}else{b=db(4)|0;ls(b);o=0;Da(27,b|0,1944,114);o=0}b=Za(0)|0;jb(b|0)|0;fb();break a}while(0);if(f<<24>>24<0){f=1;e=c[b>>2]|0;g=21;break}else{Fp(d,b,(f&255)+1|0);f=b+4|0;g=23;break}}while(0);if((g|0)==21){Fp(d,e,(c[b+4>>2]|0)+1|0);Zs(e);if(f){e=h+1|0;f=b+4|0;g=23}else g=24}if((g|0)==23){c[b+8>>2]=e|-2147483648;c[f>>2]=i;c[b>>2]=d;break}else if((g|0)==24){a[b+8+3>>0]=i;break}}while(0);return}function $d(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;g=i;h=i=i+63&-64;i=i+592|0;f=0;do{k=a[e+f>>0]|0;j=f<<1;a[h+520+j>>0]=k&15;a[h+520+(j|1)>>0]=(k&255)>>>4;f=f+1|0}while((f|0)!=32);e=0;f=0;do{k=h+520+f|0;j=(d[k>>0]|0)+e|0;e=(j<<24)+134217728>>28;a[k>>0]=j-(e<<4);f=f+1|0}while((f|0)!=63);a[h+520+63>>0]=(d[h+520+63>>0]|0)+e;e=b;f=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));c[b+40>>2]=1;e=b+44|0;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));c[b+80>>2]=1;e=b+84|0;f=e+76|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));e=1;do{Dd(h,(e|0)/2|0,a[h+520+e>>0]|0);gg(h+240|0,b,h);Rj(b,h+240|0);e=e+2|0}while((e|0)<64);qe(h+400|0,b);Ig(h+240|0,h+400|0);al(h+120|0,h+240|0);Ig(h+240|0,h+120|0);al(h+120|0,h+240|0);Ig(h+240|0,h+120|0);al(h+120|0,h+240|0);Ig(h+240|0,h+120|0);Rj(b,h+240|0);e=0;do{Dd(h,(e|0)/2|0,a[h+520+e>>0]|0);gg(h+240|0,b,h);Rj(b,h+240|0);e=e+2|0}while((e|0)<64);i=g;return}function ae(){var a=0;Xg();c[12717]=37756;c[12719]=37776;c[12718]=0;ej(50876,51548);c[12737]=0;c[12738]=-1;Wg();c[12739]=37796;c[12741]=37816;c[12740]=0;ej(50964,51612);c[12759]=0;c[12760]=-1;cg(51676,34268,51724);c[12761]=37836;c[12762]=37856;ej(51048,51676);c[12780]=0;c[12781]=-1;bg(51732,34268,51780);c[12782]=37876;c[12783]=37896;ej(51132,51732);c[12801]=0;c[12802]=-1;cg(51788,34044,51836);c[12803]=37836;c[12804]=37856;ej(51216,51788);c[12822]=0;c[12823]=-1;a=c[51212+(c[(c[12803]|0)+-12>>2]|0)+24>>2]|0;c[12845]=37836;c[12846]=37856;ej(51384,a);c[12864]=0;c[12865]=-1;bg(51844,34044,51892);c[12824]=37876;c[12825]=37896;ej(51300,51844);c[12843]=0;c[12844]=-1;a=c[51296+(c[(c[12824]|0)+-12>>2]|0)+24>>2]|0;c[12866]=37876;c[12867]=37896;ej(51468,a);c[12885]=0;c[12886]=-1;c[50868+(c[(c[12717]|0)+-12>>2]|0)+72>>2]=51044;c[50956+(c[(c[12739]|0)+-12>>2]|0)+72>>2]=51128;a=51212+(c[(c[12803]|0)+-12>>2]|0)+4|0;c[a>>2]=c[a>>2]|8192;a=51296+(c[(c[12824]|0)+-12>>2]|0)+4|0;c[a>>2]=c[a>>2]|8192;c[51212+(c[(c[12803]|0)+-12>>2]|0)+72>>2]=51044;c[51296+(c[(c[12824]|0)+-12>>2]|0)+72>>2]=51128;return}function be(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=c[b+56>>2]|0;g=c[b+56+4>>2]|0;if(!((h|0)==0&(g|0)==0)){j=Sm(16,0,h|0,g|0)|0;l=D;k=l>>>0>f>>>0|(l|0)==(f|0)&j>>>0>e>>>0?e:j;l=l>>>0>f>>>0|(l|0)==(f|0)&j>>>0>e>>>0?f:l;if(!((k|0)==0&(l|0)==0)){j=0;i=0;do{n=a[d+j>>0]|0;h=go(h|0,g|0,j|0,i|0)|0;a[b+64+h>>0]=n;j=go(j|0,i|0,1,0)|0;i=D;h=c[b+56>>2]|0;g=c[b+56+4>>2]|0}while(i>>>0<l>>>0|(i|0)==(l|0)&j>>>0<k>>>0)}n=go(h|0,g|0,k|0,l|0)|0;j=D;c[b+56>>2]=n;c[b+56+4>>2]=j;if(!(j>>>0<0|(j|0)==0&n>>>0<16)){e=Sm(e|0,f|0,k|0,l|0)|0;f=D;Yc(b,b+64|0,16,0);c[b+56>>2]=0;c[b+56+4>>2]=0;d=d+k|0;m=6}}else m=6;if((m|0)==6){if(f>>>0>0|(f|0)==0&e>>>0>15){h=e&-16;Yc(b,d,h,f);e=Sm(e|0,f|0,h|0,f|0)|0;h=d+h|0;f=D}else h=d;if(!((e|0)==0&(f|0)==0)){d=0;g=0;do{m=a[h+d>>0]|0;n=go(c[b+56>>2]|0,c[b+56+4>>2]|0,d|0,g|0)|0;a[b+64+n>>0]=m;d=go(d|0,g|0,1,0)|0;g=D}while(g>>>0<f>>>0|(g|0)==(f|0)&d>>>0<e>>>0);n=go(c[b+56>>2]|0,c[b+56+4>>2]|0,e|0,f|0)|0;c[b+56>>2]=n;c[b+56+4>>2]=D}}return}function ce(b,d,e,f,g,h,i,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0;o=c[f>>2]|0;do if((o|0)==(e|0)){m=(a[l+24>>0]|0)==b<<24>>24;if(!m?(a[l+25>>0]|0)!=b<<24>>24:0){n=5;break}c[f>>2]=e+1;a[e>>0]=m?43:45;c[g>>2]=0;m=0}else n=5;while(0);a:do if((n|0)==5){n=a[i+11>>0]|0;if(b<<24>>24==h<<24>>24?((n<<24>>24<0?c[i+4>>2]|0:n&255)|0)!=0:0){m=c[k>>2]|0;if((m-j|0)>=160){m=0;break}d=c[g>>2]|0;c[k>>2]=m+4;c[m>>2]=d;c[g>>2]=0;m=0;break}m=l;while(1){if((m|0)==(l+26|0)){m=l+26|0;break}if((a[m>>0]|0)==b<<24>>24)break;m=m+1|0}m=m-l|0;if((m|0)>23)m=-1;else{switch(d|0){case 10:case 8:{if((m|0)>=(d|0)){m=-1;break a}break}case 16:{if((m|0)>=22){if((o|0)==(e|0)){m=-1;break a}if((o-e|0)>=3){m=-1;break a}if((a[o+-1>>0]|0)!=48){m=-1;break a}c[g>>2]=0;m=a[46787+m>>0]|0;c[f>>2]=o+1;a[o>>0]=m;m=0;break a}break}default:{}}m=a[46787+m>>0]|0;c[f>>2]=o+1;a[o>>0]=m;c[g>>2]=(c[g>>2]|0)+1;m=0}}while(0);return m|0}function de(b,d,e,f,g,h,i,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0;o=c[f>>2]|0;do if((o|0)==(e|0)){m=(c[l+96>>2]|0)==(b|0);if(!m?(c[l+100>>2]|0)!=(b|0):0){n=5;break}c[f>>2]=e+1;a[e>>0]=m?43:45;c[g>>2]=0;m=0}else n=5;while(0);a:do if((n|0)==5){n=a[i+11>>0]|0;if((b|0)==(h|0)?((n<<24>>24<0?c[i+4>>2]|0:n&255)|0)!=0:0){m=c[k>>2]|0;if((m-j|0)>=160){m=0;break}d=c[g>>2]|0;c[k>>2]=m+4;c[m>>2]=d;c[g>>2]=0;m=0;break}m=l;while(1){if((m|0)==(l+104|0)){m=l+104|0;break}if((c[m>>2]|0)==(b|0))break;m=m+4|0}m=m-l|0;if((m|0)>92)m=-1;else{switch(d|0){case 10:case 8:{if((m>>2|0)>=(d|0)){m=-1;break a}break}case 16:{if((m|0)>=88){if((o|0)==(e|0)){m=-1;break a}if((o-e|0)>=3){m=-1;break a}if((a[o+-1>>0]|0)!=48){m=-1;break a}c[g>>2]=0;m=a[46787+(m>>2)>>0]|0;c[f>>2]=o+1;a[o>>0]=m;m=0;break a}break}default:{}}m=a[46787+(m>>2)>>0]|0;c[f>>2]=o+1;a[o>>0]=m;c[g>>2]=(c[g>>2]|0)+1;m=0}}while(0);return m|0}function ee(a,b,e,f,g,h,j){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=i=i+63&-64;i=i+64|0;if(!((e|0)==0&(f|0)==0)){c[l>>2]=1634760805;c[l+4>>2]=857760878;c[l+8>>2]=2036477234;c[l+12>>2]=1797285236;c[l+16>>2]=d[j>>0]|d[j+1>>0]<<8|d[j+2>>0]<<16|d[j+3>>0]<<24;c[l+20>>2]=d[j+4>>0]|d[j+4+1>>0]<<8|d[j+4+2>>0]<<16|d[j+4+3>>0]<<24;c[l+24>>2]=d[j+8>>0]|d[j+8+1>>0]<<8|d[j+8+2>>0]<<16|d[j+8+3>>0]<<24;c[l+28>>2]=d[j+12>>0]|d[j+12+1>>0]<<8|d[j+12+2>>0]<<16|d[j+12+3>>0]<<24;c[l+32>>2]=d[j+16>>0]|d[j+16+1>>0]<<8|d[j+16+2>>0]<<16|d[j+16+3>>0]<<24;c[l+36>>2]=d[j+20>>0]|d[j+20+1>>0]<<8|d[j+20+2>>0]<<16|d[j+20+3>>0]<<24;c[l+40>>2]=d[j+24>>0]|d[j+24+1>>0]<<8|d[j+24+2>>0]<<16|d[j+24+3>>0]<<24;c[l+44>>2]=d[j+28>>0]|d[j+28+1>>0]<<8|d[j+28+2>>0]<<16|d[j+28+3>>0]<<24;c[l+48>>2]=h;c[l+52>>2]=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;c[l+56>>2]=d[g+4>>0]|d[g+4+1>>0]<<8|d[g+4+2>>0]<<16|d[g+4+3>>0]<<24;c[l+60>>2]=d[g+8>>0]|d[g+8+1>>0]<<8|d[g+8+2>>0]<<16|d[g+8+3>>0]<<24;mc(l,b,a,e,f);_j(l,64)}i=k;return}function fe(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+64|0;if(!((b|0)==0&(e|0)==0)){c[j>>2]=1634760805;c[j+4>>2]=857760878;c[j+8>>2]=2036477234;c[j+12>>2]=1797285236;c[j+16>>2]=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;c[j+20>>2]=d[g+4>>0]|d[g+4+1>>0]<<8|d[g+4+2>>0]<<16|d[g+4+3>>0]<<24;c[j+24>>2]=d[g+8>>0]|d[g+8+1>>0]<<8|d[g+8+2>>0]<<16|d[g+8+3>>0]<<24;c[j+28>>2]=d[g+12>>0]|d[g+12+1>>0]<<8|d[g+12+2>>0]<<16|d[g+12+3>>0]<<24;c[j+32>>2]=d[g+16>>0]|d[g+16+1>>0]<<8|d[g+16+2>>0]<<16|d[g+16+3>>0]<<24;c[j+36>>2]=d[g+20>>0]|d[g+20+1>>0]<<8|d[g+20+2>>0]<<16|d[g+20+3>>0]<<24;c[j+40>>2]=d[g+24>>0]|d[g+24+1>>0]<<8|d[g+24+2>>0]<<16|d[g+24+3>>0]<<24;c[j+44>>2]=d[g+28>>0]|d[g+28+1>>0]<<8|d[g+28+2>>0]<<16|d[g+28+3>>0]<<24;c[j+48>>2]=0;c[j+52>>2]=d[f>>0]|d[f+1>>0]<<8|d[f+2>>0]<<16|d[f+3>>0]<<24;c[j+56>>2]=d[f+4>>0]|d[f+4+1>>0]<<8|d[f+4+2>>0]<<16|d[f+4+3>>0]<<24;c[j+60>>2]=d[f+8>>0]|d[f+8+1>>0]<<8|d[f+8+2>>0]<<16|d[f+8+3>>0]<<24;ei(a|0,0,b|0)|0;mc(j,a,a,b,e);_j(j,64)}i=h;return}function ge(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;p=i;o=i=i+63&-64;i=i+1040|0;k=c[b>>2]|0;c[o>>2]=k;e=a|0?e:256;h=a|0?a:o+8|0;a:do if((e|0)!=0&(k|0)!=0){l=d;m=e;d=k;e=0;n=h;while(1){g=l>>>2;h=g>>>0>=m>>>0;if(!(l>>>0>131|h)){g=l;j=m;m=k;h=n;break a}d=h?m:g;g=l-d|0;d=fd(n,o,d,f)|0;if((d|0)==-1)break;h=(n|0)==(o+8|0);l=h?0:d;j=m-l|0;h=h?n:n+(d<<2)|0;e=d+e|0;k=c[o>>2]|0;if((m|0)!=(l|0)&(k|0)!=0){l=g;m=j;d=k;n=h}else{m=k;d=k;break a}}d=c[o>>2]|0;j=0;m=d;e=-1;h=n}else{g=d;j=e;m=k;d=k;e=0}while(0);b:do if((m|0)!=0?(j|0)!=0&(g|0)!=0:0){l=g;k=m;while(1){g=Be(h,k,l,f)|0;if((g+2|0)>>>0<3)break;k=k+g|0;c[o>>2]=k;j=j+-1|0;e=e+1|0;d=k;if(!((j|0)!=0&(l|0)!=(g|0)))break b;else{l=l-g|0;h=h+4|0}}switch(g|0){case -1:{e=-1;break b}case 0:{c[o>>2]=0;d=0;break b}default:{c[f>>2]=0;break b}}}while(0);if(a|0)c[b>>2]=d;i=p;return e|0}function he(b,c,d,e,f,g,h){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;l=i;m=i=i+63&-64;i=i+352|0;cd(m+256|0,g,h);if(b>>>0>=d>>>0?0<f>>>0|0==(f|0)&(b-d|0)>>>0<e>>>0:0)j=5;else if(d>>>0>=b>>>0?0<f>>>0|0==(f|0)&(d-b|0)>>>0<e>>>0:0)j=5;else k=d;if((j|0)==5){Lj(b|0,d|0,e|0)|0;k=b}h=m+288|0;d=h+32|0;do{a[h>>0]=0;h=h+1|0}while((h|0)<(d|0));h=f>>>0>0|(f|0)==0&e>>>0>32?32:e;d=f>>>0>0|(f|0)==0&e>>>0>32?0:f;if(!((h|0)==0&(d|0)==0)){j=go((f>>>0<0|(f|0)==0&e>>>0<32?e:32)|0,(f>>>0<0|(f|0)==0&e>>>0<32?f:0)|0,-1,0)|0;mh(m+288+32|0,k|0,j+1|0)|0}j=go(h|0,d|0,32,0)|0;Xm(m+288|0,m+288|0,j,D,g+16|0,m+256|0);sq(m,m+288|0);if(!((h|0)==0&(d|0)==0)){j=go((f>>>0<0|(f|0)==0&e>>>0<32?e:32)|0,(f>>>0<0|(f|0)==0&e>>>0<32?f:0)|0,-1,0)|0;mh(b|0,m+288+32|0,j+1|0)|0}_j(m+288|0,64);if(f>>>0>0|(f|0)==0&e>>>0>32){j=Sm(e|0,f|0,h|0,d|0)|0;Od(b+h|0,k+h|0,j,D,g+16|0,1,0,m+256|0)}_j(m+256|0,32);ho(m,b,e,f);nq(m,c);_j(m,256);i=l;return 0}function ie(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;n=i;m=i=i+63&-64;i=i+592|0;k=0;l=32;g=1;while(1){l=l+-1|0;h=a[b+32+l>>0]|0;j=a[42422+l>>0]|0;g=g&255;k=((h&255)-(j&255)|0)>>>8&g|k&255;if(!l)break;else g=(((j^h)&255)+65535|0)>>>8&g}a:do if(k){h=0;do{g=0;j=0;do{g=a[16+(h<<5)+j>>0]^a[b+j>>0]|g;j=j+1|0}while((j|0)!=32);h=h+1|0;if(!(g<<24>>24)){g=-1;break a}}while(h>>>0<12);if(!(Wc(m+328|0,f)|0)){g=0;h=0;do{g=a[f+h>>0]|g;h=h+1|0}while((h|0)!=32);if(g<<24>>24){Ck(m);Rd(m,b,32,0);Rd(m,f,32,0);Rd(m,c,d,e);lh(m,m+520|0);cc(m+520|0);ld(m+208|0,m+520|0,m+328|0,b+32|0);oh(m+488|0,m+208|0);g=ll(m+488|0,b)|0;g=((m+488|0)==(b|0)?-1:g)|(Vi(b,m+488|0)|0)}else g=-1}else g=-1}else g=-1;while(0);i=n;return g|0}function je(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;l=i;k=i=i+63&-64;i=i+48|0;h=c[a+28>>2]|0;c[k+32>>2]=h;h=(c[a+20>>2]|0)-h|0;c[k+32+4>>2]=h;c[k+32+8>>2]=b;c[k+32+12>>2]=d;j=k+32|0;f=2;b=h+d|0;while(1){if(!(c[12576]|0)){c[k+16>>2]=c[a+60>>2];c[k+16+4>>2]=j;c[k+16+8>>2]=f;g=Ip(Ab(146,k+16|0)|0)|0}else{vb(124,a|0);c[k>>2]=c[a+60>>2];c[k+4>>2]=j;c[k+8>>2]=f;g=Ip(Ab(146,k|0)|0)|0;Na(0)}if((b|0)==(g|0)){b=6;break}if((g|0)<0){b=8;break}b=b-g|0;e=c[j+4>>2]|0;if(g>>>0<=e>>>0)if((f|0)==2){c[a+28>>2]=(c[a+28>>2]|0)+g;h=e;e=j;f=2}else{h=e;e=j}else{h=c[a+44>>2]|0;c[a+28>>2]=h;c[a+20>>2]=h;h=c[j+12>>2]|0;g=g-e|0;e=j+8|0;f=f+-1|0}c[e>>2]=(c[e>>2]|0)+g;c[e+4>>2]=h-g;j=e}if((b|0)==6){k=c[a+44>>2]|0;c[a+16>>2]=k+(c[a+48>>2]|0);c[a+28>>2]=k;c[a+20>>2]=k}else if((b|0)==8){c[a+16>>2]=0;c[a+28>>2]=0;c[a+20>>2]=0;c[a>>2]=c[a>>2]|32;if((f|0)==2)d=0;else d=d-(c[j+4>>2]|0)|0}i=l;return d|0}function ke(a,b,e,f,g,h,j,k){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;m=i=i+63&-64;i=i+64|0;if(!((e|0)==0&(f|0)==0)){c[m>>2]=1634760805;c[m+4>>2]=857760878;c[m+8>>2]=2036477234;c[m+12>>2]=1797285236;c[m+16>>2]=d[k>>0]|d[k+1>>0]<<8|d[k+2>>0]<<16|d[k+3>>0]<<24;c[m+20>>2]=d[k+4>>0]|d[k+4+1>>0]<<8|d[k+4+2>>0]<<16|d[k+4+3>>0]<<24;c[m+24>>2]=d[k+8>>0]|d[k+8+1>>0]<<8|d[k+8+2>>0]<<16|d[k+8+3>>0]<<24;c[m+28>>2]=d[k+12>>0]|d[k+12+1>>0]<<8|d[k+12+2>>0]<<16|d[k+12+3>>0]<<24;c[m+32>>2]=d[k+16>>0]|d[k+16+1>>0]<<8|d[k+16+2>>0]<<16|d[k+16+3>>0]<<24;c[m+36>>2]=d[k+20>>0]|d[k+20+1>>0]<<8|d[k+20+2>>0]<<16|d[k+20+3>>0]<<24;c[m+40>>2]=d[k+24>>0]|d[k+24+1>>0]<<8|d[k+24+2>>0]<<16|d[k+24+3>>0]<<24;c[m+44>>2]=d[k+28>>0]|d[k+28+1>>0]<<8|d[k+28+2>>0]<<16|d[k+28+3>>0]<<24;c[m+48>>2]=h;c[m+52>>2]=j;c[m+56>>2]=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;c[m+60>>2]=d[g+4>>0]|d[g+4+1>>0]<<8|d[g+4+2>>0]<<16|d[g+4+3>>0]<<24;mc(m,b,a,e,f);_j(m,64)}i=l;return}function le(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;f=i;d=i=i+63&-64;i=i+16|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[d+(e<<2)>>2]=0;e=e+1|0}g=a[h+11>>0]|0;e=g<<24>>24<0?c[h>>2]|0:h;g=e+(g<<24>>24<0?c[h+4>>2]|0:g&255)|0;while(1){if(e>>>0>=g>>>0){g=9;break}o=0;da(61,d|0,a[e>>0]|0);h=o;o=0;if(h&1){g=8;break}e=e+1|0}do if((g|0)==8)e=Ya()|0;else if((g|0)==9){e=(a[d+11>>0]|0)<0?c[d>>2]|0:d;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;g=0;while(1){if((g|0)==3)break;c[b+(g<<2)>>2]=0;g=g+1|0}e=et(e)|0;g=e+(Zg(e)|0)|0;while(1){if(e>>>0>=g>>>0){g=17;break}o=0;da(61,b|0,a[e>>0]|0);h=o;o=0;if(h&1){g=16;break}e=e+1|0}if((g|0)==16){e=Ya()|0;Oo(b);break}else if((g|0)==17){Oo(d);i=f;return}}while(0);Oo(d);Ra(e|0)}function me(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+64|0;if(!((b|0)==0&(e|0)==0)){c[j>>2]=1634760805;c[j+4>>2]=857760878;c[j+8>>2]=2036477234;c[j+12>>2]=1797285236;c[j+16>>2]=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;c[j+20>>2]=d[g+4>>0]|d[g+4+1>>0]<<8|d[g+4+2>>0]<<16|d[g+4+3>>0]<<24;c[j+24>>2]=d[g+8>>0]|d[g+8+1>>0]<<8|d[g+8+2>>0]<<16|d[g+8+3>>0]<<24;c[j+28>>2]=d[g+12>>0]|d[g+12+1>>0]<<8|d[g+12+2>>0]<<16|d[g+12+3>>0]<<24;c[j+32>>2]=d[g+16>>0]|d[g+16+1>>0]<<8|d[g+16+2>>0]<<16|d[g+16+3>>0]<<24;c[j+36>>2]=d[g+20>>0]|d[g+20+1>>0]<<8|d[g+20+2>>0]<<16|d[g+20+3>>0]<<24;c[j+40>>2]=d[g+24>>0]|d[g+24+1>>0]<<8|d[g+24+2>>0]<<16|d[g+24+3>>0]<<24;c[j+44>>2]=d[g+28>>0]|d[g+28+1>>0]<<8|d[g+28+2>>0]<<16|d[g+28+3>>0]<<24;c[j+48>>2]=0;c[j+52>>2]=0;c[j+56>>2]=d[f>>0]|d[f+1>>0]<<8|d[f+2>>0]<<16|d[f+3>>0]<<24;c[j+60>>2]=d[f+4>>0]|d[f+4+1>>0]<<8|d[f+4+2>>0]<<16|d[f+4+3>>0]<<24;ei(a|0,0,b|0)|0;mc(j,a,a,b,e);_j(j,64)}i=h;return}function ne(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;if(e<<24>>24?(e&255)<=64:0){if((c[b+80>>2]|0)==0?(c[b+80+4>>2]|0)==0:0){f=c[b+352>>2]|0;do if(f>>>0>128){f=c[b+64>>2]|0;i=c[b+64+4>>2]|0;j=go(f|0,i|0,128,0)|0;c[b+64>>2]=j;c[b+64+4>>2]=D;f=go((i>>>0>4294967295|(i|0)==-1&f>>>0>4294967167)&1|0,0,c[b+72>>2]|0,c[b+72+4>>2]|0)|0;c[b+72>>2]=f;c[b+72+4>>2]=D;Zb(b,b+96|0);f=(c[b+352>>2]|0)+-128|0;c[b+352>>2]=f;if(f>>>0<129){mh(b+96|0,b+224|0,f|0)|0;g=b+72|0;h=c[b+352>>2]|0;break}else Wa(42e3,42032,343,42076)}else{g=b+72|0;h=f}while(0);j=go(c[b+64>>2]|0,c[b+64+4>>2]|0,h|0,0)|0;f=D;c[b+64>>2]=j;c[b+64+4>>2]=f;i=g;i=go((f>>>0<0|(f|0)==0&j>>>0<h>>>0)&1|0,0,c[i>>2]|0,c[i+4>>2]|0)|0;j=g;c[j>>2]=i;c[j+4>>2]=D;if(a[b+356>>0]|0){c[b+88>>2]=-1;c[b+88+4>>2]=-1}c[b+80>>2]=-1;c[b+80+4>>2]=-1;ei(b+96+h|0,0,256-h|0)|0;Zb(b,b+96|0);mh(d|0,b|0,e&255|0)|0;f=0}else f=-1;return f|0}Ta();return 0}function oe(b){b=b|0;var d=0;if((a[49728]|0)==0?Jp(49728)|0:0){if((a[49736]|0)==0?Jp(49736)|0:0){b=52800;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[b+(d<<2)>>2]=0;d=d+1|0}b=b+12|0}while((b|0)!=52968);rb(136,0,n|0)|0}ym(52800,38872);ym(52812,38900);ym(52824,38928);ym(52836,38960);ym(52848,39e3);ym(52860,39036);ym(52872,39064);ym(52884,39100);ym(52896,39116);ym(52908,39132);ym(52920,39148);ym(52932,39164);ym(52944,39180);ym(52956,39196);c[13242]=52800}return c[13242]|0}function pe(b){b=b|0;var d=0;if((a[49648]|0)==0?Jp(49648)|0:0){if((a[49656]|0)==0?Jp(49656)|0:0){b=51988;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[b+(d<<2)>>2]=0;d=d+1|0}b=b+12|0}while((b|0)!=52156);rb(132,0,n|0)|0}zm(51988,47309);zm(52e3,47316);zm(52012,47323);zm(52024,47331);zm(52036,47341);zm(52048,47350);zm(52060,47357);zm(52072,47366);zm(52084,47370);zm(52096,47374);zm(52108,47378);zm(52120,47382);zm(52132,47386);zm(52144,47390);c[13039]=51988}return c[13039]|0}function qe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;l=c[b+4>>2]|0;k=c[b+8>>2]|0;j=c[b+12>>2]|0;i=c[b+16>>2]|0;h=c[b+20>>2]|0;g=c[b+24>>2]|0;f=c[b+28>>2]|0;e=c[b+32>>2]|0;d=c[b+36>>2]|0;c[a>>2]=c[b>>2];c[a+4>>2]=l;c[a+8>>2]=k;c[a+12>>2]=j;c[a+16>>2]=i;c[a+20>>2]=h;c[a+24>>2]=g;c[a+28>>2]=f;c[a+32>>2]=e;c[a+36>>2]=d;d=c[b+44>>2]|0;e=c[b+48>>2]|0;f=c[b+52>>2]|0;g=c[b+56>>2]|0;h=c[b+60>>2]|0;i=c[b+64>>2]|0;j=c[b+68>>2]|0;k=c[b+72>>2]|0;l=c[b+76>>2]|0;c[a+40>>2]=c[b+40>>2];c[a+44>>2]=d;c[a+48>>2]=e;c[a+52>>2]=f;c[a+56>>2]=g;c[a+60>>2]=h;c[a+64>>2]=i;c[a+68>>2]=j;c[a+72>>2]=k;c[a+76>>2]=l;l=c[b+84>>2]|0;k=c[b+88>>2]|0;j=c[b+92>>2]|0;i=c[b+96>>2]|0;h=c[b+100>>2]|0;g=c[b+104>>2]|0;f=c[b+108>>2]|0;e=c[b+112>>2]|0;d=c[b+116>>2]|0;c[a+80>>2]=c[b+80>>2];c[a+84>>2]=l;c[a+88>>2]=k;c[a+92>>2]=j;c[a+96>>2]=i;c[a+100>>2]=h;c[a+104>>2]=g;c[a+108>>2]=f;c[a+112>>2]=e;c[a+116>>2]=d;return}function re(a){a=a|0;Ao(53540);Ao(53528);Ao(53516);Ao(53504);Ao(53492);Ao(53480);Ao(53468);Ao(53456);Ao(53444);Ao(53432);Ao(53420);Ao(53408);Ao(53396);Ao(53384);Ao(53372);Ao(53360);Ao(53348);Ao(53336);Ao(53324);Ao(53312);Ao(53300);Ao(53288);Ao(53276);Ao(53264);return}function se(a){a=a|0;Oo(52728);Oo(52716);Oo(52704);Oo(52692);Oo(52680);Oo(52668);Oo(52656);Oo(52644);Oo(52632);Oo(52620);Oo(52608);Oo(52596);Oo(52584);Oo(52572);Oo(52560);Oo(52548);Oo(52536);Oo(52524);Oo(52512);Oo(52500);Oo(52488);Oo(52476);Oo(52464);Oo(52452);return}function te(a){a=a|0;Ao(53248);Ao(53236);Ao(53224);Ao(53212);Ao(53200);Ao(53188);Ao(53176);Ao(53164);Ao(53152);Ao(53140);Ao(53128);Ao(53116);Ao(53104);Ao(53092);Ao(53080);Ao(53068);Ao(53056);Ao(53044);Ao(53032);Ao(53020);Ao(53008);Ao(52996);Ao(52984);Ao(52972);return}function ue(a){a=a|0;Oo(52436);Oo(52424);Oo(52412);Oo(52400);Oo(52388);Oo(52376);Oo(52364);Oo(52352);Oo(52340);Oo(52328);Oo(52316);Oo(52304);Oo(52292);Oo(52280);Oo(52268);Oo(52256);Oo(52244);Oo(52232);Oo(52220);Oo(52208);Oo(52196);Oo(52184);Oo(52172);Oo(52160);return}function ve(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;x=c[a>>2]|0;v=c[a+4>>2]|0;t=c[a+8>>2]|0;r=c[a+12>>2]|0;p=c[a+16>>2]|0;n=c[a+20>>2]|0;l=c[a+24>>2]|0;j=c[a+28>>2]|0;h=c[a+32>>2]|0;f=c[a+36>>2]|0;w=c[b>>2]|0;u=c[b+4>>2]|0;s=c[b+8>>2]|0;q=c[b+12>>2]|0;o=c[b+16>>2]|0;m=c[b+20>>2]|0;k=c[b+24>>2]|0;i=c[b+28>>2]|0;g=c[b+32>>2]|0;e=c[b+36>>2]|0;c[a>>2]=(w^x)&0-d^x;c[a+4>>2]=(u^v)&0-d^v;c[a+8>>2]=(s^t)&0-d^t;c[a+12>>2]=(q^r)&0-d^r;c[a+16>>2]=(o^p)&0-d^p;c[a+20>>2]=(m^n)&0-d^n;c[a+24>>2]=(k^l)&0-d^l;c[a+28>>2]=(i^j)&0-d^j;c[a+32>>2]=(g^h)&0-d^h;c[a+36>>2]=(e^f)&0-d^f;c[b>>2]=(w^x)&0-d^w;c[b+4>>2]=(u^v)&0-d^u;c[b+8>>2]=(s^t)&0-d^s;c[b+12>>2]=(q^r)&0-d^q;c[b+16>>2]=(o^p)&0-d^o;c[b+20>>2]=(m^n)&0-d^m;c[b+24>>2]=(k^l)&0-d^k;c[b+28>>2]=(i^j)&0-d^i;c[b+32>>2]=(g^h)&0-d^g;c[b+36>>2]=(e^f)&0-d^e;return}function we(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;k=i=i+63&-64;i=i+96|0;c[k>>2]=(d[h>>0]|d[h+1>>0]<<8|d[h+2>>0]<<16|d[h+3>>0]<<24)&67108863;c[k+4>>2]=(d[h+3>>0]|d[h+3+1>>0]<<8|d[h+3+2>>0]<<16|d[h+3+3>>0]<<24)>>>2&67108611;c[k+8>>2]=(d[h+6>>0]|d[h+6+1>>0]<<8|d[h+6+2>>0]<<16|d[h+6+3>>0]<<24)>>>4&67092735;c[k+12>>2]=(d[h+9>>0]|d[h+9+1>>0]<<8|d[h+9+2>>0]<<16|d[h+9+3>>0]<<24)>>>6&66076671;c[k+16>>2]=(d[h+12>>0]|d[h+12+1>>0]<<8|d[h+12+2>>0]<<16|d[h+12+3>>0]<<24)>>>8&1048575;c[k+20>>2]=0;c[k+20+4>>2]=0;c[k+20+8>>2]=0;c[k+20+12>>2]=0;c[k+20+16>>2]=0;c[k+40>>2]=d[h+16>>0]|d[h+16+1>>0]<<8|d[h+16+2>>0]<<16|d[h+16+3>>0]<<24;c[k+44>>2]=d[h+20>>0]|d[h+20+1>>0]<<8|d[h+20+2>>0]<<16|d[h+20+3>>0]<<24;c[k+48>>2]=d[h+24>>0]|d[h+24+1>>0]<<8|d[h+24+2>>0]<<16|d[h+24+3>>0]<<24;c[k+52>>2]=d[h+28>>0]|d[h+28+1>>0]<<8|d[h+28+2>>0]<<16|d[h+28+3>>0]<<24;c[k+56>>2]=0;c[k+56+4>>2]=0;a[k+80>>0]=0;be(k,e,f,g);Ud(k,b);i=j;return}function xe(b){b=b|0;var d=0,e=0,f=0,g=0;f=i;e=i=i+63&-64;i=i+16|0;a:do if(c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0){o=0;da(58,e|0,b|0);d=o;o=0;b:do if(d&1)d=Za(0)|0;else{do if(a[e>>0]|0){d=c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0;o=0;d=ha(c[(c[d>>2]|0)+24>>2]|0,d|0)|0;g=o;o=0;if(!(g&1)){if((d|0)!=-1)break;g=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;o=0;da(57,g|0,c[g+16>>2]|1|0);g=o;o=0;if(!(g&1))break}d=Za(0)|0;wf(e);break b}while(0);wf(e);break a}while(0);jb(d|0)|0;o=0;ba(127,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);g=o;o=0;if(!(g&1)){fb();break}d=Ya()|0;o=0;Fa(19);g=o;o=0;if(g&1){g=Za(0)|0;xr(g)}else Ra(d|0)}while(0);i=f;return}function ye(b){b=b|0;var d=0,e=0,f=0,g=0;f=i;e=i=i+63&-64;i=i+16|0;a:do if(c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0){o=0;da(56,e|0,b|0);d=o;o=0;b:do if(d&1)d=Za(0)|0;else{do if(a[e>>0]|0){d=c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0;o=0;d=ha(c[(c[d>>2]|0)+24>>2]|0,d|0)|0;g=o;o=0;if(!(g&1)){if((d|0)!=-1)break;g=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;o=0;da(57,g|0,c[g+16>>2]|1|0);g=o;o=0;if(!(g&1))break}d=Za(0)|0;wf(e);break b}while(0);wf(e);break a}while(0);jb(d|0)|0;o=0;ba(127,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);g=o;o=0;if(!(g&1)){fb();break}d=Ya()|0;o=0;Fa(19);g=o;o=0;if(g&1){g=Za(0)|0;xr(g)}else Ra(d|0)}while(0);i=f;return}function ze(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;k=i;j=i=i+63&-64;i=i+96|0;cd(j,f,g);_f(j+32|0,f+16|0,j);if(!(gn(c,b,d,e,j+32|0)|0))if(!a)g=0;else{if(b>>>0>=a>>>0?0<e>>>0|0==(e|0)&(b-a|0)>>>0<d>>>0:0)h=8;else if(a>>>0>=b>>>0?0<e>>>0|0==(e|0)&(a-b|0)>>>0<d>>>0:0)h=8;if((h|0)==8){Lj(a|0,b|0,d|0)|0;b=a}g=e>>>0>0|(e|0)==0&d>>>0>32?32:d;c=e>>>0>0|(e|0)==0&d>>>0>32?0:e;if((g|0)==0&(c|0)==0)Xm(j+32|0,j+32|0,32,0,f+16|0,j);else{h=go((e>>>0<0|(e|0)==0&d>>>0<32?d:32)|0,(e>>>0<0|(e|0)==0&d>>>0<32?e:0)|0,-1,0)|0;mh(j+32+32|0,b|0,h+1|0)|0;l=go(g|0,c|0,32,0)|0;Xm(j+32|0,j+32|0,l,D,f+16|0,j);mh(a|0,j+32+32|0,h+1|0)|0}if(e>>>0>0|(e|0)==0&d>>>0>32){l=Sm(d|0,e|0,g|0,c|0)|0;Od(a+g|0,b+g|0,l,D,f+16|0,1,0,j)}_j(j,32);g=0}else{_j(j,32);g=-1}i=k;return g|0}function Ae(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;n=i;m=i=i+63&-64;i=i+272|0;j=c[b>>2]|0;c[m>>2]=j;e=a|0?e:256;g=a|0?a:m+8|0;a:do if((e|0)!=0&(j|0)!=0){k=d;l=e;d=j;e=0;while(1){f=k>>>0>=l>>>0;if(!(f|k>>>0>32)){f=k;h=l;l=j;break a}d=f?l:k;f=k-d|0;d=Zd(g,m,d)|0;if((d|0)==-1)break;j=(g|0)==(m+8|0);k=j?0:d;h=l-k|0;g=j?g:g+d|0;e=d+e|0;j=c[m>>2]|0;if((l|0)!=(k|0)&(j|0)!=0){k=f;l=h;d=j}else{l=j;d=j;break a}}d=c[m>>2]|0;h=0;l=d;e=-1}else{f=d;h=e;l=j;d=j;e=0}while(0);b:do if((l|0)!=0?(h|0)!=0&(f|0)!=0:0){k=f;j=l;while(1){f=pg(g,c[j>>2]|0)|0;if((f+1|0)>>>0<2)break;j=j+4|0;c[m>>2]=j;k=k+-1|0;e=e+1|0;d=j;if(!((h|0)!=(f|0)&(k|0)!=0))break b;else{h=h-f|0;g=g+f|0}}if(!f){c[m>>2]=0;d=0}else e=-1}while(0);if(a|0)c[b>>2]=d;i=n;return e|0}function Be(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;l=i;g=i=i+63&-64;i=i+16|0;j=(f|0)==0?50352:f;f=c[j>>2]|0;a:do if(!d)if(!f)f=0;else k=15;else{h=(b|0)==0?g:b;if(!e)f=-2;else{if(!f){f=a[d>>0]|0;if(f<<24>>24>-1){c[h>>2]=f&255;f=f<<24>>24!=0&1;break}if(((f&255)+-194|0)>>>0>50){k=15;break}f=c[33840+((f&255)+-194<<2)>>2]|0;if(e+-1|0){g=e+-1|0;d=d+1|0;k=9}}else{g=e;k=9}b:do if((k|0)==9){b=a[d>>0]|0;if((((b&255)>>>3)+-16|((b&255)>>>3)+(f>>26))>>>0>7){k=15;break a}while(1){d=d+1|0;f=(b&255)+-128|f<<6;g=g+-1|0;if((f|0)>=0)break;if(!g)break b;b=a[d>>0]|0;if((b&-64)<<24>>24!=-128){k=15;break a}}c[j>>2]=0;c[h>>2]=f;f=e-g|0;break a}while(0);c[j>>2]=f;f=-2}}while(0);if((k|0)==15){c[j>>2]=0;c[(gp()|0)>>2]=84;f=-1}i=l;return f|0}function Ce(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;h=a[b+11>>0]|0;if(h<<24>>24<0){k=c[b+4>>2]|0;d=(c[b+8>>2]&2147483647)+-1|0}else{k=h&255;d=10}if(k>>>0<11)l=10;else l=(k+16&-16)+-1|0;a:do if((l|0)!=(d|0)){do if((l|0)==10){e=c[b>>2]|0;if(h<<24>>24<0){d=b;f=0;j=16}else{d=b;f=0;g=1;j=17}}else{e=l+1|0;if(l>>>0<=d>>>0){o=0;d=ha(85,e|0)|0;j=o;o=0;if(j&1){b=Za(0)|0;jb(b|0)|0;fb();break a}}else d=Wi(e)|0;if(h<<24>>24<0){f=1;e=c[b>>2]|0;j=16;break}else{f=1;e=b;g=0;j=17;break}}while(0);if((j|0)==16){i=c[b+4>>2]|0;h=e;g=1}else if((j|0)==17){i=h&255;h=e}e=i+1|0;if(e|0)mh(d|0,h|0,e|0)|0;if(g)Zs(h);if(f){c[b+8>>2]=l+1|-2147483648;c[b+4>>2]=k;c[b>>2]=d;break}else{a[b+11>>0]=k;break}}while(0);return}function De(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;l=i;k=i=i+63&-64;i=i+16|0;a:do if(!b)b=0;else{j=c[g+12>>2]|0;j=(j|0)>(f-d>>2|0)?j-(f-d>>2)|0:0;if((e-d|0)>0?(Kb[c[(c[b>>2]|0)+48>>2]&63](b,d,e-d>>2)|0)!=(e-d>>2|0):0){b=0;break}do if((j|0)>0){c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Og(k,j,h);o=0;h=la(c[(c[b>>2]|0)+48>>2]|0,b|0,((a[k+8+3>>0]|0)<0?c[k>>2]|0:k)|0,j|0)|0;d=o;o=0;if(!(d&1)){Ao(k);if((h|0)==(j|0))break;else{b=0;break a}}else{l=Ya()|0;Ao(k);Ra(l|0)}}while(0);if((f-e|0)>0?(Kb[c[(c[b>>2]|0)+48>>2]&63](b,e,f-e>>2)|0)!=(f-e>>2|0):0){b=0;break}c[g+12>>2]=0}while(0);i=l;return b|0}function Ee(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;do if((b|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)==(e|0)?(c[d+28>>2]|0)!=1:0)c[d+28>>2]=f}else{if((b|0)!=(c[d>>2]|0)){b=c[b+8>>2]|0;Db[c[(c[b>>2]|0)+24>>2]&31](b,d,e,f,g);break}if((c[d+16>>2]|0)!=(e|0)?(c[d+20>>2]|0)!=(e|0):0){c[d+32>>2]=f;if((c[d+44>>2]|0)==4)break;a[d+52>>0]=0;a[d+53>>0]=0;b=c[b+8>>2]|0;Mb[c[(c[b>>2]|0)+20>>2]&31](b,d,e,e,1,g);if(a[d+53>>0]|0)if(!(a[d+52>>0]|0)){f=1;b=13}else b=17;else{f=0;b=13}do if((b|0)==13){c[d+20>>2]=e;c[d+40>>2]=(c[d+40>>2]|0)+1;if((c[d+36>>2]|0)==1?(c[d+24>>2]|0)==2:0){a[d+54>>0]=1;if(f){b=17;break}else{f=4;break}}if(f)b=17;else f=4}while(0);if((b|0)==17)f=3;c[d+44>>2]=f;break}if((f|0)==1)c[d+32>>2]=1}while(0);return}function Fe(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;l=i;k=i=i+63&-64;i=i+16|0;a:do if(!b)b=0;else{j=c[g+12>>2]|0;j=(j|0)>(f-d|0)?j-(f-d)|0:0;if((e-d|0)>0?(Kb[c[(c[b>>2]|0)+48>>2]&63](b,d,e-d|0)|0)!=(e-d|0):0){b=0;break}do if((j|0)>0){c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;xh(k,j,h);o=0;h=la(c[(c[b>>2]|0)+48>>2]|0,b|0,((a[k+11>>0]|0)<0?c[k>>2]|0:k)|0,j|0)|0;d=o;o=0;if(!(d&1)){Oo(k);if((h|0)==(j|0))break;else{b=0;break a}}else{l=Ya()|0;Oo(k);Ra(l|0)}}while(0);if((f-e|0)>0?(Kb[c[(c[b>>2]|0)+48>>2]&63](b,e,f-e|0)|0)!=(f-e|0):0){b=0;break}c[g+12>>2]=0}while(0);i=l;return b|0}function Ge(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;k=i;l=i=i+63&-64;i=i+176|0;a[l+168>>0]=a[47043]|0;a[l+168+1>>0]=a[47044]|0;a[l+168+2>>0]=a[47045]|0;a[l+168+3>>0]=a[47046]|0;a[l+168+4>>0]=a[47047]|0;a[l+168+5>>0]=a[47048]|0;b=To()|0;c[l>>2]=g;b=ij(l+148|0,20,b,l+168|0,l)|0;g=Tg(l+148|0,l+148+b|0,c[e+4>>2]|0)|0;h=Ll(e)|0;o=0;j=va(32,h|0,51948)|0;m=o;o=0;if(m&1){m=Ya()|0;Vl(h);Ra(m|0)}else{Vl(h);Sb[c[(c[j>>2]|0)+48>>2]&31](j,l+148|0,l+148+b|0,l)|0;m=De(c[d>>2]|0,l,(g|0)==(l+148+b|0)?l+(b<<2)|0:l+(g-(l+148)<<2)|0,l+(b<<2)|0,e,f)|0;i=k;return m|0}return 0}function He(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;j=i=i+63&-64;i=i+128|0;a[j+118>>0]=a[47030]|0;a[j+118+1>>0]=a[47031]|0;a[j+118+2>>0]=a[47032]|0;a[j+118+3>>0]=a[47033]|0;a[j+118+4>>0]=a[47034]|0;a[j+118+5>>0]=a[47035]|0;ng(j+118+1|0,47036,1,c[e+4>>2]|0);k=To()|0;c[j>>2]=g;g=j+104+(ij(j+104|0,13,k,j+118|0,j)|0)|0;k=Tg(j+104|0,g,c[e+4>>2]|0)|0;b=Ll(e)|0;c[j+96>>2]=b;o=0;ra(20,j+104|0,k|0,g|0,j|0,j+100|0,j+92|0,j+96|0);g=o;o=0;if(g&1){k=Ya()|0;Vl(b);Ra(k|0)}else{Vl(b);k=De(c[d>>2]|0,j,c[j+100>>2]|0,c[j+92>>2]|0,e,f)|0;i=h;return k|0}return 0}function Ie(b,e){b=b|0;e=e|0;c[b>>2]=(d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24)&67108863;c[b+4>>2]=(d[e+3>>0]|d[e+3+1>>0]<<8|d[e+3+2>>0]<<16|d[e+3+3>>0]<<24)>>>2&67108611;c[b+8>>2]=(d[e+6>>0]|d[e+6+1>>0]<<8|d[e+6+2>>0]<<16|d[e+6+3>>0]<<24)>>>4&67092735;c[b+12>>2]=(d[e+9>>0]|d[e+9+1>>0]<<8|d[e+9+2>>0]<<16|d[e+9+3>>0]<<24)>>>6&66076671;c[b+16>>2]=(d[e+12>>0]|d[e+12+1>>0]<<8|d[e+12+2>>0]<<16|d[e+12+3>>0]<<24)>>>8&1048575;c[b+20>>2]=0;c[b+20+4>>2]=0;c[b+20+8>>2]=0;c[b+20+12>>2]=0;c[b+20+16>>2]=0;c[b+40>>2]=d[e+16>>0]|d[e+16+1>>0]<<8|d[e+16+2>>0]<<16|d[e+16+3>>0]<<24;c[b+44>>2]=d[e+20>>0]|d[e+20+1>>0]<<8|d[e+20+2>>0]<<16|d[e+20+3>>0]<<24;c[b+48>>2]=d[e+24>>0]|d[e+24+1>>0]<<8|d[e+24+2>>0]<<16|d[e+24+3>>0]<<24;c[b+52>>2]=d[e+28>>0]|d[e+28+1>>0]<<8|d[e+28+2>>0]<<16|d[e+28+3>>0]<<24;c[b+56>>2]=0;c[b+56+4>>2]=0;a[b+80>>0]=0;return}function Je(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;j=i=i+63&-64;i=i+128|0;a[j+108>>0]=a[47030]|0;a[j+108+1>>0]=a[47031]|0;a[j+108+2>>0]=a[47032]|0;a[j+108+3>>0]=a[47033]|0;a[j+108+4>>0]=a[47034]|0;a[j+108+5>>0]=a[47035]|0;ng(j+108+1|0,47036,0,c[e+4>>2]|0);k=To()|0;c[j>>2]=g;g=j+96+(ij(j+96|0,12,k,j+108|0,j)|0)|0;k=Tg(j+96|0,g,c[e+4>>2]|0)|0;b=Ll(e)|0;c[j+88>>2]=b;o=0;ra(20,j+96|0,k|0,g|0,j|0,j+92|0,j+84|0,j+88|0);g=o;o=0;if(g&1){k=Ya()|0;Vl(b);Ra(k|0)}else{Vl(b);k=De(c[d>>2]|0,j,c[j+92>>2]|0,c[j+84>>2]|0,e,f)|0;i=h;return k|0}return 0}function Ke(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;j=i=i+63&-64;i=i+64|0;a[j+48>>0]=a[47030]|0;a[j+48+1>>0]=a[47031]|0;a[j+48+2>>0]=a[47032]|0;a[j+48+3>>0]=a[47033]|0;a[j+48+4>>0]=a[47034]|0;a[j+48+5>>0]=a[47035]|0;ng(j+48+1|0,47036,0,c[e+4>>2]|0);k=To()|0;c[j>>2]=g;g=j+36+(ij(j+36|0,12,k,j+48|0,j)|0)|0;k=Tg(j+36|0,g,c[e+4>>2]|0)|0;b=Ll(e)|0;c[j+28>>2]=b;o=0;ra(18,j+36|0,k|0,g|0,j|0,j+32|0,j+24|0,j+28|0);g=o;o=0;if(g&1){k=Ya()|0;Vl(b);Ra(k|0)}else{Vl(b);k=Fe(c[d>>2]|0,j,c[j+32>>2]|0,c[j+24>>2]|0,e,f)|0;i=h;return k|0}return 0}function Le(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;j=i=i+63&-64;i=i+64|0;a[j+50>>0]=a[47030]|0;a[j+50+1>>0]=a[47031]|0;a[j+50+2>>0]=a[47032]|0;a[j+50+3>>0]=a[47033]|0;a[j+50+4>>0]=a[47034]|0;a[j+50+5>>0]=a[47035]|0;ng(j+50+1|0,47036,1,c[e+4>>2]|0);k=To()|0;c[j>>2]=g;g=j+36+(ij(j+36|0,13,k,j+50|0,j)|0)|0;k=Tg(j+36|0,g,c[e+4>>2]|0)|0;b=Ll(e)|0;c[j+28>>2]=b;o=0;ra(18,j+36|0,k|0,g|0,j|0,j+32|0,j+24|0,j+28|0);g=o;o=0;if(g&1){k=Ya()|0;Vl(b);Ra(k|0)}else{Vl(b);k=Fe(c[d>>2]|0,j,c[j+32>>2]|0,c[j+24>>2]|0,e,f)|0;i=h;return k|0}return 0}function Me(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;k=i;l=i=i+63&-64;i=i+80|0;a[l+60>>0]=a[47043]|0;a[l+60+1>>0]=a[47044]|0;a[l+60+2>>0]=a[47045]|0;a[l+60+3>>0]=a[47046]|0;a[l+60+4>>0]=a[47047]|0;a[l+60+5>>0]=a[47048]|0;b=To()|0;c[l>>2]=g;b=ij(l+40|0,20,b,l+60|0,l)|0;g=Tg(l+40|0,l+40+b|0,c[e+4>>2]|0)|0;h=Ll(e)|0;o=0;j=va(32,h|0,51916)|0;m=o;o=0;if(m&1){m=Ya()|0;Vl(h);Ra(m|0)}else{Vl(h);Sb[c[(c[j>>2]|0)+32>>2]&31](j,l+40|0,l+40+b|0,l)|0;m=Fe(c[d>>2]|0,l,(g|0)==(l+40+b|0)?l+b|0:l+(g-(l+40))|0,l+b|0,e,f)|0;i=k;return m|0}return 0}function Ne(){var a=0,b=0,d=0,e=0;d=i=i+63&-64;i=i+32|0;o=0;a=za(19)|0;e=o;o=0;if(e&1){e=Za(0)|0;xr(e)}if((a|0?(b=c[a>>2]|0,b|0):0)?((c[b+48>>2]&-256|0)==1126902528?(c[b+48+4>>2]|0)==1129074247:0):0){o=0;Fa(c[b+12>>2]|0);e=o;o=0;if(!(e&1)){o=0;da(68,49399,d|0);o=0}a=Za(0)|0;jb(a|0)|0;o=0;da(68,49439,d+8|0);o=0;a=Za(0)|0;o=0;Fa(19);e=o;o=0;if(e&1){e=Za(0)|0;xr(e)}else xr(a)}e=c[10250]|0;c[10250]=e+0;o=0;Fa(e|0);e=o;o=0;if(!(e&1)){o=0;da(68,49399,d+16|0);o=0}a=Za(0)|0;jb(a|0)|0;o=0;da(68,49439,d+24|0);o=0;a=Za(0)|0;o=0;Fa(19);e=o;o=0;if(e&1){e=Za(0)|0;xr(e)}else xr(a)}function Oe(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;a:do if(!((e|0)==0&(f|0)==0)){g=c[b+352>>2]|0;j=e;while(1){i=256-g|0;e=b+96+g|0;if(!(f>>>0>0|(f|0)==0&j>>>0>i>>>0))break;mh(e|0,d|0,i|0)|0;c[b+352>>2]=(c[b+352>>2]|0)+i;e=c[b+64>>2]|0;g=c[b+64+4>>2]|0;h=go(e|0,g|0,128,0)|0;c[b+64>>2]=h;c[b+64+4>>2]=D;e=go((g>>>0>4294967295|(g|0)==-1&e>>>0>4294967167)&1|0,0,c[b+72>>2]|0,c[b+72+4>>2]|0)|0;c[b+72>>2]=e;c[b+72+4>>2]=D;Zb(b,b+96|0);e=b+96|0;g=b+224|0;h=e+128|0;do{a[e>>0]=a[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));g=(c[b+352>>2]|0)+-128|0;c[b+352>>2]=g;e=Sm(j|0,f|0,i|0,0)|0;if((j|0)==(i|0)&(f|0)==0)break a;else{d=d+i|0;f=D;j=e}}mh(e|0,d|0,j|0)|0;j=go(c[b+352>>2]|0,0,j|0,f|0)|0;c[b+352>>2]=j}while(0);return}function Pe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;j=i;h=i=i+63&-64;i=i+32|0;do if((d|0)!=-1){c[h+8>>2]=d;if(a[b+44>>0]|0)if((Xl(h+8|0,4,1,c[b+32>>2]|0)|0)==1){g=14;break}else{e=-1;break}c[h+4>>2]=h+16;f=h+8|0;while(1){e=c[b+36>>2]|0;e=Vb[c[(c[e>>2]|0)+12>>2]&31](e,c[b+40>>2]|0,f,h+8+4|0,h,h+16|0,h+16+8|0,h+4|0)|0;if((c[h>>2]|0)==(f|0)){g=13;break}if((e|0)==3){g=7;break}if((e|1|0)!=1){g=13;break}g=(c[h+4>>2]|0)-(h+16)|0;if((Xl(h+16|0,1,g,c[b+32>>2]|0)|0)!=(g|0)){g=13;break}if((e|0)==1)f=c[h>>2]|0;else{g=12;break}}if((g|0)==7)if((Xl(f,1,1,c[b+32>>2]|0)|0)==1)g=12;else g=13;if((g|0)==12){g=14;break}else if((g|0)==13){e=-1;break}}else g=14;while(0);if((g|0)==14)e=(d|0)==-1?0:d;i=j;return e|0}function Qe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;j=i;h=i=i+63&-64;i=i+32|0;do if((d|0)!=-1){a[h+8>>0]=d;if(a[b+44>>0]|0)if((Xl(h+8|0,1,1,c[b+32>>2]|0)|0)==1){g=14;break}else{e=-1;break}c[h+4>>2]=h+16;f=h+8|0;while(1){e=c[b+36>>2]|0;e=Vb[c[(c[e>>2]|0)+12>>2]&31](e,c[b+40>>2]|0,f,h+8+1|0,h,h+16|0,h+16+8|0,h+4|0)|0;if((c[h>>2]|0)==(f|0)){g=13;break}if((e|0)==3){g=7;break}if((e|1|0)!=1){g=13;break}g=(c[h+4>>2]|0)-(h+16)|0;if((Xl(h+16|0,1,g,c[b+32>>2]|0)|0)!=(g|0)){g=13;break}if((e|0)==1)f=c[h>>2]|0;else{g=12;break}}if((g|0)==7)if((Xl(f,1,1,c[b+32>>2]|0)|0)==1)g=12;else g=13;if((g|0)==12){g=14;break}else if((g|0)==13){e=-1;break}}else g=14;while(0);if((g|0)==14)e=(d|0)==-1?0:d;i=j;return e|0}function Re(a,b){a=a|0;b=b|0;var d=0;Us(53756)|0;while(1){if((c[a>>2]|0)!=1)break;Pa(53784,53756)|0}do if(!(c[a>>2]|0)){c[a>>2]=1;o=0;ha(82,53756)|0;d=o;o=0;if((((!(d&1)?(o=0,ba(173,b|0),d=o,o=0,!(d&1)):0)?(o=0,ha(83,53756)|0,d=o,o=0,!(d&1)):0)?(c[a>>2]=-1,o=0,ha(82,53756)|0,d=o,o=0,!(d&1)):0)?(o=0,ha(84,53784)|0,d=o,o=0,!(d&1)):0)break;d=Za(0)|0;jb(d|0)|0;o=0;ha(83,53756)|0;d=o;o=0;if((!(d&1)?(c[a>>2]=0,o=0,ha(82,53756)|0,d=o,o=0,!(d&1)):0)?(o=0,ha(84,53784)|0,d=o,o=0,!(d&1)):0){o=0;Fa(21);o=0}b=Ya()|0;o=0;Fa(19);d=o;o=0;if(d&1){d=Za(0)|0;xr(d)}else Ra(b|0)}else Us(53756)|0;while(0);return}function Se(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;g=i;f=i=i+63&-64;i=i+32|0;e=(a[b+52>>0]|0)!=0;a:do if((d|0)==-1)if(e)d=-1;else{d=c[b+48>>2]|0;a[b+52>>0]=(d|0)!=-1&1}else{do if(e){c[f+4>>2]=c[b+48>>2];e=c[b+36>>2]|0;switch(Vb[c[(c[e>>2]|0)+12>>2]&31](e,c[b+40>>2]|0,f+4|0,f+4+4|0,f,f+16|0,f+16+8|0,f+8|0)|0){case 1:case 2:{d=-1;break a}case 3:{a[f+16>>0]=c[b+48>>2];c[f+8>>2]=f+16+1;break}default:{}}while(1){e=c[f+8>>2]|0;if(e>>>0<=(f+16|0)>>>0){f=13;break}c[f+8>>2]=e+-1;if((Ii(a[e+-1>>0]|0,c[b+32>>2]|0)|0)==-1){f=12;break}}if((f|0)==12){d=-1;break a}else if((f|0)==13){e=b+48|0;break}}else e=b+48|0;while(0);c[e>>2]=d;a[b+52>>0]=1}while(0);i=g;return d|0}function Te(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;g=i;f=i=i+63&-64;i=i+32|0;e=(a[b+52>>0]|0)!=0;a:do if((d|0)==-1)if(e)d=-1;else{d=c[b+48>>2]|0;a[b+52>>0]=(d|0)!=-1&1}else{do if(e){a[f+8>>0]=c[b+48>>2];e=c[b+36>>2]|0;switch(Vb[c[(c[e>>2]|0)+12>>2]&31](e,c[b+40>>2]|0,f+8|0,f+8+1|0,f,f+16|0,f+16+8|0,f+4|0)|0){case 1:case 2:{d=-1;break a}case 3:{a[f+16>>0]=c[b+48>>2];c[f+4>>2]=f+16+1;break}default:{}}while(1){e=c[f+4>>2]|0;if(e>>>0<=(f+16|0)>>>0){f=13;break}c[f+4>>2]=e+-1;if((Ii(a[e+-1>>0]|0,c[b+32>>2]|0)|0)==-1){f=12;break}}if((f|0)==12){d=-1;break a}else if((f|0)==13){e=b+48|0;break}}else e=b+48|0;while(0);c[e>>2]=d;a[b+52>>0]=1}while(0);i=g;return d|0}function Ue(b,e,f,g,h,i,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;a:do if(!g){n=0;l=0;m=0;k=0}else{n=0;q=0;l=0;k=0;while(1){p=k<<24>>24==0;while(1){o=d[f+l>>0]|0;m=(((o&223)+201&255)+65526^((o&223)+201&255)+65520)>>>8;if((m|((o^48)+65526|0)>>>8)&255|0)break;if(!((h|0)!=0&p)){m=0;break a}if(!(Gp(h,o)|0)){m=0;k=0;break a}l=l+1|0;if(l>>>0>=g>>>0){m=0;k=0;break a}}m=m&(o&223)+201|((o^48)+65526|0)>>>8&(o^48);if(n>>>0>=e>>>0)break;if(p)m=m<<4&255;else{a[b+n>>0]=m|q&255;n=n+1|0;m=q}k=(k&255^255)&255;l=l+1|0;if(l>>>0<g>>>0)q=m;else{m=0;break a}}c[(gp()|0)>>2]=34;m=-1}while(0);if(j|0)c[j>>2]=f+(((k<<24>>24!=0)<<31>>31)+l);if(i|0)c[i>>2]=n;return m|0}function Ve(d,e,f,g,h,i){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;if((d|0)==(c[e+8>>2]|0))ig(e,f,g,h);else{l=b[e+52>>1]|0;j=c[d+12>>2]|0;a[e+52>>0]=0;a[e+53>>0]=0;ci(d+16|0,e,f,g,h,i);a:do if((j|0)>1){m=d+24|0;do{if(a[e+54>>0]|0)break a;k=b[e+52>>1]|0;if(!((k&255)<<24>>24)){if((k&65535)>=256?(c[d+8>>2]&1|0)==0:0)break a}else{if((c[e+24>>2]|0)==1)break a;if(!(c[d+8>>2]&2))break a}a[e+52>>0]=0;a[e+53>>0]=0;ci(m,e,f,g,h,i);m=m+8|0}while(m>>>0<(d+16+(j<<3)|0)>>>0)}while(0);a[e+52>>0]=l;a[e+53>>0]=(l&65535)>>>8}return}function We(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;k=i;l=i=i+63&-64;i=i+192|0;if((e+-1&255)>63)Ta();if((f|0)!=0&g<<24>>24!=0?(g&255)<=64:0){a[l+128>>0]=e;a[l+128+1>>0]=g;a[l+128+2>>0]=1;a[l+128+3>>0]=1;e=l+128+4|0;j=e+60|0;do{a[e>>0]=0;e=e+1|0}while((e|0)<(j|0));ei(b+64|0,0,293)|0;e=b;h=400;j=e+64|0;do{c[e>>2]=c[h>>2];e=e+4|0;h=h+4|0}while((e|0)<(j|0));e=0;do{m=l+128+(e<<3)|0;j=b+(e<<3)|0;h=c[j+4>>2]^(d[m+4>>0]|d[m+4+1>>0]<<8|d[m+4+2>>0]<<16|d[m+4+3>>0]<<24);c[j>>2]=c[j>>2]^(d[m>>0]|d[m+1>>0]<<8|d[m+2>>0]<<16|d[m+3>>0]<<24);c[j+4>>2]=h;e=e+1|0}while((e|0)!=8);ei(l+(g&255)|0,0,(g<<24>>24<0?0:128-(g&255)|0)|0)|0;mh(l|0,f|0,g&255|0)|0;Oe(b,l,128,0);_j(l,128);i=k;return}Ta()}function Xe(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;j=i;h=i=i+63&-64;i=i+16|0;f=c[d>>2]|0;do if(f|0){g=a[e+11>>0]|0;if(g<<24>>24<0)g=c[e+4>>2]|0;else g=g&255;if(g){An(e);f=c[d>>2]|0}d=c[d+4>>2]|0;Tb[c[(c[d>>2]|0)+24>>2]&31](h,d,f);d=a[h+11>>0]|0;o=0;Da(28,e|0,(d<<24>>24<0?c[h>>2]|0:h)|0,(d<<24>>24<0?c[h+4>>2]|0:d&255)|0);d=o;o=0;if(d&1){j=Ya()|0;Oo(h);Ra(j|0)}else{Oo(h);break}}while(0);c[b>>2]=c[e>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];f=0;while(1){if((f|0)==3)break;c[e+(f<<2)>>2]=0;f=f+1|0}i=j;return}function Ye(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+224|0;c[j>>2]=37;c[j+4>>2]=0;ng(j+1|0,47038,0,c[d+4>>2]|0);a=To()|0;c[j+8>>2]=f;c[j+8+4>>2]=g;g=j+192+(ij(j+192|0,23,a,j,j+8|0)|0)|0;f=Tg(j+192|0,g,c[d+4>>2]|0)|0;a=Ll(d)|0;c[j+184>>2]=a;o=0;ra(20,j+192|0,f|0,g|0,j+8|0,j+188|0,j+180|0,j+184|0);g=o;o=0;if(g&1){b=Ya()|0;Vl(a);Ra(b|0)}else{Vl(a);b=De(c[b>>2]|0,j+8|0,c[j+188>>2]|0,c[j+180>>2]|0,d,e)|0;i=h;return b|0}return 0}function Ze(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+224|0;c[j>>2]=37;c[j+4>>2]=0;ng(j+1|0,47038,1,c[d+4>>2]|0);a=To()|0;c[j+8>>2]=f;c[j+8+4>>2]=g;g=j+192+(ij(j+192|0,23,a,j,j+8|0)|0)|0;f=Tg(j+192|0,g,c[d+4>>2]|0)|0;a=Ll(d)|0;c[j+184>>2]=a;o=0;ra(20,j+192|0,f|0,g|0,j+8|0,j+188|0,j+180|0,j+184|0);g=o;o=0;if(g&1){b=Ya()|0;Vl(a);Ra(b|0)}else{Vl(a);b=De(c[b>>2]|0,j+8|0,c[j+188>>2]|0,c[j+180>>2]|0,d,e)|0;i=h;return b|0}return 0}function _e(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0;n=i;i=i+352|0;qq(n+280|0,l,m);sq(n,n+280|0);_j(n+280|0,64);ho(n,h,j,k);b=Sm(0,0,j|0,k|0)|0;ho(n,53844,b&15,0);ho(n,d,e,f);b=Sm(0,0,e|0,f|0)|0;ho(n,53844,b&15,0);c[n+256>>2]=j;c[n+256+4>>2]=k;ho(n,n+256|0,8,0);c[n+256>>2]=e;c[n+256+4>>2]=f;ho(n,n+256|0,8,0);nq(n,n+264|0);_j(n,256);b=ml(n+264|0,g)|0;_j(n+264|0,16);do if(a)if(!b){Ym(a,d,e,f,l,m);b=0;break}else{ei(a|0,0,e|0)|0;b=-1;break}while(0);i=n;return b|0}function $e(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+96|0;c[j>>2]=37;c[j+4>>2]=0;ng(j+1|0,47038,0,c[d+4>>2]|0);a=To()|0;c[j+8>>2]=f;c[j+8+4>>2]=g;g=j+64+(ij(j+64|0,23,a,j,j+8|0)|0)|0;f=Tg(j+64|0,g,c[d+4>>2]|0)|0;a=Ll(d)|0;c[j+56>>2]=a;o=0;ra(18,j+64|0,f|0,g|0,j+8|0,j+60|0,j+52|0,j+56|0);g=o;o=0;if(g&1){b=Ya()|0;Vl(a);Ra(b|0)}else{Vl(a);b=Fe(c[b>>2]|0,j+8|0,c[j+60>>2]|0,c[j+52>>2]|0,d,e)|0;i=h;return b|0}return 0}function af(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+96|0;c[j>>2]=37;c[j+4>>2]=0;ng(j+1|0,47038,1,c[d+4>>2]|0);a=To()|0;c[j+8>>2]=f;c[j+8+4>>2]=g;g=j+64+(ij(j+64|0,23,a,j,j+8|0)|0)|0;f=Tg(j+64|0,g,c[d+4>>2]|0)|0;a=Ll(d)|0;c[j+56>>2]=a;o=0;ra(18,j+64|0,f|0,g|0,j+8|0,j+60|0,j+52|0,j+56|0);g=o;o=0;if(g&1){b=Ya()|0;Vl(a);Ra(b|0)}else{Vl(a);b=Fe(c[b>>2]|0,j+8|0,c[j+60>>2]|0,c[j+52>>2]|0,d,e)|0;i=h;return b|0}return 0}function bf(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;k=i;g=i=i+63&-64;i=i+16|0;a:do if(!e)b=0;else{do if(f|0){j=(b|0)==0?g:b;b=a[e>>0]|0;if(b<<24>>24>-1){c[j>>2]=b&255;b=b<<24>>24!=0&1;break a}if(((b&255)+-194|0)>>>0<=50){h=c[33840+((b&255)+-194<<2)>>2]|0;if(f>>>0<4?h&-2147483648>>>((f*6|0)+-6|0)|0:0)break;b=d[e+1>>0]|0;if(((b>>>3)+-16|(b>>>3)+(h>>26))>>>0<=7){if((b+-128|h<<6|0)>=0){c[j>>2]=b+-128|h<<6;b=2;break a}g=d[e+2>>0]|0;if((g&192|0)==128){g=g+-128|(b+-128|h<<6)<<6;if((g|0)>=0){c[j>>2]=g;b=3;break a}b=d[e+3>>0]|0;if((b&192|0)==128){c[j>>2]=b+-128|g<<6;b=4;break a}}}}}while(0);c[(gp()|0)>>2]=84;b=-1}while(0);i=k;return b|0}function cf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a:do if((e|0)!=0&(b&3|0)!=0){f=e;while(1){if((a[b>>0]|0)==(d&255)<<24>>24)break a;b=b+1|0;e=f+-1|0;if((e|0)!=0&(b&3|0)!=0)f=e;else{f=e;e=(e|0)!=0;g=5;break}}}else{f=e;e=(e|0)!=0;g=5}while(0);b:do if((g|0)==5)if(e){if((a[b>>0]|0)!=(d&255)<<24>>24){e=S(d&255,16843009)|0;c:do if(f>>>0>3)while(1){h=c[b>>2]^e;if((h&-2139062144^-2139062144)&h+-16843009|0)break;b=b+4|0;f=f+-4|0;if(f>>>0<=3){g=11;break c}}else g=11;while(0);if((g|0)==11)if(!f){f=0;break}while(1){if((a[b>>0]|0)==(d&255)<<24>>24)break b;b=b+1|0;f=f+-1|0;if(!f){f=0;break}}}}else f=0;while(0);return (f|0?b:0)|0}function df(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;k=i;j=i=i+63&-64;i=i+64|0;h=c[d>>2]|0;g=d+(c[h+-8>>2]|0)|0;h=c[h+-4>>2]|0;c[j>>2]=e;c[j+4>>2]=d;c[j+8>>2]=1920;d=j+12|0;f=d+40|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(f|0));b[j+12+40>>1]=0;a[j+12+42>>0]=0;a:do if((h|0)==(e|0)){c[j+48>>2]=1;Mb[c[(c[e>>2]|0)+20>>2]&31](e,j,g,g,1,0);d=(c[j+24>>2]|0)==1?g:0}else{Db[c[(c[h>>2]|0)+24>>2]&31](h,j,g,1,0);switch(c[j+36>>2]|0){case 0:{d=((c[j+40>>2]|0)==1?(c[j+28>>2]|0)==1:0)&(c[j+32>>2]|0)==1?c[j+20>>2]|0:0;break a}case 1:break;default:{d=0;break a}}if((c[j+24>>2]|0)!=1?!(((c[j+40>>2]|0)==0?(c[j+28>>2]|0)==1:0)&(c[j+32>>2]|0)==1):0){d=0;break}d=c[j+16>>2]|0}while(0);i=k;return d|0}function ef(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=i=i+63&-64;i=i+32|0;c[g>>2]=b;c[g+4>>2]=d;c[g+8>>2]=0;c[g+8+4>>2]=0;c[g+8+8>>2]=0;wh(g+8|0,e,Zg(e)|0);o=0;Da(29,g+20|0,g|0,g+8|0);e=o;o=0;do if(!(e&1)){o=0;da(67,a|0,g+20|0);e=o;o=0;if(e&1){b=Ya()|0;Oo(g+20|0);break}else{Oo(g+20|0);Oo(g+8|0);c[a>>2]=40988;e=c[g+4>>2]|0;c[a+8>>2]=c[g>>2];c[a+8+4>>2]=e;i=f;return}}else b=Ya()|0;while(0);Oo(g+8|0);Ra(b|0)}function ff(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;j=i;h=i=i+63&-64;i=i+224|0;f=h+80|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));c[h+120>>2]=c[e>>2];if((ec(0,d,h+120|0,h,h+80|0)|0)<0)e=-1;else{g=c[b>>2]|0;if((a[b+74>>0]|0)<1)c[b>>2]=g&-33;if(!(c[b+48>>2]|0)){f=c[b+44>>2]|0;c[b+44>>2]=h+136;c[b+28>>2]=h+136;c[b+20>>2]=h+136;c[b+48>>2]=80;c[b+16>>2]=h+136+80;e=ec(b,d,h+120|0,h,h+80|0)|0;if(f){Kb[c[b+36>>2]&63](b,0,0)|0;e=(c[b+20>>2]|0)==0?-1:e;c[b+44>>2]=f;c[b+48>>2]=0;c[b+16>>2]=0;c[b+28>>2]=0;c[b+20>>2]=0}}else e=ec(b,d,h+120|0,h,h+80|0)|0;h=c[b>>2]|0;c[b>>2]=h|g&32;e=(h&32|0)==0?e:-1}i=j;return e|0}function gf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;w=c[a>>2]|0;u=c[a+4>>2]|0;s=c[a+8>>2]|0;q=c[a+12>>2]|0;o=c[a+16>>2]|0;m=c[a+20>>2]|0;k=c[a+24>>2]|0;i=c[a+28>>2]|0;g=c[a+32>>2]|0;e=c[a+36>>2]|0;v=(c[b+4>>2]^u)&0-d;t=(c[b+8>>2]^s)&0-d;r=(c[b+12>>2]^q)&0-d;p=(c[b+16>>2]^o)&0-d;n=(c[b+20>>2]^m)&0-d;l=(c[b+24>>2]^k)&0-d;j=(c[b+28>>2]^i)&0-d;h=(c[b+32>>2]^g)&0-d;f=(c[b+36>>2]^e)&0-d;c[a>>2]=(c[b>>2]^w)&0-d^w;c[a+4>>2]=v^u;c[a+8>>2]=t^s;c[a+12>>2]=r^q;c[a+16>>2]=p^o;c[a+20>>2]=n^m;c[a+24>>2]=l^k;c[a+28>>2]=j^i;c[a+32>>2]=h^g;c[a+36>>2]=f^e;return}function hf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;j=i;g=i=i+63&-64;i=i+48|0;c[g+32>>2]=d;h=c[b+48>>2]|0;c[g+32+4>>2]=e-((h|0)!=0&1);c[g+32+8>>2]=c[b+44>>2];c[g+32+12>>2]=h;if(!(c[12576]|0)){c[g+16>>2]=c[b+60>>2];c[g+16+4>>2]=g+32;c[g+16+8>>2]=2;f=Ip(zb(145,g+16|0)|0)|0}else{vb(125,b|0);c[g>>2]=c[b+60>>2];c[g+4>>2]=g+32;c[g+8>>2]=2;f=Ip(zb(145,g|0)|0)|0;Na(0)}if((f|0)>=1){g=c[g+32+4>>2]|0;if(f>>>0>g>>>0){h=c[b+44>>2]|0;c[b+4>>2]=h;c[b+8>>2]=h+(f-g);if(!(c[b+48>>2]|0))f=e;else{c[b+4>>2]=h+1;a[d+(e+-1)>>0]=a[h>>0]|0;f=e}}}else{c[b>>2]=c[b>>2]|f&48^16;c[b+8>>2]=0;c[b+4>>2]=0}i=j;return f|0}function jf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;h=i;g=i=i+63&-64;i=i+32|0;e=c[a+8>>2]|0;d=c[a+4>>2]|0;if(e-d>>2>>>0<b>>>0){f=c[a>>2]|0;if(((d-f>>2)+b|0)>>>0>1073741823)oj();if(e-f>>2>>>0<536870911)e=e-f>>1>>>0<((d-f>>2)+b|0)>>>0?(d-f>>2)+b|0:e-f>>1;else e=1073741823;Fh(g,e,d-f>>2,a+16|0);f=c[g+8>>2]|0;ei(f|0,0,b<<2|0)|0;c[g+8>>2]=f+(b<<2);zg(a,g);Xh(g)}else do{c[d>>2]=0;d=(c[a+4>>2]|0)+4|0;c[a+4>>2]=d;b=b+-1|0}while((b|0)!=0);i=h;return}function kf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;i=a[b+11>>0]|0;g=c[b+4>>2]|0;do if((i<<24>>24<0?g:i&255)|0){if((d|0)!=(e|0)){g=e;h=d;while(1){g=g+-4|0;if(h>>>0>=g>>>0)break;k=c[h>>2]|0;c[h>>2]=c[g>>2];c[g>>2]=k;h=h+4|0}g=c[b+4>>2]|0}k=i<<24>>24<0?c[b>>2]|0:b;h=k+(i<<24>>24<0?g:i&255)|0;i=k;while(1){g=a[i>>0]|0;if(d>>>0>=(e+-4|0)>>>0)break;if(!(g<<24>>24<1|g<<24>>24==127)?(g<<24>>24|0)!=(c[d>>2]|0):0){j=10;break}i=(h-i|0)>1?i+1|0:i;d=d+4|0}if((j|0)==10){c[f>>2]=4;break}if(!(g<<24>>24<1|g<<24>>24==127)?((c[e+-4>>2]|0)+-1|0)>>>0>=g<<24>>24>>>0:0)c[f>>2]=4}while(0);return}function lf(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;if(d&2048){a[b>>0]=43;b=b+1|0}if(d&1024){a[b>>0]=35;b=b+1|0}if((d&260|0)==260)f=0;else{a[b>>0]=46;a[b+1>>0]=42;b=b+2|0;f=1}while(1){e=a[c>>0]|0;if(!(e<<24>>24))break;a[b>>0]=e;c=c+1|0;b=b+1|0}a:do switch(d&260|0){case 4:if(!(d>>>14&1)){a[b>>0]=102;break a}else{a[b>>0]=70;break a}case 256:if(!(d>>>14&1)){a[b>>0]=101;break a}else{a[b>>0]=69;break a}default:if((d&260|0)==260)if(d>>>14&1|0){a[b>>0]=65;break a}else{a[b>>0]=97;break a}else if(d>>>14&1|0){a[b>>0]=71;break a}else{a[b>>0]=103;break a}}while(0);return f|0}function mf(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=i=i+63&-64;i=i+560|0;Ah(l+496|0,j,32,0);a[l+496>>0]=(d[l+496>>0]|0)&248;a[l+496+31>>0]=(d[l+496+31>>0]|0)&63|64;Ck(l);Rd(l,l+496+32|0,32,0);Rd(l,f,g,h);lh(l,l+432|0);Lj(b+32|0,j+32|0,32)|0;cc(l+432|0);$d(l+208|0,l+432|0);oh(b,l+208|0);Ck(l);Rd(l,b,64,0);Rd(l,f,g,h);lh(l,l+368|0);cc(l+368|0);_b(b+32|0,l+368|0,l+496|0,l+432|0);_j(l+496|0,64);if(e|0){c[e>>2]=64;c[e+4>>2]=0}i=k;return}function nf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;b=Ll(b)|0;o=0;g=va(32,b|0,51948)|0;k=o;o=0;if(((((!(k&1)?(o=0,Ba(c[(c[g>>2]|0)+48>>2]|0,g|0,46787,46819,d|0)|0,k=o,o=0,!(k&1)):0)?(o=0,j=va(32,b|0,51956)|0,k=o,o=0,!(k&1)):0)?(o=0,h=ha(c[(c[j>>2]|0)+12>>2]|0,j|0)|0,k=o,o=0,!(k&1)):0)?(c[e>>2]=h,o=0,i=ha(c[(c[j>>2]|0)+16>>2]|0,j|0)|0,k=o,o=0,!(k&1)):0)?(c[f>>2]=i,o=0,da(c[(c[j>>2]|0)+20>>2]|0,a|0,j|0),k=o,o=0,!(k&1)):0){Vl(b);return}k=Ya()|0;Vl(b);Ra(k|0)}function of(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;d=Ll(d)|0;o=0;h=va(32,d|0,51916)|0;l=o;o=0;if(((((!(l&1)?(o=0,Ba(c[(c[h>>2]|0)+32>>2]|0,h|0,46787,46819,e|0)|0,l=o,o=0,!(l&1)):0)?(o=0,k=va(32,d|0,51928)|0,l=o,o=0,!(l&1)):0)?(o=0,i=ha(c[(c[k>>2]|0)+12>>2]|0,k|0)|0,l=o,o=0,!(l&1)):0)?(a[f>>0]=i,o=0,j=ha(c[(c[k>>2]|0)+16>>2]|0,k|0)|0,l=o,o=0,!(l&1)):0)?(a[g>>0]=j,o=0,da(c[(c[k>>2]|0)+20>>2]|0,b|0,k|0),l=o,o=0,!(l&1)):0){Vl(d);return}l=Ya()|0;Vl(d);Ra(l|0)}function pf(a,b,d,e,f,g,h,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;l=i;i=i+336|0;qq(l+264|0,m,n);sq(l,l+264|0);_j(l+264|0,64);ho(l,h,j,k);h=Sm(0,0,j|0,k|0)|0;ho(l,53844,h&15,0);Ym(a,e,f,g,m,n);ho(l,a,f,g);m=Sm(0,0,f|0,g|0)|0;ho(l,53844,m&15,0);c[l+256>>2]=j;c[l+256+4>>2]=k;ho(l,l+256|0,8,0);c[l+256>>2]=f;c[l+256+4>>2]=g;ho(l,l+256|0,8,0);nq(l,b);_j(l,256);if(d|0){c[d>>2]=16;c[d+4>>2]=0}i=l;return 0}function qf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=a[b+8+3>>0]|0;if(f<<24>>24<0){g=(c[b+8>>2]&2147483647)+-1|0;j=c[b+4>>2]|0}else{g=1;j=f&255}do if(e-d>>2|0){if((g-j|0)>>>0<e-d>>2>>>0){zf(b,g,j+(e-d>>2)-g|0,j,j,0);f=a[b+8+3>>0]|0}i=f<<24>>24<0;if(i)g=c[b>>2]|0;else g=b;f=d;h=g+(j<<2)|0;while(1){if((f|0)==(e|0))break;c[h>>2]=c[f>>2];f=f+4|0;h=h+4|0}c[g+(j+((e-d|0)>>>2)<<2)>>2]=0;f=j+(e-d>>2)|0;if(i){c[b+4>>2]=f;break}else{a[b+8+3>>0]=f;break}}while(0);return}function rf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=a[b+11>>0]|0;if(f<<24>>24<0){g=(c[b+8>>2]&2147483647)+-1|0;j=c[b+4>>2]|0}else{g=10;j=f&255}do if((e|0)!=(d|0)){if((g-j|0)>>>0<(e-d|0)>>>0){ug(b,g,j+(e-d)-g|0,j,j);f=a[b+11>>0]|0}if(f<<24>>24<0)g=c[b>>2]|0;else g=b;i=e+(j-d)|0;f=d;h=g+j|0;while(1){if((f|0)==(e|0))break;a[h>>0]=a[f>>0]|0;f=f+1|0;h=h+1|0}a[g+i>>0]=0;f=j+(e-d)|0;if((a[b+11>>0]|0)<0){c[b+4>>2]=f;break}else{a[b+11>>0]=f;break}}while(0);return}function sf(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0;n=i;i=i+352|0;Kq(n+280|0,l,m);sq(n,n+280|0);_j(n+280|0,64);ho(n,h,j,k);c[n+256>>2]=j;c[n+256+4>>2]=k;ho(n,n+256|0,8,0);ho(n,d,e,f);c[n+256>>2]=e;c[n+256+4>>2]=f;ho(n,n+256|0,8,0);nq(n,n+264|0);_j(n,256);b=ml(n+264|0,g)|0;_j(n+264|0,16);do if(a)if(!b){nn(a,d,e,f,l,m);b=0;break}else{ei(a|0,0,e|0)|0;b=-1;break}while(0);i=n;return b|0}function tf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;k=i;j=i=i+63&-64;i=i+16|0;if((a|0)==(b|0)){c[d>>2]=4;a=0}else{g=gp()|0;h=c[g>>2]|0;c[g>>2]=0;To()|0;a=$q(a,j,e)|0;e=D;f=c[g>>2]|0;if(!f)c[g>>2]=h;a:do if((c[j>>2]|0)==(b|0)){do if((f|0)==34){c[d>>2]=4;if((e|0)>0|(e|0)==0&a>>>0>0){a=2147483647;break a}}else{if((e|0)<-1|(e|0)==-1&a>>>0<2147483648){c[d>>2]=4;break}if((e|0)>0|(e|0)==0&a>>>0>2147483647){c[d>>2]=4;a=2147483647;break a}else break a}while(0);a=-2147483648}else{c[d>>2]=4;a=0}while(0)}i=k;return a|0}function uf(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0;e=0;do{a[b+e>>0]=(d[c+(e>>3)>>0]|0)>>>(e&7)&1;e=e+1|0}while((e|0)!=256);i=0;do{g=b+i|0;a:do if(a[g>>0]|0){h=1;do{e=h+i|0;if((e|0)>=256)break a;c=a[b+e>>0]|0;b:do if(c<<24>>24){f=a[g>>0]|0;c=c<<24>>24<<h;if((f+c|0)<16){a[g>>0]=f+c;a[b+e>>0]=0;break}if((f-c|0)<=-16)break a;a[g>>0]=f-c;while(1){c=b+e|0;if(!(a[c>>0]|0))break;a[c>>0]=0;e=e+1|0;if((e|0)>=256)break b}a[c>>0]=1}while(0);h=h+1|0}while((h|0)<7)}while(0);i=i+1|0}while((i|0)!=256);return}function vf(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;if((1073741806-d|0)>>>0<e>>>0)nj();if((a[b+8+3>>0]|0)<0)k=c[b>>2]|0;else k=b;if(d>>>0<536870887){e=(e+d|0)>>>0<d<<1>>>0?d<<1:e+d|0;if(e>>>0>=2)if((e+4&-4)>>>0>1073741823){b=db(4)|0;ls(b);sb(b|0,1944,114)}else e=e+4&-4;else e=2}else e=1073741807;j=Wi(e<<2)|0;if(h|0)Fp(j,i,h);if((f|0)!=(g|0))Fp(j+(h<<2)|0,k+(g<<2)|0,f-g|0);if((d|0)!=1)Zs(k);c[b>>2]=j;c[b+8>>2]=e|-2147483648;c[b+4>>2]=f-g+h;c[j+(f-g+h<<2)>>2]=0;return}function wf(a){a=a|0;var b=0,d=0;b=c[a+4>>2]|0;b=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;do if(((c[b+24>>2]|0?(c[b+16>>2]|0)==0:0)?c[b+4>>2]&8192|0:0)?!(hb()|0):0){b=c[a+4>>2]|0;b=c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0;o=0;b=ha(c[(c[b>>2]|0)+24>>2]|0,b|0)|0;d=o;o=0;if(!(d&1)){if((b|0)!=-1)break;d=c[a+4>>2]|0;d=d+(c[(c[d>>2]|0)+-12>>2]|0)|0;o=0;da(57,d|0,c[d+16>>2]|1|0);d=o;o=0;if(!(d&1))break}d=Za(0)|0;jb(d|0)|0;o=0;Fa(19);d=o;o=0;if(d&1){d=Za(0)|0;xr(d)}}while(0);return}function xf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=c[e+16>>2]|0;if(!f)if(!(Zi(e)|0)){f=c[e+16>>2]|0;g=5}else f=0;else g=5;a:do if((g|0)==5){h=c[e+20>>2]|0;if((f-h|0)>>>0<d>>>0){f=Kb[c[e+36>>2]&63](e,b,d)|0;break}b:do if((a[e+75>>0]|0)>-1){f=d;while(1){if(!f){g=h;f=0;break b}g=f+-1|0;if((a[b+g>>0]|0)==10)break;else f=g}if((Kb[c[e+36>>2]&63](e,b,f)|0)>>>0<f>>>0)break a;d=d-f|0;b=b+f|0;g=c[e+20>>2]|0}else{g=h;f=0}while(0);mh(g|0,b|0,d|0)|0;c[e+20>>2]=(c[e+20>>2]|0)+d;f=f+d|0}while(0);return f|0}function yf(){var a=0,b=0,d=0,e=0;e=i=i+63&-64;i=i+48|0;a=Kk()|0;if(a|0?(d=c[a>>2]|0,d|0):0){b=c[d+48>>2]|0;a=c[d+48+4>>2]|0;if(!((b&-256|0)==1126902528&(a|0)==1129074247)){c[e+24>>2]=49254;Tm(49349,e+24|0)}if((b|0)==1126902529&(a|0)==1129074247)a=c[d+44>>2]|0;else a=d+80|0;c[e+36>>2]=a;d=c[d>>2]|0;a=c[d+4>>2]|0;if(lg(1880,d,e+36|0)|0){d=c[e+36>>2]|0;d=Ib[c[(c[d>>2]|0)+8>>2]&127](d)|0;c[e>>2]=49254;c[e+4>>2]=a;c[e+8>>2]=d;Tm(49263,e)}else{c[e+16>>2]=49254;c[e+16+4>>2]=a;Tm(49308,e+16|0)}}Tm(49387,e+32|0)}function zf(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;if((1073741807-d|0)>>>0<e>>>0)nj();if((a[b+8+3>>0]|0)<0)j=c[b>>2]|0;else j=b;if(d>>>0<536870887){e=(e+d|0)>>>0<d<<1>>>0?d<<1:e+d|0;if(e>>>0>=2)if((e+4&-4)>>>0>1073741823){b=db(4)|0;ls(b);sb(b|0,1944,114)}else e=e+4&-4;else e=2}else e=1073741807;i=Wi(e<<2)|0;if(g|0)Fp(i,j,g);if((f-h|0)!=(g|0))Fp(i+(g<<2)|0,j+(g<<2)+(h<<2)|0,f-h-g|0);if((d|0)!=1)Zs(j);c[b>>2]=i;c[b+8>>2]=e|-2147483648;return}function Af(a){a=a|0;Ao(52956);Ao(52944);Ao(52932);Ao(52920);Ao(52908);Ao(52896);Ao(52884);Ao(52872);Ao(52860);Ao(52848);Ao(52836);Ao(52824);Ao(52812);Ao(52800);return}function Bf(a){a=a|0;Oo(52144);Oo(52132);Oo(52120);Oo(52108);Oo(52096);Oo(52084);Oo(52072);Oo(52060);Oo(52048);Oo(52036);Oo(52024);Oo(52012);Oo(52e3);Oo(51988);return}function Cf(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;h=i;j=i=i+63&-64;i=i+64|0;if((e+-1&255)>63)Ta();a[j>>0]=e;a[j+1>>0]=0;a[j+2>>0]=1;a[j+3>>0]=1;e=j+4|0;g=e+60|0;do{a[e>>0]=0;e=e+1|0}while((e|0)<(g|0));ei(b+64|0,0,293)|0;e=b;f=400;g=e+64|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(g|0));e=0;do{k=j+(e<<3)|0;g=b+(e<<3)|0;f=c[g+4>>2]^(d[k+4>>0]|d[k+4+1>>0]<<8|d[k+4+2>>0]<<16|d[k+4+3>>0]<<24);c[g>>2]=c[g>>2]^(d[k>>0]|d[k+1>>0]<<8|d[k+2>>0]<<16|d[k+3>>0]<<24);c[g+4>>2]=f;e=e+1|0}while((e|0)!=8);i=h;return}function Df(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;j=Ib[c[(c[b+8>>2]|0)+8>>2]&127](b+8|0)|0;b=a[j+8+3>>0]|0;if(b<<24>>24<0)i=c[j+4>>2]|0;else i=b&255;b=a[j+20+3>>0]|0;if(b<<24>>24<0)b=c[j+16>>2]|0;else b=b&255;do if((i|0)!=(0-b|0)){b=uc(e,f,j,j+24|0,h,g,0)|0;i=c[d>>2]|0;if((b|0)==(j|0)&(i|0)==12){c[d>>2]=0;break}if((i|0)<12&(b-j|0)==12)c[d>>2]=i+12}else c[g>>2]=c[g>>2]|4;while(0);return}function Ef(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;j=Ib[c[(c[b+8>>2]|0)+8>>2]&127](b+8|0)|0;b=a[j+11>>0]|0;if(b<<24>>24<0)i=c[j+4>>2]|0;else i=b&255;b=a[j+12+11>>0]|0;if(b<<24>>24<0)b=c[j+16>>2]|0;else b=b&255;do if((i|0)!=(0-b|0)){b=vc(e,f,j,j+24|0,h,g,0)|0;i=c[d>>2]|0;if((b|0)==(j|0)&(i|0)==12){c[d>>2]=0;break}if((i|0)<12&(b-j|0)==12)c[d>>2]=i+12}else c[g>>2]=c[g>>2]|4;while(0);return}function Ff(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;m=(c[b+4>>2]|0)-(c[d+4>>2]|0)|0;l=(c[b+8>>2]|0)-(c[d+8>>2]|0)|0;k=(c[b+12>>2]|0)-(c[d+12>>2]|0)|0;j=(c[b+16>>2]|0)-(c[d+16>>2]|0)|0;i=(c[b+20>>2]|0)-(c[d+20>>2]|0)|0;h=(c[b+24>>2]|0)-(c[d+24>>2]|0)|0;g=(c[b+28>>2]|0)-(c[d+28>>2]|0)|0;f=(c[b+32>>2]|0)-(c[d+32>>2]|0)|0;e=(c[b+36>>2]|0)-(c[d+36>>2]|0)|0;c[a>>2]=(c[b>>2]|0)-(c[d>>2]|0);c[a+4>>2]=m;c[a+8>>2]=l;c[a+12>>2]=k;c[a+16>>2]=j;c[a+20>>2]=i;c[a+24>>2]=h;c[a+28>>2]=g;c[a+32>>2]=f;c[a+36>>2]=e;return}function Gf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;m=(c[d+4>>2]|0)+(c[b+4>>2]|0)|0;l=(c[d+8>>2]|0)+(c[b+8>>2]|0)|0;k=(c[d+12>>2]|0)+(c[b+12>>2]|0)|0;j=(c[d+16>>2]|0)+(c[b+16>>2]|0)|0;i=(c[d+20>>2]|0)+(c[b+20>>2]|0)|0;h=(c[d+24>>2]|0)+(c[b+24>>2]|0)|0;g=(c[d+28>>2]|0)+(c[b+28>>2]|0)|0;f=(c[d+32>>2]|0)+(c[b+32>>2]|0)|0;e=(c[d+36>>2]|0)+(c[b+36>>2]|0)|0;c[a>>2]=(c[d>>2]|0)+(c[b>>2]|0);c[a+4>>2]=m;c[a+8>>2]=l;c[a+12>>2]=k;c[a+16>>2]=j;c[a+20>>2]=i;c[a+24>>2]=h;c[a+28>>2]=g;c[a+32>>2]=f;c[a+36>>2]=e;return}function Hf(b,d){b=b|0;d=d|0;var e=0,f=0;a:do if(!(d&255))b=b+(Zg(b)|0)|0;else{if(b&3)do{f=a[b>>0]|0;if(f<<24>>24==0?1:f<<24>>24==(d&255)<<24>>24)break a;b=b+1|0}while((b&3|0)!=0);f=S(d&255,16843009)|0;e=c[b>>2]|0;b:do if(!((e&-2139062144^-2139062144)&e+-16843009))do{e=e^f;if((e&-2139062144^-2139062144)&e+-16843009|0)break b;b=b+4|0;e=c[b>>2]|0}while(!((e&-2139062144^-2139062144)&e+-16843009|0));while(0);while(1){f=a[b>>0]|0;if(f<<24>>24==0?1:f<<24>>24==(d&255)<<24>>24)break;else b=b+1|0}}while(0);return b|0}function If(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;b=Ll(b)|0;o=0;f=va(32,b|0,51948)|0;i=o;o=0;if((((!(i&1)?(o=0,Ba(c[(c[f>>2]|0)+48>>2]|0,f|0,46787,46813,d|0)|0,i=o,o=0,!(i&1)):0)?(o=0,h=va(32,b|0,51956)|0,i=o,o=0,!(i&1)):0)?(o=0,g=ha(c[(c[h>>2]|0)+16>>2]|0,h|0)|0,i=o,o=0,!(i&1)):0)?(c[e>>2]=g,o=0,da(c[(c[h>>2]|0)+20>>2]|0,a|0,h|0),i=o,o=0,!(i&1)):0){Vl(b);return}i=Ya()|0;Vl(b);Ra(i|0)}function Jf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;d=Ll(d)|0;o=0;g=va(32,d|0,51916)|0;j=o;o=0;if((((!(j&1)?(o=0,Ba(c[(c[g>>2]|0)+32>>2]|0,g|0,46787,46813,e|0)|0,j=o,o=0,!(j&1)):0)?(o=0,i=va(32,d|0,51928)|0,j=o,o=0,!(j&1)):0)?(o=0,h=ha(c[(c[i>>2]|0)+16>>2]|0,i|0)|0,j=o,o=0,!(j&1)):0)?(a[f>>0]=h,o=0,da(c[(c[i>>2]|0)+20>>2]|0,b|0,i|0),j=o,o=0,!(j&1)):0){Vl(d);return}j=Ya()|0;Vl(d);Ra(j|0)}function Kf(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;if((-18-d|0)>>>0<e>>>0)nj();if((a[b+11>>0]|0)<0)l=c[b>>2]|0;else l=b;if(d>>>0<2147483623){e=(e+d|0)>>>0<d<<1>>>0?d<<1:e+d|0;e=e>>>0<11?11:e+16&-16}else e=-17;k=Wi(e)|0;if(g|0)mh(k|0,l|0,g|0)|0;if(i|0)mh(k+g|0,j|0,i|0)|0;if((f-h|0)!=(g|0))mh(k+g+i|0,l+g+h|0,f-h-g|0)|0;if((d|0)!=10)Zs(l);c[b>>2]=k;c[b+8>>2]=e|-2147483648;c[b+4>>2]=f-h+i;a[k+(f-h+i)>>0]=0;return}function Lf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=(c[a+4>>2]|0)!=140;h=c[a>>2]|0;f=(c[d>>2]|0)-h|0;f=f>>>0<2147483647?f<<1:-1;f=(f|0)==0?4:f;g=(c[b>>2]|0)-h>>2;h=kh(e?h:0,f)|0;if(!h)Pp();do if(!e){e=c[a>>2]|0;c[a>>2]=h;if(e){o=0;ba(c[a+4>>2]|0,e|0);h=o;o=0;if(h&1){h=Za(0)|0;xr(h)}else{i=c[a>>2]|0;break}}else i=h}else{c[a>>2]=h;i=h}while(0);c[a+4>>2]=143;c[b>>2]=i+(g<<2);c[d>>2]=(c[a>>2]|0)+(f>>>2<<2);return}function Mf(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;f=i;i=i+192|0;Ck(b);d=f+64|0;e=d+128|0;do{a[d>>0]=54;d=d+1|0}while((d|0)<(e|0));a[f+64>>0]=a[c>>0]^54;d=1;do{e=f+64+d|0;a[e>>0]=a[e>>0]^a[c+d>>0];d=d+1|0}while((d|0)!=32);Rd(b,f+64|0,128,0);Ck(b+208|0);d=f+64|0;e=d+128|0;do{a[d>>0]=92;d=d+1|0}while((d|0)<(e|0));a[f+64>>0]=a[c>>0]^92;d=1;do{e=f+64+d|0;a[e>>0]=a[e>>0]^a[c+d>>0];d=d+1|0}while((d|0)!=32);Rd(b+208|0,f+64|0,128,0);_j(f+64|0,128);_j(f,64);i=f;return}function Nf(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0;k=i;e=i=i+63&-64;i=i+112|0;c[e>>2]=e+4+100;Ih(b+8|0,e+4|0,e,g,h,j);b=c[e>>2]|0;g=e+4|0;e=c[d>>2]|0;while(1){if((g|0)==(b|0))break;h=a[g>>0]|0;do if(e){j=e+24|0;f=c[j>>2]|0;if((f|0)==(c[e+28>>2]|0)){d=(Pb[c[(c[e>>2]|0)+52>>2]&63](e,h&255)|0)==-1;e=d?0:e;break}else{c[j>>2]=f+1;a[f>>0]=h;break}}else e=0;while(0);g=g+1|0}i=k;return e|0}function Of(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=(c[a+4>>2]|0)!=140;h=c[a>>2]|0;f=(c[d>>2]|0)-h|0;f=f>>>0<2147483647?f<<1:-1;f=(f|0)==0?1:f;g=(c[b>>2]|0)-h|0;h=kh(e?h:0,f)|0;if(!h)Pp();do if(!e){e=c[a>>2]|0;c[a>>2]=h;if(e){o=0;ba(c[a+4>>2]|0,e|0);h=o;o=0;if(h&1){h=Za(0)|0;xr(h)}else{i=c[a>>2]|0;break}}else i=h}else{c[a>>2]=h;i=h}while(0);c[a+4>>2]=143;c[b>>2]=i+g;c[d>>2]=(c[a>>2]|0)+f;return}function Pf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;l=i;k=i=i+63&-64;i=i+16|0;do if((b|0)==(d|0)){c[e>>2]=4;b=0}else{if((a[b>>0]|0)==45){c[e>>2]=4;b=0;break}h=gp()|0;j=c[h>>2]|0;c[h>>2]=0;To()|0;b=Sq(b,k,f)|0;f=D;g=c[h>>2]|0;if(!g)c[h>>2]=j;do if((c[k>>2]|0)==(d|0))if(f>>>0>0|(f|0)==0&b>>>0>65535|(g|0)==34){c[e>>2]=4;b=-1;break}else{b=b&65535;break}else{c[e>>2]=4;b=0}while(0)}while(0);i=l;return b|0}function Qf(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0;i=c[b+104>>2]|0;if((i|0)!=0?(c[b+108>>2]|0)>=(i|0):0)j=4;else{e=Fj(b)|0;if((e|0)>=0){i=c[b+104>>2]|0;f=c[b+8>>2]|0;if((i|0)!=0?(g=c[b+4>>2]|0,h=i-(c[b+108>>2]|0)|0,(f-g|0)>=(h|0)):0){c[b+100>>2]=g+(h+-1);g=b+4|0}else{g=b+4|0;h=f;j=9}if((j|0)==9){c[b+100>>2]=f;f=h}if(!f)f=c[g>>2]|0;else{i=c[g>>2]|0;c[b+108>>2]=f+1-i+(c[b+108>>2]|0);f=i}f=f+-1|0;if((d[f>>0]|0|0)!=(e|0))a[f>>0]=e}else j=4}if((j|0)==4){c[b+100>>2]=0;e=-1}return e|0}function Rf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;m=i;l=i=i+63&-64;i=i+128|0;g=l;h=34384;j=g+112|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(j|0));if((d+-1|0)>>>0>2147483646)if(!d){b=l+112|0;d=1;k=4}else{c[(gp()|0)>>2]=75;d=-1}else k=4;if((k|0)==4){k=-2-b|0;k=d>>>0>k>>>0?k:d;c[l+48>>2]=k;c[l+20>>2]=b;c[l+44>>2]=b;d=b+k|0;c[l+16>>2]=d;c[l+28>>2]=d;d=ff(l,e,f)|0;if(k){k=c[l+20>>2]|0;a[k+(((k|0)==(c[l+16>>2]|0))<<31>>31)>>0]=0}}i=m;return d|0}function Sf(a,b,d,e,f,g,h,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;l=i;i=i+336|0;Kq(l+264|0,m,n);sq(l,l+264|0);_j(l+264|0,64);ho(l,h,j,k);c[l+256>>2]=j;c[l+256+4>>2]=k;ho(l,l+256|0,8,0);nn(a,e,f,g,m,n);ho(l,a,f,g);c[l+256>>2]=f;c[l+256+4>>2]=g;ho(l,l+256|0,8,0);nq(l,b);_j(l,256);if(d|0){c[d>>2]=16;c[d+4>>2]=0}i=l;return 0}function Tf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;l=i;k=i=i+63&-64;i=i+16|0;do if((b|0)==(d|0)){c[e>>2]=4;b=0}else{if((a[b>>0]|0)==45){c[e>>2]=4;b=0;break}h=gp()|0;j=c[h>>2]|0;c[h>>2]=0;To()|0;b=Sq(b,k,f)|0;f=D;g=c[h>>2]|0;if(!g)c[h>>2]=j;do if((c[k>>2]|0)==(d|0))if(f>>>0>0|(f|0)==0&b>>>0>4294967295|(g|0)==34){c[e>>2]=4;b=-1;break}else break;else{c[e>>2]=4;b=0}while(0)}while(0);i=l;return b|0}function Uf(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;j=i;d=i=i+63&-64;i=i+416|0;c[d>>2]=d+8+400;Hg(a+8|0,d+8|0,d,f,g,h);a=c[d>>2]|0;f=d+8|0;d=c[b>>2]|0;while(1){if((f|0)==(a|0))break;e=c[f>>2]|0;if(!d)d=0;else{h=d+24|0;g=c[h>>2]|0;if((g|0)==(c[d+28>>2]|0))e=Pb[c[(c[d>>2]|0)+52>>2]&63](d,e)|0;else{c[h>>2]=g+4;c[g>>2]=e}d=(e|0)==-1?0:d}f=f+4|0}i=j;return d|0}function Vf(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=e-d>>2;if(f>>>0>1073741807)nj();do if(f>>>0>=2)if((f+4&-4)>>>0>1073741823){e=db(4)|0;ls(e);sb(e|0,1944,114)}else{g=Wi((f+4&-4)<<2)|0;c[b>>2]=g;c[b+8>>2]=f+4&-4|-2147483648;c[b+4>>2]=f;b=g;break}else a[b+8+3>>0]=f;while(0);f=d;g=b;while(1){if((f|0)==(e|0))break;c[g>>2]=c[f>>2];f=f+4|0;g=g+4|0}c[b+((e-d|0)>>>2<<2)>>2]=0;return}function Wf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=i=i+63&-64;i=i+48|0;Gf(a,b+40|0,b);Ff(a+40|0,b+40|0,b);fc(a+80|0,a,c+40|0);fc(a+40|0,a+40|0,c);fc(a+120|0,c+120|0,b+120|0);fc(a,b+80|0,c+80|0);Gf(e,a,a);Ff(a,a+80|0,a+40|0);Gf(a+40|0,a+80|0,a+40|0);Ff(a+80|0,e,a+120|0);Gf(a+120|0,e,a+120|0);i=d;return}function Xf(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=i=i+63&-64;i=i+48|0;Gf(a,b+40|0,b);Ff(a+40|0,b+40|0,b);fc(a+80|0,a,c);fc(a+40|0,a+40|0,c+40|0);fc(a+120|0,c+120|0,b+120|0);fc(a,b+80|0,c+80|0);Gf(e,a,a);Ff(a,a+80|0,a+40|0);Gf(a+40|0,a+80|0,a+40|0);Gf(a+80|0,e,a+120|0);Ff(a+120|0,e,a+120|0);i=d;return}function Yf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;Gf(a,b+40|0,b);Ff(a+40|0,b+40|0,b);l=c[b+84>>2]|0;k=c[b+88>>2]|0;j=c[b+92>>2]|0;i=c[b+96>>2]|0;h=c[b+100>>2]|0;g=c[b+104>>2]|0;f=c[b+108>>2]|0;e=c[b+112>>2]|0;d=c[b+116>>2]|0;c[a+80>>2]=c[b+80>>2];c[a+84>>2]=l;c[a+88>>2]=k;c[a+92>>2]=j;c[a+96>>2]=i;c[a+100>>2]=h;c[a+104>>2]=g;c[a+108>>2]=f;c[a+112>>2]=e;c[a+116>>2]=d;fc(a+120|0,b+120|0,2120);return}function Zf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;l=i;k=i=i+63&-64;i=i+16|0;do if((b|0)==(d|0)){c[e>>2]=4;f=0;b=0}else{if((a[b>>0]|0)==45){c[e>>2]=4;f=0;b=0;break}h=gp()|0;j=c[h>>2]|0;c[h>>2]=0;To()|0;b=Sq(b,k,f)|0;f=D;g=c[h>>2]|0;if(!g)c[h>>2]=j;if((c[k>>2]|0)==(d|0)){if((g|0)==34){c[e>>2]=4;b=-1;f=-1}}else{c[e>>2]=4;b=0;f=0}}while(0);D=f;i=l;return b|0}function _f(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;j=i;k=i=i+63&-64;i=i+112|0;h=k+16|0;g=h+32|0;do{a[h>>0]=a[f>>0]|0;h=h+1|0;f=f+1|0}while((h|0)<(g|0));f=d[e+4>>0]|d[e+4+1>>0]<<8|d[e+4+2>>0]<<16|d[e+4+3>>0]<<24;c[k>>2]=d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24;c[k+4>>2]=f;c[k+8>>2]=0;c[k+8+4>>2]=0;Cc(k+48|0,k,k+16|0);f=0;do{a[b+f>>0]=a[k+48+f>>0]|0;f=f+1|0}while((f|0)!=32);_j(k+48|0,64);_j(k+16|0,32);i=j;return}function $f(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;g=i;h=i=i+63&-64;i=i+320|0;f=h+280|0;e=f+32|0;do{a[f>>0]=a[c>>0]|0;f=f+1|0;c=c+1|0}while((f|0)<(e|0));a[h+280>>0]=(d[h+280>>0]|0)&248;a[h+280+31>>0]=(d[h+280+31>>0]|0)&63|64;$d(h+40|0,h+280|0);Gf(h+240|0,h+40+80|0,h+40+40|0);Ff(h+200|0,h+40+80|0,h+40+40|0);od(h+200|0,h+200|0);fc(h,h+240|0,h+200|0);Ld(b,h);i=g;return 0}function ag(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;k=i;j=i=i+63&-64;i=i+16|0;if((a|0)==(b|0)){c[d>>2]=4;e=0;a=0}else{g=gp()|0;h=c[g>>2]|0;c[g>>2]=0;To()|0;f=$q(a,j,e)|0;e=D;a=c[g>>2]|0;if(!a)c[g>>2]=h;if((c[j>>2]|0)==(b|0))if((a|0)==34){c[d>>2]=4;a=(e|0)>0|(e|0)==0&f>>>0>0?-1:0;e=(e|0)>0|(e|0)==0&f>>>0>0?2147483647:-2147483648}else a=f;else{c[d>>2]=4;a=0;e=0}}D=e;i=k;return a|0}function bg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=i=i+63&-64;i=i+16|0;Fk(b);c[b>>2]=38160;c[b+32>>2]=d;Np(g+4|0,c[b+4>>2]|0);d=c[g+4>>2]|0;c[g>>2]=d;o=0;d=va(32,d|0,53716)|0;h=o;o=0;if(h&1){h=Ya()|0;Lq(g);Kp(b);Ra(h|0)}else{Lq(g);c[b+36>>2]=d;c[b+40>>2]=e;a[b+44>>0]=(Ib[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;i=f;return}}function cg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=i=i+63&-64;i=i+16|0;Gk(b);c[b>>2]=38096;c[b+32>>2]=d;Np(g+4|0,c[b+4>>2]|0);d=c[g+4>>2]|0;c[g>>2]=d;o=0;d=va(32,d|0,53708)|0;h=o;o=0;if(h&1){h=Ya()|0;Lq(g);Lp(b);Ra(h|0)}else{Lq(g);c[b+36>>2]=d;c[b+40>>2]=e;a[b+44>>0]=(Ib[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;i=f;return}}function dg(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;h=i;j=i=i+63&-64;i=i+256|0;do if((d|0)>(e|0)&(f&73728|0)==0){ei(j|0,b|0,((d-e|0)>>>0>256?256:d-e|0)|0)|0;f=c[a>>2]|0;if((d-e|0)>>>0>255){g=d-e|0;b=f;f=(f&32|0)==0;do{if(f){xf(j,256,a)|0;b=c[a>>2]|0}g=g+-256|0;f=(b&32|0)==0}while(g>>>0>255);if(f)b=d-e&255;else break}else if(!(f&32))b=d-e|0;else break;xf(j,b,a)|0}while(0);i=h;return}function eg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;d=i=i+63&-64;i=i+16|0;c[g>>2]=e;b=zo(c[b+8>>2]|0)|0;e=pg(d,0)|0;if(b|0)zo(b)|0;a:do switch(e|0){case 0:case -1:{d=2;break}default:if((e+-1|0)>>>0>(f-(c[g>>2]|0)|0)>>>0)d=1;else{b=e+-1|0;while(1){if(!b){d=0;break a}e=a[d>>0]|0;f=c[g>>2]|0;c[g>>2]=f+1;a[f>>0]=e;b=b+-1|0;d=d+1|0}}}while(0);i=h;return d|0}function fg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=i=i+63&-64;i=i+48|0;Gf(a,b+40|0,b);Ff(a+40|0,b+40|0,b);fc(a+80|0,a,c+40|0);fc(a+40|0,a+40|0,c);fc(a+120|0,c+80|0,b+120|0);Gf(e,b+80|0,b+80|0);Ff(a,a+80|0,a+40|0);Gf(a+40|0,a+80|0,a+40|0);Ff(a+80|0,e,a+120|0);Gf(a+120|0,e,a+120|0);i=d;return}function gg(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=i=i+63&-64;i=i+48|0;Gf(a,b+40|0,b);Ff(a+40|0,b+40|0,b);fc(a+80|0,a,c);fc(a+40|0,a+40|0,c+40|0);fc(a+120|0,c+80|0,b+120|0);Gf(e,b+80|0,b+80|0);Ff(a,a+80|0,a+40|0);Gf(a+40|0,a+80|0,a+40|0);Gf(a+80|0,e,a+120|0);Ff(a+120|0,e,a+120|0);i=d;return}function hg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=a[b+8+3>>0]|0;if(f<<24>>24<0)g=(c[b+8>>2]&2147483647)+-1|0;else g=1;do if(g>>>0>=e>>>0){if(f<<24>>24<0)f=c[b>>2]|0;else f=b;up(f,d,e);c[f+(e<<2)>>2]=0;if((a[b+8+3>>0]|0)<0){c[b+4>>2]=e;break}else{a[b+8+3>>0]=e;break}}else{if(f<<24>>24<0)f=c[b+4>>2]|0;else f=f&255;vf(b,g,e-g|0,f,f,e,d)}while(0);return}function ig(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;a[b+53>>0]=1;do if((c[b+4>>2]|0)==(e|0)){a[b+52>>0]=1;e=c[b+16>>2]|0;if(!e){c[b+16>>2]=d;c[b+24>>2]=f;c[b+36>>2]=1;if(!((f|0)==1?(c[b+48>>2]|0)==1:0))break;a[b+54>>0]=1;break}if((e|0)!=(d|0)){c[b+36>>2]=(c[b+36>>2]|0)+1;a[b+54>>0]=1;break}e=c[b+24>>2]|0;if((e|0)==2){c[b+24>>2]=f;e=f}if((e|0)==1?(c[b+48>>2]|0)==1:0)a[b+54>>0]=1}while(0);return}function jg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=a[b+11>>0]|0;if(f<<24>>24<0)g=(c[b+8>>2]&2147483647)+-1|0;else g=10;do if(g>>>0>=e>>>0){if(f<<24>>24<0)f=c[b>>2]|0;else f=b;if(e|0)Lj(f|0,d|0,e|0)|0;a[f+e>>0]=0;if((a[b+11>>0]|0)<0){c[b+4>>2]=e;break}else{a[b+11>>0]=e;break}}else{if(f<<24>>24<0)f=c[b+4>>2]|0;else f=f&255;Kf(b,g,e-g|0,f,0,f,e,d)}while(0);return}function kg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a:do if((b|0)!=(c[d+8>>2]|0)){g=c[b+12>>2]|0;Fi(b+16|0,d,e,f);if((g|0)>1){h=b+24|0;do{Fi(h,d,e,f);if(a[d+54>>0]|0)break a;h=h+8|0}while(h>>>0<(b+16+(g<<3)|0)>>>0)}}else Gh(d,e,f);while(0);return}function lg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;h=i;g=i=i+63&-64;i=i+64|0;if((a|0)!=(b|0))if((b|0)!=0?(f=df(b,1888)|0,(f|0)!=0):0){b=g;e=b+56|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(e|0));c[g>>2]=f;c[g+8>>2]=a;c[g+12>>2]=-1;c[g+48>>2]=1;Xb[c[(c[f>>2]|0)+28>>2]&31](f,g,c[d>>2]|0,1);if((c[g+24>>2]|0)==1){c[d>>2]=c[g+16>>2];b=1}else b=0}else b=0;else b=1;i=h;return b|0}function mg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;do if((b|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)==(e|0)?(c[d+28>>2]|0)!=1:0)c[d+28>>2]=f}else if((b|0)==(c[d>>2]|0)){if((c[d+16>>2]|0)!=(e|0)?(c[d+20>>2]|0)!=(e|0):0){c[d+32>>2]=f;c[d+20>>2]=e;c[d+40>>2]=(c[d+40>>2]|0)+1;if((c[d+36>>2]|0)==1?(c[d+24>>2]|0)==2:0)a[d+54>>0]=1;c[d+44>>2]=4;break}if((f|0)==1)c[d+32>>2]=1}while(0);return}function ng(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0;if(e&2048){a[b>>0]=43;b=b+1|0}if(!(e&512))f=c;else{a[b>>0]=35;f=c;b=b+1|0}while(1){c=a[f>>0]|0;if(!(c<<24>>24))break;a[b>>0]=c;f=f+1|0;b=b+1|0}a:do switch(e&74|0){case 64:{a[b>>0]=111;break}case 8:if(!(e&16384)){a[b>>0]=120;break a}else{a[b>>0]=88;break a}default:if(d){a[b>>0]=100;break a}else{a[b>>0]=117;break a}}while(0);return}function og(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;if(e>>>3|0){f=0;do{g=b+(f<<3)|0;h=d+(f<<3)|0;i=c[h>>2]|0;h=c[h+4>>2]|0;a[g+7>>0]=i;j=Mm(i|0,h|0,8)|0;a[g+6>>0]=j;j=Mm(i|0,h|0,16)|0;a[g+5>>0]=j;j=Mm(i|0,h|0,24)|0;a[g+4>>0]=j;a[g+3>>0]=h;j=Mm(i|0,h|0,40)|0;a[g+2>>0]=j;j=Mm(i|0,h|0,48)|0;a[g+1>>0]=j;h=Mm(i|0,h|0,56)|0;a[g>>0]=h;f=f+1|0}while((f|0)!=(e>>>3|0))}return}function pg(b,d){b=b|0;d=d|0;do if(b){if(d>>>0<128){a[b>>0]=d;b=1;break}if(d>>>0<2048){a[b>>0]=d>>>6|192;a[b+1>>0]=d&63|128;b=2;break}if(d>>>0<55296|(d&-8192|0)==57344){a[b>>0]=d>>>12|224;a[b+1>>0]=d>>>6&63|128;a[b+2>>0]=d&63|128;b=3;break}if((d+-65536|0)>>>0<1048576){a[b>>0]=d>>>18|240;a[b+1>>0]=d>>>12&63|128;a[b+2>>0]=d>>>6&63|128;a[b+3>>0]=d&63|128;b=4;break}else{c[(gp()|0)>>2]=84;b=-1;break}}else b=1;while(0);return b|0}function qg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=a[b+11>>0]|0;if(f<<24>>24<0){g=(c[b+8>>2]&2147483647)+-1|0;h=c[b+4>>2]|0}else{g=10;h=f&255}if((g-h|0)>>>0>=e>>>0){if(e|0){if(f<<24>>24<0)g=c[b>>2]|0;else g=b;mh(g+h|0,d|0,e|0)|0;f=h+e|0;if((a[b+11>>0]|0)<0)c[b+4>>2]=f;else a[b+11>>0]=f;a[g+f>>0]=0}}else Kf(b,g,e-g+h|0,h,h,0,e,d);return}function rg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=a[b+8+3>>0]|0;if(e<<24>>24<0){f=(c[b+8>>2]&2147483647)+-1|0;g=c[b+4>>2]|0}else{f=1;g=e&255}if((g|0)==(f|0)){zf(b,f,1,f,f,0);if((a[b+8+3>>0]|0)<0)e=8;else e=7}else if(e<<24>>24<0)e=8;else e=7;if((e|0)==7)a[b+8+3>>0]=g+1;else if((e|0)==8){f=c[b>>2]|0;c[b+4>>2]=g+1;b=f}g=b+(g<<2)|0;c[g>>2]=d;c[g+4>>2]=0;return}function sg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;zq(b);e=c[a+8>>2]|0;do if((c[a+12>>2]|0)-e>>2>>>0>d>>>0)f=a+8|0;else{o=0;da(66,a+8|0,d+1|0);f=o;o=0;if(!(f&1)){f=a+8|0;e=c[a+8>>2]|0;break}e=Ya()|0;if(b|0)Vl(b);Ra(e|0)}while(0);a=c[e+(d<<2)>>2]|0;if(a){Vl(a);e=c[f>>2]|0}c[e+(d<<2)>>2]=b;return}function tg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=a[b+11>>0]|0;if(e<<24>>24<0){f=(c[b+8>>2]&2147483647)+-1|0;g=c[b+4>>2]|0}else{f=10;g=e&255}if((g|0)==(f|0)){ug(b,f,1,f,f);if((a[b+11>>0]|0)<0)e=8;else e=7}else if(e<<24>>24<0)e=8;else e=7;if((e|0)==7)a[b+11>>0]=g+1;else if((e|0)==8){f=c[b>>2]|0;c[b+4>>2]=g+1;b=f}g=b+g|0;a[g>>0]=d;a[g+1>>0]=0;return}function ug(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;if((-17-d|0)>>>0<e>>>0)nj();if((a[b+11>>0]|0)<0)i=c[b>>2]|0;else i=b;if(d>>>0<2147483623){e=(e+d|0)>>>0<d<<1>>>0?d<<1:e+d|0;e=e>>>0<11?11:e+16&-16}else e=-17;h=Wi(e)|0;if(g|0)mh(h|0,i|0,g|0)|0;if((f|0)!=(g|0))mh(h+g|0,i+g|0,f-g|0)|0;if((d|0)!=10)Zs(i);c[b>>2]=h;c[b+8>>2]=e|-2147483648;return}function vg(b){b=b|0;var d=0;if((a[49760]|0)==0?Jp(49760)|0:0){if((a[49768]|0)==0?Jp(49768)|0:0){b=53264;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[b+(d<<2)>>2]=0;d=d+1|0}b=b+12|0}while((b|0)!=53552);rb(138,0,n|0)|0}ym(53264,39732);ym(53276,39744);c[13388]=53264}return c[13388]|0}function wg(b){b=b|0;var d=0;if((a[49680]|0)==0?Jp(49680)|0:0){if((a[49688]|0)==0?Jp(49688)|0:0){b=52452;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[b+(d<<2)>>2]=0;d=d+1|0}b=b+12|0}while((b|0)!=52740);rb(134,0,n|0)|0}zm(52452,47524);zm(52464,47527);c[13185]=52452}return c[13185]|0}function xg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;l=0-(c[b+4>>2]|0)|0;k=0-(c[b+8>>2]|0)|0;j=0-(c[b+12>>2]|0)|0;i=0-(c[b+16>>2]|0)|0;h=0-(c[b+20>>2]|0)|0;g=0-(c[b+24>>2]|0)|0;f=0-(c[b+28>>2]|0)|0;e=0-(c[b+32>>2]|0)|0;d=0-(c[b+36>>2]|0)|0;c[a>>2]=0-(c[b>>2]|0);c[a+4>>2]=l;c[a+8>>2]=k;c[a+12>>2]=j;c[a+16>>2]=i;c[a+20>>2]=h;c[a+24>>2]=g;c[a+28>>2]=f;c[a+32>>2]=e;c[a+36>>2]=d;return}function yg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if(d|0){e=a[b+11>>0]|0;if(e<<24>>24<0){f=(c[b+8>>2]&2147483647)+-1|0;g=c[b+4>>2]|0}else{f=10;g=e&255}if((f-g|0)>>>0<d>>>0){ug(b,f,d-f+g|0,g,g);e=a[b+11>>0]|0}if(e<<24>>24<0)f=c[b>>2]|0;else f=b;ei(f+g|0,0,d|0)|0;e=g+d|0;if((a[b+11>>0]|0)<0)c[b+4>>2]=e;else a[b+11>>0]=e;a[f+e>>0]=0}return}function zg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=c[a>>2]|0;f=(c[a+4>>2]|0)-e|0;d=(c[b+4>>2]|0)+(0-(f>>2)<<2)|0;c[b+4>>2]=d;if((f|0)>0){mh(d|0,e|0,f|0)|0;e=b+4|0;d=c[b+4>>2]|0}else e=b+4|0;f=c[a>>2]|0;c[a>>2]=d;c[e>>2]=f;f=c[a+4>>2]|0;c[a+4>>2]=c[b+8>>2];c[b+8>>2]=f;f=c[a+8>>2]|0;c[a+8>>2]=c[b+12>>2];c[b+12>>2]=f;c[b>>2]=c[e>>2];return}function Ag(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0;j=i;h=i=i+63&-64;i=i+16|0;a[h>>0]=e;f=c[b+16>>2]|0;if(!f)if(!(Zi(b)|0)){f=c[b+16>>2]|0;g=4}else f=-1;else g=4;do if((g|0)==4){g=c[b+20>>2]|0;if(g>>>0<f>>>0?(e&255|0)!=(a[b+75>>0]|0):0){c[b+20>>2]=g+1;a[g>>0]=e;f=e&255;break}if((Kb[c[b+36>>2]&63](b,h,1)|0)==1)f=d[h>>0]|0;else f=-1}while(0);i=j;return f|0}function Bg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;f=i;d=i=i+63&-64;i=i+16|0;a:while(1){b=c[a+36>>2]|0;b=Qb[c[(c[b>>2]|0)+20>>2]&63](b,c[a+40>>2]|0,d+8|0,d+8+8|0,d)|0;g=(c[d>>2]|0)-(d+8)|0;if((Xl(d+8|0,1,g,c[a+32>>2]|0)|0)!=(g|0)){b=-1;break}switch(b|0){case 1:break;case 2:{b=-1;break a}default:{e=4;break a}}}if((e|0)==4)b=((Uh(c[a+32>>2]|0)|0)!=0)<<31>>31;i=f;return b|0}function Cg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;e=Ll(e)|0;o=0;h=va(32,e|0,51948)|0;i=o;o=0;if(i&1){i=Ya()|0;Vl(e);Ra(i|0)}else{Vl(e);ph(a,g+16|0,b,c[d>>2]|0,f,h);return c[b>>2]|0}return 0}function Dg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;e=Ll(e)|0;o=0;h=va(32,e|0,51948)|0;i=o;o=0;if(i&1){i=Ya()|0;Vl(e);Ra(i|0)}else{Vl(e);th(a,g+24|0,b,c[d>>2]|0,f,h);return c[b>>2]|0}return 0}function Eg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;e=Ll(e)|0;o=0;h=va(32,e|0,51916)|0;i=o;o=0;if(i&1){i=Ya()|0;Vl(e);Ra(i|0)}else{Vl(e);qh(a,g+16|0,b,c[d>>2]|0,f,h);return c[b>>2]|0}return 0}function Fg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;e=Ll(e)|0;o=0;h=va(32,e|0,51916)|0;i=o;o=0;if(i&1){i=Ya()|0;Vl(e);Ra(i|0)}else{Vl(e);uh(a,g+24|0,b,c[d>>2]|0,f,h);return c[b>>2]|0}return 0}function Gg(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+368|0;if((b|0)==0&((e|0)!=0|(f|0)!=0))Ta();if(!a)Ta();if((d+-1&255)>63)Ta();if(!((c|0)!=0|g<<24>>24==0))Ta();if((g&255)>64)Ta();if(!(g<<24>>24))Cf(j,d);else We(j,d,c,g);Oe(j,b,e,f);ne(j,a,d)|0;i=h;return}function Hg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+128|0;c[j+12>>2]=j+16+100;Ih(a,j+16|0,j+12|0,e,f,g);c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=j+16;g=(c[d>>2]|0)-b>>2;f=zo(c[a>>2]|0)|0;g=fd(b,j+8|0,g,j)|0;if(f|0)zo(f)|0;if((g|0)==-1)ik(47843);else{c[d>>2]=b+(g<<2);i=h;return}}function Ig(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=i=i+63&-64;i=i+48|0;ic(a,b);ic(a+80|0,b+40|0);hc(a+120|0,b+80|0);Gf(a+40|0,b,b+40|0);ic(d,a+40|0);Gf(a+40|0,a+80|0,a);Ff(a+80|0,a+80|0,a);Ff(a,d,a+40|0);Ff(a+120|0,a+120|0,a+80|0);i=c;return}function Jg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;e=Ll(e)|0;o=0;a=va(32,e|0,51948)|0;h=o;o=0;if(h&1){h=Ya()|0;Vl(e);Ra(h|0)}else{Vl(e);Vh(g+20|0,b,c[d>>2]|0,f,a);return c[b>>2]|0}return 0}function Kg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;e=Ll(e)|0;o=0;a=va(32,e|0,51916)|0;h=o;o=0;if(h&1){h=Ya()|0;Vl(e);Ra(h|0)}else{Vl(e);Wh(g+20|0,b,c[d>>2]|0,f,a);return c[b>>2]|0}return 0}function Lg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if(e>>>0>1073741807)nj();do if(e>>>0>=2)if((e+4&-4)>>>0>1073741823){e=db(4)|0;ls(e);sb(e|0,1944,114)}else{f=Wi((e+4&-4)<<2)|0;c[b>>2]=f;c[b+8>>2]=e+4&-4|-2147483648;c[b+4>>2]=e;b=f;break}else a[b+8+3>>0]=e;while(0);Fp(b,d,e);c[b+(e<<2)>>2]=0;return}function Mg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;if((e-d|0)>>>0>4294967279)nj();if((e-d|0)>>>0<11)a[b+11>>0]=e-d;else{g=Wi(e-d+16&-16)|0;c[b>>2]=g;c[b+8>>2]=e-d+16&-16|-2147483648;c[b+4>>2]=e-d;b=g}f=d;g=b;while(1){if((f|0)==(e|0))break;a[g>>0]=a[f>>0]|0;f=f+1|0;g=g+1|0}a[b+(e-d)>>0]=0;return}function Ng(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;h=i;j=i=i+63&-64;i=i+16|0;Lj(a+64|0,d|0,e|0)|0;mf(a,j,a+64|0,e,f,g);if((c[j>>2]|0)==64&(c[j+4>>2]|0)==0)if(b|0){e=go(e|0,f|0,64,0)|0;c[b>>2]=e;c[b+4>>2]=D;e=0}else e=0;else{if(b|0){c[b>>2]=0;c[b+4>>2]=0}e=go(e|0,f|0,64,0)|0;ei(a|0,0,e|0)|0;e=-1}i=h;return e|0}function Og(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if(d>>>0>1073741807)nj();do if(d>>>0>=2)if((d+4&-4)>>>0>1073741823){d=db(4)|0;ls(d);sb(d|0,1944,114)}else{f=Wi((d+4&-4)<<2)|0;c[b>>2]=f;c[b+8>>2]=d+4&-4|-2147483648;c[b+4>>2]=d;b=f;break}else a[b+8+3>>0]=d;while(0);Ep(b,d,e);c[b+(d<<2)>>2]=0;return}function Pg(a,b){a=+a;b=b|0;var d=0;if((b|0)>1023)if((b+-1023|0)>1023){b=(b+-2046|0)>1023?1023:b+-2046|0;a=a*8988465674311579538646525.0e283*8988465674311579538646525.0e283}else{b=b+-1023|0;a=a*8988465674311579538646525.0e283}else if((b|0)<-1022)if((b+1022|0)<-1022){b=(b+2044|0)<-1022?-1022:b+2044|0;a=a*2.2250738585072014e-308*2.2250738585072014e-308}else{b=b+1022|0;a=a*2.2250738585072014e-308}d=Km(b+1023|0,0,52)|0;b=D;c[k>>2]=d;c[k+4>>2]=b;return +(a*+h[k>>3])}function Qg(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,i=0;h=0;while(1){if((h|0)>=(e|0))break;f=c[a+24>>2]|0;g=c[a+28>>2]|0;if(f>>>0>=g>>>0){if((Pb[c[(c[a>>2]|0)+52>>2]&63](a,d[b>>0]|0)|0)==-1)break;b=b+1|0;h=h+1|0;continue}i=e-h|0;g=(i|0)<(g-f|0)?i:g-f|0;if(g){mh(f|0,b|0,g|0)|0;f=c[a+24>>2]|0}c[a+24>>2]=f+g;b=b+g|0;h=g+h|0}return h|0}function Rg(a,b){a=a|0;b=b|0;var c=0,d=0;d=i;c=i=i+63&-64;i=i+240|0;if(!(Wc(c+80|0,b)|0)){Om(c);Ff(c,c,c+80+40|0);od(c,c);Om(c+40|0);Gf(c+40|0,c+40|0,c+80+40|0);fc(c+40|0,c+40|0,c);Ld(a,c+40|0);a=0}else a=-1;i=d;return a|0}function Sg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;g=0;while(1){if((g|0)>=(d|0))break;e=c[a+24>>2]|0;f=c[a+28>>2]|0;if(e>>>0<f>>>0){h=d-g|0;f=(h|0)<(f-e>>2|0)?h:f-e>>2;Fp(e,b,f);c[a+24>>2]=(c[a+24>>2]|0)+(f<<2);b=b+(f<<2)|0;g=f+g|0;continue}if((Pb[c[(c[a>>2]|0)+52>>2]&63](a,c[b>>2]|0)|0)==-1)break;b=b+4|0;g=g+1|0}return g|0}function Tg(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;a:do switch(d&176|0){case 16:{d=a[b>>0]|0;switch(d<<24>>24){case 43:case 45:{b=b+1|0;break a}default:{}}if((c-b|0)>1&d<<24>>24==48){switch(a[b+1>>0]|0){case 88:case 120:break;default:{e=7;break a}}b=b+2|0}else e=7;break}case 32:{b=c;break}default:e=7}while(0);return b|0}function Ug(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;e=go(e|0,f|0,-64,-1)|0;f=D;do if(f>>>0>0|(f|0)==0&e>>>0>4294967231)h=7;else{if(ie(d,d+64|0,e,f,g)|0){ei(a|0,0,e|0)|0;h=7;break}if(b|0){c[b>>2]=e;c[b+4>>2]=f}Lj(a|0,d+64|0,e|0)|0;e=0}while(0);if((h|0)==7)if(!b)e=-1;else{c[b>>2]=0;c[b+4>>2]=0;e=-1}return e|0}function Vg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;l=c[b+4>>2]|0;k=c[b+8>>2]|0;j=c[b+12>>2]|0;i=c[b+16>>2]|0;h=c[b+20>>2]|0;g=c[b+24>>2]|0;f=c[b+28>>2]|0;e=c[b+32>>2]|0;d=c[b+36>>2]|0;c[a>>2]=c[b>>2];c[a+4>>2]=l;c[a+8>>2]=k;c[a+12>>2]=j;c[a+16>>2]=i;c[a+20>>2]=h;c[a+24>>2]=g;c[a+28>>2]=f;c[a+32>>2]=e;c[a+36>>2]=d;return}function Wg(){var b=0,d=0,e=0;b=i;d=i=i+63&-64;i=i+16|0;Fk(51612);c[12903]=38032;c[12911]=34156;c[12913]=51668;c[12915]=-1;a[51664]=0;Np(d,c[12904]|0);o=0;da(21,51612,d|0);e=o;o=0;if(e&1){e=Ya()|0;Lq(d);Kp(51612);Ra(e|0)}else{Lq(d);i=b;return}}function Xg(){var b=0,d=0,e=0;b=i;d=i=i+63&-64;i=i+16|0;Gk(51548);c[12887]=37968;c[12895]=34156;c[12897]=51604;c[12899]=-1;a[51600]=0;Np(d,c[12888]|0);o=0;da(20,51548,d|0);e=o;o=0;if(e&1){e=Ya()|0;Lq(d);Lp(51548);Ra(e|0)}else{Lq(d);i=b;return}}function Yg(b,d){b=b|0;d=d|0;var e=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;a[b+128>>0]=0;if(d|0){o=0;da(65,b|0,d|0);e=o;o=0;if(e&1){e=Ya()|0;ti(b);Ra(e|0)}e=c[b+4>>2]|0;do{c[e>>2]=0;e=(c[b+4>>2]|0)+4|0;c[b+4>>2]=e;d=d+-1|0}while((d|0)!=0)}return}function Zg(b){b=b|0;var d=0,e=0,f=0;a:do if(!(b&3)){d=b;f=4}else{e=b;d=b;while(1){if(!(a[e>>0]|0))break a;e=e+1|0;d=e;if(!(d&3)){d=e;f=4;break}}}while(0);if((f|0)==4){while(1){e=c[d>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))d=d+4|0;else break}if((e&255)<<24>>24)do d=d+1|0;while((a[d>>0]|0)!=0)}return d-b|0}function _g(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;k=i;i=i+96|0;if(!(yq(k+32|0,k)|0)){g=b;h=k+32|0;j=g+32|0;do{a[g>>0]=a[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(j|0));Cj(k+64|0,k+32|0,f);d=Jk(b+32|0,c,d,e,k+64|0,f,k)|0;_j(k,32);_j(k+32|0,32);_j(k+64|0,24)}else d=-1;i=k;return d|0}function $g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;h=i;e=i=i+63&-64;i=i+16|0;f=bc(240)|0;do if(f){c[e>>2]=c[d>>2];e=Rf(f,240,b,e)|0;if(e>>>0<240){b=kh(f,e+1|0)|0;c[a>>2]=b|0?b:f;break}kc(f);if((e|0)>=0?(g=bc(e+1|0)|0,c[a>>2]=g,(g|0)!=0):0)e=Rf(g,e+1|0,b,d)|0;else e=-1}else e=-1;while(0);i=h;return e|0}function ah(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=i=i+63&-64;i=i+16|0;b=(c[a+24>>2]|0)==0|b;c[a+16>>2]=b;if(!(b&c[a+20>>2])){i=d;return}b=db(16)|0;Qp();c[e>>2]=1;c[e+4>>2]=50864;o=0;Da(20,b|0,46458,e|0);e=o;o=0;if(e&1){e=Ya()|0;Xa(b|0);Ra(e|0)}else sb(b|0,616,40)}function bh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0.0,f=0,g=0,h=0,j=0;j=i;h=i=i+63&-64;i=i+16|0;if((a|0)==(b|0)){c[d>>2]=4;e=0.0}else{f=gp()|0;g=c[f>>2]|0;c[f>>2]=0;To()|0;e=+ks(a,h);a=c[f>>2]|0;if(!a)c[f>>2]=g;if((c[h>>2]|0)==(b|0)){if((a|0)==34)c[d>>2]=4}else{c[d>>2]=4;e=0.0}}i=j;return +e}function ch(a,b){a=+a;b=b|0;var d=0,e=0,f=0;h[k>>3]=a;d=c[k>>2]|0;e=c[k+4>>2]|0;f=Mm(d|0,e|0,52)|0;switch(f&2047|0){case 0:{if(a!=0.0){a=+ch(a*18446744073709551616.0,b);d=(c[b>>2]|0)+-64|0}else d=0;c[b>>2]=d;break}case 2047:break;default:{c[b>>2]=(f&2047)+-1022;c[k>>2]=d;c[k+4>>2]=e&-2146435073|1071644672;a=+h[k>>3]}}return +a}function dh(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0;j=Ib[c[(c[b+8>>2]|0)+20>>2]&127](b+8|0)|0;i=a[j+8+3>>0]|0;k=i<<24>>24<0?c[j>>2]|0:j;return yc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,k,k+((i<<24>>24<0?c[j+4>>2]|0:i&255)<<2)|0)|0}function eh(a,b,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;if(g>>>0>0|(g|0)==0&f>>>0>15){d=go(f|0,g|0,-16,-1)|0;i=_e(a,0,e,d,D,e+f+-16|0,h,i,j,k,l)|0}else i=-1;if(b|0){d=(i|0)==0;g=go(f|0,g|0,-16,-1)|0;c[b>>2]=d?g:0;c[b+4>>2]=d?D:0}return i|0}function fh(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0;j=Ib[c[(c[b+8>>2]|0)+20>>2]&127](b+8|0)|0;i=a[j+11>>0]|0;k=i<<24>>24<0?c[j>>2]|0:j;return xc(b,c[d>>2]|0,c[e>>2]|0,f,g,h,k,k+(i<<24>>24<0?c[j+4>>2]|0:i&255)|0)|0}function gh(a,b,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;if(g>>>0>0|(g|0)==0&f>>>0>15){d=go(f|0,g|0,-16,-1)|0;i=sf(a,0,e,d,D,e+f+-16|0,h,i,j,k,l)|0}else i=-1;if(b|0){d=(i|0)==0;g=go(f|0,g|0,-16,-1)|0;c[b>>2]=d?g:0;c[b+4>>2]=d?D:0}return i|0}function hh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;i=0;j=0;a:while(1){if((d|0)==(e|0)|j>>>0>=f>>>0)break;h=zo(c[a+8>>2]|0)|0;g=Qq(d,e-d|0,b)|0;if(h|0)zo(h)|0;switch(g|0){case -2:case -1:break a;case 0:{d=d+1|0;g=1;break}default:d=d+g|0}i=g+i|0;j=j+1|0}return i|0}function ih(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if(c>>>0>0|(c|0)==0&b>>>0>4294967295)while(1){e=nl(b|0,c|0,10,0)|0;d=d+-1|0;a[d>>0]=e|48;e=b;b=tq(b|0,c|0,10,0)|0;if(!(c>>>0>9|(c|0)==9&e>>>0>4294967295))break;else c=D}if(b)while(1){d=d+-1|0;a[d>>0]=(b>>>0)%10|0|48;if(b>>>0<10)break;else b=(b>>>0)/10|0}return d|0}function jh(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0,g=0,h=0;h=i;g=i=i+63&-64;i=i+112|0;d=g;f=d+112|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(f|0));c[g+4>>2]=a;c[g+8>>2]=-1;c[g+44>>2]=a;c[g+76>>2]=-1;Ek(g,0);e=+dc(g,2,1);d=(c[g+4>>2]|0)-(c[g+8>>2]|0)+(c[g+108>>2]|0)|0;if(b|0)c[b>>2]=d|0?a+d|0:a;i=h;return +e}function kh(a,b){a=a|0;b=b|0;var d=0,e=0;if(!a){a=bc(b)|0;return a|0}if(b>>>0>4294967231){c[(gp()|0)>>2]=12;a=0;return a|0}d=Tc(a+-8|0,b>>>0<11?16:b+11&-8)|0;if(d|0){a=d+8|0;return a|0}d=bc(b)|0;if(!d){a=0;return a|0}e=c[a+-4>>2]|0;e=(e&-8)-((e&3|0)==0?8:4)|0;mh(d|0,a|0,(e>>>0<b>>>0?e:b)|0)|0;kc(a);a=d;return a|0}function lh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=i=i+63&-64;i=i+16|0;og(e,a+64|0,16);f=Mm(c[a+72>>2]|0,c[a+72+4>>2]|0,3)|0;f=Sm((0<0|0==0&(f&127)>>>0<112?112:240)|0,(0<0|0==0&(f&127)>>>0<112?0:0)|0,f&127|0,0)|0;Rd(a,42294,f,D);Rd(a,e,16,0);og(b,a,64);_j(a,208);i=d;return}function mh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return eb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if(!e)return f|0;a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function nh(b,d){b=b|0;d=d|0;var e=0,f=0;e=a[b+11>>0]|0;if(e<<24>>24<0)f=c[b+4>>2]|0;else f=e&255;do if(f>>>0>=d>>>0)if(e<<24>>24<0){a[(c[b>>2]|0)+d>>0]=0;c[b+4>>2]=d;break}else{a[b+d>>0]=0;a[b+11>>0]=d;break}else yg(b,d-f|0);while(0);return}function oh(b,c){b=b|0;c=c|0;var e=0,f=0;e=i;f=i=i+63&-64;i=i+160|0;od(f+80|0,c+80|0);fc(f+40|0,c,f+80|0);fc(f,c+40|0,f+80|0);Ld(b,f);Ld(f+120|0,f+40|0);a[b+31>>0]=(d[b+31>>0]|0)^(d[f+120>>0]|0)<<7;i=e;return}function ph(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;a=Ib[c[(c[a+8>>2]|0)+4>>2]&127](a+8|0)|0;d=(uc(d,e,a,a+288|0,g,f,0)|0)-a|0;if((d|0)<288)c[b>>2]=((d|0)/12|0|0)%12|0;return}function qh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;a=Ib[c[(c[a+8>>2]|0)+4>>2]&127](a+8|0)|0;d=(vc(d,e,a,a+288|0,g,f,0)|0)-a|0;if((d|0)<288)c[b>>2]=((d|0)/12|0|0)%12|0;return}function rh(b,c,e,f){b=b|0;c=c|0;e=e|0;f=f|0;var g=0,h=0;if(!(f>>>0<2147483647&f<<1>>>0<c>>>0))Ta();if(!f)c=0;else{c=0;do{h=d[e+c>>0]|0;g=c<<1;a[b+g>>0]=(h>>>4)+87+(((h>>>4)+65526|0)>>>8&217);a[b+(g|1)>>0]=(((h&15)<<8)+22272+((h&15)+65526&55552)|0)>>>8;c=c+1|0}while((c|0)!=(f|0));c=f<<1}a[b+c>>0]=0;return b|0}function sh(b){b=b|0;var c=0,e=0;c=0;while(1){if((d[44018+c>>0]|0)==(b|0)){e=2;break}c=c+1|0;if((c|0)==87){c=87;b=44106;e=5;break}}if((e|0)==2)if(!c)c=44106;else{b=44106;e=5}if((e|0)==5)while(1){do{e=b;b=b+1|0}while((a[e>>0]|0)!=0);c=c+-1|0;if(!c){c=b;break}else e=5}return c|0}function th(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;a=Ib[c[c[a+8>>2]>>2]&127](a+8|0)|0;d=(uc(d,e,a,a+168|0,g,f,0)|0)-a|0;if((d|0)<168)c[b>>2]=((d|0)/12|0|0)%7|0;return}function uh(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;a=Ib[c[c[a+8>>2]>>2]&127](a+8|0)|0;d=(vc(d,e,a,a+168|0,g,f,0)|0)-a|0;if((d|0)<168)c[b>>2]=((d|0)/12|0|0)%7|0;return}function vh(b){b=b|0;var d=0;d=a[b+74>>0]|0;a[b+74>>0]=d+255|d;if((c[b+20>>2]|0)>>>0>(c[b+44>>2]|0)>>>0)Kb[c[b+36>>2]&63](b,0,0)|0;c[b+16>>2]=0;c[b+28>>2]=0;c[b+20>>2]=0;d=c[b>>2]|0;if(d&20)if(!(d&4))d=-1;else{c[b>>2]=d|32;d=-1}else{d=c[b+44>>2]|0;c[b+8>>2]=d;c[b+4>>2]=d;d=0}return d|0}function wh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if(e>>>0>4294967279)nj();if(e>>>0<11){a[b+11>>0]=e;if(e)f=6}else{f=Wi(e+16&-16)|0;c[b>>2]=f;c[b+8>>2]=e+16&-16|-2147483648;c[b+4>>2]=e;b=f;f=6}if((f|0)==6)mh(b|0,d|0,e|0)|0;a[b+e>>0]=0;return}function xh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if(d>>>0>4294967279)nj();if(d>>>0<11){a[b+11>>0]=d;if(d)f=6}else{f=Wi(d+16&-16)|0;c[b>>2]=f;c[b+8>>2]=d+16&-16|-2147483648;c[b+4>>2]=d;b=f;f=6}if((f|0)==6)ei(b|0,e|0,d|0)|0;a[b+d>>0]=0;return}function yh(){var b=0,d=0,e=0;do if((c[8530]|0)>=0?(It()|0)!=0:0){if((a[34119]|0)!=10?(b=c[8516]|0,b>>>0<(c[8515]|0)>>>0):0){c[8516]=b+1;a[b>>0]=10;break}Ag(34044,10)|0}else e=3;while(0);do if((e|0)==3){if((a[34119]|0)!=10?(d=c[8516]|0,d>>>0<(c[8515]|0)>>>0):0){c[8516]=d+1;a[d>>0]=10;break}Ag(34044,10)|0}while(0);return}function zh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+4>>2]|0;e=c[a>>2]|0;a:do if(d-e>>2>>>0>=b>>>0){if(d-e>>2>>>0>b>>>0)while(1){if((d|0)==(e+(b<<2)|0))break a;f=d+-4|0;c[a+4>>2]=f;d=f}}else jf(a,b-(d-e>>2)|0);while(0);return}function Ah(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;g=i;h=i=i+63&-64;i=i+208|0;c[h+64>>2]=0;c[h+64+4>>2]=0;c[h+64+8>>2]=0;c[h+64+12>>2]=0;f=h;j=400;k=f+64|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));Rd(h,b,d,e);lh(h,a);i=g;return}function Bh(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;do if(!(c>>>0>64|(d+-1|0)>>>0>63)){if(d>>>0>=256)Wa(42110,42130,53,42229);if(c>>>0>=256)Wa(42209,42130,54,42229);if((b|0)==0|(c|0)==0){Cf(a,d&255);b=0;break}else{We(a,d&255,b,c&255);b=0;break}}else b=-1;while(0);return b|0}function Ch(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=i=i+63&-64;i=i+112|0;c[h>>2]=0;c[h+4>>2]=a;c[h+44>>2]=a;c[h+8>>2]=(a|0)<0?-1:a+2147483647|0;c[h+76>>2]=-1;Ek(h,0);e=pc(h,d,1,e,f)|0;if(b|0)c[b>>2]=a+((c[h+4>>2]|0)+(c[h+108>>2]|0)-(c[h+8>>2]|0));i=g;return e|0}function Dh(a){a=a|0;var b=0,d=0;if((c[a+20>>2]|0)>>>0>(c[a+28>>2]|0)>>>0?(Kb[c[a+36>>2]&63](a,0,0)|0,(c[a+20>>2]|0)==0):0)b=-1;else{b=c[a+4>>2]|0;d=c[a+8>>2]|0;if(b>>>0<d>>>0)Kb[c[a+40>>2]&63](a,b-d|0,1)|0;c[a+16>>2]=0;c[a+28>>2]=0;c[a+20>>2]=0;c[a+8>>2]=0;c[a+4>>2]=0;b=0}return b|0}function Eh(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;b=c;while(1){if((e|0)==(f|0)){h=7;break}if((b|0)==(d|0)){e=-1;break}c=a[b>>0]|0;g=a[e>>0]|0;if(c<<24>>24<g<<24>>24){e=-1;break}if(g<<24>>24<c<<24>>24){e=1;break}e=e+1|0;b=b+1|0}if((h|0)==7)e=(b|0)!=(d|0)&1;return e|0}function Fh(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;c[b+12>>2]=0;c[b+16>>2]=f;do if(d)if(d>>>0<29&(a[f+112>>0]|0)==0){a[f+112>>0]=1;break}else{f=Wi(d<<2)|0;break}else f=0;while(0);c[b>>2]=f;e=f+(e<<2)|0;c[b+8>>2]=e;c[b+4>>2]=e;c[b+12>>2]=f+(d<<2);return}function Gh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=c[b+16>>2]|0;do if(f){if((f|0)!=(d|0)){c[b+36>>2]=(c[b+36>>2]|0)+1;c[b+24>>2]=2;a[b+54>>0]=1;break}if((c[b+24>>2]|0)==2)c[b+24>>2]=e}else{c[b+16>>2]=d;c[b+24>>2]=e;c[b+36>>2]=1}while(0);return}function Hh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;g=0;while(1){if((g|0)>=(e|0))break;f=c[b+12>>2]|0;if(f>>>0<(c[b+16>>2]|0)>>>0){c[b+12>>2]=f+1;f=a[f>>0]|0}else{f=Ib[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((f|0)==-1)break;f=f&255}a[d>>0]=f;d=d+1|0;g=g+1|0}return g|0}function Ih(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0;j=i;k=i=i+63&-64;i=i+16|0;a[k>>0]=37;a[k+1>>0]=g;a[k+2>>0]=h;a[k+3>>0]=0;if(h<<24>>24){a[k+1>>0]=h;a[k+2>>0]=g}c[e>>2]=d+(ab(d|0,(c[e>>2]|0)-d|0,k|0,f|0,c[b>>2]|0)|0);i=j;return}function Jh(a,b,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;if(f>>>0>4294967295|(f|0)==-1&e>>>0>4294967279)Ta();pf(a,a+e|0,0,d,e,f,g,h,i,0,k,l)|0;if(b|0){j=go(e|0,f|0,16,0)|0;c[b>>2]=j;c[b+4>>2]=D}return 0}function Kh(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;a=i;b=i=i+63&-64;i=i+16|0;c[b+4>>2]=d;c[b>>2]=g;h=xd(d,e,b+4|0,g,h,b,1114111,0)|0;c[f>>2]=c[b+4>>2];c[j>>2]=c[b>>2];i=a;return h|0}function Lh(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;a=i;b=i=i+63&-64;i=i+16|0;c[b+4>>2]=d;c[b>>2]=g;h=sd(d,e,b+4|0,g,h,b,1114111,0)|0;c[f>>2]=c[b+4>>2];c[j>>2]=c[b>>2];i=a;return h|0}function Mh(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;a=i;b=i=i+63&-64;i=i+16|0;c[b+4>>2]=d;c[b>>2]=g;h=Wd(d,e,b+4|0,g,h,b,1114111,0)|0;c[f>>2]=c[b+4>>2];c[j>>2]=c[b>>2];i=a;return h|0}function Nh(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;a=i;b=i=i+63&-64;i=i+16|0;c[b+4>>2]=d;c[b>>2]=g;h=yd(d,e,b+4|0,g,h,b,1114111,0)|0;c[f>>2]=c[b+4>>2];c[j>>2]=c[b>>2];i=a;return h|0}function Oh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=b;while(1){if((e|0)==(f|0)){h=7;break}if((a|0)==(d|0)){e=-1;break}b=c[a>>2]|0;g=c[e>>2]|0;if((b|0)<(g|0)){e=-1;break}if((g|0)<(b|0)){e=1;break}e=e+4|0;a=a+4|0}if((h|0)==7)e=(a|0)!=(d|0)&1;return e|0}function Ph(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;f=0;while(1){if((f|0)>=(d|0))break;e=c[a+12>>2]|0;if(e>>>0>=(c[a+16>>2]|0)>>>0){e=Ib[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((e|0)==-1)break}else{c[a+12>>2]=e+4;e=c[e>>2]|0}c[b>>2]=e;b=b+4|0;f=f+1|0}return f|0}function Qh(a,b,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;if(f>>>0>4294967295|(f|0)==-1&e>>>0>4294967279)Ta();Sf(a,a+e|0,0,d,e,f,g,h,i,0,k,l)|0;if(b|0){j=go(e|0,f|0,16,0)|0;c[b>>2]=j;c[b+4>>2]=D}return 0}function Rh(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;do if(!((b+-1|0)>>>0>63|g>>>0>64)){if(b>>>0>=256)Wa(42110,42130,18,42182);if(g>>>0<256){Gg(a,c,f,b&255,d,e,g&255);h=0;break}else Wa(42209,42130,19,42182)}else h=-1;while(0);return h|0}function Sh(a){a=a|0;var b=0,d=0;c[a>>2]=40560;d=0;while(1){b=c[a+8>>2]|0;if(d>>>0>=(c[a+12>>2]|0)-b>>2>>>0)break;b=c[b+(d<<2)>>2]|0;if(b|0)Vl(b);d=d+1|0}Oo(a+144|0);ti(a+8|0);return}function Th(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0;f=i;g=i=i+63&-64;i=i+160|0;Ah(c,e,32,0);a[c>>0]=(d[c>>0]|0)&248;a[c+31>>0]=(d[c+31>>0]|0)&63|64;$d(g,c);oh(b,g);Lj(c|0,e|0,32)|0;Lj(c+32|0,b|0,32)|0;i=f;return}function Uh(a){a=a|0;var b=0;if(!a){if(!(c[8595]|0))a=0;else a=Uh(c[8595]|0)|0;Qa(50332);b=c[12582]|0;if(b)do{if((c[b+20>>2]|0)>>>0>(c[b+28>>2]|0)>>>0)a=Dh(b)|0|a;b=c[b+56>>2]|0}while((b|0)!=0);ob(50332)}else a=Dh(a)|0;return a|0}function Vh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=bd(b,d,e,f,4)|0;if(!(c[e>>2]&4)){if((b|0)<69)b=b+2e3|0;else b=(b+-69|0)>>>0<31?b+1900|0:b;c[a>>2]=b+-1900}return}function Wh(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=id(b,d,e,f,4)|0;if(!(c[e>>2]&4)){if((b|0)<69)b=b+2e3|0;else b=(b+-69|0)>>>0<31?b+1900|0:b;c[a>>2]=b+-1900}return}function Xh(b){b=b|0;var d=0,e=0,f=0;d=c[b+4>>2]|0;e=c[b+8>>2]|0;while(1){if((e|0)==(d|0))break;f=e+-4|0;c[b+8>>2]=f;e=f}e=c[b>>2]|0;do if(e|0){d=c[b+16>>2]|0;if((d|0)==(e|0)){a[d+112>>0]=0;break}else{Zs(e);break}}while(0);return}function Yh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;a:do if(!(a[b+44>>0]|0)){f=d;d=0;while(1){if((d|0)>=(e|0))break a;if((Pb[c[(c[b>>2]|0)+52>>2]&63](b,c[f>>2]|0)|0)==-1)break a;f=f+4|0;d=d+1|0}}else d=Xl(d,4,e,c[b+32>>2]|0)|0;while(0);return d|0}function Zh(b,e,f){b=b|0;e=e|0;f=f|0;var g=0;a:do if(!(a[b+44>>0]|0)){g=e;e=0;while(1){if((e|0)>=(f|0))break a;if((Pb[c[(c[b>>2]|0)+52>>2]&63](b,d[g>>0]|0)|0)==-1)break a;g=g+1|0;e=e+1|0}}else e=Xl(e,1,f,c[b+32>>2]|0)|0;while(0);return e|0}function _h(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;g=i;h=i=i+63&-64;i=i+64|0;Ah(h,d,32,0);d=c;e=h;f=d+32|0;do{a[d>>0]=a[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));_j(h,64);h=fq(b,c)|0;i=g;return h|0}function $h(b,d){b=b|0;d=d|0;d=Ro(c[d>>2]|0,53716)|0;c[b+36>>2]=d;c[b+44>>2]=Ib[c[(c[d>>2]|0)+24>>2]&127](d)|0;d=c[b+36>>2]|0;a[b+53>>0]=(Ib[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[b+44>>2]|0)>8)ik(46498);else return}function ai(b,d){b=b|0;d=d|0;d=Ro(c[d>>2]|0,53708)|0;c[b+36>>2]=d;c[b+44>>2]=Ib[c[(c[d>>2]|0)+24>>2]&127](d)|0;d=c[b+36>>2]|0;a[b+53>>0]=(Ib[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[b+44>>2]|0)>8)ik(46498);else return}function bi(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;f=i;g=i=i+63&-64;i=i+64|0;Ah(g,c,32,0);a[g>>0]=(d[g>>0]|0)&248;a[g+31>>0]=(d[g+31>>0]|0)&63|64;c=g;e=b+32|0;do{a[b>>0]=a[c>>0]|0;b=b+1|0;c=c+1|0}while((b|0)<(e|0));_j(g,64);i=f;return 0}function ci(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=c[a+4>>2]|0;if(!(h&1))i=h>>8;else i=c[(c[e>>2]|0)+(h>>8)>>2]|0;a=c[a>>2]|0;Mb[c[(c[a>>2]|0)+20>>2]&31](a,b,d,e+i|0,h&2|0?f:2,g);return}function di(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if(a-b>>2>>>0<d>>>0){if(d|0)do{d=d+-1|0;c[a+(d<<2)>>2]=c[b+(d<<2)>>2]}while((d|0)!=0)}else if(d|0){e=a;while(1){d=d+-1|0;c[e>>2]=c[b>>2];if(!d)break;else{b=b+4|0;e=e+4|0}}}return a|0}function ei(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b>>0]=d;b=b+1|0}}while((b|0)<(f&~3|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b>>0]=d;b=b+1|0}return b-e|0}function fi(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;if((a|0)==(c[b+8>>2]|0))ig(b,d,e,f);else{a=c[a+8>>2]|0;Mb[c[(c[a>>2]|0)+20>>2]&31](a,b,d,e,f,g)}return}function gi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;f=i;e=i=i+63&-64;i=i+32|0;c[e>>2]=c[a+60>>2];c[e+4>>2]=0;c[e+8>>2]=b;c[e+12>>2]=e+20;c[e+16>>2]=d;if((Ip(xb(140,e|0)|0)|0)<0){c[e+20>>2]=-1;a=-1}else a=c[e+20>>2]|0;i=f;return a|0}function hi(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;h=i;g=i=i+63&-64;i=i+32|0;if(d>>>0<0|(d|0)==0&c>>>0<48)c=-1;else{Cj(g,b,e);c=go(c|0,d|0,-32,-1)|0;c=Zj(a,b+32|0,c,D,g,b,f)|0}i=h;return c|0}function ii(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;Lb[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0)}function ji(a){a=a|0;var b=0,e=0;b=c[a+4>>2]|0;e=b>>>0<(c[a+8>>2]|0)>>>0;do if((c[a+76>>2]|0)<0)if(e){c[a+4>>2]=b+1;b=d[b>>0]|0;break}else{b=Fj(a)|0;break}else if(e){c[a+4>>2]=b+1;b=d[b>>0]|0;break}else{b=Fj(a)|0;break}while(0);return b|0}function ki(b,d){b=b|0;d=d|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;if((a[d+11>>0]|0)<0)wh(b,c[d>>2]|0,c[d+4>>2]|0);else{c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2]}return}function li(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=bd(b,d,e,f,2)|0;f=c[e>>2]|0;if((b+-1|0)>>>0<12&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function mi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=id(b,d,e,f,2)|0;f=c[e>>2]|0;if((b+-1|0)>>>0<12&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function ni(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=c[a+4>>2]|0;if(!(g&1))h=g>>8;else h=c[(c[d>>2]|0)+(g>>8)>>2]|0;a=c[a>>2]|0;Db[c[(c[a>>2]|0)+24>>2]&31](a,b,d+h|0,g&2|0?e:2,f);return}function oi(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;i=i+480|0;Mf(g,f);kp(g,c,d,e);Mk(g,g+416|0);d=g+416|0;e=b+32|0;do{a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0}while((b|0)<(e|0));i=g;return}function pi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=bd(b,d,e,f,2)|0;f=c[e>>2]|0;if((b+-1|0)>>>0<31&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function qi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=bd(b,d,e,f,3)|0;f=c[e>>2]|0;if((b|0)<366&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function ri(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=id(b,d,e,f,2)|0;f=c[e>>2]|0;if((b+-1|0)>>>0<31&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function si(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=id(b,d,e,f,3)|0;f=c[e>>2]|0;if((b|0)<366&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function ti(b){b=b|0;var d=0,e=0,f=0;d=c[b>>2]|0;do if(d|0){e=c[b+4>>2]|0;while(1){if((e|0)==(d|0))break;f=e+-4|0;c[b+4>>2]=f;e=f}if((b+16|0)==(d|0)){a[b+128>>0]=0;break}else{Zs(d);break}}while(0);return}function ui(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=bd(b,d,e,f,2)|0;f=c[e>>2]|0;if((b|0)<13&(f&4|0)==0)c[a>>2]=b+-1;else c[e>>2]=f|4;return}function vi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=id(b,d,e,f,2)|0;f=c[e>>2]|0;if((b|0)<13&(f&4|0)==0)c[a>>2]=b+-1;else c[e>>2]=f|4;return}function wi(a){a=a|0;o=0;ba(129,51044);a=o;o=0;if(((!(a&1)?(o=0,ba(130,51128),a=o,o=0,!(a&1)):0)?(o=0,ba(129,51380),a=o,o=0,!(a&1)):0)?(o=0,ba(130,51464),a=o,o=0,!(a&1)):0)return;a=Za(0)|0;xr(a)}function xi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=bd(b,d,e,f,1)|0;f=c[e>>2]|0;if((b|0)<7&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function yi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=bd(b,d,e,f,2)|0;f=c[e>>2]|0;if((b|0)<61&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function zi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=bd(b,d,e,f,2)|0;f=c[e>>2]|0;if((b|0)<60&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function Ai(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=id(b,d,e,f,1)|0;f=c[e>>2]|0;if((b|0)<7&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function Bi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=id(b,d,e,f,2)|0;f=c[e>>2]|0;if((b|0)<61&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function Ci(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=id(b,d,e,f,2)|0;f=c[e>>2]|0;if((b|0)<60&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function Di(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=bd(b,d,e,f,2)|0;f=c[e>>2]|0;if((b|0)<24&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function Ei(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=id(b,d,e,f,2)|0;f=c[e>>2]|0;if((b|0)<24&(f&4|0)==0)c[a>>2]=b;else c[e>>2]=f|4;return}function Fi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=c[a+4>>2]|0;if(!(f&1))g=f>>8;else g=c[(c[d>>2]|0)+(f>>8)>>2]|0;a=c[a>>2]|0;Xb[c[(c[a>>2]|0)+28>>2]&31](a,b,d+g|0,f&2|0?e:2);return}function Gi(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=i=i+63&-64;i=i+80|0;c[b+36>>2]=18;if((c[b>>2]&64|0)==0?(c[g>>2]=c[b+60>>2],c[g+4>>2]=21505,c[g+8>>2]=g+12,nb(54,g|0)|0):0)a[b+75>>0]=-1;g=je(b,d,e)|0;i=f;return g|0}function Hi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;f=i;e=i=i+63&-64;i=i+16|0;Tb[c[(c[a>>2]|0)+12>>2]&31](e,a,b);if((c[e+4>>2]|0)==(c[d+4>>2]|0))b=(c[e>>2]|0)==(c[d>>2]|0);else b=0;i=f;return b|0}function Ii(b,d){b=b|0;d=d|0;var e=0;do if((b|0)!=-1){if((c[d+8>>2]|0)==0?vh(d)|0:0){b=-1;break}e=c[d+4>>2]|0;if(e>>>0>((c[d+44>>2]|0)+-8|0)>>>0){c[d+4>>2]=e+-1;a[e+-1>>0]=b;c[d>>2]=c[d>>2]&-17}else b=-1}else b=-1;while(0);return b|0}function Ji(b,d){b=b|0;d=d|0;var e=0;if(d>>>0>1073741823)oj();if(d>>>0<29&(a[b+128>>0]|0)==0){a[b+128>>0]=1;e=b+16|0}else e=Wi(d<<2)|0;c[b+4>>2]=e;c[b>>2]=e;c[b+8>>2]=e+(d<<2);return}function Ki(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;f=i;g=i=i+63&-64;i=i+112|0;e=g;h=e+112|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(h|0));c[g+32>>2]=45;c[g+44>>2]=a;c[g+76>>2]=-1;c[g+84>>2]=a;h=gc(g,b,d)|0;i=f;return h|0}function Li(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;oa(7,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)}function Mi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;oa(6,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)}function Ni(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;oa(5,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)}function Oi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;oa(4,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)}function Pi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;oa(3,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)}function Qi(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;oa(2,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)}function Ri(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;oa(1,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)}function Si(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;oa(0,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)}function Ti(a){a=a|0;var b=0,d=0;b=zo(c[a+8>>2]|0)|0;d=bf(0,0,4)|0;if(b|0)zo(b)|0;if(!d){b=c[a+8>>2]|0;if(b){b=zo(b)|0;if(!b)b=0;else{zo(b)|0;b=0}}else b=1}else b=-1;return b|0}function Ui(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;if((a|0)==(c[b+8>>2]|0))Gh(b,d,e);else{a=c[a+8>>2]|0;Xb[c[(c[a>>2]|0)+28>>2]&31](a,b,d,e)}return}function Vi(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=i=i+63&-64;i=i+16|0;c[f+4>>2]=b;c[f>>2]=d;b=0;d=0;do{b=a[(c[f>>2]|0)+d>>0]^a[(c[f+4>>2]|0)+d>>0]|b;d=d+1|0}while((d|0)!=32);i=e;return (((b&255)+511|0)>>>8&1)+-1|0}function Wi(a){a=a|0;var b=0,c=0;b=(a|0)==0?1:a;while(1){c=bc(b)|0;if(c|0){a=6;break}a=or()|0;if(!a){a=5;break}Ub[a&31]()}if((a|0)==5){c=db(4)|0;ls(c);sb(c|0,1944,114)}else if((a|0)==6)return c|0;return 0}function Xi(b,c){b=b|0;c=c|0;var d=0,e=0;e=a[b>>0]|0;d=a[c>>0]|0;if(e<<24>>24==0?1:e<<24>>24!=d<<24>>24)c=e;else{do{b=b+1|0;c=c+1|0;e=a[b>>0]|0;d=a[c>>0]|0}while(!(e<<24>>24==0?1:e<<24>>24!=d<<24>>24));c=e}return (c&255)-(d&255)|0}function Yi(a){a=a|0;var b=0,d=0;b=i;d=i=i+63&-64;i=i+32|0;c[d>>2]=a;c[d+4>>2]=131;c[d+8>>2]=0;if((c[a>>2]|0)!=-1){c[d+16>>2]=d;c[d+12>>2]=d+16;Re(a,d+12|0)}i=b;return (c[a+4>>2]|0)+-1|0}function Zi(b){b=b|0;var d=0;d=a[b+74>>0]|0;a[b+74>>0]=d+255|d;d=c[b>>2]|0;if(!(d&8)){c[b+8>>2]=0;c[b+4>>2]=0;d=c[b+44>>2]|0;c[b+28>>2]=d;c[b+20>>2]=d;c[b+16>>2]=d+(c[b+48>>2]|0);d=0}else{c[b>>2]=d|32;d=-1}return d|0}function _i(a){a=a|0;var b=0;c[a>>2]=37608;o=0;ba(126,a|0);b=o;o=0;if(b&1){b=Za(0)|0;xr(b)}else{Lq(a+28|0);kc(c[a+32>>2]|0);kc(c[a+36>>2]|0);kc(c[a+48>>2]|0);kc(c[a+60>>2]|0);return}}function $i(b,d){b=b|0;d=d|0;var e=0;if(((a[b>>0]|0)!=0?(Xi(b,46820)|0)!=0:0)?(Xi(b,45961)|0)!=0:0)d=0;else e=4;do if((e|0)==4)if(!d)if(!(c[12589]|0)){c[12589]=1;d=50360;break}else{d=Lm(4)|0;break}while(0);return d|0}function aj(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;j=i;i=i+32|0;if(!(Dp(j,g,h)|0)){d=ze(a,b,c,d,e,f,j)|0;_j(j,32)}else d=-1;i=j;return d|0}function bj(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;j=i;i=i+32|0;if(!(Dp(j,g,h)|0)){he(a,b,c,d,e,f,j)|0;_j(j,32);d=0}else d=-1;i=j;return d|0}function cj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=bd(b,d,e,f,4)|0;if(!(c[e>>2]&4))c[a>>2]=b+-1900;return}function dj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=id(b,d,e,f,4)|0;if(!(c[e>>2]&4))c[a>>2]=b+-1900;return}function ej(a,b){a=a|0;b=b|0;var d=0;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0&1;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+32|0;d=b+40|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));wk(a+28|0);return}function fj(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0;h=d;while(1){if((h|0)==(f|0))break;a=c[h>>2]|0;if(a>>>0<128)a=e[41480+(a<<1)>>1]|0;else a=0;b[g>>1]=a;g=g+2|0;h=h+4|0}return d+((f-d|0)>>>2<<2)|0}function gj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return yc(a,c[b>>2]|0,c[d>>2]|0,e,f,g,38680,38712)|0}function hj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return xc(a,c[b>>2]|0,c[d>>2]|0,e,f,g,47261,47269)|0}function ij(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=i=i+63&-64;i=i+16|0;c[h>>2]=f;f=zo(d)|0;d=Rf(a,b,e,h)|0;if(f|0)zo(f)|0;i=g;return d|0}function jj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Qc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function kj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Rc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function lj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Lc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function mj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Mc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function nj(){var a=0,b=0;a=db(8)|0;o=0;da(63,a|0,48885);b=o;o=0;if(b&1){b=Ya()|0;Xa(a|0);Ra(b|0)}else{c[a>>2]=41152;sb(a|0,1992,116)}}function oj(){var a=0,b=0;a=db(8)|0;o=0;da(63,a|0,48853);b=o;o=0;if(b&1){b=Ya()|0;Xa(a|0);Ra(b|0)}else{c[a>>2]=41152;sb(a|0,1992,116)}}function pj(b,d){b=b|0;d=d|0;a[b>>0]=0;c[b+4>>2]=d;d=d+(c[(c[d>>2]|0)+-12>>2]|0)|0;if(!(c[d+16>>2]|0)){d=c[d+72>>2]|0;if(d|0)xe(d);a[b>>0]=1}return}function qj(b,d){b=b|0;d=d|0;a[b>>0]=0;c[b+4>>2]=d;d=d+(c[(c[d>>2]|0)+-12>>2]|0)|0;if(!(c[d+16>>2]|0)){d=c[d+72>>2]|0;if(d|0)ye(d);a[b>>0]=1}return}function rj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;f=c[a+84>>2]|0;e=cf(f,0,d+256|0)|0;e=(e|0)==0?d+256|0:e-f|0;d=e>>>0<d>>>0?e:d;mh(b|0,f|0,d|0)|0;c[a+4>>2]=f+d;c[a+8>>2]=f+e;c[a+84>>2]=f+e;return d|0}function sj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Gc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function tj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Nc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function uj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Oc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function vj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Ec(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function wj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Ic(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function xj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Jc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function yj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Hc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function zj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Pc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function Aj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Fc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function Bj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Kc(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function Cj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=i=i+63&-64;i=i+368|0;fp(e,0,0,24)|0;cp(e,b,32,0)|0;cp(e,c,32,0)|0;Tp(e,a,24)|0;i=d;return}function Dj(a,b){a=a|0;b=b|0;c[a+4>>2]=b+-1;c[a>>2]=40672;c[a+8>>2]=46;c[a+12>>2]=44;c[a+16>>2]=0;c[a+16+4>>2]=0;c[a+16+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[a+16+(b<<2)>>2]=0;b=b+1|0}return}function Ej(a){a=a|0;var b=0,d=0;b=c[c[a>>2]>>2]|0;a=c[b+4>>2]|0;d=c[b+8>>2]|0;b=(c[b>>2]|0)+(d>>1)|0;if(d&1)a=c[(c[b>>2]|0)+a>>2]|0;Fb[a&255](b);return}function Fj(a){a=a|0;var b=0,e=0;e=i;b=i=i+63&-64;i=i+16|0;if((c[a+8>>2]|0)==0?(vh(a)|0)!=0:0)a=-1;else if((Kb[c[a+32>>2]&63](a,b,1)|0)==1)a=d[b>>0]|0;else a=-1;i=e;return a|0}function Gj(b,d){b=b|0;d=d|0;c[b+4>>2]=d+-1;c[b>>2]=40632;a[b+8>>0]=46;a[b+9>>0]=44;c[b+12>>2]=0;c[b+12+4>>2]=0;c[b+12+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[b+12+(d<<2)>>2]=0;d=d+1|0}return}function Hj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=i=i+63&-64;i=i+16|0;c[g>>2]=e;e=zo(b)|0;b=$g(a,d,g)|0;if(e|0)zo(e)|0;i=f;return b|0}function Ij(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;return Jb[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0)|0}function Jj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;d=i=i+63&-64;i=i+16|0;c[d>>2]=e;b=zo(b)|0;d=Ki(a,46822,d)|0;if(b|0)zo(b)|0;i=f;return d|0}function Kj(a,b){a=+a;b=+b;var d=0;h[k>>3]=b;d=c[k+4>>2]|0;b=+F(+a);h[k>>3]=b;d=d&-2147483648|c[k+4>>2];c[k>>2]=c[k>>2];c[k+4>>2]=d;return +(+h[k>>3])}function Lj(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b>>0]=a[c>>0]|0}b=e}else mh(b,c,d)|0;return b|0}function Mj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=S(b&65535,a&65535)|0;e=(c>>>16)+(S(b&65535,a>>>16)|0)|0;d=S(b>>>16,a&65535)|0;return (D=(e>>>16)+(S(b>>>16,a>>>16)|0)+(((e&65535)+d|0)>>>16)|0,e+d<<16|c&65535|0)|0}function Nj(b){b=b|0;if((a[49792]|0)==0?Jp(49792)|0:0){c[13395]=0;c[13396]=0;c[13397]=0;Lg(53580,39888,yo(39888)|0);rb(139,53580,n|0)|0}return 53580}function Oj(b){b=b|0;if((a[49784]|0)==0?Jp(49784)|0:0){c[13392]=0;c[13393]=0;c[13394]=0;Lg(53568,39840,yo(39840)|0);rb(139,53568,n|0)|0}return 53568}function Pj(b){b=b|0;if((a[49776]|0)==0?Jp(49776)|0:0){c[13389]=0;c[13390]=0;c[13391]=0;Lg(53556,39756,yo(39756)|0);rb(139,53556,n|0)|0}return 53556}function Qj(b){b=b|0;if((a[49800]|0)==0?Jp(49800)|0:0){c[13398]=0;c[13399]=0;c[13400]=0;Lg(53592,39924,yo(39924)|0);rb(139,53592,n|0)|0}return 53592}function Rj(a,b){a=a|0;b=b|0;fc(a,b,b+120|0);fc(a+40|0,b+40|0,b+80|0);fc(a+80|0,b+80|0,b+120|0);fc(a+120|0,b,b+40|0);return}function Sj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;if((a|0)==(c[b+8>>2]|0))ig(b,d,e,f);return}function Tj(b,d){b=b|0;d=d|0;Ib[c[(c[b>>2]|0)+24>>2]&127](b)|0;d=Ro(c[d>>2]|0,53716)|0;c[b+36>>2]=d;a[b+44>>0]=(Ib[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;return}function Uj(b,d){b=b|0;d=d|0;Ib[c[(c[b>>2]|0)+24>>2]&127](b)|0;d=Ro(c[d>>2]|0,53708)|0;c[b+36>>2]=d;a[b+44>>0]=(Ib[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;return}function Vj(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;b=d;while(1){if((b|0)==(e|0))break;h=c[b>>2]|0;a[g>>0]=h>>>0<128?h&255:f;g=g+1|0;b=b+4|0}return d+((e-d|0)>>>2<<2)|0}function Wj(b,c,d){b=b|0;c=c|0;d=d|0;if(!(tc(b,c,d)|0)){c=0;d=0;do{c=a[b+d>>0]|c;d=d+1|0}while((d|0)!=32);c=0-(((c&255)+511|0)>>>8&1)|0}else c=-1;return c|0}function Xj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=i;d=i=i+63&-64;i=i+32|0;if(!(Wj(d,c,b)|0)){cd(a,53860,d);a=0}else a=-1;i=e;return a|0}function Yj(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=i;i=i+32|0;oi(f,b,c,d,e);e=ll(a,f)|0;e=((f|0)==(a|0)?-1:e)|(Vi(f,a)|0);i=f;return e|0}function Zj(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;if(d>>>0<0|(d|0)==0&c>>>0<16)c=-1;else{c=go(c|0,d|0,-16,-1)|0;c=aj(a,b+16|0,b,c,D,e,f,g)|0}return c|0}function _j(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;f=i=i+63&-64;i=i+16|0;c[f>>2]=b;if(d|0){b=0;do{a[(c[f>>2]|0)+b>>0]=0;b=b+1|0}while((b|0)!=(d|0))}i=e;return}function $j(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;while(1){if((e|0)==(f|0)){e=f;break}a=c[e>>2]|0;if(a>>>0>=128)break;if(!((b[41480+(a<<1)>>1]&d)<<16>>16))break;e=e+4|0}return e|0}function ak(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=i=i+63&-64;i=i+16|0;we(g,b,c,d,e);e=ml(a,g)|0;i=f;return e|0}function bk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=b;while(1){if((e|0)==(d|0))break;a=c[e>>2]|0;if(a>>>0<128)a=c[36544+(a<<2)>>2]|0;c[e>>2]=a;e=e+4|0}return b+((d-b|0)>>>2<<2)|0}function ck(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=b;while(1){if((e|0)==(d|0))break;a=c[e>>2]|0;if(a>>>0<128)a=c[35008+(a<<2)>>2]|0;c[e>>2]=a;e=e+4|0}return b+((d-b|0)>>>2<<2)|0}function dk(b){b=b|0;if((a[49704]|0)==0?Jp(49704)|0:0){c[13189]=0;c[13190]=0;c[13191]=0;wh(52756,47551,11);rb(135,52756,n|0)|0}return 52756}function ek(b){b=b|0;if((a[49696]|0)==0?Jp(49696)|0:0){c[13186]=0;c[13187]=0;c[13188]=0;wh(52744,47530,20);rb(135,52744,n|0)|0}return 52744}function fk(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if(d>>>0<0|(d|0)==0&c>>>0<16)c=-1;else{c=go(c|0,d|0,-16,-1)|0;c=ze(a,b+16|0,b,c,D,e,f)|0}return c|0}function gk(b){b=b|0;if((a[49712]|0)==0?Jp(49712)|0:0){c[13192]=0;c[13193]=0;c[13194]=0;wh(52768,47563,8);rb(135,52768,n|0)|0}return 52768}function hk(b){b=b|0;if((a[49720]|0)==0?Jp(49720)|0:0){c[13195]=0;c[13196]=0;c[13197]=0;wh(52780,47572,8);rb(135,52780,n|0)|0}return 52780}function ik(a){a=a|0;var b=0;b=db(8)|0;o=0;da(60,b|0,a|0);a=o;o=0;if(a&1){a=Ya()|0;Xa(b|0);Ra(a|0)}else sb(b|0,1976,118)}function jk(a,b,d){a=a|0;b=b|0;d=d|0;if((d|0)==1){c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;wh(a,46422,35)}else hl(a,d);return}function kk(a){a=a|0;var b=0,d=0;b=c[a+40>>2]|0;while(1){if(!b)break;d=b+-1|0;Tb[c[(c[a+32>>2]|0)+(d<<2)>>2]&31](0,a,c[(c[a+36>>2]|0)+(d<<2)>>2]|0);b=d}return}function lk(b){b=b|0;var c=0;c=a[m+(b&255)>>0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)>>0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)>>0]|0;if((c|0)<8)return c+16|0;return (a[m+(b>>>24)>>0]|0)+24|0}function mk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Vf(a,d,e);return}function nk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Mg(a,d,e);return}function ok(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ka(7,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function pk(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ka(6,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function qk(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ka(5,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function rk(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ka(4,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function sk(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ka(3,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function tk(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ka(2,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function uk(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ka(1,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function vk(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ka(0,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function wk(a){a=a|0;var b=0,d=0;o=0;b=za(18)|0;d=o;o=0;if(d&1){d=Za(0)|0;xr(d)}else{d=c[b>>2]|0;c[a>>2]=d;zq(d);return}}function xk(b,c,d){b=b|0;c=c|0;d=d|0;if(!(d>>>0<1|(d|0)==1&c>>>0<0))Wa(43197,43217,172,43243);if(c|0){d=0;do{a[b+d>>0]=_a(0)|0;d=d+1|0}while((d|0)!=(c|0))}return}function yk(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;Ob[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)}function zk(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;while(1){if((e|0)==(f|0)){e=f;break}a=c[e>>2]|0;if(a>>>0<128?(b[41480+(a<<1)>>1]&d)<<16>>16:0)break;e=e+4|0}return e|0}function Ak(b,d,e){b=b|0;d=d|0;e=e|0;b=d;while(1){if((b|0)==(e|0))break;d=a[b>>0]|0;if(d<<24>>24>-1)d=c[36544+(d<<24>>24<<2)>>2]&255;a[b>>0]=d;b=b+1|0}return e|0}function Bk(b,d,e){b=b|0;d=d|0;e=e|0;b=d;while(1){if((b|0)==(e|0))break;d=a[b>>0]|0;if(d<<24>>24>-1)d=c[35008+(d<<24>>24<<2)>>2]&255;a[b>>0]=d;b=b+1|0}return e|0}function Ck(a){a=a|0;var b=0,d=0;c[a+64>>2]=0;c[a+64+4>>2]=0;c[a+64+8>>2]=0;c[a+64+12>>2]=0;b=400;d=a+64|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(d|0));return}function Dk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;if((a|0)==(c[b+8>>2]|0))Gh(b,d,e);return}function Ek(a,b){a=a|0;b=b|0;var d=0,e=0;c[a+104>>2]=b;d=c[a+8>>2]|0;e=c[a+4>>2]|0;c[a+108>>2]=d-e;if((b|0)!=0&(d-e|0)>(b|0))c[a+100>>2]=e+b;else c[a+100>>2]=d;return}function Fk(a){a=a|0;c[a>>2]=37688;wk(a+4|0);c[a+8>>2]=0;c[a+8+4>>2]=0;c[a+8+8>>2]=0;c[a+8+12>>2]=0;c[a+8+16>>2]=0;c[a+8+20>>2]=0;return}function Gk(a){a=a|0;c[a>>2]=37624;wk(a+4|0);c[a+8>>2]=0;c[a+8+4>>2]=0;c[a+8+8>>2]=0;c[a+8+12>>2]=0;c[a+8+16>>2]=0;c[a+8+20>>2]=0;return}function Hk(a,b){a=a|0;b=b|0;if(wl(a,b)|0)return c[(c[a+8>>2]|0)+(b<<2)>>2]|0;else{a=db(4)|0;ms(a);sb(a|0,2008,121)}return 0}function Ik(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;while(1){if((c|0)==(d|0))break;b=a[c>>0]|0;a[f>>0]=b<<24>>24>-1?b:e;f=f+1|0;c=c+1|0}return d|0}function Jk(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;if(d>>>0>0|(d|0)==0&c>>>0>4294967279)c=-1;else c=bj(a+16|0,a,b,c,d,e,f,g)|0;return c|0}function Kk(){var a=0,b=0;a=i;b=i=i+63&-64;i=i+16|0;if(!(mb(53832,22)|0)){b=kb(c[13459]|0)|0;i=a;return b|0}else Tm(49075,b);return 0}function Lk(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if(d>>>0>0|(d|0)==0&c>>>0>4294967279)c=-1;else{he(a+16|0,a,b,c,d,e,f)|0;c=0}return c|0}function Mk(a,b){a=a|0;b=b|0;var c=0;c=i;i=i+64|0;lh(a,c);Rd(a+208|0,c,64,0);lh(a+208|0,b);_j(c,64);i=c;return}function Nk(a){a=a|0;var b=0;if((Ib[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1)a=-1;else{b=c[a+12>>2]|0;c[a+12>>2]=b+4;a=c[b>>2]|0}return a|0}function Ok(a){a=a|0;var b=0;if((Ib[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1)a=-1;else{b=c[a+12>>2]|0;c[a+12>>2]=b+1;a=d[b>>0]|0}return a|0}function Pk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=0;while(1){if((b|0)==(d|0))break;e=(c[b>>2]|0)+(a<<4)|0;a=((e&-268435456)>>>24|e&-268435456)^e;b=b+4|0}return a|0}function Qk(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;b=0;while(1){if((c|0)==(d|0))break;e=(a[c>>0]|0)+(b<<4)|0;b=((e&-268435456)>>>24|e&-268435456)^e;c=c+1|0}return b|0}function Rk(a){a=a|0;var b=0,d=0;b=i;d=i=i+63&-64;i=i+16|0;kc(a);if(!(qb(c[13459]|0,0)|0)){i=b;return}else Tm(48972,d)}function Sk(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ua(7,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function Tk(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ua(6,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function Uk(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ua(5,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function Vk(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ua(4,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function Wk(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ua(3,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function Xk(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ua(2,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function Yk(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ua(1,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function Zk(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ua(0,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function _k(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;f=c[a+20>>2]|0;e=(c[a+16>>2]|0)-f|0;e=e>>>0>d>>>0?d:e;mh(f|0,b|0,e|0)|0;c[a+20>>2]=(c[a+20>>2]|0)+e;return d|0}function $k(a,b){a=a|0;b=b|0;var d=0,e=0;e=Zg(b)|0;d=Wi(e+13|0)|0;c[d>>2]=e;c[d+4>>2]=e;c[d+8>>2]=0;mh(d+12|0,b|0,e+1|0)|0;c[a>>2]=d+12;return}function al(a,b){a=a|0;b=b|0;fc(a,b,b+120|0);fc(a+40|0,b+40|0,b+80|0);fc(a+80|0,b+80|0,b+120|0);return}function bl(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=-1;c[a+8+4>>2]=-1;return}function cl(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;V(9)}function dl(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=i=i+63&-64;i=i+32|0;Wl(d,32);Th(a,b,d);_j(d,32);i=c;return}function el(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if(d|0){e=a;while(1){d=d+-1|0;c[e>>2]=c[b>>2];if(!d)break;else{b=b+4|0;e=e+4|0}}}return a|0}function fl(a){a=a|0;var b=0;if(a>>>0<2)b=0;else{do b=_a(0)|0;while(b>>>0<(((0-a|0)>>>0)%(a>>>0)|0)>>>0);b=(b>>>0)%(a>>>0)|0}return b|0}function gl(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Vb[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function hl(a,b){a=a|0;b=b|0;b=sh(b)|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;wh(a,b,Zg(b)|0);return}function il(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=i=i+63&-64;i=i+16|0;c[g>>2]=e;e=Rf(a,b,d,g)|0;i=f;return e|0}function jl(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[a+(b<<2)>>2]=0;b=b+1|0}return}function kl(a,b,c){a=a|0;b=b|0;c=c|0;gf(a,b,c&255);gf(a+40|0,b+40|0,c&255);gf(a+80|0,b+80|0,c&255);return}function ll(b,c){b=b|0;c=c|0;var d=0,e=0;d=0;e=0;do{d=(a[c+e>>0]^a[b+e>>0])&255|d;e=e+1|0}while((e|0)!=32);return ((d+511|0)>>>8&1)+-1|0}function ml(b,c){b=b|0;c=c|0;var d=0,e=0;d=0;e=0;do{d=(a[c+e>>0]^a[b+e>>0])&255|d;e=e+1|0}while((e|0)!=16);return ((d+511|0)>>>8&1)+-1|0}function nl(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+16|0;jd(a,b,d,e,f|0)|0;i=f;return (D=c[f+4>>2]|0,c[f>>2]|0)|0}function ol(a){a=a|0;a=c[a+8>>2]|0;if(a){a=zo(a)|0;if(!a)a=4;else{zo(a)|0;a=4}}else a=1;return a|0}function pl(){var a=0,b=0;a=i;b=i=i+63&-64;i=i+16|0;if(!(Sa(53836,174)|0)){i=a;return}else Tm(49025,b)}function ql(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=-1;c[a+8+4>>2]=-1;return}function rl(b,d){b=b|0;d=d|0;c[b>>2]=41132;$k(b+4|0,(a[d+11>>0]|0)<0?c[d>>2]|0:d);return}function sl(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Lg(a,40724,yo(40724)|0);return}function tl(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Lg(a,40704,yo(40704)|0);return}function ul(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c[f>>2]=d;c[i>>2]=g;return 3}function vl(a){a=a|0;var b=0,d=0;b=i;d=i=i+63&-64;i=i+16|0;c[d>>2]=c[a+60>>2];a=Ip(ub(6,d|0)|0)|0;i=b;return a|0}function wl(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;if((c[a+12>>2]|0)-d>>2>>>0>b>>>0)d=(c[d+(b<<2)>>2]|0)!=0;else d=0;return d|0}function xl(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;while(1){if((c|0)==(d|0))break;a[e>>0]=a[c>>0]|0;e=e+1|0;c=c+1|0}return d|0}function yl(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Cb[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function zl(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;while(1){if((d|0)==(e|0))break;c[f>>2]=a[d>>0];f=f+4|0;d=d+1|0}return e|0}function Al(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ia(7,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Bl(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ia(6,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Cl(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ia(5,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Dl(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ia(4,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function El(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ia(3,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Fl(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ia(2,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Gl(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ia(1,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Hl(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ia(0,a|0,b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Il(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if(d|0){e=a;while(1){d=d+-1|0;c[e>>2]=b;if(!d)break;else e=e+4|0}}return a|0}function Jl(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Og(a,1,45);return}function Kl(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;xh(a,1,45);return}function Ll(a){a=a|0;var b=0,d=0;d=i;b=i=i+63&-64;i=i+16|0;Np(b,c[a+28>>2]|0);i=d;return c[b>>2]|0}function Ml(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=i=i+63&-64;i=i+16|0;c[f>>2]=d;d=Ki(a,b,f)|0;i=e;return d|0}function Nl(a){a=a|0;var b=0,d=0;d=(c[a>>2]|0)+-4|0;b=c[d>>2]|0;c[d>>2]=b+-1;if((b+-1|0)<0)Zs((c[a>>2]|0)+-12|0);return}function Ol(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Nb[a&31](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function Pl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=Mj(a,c)|0;f=D;return (D=(S(b,c)|0)+(S(d,a)|0)+f|f&0,e|0|0)|0}function Ql(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;wh(a,48826,5);return}function Rl(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;wh(a,48821,4);return}function Sl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return zd(c,d,e,1114111,0)|0}function Tl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Cd(c,d,e,1114111,0)|0}function Ul(a,b,c){a=a|0;b=b|0;c=c|0;if(c>>>0<256)return ne(a,b,c&255)|0;else Wa(42110,42130,106,42261);return 0}function Vl(a){a=a|0;var b=0;b=c[a+4>>2]|0;c[a+4>>2]=b+-1;if(!b)Fb[c[(c[a>>2]|0)+8>>2]&255](a);return}function Wl(b,c){b=b|0;c=c|0;var d=0;if(c|0){d=0;do{a[b+d>>0]=_a(0)|0;d=d+1|0}while((d|0)!=(c|0))}return}function Xl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=S(c,b)|0;d=xf(a,e,d)|0;if((d|0)!=(e|0))c=(d>>>0)/(b>>>0)|0;return c|0}function Yl(a,b,d){a=a|0;b=b|0;d=d|0;ef(a,c[d>>2]|0,c[d+4>>2]|0,b);c[a>>2]=37912;return}function Zl(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Hb[a&63](b|0,c|0,d|0,e|0,f|0,g|0)|0}function _l(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){D=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}D=(b|0)<0?-1:0;return b>>c-32|0}function $l(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return ze(a,b,c,d,e,f,g)|0}function am(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Y(7,a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function bm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Y(6,a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function cm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Y(5,a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function dm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Y(4,a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function em(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Y(3,a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function fm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Y(2,a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function gm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Y(1,a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function hm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Y(0,a|0,b|0,c|0,d|0,e|0,f|0,g|0)|0}function im(a){a=a|0;sg(a,50032,Yi(53684)|0);return}function jm(a){a=a|0;sg(a,50024,Yi(53676)|0);return}function km(a){a=a|0;sg(a,50016,Yi(53668)|0);return}function lm(a){a=a|0;sg(a,50008,Yi(53660)|0);return}function mm(a){a=a|0;sg(a,50088,Yi(53620)|0);return}function nm(a){a=a|0;sg(a,50072,Yi(53612)|0);return}function om(a){a=a|0;sg(a,50056,Yi(53604)|0);return}function pm(a){a=a|0;sg(a,50040,Yi(52792)|0);return}function qm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;return Eb[a&31](b|0,c|0,d|0,e|0,f|0,+g)|0}function rm(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;V(7);return 0}function sm(){var a=0;a=ib(30)|0;if((a|0)>0)c[12575]=a;else a=c[12575]|0;if(a>>>0<16)Ta();else{Wl(53908,16);return}}function tm(a){a=a|0;sg(a,49968,Yi(51980)|0);return}function um(a){a=a|0;sg(a,49960,Yi(51972)|0);return}function vm(a){a=a|0;sg(a,49952,Yi(51964)|0);return}function wm(a){a=a|0;sg(a,49944,Yi(51940)|0);return}function xm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;he(a,b,c,d,e,f,g)|0;return 0}function ym(a,b){a=a|0;b=b|0;hg(a,b,yo(b)|0);return}function zm(a,b){a=a|0;b=b|0;jg(a,b,Zg(b)|0);return}function Am(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Mb[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function Bm(a){a=a|0;var b=0;c[a>>2]=40512;b=c[a+8>>2]|0;if((b|0)!=(To()|0))Zs(c[a+8>>2]|0);return}function Cm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sa(7,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Dm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sa(6,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Em(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sa(5,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Fm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sa(4,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Gm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sa(3,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Hm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sa(2,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Im(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sa(1,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Jm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sa(0,a|0,b|0,c|0,d|0,e|0,f|0,g|0)}function Km(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){D=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}D=a<<c-32;return 0}function Lm(a){a=a|0;var b=0;b=bc(a)|0;if(!b)return b|0;if(!(c[b+-4>>2]&3))return b|0;ei(b|0,0,a|0)|0;return b|0}function Mm(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){D=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}D=0;return b>>>c-32|0}function Nm(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Rh(a,b,c,d,e,f,g)|0}function Om(a){a=a|0;var b=0;c[a>>2]=1;a=a+4|0;b=a+36|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(b|0));return}function Pm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ((d-c|0)>>>0<e>>>0?d-c|0:e)|0}function Qm(a){a=a|0;c[a+16>>2]=c[a+16>>2]|1;if(!(c[a+20>>2]&1))return;else tb()}function Rm(){}function Sm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=b-d-(c>>>0>a>>>0|0)>>>0;return (D=d,a-c>>>0|0)|0}function Tm(a,b){a=a|0;b=b|0;var d=0;d=i=i+63&-64;i=i+16|0;c[d>>2]=b;ff(34044,a,d)|0;yh();Ta()}function Um(a,c,d){a=a|0;c=c|0;d=d|0;if(d>>>0<128)d=(b[41480+(d<<1)>>1]&c)<<16>>16!=0;else d=0;return d|0}function Vm(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Qb[a&63](b|0,c|0,d|0,e|0,f|0)|0}function Wm(a,b,d){a=a|0;b=b|0;d=d|0;return ((c[b>>2]|0)==(d|0)?(c[b+4>>2]|0)==(a|0):0)|0}function Xm(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Od(a,b,c,d,e,0,0,f);return}function Ym(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ee(a,b,c,d,e,1,f);return}function Zm(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ga(7,a|0,b|0,c|0,d|0,e|0,f|0)|0}function _m(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ga(6,a|0,b|0,c|0,d|0,e|0,f|0)|0}function $m(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ga(5,a|0,b|0,c|0,d|0,e|0,f|0)|0}function an(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ga(4,a|0,b|0,c|0,d|0,e|0,f|0)|0}function bn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ga(3,a|0,b|0,c|0,d|0,e|0,f|0)|0}function cn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ga(2,a|0,b|0,c|0,d|0,e|0,f|0)|0}function dn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ga(1,a|0,b|0,c|0,d|0,e|0,f|0)|0}function en(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ga(0,a|0,b|0,c|0,d|0,e|0,f|0)|0}function fn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return Wb[a&31](b|0,c|0,d|0,e|0,+f)|0}function gn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ak(a,b,c,d,e)|0}function hn(a){a=a|0;iq(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function jn(a){a=a|0;jq(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function kn(){if((a[50288]|0)==0?Jp(50288)|0:0){Mn();c[13438]=53748}return c[13438]|0}function ln(){if((a[50120]|0)==0?Jp(50120)|0:0){Uq();c[13436]=53740}return c[13436]|0}function mn(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;V(12)}function nn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ke(a,b,c,d,e,1,0,f);return}function on(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return aa(7,a|0,b|0,c|0,d|0,e|0,+f)|0}function pn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return aa(6,a|0,b|0,c|0,d|0,e|0,+f)|0}function qn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return aa(5,a|0,b|0,c|0,d|0,e|0,+f)|0}function rn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return aa(4,a|0,b|0,c|0,d|0,e|0,+f)|0}function sn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return aa(3,a|0,b|0,c|0,d|0,e|0,+f)|0}function tn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return aa(2,a|0,b|0,c|0,d|0,e|0,+f)|0}function un(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return aa(1,a|0,b|0,c|0,d|0,e|0,+f)|0}function vn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return aa(0,a|0,b|0,c|0,d|0,e|0,+f)|0}function wn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;mf(a,b,c,d,e,f);return 0}function xn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Db[a&31](b|0,c|0,d|0,e|0,f|0)}function yn(a){a=a|0;sg(a,49872,Yi(53724)|0);return}function zn(a){a=a|0;sg(a,49880,Yi(53732)|0);return}function An(a){a=a|0;qg(a,48969,2);return}function Bn(a){a=a|0;sg(a,49856,Yi(53716)|0);return}function Cn(a){a=a|0;sg(a,49848,Yi(53708)|0);return}function Dn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qa(7,a|0,b|0,c|0,d|0,e|0,f|0)}function En(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qa(6,a|0,b|0,c|0,d|0,e|0,f|0)}function Fn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qa(5,a|0,b|0,c|0,d|0,e|0,f|0)}function Gn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qa(4,a|0,b|0,c|0,d|0,e|0,f|0)}function Hn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qa(3,a|0,b|0,c|0,d|0,e|0,f|0)}function In(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qa(2,a|0,b|0,c|0,d|0,e|0,f|0)}function Jn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qa(1,a|0,b|0,c|0,d|0,e|0,f|0)}function Kn(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;qa(0,a|0,b|0,c|0,d|0,e|0,f|0)}function Ln(a,b){a=a|0;b=b|0;c[a+4>>2]=b+-1;c[a>>2]=40512;c[a+8>>2]=To()|0;return}function Mn(){var a=0;a=c[(ln()|0)>>2]|0;c[13437]=a;zq(a);return}function Nn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ie(a,b,c,d,e)|0}function On(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Ug(a,b,c,d,e,f)|0}function Pn(a){a=a|0;sg(a,49992,Yi(53644)|0);return}function Qn(a){a=a|0;sg(a,49984,Yi(53636)|0);return}function Rn(a){a=a|0;sg(a,49976,Yi(53628)|0);return}function Sn(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function Tn(a){a=a|0;sg(a,5e4,Yi(53652)|0);return}function Un(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function Vn(b){b=b|0;var d=0;c[b>>2]=40580;d=c[b+8>>2]|0;if(d|0?a[b+12>>0]|0:0)Ws(d);return}function Wn(a){a=a|0;sg(a,49912,Yi(51956)|0);return}function Xn(a){a=a|0;sg(a,49888,Yi(51928)|0);return}function Yn(a){a=a|0;sg(a,50112,Yi(53700)|0);return}function Zn(a){a=a|0;sg(a,50104,Yi(53692)|0);return}function _n(a){a=a|0;sg(a,49816,Yi(51908)|0);return}function $n(a){a=a|0;sg(a,49808,Yi(51900)|0);return}function ao(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Sb[a&31](b|0,c|0,d|0,e|0)|0}function bo(){var a=0;if(!(c[12574]|0)){Hs();sm();c[12574]=1;a=0}else a=1;return a|0}function co(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Ng(a,b,c,d,e,f)|0}function eo(a){a=a|0;sg(a,49840,Yi(51948)|0);return}function fo(a){a=a|0;sg(a,49824,Yi(51916)|0);return}function go(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return (D=b+d+(a+c>>>0>>>0<a>>>0|0)>>>0,a+c>>>0|0)|0}function ho(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;hp(a,b,c,d);return}function io(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Yj(a,b,c,d,e)|0}function jo(a){a=a|0;var b=0;b=c[a>>2]|0;if((b|0)!=(To()|0))Zs(c[a>>2]|0);return}function ko(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ya(7,a|0,b|0,c|0,d|0,e|0)|0}function lo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ya(6,a|0,b|0,c|0,d|0,e|0)|0}function mo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ya(5,a|0,b|0,c|0,d|0,e|0)|0}function no(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ya(4,a|0,b|0,c|0,d|0,e|0)|0}function oo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ya(3,a|0,b|0,c|0,d|0,e|0)|0}function po(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ya(2,a|0,b|0,c|0,d|0,e|0)|0}function qo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ya(1,a|0,b|0,c|0,d|0,e|0)|0}function ro(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ya(0,a|0,b|0,c|0,d|0,e|0)|0}function so(a,b){a=a|0;b=b|0;ki(a,b+16|0);return}function to(a,b){a=a|0;b=b|0;ki(a,b+12|0);return}function uo(a){a=a|0;_i(a+(c[(c[a>>2]|0)+-12>>2]|0)+4|0);return}function vo(a){a=a|0;_i(a+(c[(c[a>>2]|0)+-12>>2]|0)+8|0);return}function wo(a,b){a=a|0;b=b|0;if(b<<24>>24>-1)b=c[35008+(b<<24>>24<<2)>>2]&255;return b|0}function xo(a){a=a|0;var b=0;b=a+40|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(b|0));return}function yo(a){a=a|0;var b=0;b=a;while(1)if(!(c[b>>2]|0))break;else b=b+4|0;return b-a>>2|0}function zo(a){a=a|0;var b=0,d=0;b=(It()|0)+180|0;d=c[b>>2]|0;if(a|0)c[b>>2]=a;return d|0}function Ao(b){b=b|0;if((a[b+8+3>>0]|0)<0)Zs(c[b>>2]|0);return}function Bo(a,b,c){a=a|0;b=b|0;c=c|0;return -1}function Co(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;V(19);return 0}function Do(a,b){a=a|0;b=b|0;if(b<<24>>24>-1)b=c[36544+((b&255)<<2)>>2]&255;return b|0}function Eo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return Ka(7,a|0,b|0,c|0,d|0,+e)|0}function Fo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return Ka(6,a|0,b|0,c|0,d|0,+e)|0}function Go(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return Ka(5,a|0,b|0,c|0,d|0,+e)|0}function Ho(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return Ka(4,a|0,b|0,c|0,d|0,+e)|0}function Io(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return Ka(3,a|0,b|0,c|0,d|0,+e)|0}function Jo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return Ka(2,a|0,b|0,c|0,d|0,+e)|0}function Ko(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return Ka(1,a|0,b|0,c|0,d|0,+e)|0}function Lo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return Ka(0,a|0,b|0,c|0,d|0,+e)|0}function Mo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Oe(a,b,c,d);return}function No(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;jc(a,b,c,d,e);return 0}function Oo(b){b=b|0;if((a[b+11>>0]|0)<0)Zs(c[b>>2]|0);return}function Po(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Xb[a&31](b|0,c|0,d|0,e|0)}function Qo(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;return}function Ro(a,b){a=a|0;b=b|0;return Hk(a,Yi(b)|0)|0}function So(a,b){a=a|0;b=b|0;Wl(b,32);return fq(a,b)|0}function To(){if((a[49640]|0)==0?Jp(49640)|0:0)c[12984]=$i(46820,0)|0;return c[12984]|0}function Uo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_(7,a|0,b|0,c|0,d|0,e|0)}function Vo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_(6,a|0,b|0,c|0,d|0,e|0)}function Wo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_(5,a|0,b|0,c|0,d|0,e|0)}function Xo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_(4,a|0,b|0,c|0,d|0,e|0)}function Yo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_(3,a|0,b|0,c|0,d|0,e|0)}function Zo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_(2,a|0,b|0,c|0,d|0,e|0)}function _o(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_(1,a|0,b|0,c|0,d|0,e|0)}function $o(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;_(0,a|0,b|0,c|0,d|0,e|0)}function ap(a){a=a|0;c[a>>2]=40672;Oo(a+16|0);return}function bp(a){a=a|0;c[a>>2]=40632;Oo(a+12|0);return}function cp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Mo(a,b,c,d);return 0}function dp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;oi(a,b,c,d,e);return 0}function ep(a){a=a|0;if(a|0)Fb[c[(c[a>>2]|0)+4>>2]&255](a);return}function fp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Bh(a,b,c,d)|0}function gp(){var a=0;if(!(c[12576]|0))a=50348;else a=c[(It()|0)+64>>2]|0;return a|0}function hp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;be(a,b,c,d);return}function ip(a){a=a|0;c[a>>2]=37688;Lq(a+4|0);Zs(a);return}function jp(a){a=a|0;c[a>>2]=37624;Lq(a+4|0);Zs(a);return}function kp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Rd(a,b,c,d);return}function lp(a){a=a|0;jo(a+8|0);Zs(a);return}function mp(a,b,c){a=a|0;b=b|0;c=c|0;return _h(a,b,c)|0}function np(a,b){a=a|0;b=b|0;if(b>>>0<128)b=c[36544+(b<<2)>>2]|0;return b|0}function op(a,b){a=a|0;b=b|0;if(b>>>0<128)b=c[35008+(b<<2)>>2]|0;return b|0}function pp(a,b){a=a|0;b=b|0;c[a>>2]=41132;$k(a+4|0,b);return}function qp(a,b){a=a|0;b=b|0;c[a>>2]=41112;$k(a+4|0,b);return}function rp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Kb[a&63](b|0,c|0,d|0)|0}function sp(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;V(0);return 0}function tp(a){a=a|0;var b=0;b=c[12981]|0;c[12981]=b+1;c[a+4>>2]=b+1;return}function up(a,b,c){a=a|0;b=b|0;c=c|0;if(c|0)di(a,b,c)|0;return}function vp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ca(7,a|0,b|0,c|0,d|0)|0}function wp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ca(6,a|0,b|0,c|0,d|0)|0}function xp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ca(5,a|0,b|0,c|0,d|0)|0}function yp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ca(4,a|0,b|0,c|0,d|0)|0}function zp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ca(3,a|0,b|0,c|0,d|0)|0}function Ap(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ca(2,a|0,b|0,c|0,d|0)|0}function Bp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ca(1,a|0,b|0,c|0,d|0)|0}function Cp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Ca(0,a|0,b|0,c|0,d|0)|0}function Dp(a,b,c){a=a|0;b=b|0;c=c|0;return Xj(a,b,c)|0}function Ep(a,b,c){a=a|0;b=b|0;c=c|0;if(b|0)Il(a,c,b)|0;return}function Fp(a,b,c){a=a|0;b=b|0;c=c|0;if(c|0)el(a,b,c)|0;return}function Gp(b,c){b=b|0;c=c|0;b=Hf(b,c)|0;return ((a[b>>0]|0)==(c&255)<<24>>24?b:0)|0}function Hp(a){a=a|0;if((a+-48|0)>>>0<10)a=1;else a=((a|32)+-97|0)>>>0<6;return a&1|0}function Ip(a){a=a|0;if(a>>>0>4294963200){c[(gp()|0)>>2]=0-a;a=-1}return a|0}function Jp(b){b=b|0;if((a[b>>0]|0)==1)b=0;else{a[b>>0]=1;b=1}return b|0}function Kp(a){a=a|0;c[a>>2]=37688;Lq(a+4|0);return}function Lp(a){a=a|0;c[a>>2]=37624;Lq(a+4|0);return}function Mp(a){a=a|0;jo(a+8|0);return}function Np(a,b){a=a|0;b=b|0;c[a>>2]=b;zq(b);return}function Op(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;V(11)}function Pp(){var a=0;a=db(4)|0;ls(a);sb(a|0,1944,114)}function Qp(){if((a[49632]|0)==0?Jp(49632)|0:0)c[12716]=37932;return}function Rp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Tb[a&31](b|0,c|0,d|0)}function Sp(a,b,c){a=a|0;b=b|0;c=c|0;Th(a,b,c);return 0}function Tp(a,b,c){a=a|0;b=b|0;c=c|0;return Ul(a,b,c)|0}function Up(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+15&-16;return b|0}function Vp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ma(7,a|0,b|0,c|0,d|0)}function Wp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ma(6,a|0,b|0,c|0,d|0)}function Xp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ma(5,a|0,b|0,c|0,d|0)}function Yp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ma(4,a|0,b|0,c|0,d|0)}function Zp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ma(3,a|0,b|0,c|0,d|0)}function _p(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ma(2,a|0,b|0,c|0,d|0)}function $p(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ma(1,a|0,b|0,c|0,d|0)}function aq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ma(0,a|0,b|0,c|0,d|0)}function bq(a,b){a=a|0;b=b|0;if(!a)a=0;else a=pg(a,b)|0;return a|0}function cq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ah(a,b,c,d);return 0}function dq(a,b,c){a=a|0;b=b|0;c=c|0;return (b>>>0<128?b&255:c)|0}function eq(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;V(5);return 0}function fq(a,b){a=a|0;b=b|0;return $f(a,b)|0}function gq(a,b,c){a=a|0;b=b|0;c=c|0;return (b<<24>>24>-1?b:c)|0}function hq(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function iq(a){a=a|0;_i(a+4|0);Zs(a);return}function jq(a){a=a|0;_i(a+8|0);Zs(a);return}function kq(a){a=a|0;Kp(a);Zs(a);return}function lq(a){a=a|0;Lp(a);Zs(a);return}function mq(a){a=a|0;c[a>>2]=41132;Nl(a+4|0);return}function nq(a,b){a=a|0;b=b|0;ar(a,b);return}function oq(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;V(2);return 0}function pq(a,b,c){a=a|0;b=b|0;c=c|0;a=Ch(a,b,c,0,-2147483648)|0;return a|0}function qq(a,b,c){a=a|0;b=b|0;c=c|0;fe(a,64,0,b,c);return}function rq(a){a=a|0;c[a>>2]=41112;Nl(a+4|0);return}function sq(a,b){a=a|0;b=b|0;Ie(a,b);return}function tq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return jd(a,b,c,d,0)|0}function uq(a,b,c){a=a|0;b=b|0;c=c|0;return Wj(a,b,c)|0}function vq(a){a=a|0;if(!a)a=1;else a=(c[a>>2]|0)==0;return a&1|0}function wq(a){a=a|0;Bm(a);Zs(a);return}function xq(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;V(10)}function yq(a,b){a=a|0;b=b|0;return So(a,b)|0}function zq(a){a=a|0;c[a+4>>2]=(c[a+4>>2]|0)+1;return}function Aq(a,b,c){a=a|0;b=b|0;c=c|0;return Pb[a&63](b|0,c|0)|0}function Bq(a,b,c){a=a|0;b=b|0;c=c|0;a=Ch(a,b,c,-1,-1)|0;return a|0}function Cq(a,b,c){a=a|0;b=b|0;c=c|0;return ma(7,a|0,b|0,c|0)|0}function Dq(a,b,c){a=a|0;b=b|0;c=c|0;return ma(6,a|0,b|0,c|0)|0}function Eq(a,b,c){a=a|0;b=b|0;c=c|0;return ma(5,a|0,b|0,c|0)|0}function Fq(a,b,c){a=a|0;b=b|0;c=c|0;return ma(4,a|0,b|0,c|0)|0}function Gq(a,b,c){a=a|0;b=b|0;c=c|0;return ma(3,a|0,b|0,c|0)|0}function Hq(a,b,c){a=a|0;b=b|0;c=c|0;return ma(2,a|0,b|0,c|0)|0}function Iq(a,b,c){a=a|0;b=b|0;c=c|0;return ma(1,a|0,b|0,c|0)|0}function Jq(a,b,c){a=a|0;b=b|0;c=c|0;return ma(0,a|0,b|0,c|0)|0}function Kq(a,b,c){a=a|0;b=b|0;c=c|0;me(a,64,0,b,c);return}function Lq(a){a=a|0;Vl(c[a>>2]|0);return}function Mq(a){a=a|0;_i(a+4|0);return}function Nq(a){a=a|0;_i(a+8|0);return}function Oq(a){a=a|0;return 2}function Pq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;V(14);return 0}function Qq(a,b,c){a=a|0;b=b|0;c=c|0;return Be(0,a,b,c|0?c:50364)|0}function Rq(a,b){a=a|0;b=b|0;return fq(a,b)|0}function Sq(a,b,c){a=a|0;b=b|0;c=c|0;a=Bq(a,b,c)|0;return a|0}function Tq(a,b,c){a=a|0;b=b|0;c=c|0;sb(a|0,b|0,c|0)}function Uq(){Vc(50128,1);c[13435]=50128;return}function Vq(a,b){a=a|0;b=b|0;if(!o){o=a;p=b}}function Wq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;V(20);return 0}function Xq(a){a=a|0;return Yd(a,0)|0}function Yq(a){a=a|0;return Xd(a,0)|0}function Zq(){ae();rb(128,55996,n|0)|0;return}function _q(a,b,c){a=a|0;b=b|0;c=c|0;Gb[a&127](b|0,c|0)}function $q(a,b,c){a=a|0;b=b|0;c=c|0;a=pq(a,b,c)|0;return a|0}function ar(a,b){a=a|0;b=b|0;Ud(a,b);return}function br(a,b){a=a|0;b=b|0;return -1}function cr(a){a=a|0;return Yd(a,1)|0}function dr(a){a=a|0;return Xd(a,1)|0}function er(a,b,c){a=a|0;b=b|0;c=c|0;Ea(7,a|0,b|0,c|0)}function fr(a,b,c){a=a|0;b=b|0;c=c|0;Ea(6,a|0,b|0,c|0)}function gr(a,b,c){a=a|0;b=b|0;c=c|0;Ea(5,a|0,b|0,c|0)}function hr(a,b,c){a=a|0;b=b|0;c=c|0;Ea(4,a|0,b|0,c|0)}function ir(a,b,c){a=a|0;b=b|0;c=c|0;Ea(3,a|0,b|0,c|0)}function jr(a,b,c){a=a|0;b=b|0;c=c|0;Ea(2,a|0,b|0,c|0)}function kr(a,b,c){a=a|0;b=b|0;c=c|0;Ea(1,a|0,b|0,c|0)}function lr(a,b,c){a=a|0;b=b|0;c=c|0;Ea(0,a|0,b|0,c|0)}function mr(a){a=a|0;Ur(a);Zs(a);return}function nr(a,b){a=a|0;b=b|0;dl(a,b);return 0}function or(){var a=0;a=c[13460]|0;c[13460]=a+0;return a|0}function pr(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;V(1)}function qr(a,b,c){a=a|0;b=b|0;c=c|0;return rj(a,b,c)|0}function rr(a){a=a|0;Sh(a);Zs(a);return}function sr(a){a=a|0;ap(a);Zs(a);return}function tr(a){a=a|0;bp(a);Zs(a);return}function ur(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;V(16);return 0}function vr(a){a=a|0;mq(a);Zs(a);return}function wr(a,b){a=a|0;b=b|0;return Ib[a&127](b|0)|0}function xr(a){a=a|0;jb(a|0)|0;Ne()}function yr(a){a=a|0;return c[a+12>>2]|0}function zr(a,b){a=a|0;b=b|0;return b<<24>>24|0}function Ar(a){a=a|0;_i(a);Zs(a);return}function Br(a){a=a|0;Vn(a);Zs(a);return}function Cr(a){a=a|0;rq(a);Zs(a);return}function Dr(a){a=a|0;return c[a+8>>2]|0}function Er(a){a=a|0;Ur(a);return}function Fr(b){b=b|0;return a[b+9>>0]|0}function Gr(b){b=b|0;return a[b+8>>0]|0}function Hr(a){a=a|0;return -1}function Ir(a,b){a=a|0;b=b|0;return wa(7,a|0,b|0)|0}function Jr(a,b){a=a|0;b=b|0;return wa(6,a|0,b|0)|0}function Kr(a,b){a=a|0;b=b|0;return wa(5,a|0,b|0)|0}function Lr(a,b){a=a|0;b=b|0;return wa(4,a|0,b|0)|0}function Mr(a,b){a=a|0;b=b|0;return wa(3,a|0,b|0)|0}function Nr(a,b){a=a|0;b=b|0;return wa(2,a|0,b|0)|0}function Or(a,b){a=a|0;b=b|0;return wa(1,a|0,b|0)|0}function Pr(a,b){a=a|0;b=b|0;return wa(0,a|0,b|0)|0}function Qr(a,b){a=a|0;b=b|0;i=a;j=b}function Rr(a){a=a|0;return 2147483647}function Sr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;V(21)}function Tr(a){a=a|0;return Us(a|0)|0}function Ur(a){a=a|0;mq(a);return}function Vr(a){a=a|0;return ((a|0)==32|(a+-9|0)>>>0<5)&1|0}function Wr(a,b){a=a|0;b=b|0;Fb[a&255](b|0)}function Xr(a){a=a|0;return 4}function Yr(a,b){a=a|0;b=b|0;return b|0}function Zr(a){a=a|0;return 127}function _r(a,b){a=a|0;b=b|0;ea(7,a|0,b|0)}function $r(a,b){a=a|0;b=b|0;ea(6,a|0,b|0)}function as(a,b){a=a|0;b=b|0;ea(5,a|0,b|0)}function bs(a,b){a=a|0;b=b|0;ea(4,a|0,b|0)}function cs(a,b){a=a|0;b=b|0;ea(3,a|0,b|0)}function ds(a,b){a=a|0;b=b|0;ea(2,a|0,b|0)}function es(a,b){a=a|0;b=b|0;ea(1,a|0,b|0)}function fs(a,b){a=a|0;b=b|0;ea(0,a|0,b|0)}function gs(a){a=a|0;return 1}function hs(a,b){a=a|0;b=b|0;return}function is(a,b,c){a=a|0;b=b|0;c=c|0;V(8);return 0}function js(a){a=a|0;return c[a+4>>2]|0}function ks(a,b){a=a|0;b=b|0;return +(+jh(a,b))}function ls(a){a=a|0;c[a>>2]=41092;return}function ms(a){a=a|0;c[a>>2]=41172;return}function ns(a){a=a|0;return 46413}function os(a,b){a=+a;b=+b;return +(+Kj(a,b))}function ps(a,b){a=+a;b=b|0;return +(+Pg(a,b))}function qs(a,b,c){a=a|0;b=b|0;c=c|0;V(17)}function rs(a){a=a|0;return Rb[a&31]()|0}function ss(a,b){a=+a;b=b|0;return +(+ch(a,b))}function ts(a){a=a|0;return (a+-48|0)>>>0<10|0}function us(a){a=a|0;return ia(7,a|0)|0}function vs(a){a=a|0;return ia(6,a|0)|0}function ws(a){a=a|0;return ia(5,a|0)|0}function xs(a){a=a|0;return ia(4,a|0)|0}function ys(a){a=a|0;return ia(3,a|0)|0}function zs(a){a=a|0;return ia(2,a|0)|0}function As(a){a=a|0;return ia(1,a|0)|0}function Bs(a){a=a|0;return ia(0,a|0)|0}function Cs(a,b){a=+a;b=+b;return +(+nd(a,b))}function Ds(a,b){a=a|0;b=b|0;V(13);return 0}function Es(){return _a(0)|0}function Fs(){return 12}function Gs(a){a=a|0;Ub[a&31]()}function Hs(){gb(1);return}function Is(a){a=a|0;return 49502}function Js(a){a=a|0;return Hp(a)|0}function Ks(a){a=a|0;return 49580}function Ls(a){a=a|0;ca(7,a|0)}function Ms(a){a=a|0;ca(6,a|0)}function Ns(a){a=a|0;ca(5,a|0)}function Os(a){a=a|0;ca(4,a|0)}function Ps(a){a=a|0;ca(3,a|0)}function Qs(a){a=a|0;ca(2,a|0)}function Rs(a){a=a|0;ca(1,a|0)}function Ss(a){a=a|0;ca(0,a|0)}function Ts(a,b){a=a|0;b=b|0;V(4)}function Us(a){a=a|0;return 0}function Vs(){fb()}function Ws(a){a=a|0;Zs(a);return}function Xs(a){a=a|0;i=a}function Ys(){return 41992}function Zs(a){a=a|0;kc(a);return}function _s(a){a=a|0;D=a}function $s(){return 384}function at(){tb()}function bt(a){a=a|0;V(6);return 0}function ct(){return 3}function dt(){return 9}function et(a){a=a|0;return a|0}function ft(){return 43255}function gt(a){a=a|0;return}function ht(){return}function it(){return Aa(7)|0}function jt(){return Aa(6)|0}function kt(){return Aa(5)|0}function lt(){return Aa(4)|0}function mt(){return Aa(3)|0}function nt(){return Aa(2)|0}function ot(){return Aa(1)|0}function pt(){return Aa(0)|0}function qt(){return 8}function rt(){return 24}function st(){return D|0}function tt(){return 48}function ut(){return 16}function vt(){return i|0}function wt(){return 64}function xt(){return 32}function yt(a){a=a|0;V(3)}function zt(){V(15);return 0}function At(){Ga(7)}function Bt(){Ga(6)}function Ct(){Ga(5)}function Dt(){Ga(4)}function Et(){Ga(3)}function Ft(){Ga(2)}function Gt(){Ga(1)}function Ht(){Ga(0)}function It(){return 0}function Jt(){V(18)}

// EMSCRIPTEN_END_FUNCS
var Cb=[sp,hm,gm,fm,em,dm,cm,bm,am,sp,sp,sp,sp,sp,sp,sp,sp,sp,Nf,Uf,ad,md,$c,kd,vc,uc,sp,sp,sp,sp,sp,sp];var Db=[pr,$o,_o,Zo,Yo,Xo,Wo,Vo,Uo,pr,pr,pr,pr,pr,pr,pr,pr,pr,mg,Ee,pd,pr,pr,pr,pr,pr,pr,pr,pr,pr,pr,pr];var Eb=[oq,vn,un,tn,sn,rn,qn,pn,on,oq,oq,oq,oq,oq,oq,oq,oq,oq,Xc,Uc,oq,oq,oq,oq,oq,oq,oq,oq,oq,oq,oq,oq];var Fb=[yt,Ss,Rs,Qs,Ps,Os,Ns,Ms,Ls,yt,yt,yt,yt,yt,yt,yt,yt,yt,_i,Ar,Lp,jp,Kp,ip,Nq,jq,vo,jn,Nq,jq,vo,jn,Mq,iq,uo,hn,Mq,iq,uo,hn,Er,mr,gt,Ws,lq,kq,lq,kq,gt,Ws,ep,gt,Ws,gt,Ws,gt,Ws,gt,Ws,gt,Ws,gt,Ws,gt,Ws,Mp,lp,Mp,lp,gt,Ws,gt,Ws,gt,Ws,gt,Ws,gt,Ws,gt,Ws,gt,Ws,gt,Ws,gt,Ws,gt,Ws,gt,Ws,Ws,Bm,wq,Sh,rr,Vn,Br,bp,tr,ap,sr,Ws,Ws,Ws,Ws,Ws,Ur,vr,gt,Ws,gt,gt,Ws,gt,Ws,rq,Cr,mq,vr,Cr,gt,Ws,Ws,gt,gt,kk,Qm,wi,ye,xe,tp,Bf,ue,se,Oo,Af,te,re,Ao,gt,ik,Ce,kc,_d,$n,_n,fo,eo,Cn,Bn,yn,zn,Xn,Wn,wm,vm,um,tm,Rn,Qn,Pn,Tn,lm,km,jm,im,pm,om,nm,mm,Zn,Yn,Ej,Rk,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt,yt];var Gb=[Ts,fs,es,ds,cs,bs,as,$r,_r,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,hs,hs,ai,$h,Uj,Tj,jl,jl,jl,Kl,Sn,Sn,jl,jl,jl,Kl,Sn,Sn,jl,jl,jl,Jl,Sn,Sn,jl,jl,jl,Jl,Sn,Sn,hs,hs,to,Rl,Ql,so,tl,sl,qj,ah,pj,nh,pp,tg,rg,qp,Yg,Ji,zh,rl,Tm,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts,Ts];var Hb=[eq,en,dn,cn,bn,an,$m,_m,Zm,eq,eq,eq,eq,eq,eq,eq,eq,eq,Bd,Bj,Aj,wj,xj,xj,vj,lj,mj,mj,wc,Ad,zj,yj,tj,uj,uj,sj,jj,kj,kj,sc,af,$e,Ze,Ye,hj,fh,Fg,Eg,Kg,gj,dh,Dg,Cg,Jg,ed,dd,Fe,De,eq,eq,eq,eq,eq,eq];var Ib=[bt,Bs,As,zs,ys,xs,ws,vs,us,bt,bt,bt,bt,bt,bt,bt,bt,bt,vl,Us,Us,Hr,Ok,Us,Us,Hr,Nk,js,ns,Yq,dr,Xq,cr,Bg,Bg,Oq,pe,Hd,wg,ek,dk,gk,hk,Oq,oe,Gd,vg,Pj,Oj,Nj,Qj,Zr,Zr,Us,Zr,Zr,Us,Rr,Rr,Us,Rr,Rr,Us,Us,Us,Xr,Ti,Us,ol,Gr,Fr,Dr,yr,gs,gs,gs,Us,Us,Xr,Is,js,Ks,Tr,Tr,Tr,Wi,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt,bt];var Jb=[rm,vk,uk,tk,sk,rk,qk,pk,ok,rm,rm,rm,rm,rm,rm,rm,rm,rm,ac,$b,rm,rm,rm,rm,rm,rm,rm,rm,rm,rm,rm,rm];var Kb=[is,Jq,Iq,Hq,Gq,Fq,Eq,Dq,Cq,is,is,is,is,is,is,is,is,is,je,gi,hf,Gi,_k,hq,Hh,Qg,hq,Ph,Sg,Hi,Wm,Zh,Yh,Qk,Pk,Bo,Bo,Ak,Bk,gq,Um,bk,ck,dq,lg,qr,is,is,is,is,is,is,is,is,is,is,is,is,is,is,is,is,is,is];var Lb=[cl,Si,Ri,Qi,Pi,Oi,Ni,Mi,Li,cl,cl,cl,cl,cl,cl,cl,cl,cl,Zc,_c,cl,cl,cl,cl,cl,cl,cl,cl,cl,cl,cl,cl];var Mb=[xq,Kn,Jn,In,Hn,Gn,Fn,En,Dn,xq,xq,xq,xq,xq,xq,xq,xq,xq,bl,bl,le,qd,Sj,fi,Ve,xq,xq,xq,xq,xq,xq,xq];var Nb=[Op,Jm,Im,Hm,Gm,Fm,Em,Dm,Cm,Op,Op,Op,Op,Op,Op,Op,Op,Op,gd,zc,hd,Ac,Op,Op,Op,Op,Op,Op,Op,Op,Op,Op];var Ob=[mn,Zk,Yk,Xk,Wk,Vk,Uk,Tk,Sk,mn,mn,mn,mn,mn,mn,mn,mn,mn,rc,qc,nc,oc,mn,mn,mn,mn,mn,mn,mn,mn,mn,mn];var Pb=[Ds,Pr,Or,Nr,Mr,Lr,Kr,Jr,Ir,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,br,br,br,br,Te,Se,Qe,Pe,Do,wo,Yr,np,op,zr,Ro,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds,Ds];var Qb=[Pq,ro,qo,po,oo,no,mo,lo,ko,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Eh,Oh,Nd,Le,Ke,Me,Qd,He,Je,Ge,Un,Tl,eg,hh,Ik,Vj,Un,Pm,Un,Sl,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq,Pq];var Rb=[zt,pt,ot,nt,mt,lt,kt,jt,it,zt,zt,zt,zt,zt,zt,zt,zt,zt,kn,Kk,zt,zt,zt,zt,zt,zt,zt,zt,zt,zt,zt,zt];var Sb=[ur,Cp,Bp,Ap,zp,yp,xp,wp,vp,ur,ur,ur,ur,ur,ur,ur,ur,ur,xl,fj,zk,$j,zl,Hj,ur,ur,ur,ur,ur,ur,ur,ur];var Tb=[qs,lr,kr,jr,ir,hr,gr,fr,er,qs,qs,qs,qs,qs,qs,qs,qs,qs,Qo,jk,Yl,Of,Lf,rf,Lf,qf,wh,Tq,qg,Xe,qs,qs];var Ub=[Jt,Ht,Gt,Ft,Et,Dt,Ct,Bt,At,Jt,Jt,Jt,Jt,Jt,Jt,Jt,Jt,Jt,yf,Vs,Pp,at,pl,Jt,Jt,Jt,Jt,Jt,Jt,Jt,Jt,Jt];var Vb=[Co,Hl,Gl,Fl,El,Dl,Cl,Bl,Al,Co,Co,Co,Co,Co,Co,Co,Co,Co,Dc,Bc,Mh,Nh,Td,Id,ul,ul,Kh,Lh,Co,Co,Co,Co];var Wb=[Wq,Lo,Ko,Jo,Io,Ho,Go,Fo,Eo,Wq,Wq,Wq,Wq,Wq,Wq,Wq,Wq,Wq,wd,vd,ud,td,Wq,Wq,Wq,Wq,Wq,Wq,Wq,Wq,Wq,Wq];var Xb=[Sr,aq,$p,_p,Zp,Yp,Xp,Wp,Vp,Sr,Sr,Sr,Sr,Sr,Sr,Sr,Sr,Sr,ql,ql,nk,mk,Dk,Ui,kg,Sr,Sr,Sr,Sr,Sr,Sr,Sr];return{_sodium_library_version_minor:ct,_sodium_hex2bin:Ue,_llvm_cttz_i32:lk,_bitshift64Lshr:Mm,_crypto_box_noncebytes:rt,_crypto_aead_chacha20poly1305_ietf_keybytes:xt,_crypto_aead_chacha20poly1305_ietf_encrypt_detached:pf,_crypto_scalarmult_base:Rq,_crypto_aead_chacha20poly1305_abytes:ut,_crypto_auth_bytes:xt,_crypto_sign_open:On,_crypto_aead_chacha20poly1305_decrypt_detached:sf,_memcpy:mh,_crypto_box_seed_keypair:mp,___udivmoddi4:jd,_crypto_box_open_easy_afternm:fk,_crypto_sign_ed25519_sk_to_curve25519:bi,_pthread_cond_broadcast:Us,_crypto_aead_chacha20poly1305_keybytes:xt,_crypto_box_seal:_g,_free:kc,_crypto_shorthash:No,_crypto_auth_keybytes:xt,_crypto_aead_chacha20poly1305_npubbytes:qt,_crypto_sign_seedbytes:xt,_crypto_box_detached_afternm:xm,_crypto_auth:dp,_randombytes_random:Es,_crypto_sign_keypair:nr,_crypto_shorthash_keybytes:ut,_crypto_generichash_statebytes:$s,_crypto_aead_chacha20poly1305_encrypt_detached:Sf,_sodium_library_version_major:dt,_i64Add:go,_sodium_version_string:ft,_crypto_generichash_keybytes_max:wt,_crypto_sign_ed25519_pk_to_curve25519:Rg,_crypto_sign_publickeybytes:xt,_crypto_box_beforenmbytes:xt,_crypto_generichash:Nm,_crypto_aead_chacha20poly1305_ietf_nsecbytes:It,_randombytes_stir:Hs,_crypto_aead_chacha20poly1305_ietf_encrypt:Jh,_crypto_box_beforenm:Dp,_crypto_aead_chacha20poly1305_ietf_decrypt:eh,_randombytes_close:It,_crypto_shorthash_bytes:qt,_crypto_box_secretkeybytes:xt,_crypto_aead_chacha20poly1305_encrypt:Qh,_pthread_mutex_lock:Us,_crypto_box_detached:bj,_randombytes_buf:Wl,_sodium_bin2hex:rh,_bitshift64Ashr:_l,_crypto_box_open_detached:aj,_crypto_scalarmult_bytes:xt,_crypto_auth_verify:io,_crypto_box_seal_open:hi,_crypto_secretbox_detached:he,_crypto_secretbox_easy:Lk,_memset:ei,_crypto_box_open_detached_afternm:$l,_crypto_box_sealbytes:tt,_i64Subtract:Sm,_crypto_box_seedbytes:xt,_crypto_hash:cq,_crypto_box_easy_afternm:Lk,_crypto_box_macbytes:ut,_crypto_box_publickeybytes:xt,___udivdi3:tq,_crypto_generichash_primitive:Ys,_crypto_sign_secretkeybytes:wt,___muldsi3:Mj,_crypto_scalarmult_scalarbytes:xt,_crypto_generichash_keybytes_min:ut,_malloc:bc,_crypto_aead_chacha20poly1305_decrypt:gh,_memmove:Lj,_crypto_aead_chacha20poly1305_ietf_decrypt_detached:_e,_crypto_sign:co,_crypto_secretbox_noncebytes:rt,_crypto_box_keypair:yq,_crypto_generichash_keybytes:xt,_crypto_generichash_bytes_min:ut,_sodium_init:bo,_crypto_secretbox_macbytes:ut,_crypto_secretbox_keybytes:xt,_randombytes:xk,_crypto_hash_bytes:wt,_crypto_generichash_bytes:xt,_crypto_generichash_bytes_max:wt,_crypto_secretbox_open_detached:ze,___muldi3:Pl,_bitshift64Shl:Km,___uremdi3:nl,_crypto_sign_verify_detached:Nn,_crypto_box_open_easy:Zj,_crypto_generichash_init:fp,_crypto_aead_chacha20poly1305_nsecbytes:It,_crypto_sign_bytes:wt,_pthread_self:It,_crypto_generichash_update:cp,_pthread_mutex_unlock:Us,_crypto_scalarmult:uq,_crypto_aead_chacha20poly1305_ietf_abytes:ut,_crypto_sign_detached:wn,_crypto_box_easy:Jk,_crypto_secretbox_open_easy:fk,_crypto_generichash_final:Tp,_randombytes_uniform:fl,_crypto_sign_seed_keypair:Sp,_crypto_aead_chacha20poly1305_ietf_npubbytes:Fs,__GLOBAL__I_000101:Zq,__GLOBAL__sub_I_iostream_cpp:ht,runPostSets:Rm,stackAlloc:Up,stackSave:vt,stackRestore:Xs,establishStackSpace:Qr,setThrew:Vq,setTempRet0:_s,getTempRet0:st,dynCall_iiiiiiii:yl,dynCall_viiiii:xn,dynCall_iiiiiid:qm,dynCall_vi:Wr,dynCall_vii:_q,dynCall_iiiiiii:Zl,dynCall_ii:wr,dynCall_iiiiiiiiiiii:Ij,dynCall_iiii:rp,dynCall_viiiiiiiiiiiiiii:ii,dynCall_viiiiii:Am,dynCall_viiiiiii:Ol,dynCall_viiiiiiiiii:yk,dynCall_iii:Aq,dynCall_iiiiii:Vm,dynCall_i:rs,dynCall_iiiii:ao,dynCall_viii:Rp,dynCall_v:Gs,dynCall_iiiiiiiii:gl,dynCall_iiiiid:fn,dynCall_viiii:Po}})


// EMSCRIPTEN_END_ASM
(Module.asmGlobalArg,Module.asmLibraryArg,buffer);var _sodium_library_version_minor=Module["_sodium_library_version_minor"]=asm["_sodium_library_version_minor"];var _llvm_cttz_i32=Module["_llvm_cttz_i32"]=asm["_llvm_cttz_i32"];var _bitshift64Lshr=Module["_bitshift64Lshr"]=asm["_bitshift64Lshr"];var _crypto_box_noncebytes=Module["_crypto_box_noncebytes"]=asm["_crypto_box_noncebytes"];var _crypto_aead_chacha20poly1305_ietf_keybytes=Module["_crypto_aead_chacha20poly1305_ietf_keybytes"]=asm["_crypto_aead_chacha20poly1305_ietf_keybytes"];var _crypto_aead_chacha20poly1305_ietf_encrypt_detached=Module["_crypto_aead_chacha20poly1305_ietf_encrypt_detached"]=asm["_crypto_aead_chacha20poly1305_ietf_encrypt_detached"];var _crypto_scalarmult_base=Module["_crypto_scalarmult_base"]=asm["_crypto_scalarmult_base"];var _crypto_aead_chacha20poly1305_abytes=Module["_crypto_aead_chacha20poly1305_abytes"]=asm["_crypto_aead_chacha20poly1305_abytes"];var _crypto_auth_bytes=Module["_crypto_auth_bytes"]=asm["_crypto_auth_bytes"];var _crypto_sign_open=Module["_crypto_sign_open"]=asm["_crypto_sign_open"];var _crypto_aead_chacha20poly1305_decrypt_detached=Module["_crypto_aead_chacha20poly1305_decrypt_detached"]=asm["_crypto_aead_chacha20poly1305_decrypt_detached"];var _memcpy=Module["_memcpy"]=asm["_memcpy"];var _crypto_box_seed_keypair=Module["_crypto_box_seed_keypair"]=asm["_crypto_box_seed_keypair"];var ___udivmoddi4=Module["___udivmoddi4"]=asm["___udivmoddi4"];var _crypto_box_open_easy_afternm=Module["_crypto_box_open_easy_afternm"]=asm["_crypto_box_open_easy_afternm"];var _crypto_sign_ed25519_sk_to_curve25519=Module["_crypto_sign_ed25519_sk_to_curve25519"]=asm["_crypto_sign_ed25519_sk_to_curve25519"];var __GLOBAL__I_000101=Module["__GLOBAL__I_000101"]=asm["__GLOBAL__I_000101"];var _crypto_aead_chacha20poly1305_keybytes=Module["_crypto_aead_chacha20poly1305_keybytes"]=asm["_crypto_aead_chacha20poly1305_keybytes"];var _crypto_box_seal=Module["_crypto_box_seal"]=asm["_crypto_box_seal"];var _free=Module["_free"]=asm["_free"];var runPostSets=Module["runPostSets"]=asm["runPostSets"];var _pthread_cond_broadcast=Module["_pthread_cond_broadcast"]=asm["_pthread_cond_broadcast"];var _crypto_auth_keybytes=Module["_crypto_auth_keybytes"]=asm["_crypto_auth_keybytes"];var _crypto_aead_chacha20poly1305_npubbytes=Module["_crypto_aead_chacha20poly1305_npubbytes"]=asm["_crypto_aead_chacha20poly1305_npubbytes"];var _crypto_shorthash=Module["_crypto_shorthash"]=asm["_crypto_shorthash"];var _crypto_sign_seedbytes=Module["_crypto_sign_seedbytes"]=asm["_crypto_sign_seedbytes"];var _crypto_box_detached_afternm=Module["_crypto_box_detached_afternm"]=asm["_crypto_box_detached_afternm"];var _crypto_auth=Module["_crypto_auth"]=asm["_crypto_auth"];var _randombytes_random=Module["_randombytes_random"]=asm["_randombytes_random"];var _crypto_sign_keypair=Module["_crypto_sign_keypair"]=asm["_crypto_sign_keypair"];var _crypto_generichash_keybytes_min=Module["_crypto_generichash_keybytes_min"]=asm["_crypto_generichash_keybytes_min"];var _crypto_generichash_statebytes=Module["_crypto_generichash_statebytes"]=asm["_crypto_generichash_statebytes"];var _crypto_aead_chacha20poly1305_encrypt_detached=Module["_crypto_aead_chacha20poly1305_encrypt_detached"]=asm["_crypto_aead_chacha20poly1305_encrypt_detached"];var _sodium_library_version_major=Module["_sodium_library_version_major"]=asm["_sodium_library_version_major"];var _sodium_version_string=Module["_sodium_version_string"]=asm["_sodium_version_string"];var _crypto_generichash_keybytes_max=Module["_crypto_generichash_keybytes_max"]=asm["_crypto_generichash_keybytes_max"];var _crypto_sign_ed25519_pk_to_curve25519=Module["_crypto_sign_ed25519_pk_to_curve25519"]=asm["_crypto_sign_ed25519_pk_to_curve25519"];var _crypto_aead_chacha20poly1305_nsecbytes=Module["_crypto_aead_chacha20poly1305_nsecbytes"]=asm["_crypto_aead_chacha20poly1305_nsecbytes"];var _crypto_box_beforenmbytes=Module["_crypto_box_beforenmbytes"]=asm["_crypto_box_beforenmbytes"];var _crypto_generichash=Module["_crypto_generichash"]=asm["_crypto_generichash"];var _crypto_aead_chacha20poly1305_ietf_nsecbytes=Module["_crypto_aead_chacha20poly1305_ietf_nsecbytes"]=asm["_crypto_aead_chacha20poly1305_ietf_nsecbytes"];var _randombytes_stir=Module["_randombytes_stir"]=asm["_randombytes_stir"];var _crypto_aead_chacha20poly1305_ietf_encrypt=Module["_crypto_aead_chacha20poly1305_ietf_encrypt"]=asm["_crypto_aead_chacha20poly1305_ietf_encrypt"];var _crypto_box_beforenm=Module["_crypto_box_beforenm"]=asm["_crypto_box_beforenm"];var _crypto_shorthash_keybytes=Module["_crypto_shorthash_keybytes"]=asm["_crypto_shorthash_keybytes"];var _crypto_aead_chacha20poly1305_ietf_decrypt=Module["_crypto_aead_chacha20poly1305_ietf_decrypt"]=asm["_crypto_aead_chacha20poly1305_ietf_decrypt"];var _randombytes_close=Module["_randombytes_close"]=asm["_randombytes_close"];var _crypto_shorthash_bytes=Module["_crypto_shorthash_bytes"]=asm["_crypto_shorthash_bytes"];var _crypto_box_secretkeybytes=Module["_crypto_box_secretkeybytes"]=asm["_crypto_box_secretkeybytes"];var _crypto_aead_chacha20poly1305_encrypt=Module["_crypto_aead_chacha20poly1305_encrypt"]=asm["_crypto_aead_chacha20poly1305_encrypt"];var _pthread_mutex_lock=Module["_pthread_mutex_lock"]=asm["_pthread_mutex_lock"];var _crypto_box_detached=Module["_crypto_box_detached"]=asm["_crypto_box_detached"];var _randombytes_buf=Module["_randombytes_buf"]=asm["_randombytes_buf"];var _sodium_bin2hex=Module["_sodium_bin2hex"]=asm["_sodium_bin2hex"];var _bitshift64Ashr=Module["_bitshift64Ashr"]=asm["_bitshift64Ashr"];var _crypto_generichash_init=Module["_crypto_generichash_init"]=asm["_crypto_generichash_init"];var _crypto_box_open_detached=Module["_crypto_box_open_detached"]=asm["_crypto_box_open_detached"];var _crypto_scalarmult_bytes=Module["_crypto_scalarmult_bytes"]=asm["_crypto_scalarmult_bytes"];var _crypto_auth_verify=Module["_crypto_auth_verify"]=asm["_crypto_auth_verify"];var _crypto_sign_detached=Module["_crypto_sign_detached"]=asm["_crypto_sign_detached"];var _crypto_secretbox_detached=Module["_crypto_secretbox_detached"]=asm["_crypto_secretbox_detached"];var _crypto_secretbox_easy=Module["_crypto_secretbox_easy"]=asm["_crypto_secretbox_easy"];var _memset=Module["_memset"]=asm["_memset"];var _crypto_box_open_detached_afternm=Module["_crypto_box_open_detached_afternm"]=asm["_crypto_box_open_detached_afternm"];var _crypto_box_sealbytes=Module["_crypto_box_sealbytes"]=asm["_crypto_box_sealbytes"];var _i64Subtract=Module["_i64Subtract"]=asm["_i64Subtract"];var _crypto_box_seedbytes=Module["_crypto_box_seedbytes"]=asm["_crypto_box_seedbytes"];var _crypto_hash=Module["_crypto_hash"]=asm["_crypto_hash"];var _crypto_box_easy_afternm=Module["_crypto_box_easy_afternm"]=asm["_crypto_box_easy_afternm"];var __GLOBAL__sub_I_iostream_cpp=Module["__GLOBAL__sub_I_iostream_cpp"]=asm["__GLOBAL__sub_I_iostream_cpp"];var _crypto_box_macbytes=Module["_crypto_box_macbytes"]=asm["_crypto_box_macbytes"];var _crypto_box_publickeybytes=Module["_crypto_box_publickeybytes"]=asm["_crypto_box_publickeybytes"];var _crypto_generichash_keybytes=Module["_crypto_generichash_keybytes"]=asm["_crypto_generichash_keybytes"];var _crypto_generichash_primitive=Module["_crypto_generichash_primitive"]=asm["_crypto_generichash_primitive"];var _crypto_sign_secretkeybytes=Module["_crypto_sign_secretkeybytes"]=asm["_crypto_sign_secretkeybytes"];var ___muldsi3=Module["___muldsi3"]=asm["___muldsi3"];var _crypto_scalarmult_scalarbytes=Module["_crypto_scalarmult_scalarbytes"]=asm["_crypto_scalarmult_scalarbytes"];var _crypto_generichash_bytes_min=Module["_crypto_generichash_bytes_min"]=asm["_crypto_generichash_bytes_min"];var _malloc=Module["_malloc"]=asm["_malloc"];var _crypto_aead_chacha20poly1305_decrypt=Module["_crypto_aead_chacha20poly1305_decrypt"]=asm["_crypto_aead_chacha20poly1305_decrypt"];var _crypto_secretbox_open_easy=Module["_crypto_secretbox_open_easy"]=asm["_crypto_secretbox_open_easy"];var _crypto_aead_chacha20poly1305_ietf_decrypt_detached=Module["_crypto_aead_chacha20poly1305_ietf_decrypt_detached"]=asm["_crypto_aead_chacha20poly1305_ietf_decrypt_detached"];var _crypto_sign=Module["_crypto_sign"]=asm["_crypto_sign"];var _crypto_secretbox_noncebytes=Module["_crypto_secretbox_noncebytes"]=asm["_crypto_secretbox_noncebytes"];var _crypto_box_keypair=Module["_crypto_box_keypair"]=asm["_crypto_box_keypair"];var ___udivdi3=Module["___udivdi3"]=asm["___udivdi3"];var _sodium_hex2bin=Module["_sodium_hex2bin"]=asm["_sodium_hex2bin"];var _sodium_init=Module["_sodium_init"]=asm["_sodium_init"];var _crypto_secretbox_macbytes=Module["_crypto_secretbox_macbytes"]=asm["_crypto_secretbox_macbytes"];var _crypto_secretbox_keybytes=Module["_crypto_secretbox_keybytes"]=asm["_crypto_secretbox_keybytes"];var _randombytes=Module["_randombytes"]=asm["_randombytes"];var _crypto_sign_publickeybytes=Module["_crypto_sign_publickeybytes"]=asm["_crypto_sign_publickeybytes"];var _crypto_generichash_bytes=Module["_crypto_generichash_bytes"]=asm["_crypto_generichash_bytes"];var _crypto_generichash_bytes_max=Module["_crypto_generichash_bytes_max"]=asm["_crypto_generichash_bytes_max"];var _crypto_secretbox_open_detached=Module["_crypto_secretbox_open_detached"]=asm["_crypto_secretbox_open_detached"];var ___muldi3=Module["___muldi3"]=asm["___muldi3"];var _bitshift64Shl=Module["_bitshift64Shl"]=asm["_bitshift64Shl"];var ___uremdi3=Module["___uremdi3"]=asm["___uremdi3"];var _crypto_sign_verify_detached=Module["_crypto_sign_verify_detached"]=asm["_crypto_sign_verify_detached"];var _crypto_box_open_easy=Module["_crypto_box_open_easy"]=asm["_crypto_box_open_easy"];var _crypto_hash_bytes=Module["_crypto_hash_bytes"]=asm["_crypto_hash_bytes"];var _i64Add=Module["_i64Add"]=asm["_i64Add"];var _crypto_sign_bytes=Module["_crypto_sign_bytes"]=asm["_crypto_sign_bytes"];var _pthread_self=Module["_pthread_self"]=asm["_pthread_self"];var _crypto_generichash_update=Module["_crypto_generichash_update"]=asm["_crypto_generichash_update"];var _pthread_mutex_unlock=Module["_pthread_mutex_unlock"]=asm["_pthread_mutex_unlock"];var _crypto_scalarmult=Module["_crypto_scalarmult"]=asm["_crypto_scalarmult"];var _crypto_aead_chacha20poly1305_ietf_abytes=Module["_crypto_aead_chacha20poly1305_ietf_abytes"]=asm["_crypto_aead_chacha20poly1305_ietf_abytes"];var _crypto_box_seal_open=Module["_crypto_box_seal_open"]=asm["_crypto_box_seal_open"];var _crypto_box_easy=Module["_crypto_box_easy"]=asm["_crypto_box_easy"];var _memmove=Module["_memmove"]=asm["_memmove"];var _crypto_generichash_final=Module["_crypto_generichash_final"]=asm["_crypto_generichash_final"];var _randombytes_uniform=Module["_randombytes_uniform"]=asm["_randombytes_uniform"];var _crypto_sign_seed_keypair=Module["_crypto_sign_seed_keypair"]=asm["_crypto_sign_seed_keypair"];var _crypto_aead_chacha20poly1305_ietf_npubbytes=Module["_crypto_aead_chacha20poly1305_ietf_npubbytes"]=asm["_crypto_aead_chacha20poly1305_ietf_npubbytes"];var dynCall_iiiiiiii=Module["dynCall_iiiiiiii"]=asm["dynCall_iiiiiiii"];var dynCall_viiiii=Module["dynCall_viiiii"]=asm["dynCall_viiiii"];var dynCall_iiiiiid=Module["dynCall_iiiiiid"]=asm["dynCall_iiiiiid"];var dynCall_vi=Module["dynCall_vi"]=asm["dynCall_vi"];var dynCall_vii=Module["dynCall_vii"]=asm["dynCall_vii"];var dynCall_iiiiiii=Module["dynCall_iiiiiii"]=asm["dynCall_iiiiiii"];var dynCall_ii=Module["dynCall_ii"]=asm["dynCall_ii"];var dynCall_iiiiiiiiiiii=Module["dynCall_iiiiiiiiiiii"]=asm["dynCall_iiiiiiiiiiii"];var dynCall_iiii=Module["dynCall_iiii"]=asm["dynCall_iiii"];var dynCall_viiiiiiiiiiiiiii=Module["dynCall_viiiiiiiiiiiiiii"]=asm["dynCall_viiiiiiiiiiiiiii"];var dynCall_viiiiii=Module["dynCall_viiiiii"]=asm["dynCall_viiiiii"];var dynCall_viiiiiii=Module["dynCall_viiiiiii"]=asm["dynCall_viiiiiii"];var dynCall_viiiiiiiiii=Module["dynCall_viiiiiiiiii"]=asm["dynCall_viiiiiiiiii"];var dynCall_iii=Module["dynCall_iii"]=asm["dynCall_iii"];var dynCall_iiiiii=Module["dynCall_iiiiii"]=asm["dynCall_iiiiii"];var dynCall_i=Module["dynCall_i"]=asm["dynCall_i"];var dynCall_iiiii=Module["dynCall_iiiii"]=asm["dynCall_iiiii"];var dynCall_viii=Module["dynCall_viii"]=asm["dynCall_viii"];var dynCall_v=Module["dynCall_v"]=asm["dynCall_v"];var dynCall_iiiiiiiii=Module["dynCall_iiiiiiiii"]=asm["dynCall_iiiiiiiii"];var dynCall_iiiiid=Module["dynCall_iiiiid"]=asm["dynCall_iiiiid"];var dynCall_viiii=Module["dynCall_viiii"]=asm["dynCall_viiii"];Runtime.stackAlloc=asm["stackAlloc"];Runtime.stackSave=asm["stackSave"];Runtime.stackRestore=asm["stackRestore"];Runtime.establishStackSpace=asm["establishStackSpace"];Runtime.setTempRet0=asm["setTempRet0"];Runtime.getTempRet0=asm["getTempRet0"];function ExitStatus(status){this.name="ExitStatus";this.message="Program terminated with exit("+status+")";this.status=status}ExitStatus.prototype=new Error;ExitStatus.prototype.constructor=ExitStatus;var initialStackTop;var preloadStartTime=null;var calledMain=false;dependenciesFulfilled=function runCaller(){if(!Module["calledRun"])run();if(!Module["calledRun"])dependenciesFulfilled=runCaller};Module["callMain"]=Module.callMain=function callMain(args){args=args||[];ensureInitRuntime();var argc=args.length+1;function pad(){for(var i=0;i<4-1;i++){argv.push(0)}}var argv=[allocate(intArrayFromString(Module["thisProgram"]),"i8",ALLOC_NORMAL)];pad();for(var i=0;i<argc-1;i=i+1){argv.push(allocate(intArrayFromString(args[i]),"i8",ALLOC_NORMAL));pad()}argv.push(0);argv=allocate(argv,"i32",ALLOC_NORMAL);try{var ret=Module["_main"](argc,argv,0);exit(ret,true)}catch(e){if(e instanceof ExitStatus){return}else if(e=="SimulateInfiniteLoop"){Module["noExitRuntime"]=true;return}else{if(e&&typeof e==="object"&&e.stack)Module.printErr("exception thrown: "+[e,e.stack]);throw e}}finally{calledMain=true}};function run(args){args=args||Module["arguments"];if(preloadStartTime===null)preloadStartTime=Date.now();if(runDependencies>0){return}preRun();if(runDependencies>0)return;if(Module["calledRun"])return;function doRun(){if(Module["calledRun"])return;Module["calledRun"]=true;if(ABORT)return;ensureInitRuntime();preMain();if(Module["onRuntimeInitialized"])Module["onRuntimeInitialized"]();if(Module["_main"]&&shouldRunNow)Module["callMain"](args);postRun()}if(Module["setStatus"]){Module["setStatus"]("Running...");setTimeout((function(){setTimeout((function(){Module["setStatus"]("")}),1);doRun()}),1)}else{doRun()}}Module["run"]=Module.run=run;function exit(status,implicit){if(implicit&&Module["noExitRuntime"]){return}if(Module["noExitRuntime"]){}else{ABORT=true;EXITSTATUS=status;STACKTOP=initialStackTop;exitRuntime();if(Module["onExit"])Module["onExit"](status)}if(ENVIRONMENT_IS_NODE){process["exit"](status)}else if(ENVIRONMENT_IS_SHELL&&typeof quit==="function"){quit(status)}throw new ExitStatus(status)}Module["exit"]=Module.exit=exit;var abortDecorators=[];function abort(what){if(what!==undefined){Module.print(what);Module.printErr(what);what=JSON.stringify(what)}else{what=""}ABORT=true;EXITSTATUS=1;var extra="\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";var output="abort("+what+") at "+stackTrace()+extra;if(abortDecorators){abortDecorators.forEach((function(decorator){output=decorator(output,what)}))}throw output}Module["abort"]=Module.abort=abort;if(Module["preInit"]){if(typeof Module["preInit"]=="function")Module["preInit"]=[Module["preInit"]];while(Module["preInit"].length>0){Module["preInit"].pop()()}}var shouldRunNow=true;if(Module["noInitialRun"]){shouldRunNow=false}run()




    ENVIRONMENT_IS_NODE && !process.removeAllListeners("uncaughtException");
    return Module;
}));
